#!/usr/bin/python
#-*- encoding: utf8 -*-

from osv import fields, osv

class account_partner281_50(osv.osv):
    _name = 'account.partner281_50'

    def _sum_e(self, cr, uid, ids, field_name, arg, context={}):
        result = {}
        for record in self.browse(cr, uid, ids, context):
            result[record.id] = ( ( record.calc_sum_a or 0.0 ) + \
                                  ( record.manual_sum_b or record.calc_sum_b or 0.0 ) + \
                                  ( record.calc_sum_c or 0.0 ) + \
                                  ( record.calc_sum_d or 0.0 ) )
        return result
    _columns = {
        'partner_id': fields.many2one('res.partner','Partner',required=True),
        'final_sequence': fields.integer('Final Sequence'),
        'year':fields.char('Year',size=4),
        'name':fields.char('Name',size=120),
        'street1':fields.char('Street1',size=120),
        'street2':fields.char('Street2',size=120),
        'zip_code':fields.char('Zip Code',size=4),
        'city':fields.char('City',size=120),
        'company_number':fields.char('Company Number',size=20),
        'national_number':fields.char('Personal National Number',size=20),
        'profession':fields.char('Profession',size=50),
        'calc_sum_a':fields.float('Sum A',digits=(15,2)),
        'calc_sum_b':fields.float('Sum B',digits=(15,2)),
        'manual_sum_b':fields.float('Forced Sum B',digits=(15,2)),
        'calc_sum_c':fields.float('Sum C',digits=(15,2)),
        'calc_sum_d':fields.float('Sum D',digits=(15,2)),
        'calc_sum_e':fields.function(_sum_e, method=True, string='Sum E', type='float', digits=(15,2)),
        'calc_sum_fa':fields.float('Sum Fa',digits=(15,2)),
        'calc_sum_fb':fields.float('Sum Fb',digits=(15,2)),
        'calc_sum_g':fields.float('Sum G',digits=(15,2)),
        'final_output':fields.datetime('Final Output'),
    }
account_partner281_50()
