# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import netsvc
from osv import fields, osv,orm

class account_account(osv.osv):
    _inherit ="account.account"
    _columns={
        'cci_forced_analytic' : fields.boolean('Forced Analytic' ),
    }
    _defaults = {
        'cci_forced_analytic': lambda *args: False,
    }
account_account()

class account_analytic_plan_instance(osv.osv):
    _inherit='account.analytic.plan.instance'
    _description = 'Analytic Plan Instance'
    _columns={
        'active':fields.boolean('Active'),
    }
    _defaults = {
        'active': lambda *args: True,
    }
    def write(self, cr, uid, ids, vals, context={}, check=True, update_check=True):
        this = self.browse(cr,uid,ids[0])
        if this.plan_id and not vals.has_key('plan_id'):
            #this instance is a model, so we have to create a new plan instance instead of modifying it
            #copy the existing model
            temp_id = self.copy(cr, uid, this.id, None, context)
            #get the list of the invoice line that were linked to the model
            list = self.pool.get('account.invoice.line').search(cr,uid,[('analytics_id','=',this.id)])
            #make them link to the copy
            self.pool.get('account.invoice.line').write(cr, uid, list, {'analytics_id':temp_id}, context)

            #and finally modify the old model to be not a model anymore
            vals['plan_id'] = False
            if not vals.has_key('name'):
                vals['name'] = this.name and (str(this.name)+'*') or "*"
            if not vals.has_key('code'):
                vals['code'] = this.code and (str(this.code)+'*') or "*"
        return super(account_analytic_plan_instance, self).write(cr, uid, ids, vals, context)
account_analytic_plan_instance()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
