# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from report import report_sxw

class cci_account_cust_status(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(cci_account_cust_status, self).__init__(cr, uid, name, context=context)
        self.localcontext.update( {
            'time': time,
            'get_lines': self._get_lines,
            'sum_debit': self._get_sum_debit,
            'sum_credit': self._get_sum_credit,
            'balance': self._get_balance,
            'get_title': self._get_title,
            'get_coord': self._get_coordinates,
            'get_address': self._get_address,
        })
    def _get_lines(self, form, objects):
        result = []
        account_obj = self.pool.get('account.account')
        account_ids = account_obj.search(self.cr,self.uid,[('type','=',form['type'])])
        if account_ids:
            period_obj = self.pool.get('account.period')
            period_ids = period_obj.search(self.cr,self.uid,[('special','=',False)])
            partner_id = objects[0].id
            mline_obj = self.pool.get('account.move.line')
            if form['only_open']:
                mline_ids = mline_obj.search(self.cr,self.uid,[('account_id','in',account_ids),('partner_id','=',partner_id),('period_id','in',period_ids),('state','=','valid'),('reconcile_id','=',False)])
            else:
                mline_ids = mline_obj.search(self.cr,self.uid,[('account_id','in',account_ids),('partner_id','=',partner_id),('period_id','in',period_ids),('state','=','valid')])
            if mline_ids:
                mlines = mline_obj.browse(self.cr,self.uid,mline_ids)
                for mline in mlines:
                    record = {}
                    record['move_name'] = mline.move_id and mline.move_id.name or '-'
                    record['journal'] = mline.journal_id and mline.journal_id.code or '-'
                    record['date'] = mline.date[8:10]+'/'+mline.date[5:7]+'/'+mline.date[0:4]
                    record['period'] = mline.period_id.name
                    record['debit'] = '%.2f' % (mline.debit or 0.0)
                    record['credit'] = '%.2f' % (mline.credit or 0.0)
                    record['reconcile'] = mline.reconcile_id and mline.reconcile_id.name or ''
                    result.append(record)
        return result
    def _get_sum_debit(self, form, objects):
        result = 0.0
        account_obj = self.pool.get('account.account')
        account_ids = account_obj.search(self.cr,self.uid,[('type','=',form['type'])])
        if account_ids:
            period_obj = self.pool.get('account.period')
            period_ids = period_obj.search(self.cr,self.uid,[('special','=',False)])
            partner_id = objects[0].id
            mline_obj = self.pool.get('account.move.line')
            if form['only_open']:
                mline_ids = mline_obj.search(self.cr,self.uid,[('account_id','in',account_ids),('partner_id','=',partner_id),('period_id','in',period_ids),('state','=','valid'),('reconcile_id','=',False)])
            else:
                mline_ids = mline_obj.search(self.cr,self.uid,[('account_id','in',account_ids),('partner_id','=',partner_id),('period_id','in',period_ids),('state','=','valid')])
            if mline_ids:
                mlines = mline_obj.browse(self.cr,self.uid,mline_ids)
                for mline in mlines:
                    result += mline.debit or 0.0
        return '%.2f' % result
    def _get_sum_credit(self, form, objects):
        result = 0.0
        result = 0.0
        account_obj = self.pool.get('account.account')
        account_ids = account_obj.search(self.cr,self.uid,[('type','=',form['type'])])
        if account_ids:
            period_obj = self.pool.get('account.period')
            period_ids = period_obj.search(self.cr,self.uid,[('special','=',False)])
            partner_id = objects[0].id
            mline_obj = self.pool.get('account.move.line')
            if form['only_open']:
                mline_ids = mline_obj.search(self.cr,self.uid,[('account_id','in',account_ids),('partner_id','=',partner_id),('period_id','in',period_ids),('state','=','valid'),('reconcile_id','=',False)])
            else:
                mline_ids = mline_obj.search(self.cr,self.uid,[('account_id','in',account_ids),('partner_id','=',partner_id),('period_id','in',period_ids),('state','=','valid')])
            if mline_ids:
                mlines = mline_obj.browse(self.cr,self.uid,mline_ids)
                for mline in mlines:
                    result += mline.credit or 0.0
        return '%.2f' % result
    def _get_balance(self, form, objects):
        result = 0.0
        result = 0.0
        account_obj = self.pool.get('account.account')
        account_ids = account_obj.search(self.cr,self.uid,[('type','=',form['type'])])
        if account_ids:
            period_obj = self.pool.get('account.period')
            period_ids = period_obj.search(self.cr,self.uid,[('special','=',False)])
            partner_id = objects[0].id
            mline_obj = self.pool.get('account.move.line')
            if form['only_open']:
                mline_ids = mline_obj.search(self.cr,self.uid,[('account_id','in',account_ids),('partner_id','=',partner_id),('period_id','in',period_ids),('state','=','valid'),('reconcile_id','=',False)])
            else:
                mline_ids = mline_obj.search(self.cr,self.uid,[('account_id','in',account_ids),('partner_id','=',partner_id),('period_id','in',period_ids),('state','=','valid')])
            if mline_ids:
                mlines = mline_obj.browse(self.cr,self.uid,mline_ids)
                for mline in mlines:
                    result += (( mline.debit or 0.0 ) - (mline.credit or 0.0))
        return '%.2f' % result
    def _get_title(self, form, objects):
        result = 'Etat de compte ' + ( form['type'] == 'receivable' and 'Client' or 'Fournisseur' )
        result += ( '\n' + objects[0].name + ' [%s]' % str(objects[0].id) )
        return result
    def _get_coordinates(self, form, objects):
        result = ''
        user_obj = self.pool.get('res.users')
        user = user_obj.browse(self.cr,self.uid,[self.uid])[0]
        result = user.name
        if user.phone:
            result += u' - Tél : ' + user.phone
        if user.fax:
            result += u' - Fax : ' + user.fax
        if user.email:
            result += u' - Courriel : ' + user.email
        return result
    def _get_address(self, form, objects):
        comp_obj = self.pool.get('res.company')
        comp_ids = comp_obj.search(self.cr,self.uid,[])
        company = comp_obj.browse(self.cr,self.uid,comp_ids)[0]
        result = ('Liège Airport BAT-50','4460 Grâce-Hollogne','04/341.91.91','info@ccilvn.be')
        if company.partner_id and company.partner_id.address:
            for address in company.partner_id.address:
                if address.type == 'default':
                    result = [address.street or '',
                              address.zip_id and (address.zip_id.name + ' ' + address.zip_id.city) or '',
                              address.phone or '',
                              address.email or '']
                    break
        if result[2] and not ('/' in result[2]):
            if result[2][0:2] in ['02','04']:
                result[2] = result[2][0:2]+'/'+result[2][2:5]+'.'+result[2][5:7]+'.'+result[2][7:9]
            else:
                result[2] = result[2][0:3]+'/'+result[2][3:5]+'.'+result[2][5:7]+'.'+result[2][7:9]
        print result
        return result
report_sxw.report_sxw('report.customer_status_report',
                      'res.partner',
                      'addons/cci_account_extend/report/customer_status_report.rml',
                      parser=cci_account_cust_status,
                      header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

