# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
import urllib
import StringIO
from lxml import etree
from osv import fields,osv
import wizard
import pooler
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Change Move Date">
    <field name="period_id"/>
    <field name="new_date"/>
</form>"""

fields = {
    'new_date' : {'string':'New Date','type':'date','required':True},
    'period_id': {'string':'New Period','type':'many2one','relation':'account.period','required':True},
   }

class change_move_date(wizard.interface):
    def _change_all_move(self, cr, uid, data, context):
        pool_obj = pooler.get_pool(cr.dbname)

        # verify that the date is in the period
        period = pool_obj.get('account.period').read(cr,uid,[data['form']['period_id']],['date_start','date_stop','state','special'])[0]
        if data['form']['new_date'] < period['date_start'] or data['form']['new_date'] > period['date_stop']:
            raise osv.except_osv(_('Error :'), _('The new date must be inside the new period !'))
            return {'type':'state','state':'end'}
        else:
            # verify that the new period is draft
            if period['state'] <> 'draft' or period['special']:
                raise osv.except_osv(_('Error :'), _('The new period must be open and cannot be an opening period!'))
                return {'type':'state','state':'end'}
            else:
                # verify that only one move is selected
                if len(data['ids']) > 1:
                    raise osv.except_osv(_('Error :'), _('You can use this tool on only one move at a time !'))
                    return {'type':'state','state':'end'}
                else:
                    # verify that the old period of the move is draft
                    move_id = data['ids'][0]
                    move = pool_obj.get('account.move').browse(cr,uid,[move_id])[0]
                    if move.period_id and (move.period_id.state <> 'draft' or move.period_id.special):
                        raise osv.except_osv(_('Error :'), _('The old period must be open and cannot be an opening period!'))
                        return {'type':'state','state':'end'}
                    else:
                        new_date = data['form']['new_date']
                        new_period = data['form']['period_id']
                        cr.execute("UPDATE account_move SET date='"+new_date+"', period_id="+str(new_period)+" WHERE id="+str(move_id))
                        cr.execute("UPDATE account_move_line SET date='"+new_date+"', period_id="+str(new_period)+" WHERE move_id="+str(move_id))
                        return {'type':'state','state':'end'}
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('change','Change')]},
        },
        'change': {
            'actions': [_change_all_move],
            'result' : {'type':'state', 'state':'end'}
        },
    }
change_move_date("change_move_date")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
