# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
import urllib
import StringIO
from lxml import etree
from osv import fields,osv
import wizard
import pooler
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Change Salary Move">
    <field name="new_date"/>
    <field name="period_id"/>
    <field name="change_text"/>
    <newline/>
    <field name="old_text" colspan="4" />
    <field name="new_text" colspan="4" />
</form>"""

fields = {
    'new_date' : {'string':'New Date','type':'date','required':True},
    'period_id': {'string':'New Period','type':'many2one','relation':'account.period','required':True},
    'change_text':{'string':'Change also text inside lines','type':'boolean','default':True},
    'old_text':{'string':'Old text to Delete','type':'char','size':45},
    'new_text':{'string':'New text to Set in Place Of','type':'char','size':45},
   }

class wizard_change_salary_move(wizard.interface):
    def _change_all_move(self, cr, uid, data, context):

        pool_obj = pooler.get_pool(cr.dbname)

        # verify that the date is in the period
        period = pool_obj.get('account.period').read(cr,uid,[data['form']['period_id']],['date_start','date_stop','state','special'])[0]
        if data['form']['new_date'] < period['date_start'] or data['form']['new_date'] > period['date_stop']:
            raise osv.except_osv(_('Error :'), _('The new date must be inside the new period !'))
            return {'type':'state','state':'end'}
        else:
            # verify that the new period is draft
            if period['state'] <> 'draft' or period['special']:
                raise osv.except_osv(_('Error :'), _('The new period must be open and cannot be an opening period!'))
                return {'type':'state','state':'end'}
            else:
                # verify that only one move is selected
                if len(data['ids']) > 1:
                    raise osv.except_osv(_('Error :'), _('You van use this tool on only one move at a time !'))
                    return {'type':'state','state':'end'}
                else:
                    # if change_text, verify that two texts are given
                    if data['form']['change_text'] and (( not data['form']['old_text'] ) or ( not data['form']['new_text'] )):
                        raise osv.except_osv(_('Error :'), _('If you want to change the text, you must give the old and the new value !'))
                        return {'type':'state','state':'end'}
                    else:
                        # verify that the move is draft
                        move_id = data['ids'][0]
                        move = pool_obj.get('account.move').browse(cr,uid,[move_id])[0]
                        if move.state <> 'draft':
                            raise osv.except_osv(_('Error :'), _('You can use this tool only upon a draft move!'))
                            return {'type':'state','state':'end'}
                        else:
                            new_date = data['form']['new_date']
                            new_period = data['form']['period_id']
                            if data['form']['change_text']:
                                old_text = data['form']['old_text']
                                new_text = data['form']['new_text']
                            cr.execute("UPDATE account_move SET date='"+new_date+"', period_id="+str(new_period)+" WHERE id="+str(move_id))
                            cr.execute("UPDATE account_move_line SET date='"+new_date+"', period_id="+str(new_period)+" WHERE move_id="+str(move_id))
                            if data['form']['change_text']:
                                cr.execute("UPDATE account_move_line SET name=substr(name,0,position('"+old_text+"' in name)-1)||'"+new_text+"'||substr(name,position('"+old_text+"' in name)+"+str(len(old_text))+") WHERE position('"+old_text+"' in name) > 0 and move_id="+str(move_id))
                            return {'type':'state','state':'end'}
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('change','Change')]},
        },
        'change': {
            'actions': [_change_all_move],
            'result' : {'type':'state', 'state':'end'}
        },
    }
wizard_change_salary_move("cci_account_extend_change_salary_move")

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
