# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
from osv import fields,osv
import wizard
import pooler
import base64
import codecs
from pyExcelerator import *
from tools.translate import _
from xml.sax.saxutils import escape

form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="Files has been created.\nChoose the one(s) you want."  colspan="4"/>
     <field name="hierarchical_aaccounts.xls" colspan="4" />
     <field name="hierarchical_aaccounts.xml" colspan="4" />
</form>"""

fields = {
    'hierarchical_aaccounts.xls':{'string': 'Excel file','type': 'binary','readonly': True,},
    'hierarchical_aaccounts.xml':{'string': 'XML File','type': 'binary','readonly': True,},
}

class export_hierarchical_list_aaccounts(wizard.interface):
    def _export_lines(self, cr, uid, data, context):
        # create the workbook
        out2 = codecs.open('hierarchical_aaccounts.xml', "w", "utf-8")
        out2.write('<?xml version="1.0" encoding="utf-8"?>\n')
        out2.write('<analytic-accounts>\n')
        old_level = 0
        wb = Workbook()
        ws1 = wb.add_sheet(_('Analytic Accounts'))
        ws1.write(0,1,_('Complete Name'))
        ws1.write(0,2,_('Date Start'))
        ws1.write(0,3,_('Date End'))
        ws1.write(0,4,_('Budgetary Post'))
        ws1.write(0,5,'ID')
        line = 2
        #
        aaccount_obj = pooler.get_pool(cr.dbname).get('account.analytic.account')
        aaccount_ids = aaccount_obj.search(cr,uid,[])
        aaccounts = aaccount_obj.read(cr,uid,aaccount_ids,['name','complete_name','date_start','date','cci_post_id'])
        saaccounts = sorted(aaccounts, key=lambda k: k['complete_name'])
        first = True
        for aaccount in saaccounts:
            ws1.write(line,0,aaccount['name'])
            ws1.write(line,1,aaccount['complete_name'])
            ws1.write(line,2,aaccount['date_start'] and datetime.datetime.strptime(aaccount['date_start'],'%Y-%m-%d').strftime('%d/%m/%Y') or '')
            ws1.write(line,3,aaccount['date'] and datetime.datetime.strptime(aaccount['date'],'%Y-%m-%d').strftime('%d/%m/%Y') or '')
            ws1.write(line,4,aaccount['cci_post_id'] and aaccount['cci_post_id'][1] or '')
            ws1.write(line,5,aaccount['id'])
            line += 1
            #
            current_aaccount = aaccount_obj.browse(cr,uid,aaccount['id'])
            current_level = 1
            while current_aaccount.parent_id:
                current_aaccount = current_aaccount.parent_id
                current_level += 1
            current_aaccount = aaccount_obj.browse(cr,uid,aaccount['id'])
            if current_level <= old_level:
                real_level = old_level
                first_close = True
                while real_level >= current_level:
                    if real_level > current_level:
                        if first_close:
                            out2.write('</analytic-account>\n')
                        else:
                            out2.write( ('\t' * (((real_level-1)*2)+1)) + '</analytic-account>\n')
                        out2.write( ('\t' * ((real_level-1)*2)) + '</sub-accounts>\n')
                    else:
                        if first_close:
                            out2.write('</analytic-account>\n')
                        else:
                            out2.write( ('\t' * (((real_level-1)*2)+1)) + '</analytic-account>\n')
                    real_level -= 1
                    first_close = False
            old_level = current_level
            first = False
            attr_start = ''
            attr_end = ''
            if aaccount['date_start']:
                attr_start = ' start_date="%s"' % aaccount['date_start']
            if aaccount['date']:
                attr_start = ' end_date="%s"' % aaccount['date']
            out2.write(('\t' * ((old_level*2)-1)) + '<analytic-account%s%s id="%i">%s' % (attr_start,attr_end,aaccount['id'],escape(aaccount['complete_name'])))
            if current_aaccount.child_ids:
                out2.write('\n' + ('\t' * (old_level*2)) + '<sub-accounts>\n')
        #
        wb.save('hierarchical_aaccounts.xls')
        result_file = open('hierarchical_aaccounts.xls','rb').read()
        real_level = old_level
        first_close = True
        while real_level >= 1:
            if real_level > 1:
                if first_close:
                    out2.write('</analytic-account>\n')
                else:
                    out2.write( ('\t' * (((real_level-1)*2)+1)) + '</analytic-account>\n')
                out2.write( ('\t' * ((real_level-1)*2)) + '</sub-accounts>\n')
            else:
                if first_close:
                    out2.write('</analytic-account>\n')
                else:
                    out2.write( ('\t' * (((real_level-1)*2)+1)) + '</analytic-account>\n')
            real_level -= 1
            first_close = False
        out2.write('</analytic-accounts>\n')
        out2.close()
        result2 = open('hierarchical_aaccounts.xml','rb').read()
        # give the results to the user
        data['form']['hierarchical_aaccounts.xls']=base64.encodestring(result_file)
        data['form']['hierarchical_aaccounts.xml']=base64.encodestring(result2)
        return data['form']
    states = {
        'init': {
            'actions': [_export_lines],
            'result' : {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Ok')]}
        },
    }
export_hierarchical_list_aaccounts("export_hierarchical_list_aaccounts")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
