# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
from osv import fields,osv
import wizard
import pooler
import base64
from pyExcelerator import *
from tools.translate import _

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="account_move_lines.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'account_move_lines.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class wizard_export_line_excel(wizard.interface):
    def _export_lines(self, cr, uid, data, context):
        # create the workbook
        wb = Workbook()
        ws1 = wb.add_sheet(_('Lines'))
        ws1.write(0,0,_('ID Line'))
        ws1.write(0,1,_('Partner Name'))
        ws1.write(0,2,_('Reference'))
        ws1.write(0,3,_('Line Name'))
        ws1.write(0,4,_('Move Name'))
        ws1.write(0,5,_('Journal'))
        ws1.write(0,6,_('Date'))
        ws1.write(0,7,_('Account'))
        ws1.write(0,8,_('Period'))
        ws1.write(0,9,_('Debit'))
        ws1.write(0,10,_('Credit'))
        ws1.write(0,11,_('Reconcile'))
        ws1.write(0,12,_('Partial Reconcile'))
        #
        linenum = 1
        lines = pooler.get_pool(cr.dbname).get('account.move.line').browse(cr,uid,data['ids'])
        for line in lines:
            ws1.write(linenum,0,line.id)
            ws1.write(linenum,1,line.partner_id.name or '')
            ws1.write(linenum,2,line.ref or '')
            ws1.write(linenum,3,line.name or '')
            ws1.write(linenum,4,line.move_id.name or '')
            ws1.write(linenum,5,line.journal_id.code or line.journal_id.name or '')
            ws1.write(linenum,6,line.date and (line.date[8:]+'/'+line.date[5:7]+'/'+line.date[0:4]) or '')
            ws1.write(linenum,7,line.account_id.code + ' ' + line.account_id.name)
            ws1.write(linenum,8,line.period_id.name)
            ws1.write(linenum,9,line.debit or 0.0)
            ws1.write(linenum,10,line.credit or 0.0)
            ws1.write(linenum,11,line.reconcile_id and line.reconcile_id.name or '')
            ws1.write(linenum,12,line.reconcile_partial_id and line.reconcile_partial_id.name or '')
            linenum += 1
        #
        wb.save('account_move_lines.xls')
        result_file = open('account_move_lines.xls','rb').read()
        # give the result tos the user
        data['form']['msg']="File created 'account_move_lines.xls'"
        data['form']['account_move_lines.xls']=base64.encodestring(result_file)
        return data['form']
    states = {
        'init': {
            'actions': [_export_lines],
            'result' : {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
wizard_export_line_excel("cci_account_extend_export_line_excel")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
