# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
from osv import fields,osv
import wizard
import pooler
import base64
from pyExcelerator import *
from tools.translate import _

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="multiple_aacounts_dist.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'multiple_aacounts_dist.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class export_multi_aaccounts_dist(wizard.interface):
    def _export_lines(self, cr, uid, data, context):
        # create the workbook
        wb = Workbook()
        pattern_yellow = Pattern()
        pattern_yellow.pattern = 0x01 # SOLID
        pattern_yellow.set_pattern_fore_colour(0x0D)  ### 'yellow'

        style_float = XFStyle()
        style_float.num_format_str = '#,##0.00'

        style_rate = XFStyle()
        style_rate.num_format_str = '#,##0.00'
        style_rate.pattern = pattern_yellow
        
        ws1 = wb.add_sheet(_('Distributions'))
        ws1.write(0,0,_('list of analytic distributions with multiples accounts of some plans'))
        ws1.write(2,0,_('In Excel, we advice you to put the Analytic Account Name in vertical mode for a better visualisation'))
        ws1.write(4,0,_('ID Distribution'))
        ws1.write(4,1,_('Dist Name'))
        linenum = 6
        begin_col_aaccounts = 1
        #
        dist_obj = pooler.get_pool(cr.dbname).get('account.analytic.plan.instance')
        aacount_obj = pooler.get_pool(cr.dbname).get('account.analytic.account')
        dist_ids = dist_obj.search(cr,uid,[])
        dists = dist_obj.browse(cr,uid,dist_ids)
        rates = {}
        concerned_aaccount_ids = []
        concerned_dists = []
        for dist in dists:
            plan_not_100 = []
            for line in dist.account_ids:
                if line.rate < 100.0:
                    if line.plan_id not in plan_not_100:
                        plan_not_100.append(line.plan_id)
            if plan_not_100:
                concerned_dists.append({'name':'%s [%s]' % (dist.name or '',dist.code or ''),'id':dist.id})
                for line in dist.account_ids:
                    if line.plan_id in plan_not_100:
                        if rates.has_key((dist.id,line.analytic_account_id.id)):
                            record = rates[(dist.id,line.analytic_account_id.id)]
                            record['rate'] += line.rate
                            rates[(dist.id,line.analytic_account_id.id)] = record
                        else:
                            rates[(dist.id,line.analytic_account_id.id)] = {'rate':line.rate or 0.0,
                                                                            'aaccount_name': line.analytic_account_id.complete_name,
                                                                            'distribution_name':'%s [%s]' % (dist.name or '',dist.code or ''),
                                                                            'distribution_id':dist.id,
                                                                            'aaccount.id': line.analytic_account_id.id,
                                                                           }
                            if line.analytic_account_id.id not in concerned_aaccount_ids:
                                concerned_aaccount_ids.append(line.analytic_account_id.id)
        concerned_aaccounts = aacount_obj.read(cr,uid,concerned_aaccount_ids,['complete_name','name'])
        sconcerned_aaccounts = sorted(concerned_aaccounts, key=lambda k: k['complete_name'])
        sconcerned_dists = sorted(concerned_dists, key=lambda k: k['name'])
        count = 1
        dAAccount2Col = {}
        for aaccount in sconcerned_aaccounts:
            ws1.write(3,begin_col_aaccounts+count,aaccount['id'])
            ws1.write(4,begin_col_aaccounts+count,aaccount['complete_name'])
            ws1.write(5,begin_col_aaccounts+count,aaccount['name'])
            dAAccount2Col[aaccount['id']] = begin_col_aaccounts+count
            count += 1
        for dist in sconcerned_dists:
            ws1.write(linenum,0,dist['id'])
            ws1.write(linenum,1,dist['name'])
            for aaccount in sconcerned_aaccounts:
                if rates.has_key((dist['id'],aaccount['id'])):
                    ws1.write(linenum,dAAccount2Col[aaccount['id']],rates[(dist['id'],aaccount['id'])]['rate'],style_rate)
                else:
                    ws1.write(linenum,dAAccount2Col[aaccount['id']],0.0,style_float)
            linenum += 1
        #
        wb.save('multiple_aacounts_dist.xls')
        result_file = open('multiple_aacounts_dist.xls','rb').read()
        # give the result tos the user
        data['form']['msg']="File created 'account_move_lines.xls'"
        data['form']['multiple_aacounts_dist.xls']=base64.encodestring(result_file)
        return data['form']
    states = {
        'init': {
            'actions': [_export_lines],
            'result' : {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
export_multi_aaccounts_dist("export_multi_aaccounts_dist")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
