# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
import tools
import pooler
import base64
from pyExcelerator import *

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="analytics.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'analytics.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class wizard_extract_analytics(wizard.interface):

    def _get_file(self,cr,uid,data,context):
        obj_aline = pooler.get_pool(cr.dbname).get('account.analytic.line')
        alines = obj_aline.browse(cr,uid,data['ids'])
        wb1 = Workbook()
        ws1 = wb1.add_sheet('Lignes analytiques')
        ws1.write(0,0,u'Période')
        ws1.write(0,1,u'Description')
        ws1.write(0,2,u'Compte analytique')
        ws1.write(0,3,u'Montant')
        ws1.write(0,4,u'Compte comptable')
        ws1.write(0,5,u'Partenaire')
        ws1.write(0,6,u'Mouvement comptable')
        line = 1
        for aline in alines:
            ws1.write(line,0,aline.period_id.name or '')
            ws1.write(line,1,aline.name or '' )
            ws1.write(line,2,aline.account_id.complete_name or '' )
            ws1.write(line,3,aline.amount or '' )
            ws1.write(line,4,aline.general_account_id.code or '' )
            ws1.write(line,5,aline.partner_id.name or '' )
            ws1.write(line,6,aline.move_name.name or '' )
            line += 1
        wb1.save('analytics.xls')
        result_file = open('analytics.xls','rb').read()

        # give the result tos the user
        data['form']['msg']='Save the File with '".xls"' extension.'
        data['form']['analytics.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [_get_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

wizard_extract_analytics('extract_analytics')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

