##############################################################################
#
# Copyright (c) 2005-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import time
import datetime
import pooler
import base64
from osv import fields, osv
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Smooth a Period">
    <field name="period_id"/>
</form>"""
fields = {
    'period_id': {'string': 'Period(s)', 'type': 'many2one', 'relation':'account.period', 'required': True, 'help': 'Select here the period in wich you want the get the smoothing of past moves', 'domain':"[('smoothed','=',False),('state','=','draft')]"},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification" width="700" height="600">
    <separator string="XML File has been Created." colspan="4"/>
    <field name="msg" colspan="4" nolabel="1"/>
    <field name="move_ids" colspan="4" height="300" width="600"/>
    <field name="smoothing.xls" colspan="4"/>
</form>"""
msg_fields = {
  'msg': {'string':_('File created'), 'type':'text', 'size':'100','readonly':True},
  'move_ids':{'string':_('Created Moves'),'type':'one2many','relation':'account.move','readonly':True},
  'smoothing.xls':{'string':_('Save XLS File'),'type': 'binary','readonly': True,},
}

class smooth_period(wizard.interface):
    result_ids = []
    def _get_defaults(self, cr, uid, data, context):
        return {'period_id': False}

    def _create_moves(self, cr, uid, data, context):
        pool = pooler.get_pool(cr.dbname)

        period_obj = pool.get('account.period')
        result = period_obj.smooth(cr,uid,[data['form']['period_id'],])
        if result and result['status'] == 'OK':
            result_file = open(result['filename'],'rb').read()
            # give the result to the user
            data['form']['smoothing.xls'] = base64.encodestring(result_file)
            data['form']['move_ids'] = result['move_ids']
            data['form']['msg'] =  _('Excel File created\n\nTransfered sum : %.2f euros') % result['sum']
            self.result_ids = result['move_ids']
        else:
            data['form']['msg'] = 'ERROR : %i\n\n%s' % (result['error_num'],result['error_details'])
        return data['form']
    def _show_moves(self, cr, uid, data, context):
        value = {
            'domain': [('id', 'in',self.result_ids)],
            'name': _('Created Smoothing Moves'),
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'account.move',
            'context': {},
            'type': 'ir.actions.act_window'
        }
        return value
    states = {
        'init': {
            'actions': [_get_defaults],
            'result': {'type': 'form', 'arch':form, 'fields': fields, 'state':[('end','Cancel'),('go','Create Smoothing Moves') ]}
                },
         'go': {
            'actions': [_create_moves],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Close'),('show','Open Moves in Folder')]},
                },
         'show': {
            'actions': [],
            'result': {'type': 'action','action': _show_moves,'state': 'end'},
                },
         }
smooth_period('smooth_period')
