# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2008 CCI Connect ASBL. (http://www.cciconnect.be) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
from osv import fields, osv

class res_partner_activsector(osv.osv):
    def _check_recursion(self, cr, uid, ids):
        level = 100
        while len(ids):
            cr.execute('select distinct parent_id from res_partner_activsector where id in %s', (tuple(ids),))
            ids = filter(None, map(lambda x:x[0], cr.fetchall()))
            if not level:
                return False
            level -= 1
        return True

    _description='Partner CCI Activity Sector'
    _name = 'res.partner.activsector'
    _columns = {
        'code': fields.char('Sector Code', required=True, size=6),
        'name': fields.char('Sector Name', required=True, size=64, translate=True),
        'parent_id': fields.many2one('res.partner.activsector', 'Parent Sector', select=True),
        'child_ids': fields.one2many('res.partner.activsector', 'parent_id', 'Child Sectors'),
        'active' : fields.boolean('Active', help="The active field allows you to hide the sector without removing it."),
        'directly': fields.boolean('Directly usable', help='The concerned sector can be directly used by a partner, it isn\'t a header sector'),
    }
    _constraints = [
        (_check_recursion, 'Error ! You can not create recursive sectors.', ['parent_id'])
    ]
    _defaults = {
        'active' : lambda *a: True,
    }
    _order = 'code'
res_partner_activsector()

class res_partner_address(osv.osv):
    _inherit = "res.partner.address"
    _description = "res.partner.address"
    _columns = {
        'sector1':fields.many2one('res.partner.activsector','Sector 1'),
        'sector2':fields.many2one('res.partner.activsector','Sector 2'),
        'sector3':fields.many2one('res.partner.activsector','Sector 3'),
    }
res_partner_address()


