# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import tools
import pooler

form = """<?xml version="1.0"?>
<form string="Creation of salary for a yearly budget">
    <field name="new_budget_id" colspan="4" width="800" required="1"/>
    <field name="associated_accounts" colspan="4" required="1"/>
    <field name="period_id" required="1"/>
    <field name="cci_value_id"/>
    <newline/>
    <separator string="pourcents à ajouter chaque mois au salaire du mois précédent (par exemple 1.1 pour ajouter 1% et 1 millièmes)" colspan="4"/>
    <group col="12" colspan="4">
        <field name="rate1" nolabel="1" required="1"/>
        <field name="rate2" nolabel="1" required="1"/>
        <field name="rate3" nolabel="1" required="1"/>
        <field name="rate4" nolabel="1" required="1"/>
        <field name="rate5" nolabel="1" required="1"/>
        <field name="rate6" nolabel="1" required="1"/>
        <field name="rate7" nolabel="1" required="1"/>
        <field name="rate8" nolabel="1" required="1"/>
        <field name="rate9" nolabel="1" required="1"/>
        <field name="rate10" nolabel="1" required="1"/>
        <field name="rate11" nolabel="1" required="1"/>
        <field name="rate12" nolabel="1" required="1"/>
    </group>
    <field name="second_line_accounts" colspan="4"/>
    <group col="12" colspan="4">
        <field name="second1" nolabel="1" required="1"/>
        <field name="second2" nolabel="1" required="1"/>
        <field name="second3" nolabel="1" required="1"/>
        <field name="second4" nolabel="1" required="1"/>
        <field name="second5" nolabel="1" required="1"/>
        <field name="second6" nolabel="1" required="1"/>
        <field name="second7" nolabel="1" required="1"/>
        <field name="second8" nolabel="1" required="1"/>
        <field name="second9" nolabel="1" required="1"/>
        <field name="second10" nolabel="1" required="1"/>
        <field name="second11" nolabel="1" required="1"/>
        <field name="second12" nolabel="1" required="1"/>
    </group>
    <field name="always_new"/>
</form>"""

fields = {
    'new_budget_id': {'string': 'New Budget', 'type':'many2one','relation': 'cci_budget.budget','required': True},
    'associated_accounts':{'string':'Associated accounts','type':'char','size':1000,'required':True,'help':'List of accounts codes separated by \';\'.'},
    'second_line_accounts':{'string':'Second lines accounts','type':'char','size':1000,'help':'List of accounts codes separated by \';\'.\nMust be defined also in copied accounts.'},
    'period_id': {'string':'Period', 'type':'many2one', 'relation': 'account.period'},
    'cci_value_id':{'string':'Conversion Table','type':'many2one','relation':'cci_parameters.cci_value','help':'Table of conversion between analytic distribution for salary (\'---\' means \'no conversion\').'},
    'rate1':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'rate2':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'rate3':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'rate4':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'rate5':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'rate6':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'rate7':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'rate8':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'rate9':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'rate10':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'rate11':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'rate12':{'string':'Multiplier for January','type': 'float', 'default':'0.00'},
    'second1':{'string':'Second line in January','type': 'float', 'default':'0.00'},
    'second2':{'string':'Second line in January','type': 'float', 'default':'0.00'},
    'second3':{'string':'Second line in January','type': 'float', 'default':'0.00'},
    'second4':{'string':'Second line in January','type': 'float', 'default':'0.00'},
    'second5':{'string':'Second line in January','type': 'float', 'default':'0.00'},
    'second6':{'string':'Second line in January','type': 'float', 'default':'0.92'},
    'second7':{'string':'Second line in January','type': 'float', 'default':'0.00'},
    'second8':{'string':'Second line in January','type': 'float', 'default':'0.00'},
    'second9':{'string':'Second line in January','type': 'float', 'default':'0.00'},
    'second10':{'string':'Second line in January','type': 'float', 'default':'0.00'},
    'second11':{'string':'Second line in January','type': 'float', 'default':'0.00'},
    'second12':{'string':'Second line in January','type': 'float', 'default':'1.00'},
    'always_new':{'string':'Always Create','type':'boolean','help':'If checked, this wizard will always create new lines, never overwrite.','default':'True'},
   }

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="Results" colspan="4"/>
     <field name="msg" colspan="4" nolabel="1" width="800"/>
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
}

class cci_budget_create_salary(wizard.interface):
    def _create_salary(self,cr,uid,data,context):
        budget_obj = pooler.get_pool(cr.dbname).get('cci_budget.budget')
        budget = budget_obj.browse(cr,uid,data['form']['new_budget_id'])
        #
        # read current data
        #
        period_obj = pooler.get_pool(cr.dbname).get('account.period')
        journal_obj = pooler.get_pool(cr.dbname).get('account.journal')
        journal_id = journal_obj.search(cr,uid,[('code','=','SOC')])[0]
        adistri_obj = pooler.get_pool(cr.dbname).get('account.analytic.plan.instance')
        account_obj = pooler.get_pool(cr.dbname).get('account.account')
        salary_account_ids = [] # accounts with amount +92% in June and +100% in December
        associated_account_ids = []
        associated_account_codes = data['form']['associated_accounts'].strip().split(';')
        for associated_code in associated_account_codes:
            account_ids = account_obj.search(cr,uid,[('code','=',associated_code)])
            if account_ids:
                associated_account_ids.append(account_ids[0])
                if associated_code in data['form']['second_line_accounts']:
                    salary_account_ids.append(account_ids[0])
        ##TODO : lPeriods = list of periods of the budget.fiscalyear_id not special sorted by date_start
        #[{'id':period_id,'index':index in majorations}]
        target_period_ids = [x.id for x in budget.fiscalyear_id.period_ids if not x.special]
        target_periods = period_obj.read(cr,uid,target_period_ids,['date_start'])
        starget_periods = sorted(target_periods,key=lambda k: k['date_start'])
        #
        # cumulate data in a dict with (account_id,cci_budget_post_id) keys
        #
        majorations = [1+(data['form']['rate1']/100),
                       1+(data['form']['rate2']/100),
                       1+(data['form']['rate3']/100),
                       1+(data['form']['rate4']/100),
                       1+(data['form']['rate5']/100),
                       1+(data['form']['rate6']/100),
                       1+(data['form']['rate7']/100),
                       1+(data['form']['rate8']/100),
                       1+(data['form']['rate9']/100),
                       1+(data['form']['rate10']/100),
                       1+(data['form']['rate11']/100),
                       1+(data['form']['rate12']/100),
                      ]
        second_lines = [data['form']['second1'],
                        data['form']['second2'],
                        data['form']['second3'],
                        data['form']['second4'],
                        data['form']['second5'],
                        data['form']['second6'],
                        data['form']['second7'],
                        data['form']['second8'],
                        data['form']['second9'],
                        data['form']['second10'],
                        data['form']['second11'],
                        data['form']['second12'],
                       ]
        # get the table of conversions of distributions
        parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
        parameter = parameter_obj.read(cr,uid,data['form']['cci_value_id'],['name'])
        param_values = parameter_obj.get_value_from_names(cr,uid,[parameter['name']])
        if param_values.has_key(parameter['name']):
            new_distri = param_values[parameter['name']]
        else:
            new_distri = {}
        amline_obj = pooler.get_pool(cr.dbname).get('account.move.line')
        def_line_ids = amline_obj.search(cr,uid,[('journal_id','=',journal_id),('period_id','=',data['form']['period_id']),('account_id','in',associated_account_ids)])
        current_data = {}
        no_new_distri = False
        errors = []
        if def_line_ids:
            def_lines = amline_obj.browse(cr,uid,def_line_ids)
            for line in def_lines:
                if line.analytics_id:
                    if new_distri.has_key(line.analytics_id.name):
                        new_name = new_distri[line.analytics_id.name]
                        if new_name and new_name != '---':
                            adistri_ids = adistri_obj.search(cr,uid,[('name','=',new_name)])
                            if adistri_ids:
                                # get new distribution
                                distri = adistri_obj.browse(cr,uid,adistri_ids[0])
                                # calculate the amounts for the 12 periods for all distribution
                                period_amounts = {}
                                current_amount = ((line.credit or 0.0) - (line.debit or 0.0))
                                index = 0
                                for maj in majorations:
                                    current_amount *= maj
                                    period_amounts[index] = current_amount
                                    index += 1
                                # spread these 12 amounts in dotation_period
                                for rep_line in distri.account_ids:
                                    if rep_line.analytic_account_id.cci_post_id:
                                        key = (line.account_id.id,rep_line.analytic_account_id.cci_post_id.id)
                                        if current_data.has_key(key):
                                            datas = current_data[key]
                                        else:
                                            amounts = {}
                                            index = 0
                                            for period in majorations:
                                                amounts[index] = 0.0
                                                index += 1
                                            datas = {'amounts':amounts,'inside':[]}
                                        if new_name not in datas['inside']:
                                            datas['inside'].append(new_name)
                                        index = 0
                                        for period in starget_periods:
                                            datas['amounts'][index] += round(period_amounts[index] * rep_line.rate / 100, 2)
                                            index += 1
                                        current_data[key] = datas
                                    else:
                                        no_new_distri = True
                                        #errors.append('Analytic Account %s has no budgetary post' % rep_line.analytic_account_id.name )
                            else:
                                no_new_distri = True
                                if ('Incorrect analytic distribution name : %s' % new_distri[line.analytics_id.name]) not in errors:
                                    errors.append('Incorrect analytic distribution name : %s' % new_distri[line.analytics_id.name] )
                    else:
                        no_new_distri = True
                        if ('Analytic distribution name \'%s\' not found in conversion table' % line.analytics_id.name) not in errors:
                            errors.append('Analytic distribution name \'%s\' not found in conversion table' % line.analytics_id.name )
                else:
                    # nothing to do if no analytics in source line
                    pass
        else:
            no_new_distri = True
            errors.append('No movements found in period %i for journal %i, in specified accounts' % (data['form']['period_id'],journal_id) )
        if errors:
            # return error message to user
            data['form']['msg'] = 'NOTHING DONE !\n\nThere is some errors :\n' + '\n- '.join(errors)
        else:
            # Recording in dotations
            dotation_obj = pooler.get_pool(cr.dbname).get('cci_budget.dotation')
            per_dot_obj = pooler.get_pool(cr.dbname).get('cci_budget.period_dotation')
            for (key,datas) in current_data.items():
                account_id = key[0]
                post_id = key[1]
                # search for dotation
                dotation_ids = dotation_obj.search(cr,uid,[('budget_id','=',budget.id),('post_id','=',post_id),('account_id','=',account_id)])
                if dotation_ids:
                    dotation_id = dotation_ids[0]
                else:
                    dotation_id = dotation_obj.create(cr,uid,{'budget_id':budget.id,
                                                              'post_id':post_id,
                                                              'account_id':account_id,
                                                              'comments':'auto-created for salary\nFrom : ' + '; '.join(datas['inside']),
                                                              'active':True,
                                                             })
                index = 0
                for period in starget_periods:
                    if index == 5 and account_id in salary_account_ids:
                        this_month_amount = datas['amounts'][index] * 2
                    elif index == 11 and account_id in salary_account_ids:
                        this_month_amount = datas['amounts'][index] * 1.92
                    else:
                        this_month_amount = datas['amounts'][index]
                    per_dot_ids = per_dot_obj.search(cr,uid,[('dotation_id','=',dotation_id),('period_id','=',period['id'])])
                    if per_dot_ids and not data['form']['always_new']:
                        per_dot_obj.write(cr,uid,[per_dot_ids[0],],{'amount':this_month_amount})
                    else:
                        per_dot_obj.create(cr,uid,{'dotation_id':dotation_id,
                                                   'period_id':period['id'],
                                                   'amount':this_month_amount,
                                                   'comments':'auto-created for salary\nFrom : ' + '; '.join(datas['inside']),
                                                  })
                    if (second_lines[index] > 0.001) and (account_id in salary_account_ids):
                        per_dot_obj.create(cr,uid,{'dotation_id':dotation_id,
                                                   'period_id':period['id'],
                                                   'amount':this_month_amount*second_lines[index],
                                                   'comments':'auto-created for salary\nFrom : %s\n\nSecond line for this month (paid holidays or 13st month).' % '; '.join(datas['inside']),
                                                  })
                    index += 1
                    
            data['form']['msg']='Salaries created'
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('create','Create Salary')]},
        },
        'create': {
            'actions': [_create_salary],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

cci_budget_create_salary('cci_budget_create_salary')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

