# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
import datetime
import codecs
from tools.translate import _
from pyExcelerator import *

form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="Files has been created.\nChoose the one(s) you want."  colspan="4"/>
     <field name="budget_struct_accounts.xls" colspan="4" />
     <field name="budget_struct_accounts.xml" colspan="4" />
</form>"""

fields = {
    'budget_struct_accounts.xls':{'string': 'Excel file','type': 'binary','readonly': True,},
    'budget_struct_accounts.xml':{'string': 'XML File','type': 'binary','readonly': True,},
}

class extract_struct_accounts(wizard.interface):
    def _extract_data(self,cr,uid,data,context):
        filename = 'budget_struct_accounts.xls'
        fn2 = 'budget_struct_accounts.xml'
        out2 = codecs.open(fn2, "w", "utf-8")
        wb = Workbook()
        ws1 = wb.add_sheet(u"Structure Budget Global")
        ws1.write(0,0,'Date ' + datetime.date.today().strftime('%d/%m/%Y') )
        ws1.write(2,0,u"Catégorie")
        ws1.write(2,1,u"Groupe")
        ws1.write(2,2,u"Compte comptable")
        out2.write('<?xml version="1.0" encoding="utf-8"?>\n')
        line = 2
        #
        categ_obj = pooler.get_pool(cr.dbname).get('cci_budget.budget_account_category')
        group_obj = pooler.get_pool(cr.dbname).get('cci_budget.budget_account_group')
        account_obj = pooler.get_pool(cr.dbname).get('account.account')
        categ_ids = categ_obj.search(cr,uid,[])
        categs = categ_obj.read(cr,uid,categ_ids,['id','name','sequence'])
        group_ids = group_obj.search(cr,uid,[])
        groups = group_obj.read(cr,uid,group_ids,['id','name','category_id'])
        account_ids = account_obj.search(cr,uid,[])
        accounts = account_obj.read(cr,uid,account_ids,['id','code','name','cci_budget_group_id'])
        sortedCategs = sorted(categs,key=lambda x: x['sequence'])
        sortedAccounts = sorted(accounts,key=lambda x: x['code'])
        for categ in sortedCategs:
            line += 1
            new_categ = True
            ws1.write(line,0,categ['name'])
            out2.write('<category>%s</category>\n' % categ['name'])
            for group in groups:
                if group['category_id'][0] == categ['id']:
                    if not new_categ:
                        line += 1
                    new_categ = False
                    new_group = True
                    ws1.write(line,1,group['name'])
                    out2.write('\t<group>%s</group>\n' % group['name'])
                    for account in sortedAccounts:
                        if account['cci_budget_group_id'] and account['cci_budget_group_id'][0] == group['id']:
                            if not new_group:
                                line += 1
                            new_group = False
                            ws1.write(line,2,(account['code'] or '') + ' - ' + (account['name'] or '') )
                            out2.write('\t\t<account>%s</account>\n' % ((account['code'] or '') + ' - ' + (account['name'] or '')))
        wb.save(filename)
        result_file = open(filename,'rb').read()
        out2.close()
        result2 = open(fn2,'rb').read()
        # give the results to the user
        data['form']['budget_struct_accounts.xls']=base64.encodestring(result_file)
        data['form']['budget_struct_accounts.xml']=base64.encodestring(result2)
        return data['form']

    states = {
        'init': {
            'actions': [_extract_data],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Ok')]}
        },
    }
extract_struct_accounts('extract_struct_accounts')
