# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
import datetime
import codecs
from tools.translate import _
from pyExcelerator import *
from xml.sax.saxutils import escape

form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="Files has been created.\nChoose the one(s) you want."  colspan="4"/>
     <field name="budget_struct_projects.xls" colspan="4" />
     <field name="budget_struct_projects.xml" colspan="4" />
</form>"""

fields = {
    'budget_struct_projects.xls':{'string': 'Excel file','type': 'binary','readonly': True,},
    'budget_struct_projects.xml':{'string': 'XML File','type': 'binary','readonly': True,},
}

class extract_struct_projects(wizard.interface):
    def _extract_data(self,cr,uid,data,context):
        filename = 'budget_struct_projects.xls'
        fn2 = 'budget_struct_projects.xml'
        out2 = codecs.open(fn2, "w", "utf-8")
        wb = Workbook()
        ws1 = wb.add_sheet(u"Structure Budget par Projet")
        ws1.write(0,0,'Date ' + datetime.date.today().strftime('%d/%m/%Y') )
        ws1.write(2,0,u"Département")
        ws1.write(2,1,u"Poste")
        ws1.write(2,2,u"Compte analytique")
        out2.write('<?xml version="1.0" encoding="utf-8"?>\n')
        out2.write('<analytic-plans>\n')
        line = 2
        #
        dept_obj = pooler.get_pool(cr.dbname).get('cci_budget.department')
        post_obj = pooler.get_pool(cr.dbname).get('cci_budget.post')
        aaccount_obj = pooler.get_pool(cr.dbname).get('account.analytic.account')
        dept_ids = dept_obj.search(cr,uid,[])
        depts = dept_obj.read(cr,uid,dept_ids,['id','name'])
        post_ids = post_obj.search(cr,uid,[])
        posts = post_obj.read(cr,uid,post_ids,['id','name','department_id'])
        aaccount_ids = aaccount_obj.search(cr,uid,[])
        aaccounts = aaccount_obj.read(cr,uid,aaccount_ids,['id','code','name','cci_post_id'])
        sortedDepts = sorted(depts,key=lambda x: x['name'])
        sortedAaccounts = sorted(aaccounts,key=lambda x: x['code'])
        for dept in sortedDepts:
            line += 1
            new_dept = True
            ws1.write(line,0,dept['name'])
            out2.write('\t<department>%s\n' % escape(dept['name']))
            out2.write('\t\t<posts>\n')
            for post in posts:
                if post['department_id'][0] == dept['id']:
                    if not new_dept:
                        line += 1
                    new_dept = False
                    new_post = True
                    ws1.write(line,1,post['name'])
                    out2.write('\t\t\t<post>%s\n' % post['name'])
                    out2.write('\t\t\t\t<analytic_accounts>%s\n' % escape(post['name']))
                    for aaccount in sortedAaccounts:
                        if aaccount['cci_post_id'] and aaccount['cci_post_id'][0] == post['id']:
                            if not new_post:
                                line += 1
                            new_post = False
                            ws1.write(line,2,escape((aaccount['code'] or '') + ' - ' + (aaccount['name'] or '')))
                            out2.write('\t\t\t\t\t<analytic_account>%s</analytic_account>\n' % escape((aaccount['code'] or '') + ' - ' + (aaccount['name'] or '')))
                    out2.write('\t\t\t\t</analytic_accounts>%s\n' % post['name'])
                    out2.write('\t\t\t</post>\n')
            out2.write('\t\t</posts>\n')
            out2.write('\t</department>\n')
        wb.save(filename)
        result_file = open(filename,'rb').read()
        out2.write('</analytic-plans>\n')
        out2.close()
        result2 = open(fn2,'rb').read()
        # give the results to the user
        data['form']['budget_struct_projects.xls']=base64.encodestring(result_file)
        data['form']['budget_struct_projects.xml']=base64.encodestring(result2)
        return data['form']

    states = {
        'init': {
            'actions': [_extract_data],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Ok')]}
        },
    }
extract_struct_projects('extract_struct_projects')
