# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2008 CCI Connect ASBL. (http://www.cciconnect.be) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
import time
import datetime
import ftplib
import sys
import StringIO
import base64
import re
import tools
import pooler
from pyExcelerator import *
from osv import fields, osv
from tools.translate import _
from operator import itemgetter
import pymysql

def only_phone_numbers(phone_number):
    orig = phone_number.strip()
    result = ''
    for carac in orig:
        if carac in '0123456789':
            result += carac
    return result
def convert_phone(string):
    if len(string) > 0:
        if len(string) == 9:
            if string[0:2] in ['02','03','04','09']:
                result = string[0:2] + "/" + string[2:5] + "." + string[5:7] + "." + string[7:]
            else:
                result = string[0:3] + "/" + string[3:5] + "." + string[5:7] + "." + string[7:]
        elif len(string) == 10:
            result = string[0:4] + "/" + string[4:6] + "." + string[6:8] + "." + string[8:]
        else:
            result = string
    else:
        result = ''
    return result

def detect_strange_chars(string):
    result = ''
    index = 0
    for car in string:
        if ord(car) > 128:
            result += str(index) + ' ' + str(ord(car)) + ' ' + car + '\n'
        index += 1
    return result
    
def get_list_of_emails(original_email,text_list_of_emails):
    result = []
    if original_email:
        result.append(original_email.strip())
    if text_list_of_emails:
        if ';' in text_list_of_emails:
            supp = text_list_of_emails.split(';')
            for x in supp:
                result.append(x.strip())
        elif ',' in text_list_of_emails:
            supp = text_list_of_emails.split(',')
            for x in supp:
                result.append(x.strip())
        else:
            result.append(text_list_of_emails.strip())
    return result
    
def personalize_texts(cr,uid,participant,tags,texts,session=None,activityCodeRootID=0,dActivities={}):
    full_texts = []
    partner_obj = pooler.get_pool(cr.dbname).get('res.partner')
    for text in texts:
        for tag in tags.findall(text):
            tag_name = str(tag)
            if tag_name == '{PERSO cnp_inscrit}':
                text = text.replace(tag_name,( ( participant.contact_id.title or '' ) + ' ' + participant.contact_id.name + ' ' + ( participant.contact_id.first_name or '' ) ).strip())
            elif tag_name == '{PERSO cpn_inscrit}':
                text = text.replace(tag_name,( ( participant.contact_id.title or '' ) + ' ' + ( participant.contact_id.first_name or '' ) + ' ' + participant.contact_id.name ).strip().replace('  ',' '))
            elif tag_name == '{PERSO pn_inscrit}':
                text = text.replace(tag_name,( ( participant.contact_id.first_name or '' ) + ' ' + participant.contact_id.name ).strip())
            elif tag_name == '{PERSO np_inscrit}':
                text = text.replace(tag_name,( participant.contact_id.name + ' ' + ( participant.contact_id.first_name or '' ) ).strip())
            elif tag_name == '{PERSO n_inscrit}':
                text = text.replace(tag_name,participant.contact_id.name.strip())
            elif tag_name == '{PERSO cn_inscrit}':
                text = text.replace(tag_name,( ( participant.contact_id.title or '' ) + ' ' + participant.contact_id.name ).strip())
            elif tag_name == '{PERSO p_inscrit}':
                text = text.replace(tag_name,( participant.contact_id.first_name or '' ).strip())
            elif tag_name == '{PERSO p_id}':
                text = text.replace(tag_name,str(participant.id))
            elif tag_name == '{PERSO job_fonction}':
                fonction = ''
                for job_id in participant.contact_id.job_ids:
                    if job_id.address_id and job_id.address_id.partner_id and job_id.address_id.partner_id.id == participant.partner_id.id:
                        fonction = job_id.function_label or ''
                        break
                text = text.replace(tag_name,fonction.strip())
            elif tag_name == '{PERSO job_street}':
                tag_value = ''
                for job_id in participant.contact_id.job_ids:
                    if job_id.address_id and job_id.address_id.partner_id and job_id.address_id.partner_id.id == participant.partner_id.id:
                        tag_value = (job_id.address_id.street or '').strip()
                        if job_id.address_id.street2:
                            tag_value += ( ' - ' + job_id.address_id.street2.strip() )
                        break
                text = text.replace(tag_name,tag_value)
            elif tag_name == '{PERSO job_city}':
                tag_value = ''
                for job_id in participant.contact_id.job_ids:
                    if job_id.address_id and job_id.address_id.partner_id and job_id.address_id.partner_id.id == participant.partner_id.id:
                        if job_id.address_id.zip_id:
                            tag_value = (job_id.address_id.zip_id.name or '' ) + ' ' + (job_id.address_id.zip_id.city or '')
                        else:
                            # can't be but who can be sure...
                            tag_value = ( job_id.address_id.zip or '') + ' ' + (job_id.address_id.city or '')
                        break
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO usual_email}':
                tag_value = ''
                for job_id in participant.contact_id.job_ids:
                    if job_id.address_id and job_id.address_id.partner_id and job_id.address_id.partner_id.id == participant.partner_id.id:
                        if job_id.email:
                            tag_value = job_id.email
                            break
                        elif participant.contact_id.email:
                            tag_value = participant.contact_id.email
                            break
                        elif job_id.address_id.email:
                            tag_value = job_id.address_id.email
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO partner_activcode}':
                if activityCodeRootID == 0 and dActivities:
                    parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
                    param_values = parameter_obj.get_value_from_names(cr,uid,['ActivityCodeRootID'])
                    if param_values.has_key('ActivityCodeRootID'):
                        activityCodeRootID = param_values['ActivityCodeRootID']
                if activityCodeRootID != 0 and dActivities:
                    activ_sect = ''
                    for categ in participant.partner_id.category_id: ## category_id is, not like his name define, an array of category ids
                        if dActivities.has_key(categ.id):
                            activ_sect = dActivities[categ.id] or ''
                            break
                    text = text.replace(tag_name,activ_sect.strip())
                else:
                    text = text.replace(tag_name,'??' + tag_name[7:-1] + '-NoParameterSet??')
            elif tag_name == '{PERSO partner_activtext}':
                # when we capture text from browse objects, the content is truncated to 250 first caracters, not exactly what we want
                tag_value = ''
                if participant.partner_id:
                    partner = partner_obj.read(cr,uid,[participant.partner_id.id],['activity_description'],{'lang':'fr_FR'})
                    tag_value = partner[0]['activity_description'] or ''
                    tag_value = tag_value.replace('\n','<br/>')
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO session_address}':
                # the address indicated on the session, if not, on the club
                tag_value = ''
                if session:
                    address = False
                    if session.host_address_id:
                        address = session.host_address_id
                    else:
                        if session.group_id and session.group_id.host_address_id:
                            address = session.group_id.host_address_id
                    if address:
                        tag_value = address.street.strip()
                        if address.street2:
                            tag_value += ' ' + address.street2.strip()
                        if address.zip_id:
                            tag_value += ', ' + address.zip_id.name + ' ' + ( address.zip_id.city or '' )
                    else:
                        tag_value = '{no address defined}'
                else:
                    tag_value = '{??no session object here??}'
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO session_host_name}':
                # the host_name indicated on the session, if not, on the club
                tag_value = ''
                if session:
                    address = False
                    if session.host_address_id:
                        address = session.host_address_id
                    else:
                        if session.group_id and session.group_id.host_address_id:
                            address = session.group_id.host_address_id
                    if address and address.partner_id:
                        tag_value = address.partner_id.name
                    else:
                        tag_value = '{no host name defined}'
                else:
                    tag_value = '{??no session object here??}'
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO session_host_firstname}':
                # the first name of the host contact indicated on the session, if not, not on club, but empty
                tag_value = ''
                if session:
                    if session.host_contact_id:
                        tag_value = session.host_contact_id.first_name
                    else:
                        tag_value = ''
                else:
                    tag_value = '{??no session object here??}'
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO session_host_mobile}':
                # the first name of the host contact indicated on the session, if not, not on club, but empty
                tag_value = ''
                if session:
                    if session.host_contact_id and session.host_contact_id.mobile:
                        try:
                            tag_value = '<br/>GSM : ' + session.host_contact_id.mobile[0:4]+'/'+session.host_contact_id.mobile[4:6]+'.'+session.host_contact_id.mobile[6:8]+'.'+session.host_contact_id.mobile[8:]
                        except Exception:
                            tag_value = '<br/>GSM : ' + session.host_contact_id.mobile
                    else:
                        tag_value = ''
                else:
                    tag_value = '{??no session object here??}'
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO session_warning_before}':
                tag_value = ''
                if session:
                    if session.warning_before:
                        tag_value = '<p>' + session.warning_before + '</p>'
                        tag_value = tag_value.replace('\n','<br/>')
                else:
                    tag_value = '{??no session object here??}'
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO club_responsible}':
                tag_value = ''
                if participant.group_id.responsible_id:
                    tag_value = participant.group_id.responsible_id.name
                else:
                    tag_value = 'Votre responsable %s' % participant.group_id.type_id.name
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO club_resp_mobile}':
                tag_value = ''
                if participant.group_id.responsible_id and participant.group_id.responsible_id.mobile:
                    tag_value = convert_phone(participant.group_id.responsible_id.mobile)
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO club_name}':
                tag_value = participant.group_id.name or ('ID:[%s]' % str(participant.group_id.id))
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO club_type}':
                if participant.group_id and participant.group_id.type_id:
                    tag_value = participant.group_id.type_id.name
                else:
                    tag_value = 'Alter Ego (manuel)'
                text = text.replace(tag_name,tag_value.strip())
            elif tag_name == '{PERSO club_hours}':
                tag_value = ''
                if participant.group_id.hours:
                    tag_value = '<p>De : ' + participant.group_id.hours + '</p>'
                text = text.replace(tag_name,tag_value)
            else:
                try:
                    text = text.replace(tag_name,str(eval(tag_name[7:-1])).strip())
                except Exception:
                    text = text.replace(tag_name,'??' + tag_name[7:-1] + '??')
        full_texts.append( text )
    return full_texts

def addWorkingDays(cr,uid,beginDate,daysToAdd):
    finalDate = beginDate
    additional_days = 0
    holiday_obj = pooler.get_pool(cr.dbname).get('cci_club.club_holiday')
    while additional_days < daysToAdd:
        finalDate += datetime.timedelta(days=1)
        if finalDate.weekday() not in [5,6]:
            # search if notworkingdays for alter ego
            holiday_ids = holiday_obj.search(cr,uid,[('date_from','<=',finalDate),('date_to','>=',finalDate),('notworking_alter','=',True)])
            if not holiday_ids:
                additional_days += 1
    return finalDate

def addWorkingDaysByType(cr,uid,beginDate,daysToAdd,type_ids):
    finalDate = beginDate
    additional_days = 0
    holiday_obj = pooler.get_pool(cr.dbname).get('cci_club.club_holiday')
    # get future holidays of this type
    holiday_ids = holiday_obj.search(cr,uid,[('date_to','>=',beginDate)])
    future_holidays_of_these_types = []
    holidays = holiday_obj.read(cr,uid,holiday_ids,['date_from','date_to','type_ids'])
    for holiday in holidays:
        if holiday['type_ids'] and type_ids and set(holiday['type_ids']).intersection(set(type_ids)):
            future_holidays_of_these_types.append((holiday['date_from'],holiday['date_to']))
    while additional_days < daysToAdd:
        finalDate += datetime.timedelta(days=1)
        if finalDate.weekday() not in [5,6]:
            # search if not holiday for these types of clubs
            found_holiday = False
            for holiday in future_holidays_of_these_types:
                cfinalDate = finalDate.strftime("%Y-%m-%d")
                if cfinalDate >= holiday[0] and cfinalDate <= holiday[1]:
                    found_holiday = True
                    break
            if not found_holiday:
                additional_days += 1
    return finalDate

class club(osv.osv):
    _inherit = "cci_club.club"
    _columns = {
	    'closed' : fields.boolean('Closed',help='Check this box if this club is closed'),
	    'active' : fields.boolean('Active'),
	    'state': fields.selection([('draft','Waiting to begin'),('current','Current'),('done','Closed')],'State'),
	    'warning_start': fields.date('Warning Start Send',help="Date of mail sending to warn responsible and salesman of the start of a new club"),
	    'host_address_id': fields.many2one('res.partner.address','Host Address'),
	    'external_name': fields.char('External Name',size=30),
	    'closure_date': fields.date('Closure Date',help="Date of counting possible formation checks for this club once finished"),
        'day' : fields.selection([('Monday','Monday'),('Tuesday','Tuesday'),('Wednesday','Wednesday'),('Thursday','Thursday'),('Friday','Friday'),('none','None')],'Day'),
        'school2_id' : fields.many2one('res.partner','School 2'),
        'formative2_id' : fields.many2one('res.partner.contact','Formative 2'),
    }
    _defaults = {
        'closed': lambda *a: False,
	    'active' : lambda *a: True,
	    'day': lambda *a: 'none',
    }

    def unlink(self,cr,uid,ids,context):
        empty = True
        for club in self.browse(cr,uid,ids):
            if len(club.participation_ids) > 0:
                empty = False
        if empty:
            return super(osv.osv,self).unlink(cr,uid,ids,context)
        else:
            raise osv.except_osv(_('Error!'),_("You can't delete a club with participations !"))
            return False
    def copy(self, cr, uid, id, default=None, context={}):
        part = self.read(cr,uid,id,['name','code','external_name'])
        if not default:
            default = {}
        default.update({
            'name':part['name']+' (copy)',
            'code':(part['code'] or '')+' (copy)',
            'participation_ids': False,
            'session_ids':False,
            'external_name':False,
            'date_begin':False,
            'agreement_nbr':False,
            'closure_date':False,
            'date_end':False,
        })
        return super(club, self).copy(cr, uid, id, default, context)
    def write(self, cr, uid, ids,vals,context=None):
        self._get_active_participations(cr, uid, ids, None, None, context)
        if len(ids) == 1 and vals.has_key('external_name'):
            if vals['external_name']:
                vals['external_name'] = vals['external_name'].replace('\n','').replace('\t','').replace('\r','')
        return super(osv.osv,self).write(cr, uid, ids,vals, context)

    def _forced_unlink(self,cr,uid,club_id,context):
        # this method delete all linked participations, sessions and attendances
        # this method is not directly callable, but through a wizard that ask for a confirmation
        # and check there is only one club selected
        # we first delete attendances, then sessions then participations in case there is a problem somewhere
        obj_attendance = self.pool.get('cci_club.attendance')
        obj_session = self.pool.get('cci_club.session')
        session_ids = obj_session.search(cr,uid,[('group_id','=',club_id)])
        if session_ids:
            attendance_ids = obj_attendance.search(cr,uid,[('session_id','in',session_ids),'|',('active','=',True),('active','=',False)])
            if attendance_ids:
                obj_attendance.unlink(cr,uid,attendance_ids,context)
                # don't need to delete also linked convocations because ondelet=cascade on this many2one link
            obj_session.unlink(cr,uid,session_ids,context)
        obj_part_log = self.pool.get('cci_club.participation_log')
        obj_part = self.pool.get('cci_club.participation')
        part_ids = obj_part.search(cr,uid,[('group_id','=',club_id),'|',('active','=',True),('active','=',False)])
        if part_ids:
            part_log_ids = obj_part_log.search(cr,uid,[('participation_id','in',part_ids),'|',('active','=',True),('active','=',False)])
            if part_log_ids:
                obj_part_log.unlink(cr,uid,part_log_ids,context)
            obj_part.unlink(cr,uid,part_ids,context)
        obj_club = self.pool.get('cci_club.club')
        obj_club.unlink(cr,uid,[club_id,],context)
        return True
    def _recalc_end_date(self,cr,uid,club_ids):
        for club_id in club_ids:
            selection = """SELECT MAX(date) from cci_club_session WHERE group_id = %s""" % str(club_id)
            cr.execute(selection)
            res = cr.fetchall()
            if len(res) > 0:
                max_date = res[0][0]
            else:
                max_date = False
            self.pool.get('cci_club.club').write(cr,uid,[club_id],{'date_end':max_date})
        return True

    def _recycle_from_last_session_or_create(self,cr,uid,club_id,new_date,create_if_needed=False,created_state_id=False):
        # this method take the last session of this club and transform it to a new_date
        # mainly to insert it into the flow, during holidays for example
        # the result is a tuple with :
        # 0/ modified session_id if recycled session
        # 1/ old date of this session
        # 2/ new date
        # 3/ session state name
        # 4/ Old value of 'number' before changement
        # 5/ New value of 'number' after recycling
        # 6/ id of created record if created session
        # The way to differentiate recycled of created records is by ID : res[0] = 0 is empty if created
        result = False
        selection = """SELECT id, date from cci_club_session WHERE date IS NOT NULL AND group_id = %s ORDER BY date desc""" % str(club_id)
        cr.execute(selection)
        res = cr.fetchall()
        if res:
            session_id = res[0][0]
            session_obj = self.pool.get('cci_club.session')
            session = session_obj.browse(cr,uid,session_id)
            if session:
                if not session.attendance_ids:
                    # The last session is not yet used, we can recycle it
                    old_date = session.date or ''
                    old_number = ( session.number or '' )
                    new_number = ''
                    new_data = {'date':new_date,'comments':(session.comments or '') + _('\n\nUsed during Lerian Import to insert a date.\nOld value : %s') % old_date }
                    session_obj.write(cr,uid,[session.id],new_data)
                    # we search for the maximum number before that date
                    before_ids = session_obj.search(cr,uid,[('group_id','=',club_id),('date','<',new_date)])
                    befores = session_obj.read(cr,uid,before_ids,['date','number'])
                    max_number = 0
                    max_date = '1980-01-01'
                    for sess in befores:
                        if sess['date'] and sess['number']:
                            if sess['date'] > max_date and sess['number'] and sess['number'].strip().isdigit():
                                max_date = sess['date']
                                max_number = int(sess['number'].strip())
                    if max_number:
                        # we correct the number of the new date and also of following dates
                        new_number = str(max_number+1)
                        session_obj.write(cr,uid,[session.id],{'number':new_number})
                        after_ids = session_obj.search(cr,uid,[('group_id','=',club_id),('date','>',new_date)])
                        afters = session_obj.read(cr,uid,after_ids,['id','number'])
                        for sess in afters:
                            if sess['number'] and sess['number'].strip().isdigit():
                                session_obj.write(cr,uid,[sess['id']],{'number':str(int(sess['number'].strip())+1)})
                    result = (session_id,old_date,new_date,session.state_id.name,old_number,new_number,0)
                else:
                    if create_if_needed:
                        # we found no available dates, but we have the right to create a new one as needed
                        new_data = {}
                        new_data['group_id'] = club_id
                        new_data['date'] = new_date
                        new_data['number'] = 'add'
                        new_data['comments'] = 'created during import'
                        new_data['state_id'] = created_state_id
                        created_id = session_obj.create(cr,uid,new_data)
                        result = (0,'',new_date,created_state_id,'','add',created_id)
        return result
        
    def score_presences(self,cr,uid,**kwargs): # type_ids,minimum_sessions=0,supervisor_emails=[]
        '''
        This method checks the scoring of presences of participers to clubs of certain types
        '''
        # types_ids = list of id of clubs to score together
        #  if not given, we try to read it in the cci_parameters table with the key 'ScorePresenceTypes'
        # minimum_sessions = minimum number of past sessions to take this club into account.
        #  if the club has les past sessions, it is considered too young to give a good scoring
        #  if this parameter is not given, we try to read it in the cci_parameters table; key 'ScorePresenceMinimumSessions'
        # supervisor_emails = list of emails address of person to send them the report
        #  if empty; we try to read it in the cci_parameters table with the key 'ScorePresenceSupervisors'
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['ScorePresenceTypes','ScorePresenceMinimumSessions','ScorePresenceSupervisors'])
        if not kwargs.has_key('type_ids'):
            if param_values.has_key('ScorePresenceTypes'):
                type_ids = param_values['ScorePresenceTypes']
            else:
                type_ids = []
        else:
            type_ids = kwargs['type_ids']
        if not kwargs.has_key('minimum_sessions'):
            if param_values.has_key('ScorePresenceMinimumSessions'):
                minimum_sessions = param_values['ScorePresenceMinimumSessions']
            else:
                minimum_sessions = 0
        else:
            minimum_sessions = kwargs['minimum_sessions']
        if not kwargs.has_key('supervisor_emails'):
            if param_values.has_key('ScorePresenceSupervisors'):
                supervisor_emails = param_values['ScorePresenceSupervisors']
            else:
                supervisor_emails = []
        else:
            supervisor_emails = kwargs['supervisor_emails']
        if type_ids:
            # creating excel file for output
            ExcelFileName = 'score_presences.xls'

            wb = Workbook()
            ws1 = wb.add_sheet(u'Tables')
            ws2 = wb.add_sheet(u'Personnes')
            ws3 = wb.add_sheet(u'Paramètres')
            
            # recording parameters in excel file for 'debugging' if necessary
            ws3.write(0,0,u'Types')
            ws3.write(1,0,u'Minimum')
            ws3.write(2,0,u'Superviseurs')
            types = self.pool.get('cci_club.club_type').browse(cr,uid,type_ids)
            column = 1
            for club_type in types:
                ws3.write(0,column,'%s (%i)' % (club_type.name,club_type.id) )
                column += 1
            ws3.write(1,1,minimum_sessions)
            column = 1
            for item in supervisor_emails:
                ws3.write(2,column,item)
                column += 1
                
            # extract of all concerned club_ids
            if minimum_sessions > 0:
                selection = """SELECT group_id, count(group_id)
                                   FROM cci_club_session as sess
                                   WHERE sess.group_id in ( SELECT id from cci_club_club WHERE type_id in (%s) AND state = 'current' AND active ) 
                                       AND sess.date < '%s'
                                   GROUP BY sess.group_id
                                   HAVING count(group_id) > %i
                            """ % ( ','.join([str(x) for x in type_ids]) , datetime.date.today().strftime('%Y-%m-%d'), minimum_sessions )
            else:
                selection = """SELECT id
                                   FROM cci_club_club
                                   WHERE type_id in (%s) AND state = 'current' AND active
                            """ % ','.join([str(x) for x in type_ids])
            cr.execute(selection)
            res = cr.fetchall()
            club_ids = []
            part_ids = []
            if res:
                for line in res:
                    club_ids.append(line[0])
                
                # for these clubs, extract the number of present/absent/undefined for each participer
                selection = """SELECT attend.participation_id, session.group_id, state.count_as, count(attend.id)
                                   FROM cci_club_attendance as attend, cci_club_session as session, cci_club_attendance_state as state
                                   WHERE attend.state = state.id AND attend.session_id = session.id AND attend.active AND
                                         session.group_id in (%s) AND session.date < '%s'
                                   GROUP BY attend.participation_id,session.group_id,state.count_as
                                   ORDER BY group_id, participation_id, count_as
                            """ % ( ','.join([str(x) for x in club_ids]), datetime.date.today().strftime('%Y-%m-%d') )
                cr.execute(selection)
                res = cr.fetchall()
                dResClubs = {}
                dResParts = {}
                for line in res:
                    # add this sum in the count for the clubs
                    if dResClubs.has_key(line[1]):
                        resClub = dResClubs[line[1]]
                    else:
                        resClub = {'present':0,'absent':0,'undefined':0}
                    resClub[line[2]] += line[3]
                    dResClubs[line[1]] = resClub
                    # add this sum in the count for the participers
                    if dResParts.has_key(line[0]):
                        resPart = dResParts[line[0]]
                    else:
                        resPart = {'present':0,'absent':0,'undefined':0}
                    resPart[line[2]] += line[3]
                    dResParts[line[0]] = resPart
                # sort the results by ascending scoring (the worst scoring at the beginning)
                # with the scoring = present/(present+absent)
                scoring_clubs = []
                for (key,result) in dResClubs.items():
                    if result['present'] + result['absent'] > 0:
                        scoring_clubs.append( ( key,int(result['present']*100/(result['present']+result['absent'])) ) )
                sorted_scoring_clubs = sorted(scoring_clubs, key=lambda k: k[1] )
                scoring_parts = []
                for (key,result) in dResParts.items():
                    if result['present'] + result['absent'] > 0:
                        scoring_parts.append( ( key,int(result['present']*100/(result['present']+result['absent'])) ) )
                    part_ids.append( key )
                sorted_scoring_parts = sorted(scoring_parts, key=lambda k: k[1] )
            # record results
            # first tab : scoring by clubs
            ws1.write(0,0,u'Nom Club')
            ws1.write(0,1,u'Présences')
            ws1.write(0,2,u'Absences')
            ws1.write(0,3,u'Indéterminé')
            ws1.write(0,4,u'Scoring')
            ws1.write(0,5,u'Séances passées encodées')
            ws1.write(0,6,u'Séances passées indéterminées')
            ws1.write(0,7,u'Séances futures')
            ws1.write(0,8,u'Ecole')
            if club_ids:
                clubs = self.pool.get('cci_club.club').browse(cr,uid,club_ids)
                dClubs = {}
                for club in clubs:
                    dClubs[club.id] = {'name':club.name,'school':club.school_id and club.school_id.name or ''}
                obj_session = self.pool.get('cci_club.session')
                today = datetime.date.today().strftime('%Y-%m-%d')
                line = 1
                for (key,result) in sorted_scoring_clubs:
                    ws1.write(line,0,dClubs[key]['name'])
                    ws1.write(line,1,dResClubs[key]['present'])
                    ws1.write(line,2,dResClubs[key]['absent'])
                    ws1.write(line,3,dResClubs[key]['undefined'])
                    ws1.write(line,4,result)
                    # reading of the state of sessions of this clubs
                    session_ids = obj_session.search(cr,uid,[('group_id','=',key)])
                    sessions = obj_session.browse(cr,uid,session_ids)
                    encoded = 0
                    undefined = 0
                    future = 0
                    for session in sessions:
                        if session.date >= today:
                            future += 1
                        else:
                            if session.attendance_ids:
                                encoded += 1
                            else:
                                undefined += 1
                    ws1.write(line,5,encoded)
                    ws1.write(line,6,undefined)
                    ws1.write(line,7,future)
                    ws1.write(line,8,dClubs[key]['school'])
                    line += 1
            # second tab : scoring by participation
            ws2.write(0,0,u'Participant')
            ws2.write(0,1,u'Entreprise')
            ws2.write(0,2,u'Commercial')
            ws2.write(0,3,u'Club')
            ws2.write(0,4,u'Présent')
            ws2.write(0,5,u'Absent')
            ws2.write(0,6,u'Indéterminé')
            ws2.write(0,7,u'Scoring')
            if part_ids:
                parts = self.pool.get('cci_club.participation').browse(cr,uid,part_ids)
                dParts = {}
                for participer in parts:
                    if participer.contact_id:
                        full_name = participer.contact_id.name
                        if participer.contact_id.first_name:
                            full_name += ( ' ' + participer.contact_id.first_name )
                    else:
                        full_name = ''
                    salesman_name = ''
                    if participer.partner_id:
                        if participer.partner_id.user_id:
                            salesman_name = participer.partner_id.user_id.name or ''
                    dParts[participer.id] = {'name':full_name,'company':participer.partner_id and participer.partner_id.name or '','salesman':salesman_name,'club':participer.group_id and participer.group_id.name or ''}
                line = 1
                for (key,result) in sorted_scoring_parts:
                    ws2.write(line,0,dParts[key]['name'])
                    ws2.write(line,1,dParts[key]['company'])
                    ws2.write(line,2,dParts[key]['salesman'])
                    ws2.write(line,3,dParts[key]['club'])
                    ws2.write(line,4,dResParts[key]['present'])
                    ws2.write(line,5,dResParts[key]['absent'])
                    ws2.write(line,6,dResParts[key]['undefined'])
                    ws2.write(line,7,result)
                    line += 1
            # 
            # save the created excel file
            wb.save(ExcelFileName)
            
            # sending by mail to the possible supervisor(s)
            if supervisor_emails:
                tools.email_send('no-reply@ccilvn.be', supervisor_emails, u'Scoring des Présences', u'Scoring des présences du jour', subtype='html', attach = [(ExcelFileName,open(ExcelFileName,'rb').read())] )
            
        else:
            ExcelFileName = ''
        return ExcelFileName
        
    def dont_forget_you(self,cr,uid):
        ''' 
        This method select participers to certains type(s) of club(s) if participers are 'waiting' and clubs are in 'wait state'
        After this selection, we send an 'we dont forget you' mail to all these participers
        AND a reminder of what is sended to the responsibles of theses clubs AND to a list of possible additionnal supervisors
        '''
        # Start log
        cronline_id = self.pool.get('cci_logs.cron_line')._start(cr,uid,'ClubDontForgetYou')
        final_result = True
        #
        bd_test = False
        #
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['DontForgetYouTemplateID','DontForgetYouPartStateList','DontForgetYouClubStateList','DontForgetYouClubTypeList','DontForgetYouSupervisors','DontForgetYouEMailFrom','BDDeTest'])
        if param_values.has_key('DontForgetYouTemplateID') and \
                param_values.has_key('DontForgetYouEMailFrom') and \
                param_values.has_key('DontForgetYouPartStateList') and \
                param_values.has_key('DontForgetYouClubStateList') and \
                param_values.has_key('DontForgetYouClubTypeList') and \
                param_values.has_key('DontForgetYouSupervisors'):
            if param_values.has_key('BDDeTest'):
                bd_test = param_values['BDDeTest']
            template_obj = self.pool.get('cci_email_template')
            templates = template_obj.browse(cr,uid,[param_values['DontForgetYouTemplateID']])
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'Good Configuration')
            if len(templates) == 1:
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nFound Template')
                template = templates[0]
                # we have all necessary parameters, we can now select
                selection = '''SELECT particip.id
                                    FROM cci_club_participation as particip, cci_club_club as club
                                    WHERE particip.active AND particip.group_id = club.id AND particip.state_id in (%s) 
                                          AND club.state in (%s) AND club.type_id in (%s) AND club.active
                                    ORDER by particip.group_id
                            ''' % (','.join([str(x) for x in param_values['DontForgetYouPartStateList']]),
                                   ','.join([("'"+x+"'") for x in param_values['DontForgetYouClubStateList']]),
                                   ','.join([str(x) for x in param_values['DontForgetYouClubTypeList']]))
                cr.execute(selection)
                res = cr.fetchall()
                if res:
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nMails sended to :\nParticipants :')
                    part_ids = [x[0] for x in res]
                    supervisors = param_values['DontForgetYouSupervisors']
                    if supervisors:
                        supervisors = supervisors.replace(';',',')
                        lSupervisors = supervisors.split(',')
                        lSupervisors = [x.strip() for x in lSupervisors]
                    else:
                        lSupervisors = []
                    # we create browse objects with all participants but we use only those having an email
                    # logically all, but we can't be sure
                    tags = re.compile('{PERSO .*?}',re.IGNORECASE)
                    dResponsibles = {}
                    all_lines_supervisors = ''
                    parts = self.pool.get('cci_club.participation').browse(cr,uid,part_ids)
                    part_emails = []
                    for participant in parts:
                        if participant.email or participant.copy_emails:
                            full_texts = personalize_texts(cr,uid,participant,tags,[template.subject,template.body],session)
                            # sending of the email
                            if not bd_test:
                                tools.email_send(param_values['DontForgetYouEMailFrom'], get_list_of_emails(participant.email,participant.copy_emails), full_texts[0], full_texts[1], subtype=template.type)
                            else:
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBD Test => no real sending' )
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n"%s" [Participation ID : %s]' % (','.join(get_list_of_emails(participant.email,participant.copy_emails)), str(participant.id) ))
                            if participant.group_id.responsible_id.email or lSupervisors:
                                # we record the data about this participer for the responsible of the club and/or the supervisor(s)
                                line = "<p>%s - %s %s [%s]- %s</p>\n" % (participant.group_id.name,
                                                                         participant.contact_id.name,
                                                                         participant.contact_id.first_name or '', ';'.join(get_list_of_emails(participant.email,participant.copy_emails)),
                                                                         participant.partner_id.name )
                                if participant.group_id.responsible_id.email:
                                    if dResponsibles.has_key(participant.group_id.responsible_id.email):
                                        all_lines = dResponsibles[participant.group_id.responsible_id.email] + line
                                    else:
                                        all_lines = line
                                    dResponsibles[participant.group_id.responsible_id.email] = all_lines
                                if lSupervisors:
                                    all_lines_supervisors += line
                    if dResponsibles:
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nClub Responsibles :')
                        for (resp_email,all_lines) in dResponsibles.items():
                            if not bd_test:
                                tools.email_send(param_values['DontForgetYouEMailFrom'], [resp_email,], 'Le \'Nous ne vous oublions\' pas du jour', '<html><body>' + all_lines + '</body></html>', subtype='html')
                            else:
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBD Test => no real sending' )
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n"'+resp_email+'"')
                    if lSupervisors:
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSupervisors :')
                        for email_super in lSupervisors:
                            if not bd_test:
                                tools.email_send(param_values['DontForgetYouEMailFrom'], [email_super,], 'Le \'Nous ne vous oublions\' pas du jour', '<html><body>' + all_lines_supervisors + '</body></html>', subtype='html')
                            else:
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBD Test => no real sending' )
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n"'+email_super+'"')
                else:
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing to do - No Participations found with the selection :\n'+selection)
                    final_result = False # not really a bad case but this is a very special case to validate manually
            else:
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - Template ID not found')
                final_result = False
        else:
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - some parameters were missing')
            final_result = False
        self.pool.get('cci_logs.cron_line')._stop(cr,uid,cronline_id,final_result,'\n---end---')
        return True
    def send_confirm_presence(self,cr,uid,*params):
        ''' 
        This method select active participers to certains type(s) of club(s) having session in xx days
        It send mails to ask them to confirm or not their presence
        We can specify the parameters with the same name as in cci_value
        '''
        # Start log
        cronline_id = self.pool.get('cci_logs.cron_line')._start(cr,uid,'AlterEgoAskConfirmation')
        final_result = True
        #
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['AEConfirmConvocationName','AEConfirmTemplateID','AEConfirmPartStateList','AEConfirmClubStateList','AEConfirmClubTypeList','AEConfirmEMailFrom','AEConfirmDaysBefore','AEConfirmDaysLimit','AEConfirmSessionStateList','AEConfirmNoAnswerState','AEConfirmAnswerYesState','AEConfirmAnswerNoState','AEConfirmCopyResp','BDDeTest'])
        if params:
            if len(params) > 0:
                param_values['AEConfirmConvocationName'] = params[0]
                if len(params) > 1:
                    param_values['AEConfirmTemplateID'] = params[1]
                    if len(params) > 2:
                        param_values['AEConfirmPartStateList'] = params[2]
                        if len(params) > 3:
                            param_values['AEConfirmClubStateList'] = params[3]
                            if len(params) > 4:
                                param_values['AEConfirmClubTypeList'] = params[4]
                                if len(params) > 5:
                                    param_values['AEConfirmEMailFrom'] = params[5]
                                    if len(params) > 6:
                                        param_values['AEConfirmDaysBefore'] = params[6]
                                        if len(params) > 7:
                                            param_values['AEConfirmDaysLimit'] = params[7]
                                            if len(params) > 8:
                                                param_values['AEConfirmSessionStateList'] = params[8]
                                                if len(params) > 9:
                                                    param_values['AEConfirmNoAnswerState'] = params[9]
                                                    if len(params) > 10:
                                                        param_values['AEConfirmAnswerYesState'] = params[10]
                                                        if len(params) > 11:
                                                            param_values['AEConfirmAnswerNoState'] = params[11]
                                                            if len(params) > 12:
                                                                param_values['AEConfirmCopyResp'] = params[12]
                                                                if len(params) > 13:
                                                                    param_values['AEConfirmCopyResp'] = params[13]
        this_day = datetime.date.today()
        if this_day.strftime('%w') not in ['0','6']:
            if param_values.has_key('AEConfirmConvocationName') and \
                    param_values.has_key('AEConfirmTemplateID') and \
                    param_values.has_key('AEConfirmEMailFrom') and \
                    param_values.has_key('AEConfirmPartStateList') and \
                    param_values.has_key('AEConfirmClubStateList') and \
                    param_values.has_key('AEConfirmClubTypeList') and \
                    param_values.has_key('AEConfirmDaysBefore') and\
                    param_values.has_key('AEConfirmDaysLimit') and\
                    param_values.has_key('AEConfirmSessionStateList') and\
                    param_values.has_key('AEConfirmNoAnswerState') and\
                    param_values.has_key('AEConfirmAnswerYesState') and\
                    param_values.has_key('AEConfirmAnswerNoState') and\
                    param_values.has_key('AEConfirmCopyResp'):
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'Good Configuration :')
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nConvocation Name :' + str(param_values['AEConfirmConvocationName']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nTemplate ID :' + str(param_values['AEConfirmTemplateID']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEMail from : "' + param_values['AEConfirmEMailFrom'] + '"' )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nPart State List : [' + ','.join([str(x) for x in param_values['AEConfirmPartStateList']]) + ']' )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nClub State List : [' + ','.join([str(x) for x in param_values['AEConfirmClubStateList']]) + ']' )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nClub Type List : [' + ','.join([str(x) for x in param_values['AEConfirmClubTypeList']]) + ']' )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nDays Before :' + str(param_values['AEConfirmDaysBefore']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nDays Limit :' + str(param_values['AEConfirmDaysLimit']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSession State List : [' + ','.join([str(x) for x in param_values['AEConfirmSessionStateList']]) + ']' )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNo Answer ID :' + str(param_values['AEConfirmNoAnswerState']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nAnswer YES ID :' + str(param_values['AEConfirmAnswerYesState']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nAnswer NO ID :' + str(param_values['AEConfirmAnswerNoState']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nCopy to the Responsible :' + str(param_values['AEConfirmCopyResp']) )
                BD_DE_TEST = True
                if param_values.has_key('BDDeTest'):
                    if param_values['BDDeTest'] == 0:
                        BD_DE_TEST = False
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBD De Test :' + (BD_DE_TEST and 'OUI' or 'Non') )
                template_obj = self.pool.get('cci_email_template')
                templates = template_obj.browse(cr,uid,[param_values['AEConfirmTemplateID']])
                if len(templates) == 1:
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nFound Template')
                    club_type_obj = self.pool.get('cci_club.club_type')
                    template = templates[0]
                    # we have all necessary parameters, we can now select
                    for club_type_id in param_values['AEConfirmClubTypeList']:
                        club_type = club_type_obj.read(cr,uid,club_type_id,['name'])
                        next_date_to_warn = addWorkingDaysByType(cr,uid,this_day,param_values['AEConfirmDaysBefore'],[club_type_id,])
                        last_limit_date = addWorkingDaysByType(cr,uid,this_day,param_values['AEConfirmDaysLimit'],[club_type_id,])
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,"\n\nSearching sessions for club type '%s' between %s and %s" % (club_type['name'],last_limit_date.strftime('%Y-%m-%d'),next_date_to_warn.strftime('%Y-%m-%d')))
                        selection = '''SELECT session.id
                                            FROM cci_club_session as session, cci_club_club as club
                                            WHERE session.group_id = club.id AND session.state_id in (%s) AND club.active
                                                  AND club.state in (%s) AND club.type_id = %i AND session.date between '%s' and '%s'
                                    ''' % (','.join([str(x) for x in param_values['AEConfirmSessionStateList']]),
                                           ','.join([("'"+x+"'") for x in param_values['AEConfirmClubStateList']]),
                                           club_type_id,
                                           last_limit_date.strftime('%Y-%m-%d'),
                                           next_date_to_warn.strftime('%Y-%m-%d'))
                        cr.execute(selection)
                        res = cr.fetchall()
                        if res:
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n%s sessions found' % str(len(res)))
                            convoc_obj = self.pool.get('cci_club.convocation')
                            session_ids = [x[0] for x in res]
                            part_state_ids = param_values['AEConfirmPartStateList']
                            bSendedAtLeastOneMail = False
                            # we create browse objects with all sessions
                            tags = re.compile('{PERSO .*?}',re.IGNORECASE)
                            sessions = self.pool.get('cci_club.session').browse(cr,uid,session_ids)
                            attendance_obj = self.pool.get('cci_club.attendance')
                            for session in sessions:
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSession ID %s' % str(session.id) )
                                participants_status = []
                                if session.group_id.participation_ids:
                                    for participant in session.group_id.participation_ids:
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n # Participant ID %s' % str(participant.id) )
                                        if participant.state_id.id in part_state_ids and participant.date_in and participant.date_in <= session.date and ( participant.date_out >= session.date or not participant.date_out ):
                                            # check if attendance exists for this participant at this session
                                            attendance_ids = attendance_obj.search(cr,uid,[('participation_id','=',participant.id),('session_id','=',session.id)])
                                            send_mail = False
                                            nosend_reason = 'Unknown'
                                            if len(attendance_ids) == 0:
                                                # create in undetermined state
                                                attendance_id = attendance_obj.create(cr,uid,{'participation_id':participant.id,'session_id':session.id,'state':param_values['AEConfirmNoAnswerState'],'comments':'Automatic Creation','active':True})
                                                send_mail = True
                                                attendance_ids = [attendance_id]
                                            elif len(attendance_ids) == 1:
                                                attendance = attendance_obj.read(cr,uid,attendance_ids,['state'])[0]
                                                if attendance['state'][0] == param_values['AEConfirmNoAnswerState']:
                                                    send_mail = True
                                                else:
                                                    nosend_reason = 'Already answered'
                                            else:
                                                nosend_reason = 'Too much attendance for participant %s for session %s' % (str(participant.id),str(session.id))
                                            if send_mail:
                                                if participant.email or participant.copy_emails:
                                                    # check if already convocated
                                                    bContinue = False
                                                    if param_values['AEConfirmConvocationName'] == 'C1':
                                                        convocation_ids = convoc_obj.search(cr,uid,[('name','=','C1'),('email','=',participant.email),('attendance_id','=',attendance_ids[0])])
                                                        bContinue = not convocation_ids
                                                    else:
                                                        # convocation C2 => C1 already sended but not today and C2 not already sended
                                                        convocation_ids = convoc_obj.search(cr,uid,[('name','=','C1'),('email','=',participant.email),('attendance_id','=',attendance_ids[0])])
                                                        if convocation_ids:
                                                            convocation = convoc_obj.read(cr,uid,convocation_ids,['datetime'])[0]
                                                            if convocation['datetime'][0:10] < datetime.datetime.today().strftime('%Y-%m-%d'):
                                                                convocation_ids = convoc_obj.search(cr,uid,[('name','=','C2'),('email','=',participant.email),('attendance_id','=',attendance_ids[0])])
                                                                if not convocation_ids:
                                                                    bContinue = True
                                                        else:
                                                            bContinue = False
                                                    if bContinue:
                                                        full_texts = personalize_texts(cr,uid,participant,tags,[template.subject,template.body],session)
                                                        # construction of the list of other participants
                                                        if full_texts[1].find('{OTHER_PARTS}') >= 0:
                                                            lParts = '<ul>\n'
                                                            for other_participant in session.group_id.participation_ids:
                                                                if other_participant.id != participant.id and other_participant.state_id.id in part_state_ids:
                                                                    lParts += '<li>%s, %s</li>\n' % (other_participant.contact_id.name + ( other_participant.contact_id.first_name and ( ' ' + other_participant.contact_id.first_name ) or ''),other_participant.partner_id.name)
                                                            lParts += '</ul>\n'
                                                            full_texts[1] = full_texts[1].replace('{OTHER_PARTS}',lParts)
                                                        # personalize the links to confirm or not
                                                        ssid = str(attendance_ids[0])
                                                        rest = attendance_ids[0] % 83
                                                        if rest == 0:
                                                            ssid = ssid + '83'
                                                        else:
                                                            ssid = ssid + str(rest).rjust(2,'0')
                                                        link1 = "atid=%s&stid=%s" % (ssid,param_values['AEConfirmAnswerYesState'])
                                                        link2 = "atid=%s&stid=%s" % (ssid,param_values['AEConfirmAnswerNoState'])
                                                        full_texts[1] = full_texts[1] % (link1,link1,link2,link2)
                                                        # sending of the email
                                                        addr_email_from = param_values['AEConfirmEMailFrom']
                                                        if addr_email_from.upper() == 'RESPONSIBLE':
                                                            if session.group_id.responsible_id and session.group_id.responsible_id.email:
                                                                addr_email_from = session.group_id.responsible_id.email.strip()
                                                            else:
                                                                addr_email_from = 'ck@ccilvn.be'
                                                        if BD_DE_TEST:
                                                            print 'From : ' + addr_email_from
                                                            print 'To : ' + ','.join(get_list_of_emails(participant.email,participant.copy_emails))
                                                            print 'Subject : ' + full_texts[0]
                                                            print 'Message : ' + full_texts[1]
                                                        else:
                                                            tools.email_send(addr_email_from, get_list_of_emails(participant.email,participant.copy_emails), full_texts[0], full_texts[1], subtype=template.type)
                                                        bSendedAtLeastOneMail = True
                                                        # Recording of the sending
                                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,' - MAIL SENDED to "' + ";".join(get_list_of_emails(participant.email,participant.copy_emails)) + '"')
                                                        self.pool.get('cci_club.convocation').create(cr,uid,{'attendance_id':attendance_ids[0],'email':participant.email,'name':param_values['AEConfirmConvocationName']})
                                                    else:
                                                        send_mail = False
                                                        nosend_reason = 'Already sended first convocation'
                                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,' - Already sended convocation')
                                                else:
                                                    send_mail = False
                                                    nosend_reason = 'Participant without email'
                                                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,' - no email address')
                                            else:
                                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,' - ' + nosend_reason)
                                        else:
                                            send_mail = False
                                            if participant.state_id.id not in part_state_ids:
                                                nosend_reason = 'Participant not in good state'
                                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,' - not in good state')
                                            else:
                                                nosend_reason = 'Session not between Dates Begin and End of the participant'
                                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,' - session date not between begin-end dates')
                                        participants_status.append({'name':participant.contact_id.name + ' ' + (participant.contact_id.first_name or ''),
                                                                   'company':participant.partner_id.name,
                                                                   'mail':participant.email or '',
                                                                   'send_mail':send_mail,
                                                                   'nosend_reason':nosend_reason})
                                    # send the status of participants to the responsible of the club if at least one confirmation asked
                                    if participant.group_id.responsible_id.email and param_values['AEConfirmCopyResp'] and bSendedAtLeastOneMail:
                                        status_ok = ''
                                        status_ko = ''
                                        for status in participants_status:
                                            if status['send_mail']:
                                                status_ok += '%s, %s, %s<br/>' % (status['name'],status['company'],status['mail'])
                                            else:
                                                status_ko += '%s, %s, %s<br/>' % (status['name'],status['company'],status['nosend_reason'])
                                        summary_object = u'''{PERSO club_type} {PERSO session.date[8:]+'/'+ session.date[5:7]} - {PERSO club_name}'''
                                        summary_mail = u'''
                                                    <p>La prochaine réunion {PERSO club_type} du club : {PERSO club_name}</p>
                                                    <p>Aura lieu le <b>{PERSO session.date[8:]+'/'+ session.date[5:7]+'/'+ session.date[0:4]}</b></p>
                                                    {PERSO club_hours}
                                                    <p>Avertissement préalable : %s</p>
                                                    <p><u>Adresse du jour :</u><br/>
                                                    {PERSO session_host_name}<br/>
                                                    {PERSO session_address}</p>
                                                    <p><strong>Les participants suivants ont reçu un mail de demande de confirmation :</strong><br/>
                                                    %s
                                                    </p>
                                                    <p><strong>Les participants suivants n'ont pas reçu le mail :</strong><br/>
                                                    %s
                                                    </p>
                                                    ''' % (session.warning_before and session.warning_before.replace('\n','<br/>') or '-Aucun-',status_ok,status_ko)
                                        (summary_object,summary_mail) = personalize_texts(cr,uid,participant,tags,[summary_object,summary_mail],session)
                                        # sending of the email
                                        addr_email_from = param_values['AEConfirmEMailFrom']
                                        if addr_email_from.upper() == 'RESPONSIBLE':
                                            if session.group_id.responsible_id and session.group_id.responsible_id.email:
                                                addr_email_from = session.group_id.responsible_id.email.strip()
                                            else:
                                                addr_email_from = 'ck@ccilvn.be'
                                        if BD_DE_TEST:
                                            print 'From : ' + addr_email_from
                                            print 'To : ' + participant.group_id.responsible_id.email
                                            print 'Subject : ' + summary_object
                                            print 'Message : ' + summary_mail
                                            print 'BCC : philmer@ccilvn.be'
                                        else:
                                            tools.email_send(addr_email_from, [participant.group_id.responsible_id.email], summary_object, summary_mail, subtype='HTML', email_bcc=['philmer@ccilvn.be',])
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSending to Responsible : "' + participant.group_id.responsible_id.email + '"' )
                                else:
                                    # we have found a session for a club without any participants => we send a special email to the responsible of the club
                                    if session.group_id.responsible_id.email:
                                        summary_object = u'''%s %s - %s [%i]''' % (session.group_id.type_id.name, session.date[8:]+'/'+ session.date[5:7],session.group_id.name,session.group_id.id)
                                        summary_mail = u'''<p>Il y a bientôt une séance prévue pour ce club, mais il n'y a encore AUCUN participant inscrit dans ce club !</p>'''
                                        # sending of the email
                                        addr_email_from = param_values['AEConfirmEMailFrom']
                                        if addr_email_from.upper() == 'RESPONSIBLE':
                                            if session.group_id.responsible_id and session.group_id.responsible_id.email:
                                                addr_email_from = session.group_id.responsible_id.email.strip()
                                            else:
                                                addr_email_from = 'ck@ccilvn.be'
                                        if BD_DE_TEST:
                                            print 'From : ' + addr_email_from
                                            print 'To : ' + participant.group_id.responsible_id.email
                                            print 'Subject : ' + summary_object
                                            print 'Message : ' + summary_mail
                                            print 'BCC : philmer@ccilvn.be'
                                        else:
                                            tools.email_send(addr_email_from, [session.group_id.responsible_id.email], summary_object, summary_mail, subtype='HTML', email_bcc=['philmer@ccilvn.be',])
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSending Warning message to Responsible : "' + session.group_id.responsible_id.email + '"' )
                                        
                        else:
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - No sessions found with the selection :\n'+selection+'\n')
                else:
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - Template ID not found')
                    final_result = False
            else:
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - some parameters were missing')
                final_result = False
        else:
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - we\'re on saturday or sunday ...')
        self.pool.get('cci_logs.cron_line')._stop(cr,uid,cronline_id,final_result,'\n---end---')
        return True
    def get_mobile_or_prof_and_address_phone(self,participant):
        result = (participant.contact_id.mobile or '').strip()
        if not result:
            if participant.contact_id.job_ids:
                for job in participant.contact_id.job_ids:
                    if job.address_id and job.address_id.partner_id and job.address_id.partner_id.id == participant.partner_id.id:
                        if job.address_id.phone and job.phone:
                            result = u'Prof. : %s - Siège : %s' % ( convert_phone(job.phone.strip()),convert_phone(job.address_id.phone.strip()) )
                            break
                        elif job.address_id.phone and not job.phone:
                            result = u'Siège : %s' % convert_phone(job.address_id.phone.strip())
                            break
                        elif (not job.address_id.phone) and job.phone:
                            result = u'Prof. : %s' % convert_phone(job.phone.strip())
                            break
                        else: 
                            result = u'Pas de téléphone'                       
        return result
    def send_confirmed2host(self,cr,uid,*params):
        ''' 
        This method select active participers to certains type(s) of club(s) having session in xx days
        It send mails to the host to confirm their presence/absence
        It adds also club's responsible and formative to the list of presents if their presence is confirmed on session object
        It send the same mail to the formative

        We can specify the parameters with the same name as in cci_value
        '''
        # 2013-09-18 : there is something wrong with the extraction of the host email
        #              this bug has perhaps caused the errors of the 4/9, 14/9 and 15/9, not sure about it
        # 2016-05-13 : il there is no mobile for particiapnt, sho professional AND address phone (JB by mail)
        
        # Start log
        cronline_id = self.pool.get('cci_logs.cron_line')._start(cr,uid,'AlterEgoSendToHost')
        final_result = True
        
        # check if we're not on saturday or sunday : no sending on these days; check also if not in club_holiday
        this_day = datetime.date.today()
        if this_day.strftime('%w') not in ['0','6']:
            #holiday_obj = self.pool.get('cci_club.club_holiday')
            #holiday_ids = holiday_obj.search(cr,uid,[('date_from','<=',this_day.strftime('%Y-%m-%d')),('date_to','>=',this_day.strftime('%Y-%m-%d')),('notworking_alter','=',True)])
            #if not holiday_ids:
            parameter_obj = self.pool.get('cci_parameters.cci_value')
            param_values = parameter_obj.get_value_from_names(cr,uid,['AEHostTemplateID','AEHostPartStateList','AEHostClubStateList','AEHostClubTypeList','AEHostEMailFrom','AEHostDaysBefore','AEHostSessionStateList','AEConfirmNoAnswerState','AEConfirmAnswerYesState','AEConfirmAnswerNoState','BDDeTest'])
            if params:
                if len(params) > 0:
                    param_values['AEHostTemplateID'] = params[0]
                    if len(params) > 1:
                        param_values['AEHostPartStateList'] = params[1]
                        if len(params) > 2:
                            param_values['AEHostClubStateList'] = params[2]
                            if len(params) > 3:
                                param_values['AEHostClubTypeList'] = params[3]
                                if len(params) > 4:
                                    param_values['AEHostEMailFrom'] = params[4]
                                    if len(params) > 5:
                                        param_values['AEHostDaysBefore'] = params[5]
                                        if len(params) > 6:
                                            param_values['AEHostSessionStateList'] = params[6]
                                            if len(params) > 7:
                                                param_values['AEConfirmAnswerState'] = params[7]
                                                if len(params) > 8:
                                                    param_values['AEConfirmAnswerYesState'] = params[8]
                                                    if len(params) > 9:
                                                        param_values['AEConfirmAnswerNoState'] = params[9]
                                                        #if len(params) > 10:
                                                        #    param_values['BDDeTest'] = params[10]
            if param_values.has_key('AEHostTemplateID') and \
                    param_values.has_key('AEHostEMailFrom') and \
                    param_values.has_key('AEHostPartStateList') and \
                    param_values.has_key('AEHostClubStateList') and \
                    param_values.has_key('AEHostClubTypeList') and \
                    param_values.has_key('AEHostDaysBefore') and\
                    param_values.has_key('AEHostSessionStateList') and\
                    param_values.has_key('AEConfirmNoAnswerState') and\
                    param_values.has_key('AEConfirmAnswerYesState') and\
                    param_values.has_key('AEConfirmAnswerNoState') and\
                    param_values.has_key('BDDeTest'):
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'Good Configuration :')
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nTemplate ID :' + str(param_values['AEHostTemplateID']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEMail from : "' + param_values['AEHostEMailFrom'] + '"' )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nPart State List : [' + ','.join([str(x) for x in param_values['AEHostPartStateList']]) + ']' )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nClub State List : [' + ','.join([str(x) for x in param_values['AEHostClubStateList']]) + ']' )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nClub Type List : [' + ','.join([str(x) for x in param_values['AEHostClubTypeList']]) + ']' )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nDays Before :' + str(param_values['AEHostDaysBefore']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSession State List : [' + ','.join([str(x) for x in param_values['AEHostSessionStateList']]) + ']' )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNo Answer ID :' + str(param_values['AEConfirmNoAnswerState']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nAnswer YES ID :' + str(param_values['AEConfirmAnswerYesState']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nAnswer NO ID :' + str(param_values['AEConfirmAnswerNoState']) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBD de Test :' + str(param_values['BDDeTest']) )
                template_obj = self.pool.get('cci_email_template')
                templates = template_obj.browse(cr,uid,[param_values['AEHostTemplateID']])
                if len(templates) == 1:
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nFound Template')
                    bd_test = True
                    if param_values.has_key('BDDeTest'):
                        if param_values['BDDeTest'] == 0:
                            bd_test = False
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nType(bd_test) :' + str(type(bd_test)) )
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nbd_test :' + (bd_test and 'OUI' or 'Non') )
                    template = templates[0]
                    # we have all necessary parameters, we can now select
                    club_type_obj = self.pool.get('cci_club.club_type')
                    for club_type_id in param_values['AEHostClubTypeList']:
                        club_type = club_type_obj.read(cr,uid,club_type_id,['name'])
                        next_date_to_warn = addWorkingDaysByType(cr,uid,datetime.datetime.today(),param_values['AEHostDaysBefore'],[club_type_id,])
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,"\n\nSearching sessions for club type '%s' at the date %s" % (club_type['name'],next_date_to_warn.strftime('%Y-%m-%d')))
                        selection = '''SELECT session.id
                                            FROM cci_club_session as session, cci_club_club as club
                                            WHERE session.group_id = club.id AND session.state_id in (%s) AND club.active 
                                                  AND club.state in (%s) AND club.type_id = %i AND session.date = '%s'
                                    ''' % (','.join([str(x) for x in param_values['AEHostSessionStateList']]),
                                           ','.join([("'"+x+"'") for x in param_values['AEHostClubStateList']]),
                                           club_type_id,
                                           next_date_to_warn.strftime('%Y-%m-%d'))
                        cr.execute(selection)
                        res = cr.fetchall()
                        if res:
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n%s sessions found' % str(len(res)))
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nIDs : %s' % ','.join([str(x[0]) for x in res ]) )
                            session_ids = [x[0] for x in res]
                            part_state_ids = param_values['AEHostPartStateList']
                            # we create browse objects with all sessions
                            tags = re.compile('{PERSO .*?}',re.IGNORECASE)
                            sessions = self.pool.get('cci_club.session').browse(cr,uid,session_ids)
                            NoAnswerStateName = self.pool.get('cci_club.attendance_state').browse(cr,uid,[param_values['AEConfirmNoAnswerState']])[0].name
                            AnswerYesStateName = self.pool.get('cci_club.attendance_state').browse(cr,uid,[param_values['AEConfirmAnswerYesState']])[0].name
                            AnswerNoStateName = self.pool.get('cci_club.attendance_state').browse(cr,uid,[param_values['AEConfirmAnswerNoState']])[0].name
                            attendance_obj = self.pool.get('cci_club.attendance')
                            for session in sessions:
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSession ID %s management' % str(session.id) )
                                participants_status = []
                                if session.group_id.participation_ids:
                                    for participant in session.group_id.participation_ids:
                                        if participant.state_id.id in part_state_ids and participant.date_in and participant.date_in <= session.date and ( participant.date_out >= session.date or not participant.date_out ):
                                            # check if attendance exists for this participant at this session
                                            attendance_ids = attendance_obj.search(cr,uid,[('participation_id','=',participant.id),('session_id','=',session.id)])
                                            send_mail = False
                                            status2 = ''
                                            if len(attendance_ids) == 0:
                                                # create in undetermined state
                                                attendance_id = attendance_obj.create(cr,uid,{'participation_id':participant.id,'session_id':session.id,'state':param_values['AEConfirmNoAnswerState'],'comments':'Automatic Creation','active':True})
                                                send_mail = NoAnswerStateName
                                                status2 = 'NoMail'
                                                reason = u'Présence non trouvée'
                                                attendance_ids = [attendance_id]
                                            elif len(attendance_ids) == 1:
                                                attendance = attendance_obj.read(cr,uid,attendance_ids,['state'])[0]
                                                if attendance['state'][0] in [param_values['AEConfirmNoAnswerState'],param_values['AEConfirmAnswerYesState'],param_values['AEConfirmAnswerNoState']]:
                                                    send_mail = attendance['state'][1]
                                                    status2 = attendance['state'][1]
                                                    reason = ''
                                                else:
                                                    status2 = NoAnswerStateName
                                                    reason = u'Présence mal enregistrée'
                                            else:
                                                status2 = NoAnswerStateName
                                                reason = u'Trop de présences enregistrées'
                                            mobile_def = self.get_mobile_or_prof_and_address_phone(participant)
                                            participants_status.append({'name':participant.contact_id.name.strip() + ' ' + (participant.contact_id.first_name or '').strip(),
                                                                       'company':participant.partner_id.name.strip(),
                                                                       'mobile':convert_phone(mobile_def), 
                                                                       'status':send_mail,
                                                                       'status2':status2,
                                                                       'reason':reason})
                                        else:
                                            if not participant.state_id.id in part_state_ids:
                                                mobile_def = self.get_mobile_or_prof_and_address_phone(participant)
                                                participants_status.append({'name':participant.contact_id.name.strip() + ' ' + (participant.contact_id.first_name or '').strip(),
                                                                           'company':participant.partner_id.name.strip(),
                                                                           'mobile':convert_phone(mobile_def), 
                                                                           'status':False,
                                                                           'status2':'NoMail',
                                                                           'reason':u'Etat de la participation non pris en compte'})
                                            elif not (participant.date_in and participant.date_in <= session.date and ( participant.date_out >= session.date or not participant.date_out )):
                                                mobile_def = self.get_mobile_or_prof_and_address_phone(participant)
                                                participants_status.append({'name':participant.contact_id.name.strip() + ' ' + (participant.contact_id.first_name or '').strip(),
                                                                           'company':participant.partner_id.name.strip(),
                                                                           'mobile':convert_phone(mobile_def), 
                                                                           'status':False,
                                                                           'status2':'NoMail',
                                                                           'reason':u'Participation hors dates'})
                                            elif not participant.email:
                                                mobile_def = self.get_mobile_or_prof_and_address_phone(participant)
                                                participants_status.append({'name':participant.contact_id.name.strip() + ' ' + (participant.contact_id.first_name or '').strip(),
                                                                           'company':participant.partner_id.name.strip(),
                                                                           'mobile':convert_phone(mobile_def), 
                                                                           'status':False,
                                                                           'status2':'NoMail',
                                                                           'reason':u'Participation sans adresse email'})
                                    # endfor participant
                                   
                                    full_texts = personalize_texts(cr,uid,participant,tags,[template.subject,template.body],session)
                                    status_confirmed = ''
                                    status_absents = ''
                                    #status_unknown = ''
                                    for status in participants_status:
                                        if status['status']:
                                            if status['status'] == AnswerYesStateName:


                                                status_confirmed += '%s, %s [%s]<br/>' % (status['name'],status['company'],status['mobile'])
                                            elif status['status'] == AnswerNoStateName:
                                                status_absents += '%s, %s [%s]<br/>' % (status['name'],status['company'],status['mobile'])
                                    # add the formative and the responsible to the presents
                                    if session.group_id.responsible_id and session.presence_responsible:
                                        status_confirmed += 'Responsable interne : %s, %s [%s]<br/>' % (session.group_id.responsible_id.name,'CCI',convert_phone(session.group_id.responsible_id.mobile or ''))
                                    if session.group_id.formative_id and session.presence_formative:
                                        formative_name = session.group_id.formative_id.name
                                        school_name = ''
                                        if session.group_id.formative_id.first_name:
                                            formative_name += ( ' ' + session.group_id.formative_id.first_name )
                                        if session.group_id.school_id:
                                            school_name = session.group_id.school_id.name
                                        status_confirmed += 'Animateur : %s, %s<br/>' % (formative_name,school_name)
                                    if not status_confirmed:
                                        status_confirmed = '-aucun-'
                                    if not status_absents:
                                        status_absents = '-aucun-'
                                    full_texts[1] = full_texts[1] % (status_confirmed,status_absents)  ## we don't use 'status_unknown' anymore for host, but later
                                    host_email = ''
                                    if session.host_contact_id:
                                        if session.host_contact_id.email:
                                            host_email = session.host_contact_id.email.strip()
                                        else:
                                            for job in session.host_contact_id.job_ids:
                                                if job.address_id and job.address_id.id == session.host_address_id.id:
                                                    if job.email:
                                                        host_email = job.email.strip()
                                                        break
                                                    elif job.address_id.email:
                                                        host_email = job.address_id.email.strip()
                                                        break
                                    formative_email = ''
                                    if session.group_id.formative_id:
                                        # try first professionnal email, else, personal
                                        if session.group_id.school_id:
                                            for job in session.group_id.formative_id.job_ids:
                                                if job.address_id and job.address_id.partner_id and job.address_id.partner_id.id == session.group_id.school_id.id:
                                                    if job.email:
                                                        formative_email = job.email.strip()
                                                        break
                                        if not formative_email and session.group_id.formative_id.email:
                                            formative_email = session.group_id.formative_id.email.strip()
                                    if host_email:
                                        full_texts[0] = full_texts[0].encode('ascii', 'xmlcharrefreplace')
                                        full_texts[1] = full_texts[1].encode('ascii', 'xmlcharrefreplace')
                                        strange = detect_strange_chars(full_texts[0])
                                        if strange:
                                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nStrange characters : '+strange )
                                        strange = detect_strange_chars(full_texts[1])
                                        if strange:
                                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nStrange characters : '+strange )
                                        # sending of the email
                                        addr_email_from = param_values['AEHostEMailFrom']
                                        if addr_email_from.upper() == 'RESPONSIBLE':
                                            if session.group_id.responsible_id and session.group_id.responsible_id.email:
                                                addr_email_from = session.group_id.responsible_id.email.strip()
                                            else:
                                                addr_email_from = 'ck@ccilvn.be'
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n%s' % addr_email_from)
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n%s' % host_email)
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nObject : %s' % full_texts[0])
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBody : %s' % full_texts[1])
                                        if not bd_test:
                                            tools.email_send(addr_email_from, [host_email], full_texts[0], full_texts[1], subtype=template.type, email_bcc=['philmer@ccilvn.be',])
                                        else:
                                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBD Test => no real sending' )
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSending to Host : "' + host_email + '"' )
                                    else:
                                        host_email = 'None !'
                                        if session.host_contact_id: # no email address found for the host. But we have a contact => seems Houston has a problem
                                            # we send a warning mail to responsible of the club, else to Celine Kuetgens
                                            # and we mark this task as 'not correct'
                                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n\n--------------------------\nNO EMAIL FOUND FOR THE HOST !!!!\n--------------------------\n\n' )
                                            final_result = False
                                            if session.group_id.responsible_id and session.group_id.responsible_id.email:
                                                addr_email_from = session.group_id.responsible_id.email.strip()
                                            else:
                                                addr_email_from = 'ck@ccilvn.be'
                                            if not bd_test:
                                                tools.email_send(addr_email_from, [addr_email_from,], 'No email address for Host', '<p>The ERP has found <strong>no email address</strong> for the host contact of %s</p><p>No email sended to host...</p>' % session.group_id.name, subtype=template.type, email_bcc=['philmer@ccilvn.be',])
                                            else:
                                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBD Test => no real sending' )

                                    # send the status of participants to the responsible of the club and perhaps to the formative
                                    status_confirmed = ''
                                    status_absents = ''
                                    status_noanswer = ''
                                    #status_nomail = ''
                                    for status in participants_status:
                                        if status['status2'] == AnswerYesStateName:
                                            status_confirmed += '%s, %s<br/>' % (status['name'],status['company'])
                                        elif status['status2'] == AnswerNoStateName:
                                            status_absents += '%s, %s<br/>' % (status['name'],status['company'])
                                        elif status['status2'] == NoAnswerStateName:
                                            status_noanswer += '%s, %s, %s<br/>' % (status['name'],status['company'],status['mobile'])

                                        #else:
                                        #    status_nomail += '%s, %s : %s<br/>' % (status['name'],status['company'],status['reason'])
                                    # add the formative and the responsible to the presents
                                    if session.group_id.responsible_id:
                                        status_confirmed += 'Responsable interne : %s, %s<br/>' % (session.group_id.responsible_id.name,'CCI')
                                    if session.group_id.formative_id:
                                        formative_name = session.group_id.formative_id.name
                                        school_name = ''
                                        if session.group_id.formative_id.first_name:
                                            formative_name += ( ' ' + session.group_id.formative_id.first_name )
                                        if session.group_id.school_id:
                                            school_name = session.group_id.school_id.name
                                        status_confirmed += 'Animateur : %s, %s<br/>' % (formative_name,school_name)
                                    if not status_confirmed:
                                        status_confirmed = '-aucun-'
                                    if not status_absents:
                                        status_absents = '-aucun-'
                                    if not status_noanswer:
                                        status_noanswer = '-aucun-'
                                    #if not status_nomail:
                                    #    status_nomail = '-aucun-'
                                    summary_object = u'''{PERSO club_type} {PERSO session.date[8:]+'/'+ session.date[5:7]} - {PERSO club_name}'''
                                    summary_mail = u'''
                                                <p>La prochaine réunion {PERSO club_type} du club : {PERSO club_name}</p>
                                                <p>Aura lieu le <b>{PERSO session.date[8:]+'/'+ session.date[5:7]+'/'+ session.date[0:4]}</b></p>
                                                {PERSO club_hours}
                                                <p><u>Adresse du jour :</u><br/>
                                                {PERSO session_host_name}<br/>
                                                {PERSO session_address}</p>
                                                {PERSO session_warning_before}
                                                <p><strong>Les participants suivants ont confirmé leur présence :</strong><br/>
                                                %s
                                                </p>
                                                <p><strong>Les participants suivants ont confirmé leur absence :</strong><br/>
                                                %s
                                                </p>
                                                <p><strong>Les participants suivants n'ont pas répondu :</strong><br/>
                                                %s
                                                </p>
                                                ''' % (status_confirmed,status_absents,status_noanswer) ## ,status_nomail not anymore used
                                    # sending of the email to the responsible and, perhaps, to the formative
                                    # 2016-02-17 : perhaps also to host if host_email is in '@ccilvn.be'
                                    # 2016-10-07 : also to alterego@ccilvn.be
                                    (summary_object,summary_mail) = personalize_texts(cr,uid,participant,tags,[summary_object,summary_mail],session)
                                    resp_email = ''
                                    summary_object = summary_object.encode('ascii', 'xmlcharrefreplace')
                                    summary_mail = summary_mail.encode('ascii', 'xmlcharrefreplace')
                                    strange = detect_strange_chars(summary_object)
                                    if strange:
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nStrange characters : '+strange )
                                    strange = detect_strange_chars(summary_mail)
                                    if strange:
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nStrange characters : '+strange )
                                    addr_email_from = param_values['AEHostEMailFrom']
                                    if addr_email_from.upper() == 'RESPONSIBLE':
                                        if session.group_id.responsible_id and session.group_id.responsible_id.email:
                                            addr_email_from = session.group_id.responsible_id.email.strip()
                                        else:
                                            addr_email_from = 'ck@ccilvn.be'
                                    if participant.group_id.responsible_id.email and ( host_email and participant.group_id.responsible_id.email != host_email):
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSended to responsible # host')
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n%s' % addr_email_from)
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n%s' % participant.group_id.responsible_id.email)
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nObject : %s' % summary_object)
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBody : %s' % summary_mail)
                                        if not bd_test:
                                            tools.email_send(addr_email_from, [participant.group_id.responsible_id.email,], summary_object, summary_mail, subtype='HTML', email_bcc=['philmer@ccilvn.be','alterego@ccilvn.be'])
                                        else:
                                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBD Test => no real sending' )
                                        resp_email = participant.group_id.responsible_id.email
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSending to Responsible : "' + participant.group_id.responsible_id.email + '"' )
                                    if host_email and ('@ccilvn.be' in host_email):
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSended a copy to CCI Host')
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n%s' % addr_email_from)
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n%s' % participant.group_id.responsible_id.email)
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nObject : %s' % summary_object)
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBody : %s' % summary_mail)
                                        if not bd_test:
                                            tools.email_send(addr_email_from, [host_email,], summary_object, summary_mail, subtype='HTML', email_bcc=['philmer@ccilvn.be','alterego@ccilvn.be'])
                                        else:
                                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBD Test => no real sending' )

                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSending a copy to CCI Host : "' + host_email + '"' )
                                    if formative_email and formative_email != host_email and formative_email != resp_email:
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSended to formative')
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n%s' % addr_email_from)
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n%s' % participant.group_id.responsible_id.email)
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nObject : %s' % summary_object)
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBody : %s' % summary_mail)
                                        if not bd_test:
                                            tools.email_send(addr_email_from, [formative_email,], summary_object, summary_mail, subtype='HTML', email_bcc=['philmer@ccilvn.be','alterego@ccilvn.be'])
                                        else:
                                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nBD Test => no real sending' )
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSending to formative : "' + formative_email + '"' )
                                else:
                                    # no participations linked to the club of this session
                                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - No participant to this session')
                        else:
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - No sessions found with the selection :\n'+selection)
                else:
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - Template ID not found')
                    final_result = False
            else:
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - some parameters were missing')
                final_result = False
#            else:
#                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - we\'re on holiday ...')
        else:
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - we\'re on saturday or sunday ...')
        self.pool.get('cci_logs.cron_line')._stop(cr,uid,cronline_id,final_result,'\n---end---')
        return True
    def evaluate_yourself(self,cr,uid):
        ''' 
        This method select active participers to certains type(s) of club(s) for wich the end of activity approach
        After this selection, we send them an evaluation form
        The Evaluation Forms (one by langage) is attached to the concerned Template; each begin with the code of the concerned Langage
        '''
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['EvaluationFormTemplateID','EvaluationFormRemainingSessions','EvaluationFormAttachmentName','EvaluationFormPartStateList','EvaluationFormClubTypeList','EvaluationFormSupervisors','EvaluationFormEMailFrom'])
        if param_values.has_key('EvaluationFormTemplateID') and \
                param_values.has_key('EvaluationFormRemainingSessions') and \
                param_values.has_key('EvaluationFormAttachmentName') and \
                param_values.has_key('EvaluationFormEMailFrom') and \
                param_values.has_key('EvaluationFormPartStateList') and \
                param_values.has_key('EvaluationFormClubTypeList') and \
                param_values.has_key('EvaluationFormSupervisors'):
            template_obj = self.pool.get('cci_email_template')
            templates = template_obj.browse(cr,uid,[param_values['EvaluationFormTemplateID']])
            if len(templates) == 1:
                template = templates[0]
                # we have all necessary parameters, we can now select
                # first we select all clubs with an approaching end date
                selection = '''SELECT club.id
                                    FROM cci_club_club as club
                                    WHERE club.state = 'current' AND club.type_id in (%s) AND club.active
                            ''' % (','.join([str(x) for x in param_values['EvaluationFormClubTypeList']]))
                cr.execute(selection)
                res = cr.fetchall()
                if res:
                    # prepare the list of supervisor to sed also a copy of the mail
                    supervisors = param_values['EvaluationFormSupervisors']
                    if supervisors:
                        supervisors = supervisors.replace(';',',')
                        lSupervisors = supervisors.split(',')
                        lSupervisors = map(strip,lSupervisors)
                    else:
                        lSupervisors = []
                    # prepare the list of attachments file from the template attachments
                    attach_obj = self.pool.get('ir.attachment')
                    attach_ids = attach_obj.search(cr,uid,[('res_model','=','cci_email_template'),('res_id','=',template.id)])
                    attachs = attach_obj.read(cr,uid,attach_ids,['datas','name'])
                    dAttachs = {}
                    for attach in attachs:
                        dAttachs[attach['name'][0:2]] = base64.decodestring(attach['datas'])
                    # manage club list
                    club_ids = [x[0] for x in res]
                    clubs = self.pool.get('cci_club.club').browse(cr,uid,club_ids)
                    today = datetime.date.today().strftime('%Y-%m-%d')
                    for club in clubs:
                        # for each club, we validate if there are concerned; 
                        # and if concerned, if it has some participants concerned
                        sessions_left = 0
                        if club.session_ids:
                            for sess in club.session_ids:
                                if sess.date > today:
                                    sessions_left += 1
                        if sessions_left <= param_values['EvaluationFormRemainingSessions']:
                            selection = '''SELECT id
                                                FROM cci_club_participation
                                                WHERE group_id = %s AND state_id in (%s) AND evaluation_form IS NULL AND active
                                        ''' % (str(club.id),
                                               ','.join([str(x) for x in param_values['EvaluationFormPartStateList']]))
                            cr.execute(selection)
                            res = cr.fetchall()
                            if res:
                                part_ids = [x[0] for x in res]
                                supervisors = param_values['EvaluationFormSupervisors']
                                if supervisors:
                                    supervisors = supervisors.replace(';',',')
                                    lSupervisors = supervisors.split(',')
                                else:
                                    lSupervisors = []
                                # we create browse objects with all participants but we use only those having an email
                                # logically all, but we can't be sure
                                tags = re.compile('{PERSO .*?}',re.IGNORECASE)
                                part_obj = self.pool.get('cci_club.participation')


                                parts = part_obj.browse(cr,uid,part_ids)
                                for participant in parts:
                                    if participant.email or participant.copy_emails:
                                        full_texts = personalize_texts(cr,uid,participant,tags,[template.subject,template.body])
                                        # we prepare the attachment file for this participer
                                        if participant.language_id and participant.language_id.code and len(participant.language_id.code) == 2 and dAttachs.has_key(participant.language_id.code):
                                            attachedFile = (param_values['EvaluationFormAttachmentName'],dAttachs[participant.language_id.code])
                                        else:
                                            attachedFile = None
                                        # sending of the email
                                        addr_email_from = param_values['EvaluationFormEMailFrom']
                                        if addr_email_from.upper() == 'RESPONSIBLE':
                                            if club.responsible_id and club.responsible_id.email:
                                                addr_email_from = club.responsible_id.email.strip()
                                            else:
                                                addr_email_from = 'ck@ccilvn.be'
                                        if lSupervisors:
                                            if attachedFile:
                                                tools.email_send(addr_email_from, get_list_of_emails(participant.email,participant.copy_emails), full_texts[0], full_texts[1], subtype=template.type, email_bcc = lSupervisors, attach = [attachedFile])
                                            else:
                                                tools.email_send(addr_email_from, get_list_of_emails(participant.email,participant.copy_emails), full_texts[0], full_texts[1], subtype=template.type, email_bcc = lSupervisors)
                                        else:
                                            if attachedFile:
                                                tools.email_send(addr_email_from, get_list_of_emails(participant.email,participant.copy_emails), full_texts[0], full_texts[1], subtype=template.type, attach = [attachedFile])
                                            else:
                                                tools.email_send(addr_email_from, get_list_of_emails(participant.email,participant.copy_emails), full_texts[0], full_texts[1], subtype=template.type)
                                        # recording of the date of email sending
                                        part_obj.write(cr,uid,[participant.id],{'evaluation_form':today})
        return True
    def _send_survey_link(self,cr,uid,survey_type,club_ids):
        ''' 
        This method select participers of 'ACTIVE' state to user-select list of club(s)
        After this selection, we send them en email with the link to an evaluation form
        '''
        final_text = u'Envoi des emails pour les enquêtes'
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['Survey_%s_TemplateID' % survey_type,'AEFormsConnectionDict','AEEvaluationFormEMailFrom'])
        if param_values.has_key('Survey_%s_TemplateID' % survey_type) and param_values.has_key('AEFormsConnectionDict') and param_values.has_key('AEEvaluationFormEMailFrom'):
            template_obj = self.pool.get('cci_email_template')
            templates = template_obj.browse(cr,uid,[param_values['Survey_%s_TemplateID' % survey_type]])
            if len(templates) == 1:
                template = templates[0]
                tags = re.compile('{PERSO .*?}',re.IGNORECASE)
                # we have all necessary parameters, we can now select
                connection = param_values['AEFormsConnectionDict']
                cur = False
                con = False
                try:
                    con = pymysql.connect(host=connection['host'], port=connection['port'], user=connection['user'], passwd=connection['pw'], db=connection['db'], charset='utf8');
                    cur = con.cursor(pymysql.cursors.DictCursor)
                    sentence = "SELECT pid FROM `aeforms` WHERE type = '%s' AND pid > 0 AND pid IS NOT NULL " % survey_type
                    cur.execute(sentence)
                    res = cur.fetchall()
                    answered_ids = []
                    for line in res:
                        answered_ids.append(line['pid'])
                except pymysql.err.Error, e:
                    print 'Connection Error %d: %s' % (e.args[0],e.args[1])
                    final_result = False
                if cur:
                    cur.close()
                if con:
                    con.close()
                # second we select all selected clubs with participants
                final_text += u'\n\nRésultats :'
                good_state_ids = self.pool.get('cci_club.participation_state').search(cr,uid,[('name','ilike','ACTIVE')])
                clubs = self.pool.get('cci_club.club').browse(cr,uid,club_ids)
                for club in clubs:
                    answered = []
                    sended = []
                    wo_emails = []
                    for participant in club.participation_ids:
                        if participant.state_id and participant.state_id.id in good_state_ids:
                            if participant.email or participant.copy_emails:
                                if participant.id not in answered_ids:
                                    full_texts = personalize_texts(cr,uid,participant,tags,[template.subject,template.body])
                                    # sending of the email
                                    addr_email_from = param_values['AEEvaluationFormEMailFrom']
                                    if addr_email_from.upper() == 'RESPONSIBLE':
                                        if club.responsible_id and club.responsible_id.email:
                                            addr_email_from = club.responsible_id.email.strip()
                                        else:
                                            addr_email_from = 'ck@ccilvn.be'
                                    tools.email_send(param_values['AEEvaluationFormEMailFrom'], get_list_of_emails(participant.email,participant.copy_emails), full_texts[0], full_texts[1], subtype=template.type)
                                    sended.append(participant.email)
                                else:
                                    answered.append(participant.email)
                            else:
                                wo_emails.append(participant.contact_id and participant.contact_id.name or str(participant.id) )
                    final_text += u'\n\nGroupe %s [%d]:\nEnvois :\n- %s\nDéjà répondu :\n- %s\nPas d\'adresse email :\n- %s' % (club.name,
                                                                                                                                club.id,
                                                                                                                                sended and '\n- '.join(sended) or u'aucun',
                                                                                                                                answered and '\n- '.join(answered) or u'aucun',
                                                                                                                                wo_emails and '\n- '.join(wo_emails) or u'aucun',
                                                                                                                               )
            else:
                final_text = u'Problème pour retrouver le template.\n\nEnvoi non effectué.'
        else:
            final_text = u'Il manque des paramètres.\n\nEnvoi non effectué.'
        return final_text
    def warn_new(self,cr,uid):
        ''' 
        This method warn the responsible of the start of a new table. It send also mails to salesman concerned by these partners
        '''
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['ClubWarnNewTemplateID','ClubWarnNewClubStateList','ClubWarnNewClubTypeList','ClubWarnNewEMailFrom'])
        if param_values.has_key('ClubWarnNewTemplateID') and \
                param_values.has_key('ClubWarnNewEMailFrom') and \
                param_values.has_key('ClubWarnNewClubStateList') and \
                param_values.has_key('ClubWarnNewClubTypeList'):
            template_obj = self.pool.get('cci_email_template')
            templates = template_obj.browse(cr,uid,[param_values['ClubWarnNewTemplateID']])
            if len(templates) == 1:
                template = templates[0]
                # we have all necessary parameters, we can now select
                selection = '''SELECT id
                                    FROM cci_club_club 
                                    WHERE state in (%s) AND type_id in (%s)
                                       AND warning_start IS NULL AND active
                            ''' % (','.join([("'"+x+"'") for x in param_values['ClubWarnNewClubStateList']]),
                                   ','.join([str(x) for x in param_values['ClubWarnNewClubTypeList']]))
                cr.execute(selection)
                res = cr.fetchall()
                if res:
                    club_ids = [x[0] for x in res]
                    clubs = self.pool.get('cci_club.club').browse(cr,uid,club_ids)
                    part_ids = []
                    for club in clubs:
                        for part in club.participation_ids:
                            part_ids.append( part.id )
                    # we create browse objects with all participants
                    parts = self.pool.get('cci_club.participation').browse(cr,uid,part_ids)
                    dParts = {}
                    for part in parts:
                        dParts[part.id] = {'company':part.partner_id.name,'part_name':part.contact_id.name + ' ' + (part.contact_id.first_name or '' ),'salesman_id':(part.partner_id.user_id and part.partner_id.user_id.id or 0)}
                    dResponsibles = {}
                    dSalesmen = {}
                    user_ids = []
                    for club in clubs:
                        lSalesman = []
                        text_resp = '<p><strong>Nouveau Club : %s</strong><br/>\n' % club.name
                        for part_id in club.participation_ids:
                            text_resp += '%s - %s<br/>\n' % (dParts[part_id.id]['company'],dParts[part_id.id]['part_name'])
                            if dParts[part_id.id]['salesman_id'] > 0:
                                if not dSalesmen.has_key(dParts[part_id.id]['salesman_id']):
                                    dSalesmen[dParts[part_id.id]['salesman_id']] = ''
                                text_sales = dSalesmen[dParts[part_id.id]['salesman_id']]
                                if dParts[part_id.id]['salesman_id'] not in lSalesman:
                                    text_sales += '<p><strong>Nouveau Club : %s</strong><br/>\n' % club.name
                                    lSalesman.append( dParts[part_id.id]['salesman_id'] )
                                text_sales += '%s - %s<br/>\n' % (dParts[part_id.id]['company'],dParts[part_id.id]['part_name'])
                                dSalesmen[dParts[part_id.id]['salesman_id']] = text_sales
                                if dParts[part_id.id]['salesman_id'] not in user_ids:
                                    user_ids.append( dParts[part_id.id]['salesman_id'] )
                        if club.responsible_id:
                            if not dResponsibles.has_key(club.responsible_id.id):
                                if club.responsible_id.id not in user_ids:
                                    user_ids.append( club.responsible_id.id )
                            else:
                                text_resp = dResponsibles[club.responsible_id.id] + '\n' + text_resp
                            dResponsibles[club.responsible_id.id] = text_resp
                    users = self.pool.get('res.users').read(cr,uid,user_ids,['id','email'])
                    dUsers = {}
                    for user in users:
                        dUsers[user['id']] = user['email']
                    if dResponsibles:
                        for (user_id,text) in dResponsibles.items():
                            if dUsers.has_key( user_id ) and dUsers[user_id]:
                                tools.email_send(param_values['ClubWarnNewEMailFrom'], [dUsers[user_id]], template.subject, u'<html><body><p>Vous êtes responsable des clubs suivants.</p>\n' + text + '</p></body></html>', subtype='html')
                    if dSalesmen:
                        for (user_id,text) in dSalesmen.items():
                            if dUsers.has_key( user_id ) and dUsers[user_id]:
                                tools.email_send(param_values['ClubWarnNewEMailFrom'], [dUsers[user_id]], template.subject, u'<html><body>Vous êtes le commercial attaché aux partenaires participants à ces nouveaux clubs.</p>\n' + text + '</p></body></html>', subtype='html')
                    self.pool.get('cci_club.club').write(cr,uid,club_ids,{'warning_start':datetime.date.today().strftime('%Y-%m-%d')})
        return True
    def send_sms_2_group(self,cr,uid,club_ids,from_name,message,to_formative,to_formative2,to_responsible,only_active,agreement,SMSPLATFORM):
        # this method send sms to all active partipants of these club(s)
        # we take mobile number on contact if present (and if (sms-ms))
        # else, if no mobile number we take the phone on job if it has (sms-ms)
        if not agreement:
            agreement = '(sms-ms)'
        sms_sended = 0
        numbers = []
        if club_ids:
            clubs = self.pool.get('cci_club.club').browse(cr,uid,club_ids)
            for club in clubs:
                for participation in club.participation_ids:
                    participant_ok = False
                    if only_active:
                        if participation.state_id.current and ( not participation.date_out or participation.date_out >= datetime.date.today().strftime('%Y-%m-%d') ):
                            # active participant
                            participant_ok = True
                    else:
                        participant_ok = True
                    if participant_ok:
                        if participation.contact_id and participation.contact_id.mobile:
                            if agreement in participation.contact_id.mobile:
                                number = participation.contact_id.mobile
                                if '(' in number:
                                    number = number[0:number.find('(')].strip()
                                if number not in numbers:
                                    numbers.append(only_phone_numbers(number))
                        elif participation.contact_id and participation.contact_id.job_id and participation.contact_id.job_id.phone and agreement in participation.contact_id.job_id.phone:
                            number = participation.contact_id.mobile
                            if '(' in number:
                                number = number[0:number.find('(')].strip()
                            if number not in numbers:
                                numbers.append(only_phone_numbers(number))
                if to_formative and club.formative_id and club.formative_id.mobile:
                    if agreement in club.formative_id.mobile:
                        number = club.formative_id.mobile
                        if '(' in number:
                            number = number[0:number.find('(')].strip()
                        if number not in numbers:
                            numbers.append(only_phone_numbers(number))
                if to_formative2 and club.formative2_id and club.formative_id2.mobile:
                    if agreement in club.formative2_id.mobile:
                        number = club.formative2_id.mobile
                        if '(' in number:
                            number = number[0:number.find('(')].strip()
                        if number not in numbers:
                            numbers.append(only_phone_numbers(number))
                if to_responsible and club.responsible_id and club.responsible_id.mobile:
                    if agreement in club.responsible_id.mobile:
                        number = club.responsible_id.mobile
                        if '(' in number:
                            number = number[0:number.find('(')].strip()
                        if number not in numbers:
                            numbers.append(only_phone_numbers(number))
            # Log the action before executing it
            current_user= self.pool.get('res.users').read(cr,uid,uid,['name'])
            dt = datetime.datetime.now()
            sending_id = self.pool.get('sms_sending').create(cr,uid,{'name':'%s %s %i SMS' % (dt.strftime('%Y-%m-%d %H-%M-%S'),current_user['name'],len(numbers)),
                                                                     'when_dt': dt,
                                                                     'who': uid,
                                                                     'agreement': agreement,
                                                                     'count': len(numbers),
                                                                     'text': message,
                                                                     'initial_numbers': ','.join(numbers),
                                                                     'result':'',
                                                                     'done':False,
                                                                    })
            results = ''
            launcher = self.pool.get('cci_club.participation')
            for to_number in numbers:
                result = launcher.send_sms(from_name,to_number,message,SMSPLATFORM)
                results += '%s => %s\n' % (to_number,result)
            self.pool.get('sms_sending').write(cr,uid,[sending_id,],{'result':results,'done':True})
            sms_sended = len(numbers)
        return sms_sended
club()

class participation_state(osv.osv):
    _inherit = "cci_club.participation_state"
    _columns = {
        'active_presence': fields.boolean('Active on Presences',help="Indicates if this state if considered active in application 'Presences'"),
    }
    _defaults = {
        'active_presence': lambda *a: True,
    }
participation_state()

class attendance_state(osv.osv):
    _inherit = "cci_club.attendance_state"
    _columns = {
        'count_as' : fields.selection([('present','Present'),('absent','Absent'),('undefined','Undefined')],'Count as',help='Indicate if this state must be counted as \'present\' for scoring'),
        'external_codes' : fields.char('External(s) code(s)',size=30,help='List of Lerian Codes, preceded, terminated and separated by |'),
    }
    _defaults = {
        'count_as' : lambda *a:'undefined',
    }
attendance_state()

class attendance(osv.osv):
    _inherit = "cci_club.attendance"
    _columns = {
        'active' : fields.boolean('Active'),
    }
    _defaults = {
        'active': lambda *a: True,
    }
    def name_get(self, cr, user, ids, context={}):
        #will return date session - name participant - club
        if not len(ids):
            return []
        res = []
        for r in self.browse(cr, user, ids):
            full_name = r.session_id.date[8:10]+'/'+r.session_id.date[5:7]+'/'+r.session_id.date[0:4]
            full_name +=  ' - ' + r.participation_id.contact_id.name
            if r.participation_id.contact_id.first_name:
                full_name += ' ' + r.participation_id.contact_id.first_name
            full_name += ' - ' + r.participation_id.group_id.name
            res.append((r.id, full_name))
        return res
attendance()

class participation_log(osv.osv):
    _inherit = "cci_club.participation_log"
    _columns = {
        'active' : fields.boolean('Active'),
    }
    _defaults = {
        'active': lambda *a: True,
    }
participation_log()

class club_check(osv.osv):
    _inherit ="cci_club.club_check"
    _columns={
        'active' : fields.boolean('Active'),
    }
    _defaults = {
        'active': lambda *a: True,


    }
club_check()

def get_activity_codes(cr,uid,rootID):
    # extract all ids of activity sector categories
    obj_categ = pooler.get_pool(cr.dbname).get('res.partner.category')
    old_len = 0
    categ_ids = [ rootID ]
    while len(categ_ids) > old_len:


        new_ids = categ_ids[old_len:] # ids of categories added last time
        old_len = len(categ_ids) # the new frontier ...
        new_categs = obj_categ.read(cr,uid,new_ids,['child_ids'])
        for categ in new_categs:
            if categ['child_ids']:
                categ_ids.extend(categ['child_ids'])
    categs = obj_categ.read(cr,uid,categ_ids,['name'],{'lang':'fr_FR'})
    dCategs = {}
    for categ in categs:
        dCategs[ categ['id'] ] = categ['name']
    return dCategs

class participation(osv.osv):
    _inherit = "cci_club.participation"

    def name_get(self,cr,uid,ids,context={}):
        if not len(ids):
            return []
        res = []
        for part in self.read(cr,uid,ids, ['contact_id','group_id'] ):
            if part['group_id']:
                res.append( (part['id'], "%s - %s" % (part['contact_id'][1], part['group_id'][1] )))
            else:
                res.append( (part['id'], "%s - %s" % (part['contact_id'][1], 'no-group' )))
        return res
    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=None):
        if not args:
            args = []
        if context is None:
            context = {}
        part_ids = []
        if name and len(name.strip().split(' ')) == 1:
            contact_obj = self.pool.get('res.partner.contact')
            search_arg = ['|', ('first_name', 'ilike', name), ('name', 'ilike', name)]
            contact_ids = contact_obj.search(cr, uid, search_arg)
            if contact_ids:
                contacts = contact_obj.browse(cr, uid, contact_ids, context=context)
                for contact in contacts:
                    part_ids.extend([item.id for item in contact.club_participation_ids])
        elif name and len(name.strip().split(' ')) == 2:
            (last,first) = name.strip().split(' ')
            contact_obj = self.pool.get('res.partner.contact')
            search_arg = [('first_name', 'ilike', first), ('name', 'ilike', last)]
            contact_ids = contact_obj.search(cr, uid, search_arg)
            if contact_ids:
                contacts = contact_obj.browse(cr, uid, contact_ids)
                for contact in contacts:
                    part_ids.extend([item.id for item in contact.club_participation_ids])
        return self.name_get(cr, uid, part_ids, context=context)
    def search(self, cr, user, targs, offset=0, limit=None, order=None, context=None, count=False):
        part_ids = []
        for targ in targs:
            if targ[0] == 'contact_id' and targ[1] == 'ilike':
                contact_obj = self.pool.get('res.partner.contact')
                search_arg = ['|', ('first_name', 'ilike', targ[2]), ('name', 'ilike', targ[2])]
                contact_ids = contact_obj.search(cr, user, search_arg, offset=offset, limit=None, order=order, context=context, count=count)
                if not contact_ids:
                    if targ[2].count(' ') == 1:
                        (ename,efirst) = targ[2].split(' ')
                        search_arg = [('first_name','ilike',efirst),('name','ilike',ename)]
                        contact_ids = contact_obj.search(cr, user, search_arg, offset=offset, limit=None, order=order, context=context, count=count)
                        if not contact_ids:
                            # no results to first search and not exactly one space separator => nothing to find
                            continue
                    else:
                        # no results to first search and not exactly one space separator => nothing to find
                        continue
                contacts = contact_obj.browse(cr, user, contact_ids, context=context)
                for contact in contacts:
                    part_ids.extend([item.id for item in contact.club_participation_ids])
        res = super(participation,self).search(cr, user, targs, offset=offset, limit=limit, order=order, context=context, count=count)
        if part_ids:
            res = list(set(res + part_ids))
        return res
    def _get_mail_addresses(self,cr,uid,ids):
        result = {}
        parts = self.browse(cr,uid,ids)
        for part in parts:
            list_of_emails = []
            if part.email:
                list_of_emails.append(part.email.strip())
            if part.copy_emails:
                if ';' in part.copy_emails:
                    supp = part.copy_emails.split(';')
                    for x in supp:
                        list_of_emails.append(x.strip())
                elif ',' in part.copy_emails:
                    supp = part.copy_emails.split('')
                    for x in supp:
                        list_of_emails.append(x.strip())
                else:
                    list_of_emails.append(self.copy_emails)
            result[part.id] = list_of_emails
        return result
    def send_emails(self,cr,uid,ids,email_from,email_to,email_subject,email_body,email_type='html'):
        count = 0
        tags = re.compile('{PERSO .*?}',re.IGNORECASE)
        part_obj = self.pool.get('cci_club.participation')
        parts = part_obj.browse(cr,uid,ids)
        activityCodeRootID = 0
        if '{PERSO partner_activcode}' in email_subject or '{PERSO partner_activcode}' in email_body:
            parameter_obj = self.pool.get('cci_parameters.cci_value')
            param_values = parameter_obj.get_value_from_names(cr,uid,['ActivityCodeRootID'])
            if param_values.has_key('ActivityCodeRootID'):
                activityCodeRootID = param_values['ActivityCodeRootID']
            dActivs = {}
            if activityCodeRootID:
                dActivs = get_activity_codes(cr,uid,activityCodeRootID)
        forced_to = []
        if email_to:
            if ',' in email_to:
                forced_to = email_to.split(',')
            elif ';' in email_to:
                forced_to = email_to.split(';')
            else:
                forced_to = [email_to]
            forced_to = [x.strip() for x in forced_to]
        for participant in parts:
            # extract of the 'to' email address
            if forced_to:
                email_to = forced_to
            else:
                email_to = []
                if participant.contact_id and participant.contact_id.job_id and participant.contact_id.job_id.email:
                    email_to = [participant.contact_id.job_id.email]
                elif participant.contact_id and participant.contact_id.email:
                    email_to = [participant.contact_id.email]
                elif participant.contact_id and participant.contact_id.job_id and participant.contact_id.job_id.address_id and participant.contact_id.job_id.address_id.email:
                    email_to = [participant.contact_id.job_id.address_id.email]
                if participant.copy_emails:
                    if ';' in participant.copy_emails:
                        supp = participant.copy_emails.split(';')
                        for x in supp:
                            email_to.append(x.strip())
                    elif ',' in participant.copy_emails:
                        supp = participant.copy_emails.split('')
                        for x in supp:
                            email_to.append(x.strip())
                    else:
                        email_to.append(self.copy_emails)
            if email_to:
                # convert all possible tags
                full_texts = personalize_texts(cr,uid,participant,tags,[unicode(email_subject,sys.stdin.encoding),unicode(email_body,sys.stdin.encoding)],None,activityCodeRootID,dActivs)
                # sending of the email
                tools.email_send(email_from, email_to, full_texts[0], full_texts[1], subtype=email_type)
                count += 1
        return count
    def send_sms(self,from_name,to_number,message,SMSPLATFORM):
        # from_name doesn't work today with CURL method
        # to_name must be formatted => 0032499123456
        ## message only first 140 characters with CURL method
        #import subprocess
        final_result = True
        to_number = to_number.strip()
        if len(to_number) > 2:
            if to_number[0:1] == '+':
                to_number = '00'+to_number[1:]
            if (to_number[0:2] <> '00') and to_number[0:1] == '0':
                to_number = '0032' + to_number[1:]
            number_seems_ok = False
            if to_number[0:4] == '0032' and len(to_number) == 13:
                number_seems_ok = True
            elif to_number[0:2] == '00' and to_number[0:4] <> '0032':
                # not a belgian number => by default OK
                number_seems_ok = True
            #message = message[0:140]
            if number_seems_ok:
                import requests, urllib
                params = urllib.urlencode({'email':'apisms@ccilvn.be','password':'SmSTOthemoon','numbers':to_number,'text':message})
                print SMSPLATFORM % params
                req = requests.get(SMSPLATFORM % params)
                #final_result = req.text.replace('<html><head>SMS</head><body>','').replace('</body></html>','')
                print req.text
                final_result = 'OK'
            else:
                final_result = 'ERROR: Strange mobile number : ' + to_number
        else:
            final_result = 'ERROR: Wrong mobile number: ' + to_number
        return final_result
    def unlink(self,cr,uid,ids,context):
        log_obj = self.pool.get('cci_club.participation_log')
        attendance_obj = self.pool.get('cci_club.attendance')
        check_obj = self.pool.get('cci_club.club_check')
        participation_obj = self.pool.get('cci_club.participation')
        for part in self.browse(cr,uid,ids):
            current_part = participation_obj.read(cr,uid,[part.id],['order_id'])[0]
            log_ids = log_obj.search(cr,uid,[('participation_id','=',part.id)])
            #log_obj.unlink(cr,uid,log_ids)
            att_ids = attendance_obj.search(cr,uid,[('participation_id','=',part.id)])
            #attendance_obj.unlink(cr,uid,att_ids)
            check_ids = check_obj.search(cr,uid,[('participation_id','=',part.id)])
            #check_obj.unlink(cr,uid,att_ids)
            if current_part['order_id'] or log_ids or att_ids or check_ids:
                log_obj.write(cr,uid,log_ids,{'active':False})
                attendance_obj.write(cr,uid,att_ids,{'active':False})
                check_obj.write(cr,uid,check_ids,{'active':False})
                participation_obj.write(cr,uid,[part.id],{'active':False})
            else:
                super(osv.osv,self).unlink(cr, uid, [part.id],context)
        return True
    def copy(self, cr, uid, id, default=None, context={}):
        if not default:
            default = {}
        default.update({
            'order_id': False,
            'attendance_ids': False,
            'check_ids': False,
            'checks_a' : '',
            'checks_b' : '',
            'valid_checks_a' : False,
            'valid_checks_b' : False,
            'note': '',
            'copy_emails':False,
        })

        return super(participation, self).copy(cr, uid, id, default, context)
    def send_test(self,cr,uid):
        ''' 
        This method select participers with a certain state to certains type(s) of club(s) in somes states
        After this selection, we send them an form to test them
        The Test Forms (minimum one by langage) is attached to the concerned Template; each file begin with the code of the concerned Langage
        The Same method send also two possible reminders if the state has not changed in between
        '''
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['TestFormTemplateID','TestFormClubStateList','TestFormPartStateList','TestFormClubTypeList','TestFormSupervisors','TestFormEMailFrom','TestFormPartNewState','TestReminderTemplateID','TestReminder2TemplateID','TestReminderDelay1','TestReminderDelay2'])
        if param_values.has_key('TestFormTemplateID') and \
                param_values.has_key('TestFormEMailFrom') and \
                param_values.has_key('TestFormPartStateList') and \
                param_values.has_key('TestFormPartNewState') and \
                param_values.has_key('TestFormClubStateList') and \
                param_values.has_key('TestFormClubTypeList') and \
                param_values.has_key('TestReminderTemplateID') and \
                param_values.has_key('TestReminder2TemplateID') and \
                param_values.has_key('TestReminderDelay1') and \
                param_values.has_key('TestReminderDelay2') and \
                param_values.has_key('TestFormSupervisors'):
            template_obj = self.pool.get('cci_email_template')
            templates = template_obj.browse(cr,uid,[param_values['TestFormTemplateID']])
            if len(templates) == 1:
                template = templates[0]
                selection = '''SELECT particip.id
                                    FROM cci_club_participation as particip, cci_club_club as club
                                    WHERE particip.group_id = club.id AND particip.state_id in (%s) 
                                          AND particip.test_send IS NULL AND particip.active
                                          AND club.state in (%s) AND club.type_id in (%s) AND club.active
                                    ORDER by particip.group_id
                            ''' % (','.join([str(x) for x in param_values['TestFormPartStateList']]),
                                   ','.join([("'"+x+"'") for x in param_values['TestFormClubStateList']]),
                                   ','.join([str(x) for x in param_values['TestFormClubTypeList']]))
                cr.execute(selection)
                res = cr.fetchall()
                if res:
                    part_ids = [x[0] for x in res]
                    today = datetime.date.today().strftime('%Y-%m-%d')
                    part_obj = self.pool.get('cci_club.participation')
                    supervisors = param_values['TestFormSupervisors']
                    if supervisors:
                        supervisors = supervisors.replace(';',',')
                        lSupervisors = supervisors.split(',')
                        lSupervisors = map(strip,lSupervisors)
                    else:
                        lSupervisors = []
                    # prepare the list of attachments file from the template attachments
                    attach_obj = self.pool.get('ir.attachment')
                    attach_ids = attach_obj.search(cr,uid,[('res_model','=','cci_email_template'),('res_id','=',template.id)])
                    attachs = attach_obj.read(cr,uid,attach_ids,['datas','name'])
                    dAttachs = {}
                    for attach in attachs:
                        if dAttachs.has_key(attach['name'][0:2]):
                            list_of_attach = dAttachs[attach['name'][0:2]]
                            list_of_attach.append( (attach['name'],base64.decodestring(attach['datas'])) )
                            dAttachs[attach['name'][0:2]] = list_of_attach
                        else:
                            dAttachs[attach['name'][0:2]] = [(attach['name'],base64.decodestring(attach['datas']))]
                    # we create browse objects with all participants but we use only those having an email
                    # logically all, but we can't be sure
                    tags = re.compile('{PERSO .*?}',re.IGNORECASE)
                    parts = self.pool.get('cci_club.participation').browse(cr,uid,part_ids)

                    for participant in parts:
                        if participant.email:
                            full_texts = personalize_texts(cr,uid,participant,tags,[template.subject,template.body])
                            # we prepare the attachment file for this participer
                            if participant.language_id and participant.language_id.code and len(participant.language_id.code) == 2 and dAttachs.has_key(participant.language_id.code):
                                attachedFiles = dAttachs[participant.language_id.code]
                            else:
                                attachedFiles = None
                            # sending of the email
                            if lSupervisors:
                                if attachedFiles:
                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type, email_bcc = lSupervisors, attach = attachedFiles)
                                else:
                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type, email_bcc = lSupervisors)
                            else:
                                if attachedFiles:
                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type, attach = attachedFiles)
                                else:
                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type)
                            # recording of the date of email sending
                            part_obj.write(cr,uid,[participant.id],{'test_send':today,'state_id':param_values['TestFormPartNewState']})
            ## PART II : sending of the first reminder
            templates = template_obj.browse(cr,uid,[param_values['TestReminderTemplateID']])
            if len(templates) == 1:
                template = templates[0]
                delay = param_values['TestReminderDelay1']
                past_date = datetime.date.today() - datetime.timedelta(days=delay)
                selection = '''SELECT particip.id
                                    FROM cci_club_participation as particip, cci_club_club as club
                                    WHERE particip.group_id = club.id AND particip.state_id = %s 
                                          AND particip.test_send <= '%s' AND reminder_send IS NULL AND particip.active
                                          AND club.state in (%s) AND club.type_id in (%s) AND club.active
                                    ORDER by particip.group_id
                            ''' % (str(param_values['TestFormPartNewState']),
                                   past_date.strftime('%Y-%m-%d'),
                                   ','.join([("'"+x+"'") for x in param_values['TestFormClubStateList']]),
                                   ','.join([str(x) for x in param_values['TestFormClubTypeList']]))
                cr.execute(selection)
                res = cr.fetchall()
                if res:
                    part_ids = [x[0] for x in res]
                    today = datetime.date.today().strftime('%Y-%m-%d')
                    part_obj = self.pool.get('cci_club.participation')
                    supervisors = param_values['TestFormSupervisors']
                    if supervisors:
                        supervisors = supervisors.replace(';',',')
                        lSupervisors = supervisors.split(',')
                        lSupervisors = map(strip,lSupervisors)
                    else:
                        lSupervisors = []
                    # prepare the list of attachments file from the template attachments
                    attach_obj = self.pool.get('ir.attachment')
                    attach_ids = attach_obj.search(cr,uid,[('res_model','=','cci_email_template'),('res_id','=',template.id)])
                    attachs = attach_obj.read(cr,uid,attach_ids,['datas','name'])
                    dAttachs = {}
                    for attach in attachs:
                        if dAttachs.has_key(attach['name'][0:2]):
                            list_of_attach = dAttachs[attach['name'][0:2]]
                            list_of_attach.append( (attach['name'],base64.decodestring(attach['datas'])) )
                            dAttachs[attach['name'][0:2]] = list_of_attach
                        else:
                            dAttachs[attach['name'][0:2]] = [(attach['name'],base64.decodestring(attach['datas']))]
                    # we create browse objects with all participants but we use only those having an email
                    # logically all, but we can't be sure
                    tags = re.compile('{PERSO .*?}',re.IGNORECASE)
                    parts = self.pool.get('cci_club.participation').browse(cr,uid,part_ids)
                    for participant in parts:
                        if participant.email:
                            full_texts = personalize_texts(c,uid,participant,tags,[template.subject,template.body])
                            # we prepare the attachment file for this participer

                            if participant.language_id and participant.language_id.code and len(participant.language_id.code) == 2 and dAttachs.has_key(participant.language_id.code):
                                attachedFiles = dAttachs[participant.language_id.code]
                            else:
                                attachedFiles = None
                            # sending of the email
                            if lSupervisors:
                                if attachedFiles:
                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type, email_bcc = lSupervisors, attach = attachedFiles)
                                else:
                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type, email_bcc = lSupervisors)
                            else:
                                if attachedFiles:


                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type, attach = attachedFiles)
                                else:
                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type)
                            # recording of the date of email sending
                            part_obj.write(cr,uid,[participant.id],{'reminder_send':today})
            ## PART III : sending of the second reminder
            template_obj = self.pool.get('cci_email_template')
            templates = template_obj.browse(cr,uid,[param_values['TestReminder2TemplateID']])
            if len(templates) == 1:
                template = templates[0]
                delay = param_values['TestReminderDelay2']
                past_date = datetime.date.today() - datetime.timedelta(days=delay)
                selection = '''SELECT particip.id
                                    FROM cci_club_participation as particip, cci_club_club as club
                                    WHERE particip.group_id = club.id AND particip.state_id = %s 
                                          AND particip.reminder_send <= '%s' AND reminder2_send IS NULL AND particip.active
                                          AND club.state in (%s) AND club.type_id in (%s) AND club.active
                                    ORDER by particip.group_id
                            ''' % (str(param_values['TestFormPartNewState']),
                                   past_date.strftime('%Y-%m-%d'),
                                   ','.join([("'"+x+"'") for x in param_values['TestFormClubStateList']]),
                                   ','.join([str(x) for x in param_values['TestFormClubTypeList']]))
                cr.execute(selection)
                res = cr.fetchall()
                if res:
                    part_ids = [x[0] for x in res]
                    today = datetime.date.today().strftime('%Y-%m-%d')
                    part_obj = self.pool.get('cci_club.participation')
                    supervisors = param_values['TestFormSupervisors']
                    if supervisors:
                        supervisors = supervisors.replace(';',',')
                        lSupervisors = supervisors.split(',')
                        lSupervisors = map(strip,lSupervisors)
                    else:
                        lSupervisors = []
                    # prepare the list of attachments file from the template attachments
                    attach_obj = self.pool.get('ir.attachment')
                    attach_ids = attach_obj.search(cr,uid,[('res_model','=','cci_email_template'),('res_id','=',template.id)])
                    attachs = attach_obj.read(cr,uid,attach_ids,['datas','name'])
                    dAttachs = {}
                    for attach in attachs:
                        if dAttachs.has_key(attach['name'][0:2]):
                            list_of_attach = dAttachs[attach['name'][0:2]]
                            list_of_attach.append( (attach['name'],base64.decodestring(attach['datas'])) )
                            dAttachs[attach['name'][0:2]] = list_of_attach
                        else:
                            dAttachs[attach['name'][0:2]] = [(attach['name'],base64.decodestring(attach['datas']))]
                    # we create browse objects with all participants but we use only those having an email
                    # logically all, but we can't be sure
                    tags = re.compile('{PERSO .*?}',re.IGNORECASE)
                    parts = self.pool.get('cci_club.participation').browse(cr,uid,part_ids)
                    for participant in parts:
                        if participant.email:
                            full_texts = personalize_texts(cr,uid,participant,tags,[template.subject,template.body])
                            # we prepare the attachment file for this participer
                            if participant.language_id and participant.language_id.code and len(participant.language_id.code) == 2 and dAttachs.has_key(participant.language_id.code):
                                attachedFiles = dAttachs[participant.language_id.code]
                            else:
                                attachedFiles = None
                            # sending of the email
                            if lSupervisors:
                                if attachedFiles:
                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type, email_bcc = lSupervisors, attach = attachedFiles)
                                else:
                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type, email_bcc = lSupervisors)
                            else:
                                if attachedFiles:
                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type, attach = attachedFiles)
                                else:
                                    tools.email_send(param_values['TestFormEMailFrom'], [participant.email], full_texts[0], full_texts[1], subtype=template.type)
                            # recording of the date of email sending
                            part_obj.write(cr,uid,[participant.id],{'reminder2_send':today})
        return True
    def check_not_in_orders(self,cr,uid,**args): # type_ids,club_states,part_states,supervisor_emails
        '''
        This method checks the participers of a certain type of clubs, in a certain states, with the participes in somes states also
        It create an excel file and send it to list of asked emails
        This method can be called from a manual wizard OR from scheduled actions
        '''
        # types_ids = list of id of types of clubs to scan
        #  if not given, we try to read it in the cci_parameters table with the key 'NotInOrderTypes'
        # club_states = list of char states of clubs to scan
        #  if this parameter is not given, we try to read it in the cci_parameters table; key 'NotInOrderClubStates'
        # part_states = list of if of participation_states of clubs to select
        #  if this parameter is not given, we try to read it in the cci_parameters table; key 'NotInOrderPartStates'
        # supervisor_emails = list of emails address of person to send them the report
        #  if empty; we try to read it in the cci_parameters table with the key 'NotInOrderSupervisors'
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['NotInOrderTypes','NotInOrderClubStates','NotInOrderPartStates','NotInOrdersSupervisors'])
        if not args.has_key('type_ids'):
            if param_values.has_key('NotInOrderTypes'):
                type_ids = param_values['NotInOrderTypes']
            else:
                type_ids = []
        else:
            type_ids = args['type_ids']
        if not args.has_key('club_states'):
            if param_values.has_key('NotInOrderClubStates'):
                lStates = param_values['NotInOrderClubStates']
            else:
                lStates = ['draft']
        else:
            lStates = args['club_states']
        if not args.has_key('part_states'):
            if param_values.has_key('NotInOrderPartStates'):
                state_ids = param_values['NotInOrderPartStates']
            else:
                state_ids = []
        else:
            state_ids = args['part_states']
        if not args.has_key('supervisor_emails'):
            if param_values.has_key('NotInOrderSupervisors'):
                supervisor_emails = param_value['NotInOrderSupervisors']
            else:
                supervisor_emails = []
        else:
            supervisor_emails = args['supervisor_emails']
        if type_ids and lStates and state_ids:
            # creating excel file for output
            ExcelFileName = 'part_not_in_order.xls'
            wb = Workbook()
            ws1 = wb.add_sheet(_('Persons'))
            ws2 = wb.add_sheet(_('Parameters'))
            
            # recording parameters in excel file for 'debugging' if necessary
            ws2.write(0,0,_('Types'))
            ws2.write(1,0,_('Clubs states'))
            ws2.write(2,0,_('Participers states'))
            ws2.write(3,0,_('Supervisors'))
            types = self.pool.get('cci_club.club_type').browse(cr,uid,type_ids)
            column = 1
            for club_type in types:
                ws2.write(0,column,'%s (%i)' % (club_type.name,club_type.id) )
                column += 1
            ws2.write(1,1,','.join(lStates))
            column = 1
            states = self.pool.get('cci_club.participation_state').browse(cr,uid,state_ids)
            for state in states:
                ws2.write(2,column,'%s (%i)' % (state.name,state.id) )
                column += 1
            column = 1
            for item in supervisor_emails:
                ws2.write(3,column,item)
                column += 1

            # extract of all concerned part_ids
            selection = """SELECT parti.id
                               FROM cci_club_participation as parti, cci_club_club as club
                               WHERE parti.group_id = club.id AND parti.state_id in (%s) AND parti.active
                                    AND club.type_id in (%s) AND club.state in (%s) AND club.active
                        """ % ( ','.join([str(x) for x in state_ids]), ','.join([str(x) for x in type_ids]) , ','.join([("'%s'" % x) for x in lStates]) )
            cr.execute(selection)
            res = cr.fetchall()
            ws1.write(0,0,_('Participer'))
            ws1.write(0,1,_('Company'))
            ws1.write(0,2,_('Club'))
            ws1.write(0,3,_('State'))
            ws1.write(0,4,_('First sending'))
            if res:
                part_ids = [x[0] for x in res]
                # record results
                # first tab : participations
                parts = self.pool.get('cci_club.participation').browse(cr,uid,part_ids)
                line = 1
                for particip in parts:
                    full_name = ''
                    if particip.contact_id:
                        full_name = particip.contact_id.name
                        if particip.contact_id.first_name:
                            full_name += ( ' ' + particip.contact_id.first_name )
                    ws1.write(line,0,full_name)
                    ws1.write(line,1,particip.partner_id and particip.partner_id.name)
                    ws1.write(line,2,particip.group_id.name)
                    ws1.write(line,3,particip.state_id and particip.state_id.name)
                    ws1.write(line,4,particip.test_send or '')
                    line += 1
            # save the created excel file
            wb.save(ExcelFileName)
            
            # sending by mail to the possible supervisor(s)
            if supervisor_emails:
                tools.email_send('no-reply@ccilvn.be', supervisor_emails, _('Not In Order'), _('See the attached file'), subtype='html', attach = [(ExcelFileName,open(ExcelFileName,'rb').read())] )
            
        else:
            ExcelFileName = ''
        return ExcelFileName

    def _get_locality(self, cr, uid, ids, field_name, arg, context={}):
        result = {}
        for rec in self.browse(cr, uid, ids, context):
            result[rec.id] = ''
            if rec.contact_id:
                for job in rec.contact_id.job_ids:
                    if job.address_id and job.address_id.partner_id and job.address_id.zip_id and job.address_id.partner_id == rec.partner_id:
                        result[rec.id] = job.address_id.zip_id.name + ' ' + job.address_id.zip_id.city
                        break
        return result
    def _get_date_out(self, cr, uid, ids, field_name, arg, context={}):
        result = {}
        for rec in self.browse(cr, uid, ids, context):
            if rec.forced_date_out:
                result[rec.id] = rec.forced_date_out
            else:
                result[rec.id] = rec.group_id.date_end
        return result
    def _search_date_out(self, cr, uid, obj, name, args, context):
        if not len(args):
            return []
        if args == [('date_out','=',False)]:
            cr.execute("""SELECT particip.id FROM cci_club_participation AS particip, cci_club_club AS club
                              WHERE particip.forced_date_out IS NULL AND
                                    particip.group_id = club.id AND
                                    club.date_end IS NULL""")
            res = cr.fetchall()
        else:
            cr.execute("""SELECT id FROM cci_club_participation
                              WHERE forced_date_out %s '%s'
                           UNION
                           SELECT particip.id FROM cci_club_participation AS particip, cci_club_club AS club
                               WHERE particip.forced_date_out IS NULL AND
                                     particip.group_id = club.id AND
                                     club.date_end %s '%s'"""
                       % (args[0][1],args[0][2],args[0][1],args[0][2]) )
            res = cr.fetchall()
        if not len(res):
            return [('id','=','0')]
        return [('id','in',map(itemgetter(0), res))]
    def onchange_partner(self, cr, uid, ids, partner_id, group_id, contact_id):
        warning = False
        if partner_id:
            data_partner = self.pool.get('res.partner').browse(cr,uid,partner_id)
            if data_partner.alert_others:
                warning = {
                    'title': "Warning:",
                    'message': data_partner.alert_explanation or 'Partner is not valid'
                        }
        newvalues={'salesman':False,'provided_turnover':False,'email':'','phone':''}
        context={}
        if partner_id:
            newvalues['salesman']=data_partner.user_id.id
            newvalues['reductions'] = ( data_partner.membership_state in ['free','invoiced','paid'] ) and u'Membre' or u'Non-membre'
            if group_id:
                data_club = self.pool.get('cci_club.club').browse(cr,uid,group_id)
                if data_club['product_id']:
                    context.update({'partner_id':data_partner and data_partner.id})
                    newvalues['provided_turnover']=self.pool.get('product.product').price_get(cr, uid, [data_club.product_id.id],context=context)[data_club.product_id.id]
        else:
            newvalues['reductions'] = u'Non-membre'
        if contact_id:
            # get the email address
            contact = self.pool.get('res.partner.contact').browse(cr, uid, contact_id)
            if contact.job_id and contact.job_id.email:
                newvalues['email'] = contact.job_id.email
            elif contact.email:
                newvalues['email'] = contact.email
            elif contact.job_id and contact.job_id.address_id and contact.job_id.address_id.email:
                newvalues['email'] = contact.job_id.address_id.email
            else:
                newvalues['email'] = ''
            # get the phone
            if contact.job_id and contact.job_id.phone:
                newvalues['phone'] = contact.job_id.phone + ' (Job)'
            elif contact.mobile:
                newvalues['phone'] = contact.mobile + ' (Mobile contact)'
            elif contact.job_id and contact.job_id.address_id and contact.job_id.address_id.phone:
                newvalues['phone'] = contact.job_id.address_id.phone + ' (Address)'
            else:
                newvalues['phone'] = ''
            #newvalues['reductions'] += ( contact.is_premium and u' / Premium' or u' / Pas premium' )
        elif partner_id:
            if data_partner.address:
                for add in data_partner.address:
                    if add.type == 'default':
                        if add.email:
                            newvalues['email'] = add.email
                        if add.phone:
                            newvalues['phone'] = add.phone + ' (Address)'
                        break
        #if not contact_id:
        #    newvalues['reductions'] += u' / Pas premium'
        return_value = {'value':newvalues}
        if warning:
            return_value['warning'] = warning
        return return_value
    def onchange_contact(self, cr, uid, ids, contact_id, partner_id):
        newvalues = {}
        if partner_id:
            data_partner = self.pool.get('res.partner').browse(cr,uid,partner_id)
            newvalues['reductions'] = ( data_partner.membership_state in ['free','invoiced','paid'] ) and u'Membre' or u'Non-membre'
        else:
            newvalues['reductions'] = u'Non-membre'
        if contact_id:
            # get the email address
            contact = self.pool.get('res.partner.contact').browse(cr, uid, contact_id)
            if contact.job_id and contact.job_id.email:
                newvalues['email'] = contact.job_id.email
            elif contact.email:
                newvalues['email'] = contact.email
            elif contact.job_id and contact.job_id.address_id and contact.job_id.address_id.email:
                newvalues['email'] = contact.job_id.address_id.email
            else:
                newvalues['email'] = ''
            # get the phone
            if contact.job_id and contact.job_id.phone:
                newvalues['phone'] = contact.job_id.phone + ' (Job)'
            elif contact.mobile:
                newvalues['phone'] = contact.mobile + ' (Mobile contact)'
            elif contact.job_id and contact.job_id.address_id and contact.job_id.address_id.phone:
                newvalues['phone'] = contact.job_id.address_id.phone + ' (Address)'
            else:
                newvalues['phone'] = ''
            #newvalues['reductions'] += ( contact.is_premium and u' / Premium' or u' / Pas premium' )
        elif partner_id:
            newvalues['email'] = ''
            newvalues['phone'] = ''
            partner = self.pool.get('res.partner').browse(cr, uid, partner_id)
            if partner.address:
                for add in partner.address:
                    if add.type == 'default':
                        if add.email:
                            newvalues['email'] = add.email
                        if add.phone:
                            newvalues['phone'] = add.phone + ' (Address)'
                        break
        else:
            newvalues['email'] = ''
            newvalues['phone'] = ''
            #newvalues['reductions'] += u' / Pas premium'
        return {'value':newvalues}
    def _get_redux(self, cr, uid, ids, field_name, arg, context={}):
        result = {}
        for rec in self.browse(cr, uid, ids, context):
            result[rec.id] = ''
            if rec.partner_id:
                result[rec.id] = ( rec.partner_id.membership_state in ['free','invoiced','paid'] ) and u'Membre' or u'Non-membre'
            else:
                result[rec.id] = u'Non-membre'
            #if rec.contact_id:
            #    result[rec.id] += rec.contact_id.is_premium and u' / Premium' or u' / Pas premium'
            #else:
            #    result[rec.id] += u' / Pas premium'
        return result
    def _get_invoice_first_date(self, cr, uid, part_id, context={}):
        result = ''
        rec = self.browse(cr, uid, part_id, context)[0]
        if rec.order_id and rec.order_id.invoice_ids:
            for invoice in rec.order_id.invoice_ids:

                if invoice.date_invoice and invoice.state not in ['draft','cancel']:
                    if (not result) or (invoice.date_invoice < result):
                        result = invoice.date_invoice
        return result
    _columns={
        'active': fields.boolean('Active'),
        'monday': fields.boolean('Monday'),
        'tuesday': fields.boolean('Tuesday'),
        'wednesday': fields.boolean('Wednesday'),
        'thursday': fields.boolean('Thursday'),
        'friday': fields.boolean('Friday'),
        'evaluation_form': fields.date('Evaluation Form Asked'), # this field doesn't appear on screen now, perhaps later if necessary
        'test_send': fields.date('Test Sended'), # this field doesn't appear on screen now, perhaps later if necessary
        'reminder_send': fields.date('Test Reminder Sended'), # this field doesn't appear on screen now, perhaps later if necessary
        'reminder2_send': fields.date('Second test Reminder Sended'), # this field doesn't appear on screen now, perhaps later if necessary
        'zip_loc' : fields.function(_get_locality,method=True, string='Zip and City', type='char', size='80'),
        'forced_date_out' : fields.date('Forced End Date',help="If you want to change the end date of this participation, you can FORCE it"),
        'date_out':fields.function(_get_date_out,method=True,string='Date de fin', type='date',fnct_search=_search_date_out,help='Par défaut, cette date de fin est égale à celle du club, mais vous pouvez la forcer (voir ci-dessous).'),
        #'reductions':fields.char('Reductions',size=25),
        'reductions':fields.function(_get_redux,method=True,string='Reductions', type='char', size=25),
        'copy_emails':fields.text('Copy emails',help=u"List of emails to adress copies of all mails sended to this participant. The emails must be separated by ;"),
    }
    _defaults = {
        'active': lambda *a: True,
        'monday': lambda *a: True,
        'tuesday': lambda *a: True,
        'wednesday': lambda *a: True,
        'thursday': lambda *a: True,
        'friday': lambda *a: True,
    }
participation()

class session(osv.osv):
    _inherit = "cci_club.session"
    _columns = {
        'host_address_id': fields.many2one('res.partner.address','Host Address'),
        'host_contact_id': fields.many2one('res.partner.contact','Host Contact'),
        'warning_before': fields.text('Warning before'),
        'presence_responsible': fields.boolean('Presence responsible'),
        'presence_formative': fields.boolean('Presence Formative'),
        'name':fields.char('Name',size=150),
    }
    _defaults = {
        'presence_responsible': lambda *a: True,
        'presence_formative': lambda *a: True,
    }
    def _import_files_from_website(self,cr,uid,ids=[],context={}):
        BD_DE_TEST = True
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['BDDeTest',])
        if param_values.has_key('BDDeTest'):
            if param_values['BDDeTest'] == 0:
                BD_DE_TEST = False
        if BD_DE_TEST:
            return 0
        ftp = ftplib.FTP( 'ftp.alwaysdata.com', 'philmer', 'ceileis' )
        ftp.cwd( 'www/cciconnect/presences/attach2get' )
        dir_lines = []
        ftp.retrlines('LIST',dir_lines.append)
        count = 0
        current_dbname = cr.dbname
        for line in dir_lines:
            if ' session__' in line:
                filename = line[line.find(' session__')+1:]
                fn_parts = filename.split('__')
                if len(fn_parts) == 4:
                    dbname = fn_parts[1]
                    session_id = int(fn_parts[2])
                    outfilename = fn_parts[3]
                    if dbname == current_dbname and session_id > 0:
                        memfile = StringIO.StringIO()
                        ftp.retrbinary("RETR " + filename, memfile.write )
                        memfile.seek(0)
                        newvalue = {}
                        newvalue['res_model'] = 'cci_club.session'
                        newvalue['res_id'] = session_id
                        newvalue['datas_fname'] = outfilename
                        newvalue['datas'] = base64.encodestring(memfile.read())
                        newvalue['name'] = outfilename
                        res_id = self.pool.get('ir.attachment').create(cr,uid,newvalue )
                        ftp.delete(filename)
                        count += 1
        return count
    def _get_full_name(self,cr,uid,date,group_id,context=None):
        group = self.pool.get('cci_club.club').browse(cr,uid,group_id)
        return date+' '+group.name
    def create(self,cr,uid,vals,context=None):
        vals['name'] = self._get_full_name(cr,uid,vals['date'],vals['group_id'])
        result = super(osv.osv,self).create(cr,uid,vals,context)
        session = self.pool.get('cci_club.session').browse(cr,uid,[result])[0]
        club_id = session.group_id.id
        self.pool.get('cci_club.club')._recalc_end_date(cr,uid,[club_id])
        return result
    def unlink(self,cr,uid,ids,context):
        # before deleting each session, verify that there is no active attendance linked to every one
        # if so, don't delete theses 'active' sessions and warn the user
        selection = """SELECT count(att.id), session.date, club.name 
                           FROM cci_club_attendance as att,
                                cci_club_session as session,
                                cci_club_club as club
                           WHERE att.session_id = session.id AND session.group_id = club.id AND 
                                 att.session_id in (%s) AND att.active
                           GROUP BY session.date, club.name
                           """ % ','.join([str(x) for x in ids])
        cr.execute(selection)
        res = cr.fetchall()
        if len(res) > 0:
            errors = "\n- ".join(["Session of %s for club '%s' (%i attendances)" % (x[1], x[2], x[0]) for x in res])
            raise osv.except_osv(_('Error!'),_("You can't delete a session with recorded attendances !\nFound errors :\n" + errors))
            return False
        else:
            selection = """SELECT id from cci_club_attendance WHERE session_id in (%s) AND active = false""" % ','.join([str(x) for x in ids])
            cr.execute(selection)
            res = cr.fetchall()
            if len(res) > 0:
                # linked attendance found but inactive ones => we delete them and continue the deleting of the session(s)
                attendance_obj = self.pool.get('cci_club.attendance')
                att_ids = [x[0] for x in res]
                attendance_obj.unlink(cr,uid,att_ids,context)
            sessions = self.pool.get('cci_club.session').browse(cr,uid,ids)
            club_ids = []
            for session in sessions:
                if session.group_id.id not in club_ids:
                    club_ids.append(session.group_id.id)
            if super(osv.osv,self).unlink(cr,uid,ids,context):
                return self.pool.get('cci_club.club')._recalc_end_date(cr,uid,club_ids)
            else:
                return False
    def write(self,cr,uid,ids,vals,context=None):
        if isinstance(ids, (int, long)):
            ids = [ids]
        if len(ids) == 1 and vals.has_key('date'):
            if vals.has_key('date') and vals.has_key('group_id'):
                vals['name'] = self._get_full_name(cr,uid,vals['date'],vals['group_id'])
            elif vals.has_key('date') or vals.has_key('group_id'):
                session = self.pool.get('cci_club.session').browse(cr,uid,ids)[0]
                if vals.has_key('date'):
                    vals['group_id'] = session.group_id.id
                else:
                    vals['date'] = session.date
                vals['name'] = self._get_full_name(cr,uid,vals['date'],vals['group_id'])
            result = super(osv.osv,self).write(cr, uid, ids,vals, context)
            if result:
                session = self.pool.get('cci_club.session').browse(cr,uid,ids)[0]
                self.pool.get('cci_club.club')._recalc_end_date(cr,uid,[session.group_id.id])
            else:
                return result
        else:
            return super(osv.osv,self).write(cr, uid, ids,vals, context)
    def next_id(self,cr,uid,ids,context=None):
        if ids:
            obj_session = self.pool.get('cci_club.session')
            result = []
            for session_id in ids:
                sessions = obj_session.read(cr,uid,[session_id],['group_id','date'])
                next_id = 0
                if sessions:
                    current_session = sessions[0]
                    if current_session['group_id'] and current_session['date']:
                        sentence = """SELECT MIN(id)
                                          FROM cci_club_session
                                          WHERE group_id = %s AND date IS NOT NULL and date > '%s'
                                   """ % (str(current_session['group_id'][0]),current_session['date'])
                        cr.execute(sentence)
                        res = cr.fetchall()
                        if res and res[0][0] != None:
                            next_id = res[0][0]
                result.append( [session_id,next_id] )
            return result
        else:
            return [[0,0]]
session()

class language(osv.osv):
    _inherit = "cci_club.language"
    _columns = {
        'code' : fields.char('Code',size=2),
    }
language()

class club_holiday(osv.osv):
    _name = "cci_club.club_holiday"
    _description = "Holidays when clubs are inactive and can't fix sessions"
    _columns = {
        'name' : fields.char('Name',size=32,required=True),
        'date_from' : fields.date('From',required=True),
        'date_to' : fields.date('To',required=True),
        'description' : fields.text('Description'),
        'notworking_alter': fields.boolean('Not Working Day for AE',help='This holidays are considered as not working day for the calculation of the sending of convocations for Alter Ego'),
        'type_ids': fields.many2many('cci_club.club_type','cci_club_holiday_type', 'holiday_id', 'type_id', "Linked Types"),
    }

    def check_dates(self, cr, uid, ids):
        for holiday in self.browse(cr, uid, ids):
            if holiday.date_from > holiday.date_to:
                return False
        return True

    _constraints = [(check_dates, "The 'to' date must be greater than the 'from' date...", ["date_from","date_to"]),]
    _defaults = {
        'notworking_alter': lambda *a: True,
    }
club_holiday()

class level(osv.osv):
    _inherit = "cci_club.level"
    _columns = {
        'active' : fields.boolean('Active'),
    }
    _defaults = {
        'active': lambda *a: True,
    }
level()

class convocation(osv.osv):
    _name = "cci_club.convocation"
    _description = "Dates when convocations are send"
    _columns = {
        'name': fields.char('Name-Type Convocation',size=20,required=True),
        'attendance_id': fields.many2one('cci_club.attendance','Attendance',ondelete='cascade',required=True),
        'datetime': fields.datetime('Sending Time',required=True),
        'email': fields.char('email',size=128,required=True),
        'contact_id': fields.related('attendance_id','participation_id','contact_id',type='many2one',relation='res.partner.contact',string='Contact',store=False,readonly=True),
        'club_id': fields.related('attendance_id','session_id','group_id',type='many2one',relation='cci_club.club',string='Club',store=False,readonly=True),
        'date': fields.related('attendance_id','session_id','date',type='date',string='Session Date',store=False,readonly=True),
    }
    _defaults = {
        'datetime': lambda *a: datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
    }
    _order = 'datetime desc'
    
convocation()

class club_type(osv.osv):
    _inherit = "cci_club.club_type"
    _columns = {
        'holiday_ids': fields.many2many('cci_club.club_holiday','cci_club_holiday_type', 'type_id', 'holiday_id', "Linked Holidays"),
        'active' : fields.boolean('Active'),
    }
    _defaults = {
        'active': lambda *a: True,
    }
club_type()

class sms_sending(osv.osv):
    _name = 'sms_sending'
    _description = 'Log group sending of SMS'
    _columns = {
        'name': fields.char('Name',size=100,required=True),
        'when_dt': fields.datetime('When',required=True),
        'who': fields.many2one('res.users','Who',required=True),
        'agreement': fields.char('Agreement',size=15),
        'count': fields.integer('Count'),
        'text': fields.text('Text'),
        'initial_numbers': fields.text('Numbers to send'),
        'result': fields.text('Result'),
        'done': fields.boolean('Done'),
    }
    _order = 'when_dt desc'
sms_sending()
