# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import time
from report import report_sxw
from tools.translate import _

class report_renewal_alterego(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(report_renewal_alterego, self).__init__(cr, uid, name, context)
        self.localcontext.update({'time': time,
                                  'get_datas':self._get_datas})
    def _get_datas(self, form, objects):
        # this method search data on res.partner.job, res.partner.address on the link between contact_id and partner_id
        result = []
        partner_obj = self.pool.get('res.partner')
        activity_sector_ids = []
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(self.cr,self.uid,['ActivityCodeRootID'])
        if param_values.has_key('ActivityCodeRootID'):
            cat_obj = self.pool.get('res.partner.category')
            rootSectors = cat_obj.browse(self.cr,self.uid,[param_values['ActivityCodeRootID']],{'lang':'fr_FR'})
            name_beginning = rootSectors[0]['complete_name']
            cat_ids = cat_obj.search(self.cr,self.uid,[])
            categories = cat_obj.browse(self.cr,self.uid,cat_ids,{'lang':'fr_FR'})
            dCategs = {}
            for categ in categories:
                if categ.complete_name[0:len(name_beginning)] == name_beginning:
                    activity_sector_ids.append(categ.id)
                    dCategs[categ.id] = (categ.name or '' )
        for part in objects:
            record = {}
            record['id'] = str(part.id)
            if part.contact_id:
                record['contact_id'] = str(part.contact_id.id)
                record['contact_name'] = part.contact_id.name
                record['contact_first_name'] = part.contact_id.first_name or ''
                record['email'] = part.email
                record['mobile'] = part.contact_id.mobile or ''
            else:
                record['contact_id'] = '0'
                record['contact_name'] = ''
                record['contact_first_name'] = ''
                record['email'] = ''
                record['mobile'] = ''
            if part.partner_id:
                partner = partner_obj.browse(self.cr,self.uid,part.partner_id.id)
                record['partner_id'] = str(part.partner_id.id)
                record['partner_name'] = part.partner_id.name
                if part.partner_id.vat:
                    record['vat'] = part.partner_id.vat
                else:
                    record['vat'] = _('Unknown')
                if not part.partner_id.vat_subjected:
                    record['vat'] += _(' (Not subjected to VAT)')
                record['employee'] = str(part.partner_id.employee_nbr)
                # search of the activity sector
                record['activity_sector'] = ''
                for categ_id in partner.category_id:
                    if categ_id.id in activity_sector_ids:
                        record['activity_sector'] = dCategs[categ_id.id]
            else:
                partner = False
                record['partner_id'] = '0'
                record['partner_name'] = ''
                record['vat'] = _('Unknown')
                record['employee'] = '0'
                record['activity_sector'] = ''
            record['street'] = ''
            record['street2'] = ''
            record['zipcode'] = ''
            record['city'] = ''
            record['function'] = ''
            record['provided_turnover'] = '%.2f euros HTVA' % (part.provided_turnover or 0.0) 
            if part.date_in and part.date_in <> 'False':
                record['date_in'] = part.date_in[8:10]+'/'+part.date_in[5:7]+'/'+part.date_in[0:4]
            else:
                record['date_in'] = ''
            if part.contact_id and part.partner_id and part.partner_id.address:
                for addr in partner.address:
                    for job in addr.job_ids:
                        if job.contact_id and job.contact_id.id == part.contact_id.id:
                            record['street'] = addr.street or ''
                            record['street2'] = addr.street2 or ''
                            record['zipcode'] = addr.zip_id and addr.zip_id.name or ''
                            record['city'] = addr.zip_id and addr.zip_id.city or ''
                            record['function'] = job.function_label or ''
                            break
            record['profil'] = part.group_id and part.group_id.name or ''
            result.append(record)
        return result
report_sxw.report_sxw('report.club_renewal_alterego', 'cci_club.participation', 'addons/cci_club_extend/report/report_renewal_alterego.rml', parser=report_renewal_alterego,header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

