# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import time
from report import report_sxw
from tools.translate import _
import pooler
import pymysql

class report_surveys_comments(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(report_surveys_comments, self).__init__(cr, uid, name, context)
        self.localcontext.update({'time': time,
                                  'get_datas':self._get_datas})
    def _get_datas(self, form, objects,context=None):
        result = []
        parameter_obj = pooler.get_pool(self.cr.dbname).get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(self.cr,self.uid,['AEFormsConnectionDict'])
        if param_values.has_key('AEFormsConnectionDict'):
            connection = param_values['AEFormsConnectionDict']
            survey_type = form['type']
            if survey_type == 'mi_10':
                full_name = u"Mi-parcours version 1.0 (2014-05-30)"
                where_clause = "`type` = 'mi-parcours' AND `version` = '1.0'"
                lFields = ['create_time','pid','name','group_name','ind_satis',
                           'attentes','quotidien','reflexion','partage','reseau','question','leadership','ecoute','competence','devperso','com_content',
                           'animateur','expert','groupe','cci','com_animateur','com_expert','com_groupe','com_cci','suggestion','com_best','com_worst','com_theme','com_track']
                dResTables = {0:{'name':'Le contenu','res_codes':('TAF','Part','PV','PDT'),'res_name':(u'Tout à fait',u'Partiellement',u'Pas Vraiment',u'Pas du tout')},
                              1:{'name':'Les personnes','res_codes':('TAF','Plutot','PlPa','PDT'),'res_name':(u'Très satisfait',u'Satisfait',u'Moyennement satisfait',u'Pas du tout satisfait')},
                              2:{'name':'Indice de satisfaction','res_codes':('average',),'res_name':(u'Moyenne des valeurs de 0 à 10',)},
                             }
                lSums = [('attentes',u"ALTER EGO a rencontré mes attentes initiales",0),
                         ('quotidien',u"ALTER EGO m'a permis de prendre du recul par rapport au quotidien",0),
                         ('reflexion',u"Les réunions ALTER EGO m'ont aidé à renouveler/enrichir ma réflexion.",0),
                         ('partage',u"ALTER EGO m'a permis des échanges intéressants avec mes alter ego en terme de partage d'expérience",0),
                         ('reseau',u"ALTER EGO m'a permis de créer/étendre mon réseau professionnel",0),
                         ('question',u"Question.",0),
                         ('leadership',u"Leadership.",0),
                         ('ecoute',u"J'ai le sentiment d'être écouté quand je m'exprime. Je me sens compris.",0),
                         ('competence',u"Competence",0),
                         ('devperso',u"devperso.",0),
                         ('animateur',u"Animateur.",1),
                         ('expert',u"Experts.",1),
                         ('groupe',u"Groupe.",1),
                         ('cci',u"CCI.",1),
                        ]
                com_fields = [(u'Contenu:','com_content'),
                              (u'Animateur','com_animateur'),
                              (u'Experts','com_expert'),
                              (u'Groupe','com_groupe'),
                              (u'Rôle CCI','com_cci'),
                              (u'Suggestions','suggestion'),
                              (u'Plus apprécié:','com_best'),
                              (u'Moins apprécié:','com_worst'),
                              (u'Piste amélioration:','com_track'),
                              (u'Thèmes:','com_theme'),
                             ]
            else:
                full_name = u"Fin parcours version 1.0 (2014-05-30)"
                where_clause = "`type` = 'finparcours' AND `version` = '1.0'"
                lFields = ['create_time','pid','name','group_name','ind_satis',
                           'attentes','quotidien','reflexion','partage','reseau','ecoute','competence','devperso','evolcomp','rh','time','money','action','com_content',
                           'animateur','expert','groupe','cci','com_animateur','com_expert','com_groupe','com_cci','suggestion','com_best','com_worst','com_theme','com_track','renew','com_renew','new_group','com_new_group']
                dResTables = {0:{'name':'Le contenu','res_codes':('TAF','Part','PV','PDT'),'res_name':(u'Tout à fait',u'Partiellement',u'Pas Vraiment',u'Pas du tout')},
                              1:{'name':'Les personnes','res_codes':('TAF','Plutot','PlPa','PDT'),'res_name':(u'Très satisfait',u'Satisfait',u'Moyennement satisfait',u'Pas du tout satisfait')},
                              2:{'name':'Indice de satisfaction','res_codes':('average',),'res_name':(u'Moyenne des valeurs de 0 à 10',)},
                             }
                lSums = [('attentes',u"ALTER EGO a rencontré mes attentes initiales",0),
                         ('quotidien',u"ALTER EGO m'a permis de prendre du recul par rapport au quotidien",0),
                         ('reflexion',u"Les réunions ALTER EGO m'ont aidé à renouveler/enrichir ma réflexion.",0),
                         ('partage',u"ALTER EGO m'a permis des échanges intéressants avec mes alter ego en terme de partage d'expérience",0),
                         ('reseau',u"ALTER EGO m'a permis de créer/étendre mon réseau professionnel",0),
                         ('ecoute',u"J'ai le sentiment d'être écouté quand je m'exprime. Je me sens compris.",0),
                         ('competence',u"Competence",0),
                         ('devperso',u"devperso.",0),
                         ('evolcomp',u"evolcomp.",0),
                         ('rh',u"rh.",0),
                         ('time',u"time.",0),
                         ('money',u"money.",0),
                         ('action',u"action.",0),
                         ('animateur',u"Animateur.",1),
                         ('expert',u"Experts.",1),
                         ('groupe',u"Groupe.",1),
                         ('cci',u"CCI.",1),
                        ]
                com_fields = [(u'Contenu:','com_content'),
                              (u'Animateur:','com_animateur'),
                              (u'Experts:','com_expert'),
                              (u'Groupe:','com_groupe'),
                              (u'Rôle CCI:','com_cci'),
                              (u'Suggestions:','suggestion'),
                              (u'Plus apprécié:','com_best'),
                              (u'Moins apprécié:','com_worst'),
                              (u'Thèmes:','com_theme'),
                              (u'Piste amélioration:','com_track'),
                             ]
            try:
                where_clause += " AND `create_time` >= '%s 00:00:01' AND `create_time` <= '%s 23:59:59'" % (form['from'],form['to'])
                con = pymysql.connect(host=connection['host'], port=connection['port'], user=connection['user'], passwd=connection['pw'], db=connection['db'], charset='utf8');
                cur = con.cursor(pymysql.cursors.DictCursor)
                sentence = "SELECT %s FROM `aeforms` WHERE %s" % (','.join(lFields),where_clause)
                cur.execute(sentence)
                res = cur.fetchall()
            except pymysql.err.Error, e:
                print 'Connection Error %d: %s' % (e.args[0],e.args[1])
                final_result = False
            if cur:
                cur.close()
            if con:
                con.close()
            part_obj = pooler.get_pool(self.cr.dbname).get('cci_club.participation')
            for line in res:
                record = {}
                record['survey_date'] = line['create_time'].strftime('%d/%m/%Y %H:%M:%S')
                record['survey_type'] = full_name
                if line['pid']:
                    participation = part_obj.browse(self.cr,self.uid,line['pid'])
                    group_name = participation.group_id.name
                    part_name = participation.contact_id.name
                    if participation.contact_id.first_name:
                        part_name += (' ' + participation.contact_id.first_name )
                    record['club_name'] = u'%s [%s]' % (group_name,'id = ' + str(line['pid']))
                    record['part_name'] = u'%s [%s]' % (part_name,'id = ' + str(line['pid']))
                else:
                    record['club_name'] = u'%s [%s]' % (line['group_name'],u'manuel')
                    record['part_name'] = u'%s [%s]' % (line['name'],u'manuel')
                record['indice'] = line['ind_satis']
                lines = []
                for (key_table,table) in dResTables.items():
                    if table['res_codes'] <> ('average',):
                        lines.append( ( table['name'], '' ) )
                        for sum_line in lSums:
                            if sum_line[2] == key_table:
                                value = line[sum_line[0]]
                                if value in table['res_codes']:
                                    value = table['res_name'][table['res_codes'].index(value)]
                                lines.append( (sum_line[1], value) )
                lines.append( ( u'Commentaires', '' ) )
                for field in com_fields:
                    lines.append( (field[0],line[field[1]]) )
                if survey_type == 'fin_10':
                    lines.append(('Renouvellement participation',(line['renew'] == 'YES') and 'OUI' or 'Non'))
                    if line['renew'] == 'no':
                        lines.append(('Raisons:',line['com_renew']))
                    lines.append(('Orienté vers un autre groupe',(line['new_group'] == 'YES') and 'OUI' or 'Non'))
                    if line['new_group'] == 'YES':
                        lines.append(('Lequel:',line['com_new_group']))
                record['lines'] = lines
                result.append(record)
        return result
report_sxw.report_sxw('report.surveys_comments', 'cci_club.club', 'addons/cci_club_extend/report/surveys_comments.rml', parser=report_surveys_comments,header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

