# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
import datetime
from pyExcelerator import *
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Count Formation Checks for Finished Clubs">
    <field name="type_id" colspan="4" width="600"/>
    <field name="period_id"/>
</form>"""

fields = {
    'type_id': {'string':'Type of clubs', 'type':'many2one', 'relation':'cci_club.club_type','required':True},
    'period_id': {'string':'Period of closing Club', 'type':'many2one', 'relation':'account.period','required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="count_fc.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'count_fc.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class count_fc(wizard.interface):
    def _count_formation_check(self,cr,uid,data,context):
        # we search for all club of the given type where there is no more sessions beyond the given period
        club_type = pooler.get_pool(cr.dbname).get('cci_club.club_type').read(cr,uid,[data['form']['type_id']],['name'])[0]
        period = pooler.get_pool(cr.dbname).get('account.period').read(cr,uid,[data['form']['period_id']],['name','date_start','date_stop'])[0]
        last_date = period['date_stop']
        obj_club = pooler.get_pool(cr.dbname).get('cci_club.club')
        club_ids = obj_club.search(cr,uid,[('type_id','=',data['form']['type_id']),('closure_date','=',False),('date_end','<=',last_date)])
        if club_ids:
            # creation of the Excel file containint the results
            wb = Workbook()
            ws1 = wb.add_sheet('Count')
            ws2 = wb.add_sheet('Parameters')
            ws2.write(0,0,_('Type'))
            ws2.write(1,0,_('Period'))
            ws2.write(0,1,club_type['name'] + ' [' + str(club_type['id']) + ']')
            ws2.write(1,1,period['name'] + ' => ' + last_date[8:]+'/'+last_date[5:7]+'/'+last_date[0:4])
            #
            ws1.write(0,0,_('This wizard count the number of SESSIONS (not Hours) valids for checks or not'))
            ws1.write(1,0,_('The first column gives you the number of sessions configured to be \'valid for asking checks\','))
            ws1.write(2,0,_('While the second column gives you the number of sessions not valid (mainly because not present).'))
            ws1.write(3,0,_('Don\'t forget to multiply the number of vamid sessions by the number of hours by session to get the number of cheks you can ask for.'))
            ws1.write(5,0,_('Club Name'))
            ws1.write(5,1,_('Club Last Date'))
            ws1.write(5,2,_('Company'))
            ws1.write(5,3,_('Participant'))
            ws1.write(5,4,_('Participant Email'))
            ws1.write(5,5,_('Valid sessions'))
            ws1.write(5,7,_('Invalid sessions'))
            line = 6
            clubs = obj_club.browse(cr,uid,club_ids)
            for club in clubs:
                # treatment of each clubs
                if club.participation_ids:
                    for participant in club.participation_ids:
                        ws1.write(line,0,club.name)
                        ws1.write(line,1,club.date_end)
                        ws1.write(line,2,participant.partner_id.name or '' )
                        ws1.write(line,3,participant.contact_id.name + ' ' + (participant.contact_id.first_name and participant.contact_id.first_name or '' ))
                        ws1.write(line,4,participant.email or '')
                        count = 0
                        invalid = 0
                        for session in participant.attendance_ids:
                            if session.state.checks_valid:
                                count += 1
                            else:
                                invalid += 1
                        ws1.write(line,5,count)
                        ws1.write(line,7,invalid)
                        line += 1
                else:
                    ws1.write(line,0,club.name)
                    ws1.write(line,1,club.date_end)
                    ws1.write(line,2,_('No participant'))
                    line += 1
            # record the date of closure for all theses clubs
            obj_club.write(cr,uid,club_ids,{'closure_date':datetime.datetime.today().strftime('%Y-%m-%d')})
            wb.save('count_fc.xls')
            result_file = open('count_fc.xls','rb').read()
            # give the result tos the user
            data['form']['msg']=_("File created 'count_fc.xls'")
            data['form']['count_fc.xls']=base64.encodestring(result_file)
        else:
            data['form']['msg'] = _('Nothing found')
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('count','Count')]},
        },
        'count': {
            'actions': [_count_formation_check],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
count_fc('count_fc')
