# -*- encoding: utf-8 -*-
# 2013-0123 : added the modification of end_date on participation, not only on club as initially asked

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
import datetime
from pyExcelerator import *
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Create Weekly Sessions">
    <field name="from"/>
    <field name="count"/>
    <field name="state_id"/>
</form>"""

fields = {
    'from': {'string':'Date first session', 'type':'date', 'required': True},
    'count':{'string':'Number of sessions', 'type':'integer', 'required': True},
    'state_id':{'string':'Etat initial', 'type':'many2one', 'relation':'cci_club.session_state','required': True},
}

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <field name="msg" colspan="4" nolabel="1" width="600"/>
</form>"""

msg_fields = {
    'msg': {'string':'Result', 'type':'text', 'size':'200','readonly':True},
}

def addWorkingDaysByType(cr,uid,beginDate,daysToAdd,type_ids):
    finalDate = beginDate
    additional_days = 0
    holiday_obj = pooler.get_pool(cr.dbname).get('cci_club.club_holiday')
    # get future holidays of this type
    holiday_ids = holiday_obj.search(cr,uid,[('to','>=',beginDate)])
    future_holidays_of_these_types = []
    holidays = holiday_obj.read(cr,uid,holiday_ids,['date_from','date_to','type_ids'])
    for holiday in holidays:
        if holiday['type_ids'] and type_ids and set(holiday['type_ids']).intersection(set(type_ids)):
            future_holidays_of_these_types.append((holiday['date_from'],holiday['date_to']))
    while additional_days < daysToAdd:
        finalDate += datetime.timedelta(days=1)
        if finalDate.weekday() not in [5,6]:
            # search if not holiday for these types of clubs
            found_holiday = False
            for holiday in future_holidays_of_these_types:
                cfinalDate = finalDate.strftime("%Y-%m-%d")
                if cfinalDate >= holiday[0] and cfinalDate <= holiday[1]:
                    found_holiday = True
                    break
            if not found_holiday:
                additional_days += 1
    return finalDate

class create_weekly_sessions(wizard.interface):
    def _create_sessions(self,cr,uid,data,context):
        if data['form']['count'] > 0:
            obj_session = pooler.get_pool(cr.dbname).get('cci_club.session')
            obj_holiday = pooler.get_pool(cr.dbname).get('cci_club.club_holiday')
            obj_club = pooler.get_pool(cr.dbname).get('cci_club.club')
            obj_part = pooler.get_pool(cr.dbname).get('cci_club.participation')
            a_week = datetime.timedelta(weeks=1)
            first_date = datetime.date(int(data['form']['from'][0:4]),int(data['form']['from'][5:7]),int(data['form']['from'][8:10]))
            #
            for gid in data['ids']:
                obj_session.create(cr,uid,{'group_id':gid,'date':first_date.strftime('%Y-%m-%d'),'number':'1','state_id':data['form']['state_id']})
                club = obj_club.browse(cr,uid,gid)
                # get future holidays of this type
                holiday_ids = obj_holiday.search(cr,uid,[('date_to','>=',first_date)])
                future_holidays_of_this_type = []
                holidays = obj_holiday.read(cr,uid,holiday_ids,['date_from','date_to','type_ids'])
                for holiday in holidays:
                    if holiday['type_ids'] and (club.type_id.id in holiday['type_ids']):
                        future_holidays_of_this_type.append((holiday['date_from'],holiday['date_to']))
                current_number = 1
                last_date = first_date
                while current_number < data['form']['count']:
                    last_date = last_date + a_week
                    found_holiday = False
                    for holiday in future_holidays_of_this_type:
                        cfinalDate = last_date.strftime("%Y-%m-%d")
                        if cfinalDate >= holiday[0] and cfinalDate <= holiday[1]:
                            found_holiday = True
                            break
                    if not found_holiday:
                        current_number += 1
                        obj_session.create(cr,uid,{'group_id':gid,'date':last_date.strftime('%Y-%m-%d'),'number':str(current_number),'state_id':data['form']['state_id']})
                obj_club.write(cr,uid,data['ids'],{'date_end':last_date})
                part_ids = []
                # set also the end date on all participants
                part_ids = [x.id for x in club.participation_ids]
                obj_part.write(cr,uid,part_ids,{'date_out':last_date})
            data['form']['msg'] = _('%i sessions created in %i clubs from %s to %s\nThe date of ending of this(these) club(s) has been changed.') % (data['form']['count'],len(data['ids']),first_date.strftime('%d/%m/%Y'),last_date.strftime('%d/%m/%Y'))
        else:
            data['form']['msg'] = _('Nothing created !')
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('create','Create')]},
        },
        'create': {
            'actions': [_create_sessions],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
create_weekly_sessions('create_weekly_sessions')
