# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
from tools.translate import _
from pyExcelerator import *
import pymysql

form = """<?xml version="1.0"?>
<form string="Extract Results of Surveys">
    <field name="type" colspan="4" width="600"/>
    <field name="from"/>
    <field name="to"/>
</form>"""

fields = {
    'type': {'string':'Survey','type':'selection','selection':[('mi_10','Mi-Parcours v1.0'),('fin_10','Fin Parcours v1.0')],'required':True},
    'from': {'string':'From', 'type':'date','required':True},
    'to': {'string':'To', 'type':'date','required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="File has been created."  colspan="4"/>
     <field name="results_survey.xls" colspan="4" />
</form>"""

msg_fields = {
    'results_survey.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class extract_res_surveys(wizard.interface):
    def _extract_data(self,cr,uid,data,context):
        parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['AEFormsConnectionDict'])
        if param_values.has_key('AEFormsConnectionDict'):
            connection = param_values['AEFormsConnectionDict']
            survey_type = data['form']['type']
            if survey_type == 'mi_10':
                full_name = u"Mi-parcours version 1.0 (2014-05-30)"
                where_clause = "`type` = 'mi-parcours' AND `version` = '1.0'"
                lFields = ['create_time','pid','name','group_name','ind_satis',
                           'attentes','quotidien','reflexion','partage','reseau','question','leadership','ecoute','competence','devperso','com_content',
                           'animateur','expert','groupe','cci','com_animateur','com_expert','com_groupe','com_cci','suggestion','com_best','com_worst','com_theme','com_track']
                dResTables = {0:{'name':'Le contenu','res_codes':('TAF','Part','PV','PDT'),'res_name':(u'Tout à fait',u'Partiellement',u'Pas Vraiment',u'Pas du tout')},
                              1:{'name':'Les personnes','res_codes':('TAF','Plutot','PlPa','PDT'),'res_name':(u'Très satisfait',u'Satisfait',u'Moyennement satisfait',u'Pas du tout satisfait')},
                              2:{'name':'Indice de satisfaction','res_codes':('average',),'res_name':(u'Moyenne des valeurs de 0 à 10',)},
                             }
                lSums = [('attentes',u"ALTER EGO a rencontré mes attentes initiales",0),
                         ('quotidien',u"ALTER EGO m'a permis de prendre du recul par rapport au quotidien",0),
                         ('reflexion',u"Les réunions ALTER EGO m'ont aidé à renouveler/enrichir ma réflexion.",0),
                         ('partage',u"ALTER EGO m'a permis des échanges intéressants avec mes alter ego en terme de partage d'expérience",0),
                         ('reseau',u"ALTER EGO m'a permis de créer/étendre mon réseau professionnel",0),
                         ('question',u"Question.",0),
                         ('leadership',u"Leadership.",0),
                         ('ecoute',u"J'ai le sentiment d'être écouté quand je m'exprime. Je me sens compris.",0),
                         ('competence',u"Competence",0),
                         ('devperso',u"devperso.",0),
                         ('animateur',u"Animateur.",1),
                         ('expert',u"Experts.",1),
                         ('groupe',u"Groupe.",1),
                         ('cci',u"CCI.",1),
                        ]
            else:
                full_name = u"Fin parcours version 1.0 (2014-05-30)"
                where_clause = "`type` = 'finparcours' AND `version` = '1.0'"
                lFields = ['create_time','pid','name','group_name','ind_satis',
                           'attentes','quotidien','reflexion','partage','reseau','ecoute','competence','devperso','evolcomp','rh','time','money','action','com_content',
                           'animateur','expert','groupe','cci','com_animateur','com_expert','com_groupe','com_cci','suggestion','com_best','com_worst','com_theme','com_track',
                           'renew','com_renew','new_group','com_new_group']
                dResTables = {0:{'name':'Le contenu','res_codes':('TAF','Part','PV','PDT'),'res_name':(u'Tout à fait',u'Partiellement',u'Pas Vraiment',u'Pas du tout')},
                              1:{'name':'Les personnes','res_codes':('TAF','Plutot','PlPa','PDT'),'res_name':(u'Très satisfait',u'Satisfait',u'Moyennement satisfait',u'Pas du tout satisfait')},
                              2:{'name':'Indice de satisfaction','res_codes':('average',),'res_name':(u'Moyenne des valeurs de 0 à 10',)},
                             }
                lSums = [('attentes',u"ALTER EGO a rencontré mes attentes initiales",0),
                         ('quotidien',u"ALTER EGO m'a permis de prendre du recul par rapport au quotidien",0),
                         ('reflexion',u"Les réunions ALTER EGO m'ont aidé à renouveler/enrichir ma réflexion.",0),
                         ('partage',u"ALTER EGO m'a permis des échanges intéressants avec mes alter ego en terme de partage d'expérience",0),
                         ('reseau',u"ALTER EGO m'a permis de créer/étendre mon réseau professionnel",0),
                         ('ecoute',u"J'ai le sentiment d'être écouté quand je m'exprime. Je me sens compris.",0),
                         ('competence',u"Competence",0),
                         ('devperso',u"devperso.",0),
                         ('evolcomp',u"evolcomp.",0),
                         ('rh',u"rh.",0),
                         ('time',u"time.",0),
                         ('money',u"money.",0),
                         ('action',u"action.",0),
                         ('animateur',u"Animateur.",1),
                         ('expert',u"Experts.",1),
                         ('groupe',u"Groupe.",1),
                         ('cci',u"CCI.",1),
                        ]
            try:
                where_clause += " AND `create_time` >= '%s 00:00:01' AND `create_time` <= '%s 23:59:59'" % (data['form']['from'],data['form']['to'])
                con = pymysql.connect(host=connection['host'], port=connection['port'], user=connection['user'], passwd=connection['pw'], db=connection['db'], charset='utf8');
                cur = con.cursor(pymysql.cursors.DictCursor)
                sentence = "SELECT %s FROM `aeforms` WHERE %s" % (','.join(lFields),where_clause)
                cur.execute(sentence)
                res = cur.fetchall()
            except pymysql.err.Error, e:
                print 'Connection Error %d: %s' % (e.args[0],e.args[1])
                final_result = False
            if cur:
                cur.close()
            if con:
                con.close()
            filename = 'results_survey.xls'
            wb = Workbook()
            ws1 = wb.add_sheet(u"Détails")
            ws1.write(0,0,u"ALTER EGO")
            ws1.write(2,0,u"Type d'enquête :")
            ws1.write(3,0,u"Récoltées du :")
            ws1.write(4,0,u"au :")
            ws1.write(2,1,full_name)
            ws1.write(3,1,data['form']['from'])
            ws1.write(4,1,data['form']['to'])
            col = 0
            for field_name in lFields:
                ws1.write(6,col,field_name)
                col += 1
            line1 = 7
            #
            dClubs = {}
            dCounts = {}
            part_obj = pooler.get_pool(cr.dbname).get('cci_club.participation')
            for line in res:
                col = 0
                if line['pid']:
                    participation = part_obj.browse(cr,uid,line['pid'])
                    group_name = participation.group_id.name
                else:
                    group_name = line['group_name']
                if not dClubs.has_key(group_name):
                    total_question = {}
                    for field in lSums:
                        for response in dResTables[field[2]]['res_codes']:
                            total_question[(field[0],response)] = 0
                    dClubs[group_name] = total_question
                if not dCounts.has_key(group_name):
                    count = {'count':0,'total':0}
                    dCounts[group_name] = count
                total_question = dClubs[group_name]
                total_indice = dCounts[group_name]
                total_indice['count'] += 1
                total_indice['total'] += line['ind_satis']
                for field_name in lFields:
                    if field_name == 'create_time':
                        ws1.write(line1,col,line[field_name].strftime('%d/%m/%Y %H:%M:%M'))
                    elif field_name == 'name' and line['pid'] > 0:
                        ws1.write(line1,col,participation.contact_id.name + ' ' + (participation.contact_id.first_name or '' ))
                    elif field_name == 'group_name' and line['pid'] > 0:
                        ws1.write(line1,col,participation.group_id.name)
                    else:
                        ws1.write(line1,col,line[field_name] or '')
                    col += 1
                    to_sum = ''
                    for sumline in lSums:
                        if field_name == sumline[0]:
                            to_sum = sumline[0]
                    if to_sum:
                        total_question[(to_sum,line[field_name])] += 1
                dClubs[group_name] = total_question
                line1 += 1
            for (club_name,res_club) in dClubs.items():
                club_num = 2
                ws = wb.add_sheet(u"Totaux Club " + club_name)
                ws.write(0,0,u"Résultats du club " + club_name)
                linec = 1
                for (key,table) in dResTables.items():
                    linec += 1
                    ws.write(linec,0,table['name'])
                    col = 1
                    for resultat in table['res_name']:
                        ws.write(linec,col,resultat)
                        col += 1
                    linec += 1
                    for question_2_sum in lSums:
                        if question_2_sum[2] == key:
                            ws.write(linec,0,question_2_sum[1])
                            col = 1
                            for result in table['res_codes']:
                                ws.write(linec,col,res_club[(question_2_sum[0],result)])
                                col += 1 
                            linec += 1
                ws.write(linec,1,"%.2f" % (dCounts[club_name]['total']/dCounts[club_name]['count']))
            wb.save(filename)
            result_file = open(filename,'rb').read()
            # give the results to the user
            data['form']['msg']='File created %s' % filename
            data['form']['results_survey.xls']=base64.encodestring(result_file)
        else:
            data['form']['msg'] = _('Nothing created.\nParameters are missing.')
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('extract','Extract')]},
        },
        'extract': {
            'actions': [_extract_data],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Cancel'),('print','Print Comments')]}
        },
        'print': {
            'actions': [],
            'result': {'type':'print', 'report':'surveys_comments', 'state':'end'},
        },
    }
extract_res_surveys('extract_res_surveys')
