# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
from pyExcelerator import *
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Follow Alter Ego">
    <field name="type_id" colspan="4" width="600"/>
    <field name="area_id" colspan="4"/>
    <field name="sector_id" colpsan="4"/>
</form>"""

fields = {
    'type_id': {'string':'Type of clubs', 'type':'many2one', 'relation':'cci_club.club_type'},
    'area_id': {'string':'Area','type':'many2one','relation':'res.partner.zip.group.type'},
    'sector_id':{'string':'Activity Sector Root','type':'many2one','relation':'res.partner.category'},
}

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="follow_alter_ego.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'follow_alter_ego.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}
def extract_categ_ids(cr,uid,parent_ids):
    categ_obj = pooler.get_pool(cr.dbname).get('res.partner.category')
    result_ids = parent_ids
    next_id = 0
    while next_id < len(result_ids):
        read_ids = result_ids[next_id:]
        next_id = len(result_ids)
        read_categs = categ_obj.read(cr,uid,read_ids,['id','child_ids'])
        for categ in read_categs:
            if categ['child_ids']:
                for id in categ['child_ids']:
                    if id not in result_ids:
                        result_ids.append(id)
    return result_ids

class follow_alter_ego(wizard.interface):
    def _extract_file(self,cr,uid,data,context):
        wb = Workbook()
        ws1 = wb.add_sheet(_('Participants'))
        ws1.write(0,0,_('ID part'))
        ws1.write(0,1,_('Group Name'))
        ws1.write(0,2,_('Participant Name'))
        ws1.write(0,3,_('Participant First Name'))
        ws1.write(0,4,_('Company'))
        ws1.write(0,5,_('EMail Participant'))
        ws1.write(0,6,_('Phone Participant'))
        ws1.write(0,7,_('Mobile Participant'))
        ws1.write(0,8,_('Phone Company'))
        ws1.write(0,9,_('State Participant'))
        ws1.write(0,10,_('Record Date'))
        ws1.write(0,11,_('Begin Date'))
        ws1.write(0,12,_('End Date'))
        ws1.write(0,13,_('Address'))
        ws1.write(0,14,_('Employment'))
        ws1.write(0,15,_('Activity250'))
        ws1.write(0,16,_('ActivitySector'))
        ws1.write(0,17,_('Salesman'))
        ws1.write(0,18,_('Zip Code'))
        ws1.write(0,19,_('Zone'))
        ws1.write(0,20,_('Continuation'))
        ws1.write(0,21,_('TotalPart'))
        ws1.write(0,22,_('TotalCompany'))
        ws1.write(0,23,_('Provided Turnover'))
        ws1.write(0,24,_('Final Turnover'))
        obj_participation = pooler.get_pool(cr.dbname).get('cci_club.participation')
        obj_club = pooler.get_pool(cr.dbname).get('cci_club.club')
        if data['form']['type_id']:
            club_ids = obj_club.search(cr,uid,[('type_id','=',data['form']['type_id'])])
            participation_ids = obj_participation.search(cr,uid,[('group_id','in',club_ids)])
        else:
            participation_ids = obj_participation.search(cr,uid,[])
        errors = 0
        if participation_ids:
        
            participations = obj_participation.browse(cr,uid,participation_ids)
            
            # Before all, extract all 'secteurs d'activité' categories
            if data['form']['sector_id']:
                categ_ids = extract_categ_ids(cr,uid,[data['form']['sector_id']])
                categs = pooler.get_pool(cr.dbname).get('res.partner.category').browse(cr,uid,categ_ids)
                dCategs = {}
                for category in categs:
                    dCategs[category.id] = category.name or ''
            else:
                categ_ids = []
            # translate every zip code into an area name
            dZipArea = {}
            if data['form']['area_id']:
                obj_zip = pooler.get_pool(cr.dbname).get('res.partner.zip')
                obj_zip_group = pooler.get_pool(cr.dbname).get('res.partner.zip.group')
                area_ids = obj_zip_group.search(cr,uid,[('type_id','=',data['form']['area_id'])])
                areas = obj_zip_group.browse(cr,uid,area_ids)
                dAreas = {}
                for area in areas:
                    dAreas[area.id] = area.name
                zip_ids = obj_zip.search(cr,uid,[])
                zips = obj_zip.browse(cr,uid,zip_ids)
                for zip_code in zips:
                    area = ''
                    for group in zip_code.groups_id:
                        if dAreas.has_key(group.id):
                            area = dAreas[group.id]
                    if area:
                        dZipArea[zip_code.id] = area
            # first, we calculate totals by contact_id and partner_id
            dTotParts = {}
            dTotComps = {}
            for part in participations:
                if part.contact_id:
                    if dTotParts.has_key(part.contact_id.id):
                        dTotParts[part.contact_id.id] += 1
                    else:
                        dTotParts[part.contact_id.id] = 1
                if part.partner_id:
                    if dTotComps.has_key(part.partner_id.id):
                        dTotComps[part.partner_id.id] += 1
                    else:
                        dTotComps[part.partner_id.id] = 1

            # Then, we record the data in excel file
            line = 1
            for part in participations:
                # we search for the job and address between the contact and partner
                current_job_id = False
                current_address_id = False
                for job in part.contact_id.job_ids:
                    if job.address_id and job.address_id.partner_id and job.address_id.partner_id.id == part.partner_id.id:
                        current_job_id = job
                        current_address_id = job.address_id
                        break
                if current_address_id:
                    full_address = current_address_id.street or ''
                    if current_address_id.street2:
                        full_address += ( ' ' + current_address_id.street2 )
                    if current_address_id.zip_id:
                        full_address += ', ' + current_address_id.zip_id.name + ' ' +current_address_id.zip_id.city
                else:
                    full_address = ''
                current_zone = '' 
                if dZipArea:
                    if current_address_id and current_address_id.zip_id and dZipArea.has_key(current_address_id.zip_id.id):
                        current_zone = dZipArea[current_address_id.zip_id.id]
                current_sector = ''
                if categ_ids:
                    for category in part.partner_id.category_id:
                        if category.id in categ_ids:
                            current_sector = dCategs[category.id]
                            break
                ws1.write(line,0,part.id)
                ws1.write(line,1,part.group_id.name)
                ws1.write(line,2,part.contact_id.name )
                ws1.write(line,3,part.contact_id.first_name or '')
                ws1.write(line,4,part.partner_id.name)
                ws1.write(line,5,part.email or '')
                ws1.write(line,6,current_job_id and current_job_id.phone or '')
                ws1.write(line,7,part.contact_id.mobile or '')
                ws1.write(line,8,current_address_id and current_address_id.phone or '')
                ws1.write(line,9,part.state_id.name)
                ws1.write(line,10,part.date_registration or '')
                ws1.write(line,11,part.date_in or '')
                ws1.write(line,12,part.date_out or '')
                ws1.write(line,13,full_address)
                ws1.write(line,14,part.partner_id.employee_nbr or 0)
                ws1.write(line,15,part.partner_id.activity_description and part.partner_id.activity_description[0:250] or '')
                ws1.write(line,16,current_sector)
                ws1.write(line,17,part.partner_id.user_id.name)
                ws1.write(line,18,current_address_id and current_address_id.zip_id.name or '' )
                ws1.write(line,19,current_zone)
                ws1.write(line,20,part.continuation and _('YES') or _('No'))
                ws1.write(line,21,dTotParts[part.contact_id.id])
                ws1.write(line,22,dTotComps[part.partner_id.id])
                ws1.write(line,23,part.provided_turnover or 0.0)
                ws1.write(line,24,part.final_turnover or 0.0)
                line += 1
        wb.save('follow_alter_ego.xls')
        result_file = open('follow_alter_ego.xls','rb').read()

        # give the result to the user
        data['form']['msg']=_('Save the File with '".xls"' extension.')
        data['form']['follow_alter_ego.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('extract','Extract')]},
        },
        'extract': {
            'actions': [_extract_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
follow_alter_ego('follow_alter_ego')
