# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
import calendar
import tools
import pooler
import base64
import csv
from pyExcelerator import *
from osv import fields
from osv import osv
from tools.translate import _
import StringIO

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="input" colspan="4" width="600"/>
    <field name="year"/>
</form>"""

fields = {
    'input': {'type':'binary','string':'Traform XLS File','required':True},
    'year': {'string':'Year to inject','type':'integer','default': int(datetime.date.today().strftime('%Y')),'required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="Importation result" colspan="4"/>
     <field name="msg" colspan="4" nolabel="1" width="800" heigth="600"/>
</form>"""

msg_fields = {
    'msg': {'string':'File imported', 'type':'text', 'readonly':True},
}

def _remove_accentuation(name):
    return name.strip().replace(u'é','e').replace(u'è','e').replace(u'ê','e').replace(u'ë','e').replace(u'ù','u').replace(u'û','u').replace(u'ü','u').replace(u'à','a').replace(u'â','a').replace(u'ä','a').replace(u'ç','c').replace(u'î','i').replace(u'ï','i').replace(u'ô','o').replace(u'ö','o')

class import_injected_checks(wizard.interface):

    def _import_data(self,cr,uid,data,context):
        inputfile = data['form']['input']
        inputdata = base64.decodestring(inputfile)
        # creation of excel file for receiving data during importation
        wb = parse_xls(StringIO.StringIO(inputdata))
        sheet_checks = wb[1]
        if sheet_checks[0] == u'Chèques':
            sheet_content = sheet_checks[1]
            if sheet_content[(11,0)] == 'Check ID' and sheet_content[(11,27)] == 'Injected today':
                check_obj = pooler.get_pool(cr.dbname).get('cci_club.club_check')
                line = 12
                count = 0
                try:
                    check_id = sheet_content[(line,0)]
                except:
                    check_id = False
                while check_id:
                    try:
                        injected = sheet_content[(line,27)]
                    except:
                        injected = False
                    if injected and injected.upper() == 'X':
                        check_obj.write(cr,uid,[check_id,],{'traform_year':data['form']['year']})
                        count += 1
                    line += 1
                    try:
                        check_id = sheet_content[(line,0)]
                    except:
                        check_id = False
                data['form']['msg'] = u'Injected : ' + str(count)
            else:
                data['form']['msg'] = u'The first column is not \'Check ID\' or the 28st is not \'Injected Today\'.'
        else:
            data['form']['msg'] = u'The second sheet is not Chèques'
        return data['form']
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('import','Import File')]},
        },
        'import': {
            'actions': [_import_data],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

import_injected_checks('import_injected_checks')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

