# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
import calendar
import tools
import pooler
import base64
import csv
from pyExcelerator import *
from osv import fields
from osv import osv
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="type_id" colspan="4"/>
    <field name="school_id" colspan="4"/>
    <field name="create_if_needed"/>
    <field name="created_state_id" attrs="{'readonly':[('create_if_needed','=',False)],'required':[('create_if_needed','=',True)]}"/>
    <newline/>
    <field name="input" colspan="4" width="600"/>
    <field name="codepage"/>
</form>"""

fields = {
    'type_id': {'type':'many2one','string':'Club Type','relation':'cci_club.club_type','required':True},
    'school_id': {'type':'many2one','string':'School','relation':'res.partner','required':True},
    'input': {'type':'binary','string':'Lerian file','required':True},
    'create_if_needed':{'type':'boolean','string':'Allow creation','default':False},
    'created_state_id':{'string':'Created Session State','type':'many2one','relation':'cci_club.session_state'},
    'codepage':{'string':'Accents','type':'selection','selection':[('cp850','ASCII-850'),('cp1252','ANSI'),('utf8','UTF-8')]},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="Importation result" colspan="4"/>
     <field name="msg" colspan="4" nolabel="1" width="800" heigth="600"/>
     <field name="lerian_import_result.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File imported', 'type':'text', 'readonly':True},
    'lerian_import_result.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

def _remove_accentuation(name):
    return name.strip().replace(u'é','e').replace(u'è','e').replace(u'ê','e').replace(u'ë','e').replace(u'ù','u').replace(u'û','u').replace(u'ü','u').replace(u'à','a').replace(u'â','a').replace(u'ä','a').replace(u'ç','c').replace(u'î','i').replace(u'ï','i').replace(u'ô','o').replace(u'ö','o')

class import_lerian(wizard.interface):

    def _import_data(self,cr,uid,data,context):
        cp = data['form']['codepage']
        imported = 0
        rejected = 0
        created = 0
        empty = 0
        created_dates = 0
        errors_name_club = []
        errors_date_club = []
        inputfile = data['form']['input']
        inputdata = base64.decodestring(inputfile).split('\n')
        if inputdata[0][0:3] == '\xef\xbb\xbf':
            naam_key = '\xef\xbb\xbfNaamStudent'
        else:
            naam_key = 'NaamStudent'
        hfInput = csv.DictReader(inputdata,delimiter=";" )
        # creation of excel file for receiving data during importation
        wb = Workbook()
        ws1 = wb.add_sheet(_('Input Data'))
        ws1.write(0,0,_('Input Data'))
        ws1.write(2,0,_('Student name'))
        ws1.write(2,1,_('Module number'))
        ws1.write(2,2,_('Date'))
        ws1.write(2,3,_('Presence Code'))
        ws1.write(2,4,_('Result'))
        line_sheet1 = 3
        ws2 = wb.add_sheet(_('Wrong Clubs'))
        ws2.write(0,0,_('Wrong Clubs'))
        ws2.write(2,0,_('Lerian Module Number'))
        line_sheet2 = 3
        ws3 = wb.add_sheet(_('Wrong Presence Codes'))
        ws3.write(0,0,_('Wrong Presence Codes'))
        ws3.write(2,0,_('Lerian Presence Code'))
        line_sheet3 = 3
        ws4 = wb.add_sheet(_('Not found student name in club'))
        ws4.write(0,0,_('Not found student name in club'))
        ws4.write(2,0,_('Module number'))
        ws4.write(2,1,_('Club ID'))
        ws4.write(2,2,_('Club Name'))
        ws4.write(2,3,_('Student Name'))
        line_sheet4 = 3
        ws5 = wb.add_sheet(_('Date not found for this club'))
        ws5.write(0,0,_('Date not found for this club'))
        ws5.write(2,0,_('This is ERRORS !!!!!'))
        ws5.write(3,0,_('List of date in the Lerian file not found in OpenERP'))
        ws5.write(4,0,_(' AND OpenERP unable to fin an other date we can use to insert this missing date...'))
        ws5.write(5,0,_('YOU HAVE TO correct this manually and re-import the Lerian file'))
        ws5.write(7,0,_('Module number'))
        ws5.write(7,1,_('Club ID'))
        ws5.write(7,2,_('Club Name'))
        ws5.write(7,3,_('Date'))
        line_sheet5 = 8
        ws6 = wb.add_sheet(_('Sessions not in the imported file but in the period'))
        ws6.write(0,0,_('Sessions not in the imported file but in the period'))
        ws6.write(2,0,_('This is NOT errors.'))
        ws6.write(3,0,_('List of dates of sessions found in OpenERP but NOT in Lerian file'))
        ws6.write(4,0,_('while these dates are in the period covered by the Lerian file'))
        ws6.write(6,0,_('Min Date'))
        ws6.write(7,0,_('Max Date'))
        ws6.write(8,0,_('Session ID'))
        ws6.write(8,1,_('Club ID'))
        ws6.write(8,2,_('Club Name'))
        ws6.write(8,3,_('Lerian Name'))
        ws6.write(8,4,_('Date'))
        line_sheet6 = 9
        ws8 = wb.add_sheet(_('Date inserted from older dates'))
        ws8.write(0,0,_('Date inserted from older dates'))
        ws8.write(2,0,_('This is NOT errors.'))
        ws8.write(3,0,_('List of date inserted from dates already defined in the ERP'))
        ws8.write(4,0,_(' to accept dates from Lerian file'))
        ws8.write(6,0,_('Session ID'))
        ws8.write(6,1,_('Old Date'))
        ws8.write(6,2,_('New Date'))
        ws8.write(6,3,_('Old Number'))
        ws8.write(6,4,_('New Number'))
        line_sheet8 = 7
        if data['form']['create_if_needed']:
            ws9 = wb.add_sheet(_('Date created in OpenERP'))
            ws9.write(0,0,_('Date created'))
            ws9.write(2,0,_('This is NOT errors.'))
            ws9.write(3,0,_('List of date created in the ERP to accept dates'))
            ws9.write(4,0,_(' from Lerian file when there is no left acceptable dates'))
            ws9.write(6,0,_('Session ID'))
            ws9.write(6,1,_('New Date'))
            ws9.write(6,2,_('New Number'))
        line_sheet9 = 7
        ws7 = wb.add_sheet(_('Results'))
        # management of clubs and presences Lerian codes
        # and test of the format of the dates
        strange_dates = []
        club_names = []
        presence_codes = []
        min_date = (datetime.date.today()-datetime.timedelta(days=182)).strftime('%Y-%m-%d')
        max_date = datetime.date.today().strftime('%Y-%m-%d')
        for record in hfInput:
            if record['Modulenummer'].decode(cp) not in club_names:
                club_names.append(record['Modulenummer'].decode(cp))
            if record['Aanwezigheid'].decode(cp) not in presence_codes:
                presence_codes.append(record['Aanwezigheid'].decode(cp))

            full_date = record['DatumEncodering']
            if len(full_date) == 9:
                full_date = '0' + full_date
            if len(full_date) != 10:
                strange_dates.append(full_date)
            else:
                givendate = full_date[6:10]+'-'+full_date[3:5]+'-'+full_date[0:2]
                if not (givendate >= min_date and givendate <= max_date):
                    strange_dates.append(givendate+ ' ['+record['DatumEncodering']+']')
        if strange_dates:
            line_sheet1 += 1
            ws1.write(line_sheet1,0,_('Strange dates in the file - Nothing imported !'))
            line_sheet1 += 1
            ws1.write(line_sheet1,0,','.join(strange_dates))
            data['form']['msg']=_('Strange Dates in the file - Nothing Imported !')
        else:
            # orm objects
            club_obj = pooler.get_pool(cr.dbname).get('cci_club.club')
            session_obj = pooler.get_pool(cr.dbname).get('cci_club.session')
            attendance_obj = pooler.get_pool(cr.dbname).get('cci_club.attendance')
            attendance_state_obj = pooler.get_pool(cr.dbname).get('cci_club.attendance_state')
            # clubs
            club_ids = club_obj.search(cr,uid,[('external_name','in',club_names)])
            if club_ids:
                clubs = club_obj.browse(cr,uid,club_ids)
                dClubs = {}
                for club in clubs:
                    dClubs[club.external_name] = club
                notfound_clubs = []
                # presences codes
                dAttendanceStates = {}
                for external_code in presence_codes:
                    searched_code = '|'+external_code+'|'
                    attendance_id = attendance_state_obj.search(cr,uid,[('external_codes','like',searched_code)])
                    if attendance_id and len(attendance_id) == 1:
                        dAttendanceStates[external_code] = attendance_id[0]
                    else:
                        ws3.write(line_sheet3,0,external_code)
                        line_sheet3 += 1
                # re-read of the file
                hfInput = csv.DictReader(inputdata,delimiter=";" )
                min_date = '2999-12-31'
                max_date = '1980-01-01'
                found_session_ids = []
                for record in hfInput:
                    if record['Aanwezigheid'].decode(cp).lower() == 'geen':
                        empty += 1
                    else:
                        ws1.write(line_sheet1,0,record[naam_key].decode(cp))
                        ws1.write(line_sheet1,1,record['Modulenummer'].decode(cp))
                        ws1.write(line_sheet1,2,record['DatumEncodering'].decode(cp))
                        ws1.write(line_sheet1,3,record['Aanwezigheid'].decode(cp))
                        full_date = record['DatumEncodering']
                        if len(full_date) == 9:
                            full_date = '0' + full_date
                        givendate = full_date[6:10]+'-'+full_date[3:5]+'-'+full_date[0:2]
                        if givendate < min_date:
                            min_date = givendate
                        if givendate > max_date:
                            max_date = givendate
                        if dClubs.has_key(record['Modulenummer'].decode(cp)):
                            club = dClubs[record['Modulenummer'].decode(cp)]
                            if dAttendanceStates.has_key(record['Aanwezigheid'].decode(cp)):
                                full_name = record[naam_key].strip().decode(cp)
                                while '  ' in full_name:
                                    full_name = full_name.replace('  ',' ')
                                name_items = full_name.split(' ')
                                if len(name_items) == 2:
                                    names = [(_remove_accentuation(name_items[1]).upper(),_remove_accentuation(name_items[0]))]
                                else:
                                    if name_items[1].upper in ['DE','VAN'] and len(name_items) == 3: # case: Aurelie de ville de goyet
                                        names = [(_remove_accentuation(' '.join(name_items[1:])).upper(),_remove_accentuation(name_items[0]))]
                                    else:
                                        if len(name_items) == 3:
                                            names = [(_remove_accentuation(name_items[1]+' '+name_items[2]).upper(),_remove_accentuation(name_items[0])),
                                                     (_remove_accentuation(name_items[2]).upper(),_remove_accentuation(name_items[0]+' '+name_items[1]))]
                                        elif len(name_items) == 4:
                                            names = [(_remove_accentuation(name_items[2]+' '+name_items[3]).upper(),_remove_accentuation(name_items[0]+' '+name_items[1])),
                                                     (_remove_accentuation(name_items[3]).upper(),_remove_accentuation(name_items[0]+' '+name_items[1]+' '+name_items[2])),
                                                     (_remove_accentuation(name_items[1]+' '+name_items[2]+' '+name_items[3]).upper(),_remove_accentuation(name_items[0]))]
                                        elif len(name_items) == 5:
                                            names = [(_remove_accentuation(name_items[2]+' '+name_items[3]+' '+name_items[4]).upper(),_remove_accentuation(name_items[0]+' '+name_items[1])),
                                                     (_remove_accentuation(name_items[3]+' '+name_items[4]).upper(),_remove_accentuation(name_items[0]+' '+name_items[1]+' '+name_items[2])),
                                                     (_remove_accentuation(name_items[1]+' '+name_items[2]+' '+name_items[3]+' '+name_items[4]).upper(),_remove_accentuation(name_items[0])),
                                                     (_remove_accentuation(name_items[4]).upper(),_remove_accentuation(name_items[0]+' '+name_items[1]+' '+name_items[2]+' '+name_items[3])),]
                                # search of this person in the participers of the club
                                participation_id = 0
                                for part in club.participation_ids:
                                    for (sname,sfirst_name) in names:
                                        if part.contact_id.name.upper().strip() == sname and _remove_accentuation((part.contact_id.first_name or '').strip()) == sfirst_name:
                                            participation_id = part.id
                                            break
                                if participation_id == 0:
                                    error_line = (full_name,club.id)
                                    ws1.write(line_sheet1,4,_('KO - Student not found by his name on this club'))
                                    if error_line not in errors_name_club:
                                        ws4.write(line_sheet4,0,record['Modulenummer'].decode(cp))
                                        ws4.write(line_sheet4,1,club.id)
                                        ws4.write(line_sheet4,2,club.name)
                                        ws4.write(line_sheet4,3,record[naam_key].decode(cp))
                                        line_sheet4 += 1
                                        errors_name_club.append(error_line)
                                    rejected += 1
                                else:
                                    # search for a correct date with club, participer and given date
                                    session_id = session_obj.search(cr,uid,[('date','=',givendate),('group_id','=',club.id)])
                                    if not session_id:
                                        # we try to insert a session at this date, transforming the older date of this club
                                        res = club_obj._recycle_from_last_session_or_create(cr,uid,club.id,givendate,data['form']['create_if_needed'],data['form']['created_state_id'])
                                        if res:
                                            if res[0]:
                                                session_id = [res[0]]
                                                # we record this transformation
                                                ws8.write(line_sheet8,0,res[0])
                                                ws8.write(line_sheet8,1,res[1][8:10]+'/'+res[1][5:7]+'/'+res[1][:4])
                                                ws8.write(line_sheet8,2,res[2][8:10]+'/'+res[2][5:7]+'/'+res[2][:4])
                                                ws8.write(line_sheet8,3,res[3])
                                                ws8.write(line_sheet8,4,res[4])
                                                line_sheet8 += 1
                                            else:
                                                ws9.write(line_sheet9,0,res[6])
                                                ws9.write(line_sheet9,1,res[2][8:10]+'/'+res[2][5:7]+'/'+res[2][:4])
                                                ws9.write(line_sheet9,2,res[5])
                                                line_sheet9 += 1
                                                created_dates += 1
                                                session_id = [res[3]]
                                    if session_id and len(session_id) == 1:
                                        ws1.write(line_sheet1,4,_('OK'))
                                        if session_id[0] not in found_session_ids:
                                            found_session_ids.append(session_id[0])
                                        # now we have the club.id, the participation.id, the session.id and the attendance_state code,
                                        # we can modify/create the attendance
                                        attendance_id = attendance_obj.search(cr,uid,[('session_id','=',session_id[0]),('participation_id','=',participation_id)])
                                        if attendance_id and len(attendance_id) == 1:
                                            attendance_obj.write(cr,uid,[attendance_id[0]],{'state':dAttendanceStates[record['Aanwezigheid'].decode(cp)]})
                                        else:
                                            attendance_obj.create(cr,uid,{'session_id':session_id[0],'participation_id':participation_id,'state':dAttendanceStates[record['Aanwezigheid'].decode(cp)],'comments':_('Automatic creation')})
                                            created += 1
                                        imported += 1
                                    else:
                                        error_line = (givendate,club.id)
                                        ws1.write(line_sheet1,4,_('KO - Session not found by the date on this club'))
                                        if error_line not in errors_date_club:
                                            ws5.write(line_sheet5,0,record['Modulenummer'].decode(cp))
                                            ws5.write(line_sheet5,1,club.id)
                                            ws5.write(line_sheet5,2,club.name)
                                            ws5.write(line_sheet5,3,record['DatumEncodering'].decode(cp))
                                            line_sheet5 += 1
                                            errors_date_club.append(error_line)
                                        rejected += 1
                            else:
                                ws1.write(line_sheet1,4,_('KO - Unknown Presence Code'))
                                rejected += 1
                        else:
                            ws1.write(line_sheet1,4,_('KO - Club code not found'))
                            if record['Modulenummer'].decode(cp) not in notfound_clubs:
                                ws2.write(line_sheet2,0,record['Modulenummer'].decode(cp))
                                notfound_clubs.append(record['Modulenummer'].decode(cp))
                                line_sheet2 += 1
                            rejected += 1
                        line_sheet1 += 1
                # now we search for all sessions for this type of clubs between min and max date to find forgotten sessions
                if min_date[8:10] > '01':
                    min_date = min_date[0:8]+'01'
                last_day = calendar.monthrange(int(max_date[0:4]),int(max_date[5:7]))[1]
                if int(max_date[8:10]) < last_day:
                    max_date = max_date[0:8]+str(last_day)

                # if no sessions found, we must go to the end of the procedure to get the error excel file            
                if not found_session_ids:
                    found_session_ids = [0]
                sentence = """SELECT session.id, session.group_id, club.name, club.external_name, session.date
                                FROM cci_club_session as session, cci_club_club as club 
                                WHERE session.date >= '%s' AND session.date <= '%s'
                                    AND session.group_id = club.id
                                    AND club.type_id = %s AND club.school_id = %s AND club.active
                                    AND session.id not in (%s)""" % ( min_date, max_date, data['form']['type_id'], data['form']['school_id'], ','.join([str(x) for x in found_session_ids]) )
                cr.execute(sentence)
                res = cr.fetchall()
                ws6.write(6,1,min_date)
                ws6.write(7,1,max_date)
                for line in res:
                    ws6.write(line_sheet6,0,line[0])
                    ws6.write(line_sheet6,1,line[1])
                    ws6.write(line_sheet6,2,line[2])
                    ws6.write(line_sheet6,3,line[3] or '')
                    ws6.write(line_sheet6,4,line[4] or '')
                    line_sheet6 += 1
                ws7.write(0,0,_('Final Results'))
                ws7.write(1,0,_('Imported presences'))
                ws7.write(1,1,imported)
                ws7.write(2,0,_('Rejected presences'))
                ws7.write(2,1,rejected)
                ws7.write(3,0,_('Created'))
                ws7.write(3,1,created)
                ws7.write(4,0,_('Empty presences in Lerian File'))
                ws7.write(4,1,empty)
                # give the result to the user
                data['form']['msg']=_('Number of imported presences : %s\nNumber of rejected presences : %s\nNumber of created attendances : %s\nNumber of empties attendances : %s') % (str(imported),str(rejected),str(created),str(empty))
                if data['form']['create_if_needed']:
                    data['form']['msg'] += ( '\nCreated dates for lacking dates : %s' % str(created_dates) )
            else:
                data['form']['msg']=_('You must begin by linking clubs, giving external names on clubs definition.')
            # endif strange_dates
            
        wb.save('lerian_import_result.xls')
        result_file = open('lerian_import_result.xls','rb').read()

        # give the result to the user
        data['form']['lerian_import_result.xls']=base64.encodestring(result_file)
        return data['form']
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('import','Import File')]},
        },
        'import': {
            'actions': [_import_data],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

import_lerian('import_lerian')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

