# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Participants not in orders">
    <field name="type_id" colspan="4" width="600"/>
    <field name="club_state" colspan="4"/>
    <field name="part_state" colspan="4"/>
    <field name="supervisors"/>
</form>"""

fields = {
    'type_id': {'string':'Type of clubs', 'type':'many2one', 'relation':'cci_club.club_type','required':True},
    'club_state': {'string':'Type of clubs', 'type':'selection', 'selection':[('draft','Waiting to begin'),('current','Current'),('done','Closed')],'required':True},
    'part_state': {'string':'State of participants', 'type':'many2one', 'relation':'cci_club.participation_state','required':True},
    'supervisors':{'string':'Emails supervisors', 'type':'char', 'size':250},
}

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="part_not_in_order.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'part_not_in_order.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class part_not_in_orders(wizard.interface):
    def _extract_file(self,cr,uid,data,context):
        lSupervisors = []
        if data['form']['supervisors']:
            names = data['form']['supervisors'].replace(',',';')
            lSupervisors = names.split(';')
        obj_participation = pooler.get_pool(cr.dbname).get('cci_club.participation')
        filename = obj_participation.check_not_in_orders(cr,uid,type_ids=[data['form']['type_id']],club_states=[data['form']['club_state']],part_states=[data['form']['part_state']],supervisor_emails=lSupervisors)
        if filename:
            result_file = open(filename,'rb').read()
            # give the result tos the user
            data['form']['msg']='File created %s' % filename
            data['form']['part_not_in_order.xls']=base64.encodestring(result_file)
        else:
            data['form']['msg'] = _('Nothing created')
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('extract','Extract')]},
        },
        'extract': {
            'actions': [_extract_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
part_not_in_orders('part_not_in_orders')
