# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import pooler

def _select_convocs(self, cr, uid, data, context):
    participation_ids = data['ids']
    cr.execute("""SELECT convoc.id FROM cci_club_convocation as convoc, cci_club_attendance as attendance 
                      WHERE attendance.participation_id in (%s) AND attendance.id = convoc.attendance_id""" % ','.join([str(x) for x in participation_ids]) )
    res = cr.fetchall()
    convoc_ids = [x[0] for x in res]
    values = {
        'domain': [('id', 'in', convoc_ids)],
        'name': 'Convocations',
        'view_type': 'form',
        'view_mode': 'tree,form',
        'res_model': 'cci_club.convocation',
        'context': {},
        'type': 'ir.actions.act_window',
    }
    return values
class wizard_participation_convocations(wizard.interface):
    states = {
        'init': {
            'actions': [],
            'result': {
                'type': 'action',
                'action': _select_convocs,
                'state': 'end'
            }
        },
    }
wizard_participation_convocations("wizard_participation_convocations")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

