# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
import datetime
from pyExcelerator import *
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Report Session">
    <field name="new_date"/>
</form>"""

fields = {
    'new_date': {'string':'Date', 'type':'date', 'help':'If not given, set to the first available date after the last date','required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <field name="msg" colspan="4" nolabel="1" width="400"/>
</form>"""

msg_fields = {
    'msg': {'string':'Result', 'type':'text', 'size':'200','readonly':True},
}

class report_session(wizard.interface):
    def _init_date(self,cr,uid,data,context):
        obj_session = pooler.get_pool(cr.dbname).get('cci_club.session')
        obj_holiday = pooler.get_pool(cr.dbname).get('cci_club.club_holiday')
        current_session = obj_session.browse(cr,uid,data['id'])
        other_session_ids = obj_session.search(cr,uid,[('group_id','=',current_session.group_id.id)])
        other_sessions = obj_session.read(cr,uid,other_session_ids,['date'])
        # We take only the others sessions occuing in the same week's day into account, because, with 'Mens Sana', we can have two or threee sessions in the same week for the same club
        last_date = current_session.date
        day_of_week = datetime.datetime.strptime(last_date,'%Y-%m-%d').date().weekday()
        for session in other_sessions:
            this_day_of_week = datetime.datetime.strptime(session['date'],'%Y-%m-%d').date().weekday()
            if this_day_of_week == day_of_week:
                last_date = max(last_date,session['date'])
        last_date = datetime.date(int(last_date[0:4]),int(last_date[5:7]),int(last_date[8:10]))
        # get future holidays of this type
        holiday_ids = obj_holiday.search(cr,uid,[('date_to','>=',last_date.strftime('%Y-%m-%d'))])
        future_holidays_of_this_type = []
        holidays = obj_holiday.read(cr,uid,holiday_ids,['date_from','date_to','type_ids'])
        for holiday in holidays:
            if holiday['type_ids'] and (current_session.group_id.type_id.id in holiday['type_ids']):
                future_holidays_of_this_type.append((holiday['date_from'],holiday['date_to']))
        a_week = datetime.timedelta(weeks=1)
        new_date_valid = False
        new_date = last_date + a_week
        while not new_date_valid:
            found_holiday = False
            for holiday in future_holidays_of_this_type:
                cfinalDate = new_date.strftime("%Y-%m-%d")
                if cfinalDate >= holiday[0] and cfinalDate <= holiday[1]:
                    found_holiday = True
                    break
            if not found_holiday:
                new_date_valid = True
            else:
                new_date += a_week
        data['form']['new_date'] = new_date.strftime('%Y-%m-%d')
        return data['form']
    def _report_session(self,cr,uid,data,context):
        if len(data['ids']) > 1:
            data['form']['msg'] = _('You can use this tool on only one session at a given time.\n\nNothing done !')
        else:
            obj_session = pooler.get_pool(cr.dbname).get('cci_club.session')
            current_session = obj_session.browse(cr,uid,data['id'])
            new_date = data['form']['new_date']
            obj_session.write(cr,uid,[data['id']],{'date':new_date,'number':current_session.number + u' reportée'})
            # give the result to the user
            data['form']['msg'] = _('Date changed from %s/%s/%s to %s/%s/%s') % (current_session.date[8:10],current_session.date[5:7],current_session.date[0:4],new_date[8:10],new_date[5:7],new_date[0:4])
        return data['form']

    states = {
        'init': {
            'actions': [_init_date],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('change','Change')]},
        },
        'change': {
            'actions': [_report_session],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
report_session('report_session')
