# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Score Presences">
    <field name="type_id" colspan="4" width="600"/>
    <field name="minimum_sessions"/>
    <newline/>
    <field name="supervisors"/>
</form>"""

fields = {
    'type_id': {'string':'Type of clubs', 'type':'many2one', 'relation':'cci_club.club_type','required':True},
    'minimum_sessions':{'string':'Minimumpast sessions', 'type':'integer'},
    'supervisors':{'string':'Emails supervisors', 'type':'char', 'size':250},
}

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="score_presences.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'score_presences.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class score_presence(wizard.interface):
    def _score_presence(self,cr,uid,data,context):
        lSupervisors = []
        if data['form']['supervisors']:
            names = data['form']['supervisors'].replace(',',';')
            lSupervisors = names.split(';')
        obj_club = pooler.get_pool(cr.dbname).get('cci_club.club')
        filename = obj_club.score_presences(cr,uid,type_ids=[data['form']['type_id']],minimum_sessions=data['form']['minimum_sessions'],supervisor_emails=lSupervisors)
        if filename:
            result_file = open(filename,'rb').read()
            # give the result tos the user
            data['form']['msg']='File created %s' % filename
            data['form']['score_presences.xls']=base64.encodestring(result_file)
        else:
            data['form']['msg'] = _('Nothing created') % filename
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('calculate','Score')]},
        },
        'calculate': {
            'actions': [_score_presence],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
score_presence('score_presence')
