# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
from tools.translate import _
from pyExcelerator import *

form = """<?xml version="1.0"?>
<form string="Score Presences">
    <field name="count_formative" colspan="4" width="600"/>
    <field name="count_responsible" colspan="4"/>
</form>"""

fields = {
    'count_formative': {'string':'Count Formative', 'type':'boolean','default':True},
    'count_responsible': {'string':'Count Responsible', 'type':'boolean','default':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="File has been created."  colspan="4"/>
     <field name="presences_formresp.xls" colspan="4" />
</form>"""

msg_fields = {
    'presences_formresp.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class score_presence_form_and_cci(wizard.interface):
    def _score_presence_form_and_resp(self,cr,uid,data,context):
        if data['form']['count_formative'] or data['form']['responsible']:
            bform = data['form']['count_formative']
            bresp = data['form']['count_responsible']
            filename = 'presences_formresp.xls'
            wb = Workbook()
            ws1 = wb.add_sheet(_('Main Totals'))
            ws1.write(0,0,_('Main Totals'))
            ws1.write(2,0,_('Formatives Presences'))
            ws1.write(3,0,_('Responsible Presences'))
            if bform:
                ws2 = wb.add_sheet(_('Formatives Presences'))
                ws2.write(0,0,_('Club'))
                ws2.write(0,1,_('Name'))
                ws2.write(0,2,_('Date'))
                ws2.write(0,3,_('Presence'))
            if bresp:
                ws3 = wb.add_sheet(_('Responsibles Presences'))
                ws3.write(0,0,_('Club'))
                ws3.write(0,1,_('Name'))
                ws3.write(0,2,_('Date'))
                ws3.write(0,3,_('Presence'))
            ws4 = wb.add_sheet(_('By Clubs'))
            ws4.write(0,0,_('Club'))
            ws4.write(0,1,_('Formative'))
            ws4.write(0,2,_('Responsible'))
            line2 = 1
            line3 = 1
            line4 = 1
            main_form = 0
            main_resp = 0
            club_obj = pooler.get_pool(cr.dbname).get('cci_club.club')
            clubs = club_obj.browse(cr,uid,data['ids'])
            for club in clubs:
                club_form = 0
                club_resp = 0
                for session in club.session_ids:
                    if bform and club.formative_id:
                        ws2.write(line2,0,club.name)
                        ws2.write(line2,1,club.formative_id.name)
                        ws2.write(line2,2,session.date)
                        ws2.write(line2,3,session.presence_formative and 1 or 0)
                        club_form += (session.presence_formative and 1 or 0)
                        line2 += 1
                    if bresp and club.responsible_id:
                        ws3.write(line3,0,club.name)
                        ws3.write(line3,1,club.responsible_id.name)
                        ws3.write(line3,2,session.date)
                        ws3.write(line3,3,session.presence_responsible and 1 or 0)
                        club_resp += (session.presence_formative and 1 or 0)
                        line3 += 1
                ws4.write(line4,0,club.name)
                ws4.write(line4,1,club_form)
                ws4.write(line4,2,club_resp)
                line4 += 1
                main_form += club_form
                main_resp += club_resp
            ws1.write(2,1,main_form)
            ws1.write(3,1,main_resp)
            wb.save(filename)
            result_file = open(filename,'rb').read()
            # give the result tos the user
            data['form']['msg']='File created %s' % filename
            data['form']['presences_formresp.xls']=base64.encodestring(result_file)
        else:
            data['form']['msg'] = _('Nothing created') % filename
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('calculate','Count')]},
        },
        'calculate': {
            'actions': [_score_presence_form_and_resp],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
score_presence_form_and_cci('score_presence_form_and_cci')
