# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2008 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import wizard
import netsvc
import pooler
from tools.translate import _
from osv import fields, osv

form = """<?xml version="1.0"?>
<form string="Send SMS">
    <field name="from_name" colspan="4" width="650"/>
    <field name="to_number" colspan="4"/>
    <field name="message" colspan="4"/>
</form>
"""
fields = {
    'from_name': {'string':'From (useless today)','type':'char','size':14},
    'to_number': {'string':'Mobile Number','type':'char','size':30,'required':True},
    'message': {'string':'Message (160 caracters max today)','type':'text','required':True},
}


msg_form = """<?xml version="1.0"?>
<form string="Result">
    <field name="result" width="650" height="50"/>
</form>
"""
msg_fields = {
      'result': {'string':'Result', 'type':'text', 'readonly':True}
}

def _init_param_form(self,cr,uid,data,context):
    data['form']['from_name'] = 'Mens Sana'
    return data['form']
    
def _sendsms(self, cr, uid, data, context):
    pool = pooler.get_pool(cr.dbname)
    parameter_obj = pool.get('cci_parameters.cci_value')
    param_values = parameter_obj.get_value_from_names(cr,uid,['SMSPlatform'])
    if param_values.has_key('SMSPlatform') and param_values['SMSPlatform']:
        parti_obj = pool.get('cci_club.participation')
        answer = parti_obj.send_sms(data['form']['from_name'] or 'CCILVN', data['form']['to_number'], data['form']['message'],param_values['SMSPlatform'])
        if 'ERROR:' not in answer.upper():
            res_msg = _('SMS has been sent.\n\n%s' % answer)
        else:
            res_msg = _('Houston, we stumble upon a problem !\n\n%s' % answer)
    else:
        res_msg = _('First, you MUST take a contract with a SMS sending platform then parameter it into the ERP.\n\nContact Philmer !')
    return {'result': res_msg}

class send_sms(wizard.interface):
    states = {
        'init' : {
           'actions' : [],
           'result': {'type': 'form', 'arch': form, 'fields': fields, 'state':[('end','Cancel'), ('send','Send')]}
        },
        'send': {
            'actions': [_sendsms],
            'result': {'type':'form', 'arch': msg_form, 'fields': msg_fields, 'state':[('end','Ok')]}
        },
    }
send_sms("send_sms")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
