# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
from pyExcelerator import *
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Participations with a contact not linked to the partner">
    <field name="type_id" colspan="4" width="600"/>
</form>"""

fields = {
    'type_id': {'string':'Type of clubs', 'type':'many2one', 'relation':'cci_club.club_type'},
}

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="wrong_contacts.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'wrong_contacts.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class wrong_contact_participation(wizard.interface):
    def _extract_file(self,cr,uid,data,context):
        wb = Workbook()
        ws1 = wb.add_sheet(_('Participants'))
        ws1.write(0,0,_('ID part'))
        ws1.write(0,1,_('Participant'))
        ws1.write(0,1,_('Company'))
        ws1.write(0,3,_('Club'))
        ws1.write(0,4,_('Club state'))
        ws1.write(0,5,_('Participant state'))
        obj_participation = pooler.get_pool(cr.dbname).get('cci_club.participation')
        obj_club = pooler.get_pool(cr.dbname).get('cci_club.club')
        if data['form']['type_id']:
            club_ids = obj_club.search(cr,uid,[('type_id','=',data['form']['type_id'])])
            participation_ids = obj_participation.search(cr,uid,[('group_id','in',club_ids)])
        else:
            participation_ids = obj_participation.search(cr,uid,[])
        errors = 0
        if participation_ids:
        
            participations = obj_participation.browse(cr,uid,participation_ids)
            for part in participations:
                if part.contact_id and part.partner_id:
                    lFound = False
                    if part.contact_id.job_ids:
                        for job in part.contact_id.job_ids:
                            if job.address_id and job.address_id.partner_id and job.address_id.partner_id.id == part.partner_id.id:
                                lFound = True
                                break
                    if not lFound:
                        errors += 1
                        ws1.write(errors,0,part.id)
                        ws1.write(errors,1,part.contact_id.name + ' ' + ( part.contact_id.first_name or '' ))
                        ws1.write(errors,2,part.partner_id.name)
                        ws1.write(errors,3,part.group_id.name)
                        ws1.write(errors,4,part.group_id.state)
                        ws1.write(errors,5,part.state_id.name)
        wb.save('wrong_contacts.xls')
        result_file = open('wrong_contacts.xls','rb').read()

        # give the result to the user
        data['form']['msg']=_('%i errors detected.\n\nSave the File with '".xls"' extension.') % errors
        data['form']['wrong_contacts.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('extract','Search Errors')]},
        },
        'extract': {
            'actions': [_extract_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
wrong_contact_participation('wrong_contact_participation')
