# -*- coding: utf-8 -*-
##############################################################################
#    
#    Copyright (c) 2009 CCI  ASBL. (<http://www.ccilconnect.be>).
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields, osv
import datetime

class cci_email_template(osv.osv):
    _name = "cci_email_template"
    _description = "Template for emails"
    _columns = {
        'name': fields.char('Name', required=True, size=64),
        'model_id': fields.many2one('ir.model','Model',required=True),
        'type': fields.selection([('html','HTML'),('plain','Plain Text')],'Type',required=True),
        'subject': fields.char('Subject',size=250,required=True),
        'body': fields.text('Body',required=True),
        'desc': fields.text('Description'),
    }
cci_email_template()

class cci_email_sended(osv.osv):
    _name = 'cci_email_sended'
    _description = 'recording of a mail sended'
    _columns = {
        'name':fields.char('Name',size=200,required=True),
        'subject':fields.char('Subject',size=250),
        'body':fields.text('Body'),
        'ressource':fields.char('Linked Ressource',size=200),
        'sended_time':fields.datetime('Sending Time'),
        'addr_from':fields.char('From',size=200),
        'addrs_to':fields.text('To'),
        'bcc':fields.text('BCC'),
    }
    _defaults = {
        'sended_time': lambda *a: datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")
    }
    _order = "sended_time desc"
cci_email_sended()

