# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import tools

form = """<?xml version="1.0"?>
<form string="Send Test Email">
     <field name="subject" colspan="4" nolabel="1" width="600"/>
     <field name="addr_from"/>
     <field name="addrs_to"/>
</form>"""

fields = {
    'subject': {'string':'Subject','type':'char','size':120,'required':True},
    'addr_from': {'string':'From','type':'char','size':200,'required':True},
    'addrs_to': {'string':'To','type':'char','size':200,'required':True,'help':'Accept \',\' , \';\' or spaces as separator'},
}
msg_form = """<?xml version="1.0"?>
<form string="Manual Sended Email">
     <field name="msg" colspan="4" nolabel="1" width="600"/>
</form>"""

msg_fields = {
    'msg': {'string':'Finish', 'type':'text', 'size':'100','readonly':True},
}

class manual_send(wizard.interface):
    def _init(self,cr,uid,data,context):
        obj_template = pooler.get_pool(cr.dbname).get('cci_email_template')
        current = obj_template.browse(cr,uid,data['id'])
        data['form']['subject'] = current.subject
        return data['form']
    def _send(self,cr,uid,data,context):
        obj_template = pooler.get_pool(cr.dbname).get('cci_email_template')
        current = obj_template.browse(cr,uid,data['id'])
        if ',' in data['form']['addrs_to']:
            sending_addresses = [x.strip() for x in data['form']['addrs_to'].split(',')]
        elif ';' in data['form']['addrs_to']:
            sending_addresses = [x.strip() for x in data['form']['addrs_to'].split(';')]
        elif ' ' in data['form']['addrs_to']:
            temp = data['form']['addrs_to']
            while '  ' in temp:
                temp = temp.replace('  ',' ')
            sending_addresses = [x.strip() for x in temp.split(' ')]
        else:
            sending_addresses = [data['form']['addrs_to'],]
        parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['BDDeTest'])
        if param_values.has_key('BDDeTest'):
            bddetest = param_values['BDDeTest']
        else:
            bddetest = True
        if bddetest:
            print 'mocked email send'
            print 'From : \'%s\'' % data['form']['addr_from']
            print 'To : [\'%s\']' % "', '".join(sending_addresses)
            print 'Subject : %s' % data['form']['subject']
            print 'Body :\n%s' % current.body
        else:
            tools.email_send(data['form']['addr_from'], sending_addresses, data['form']['subject'], current.body, subtype=current.type)
        data['form']['msg'] = 'The mail is sended'
        return data['form']

    states = {
        'init': {
            'actions': [_init],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('send','Send Test Email')]},
        },
        'send': {
            'actions' : [_send],
            'result' : {'type' : 'form','arch': msg_form,'fields' : msg_fields,'state' : [('end','Close')],}
        }
    }
manual_send('manual_send')
