# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import tools

form = """<?xml version="1.0"?>
<form string="Resend already sended email">
     <field name="addr_from" colspan="4" width="600"/>
     <field name="addrs_to"/>
     <newline/>
     <field name="record"/>
</form>"""

fields = {
    'subject': {'string':'Subject','type':'char','size':120,'required':True},
    'addr_from': {'string':'From','type':'char','size':200,'required':True},
    'addrs_to': {'string':'To','type':'char','size':200,'required':True,'help':'Accept \',\' , \';\' or spaces as separator'},
    'record': {'string':'Record this one','type':'boolean','help':'If checked, will record this new sending as a new sended message'},
}
msg_form = """<?xml version="1.0"?>
<form string="Resend already sended email">
     <field name="msg" colspan="4" nolabel="1" width="600"/>
</form>"""

msg_fields = {
    'msg': {'string':'Finish', 'type':'text', 'size':'100','readonly':True},
}

class sended_resend(wizard.interface):
    def _init(self,cr,uid,data,context):
        obj_sended_email = pooler.get_pool(cr.dbname).get('cci_email_sended')
        current = obj_sended_email.read(cr,uid,[data['id'],],['addr_from','addrs_to','subject','body'])[0]
        data['form']['addr_from'] = current['addr_from'] or ''
        current_to = current['addrs_to'] or ''
        if current_to and current_to[0] == '[':
            current_to = current_to[1:]
        if current_to and current_to[-1] == ']':
            current_to = current_to[0:-1]
        if current_to and current_to[-1] == ',':
            current_to = current_to[0:-1]
        data['form']['addrs_to'] = current_to
        data['form']['subject'] = current['subject'] or ''
        return data['form']
    def _send(self,cr,uid,data,context):
        obj_sended = pooler.get_pool(cr.dbname).get('cci_email_sended')
        current = obj_sended.read(cr,uid,[data['id'],],['addr_from','addrs_to','subject','body','name','ressource'])[0]
        if data['form']['addr_from']:
            from_addr = data['form']['addr_from']
        else:
            from_addr = current['addr_from']
        if data['form']['addrs_to']:
            if ',' in data['form']['addrs_to']:
                sending_addresses = [x.strip() for x in data['form']['addrs_to'].split(',')]
            elif ';' in data['form']['addrs_to']:
                sending_addresses = [x.strip() for x in data['form']['addrs_to'].split(';')]
            elif ' ' in data['form']['addrs_to']:
                temp = data['form']['addrs_to']
                while '  ' in temp:
                    temp = temp.replace('  ',' ')
                sending_addresses = [x.strip() for x in temp.split(' ')]
            else:
                sending_addresses = [data['form']['addrs_to'],]
        else:
            sending_addresses = eval(current['addrs_to'])
        if data['form']['subject']:
            subject = data['form']['subject']
        else:
            subject = current['subject']
        parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['BDDeTest'])
        if param_values.has_key('BDDeTest'):
            bddetest = param_values['BDDeTest']
        else:
            bddetest = False
        if bddetest:
            print 'mocked email send'
            print 'From : \'%s\'' % data['form']['addr_from']
            print 'To : [\'%s\']' % "', '".join(sending_addresses)
            print 'Subject : %s' % data['form']['subject']
            print 'Body :\n%s' % current['body']
        else:
            tools.email_send(from_addr, sending_addresses, current['subject'], current['body'], subtype='html')
        if data['form']['record']:
            pooler.get_pool(cr.dbname).get('cci_email_sended').create(cr,uid,{'name':current['name']+' (resend)',
                                                                              'subject':subject,
                                                                              'body':current['body'],
                                                                              'ressource':current['ressource'],
                                                                              'from':from_addr,
                                                                              'to':'['+','.join(sending_addresses)+']',
                                                                             })
        data['form']['msg'] = 'The mail is sended'
        return data['form']

    states = {
        'init': {
            'actions': [_init],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('send','Send Test Email')]},
        },
        'send': {
            'actions' : [_send],
            'result' : {'type' : 'form','arch': msg_form,'fields' : msg_fields,'state' : [('end','Close')],}
        }
    }
sended_resend('sended_resend')
