# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2008 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv
from osv import orm
import netsvc
import pooler
import time
import tools
import re
from tools.translate import _
import urllib
import urllib2
from lxml import etree
from lxml import objectify        
import pymysql
import datetime
from pyExcelerator import *

def correct_phone(string):
    if 'conf' not in string:
        result = string.replace(' ','').replace('/','').replace('.','').replace('-','').replace('+','00')
    else:
        result = ''
    return result

def clean_email_addr(string):
    return string.replace('\n','').replace('\r','').replace('\t','')

def add_working_days(origin_date,days_to_add):
    # add x working days to a date to obtain a new date
    result_date = origin_date
    sign = 1
    if days_to_add <= 0:
        sign = -1
    left_days = abs(days_to_add)
    while left_days > 0:
        result_date = result_date + datetime.timedelta(days=sign)
        if result_date.weekday() < 5:
            left_days += -1
    return result_date

class event(osv.osv):
    _inherit="event.event"
    _name="event.event"
    _description="event.event"
    _columns={'site_id': fields.integer('ID on WebSite'),
              'sended_before': fields.datetime('Automatic Sending before'),
              'sended_after': fields.datetime('Automatic Sending After'),
              'subject_register': fields.char('Subject Registration Mail',size=128),
              'subject_confirm': fields.char('Subject Confirmation Mail',size=128),
              'members_after_mail_template_id': fields.many2one('cci_email_template','Mail for members after the event',help='Template of mail to send to members after the event'),
              'nonmembers_after_mail_template_id': fields.many2one('cci_email_template','Mail for non-members after the event',help='Template of mail to send to non-members after the event'),
              'members_sended_after': fields.datetime('Automatic Sending to Members after event'),
              'nonmembers_sended_after': fields.datetime('Automatic Sending to Non-Members after event'),
             }
    def copy(self, cr, uid, id, default=None, context=None):
        if not default:
            default = {}
        default.update({
            'code': self.pool.get('ir.sequence').get(cr, uid, 'event.event'),
            'state': 'draft',
        })
        new_id = super(event, self).copy(cr, uid,id, default, context)
        self.write(cr,uid,[new_id], {'site_id':False} )
        return new_id
    def _update_from_website(self,cr,uid,address):
        #address="http://www.ccilvn.be/fr/feed?post_type=event"
        # Start log
        cronline_id = self.pool.get('cci_logs.cron_line')._start(cr,uid,'EventsUpdateFromSite')
        final_result = True
        try:
            request = urllib2.Request(address, headers={'User-Agent' : "Magic Browser"})
            atomDoc = urllib2.urlopen(request)
        except Exception, err:
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'Erreur de lecture du flux - ' + str(err) )
            final_result = False
        if final_result:
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,u'Flux lu\n' )
            analytic_default_obj = self.pool.get('account.analytic.default')
            event_obj = self.pool.get('event.event')
            parameter_obj = self.pool.get('cci_parameters.cci_value')
            param_values = parameter_obj.get_value_from_names(cr,uid,['EventDefaultProductID','EventImportManagers','BDDeTest'])
            if param_values.has_key('EventDefaultProductID'):
                default_product_id = param_values['EventDefaultProductID']
            else:
                default_product_id = 0
            if param_values.has_key('EventImportManagers'):
                email_managers = param_values['EventImportManagers']
            else:
                email_managers = []
            BD_DE_TEST = True
            if param_values.has_key('BDDeTest'):
                if param_values['BDDeTest'] == 0:
                    BD_DE_TEST = False
            #
            valid_types = []
            #
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,u'Before read\n' )
            xml_content = atomDoc.read()
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,u'Before etree.xml\n' )
            root = etree.XML(xml_content)
            for item in root.iter('item'):
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,u'Item read\n' )
                type_name = ''
                event_name = ''
                resp_email = ''
                date_debut = ''
                heure_debut = ''
                heure_fin = ''
                prix_membre = 0.0
                prix_nmembre = 0.0
                id_on_site = 0
                event_errors = []
                for element in item.iter():
                    if element.tag == 'produitRelatif':
                        type_name = element.text or ''
                    elif element.tag == 'title':
                        event_name = element.text.strip()
                    elif element.tag == 'contact0':
                        for element in element.iter():
                            if element.tag == 'contactEmail':
                                resp_email = element.text.strip()
                    elif element.tag == 'id':
                        id_on_site = int(element.text)
                    elif element.tag == 'dateDebut':
                        date_debut = element.text
                    elif element.tag == 'heureDebut':
                        heure_debut = element.text
                    elif element.tag == 'heureFin':
                        heure_fin = element.text
                    elif element.tag == 'tarifMembres':
                        prix_membre = float(element.text)
                    elif element.tag == 'tarifNonMembres':
                        prix_nmembre = float(element.text)
                if type_name not in valid_types:
                    valid_types.append(type_name)
                if event_name and date_debut and id_on_site:
                    if id_on_site >= 81000:
                        type_name = type_name.replace(u'’',u"'")
                        event_data = {}
                        event_data['state'] = 'draft'
                        event_data['active'] = True
                        event_data['site_id'] = id_on_site
                        event_data['name_on_site'] = event_name
                        event_data['name'] = event_name ## will be replaced if we found an event.type and this event.type has an name_template value
                        event_data['reply_to'] = resp_email
                        event_data['date_begin'] = date_debut[0:4]+'-'+date_debut[4:6]+'-'+date_debut[6:]
                        event_data['date_end'] = event_data['date_begin']
                        if heure_debut:
                            if 'h' in heure_debut.lower():
                                elements = heure_debut.lower().split('h')
                            else:
                                elements = heure_debut.split(':')
                            if len(elements)>1:
                                event_data['date_begin'] += ' '+elements[0].rjust(2,'0')[0:2]+':'+elements[1].rjust(2,'0')[0:2]+':00'
                            else:
                                event_data['date_begin'] += ' '+elements[0].rjust(2,'0')[0:2]+':00:00'
                        else:
                            event_data['date_begin'] += ' 00:00:00'
                        if heure_fin:
                            if 'h' in heure_fin.lower():
                                elements = heure_fin.lower().split('h')
                            else:
                                elements = heure_fin.split(':')
                            if len(elements)>1:
                                event_data['date_end'] += ' '+elements[0].rjust(2,'0')[0:2]+':'+elements[1].rjust(2,'0')[0:2]+':00'
                            else:
                                event_data['date_end'] += ' '+elements[0].rjust(2,'0')[0:2]+':00:00'
                        else:
                            event_data['date_end'] += ' 00:00:00'
                        # we check if this event already exists in the ERP, to not create product for an already created event
                        current_id = 0
                        event_ids = event_obj.search(cr,uid,[('site_id','=',id_on_site)])
                        if event_ids and len(event_ids) == 1:
                            current_id = event_ids[0]
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,u'Before type creation\n' )
                        if type_name and not current_id:
                            type_ids = self.pool.get('event.type').search(cr,uid,[('name_on_site','ilike',type_name)])
                            if type_ids:
                                event_type = self.pool.get('event.type').browse(cr,uid,[type_ids[0]])[0]
                                if event_type.default_auto_register:
                                    event_data['mail_auto_registr'] = event_type.default_auto_register
                                if event_type.default_msg_register:
                                    event_data['mail_registr'] = event_type.default_msg_register
                                if event_type.default_auto_confirm:
                                    event_data['mail_auto_confirm'] = event_type.default_auto_confirm
                                if event_type.default_msg_confirm:
                                    event_data['mail_confirm'] = event_type.default_msg_confirm
                                if event_type.name_template:
                                    event_data['name'] = event_type.name_template.replace('{PERSO Date}',date_debut).replace('{PERSO Nom}',event_name)
                                if not resp_email and event_type.user_id and event_type.user_id.email:
                                    resp_email = event_type.user_id.email.strip()
                                    event_data['reply_to'] = resp_email
                                if event_type.product_id:
                                    product_name = event_data['name']
                                    if event_type.product_name_template:
                                        product_name = event_type.product_name_template.replace('{PERSO Date}',date_debut).replace('{PERSO Nom}',event_name).replace('{PERSO FRDate}',date_debut[6:8]+'/'+date_debut[4:6]+'/'+date_debut[0:4]).replace('{PERSO FRMois}',date_debut[6:8]+'/'+date_debut[4:6])
                                    prod_obj = self.pool.get('product.product')
                                    new_product_id = prod_obj.copy(cr,uid,event_type.product_id.id,{'name':product_name,'list_price':prix_nmembre,'member_price':prix_membre})
                                    prod_obj.write(cr,uid,[new_product_id],{'name':product_name},{'lang':'de_DE'})
                                    prod_obj.write(cr,uid,[new_product_id],{'name':product_name},{'lang':'nl_NL'})
                                    prod_obj.write(cr,uid,[new_product_id],{'name':product_name},{'lang':'fr_FR'})
                                    prod_obj.write(cr,uid,[new_product_id],{'name':product_name},{'lang':'fr_BE'})
                                    event_data['product_id'] = new_product_id
                                    # copy also the account.analytic.default linked to the original product
                                    adef_ids = analytic_default_obj.search(cr,uid,[('product_id','=',event_type.product_id.id)])
                                    if adef_ids:
                                        if len(adef_ids) > 1:
                                            event_errors.append(_(u'The product linked to the type of event has more than one analytic default value => only the first one has been used.'))
                                        analytic_default_obj.copy(cr,uid,adef_ids[0],{'product_id':new_product_id})
                                    else:
                                        event_errors.append(_(u'The product linked to the type of event has no analytic default.'))
                                event_data['type'] = event_type.id
                            else:
                                event_errors.append(_(u'Not possible to find the type of event => no default values for this event.ņ'))
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,_(u'\nPas possible de retrouver le type de l\'event \'%s\' [%s] : %s') % (event_name,str(id_on_site),type_name) )
                                type_ids = self.pool.get('event.type').search(cr,uid,[])
                                types = self.pool.get('event.type').read(cr,uid,type_ids,['name_on_site'])
                                for type_event in types:
                                    if type_event['name_on_site']:
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,_(u'\n\t-> Type \'%s\' != \'%s\'.') % (type_event['name_on_site'],type_name) )
                                final_result = False
                        else:
                            if not current_id:
                                event_errors.append(_(u'Not possible to find the type of event => no default values for this event.ņ'))
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,_(u'\nPas possible de retrouver le type de l\'event \'%s\' [%s]') % (event_name,str(id_on_site)) )
                                final_result = False
                        if resp_email and event_data['date_begin'] > datetime.datetime.today().strftime('%Y-%m-%d'):
                            user_ids = self.pool.get('res.users').search(cr,uid,[('email','=',resp_email)])
                            if user_ids:
                                event_data['user_id'] = user_ids[0]
                            else:
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,_(u'\nPas possible de retrouver le responsable de l\'event \'%s\' [%s]') % (event_name,str(id_on_site)) )
                                final_result = False
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,_(u'\n---------------\nEvent [%s] "%s" sur site - ERP [%s]') % (str(id_on_site),event_name,str(current_id)) )
                        if current_id:
                            # this event is already in the ERP => just check if data have changed on site
                            event = event_obj.browse(cr,uid,[current_id])[0]
                            if event_data.has_key('reply_to') and event_data['reply_to'] and event_data['reply_to'] != event.reply_to:
                                event_errors.append(_(u'Modified Reply To ? %s on site -> %s in OpenERP') % (event_data['reply_to'],event.reply_to or ''))
                            if event_data.has_key('date_begin') and event_data['date_begin'] != event.date_begin:
                                event_errors.append(_(u'Modified Date Begin ? %s on site -> %s in OpenERP') % (event_data['date_begin'],event.date_begin or ''))
                            if event_data.has_key('date_end') and event_data['date_end'] != event.date_end:
                                event_errors.append(_(u'Modified Date End ? %s on site -> %s in OpenERP') % (event_data['date_end'],event.date_end or ''))
                        else:
                            if not event_data.has_key('product_id') and default_product_id:
                                new_product_id = self.pool.get('product.product').copy(cr,uid,default_product_id,{'name':event_data['name'],'list_price':prix_nmembre,'member_price':prix_membre})
                                event_data['product_id'] = new_product_id
                                # copy also the account.analytic.default linked to the original product
                                adef_ids = analytic_default_obj.search(cr,uid,[('product_id','=',default_product_id)])
                                if adef_ids:
                                    if len(adef_ids) > 1:
                                        event_errors.append(_(u'The product linked to the type of event has more than one analytic default value => only the first one has been used.'))
                                    analytic_default_obj.copy(cr,uid,adef_ids[0],{'product_id':new_product_id})
                                else:
                                    event_errors.append(_(u'The product linked to the type of event has no analytic default.'))
                            if event_data.has_key('product_id'):
                                # create this event in the ERP
                                self.pool.get('event.event').create(cr,uid,event_data)
                            else:
                                event_errors.append(_(u'no creation because no product id'))
                        if event_errors:
                            # there is some errors on the current event => sending an warning email to DefaultManagers and current event's responsible
                            email_title = _(u"Warning ! Import Event '%s' from WebSite [%s]") % (event_name,str(id_on_site))
                            email_content = _(u'<html><body>This event has some possible problems to check ASAP :<ul><li>%s</li></ul></body></html>') % '</li><li>'.join(event_errors)
                            email_dest = [x for x in email_managers]
                            if resp_email and resp_email not in email_dest:
                                email_dest.append(resp_email)
                            if email_dest:
                                if BD_DE_TEST:
                                    print 'email sended'
                                else:
                                    tools.email_send(email_dest[0], email_dest, email_title, email_content, subtype='html')
                    else:
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,_(u'\nVieil event \'%s\' [%s]') % (event_name,str(id_on_site)) )
                else:
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,_(u'\nPas assez de données pour créer l\'event \'%s\' [%s]') % (event_name,str(id_on_site)) )
                    final_result = False
        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,_('\n\n----------\nOriginal content:\n'))
        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,xml_content.decode('utf-8'))
        self.pool.get('cci_logs.cron_line')._stop(cr,uid,cronline_id,final_result,'\n---end---')
        return True
    def convert_old_sector_ids_to_new_ids(self,cr,uid,dSectCode2ID):
        dResult = {}
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['ActivityCodeRootID'])
        if param_values.has_key('ActivityCodeRootID'):
            activityCodeRootID = param_values['ActivityCodeRootID']
            obj_categ = self.pool.get('res.partner.category')
            old_len = 0
            categ_ids = [ activityCodeRootID ]
            while len(categ_ids) > old_len:
                new_ids = categ_ids[old_len:] # ids of categories added last time
                old_len = len(categ_ids) # the new frontier ...
                new_categs = obj_categ.read(cr,uid,new_ids,['child_ids'])
                for categ in new_categs:
                    if categ['child_ids']:
                        categ_ids.extend(categ['child_ids'])
            categs = obj_categ.read(cr,uid,categ_ids,['name'],{'lang':'fr_FR'})
            dCategs = {}
            for categ in categs:
                formated_name = categ['name']
                posA = formated_name.rfind('[')
                posB = formated_name.rfind(']')
                if posA >= 0 and posB > 0 and posA < posB:
                    code = formated_name[posA+1:posB]
                    if dSectCode2ID.has_key(code):
                        dResult[categ['id']] = dSectCode2ID[code]
        return (dResult,categ_ids)
    def _export_popup(self,cr,uid,**args):
        # Start log
        cronline_id = self.pool.get('cci_logs.cron_line')._start(cr,uid,'PopupExport')
        final_result = True
        test = False
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['PopupEventsList','PopupExportSupervisors','PopupConnectionDict','CompanyFacebookURL','CompanyLinkedInURL','CompanyTwitterURL','PopupTest','BDDeTest'])
        if param_values.has_key('PopupEventsList') and param_values.has_key('PopupExportSupervisors') and param_values.has_key('PopupConnectionDict'):
            events = param_values['PopupEventsList'] # ((154,1,2,4,0),(155,3,0,0),(156,2,3,10)) for example with 154 = event_id and 1 = type_stand in stand; 2 = max_part_expor for this type of stand; 4 = max_part_invit for this type of stand; 0 = screen (if 1) or not
            supervisor_emails = param_values['PopupExportSupervisors'] # list of emails
            connection = param_values['PopupConnectionDict']
            BD_DE_TEST = True
            if param_values.has_key('BDDeTest'):
                if param_values['BDDeTest'] == 0:
                    BD_DE_TEST = False
            if param_values.has_key('CompanyFacebookURL'):
                question_fb_id = param_values['CompanyFacebookURL']
            else:
                question_fb_id = False
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nATTENTION pas de question ID sur Facebook définie' )
            if param_values.has_key('CompanyLinkedInURL'):
                question_li_id = param_values['CompanyLinkedInURL']
            else:
                question_li_id = False
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nATTENTION pas de question ID sur LinkedIn définie' )
            if param_values.has_key('CompanyTwitterURL'):
                question_tw_id = param_values['CompanyTwitterURL']
            else:
                question_tw_id = False
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nATTENTION pas de question ID sur Twitter définie' )
            if param_values.has_key('PopupTest'):
                test = param_values['PopupTest']
            nom_table_secteur = test and 'secteurs_test' or 'secteurs'
            nom_table_stand = test and 'stand_test' or 'stand'
            #
            function_categs = [('G',u'DIRECTION GÉNÉRALE'),('$',u'DIRECTION GÉNÉRALE'),('K',u'DIRECTION'),('D',u'DIRECTION'),
                               ('B',u'ADMINISTRATIF ET FINANCIER'),('F',u'ADMINISTRATIF ET FINANCIER'),('J',u'ADMINISTRATIF ET FINANCIER'),
                               ('A',u'ACHAT'),('M',u'MARKETING ET COMMERCIAL'),('C',u'MARKETING ET COMMERCIAL'),
                               ('U',u'COMMUNICATION'),('P',u'COMMUNICATION'),('R',u'COMMUNICATION'),('E',u'RH'),
                               ('I',u'IT'),('O',u'TECHNIQUE'),('Q',u'TECHNIQUE'),('T',u'TECHNIQUE'),
                               ('S',u'SECRETARIAT'),('Z',u'LOGISTIQUE')]
            undefined_categ = u'Autres'
            # Connection to the external db
            try:
                con = pymysql.connect(host=connection['host'], port=connection['port'], user=connection['user'], passwd=connection['pw'], db=connection['db']);
                cur = con.cursor()
            except pymysql.err.Error, e:
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'Connection Error %d: %s' % (e.args[0],e.args[1]))
                final_result = False
                if cur:
                    cur.close()
                if con:
                    con.close()
            if final_result:
                changes = False
                email_problems = []
                # 1. Synchronise the secteur table and keep mysql-ids
                sector_obj = self.pool.get('res.partner.activsector')
                sector_ids = sector_obj.search(cr,uid,[])
                sectors = sector_obj.read(cr,uid,sector_ids,['id','name','code'],{'lang':'fr_FR'})
                try:
                    sentence = "SELECT code, denomination, id FROM `%s`" % nom_table_secteur
                    cur.execute(sentence)
                except pymysql.err.Error, e:
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'Connection Error %d: %s' % (e.args[0],e.args[1]))
                    final_result = False
                data = cur.fetchall()
                dSectors = {}
                dSectCode2ID = {} # usefull to res.partner.category->id to res.partner.activsector->id
                for line in data:
                    dSectors[line[0]] = {'id':line[2],'denomination':line[1]}
                    dSectCode2ID[line[0]] = line[2]
                # Table to convert res.partner.category->id to res.partner.activsector->id
                (dOldSect2New,old_categ_ids) = self.convert_old_sector_ids_to_new_ids(cr,uid,dSectCode2ID) # table to convert id from res.partner_category to id in res.partner.activsector AND list of valid res.partner.category ids
                #
                dSectID_ERP_MYSQL = {}
                dSectCode_MYSQL = {}
                for sector in sectors:
                    if not dSectors.has_key(sector['code']):
                        sentence = "INSERT INTO `%s` ( code, denomination ) VALUES ( '%s', '%s')" % (nom_table_secteur,sector['code'],sector['name'].replace("'","''").replace("\\","\\\\"))
                        cur.execute(sentence)
                        new_id = cur.lastrowid
                        if new_id > 0:
                            changes = True
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nInsertion du secteur %s reussie -> %s' % (str(sector['id']),str(new_id)) )
                            dSectID_ERP_MYSQL[sector['id']] = new_id
                        else:
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nInsertion du secteur %s ratee' % str(sector['id']) )
                    else:
                        dSectID_ERP_MYSQL[sector['id']] = dSectors[sector['code']]['id']
                        if dSectors[sector['code']]['denomination'].decode('iso-8859-1') != sector['name']:
                            sentence = u"UPDATE `%s` SET denomination = '%s' WHERE code = '%s'" % (nom_table_secteur,sector['name'].replace("'","''").replace("\\","\\\\"),sector['code'])
                            cur.execute(sentence)
                            changes = True
                            #self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nMise à jour du secteur [%s] reussie -> %s' % (str(dSectors[sector['code']]['id']),sector['name']) )
                if cur:
                    con.commit()
                    cur.close()
                # 2. Synchronise to MYSQL the events definies as popup recordings
                #TEMP
                #updates = []
                mySQL_reg_ids =  []
                cur = con.cursor()
                try:
                    sentence = "SELECT id_stand, erp_reg_id FROM `%s`" % nom_table_stand
                    cur.execute(sentence)
                except pymysql.err.Error, e:
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'Connection Error %d: %s' % (e.args[0],e.args[1]))
                    final_result = False
                data = cur.fetchall()
                dExistingStands = {}
                for line in data:
                    dExistingStands[line[1]] = line[0]
                    if line[1] and line[1] > 0:
                        mySQL_reg_ids.append(line[1])
                reg_obj = self.pool.get('event.registration')
                current_registration_ids = []
                for concerned_event in events:
                    event_id = concerned_event[0]
                    type_stand = concerned_event[1]
                    default_max_part_expo = concerned_event[2]
                    default_max_part_invit = concerned_event[3]
                    default_screen = concerned_event[4]
                    reg_ids = reg_obj.search(cr,uid,[('event_id','=',event_id),('state','in',['open','done'])])
                    if reg_ids:
                        current_registration_ids.extend(reg_ids)
                        regs = reg_obj.browse(cr,uid,reg_ids,{'lang':'fr_FR'})
                        for reg in regs:
                            if not dExistingStands.has_key(reg.id):
                                # new registration to insert into mysql
                                if reg.contact_id and reg.partner_id:
                                    # search for the address and the job that links the reg.partner_id and reg.contact_id
                                    job = False
                                    current_sequence_contact = 999
                                    if reg.contact_id.job_ids:
                                        for possible_job in reg.contact_id.job_ids:
                                            if possible_job.address_id and possible_job.address_id.partner_id and possible_job.address_id.partner_id.id == reg.partner_id.id:
                                                if possible_job.sequence_contact < current_sequence_contact:
                                                    job = possible_job
                                    if job:
                                        address = job.address_id
                                        partner = address.partner_id
                                        contact = reg.contact_id
                                        if reg.badge_partner:
                                            partner_full_name = reg.badge_partner
                                        else:
                                            if address.name:
                                                if address.name[0:3] == ' - ':
                                                    partner_full_name = partner.name + address.name
                                                elif address.name[0:2] == '- ':
                                                    partner_full_name = partner.name + ' ' + address.name
                                                else:
                                                    partner_full_name = address.name
                                            else:
                                                partner_full_name = partner.name
                                        addr_fb = ''
                                        if question_fb_id:
                                            for answer in partner.answers_ids:
                                                if answer.question_id.id == question_fb_id:
                                                    addr_fb = answer.text or ''
                                        addr_li = ''
                                        if question_li_id:
                                            for answer in partner.answers_ids:
                                                if answer.question_id.id == question_li_id:
                                                    addr_li = answer.text or ''
                                        addr_tw = ''
                                        if question_tw_id:
                                            for answer in partner.answers_ids:
                                                if answer.question_id.id == question_tw_id:
                                                    addr_tw = answer.text or ''
                                        sector1 = 0
                                        sector2 = 0
                                        sector3 = 0
                                        if address.sector1:
                                            # we take the sectors from the address
                                            if dSectID_ERP_MYSQL.has_key(address.sector1.id):
                                                sector1 = dSectID_ERP_MYSQL[address.sector1.id]
                                            if address.sector2 and dSectID_ERP_MYSQL.has_key(address.sector2.id):
                                                sector2 = dSectID_ERP_MYSQL[address.sector2.id]
                                            if address.sector3 and dSectID_ERP_MYSQL.has_key(address.sector3.id):
                                                sector3 = dSectID_ERP_MYSQL[address.sector3.id]
                                        else:
                                            # we get them from the partner's categories
                                            new_sector_ids = []
                                            for category in partner.category_id:
                                                categ_id = category.id
                                                if categ_id in old_categ_ids and dOldSect2New.has_key(categ_id):
                                                    new_sector_ids.append(dOldSect2New[categ_id])
                                            if len(new_sector_ids) > 0:
                                                sector1 = new_sector_ids[0]
                                                if len(new_sector_ids) > 1:
                                                    sector2 = new_sector_ids[1]
                                                    if len(new_sector_ids) > 2:
                                                        sector3 = new_sector_ids[2]
                                        zip_code = address.zip_id and address.zip_id.name or ''
                                        if len(zip_code) > 12:
                                            zip_code = '0'
                                        user_phone = ''
                                        user_mobile = ''
                                        if job.phone and not 'conf' in job.phone:
                                            user_phone = job.phone
                                        if contact.mobile and not 'conf' in contact.mobile:
                                            user_mobile = contact.mobile
                                        function_categ = ''
                                        this_job_code_labels = (job.function_code_label or '')
                                        for (letter,fcateg) in function_categs:
                                            if letter in this_job_code_labels:
                                                function_categ = fcateg
                                                break
                                        if not function_categ:
                                            function_categ = undefined_categ
                                        sentence = """INSERT INTO `%s` ( user_level, user_mail, user_mdp, user_civ, user_nom, user_prenom, user_fonction, user_fonction_plus, user_tel, user_gsm, 
                                                          part_tva, part_nom, part_adresse, part_adresse_plus, part_adresse_cp, part_adresse_loca, part_adresse_pays, part_tel, part_email, 
                                                          part_site, part_linkedin, part_facebook, part_twitter, part_description, part_logo, part_s1, part_s2, part_s3, erp_partner_id, erp_reg_id, erp_type_stand, erp_adresse_id, 
                                                          erp_effectif_tot, max_part_expo, max_part_invit, last_action, stand_pos1, stand_pos2, stand_pos3, actif, screen ) 
                                                      VALUES ( 0, '%s', '', '%s', '%s', '%s', '%s', '%s', '%s', '%s',
                                                               '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s',
                                                               '%s', '%s', '%s', '%s', '%s', '%s', %i, %i, %i, %i, %i, %i, %i, 
                                                               %s, %i, %i, 0, '', '', '', 0, %i )""" % ( nom_table_stand, 
                                                                                     reg.email_from or '',
                                                                                     (contact.title or '').replace("'","''").replace("\\","\\\\"),
                                                                                     (contact.name or '').replace("'","''").replace("\\","\\\\"),
                                                                                     (contact.first_name or '').replace("'","''").replace("\\","\\\\"),
                                                                                     (function_categ).replace("'","''").replace("\\","\\\\"),
                                                                                     (reg.badge_title or job.function_label or '').replace("'","''").replace("\\","\\\\"),
                                                                                     user_phone,
                                                                                     user_mobile,
                                                                                     partner.vat or '',
                                                                                     (partner_full_name).replace("'","''").replace("\\","\\\\"),
                                                                                     (address.street or '').replace("'","''").replace("\\","\\\\"),
                                                                                     (address.street2 or '').replace("'","''").replace("\\","\\\\"),
                                                                                     zip_code,
                                                                                     (address.zip_id and address.zip_id.city or '').replace("'","''").replace("\\","\\\\"),
                                                                                     (address.country_id and address.country_id.name or 'Belgique'),
                                                                                     (correct_phone(address.phone or '')).replace("'","''").replace("\\","\\\\"),
                                                                                     (address.email or '').replace("'","''").replace("\\","\\\\"),
                                                                                     (partner.website or '').replace("'","''").replace("\\","\\\\"),
                                                                                     (addr_li).replace("'","''").replace("\\","\\\\"),
                                                                                     (addr_fb).replace("'","''").replace("\\","\\\\"),
                                                                                     (addr_tw).replace("'","''").replace("\\","\\\\"),
                                                                                     (address.activity_description or partner.activity_description or '').replace(u"’","'").replace("'","''").replace("\\","\\\\").replace(u'€','euros'),
                                                                                     '',
                                                                                     sector1,
                                                                                     sector2,
                                                                                     sector3,
                                                                                     partner.id,
                                                                                     reg.id,
                                                                                     type_stand,
                                                                                     address.id,
                                                                                     str(partner.employee_nbr_total or 0),
                                                                                     default_max_part_expo,
                                                                                     default_max_part_invit,
                                                                                     default_screen)
                                                                                     # 
                                        final_result = True
                                        try:
                                            cur.execute(sentence)
                                            changes = True
                                        except pymysql.err.Error, e:
                                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nConnection Error %d: %s' % (e.args[0],e.args[1]))
                                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n' + sentence )
                                            final_result = False
                                        except:
                                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSouci lors de l''ajout de cette phrase')
                                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n' + sentence )
                                            final_result = False
                                        if final_result:
                                            new_id = cur.lastrowid
                                            if new_id > 0:
                                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nInsertion inscription [%s] reussie -> %s' % (str(reg.id),str(new_id)) )
                                            else:
                                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nInsertion inscription [%s] ratee' % str(reg.id) )
                                                email_problems.append('<li>Insertion inscription [%s] echoue dans MySQL.</li>' % str(reg.id) )
                                    else:
                                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nRegistration [%s] impossible to send to Mysql : no link between contact and partner' % str(reg.id) )
                                        email_problems.append('<li>Impossible d\'envoyer l\'inscrit [%s] dans Mysql : pas de lien entre le partenaire et le contact.</li>' % str(reg.id) )
                                else:
                                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nRegistration [%s] impossible to send to Mysql : no partner or no contact' % str(reg.id) )
                                    email_problems.append('<li>Impossible d\'envoyer l\'inscrit [%s] dans Mysql : le partenaire ou le contact manque.</li>' % str(reg.id) )
                            else:
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nRegistration [%s] already existing' % str(reg.id) )
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEnd of main loop')
                if final_result and changes:
                    con.commit()
                if cur:
                    cur.close()
                if con:
                    con.close()
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nChecking deleted')
                # check if deleted or canceled registrations not still in MySQL
                for mySQL_id in mySQL_reg_ids:
                    if mySQL_id not in current_registration_ids:
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nRegistration ID [%s] still existing in MySQL while erased or canceled in ERP' % str(mySQL_id) )
                        email_problems.append('<li>L\'inscription ID [%s] existe encore dans MySQL alors qu\'elle a ete effacee .</li>' % str(mySQL_id) )
                # envoi de l'email au superviseur
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nCheck if we need to send email')
                if email_problems and supervisor_emails:
                    if test:
                        supervisor_emails = ['philmer.vdm@gmail.com']
                    if BD_DE_TEST:
                        print 'From : no-reply@ccilvn.be'
                        print 'To : ' + str(supervisor_emails)
                        #print u"<p>La mise à jour de ce matin a eu quelques problèmes :</p><p><ul>%s</ul></p>" % ('\n'.join(email_problems))
                    else:
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nTrying to send mail')
                        tools.email_send('no-reply@ccilvn.be', 
                                         supervisor_emails, 
                                         u'Mise à jour exposants Pop Up', 
                                         u'<p>La mise à jour de ce matin a eu quelques problèmes :</p><p><ul>%s</ul></p>' % ('\n'.join(email_problems)), 
                                         subtype='html' )
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEmail sended')
        else:
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNothing done - some parameters were missing')
            final_result = False
        self.pool.get('cci_logs.cron_line')._stop(cr,uid,cronline_id,final_result,'\n---end---')
        return True
    def _send_list(self,cr,uid,before_days,after_days,copy_to=None):
        today = datetime.date.today()
        if today.weekday() < 5: # only Monday 0 -> Friday 4
            # Start log
            cronline_id = self.pool.get('cci_logs.cron_line')._start(cr,uid,'SendListParticipants')
            final_result = False
            event_obj = self.pool.get('event.event')
            type_obj = self.pool.get('event.type')
            reg_obj = self.pool.get('event.registration')
            partner_obj = self.pool.get('res.partner')
            parameter_obj = self.pool.get('cci_parameters.cci_value')
            template_obj = self.pool.get('cci_email_template')
            param_values = parameter_obj.get_value_from_names(cr,uid,['BDDeTest'])
            BD_DE_TEST = True
            if param_values.has_key('BDDeTest'):
                if param_values['BDDeTest'] == 0:
                    BD_DE_TEST = False
            # Search not sended events that occurs in some days
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nSearching for events that begins in %i days.' % before_days)
            event_type_ids = type_obj.search(cr,uid,[('emails_sending_before','ilike','@')])
            if event_type_ids:
                param_values = parameter_obj.get_value_from_names(cr,uid,['EventListSendingBeforeTemplateID'])
                if param_values.has_key('EventListSendingBeforeTemplateID'):
                    template = template_obj.browse(cr,uid,[param_values['EventListSendingBeforeTemplateID'],])[0]
                    before_subject = template.subject
                    before_body = template.body
                else:
                    before_subject = u'Liste Participants \'{0}\''
                    before_body = u'<p>Cher(s) Sponsor(s),</p><p>Voici la liste des participants pour l\'event \'{0}\' qui aura lieu le {1}.</p><p>Nous en souhaitons bonne réception.<br/>Espérant vous être agréable, nous vous souhaitons une excellente journée.</p><p>Christophe Mausen<br/>0496/55.92.52</p>'
                #
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\ninside 1')
                #
                until = add_working_days(today,before_days)
                event_ids = event_obj.search(cr,uid,[('type','in',event_type_ids),('date_begin','>=',today.strftime('%Y-%m-%d')),('date_begin','<=',until.strftime('%Y-%m-%d')),('state','<>','cancel')])
                if event_ids:
                    events = event_obj.browse(cr,uid,event_ids)
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\ninside 2')
                    for event in events:
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\ninside 3')
                        if not event.sended_before: # checked here and not in the search because not sure that "('sended_before','=',False)" give good results
                            reg_ids = reg_obj.search(cr,uid,[('event_id','=',event.id),('state','<>','cancel')])
                            if reg_ids:
                                regs = reg_obj.browse(cr,uid,reg_ids)
                                conso_shemas = ['FreeEvents','PaidEvents','PaidAE','PaidCNN','PaidTC','PaidMS','PaidPublication','PaidSponsoring','PaidMissions']
                                # 1. read all partner_ids to calculate consos
                                conso_partner_ids = []
                                for reg in regs:
                                    if reg.partner_id and reg.partner_id.id not in conso_partner_ids:
                                        conso_partner_ids.append(reg.partner_id.id)
                                if conso_partner_ids:
                                    date_to = datetime.date.today()
                                    date_from = (date_to + datetime.timedelta(days=-365)).replace(day=1)
                                    dPartner2Conso = partner_obj._extract_consumption(cr,uid,date_from.strftime('%Y-%m-%d'),date_to.strftime('%Y-%m-%d'),conso_shemas,conso_partner_ids)
                                # creating the excel files to send
                                wb1 = Workbook()
                                ws1 = wb1.add_sheet('Inscriptions %s' % event.name)
                                ws1.write(0,0,'partner_name')
                                ws1.write(0,1,'contact_name')
                                ws1.write(0,2,'contact_first_name')
                                ws1.write(0,3,'contact_courtesy')
                                ws1.write(0,4,'function')
                                ws1.write(0,5,'street')
                                ws1.write(0,6,'street2')
                                ws1.write(0,7,'zip_code')
                                ws1.write(0,8,'city')
                                ws1.write(0,9,'phone_address')
                                ws1.write(0,10,'fax_address')
                                ws1.write(0,11,'vat_number')
                                wb2 = Workbook()
                                ws2 = wb2.add_sheet('CCI Inscriptions %s' % event.name)
                                ws2.write(0,0,'partner_name')
                                ws2.write(0,1,'contact_name')
                                ws2.write(0,2,'contact_first_name')
                                ws2.write(0,3,'contact_courtesy')
                                ws2.write(0,4,'function')
                                ws2.write(0,5,'function_codes')
                                ws2.write(0,6,'street')
                                ws2.write(0,7,'street2')
                                ws2.write(0,8,'zip_code')
                                ws2.write(0,9,'city')
                                ws2.write(0,10,'phone_address')
                                ws2.write(0,11,'fax_address')
                                ws2.write(0,12,'vat_number')
                                ws2.write(0,13,'member_cci')
                                ws2.write(0,14,'employee')
                                ws2.write(0,15,'contact_mobile')
                                ws2.write(0,16,'contact_email')
                                ws2.write(0,17,'salesman')
                                ws2.write(0,18,'partner_id')
                                ws2.write(0,19,'contact_id')
                                col = 20
                                for shema in conso_shemas:
                                    ws2.write(0,col,shema)
                                    col += 1
                                line = 1
                                for reg in regs:
                                    # search for the address of the contact
                                    job_id = 0
                                    address_id = 0
                                    street = ''
                                    street2 = ''
                                    zip_code = ''
                                    city = ''
                                    addr_phone = ''
                                    addr_fax = ''
                                    job_email = ''
                                    job_phone = ''
                                    full_function = ''
                                    function_codes = ''
                                    if reg.contact_id:
                                        for job in reg.contact_id.job_ids:
                                            if job.address_id and job.address_id.partner_id and job.address_id.partner_id.id == reg.partner_id.id:
                                                street = job.address_id.street
                                                street2 = job.address_id.street2
                                                if job.address_id.zip_id:
                                                    zip_code = job.address_id.zip_id.name
                                                    city = job.address_id.zip_id.city
                                                addr_phone = job.address_id.phone
                                                addr_fax = job.address_id.fax
                                                job_email = job.email
                                                job_phone = job.phone
                                                job_id = job.id
                                                address_id = job.address_id.id
                                                full_function = job.function_label or ''
                                                function_codes = job.function_code_label or ''
                                    if job_id == 0 and reg.partner_id:
                                        # we found no address between partner_id and contact_id, then we take the default address of the partner
                                        for address in reg.partner_id.address:
                                            if address.type == 'default':
                                                street = address.street
                                                street2 = address.street2
                                                if address.zip_id:
                                                    zip_code = address.zip_id.name
                                                    city = address.zip_id.city
                                                addr_phone = address.phone
                                                addr_fax = address.fax
                                                address_id = address.id
                                    ws1.write(line,0,reg.partner_id.name or '')
                                    ws1.write(line,1,reg.contact_id.name or '' )
                                    ws1.write(line,2,reg.contact_id.first_name or '' )
                                    ws1.write(line,3,reg.contact_id.title or '' )
                                    ws1.write(line,4,full_function)
                                    ws1.write(line,5,street or '' )
                                    ws1.write(line,6,street2 or '' )
                                    ws1.write(line,7,zip_code or '' )
                                    ws1.write(line,8,city or '' )
                                    ws1.write(line,9,addr_phone or '' )
                                    ws1.write(line,10,addr_fax or '' )
                                    ws1.write(line,11,reg.partner_id and reg.partner_id.vat or '' )
                                    #
                                    ws2.write(line,0,reg.partner_id.name or '')
                                    ws2.write(line,1,reg.contact_id.name or '' )
                                    ws2.write(line,2,reg.contact_id.first_name or '' )
                                    ws2.write(line,3,reg.contact_id.title or '' )
                                    ws2.write(line,4,full_function)
                                    ws2.write(line,5,function_codes)
                                    ws2.write(line,6,street or '' )
                                    ws2.write(line,7,street2 or '' )
                                    ws2.write(line,8,zip_code or '' )
                                    ws2.write(line,9,city or '' )
                                    ws2.write(line,10,addr_phone or '' )
                                    ws2.write(line,11,addr_fax or '' )
                                    ws2.write(line,12,reg.partner_id and reg.partner_id.vat or '' )
                                    if reg.partner_id:
                                        ws2.write(line,13,(reg.partner_id.membership_state in ('free','invoiced','paid')) and 'Oui' or 'NON')
                                    else:
                                        ws2.write(line,13,'NON')
                                    if reg.partner_id:
                                        ws2.write(line,14,reg.partner_id.employee_nbr_total or 0)
                                    else:
                                        ws2.write(line,14,0)
                                    if reg.contact_id and reg.contact_id.mobile:
                                        ws2.write(line,15,reg.contact_id.mobile)
                                    else:
                                        ws2.write(line,15,job_phone)
                                    if job_email:
                                        ws2.write(line,16,job_email)
                                    else:
                                        ws2.write(line,16,reg.contact_id.email or '')
                                    ws2.write(line,17,reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.name or '' )
                                    ws2.write(line,18,reg.partner_id and reg.partner_id.id or 0 )
                                    ws2.write(line,19,reg.contact_id and reg.contact_id.id or 0)
                                    col = 20
                                    for shema in conso_shemas:
                                        if dPartner2Conso.has_key(reg.partner_id.id):
                                            if dPartner2Conso[reg.partner_id.id].has_key(shema):
                                                ws2.write(line,col,dPartner2Conso[reg.partner_id.id][shema])
                                            else:
                                                ws2.write(line,col,0)
                                        else:
                                            ws2.write(line,col,0)
                                        col += 1
                                    line += 1
                                filename = 'registrations_%i.xls' % event.id
                                wb1.save(filename)
                                filename2 = 'cci_registrations_%i.xls' % event.id
                                wb2.save(filename2)

                                # creating list of emails to send
                                emails = event.type.emails_sending_before
                                if ',' in emails:
                                    l_emails = emails.split(',')
                                elif ';' in emails:
                                    l_emails = emails.split(';')
                                else:
                                    l_emails = [emails,]
                                if copy_to:
                                    ccopies = copy_to.split(',')
                                else:
                                    ccopies = []
                                emails = [clean_email_addr(x) for x in emails]
                                
                                # sending of the email to each contacts (with the first one to the 'copy_to' address(es)
                                if BD_DE_TEST:
                                    print 'sending excel file'
                                    print event.id
                                    print event.name
                                    print l_emails
                                    print ccopies
                                    print before_subject.format(event.name_on_site or event.name)
                                    print before_body.format(event.name_on_site or event.name,event.date_begin[8:10]+'/'+event.date_begin[5:7]+'/'+event.date_begin[0:4])
                                else:
                                    first_mail = True
                                    for email_addr in l_emails:
                                        if '@ccilvn.be' in email_addr:
                                            current_filename = filename2
                                        else:
                                            current_filename = filename
                                        if ccopies and first_mail:
                                            tools.email_send('cm@ccilvn.be', [email_addr,], before_subject.format(event.name_on_site or event.name),
                                                                                               before_body.format(event.name_on_site or event.name,event.date_begin[8:10]+'/'+event.date_begin[5:7]+'/'+event.date_begin[0:4]),
                                                                                               subtype='html',
                                                                                               attach = [(current_filename,open(current_filename,'rb').read())],
                                                                                               email_bcc=ccopies)
                                        else:
                                            tools.email_send('cm@ccilvn.be', [email_addr,], before_subject.format(event.name_on_site or event.name),
                                                                                               before_body.format(event.name_on_site or event.name,event.date_begin[8:10]+'/'+event.date_begin[5:7]+'/'+event.date_begin[0:4]),
                                                                                               subtype='html',
                                                                                               attach = [(current_filename,open(current_filename,'rb').read())])
                                        first_mail = False
                                # recording of the sending
                                event_obj.write(cr,uid,[event.id,],{'sended_before':datetime.datetime.now()})
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' sended before.' % event.name )
                            else:
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' : no registration to send before.' % event.name )
                        else:
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' already sended before.' % event.name )
                else:
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNo event between %s and %s for types [%s] in sending before event.' % (today.strftime('%Y-%m-%d'),until.strftime('%Y-%m-%d'),','.join(str(x) for x in event_type_ids)))
            else:
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNo type of event configured for automatic list sending before the event.')
            
            # search for events finished since some days with mail template for members configured
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n\nSearching for events that occurred since %i days and with mail dedicated to members programmed.' % after_days)
            members_email_sended_addrs = [] # to add this info in the last list sended
            from_date = add_working_days(today,-1*after_days)
            event_ids = event_obj.search(cr,uid,[('members_after_mail_template_id','!=',False),('date_end','>=',from_date.strftime('%Y-%m-%d 00:00:01')),('date_end','<=',from_date.strftime('%Y-%m-%d 23:59:59')),('state','<>','cancel')])
            if event_ids:
                events = event_obj.browse(cr,uid,event_ids)
                for event in events:
                    template = event.members_after_mail_template_id
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' sending after message \'%s [%i]\' to members.' % (event.name,template.name,template.id) )
                    after_subject = template.subject
                    after_body = template.body
                    if not event.members_sended_after: # checked here and not in the search because not sure that "('sended_before','=',False)" give good results
                        reg_ids = reg_obj.search(cr,uid,[('event_id','=',event.id),('state','<>','cancel'),('attendance','=',True),('email_from','!=',False)])
                        if reg_ids:
                            tags = re.compile('{PERSO .*?}',re.IGNORECASE)
                            regs = reg_obj.browse(cr,uid,reg_ids)
                            count_sendings = 0
                            for reg in regs:
                                if reg.partner_id and (reg.partner_id.membership_state in ['free','invoiced','paid']) and reg.partner_id.user_id and reg.partner_id.user_id.email:
                                    msg_mail = template.body
                                    subject_mail = template.subject
                                    msg_mail = reg_obj.personalize_text(cr,uid,tags,msg_mail,reg)
                                    subject_mail = reg_obj.personalize_text(cr,uid,tags,subject_mail,reg)
                                    address_from = reg.partner_id.user_id.email
                                    addresses_to = [clean_email_addr(reg.email_from),]
                                    if BD_DE_TEST:
                                        print "------------ Msg to send --------------------"
                                        print "From : " + address_from
                                        print "To : " + ','.join(addresses_to)
                                        print "Subject : " + subject_mail
                                        print "Body :\n" + msg_mail
                                    else:
                                        tools.email_send(address_from, addresses_to, subject_mail, msg_mail,subtype='html')
                                    members_email_sended_addrs.append(clean_email_addr(reg.email_from))
                                    count_sendings += 1
                                    self.pool.get('cci_email_sended').create(cr,uid,{'name':u'After Event to Member',
                                                                                     'subject':subject_mail,
                                                                                     'body':msg_mail,
                                                                                     'ressource':'event.registration:'+str(reg.id)+':',
                                                                                     'addr_from':address_from,
                                                                                     'addrs_to':'['+','.join(addresses_to)+']',
                                                                                    })
                            # recording of the sending
                            event_obj.write(cr,uid,[event.id,],{'members_sended_after':datetime.datetime.now()})
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' sended after to members (%i sendings).' % (event.name,count_sendings) )
                        else:
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' : no members for sending \'after message\' by mail.' % event.name )
                    else:
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' already sended after to members.' % event.name )
            else:
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNo event between %s and %s configured for sending mail to members after event.' % (from_date.strftime('%Y-%m-%d'),from_date.strftime('%Y-%m-%d')))
               
            # search for events finished since some days with mail template for non-members configured
            nonmembers_email_sended_addrs = [] # to add this info in the last list sended
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n\nSearching for events that occurred since %i days and with mail dedicated to non-members programmed.' % after_days)
            from_date = add_working_days(today,-1*after_days)
            event_ids = event_obj.search(cr,uid,[('nonmembers_after_mail_template_id','!=',False),('date_end','>=',from_date.strftime('%Y-%m-%d 00:00:01')),('date_end','<=',from_date.strftime('%Y-%m-%d 23:59:59')),('state','<>','cancel')])
            if event_ids:
                events = event_obj.browse(cr,uid,event_ids)
                for event in events:
                    template = event.nonmembers_after_mail_template_id
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' sending after message \'%s [%i]\' to non-members.' % (event.name,template.name,template.id) )
                    after_subject = template.subject
                    after_body = template.body
                    if not event.nonmembers_sended_after: # checked here and not in the search because not sure that "('sended_before','=',False)" give good results
                        reg_ids = reg_obj.search(cr,uid,[('event_id','=',event.id),('state','<>','cancel'),('attendance','=',True),('email_from','!=',False)])
                        if reg_ids:
                            tags = re.compile('{PERSO .*?}',re.IGNORECASE)
                            regs = reg_obj.browse(cr,uid,reg_ids)
                            count_sendings = 0
                            for reg in regs:
                                if reg.partner_id and (reg.partner_id.membership_state not in ['free','invoiced','paid']) and reg.partner_id.user_id and reg.partner_id.user_id.email:
                                    msg_mail = template.body
                                    subject_mail = template.subject
                                    msg_mail = reg_obj.personalize_text(cr,uid,tags,msg_mail,reg)
                                    subject_mail = reg_obj.personalize_text(cr,uid,tags,subject_mail,reg)
                                    address_from = reg.partner_id.user_id.email
                                    addresses_to = [clean_email_addr(reg.email_from),]
                                    if BD_DE_TEST:
                                        print "------------ Msg to send --------------------"
                                        print "From : " + address_from
                                        print "To : " + ','.join(addresses_to)
                                        print "Subject : " + subject_mail
                                        print "Body :\n" + msg_mail
                                    else:
                                        tools.email_send(address_from, addresses_to, subject_mail, msg_mail,subtype='html')
                                    nonmembers_email_sended_addrs.append(clean_email_addr(reg.email_from))
                                    count_sendings += 1
                                    self.pool.get('cci_email_sended').create(cr,uid,{'name':u'After Event to Non-Member',
                                                                                     'subject':subject_mail,
                                                                                     'body':msg_mail,
                                                                                     'ressource':'event.registration:'+str(reg.id)+':',
                                                                                     'addr_from':address_from,
                                                                                     'addrs_to':'['+','.join(addresses_to)+']',
                                                                                    })
                            # recording of the sending
                            event_obj.write(cr,uid,[event.id,],{'nonmembers_sended_after':datetime.datetime.now()})
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' sended after to non-members (%i sendings).' % (event.name,count_sendings) )
                        else:
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' : no non-members for sending \'after message\' by mail.' % event.name )
                    else:
                        self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' already sended after to non-members.' % event.name )
            else:
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNo event between %s and %s configured for sending mail to non-members after event.' % (from_date.strftime('%Y-%m-%d'),from_date.strftime('%Y-%m-%d')))

            # Search not sended events that have finished since some days
            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\n\nSearching for events that occurred since %i days.' % after_days)
            event_type_ids = type_obj.search(cr,uid,[('emails_sending_after','ilike','@')])
            if event_type_ids:
                param_values = parameter_obj.get_value_from_names(cr,uid,['EventListSendingAfterTemplateID'])
                if param_values.has_key('EventListSendingAfterTemplateID'):
                    template = template_obj.browse(cr,uid,[param_values['EventListSendingAfterTemplateID'],])[0]
                    after_subject = template.subject
                    after_body = template.body
                else:
                    after_subject = u'Liste Présents {0}'
                    after_body = u'<p>Cher(s) Sponsor(s),</p><p>Voici la liste des présents à l\'event \'{0}\' qui s\'est déroulé le {1}.</p><p>Nous en souhaitons bonne réception.<br/>Espérant vous être agréable, nous vous souhaitons une excellente journée.</p><p>Christophe Mausen<br/>0496/55.92.52</p>'
                #
                from_date = add_working_days(today,-1*after_days)
                event_ids = event_obj.search(cr,uid,[('type','in',event_type_ids),('date_end','>=',from_date.strftime('%Y-%m-%d')),('date_end','<=',from_date.strftime('%Y-%m-%d')),('state','<>','cancel')])
                if event_ids:
                    events = event_obj.browse(cr,uid,event_ids)
                    for event in events:
                        if not event.sended_after: # checked here and not in the search because not sure that "('sended_before','=',False)" give good results
                            reg_ids = reg_obj.search(cr,uid,[('event_id','=',event.id),('state','<>','cancel')])
                            if reg_ids:
                                regs = reg_obj.browse(cr,uid,reg_ids)
                                # creating the excel file to send
                                wb1 = Workbook()
                                ws1 = wb1.add_sheet(u'Présents %s' % event.name)
                                ws1.write(0,0,'partner_name')
                                ws1.write(0,1,'contact_name')
                                ws1.write(0,2,'contact_first_name')
                                ws1.write(0,3,'contact_courtesy')
                                ws1.write(0,4,'function')
                                ws1.write(0,5,'street')
                                ws1.write(0,6,'street2')
                                ws1.write(0,7,'zip_code')
                                ws1.write(0,8,'city')
                                ws1.write(0,9,'phone_address')
                                ws1.write(0,10,'fax_address')
                                ws1.write(0,11,'vat_number')
                                wb2 = Workbook()
                                ws2 = wb2.add_sheet('CCI Inscriptions %s' % event.name)
                                ws2.write(0,0,'partner_name')
                                ws2.write(0,1,'contact_name')
                                ws2.write(0,2,'contact_first_name')
                                ws2.write(0,3,'contact_courtesy')
                                ws2.write(0,4,'function')
                                ws2.write(0,5,'street')
                                ws2.write(0,6,'street2')
                                ws2.write(0,7,'zip_code')
                                ws2.write(0,8,'city')
                                ws2.write(0,9,'phone_address')
                                ws2.write(0,10,'fax_address')
                                ws2.write(0,11,'vat_number')
                                ws2.write(0,12,'member_cci')
                                ws2.write(0,13,'contact_mobile')
                                ws2.write(0,14,'contact_email')
                                ws2.write(0,15,'salesman')
                                ws2.write(0,16,'partner_id')
                                ws2.write(0,17,'contact_id')
                                line = 1
                                for reg in regs:
                                    # search for the address of the contact
                                    job_id = 0
                                    address_id = 0
                                    street = ''
                                    street2 = ''
                                    zip_code = ''
                                    city = ''
                                    addr_phone = ''
                                    addr_fax = ''
                                    job_email = ''
                                    job_phone = ''
                                    full_function = ''
                                    if reg.contact_id:
                                        for job in reg.contact_id.job_ids:
                                            if job.address_id and job.address_id.partner_id and job.address_id.partner_id.id == reg.partner_id.id:
                                                street = job.address_id.street
                                                street2 = job.address_id.street2
                                                if job.address_id.zip_id:
                                                    zip_code = job.address_id.zip_id.name
                                                    city = job.address_id.zip_id.city
                                                addr_phone = job.address_id.phone
                                                addr_fax = job.address_id.fax
                                                job_email = job.email
                                                job_id = job.id
                                                job_phone = job.phone
                                                address_id = job.address_id.id
                                                full_function = job.function_label or ''
                                    if job_id == 0 and reg.partner_id:
                                        # we found no address between partner_id and contact_id, then we take the default address of the partner
                                        for address in reg.partner_id.address:
                                            if address.type == 'default':
                                                street = address.street
                                                street2 = address.street2
                                                if address.zip_id:
                                                    zip_code = address.zip_id.name
                                                    city = address.zip_id.city
                                                addr_phone = address.phone
                                                addr_fax = address.fax
                                                address_id = address.id
                                    ws1.write(line,0,reg.partner_id.name or '')
                                    ws1.write(line,1,reg.contact_id.name or '' )
                                    ws1.write(line,2,reg.contact_id.first_name or '' )
                                    ws1.write(line,3,reg.contact_id.title or '' )
                                    ws1.write(line,4,full_function)
                                    ws1.write(line,5,street or '' )
                                    ws1.write(line,6,street2 or '' )
                                    ws1.write(line,7,zip_code or '' )
                                    ws1.write(line,8,city or '' )
                                    ws1.write(line,9,addr_phone or '' )
                                    ws1.write(line,10,addr_fax or '' )
                                    ws1.write(line,11,reg.partner_id and reg.partner_id.vat or '' )
                                    #
                                    ws2.write(line,0,reg.partner_id.name or '')
                                    ws2.write(line,1,reg.contact_id.name or '' )
                                    ws2.write(line,2,reg.contact_id.first_name or '' )
                                    ws2.write(line,3,reg.contact_id.title or '' )
                                    ws2.write(line,4,full_function)
                                    ws2.write(line,5,street or '' )
                                    ws2.write(line,6,street2 or '' )
                                    ws2.write(line,7,zip_code or '' )
                                    ws2.write(line,8,city or '' )
                                    ws2.write(line,9,addr_phone or '' )
                                    ws2.write(line,10,addr_fax or '' )
                                    ws2.write(line,11,reg.partner_id and reg.partner_id.vat or '' )
                                    if reg.partner_id:
                                        ws2.write(line,12,(reg.partner_id.membership_state in ('free','invoiced','paid')) and 'Oui' or 'NON')
                                    else:
                                        ws1.write(line,12,'NON')
                                    if reg.contact_id and reg.contact_id.mobile:
                                        ws2.write(line,13,reg.contact_id.mobile)
                                    else:
                                        ws2.write(line,13,job_phone)
                                    if job_email:
                                        ws2.write(line,14,job_email)
                                    else:
                                        ws2.write(line,14,reg.contact_id.email or '')
                                    ws2.write(line,15,reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.name or '' )
                                    ws2.write(line,16,reg.partner_id and reg.partner_id.id or 0 )
                                    ws2.write(line,17,reg.contact_id and reg.contact_id.id or 0)
                                    line += 1
                                filename = 'presents_%i.xls' % event.id
                                wb1.save(filename)
                                filename2 = 'cci_presents_%i.xls' % event.id
                                wb2.save(filename2)

                                # creating list of emails to send
                                emails = event.type.emails_sending_after
                                if ',' in emails:
                                    l_emails = emails.split(',')
                                elif ';' in emails:
                                    l_emails = emails.split(';')
                                else:
                                    l_emails = [emails,]
                                if copy_to:
                                    ccopies = copy_to.split(',')
                                else:
                                    ccopies = []
                                emails = [clean_email_addr(x) for x in emails]

                                # sending of the email to each contacts (with the first one to the 'copy_to' address(es)
                                if BD_DE_TEST:
                                    print 'sending excel file'
                                    print event.id
                                    print event.name
                                    print l_emails
                                    print ccopies
                                    print after_subject.format(event.name_on_site or event.name)
                                    print after_body.format(event.name_on_site or event.name,event.date_end[8:10]+'/'+event.date_end[5:7]+'/'+event.date_end[0:4])
                                else:
                                    first_mail = True
                                    for email_addr in l_emails:
                                        if '@ccilvn.be' in email_addr:
                                            current_filename = filename2
                                        else:
                                            current_filename = filename
                                        if ccopies and first_mail:
                                            tools.email_send('cm@ccilvn.be', [email_addr,], after_subject.format(event.name_on_site or event.name),
                                                                                               after_body.format(event.name_on_site or event.name,event.date_end[8:10]+'/'+event.date_end[5:7]+'/'+event.date_end[0:4]),
                                                                                               subtype='html',
                                                                                               attach = [(current_filename,open(current_filename,'rb').read())],
                                                                                               email_bcc=ccopies)
                                        else:
                                            tools.email_send('cm@ccilvn.be', [email_addr,], after_subject.format(event.name_on_site or event.name),
                                                                                               after_body.format(event.name_on_site or event.name,event.date_end[8:10]+'/'+event.date_end[5:7]+'/'+event.date_end[0:4]),
                                                                                               subtype='html',
                                                                                               attach = [(current_filename,open(current_filename,'rb').read())])
                                        first_mail = False
                                # recording of the sending
                                event_obj.write(cr,uid,[event.id,],{'sended_after':datetime.datetime.now()})
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' sended after.' % event.name )
                            else:
                                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' : no registration to send after.' % event.name )
                        else:
                            self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nEvent \'%s\' already sended after.' % event.name )
                else:
                    self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNo event between %s and %s for types [%s] in sending after event.' % (from_date.strftime('%Y-%m-%d'),from_date.strftime('%Y-%m-%d'),','.join(str(x) for x in event_type_ids)))
            else:
                self.pool.get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'\nNo type of event configured for automatic list sending after the event.')
            final_result = True
            self.pool.get('cci_logs.cron_line')._stop(cr,uid,cronline_id,final_result,'\n---end---')
        return True
event()

class event_type(osv.osv):
    _inherit = 'event.type'
    _description= 'Event type'
    _columns = {
        'product_id': fields.many2one('product.product','Default Product',help='This product will be used as template for creating a precise product linked only to each event of this type'),
        'user_id': fields.many2one('res.users','Default Responsible',help='The events of this type will be linked to this user when we can\'t find any user from the website user name.'),
        'name_template': fields.char('Name Template',size=120,help='String with {PERSO Date} or {PERSO Nom} available to auto-format the event name'),
        'product_name_template': fields.char('Product Name Template',size=120,help='String with {PERSO Date}, {PERSO Nom}, {PERSO FRDate} or {PERSO FRMois} available to auto-format the product name'),
        'name_on_site': fields.char('Name on Site',size=120,help='Name of this type of events as defined on the side of the website to do the link'),
        'default_auto_register':fields.boolean('Mail Auto Register',help='Check this box if you want to use the automatic mailing for new registration'),
        'default_auto_confirm':fields.boolean('Mail Auto Confirm',help='Check this box if you want to use the automatic confirmation emailing or the reminder'),
        'default_msg_register':fields.text('Registration Email',help='This email will be sent when someone subscribes to the event.'),
        'default_msg_confirm': fields.text('Confirmation Email', help="This email will be sent when the event gets confirmed or when someone subscribes to a confirmed event."),
        'active': fields.boolean('Active'),
        'emails_sending_before': fields.text('Emails to send before',help="List of emails separated by ',' or ';'. Always sended, even if registered as participant."),
        'emails_sending_after': fields.text('Emails to send after',help="List of emails separated by ',' or ';'. Always sended, even if registered as participant."),
    }
    _defaults = {
        'active': lambda *args: True,
    }
event_type()

class event_registration(osv.osv):
    _inherit = 'event.registration'
    _description="event.registration"
    def personalize_text(self,cr,uid,tags,text,reg):
        ''' This method replace tags with content from registration browse object
            to personalize the mail sended to the registrated contacts
        '''
        # 2017-03-15 Ajout tag invitpay
        for tag in tags.findall(text):
            tag_name = str(tag)
            if tag_name == '{PERSO nom_event}':
                text = text.replace(tag_name,reg.event_id.name)
            elif tag_name == '{PERSO nom_humain_event}':
                text = text.replace(tag_name,reg.event_id.name_on_site or reg.event_id.name or 'Event')
            elif tag_name == '{PERSO date_complete_event}':
                days = [u'lundi',u'mardi',u'mercredi',u'jeudi',u'vendredi',u'samedi',u'dimanche']
                months = [u'',u'janvier',u'février',u'mars',u'avril',u'mai',u'juin',u'juillet',u'août',u'septembre',u'octobre',u'novembre',u'décembre']
                event_begin_as_date = datetime.date(int(reg.event_id.date_begin[0:4]),int(reg.event_id.date_begin[5:7]),int(reg.event_id.date_begin[8:10]))
                full_date = days[event_begin_as_date.weekday()]+' '+str(int(event_begin_as_date.strftime('%d')))+' '+months[int(event_begin_as_date.strftime('%m'))]+' '+ reg.event_id.date_begin[0:4]
                text = text.replace(tag_name,full_date)
            elif tag_name == '{PERSO nom_badge}':
                text = text.replace(tag_name,reg.badge_name or '')
            elif tag_name == '{PERSO partenaire_badge}':
                text = text.replace(tag_name,reg.badge_partner or '')
            elif tag_name == '{PERSO titre_badge}':
                text = text.replace(tag_name,reg.badge_title or '')
            elif tag_name == '{PERSO cnp_inscrit}':
                text = text.replace(tag_name,( ( reg.contact_id.title or '' ) + ' ' + reg.contact_id.name + ' ' + ( reg.contact_id.first_name or '' ) ).strip())
            elif tag_name == '{PERSO cpn_inscrit}':
                text = text.replace(tag_name,( ( reg.contact_id.title or '' ) + ' ' + ( reg.contact_id.first_name or '' ) + ' ' + reg.contact_id.name ).strip().replace('  ',' '))
            elif tag_name == '{PERSO pn_inscrit}':
                text = text.replace(tag_name,( ( reg.contact_id.first_name or '' ) + ' ' + reg.contact_id.name ).strip())
            elif tag_name == '{PERSO np_inscrit}':
                text = text.replace(tag_name,( reg.contact_id.name + ' ' + ( reg.contact_id.first_name or '' ) ).strip())
            elif tag_name == '{PERSO n_inscrit}':
                text = text.replace(tag_name,( reg.contact_id.name ).strip())
            elif tag_name == '{PERSO p_inscrit}':
                text = text.replace(tag_name,( reg.contact_id.first_name or '' ).strip())
            elif tag_name == '{PERSO cn_inscrit}':
                text = text.replace(tag_name,( ( reg.contact_id.title or '' ) + ' ' + reg.contact_id.name ).strip())
            elif tag_name == '{PERSO nomfact}':
                if reg.unit_price > 0.001:
                    value = u'<p>Aucune adresse de facturation définie</p>'
                    if reg.partner_invoice_id:
                        # search of the first 'invoice' address, else first 'default' address
                        if reg.partner_invoice_id.address:
                            good_address = False
                            for address in reg.partner_invoice_id.address:
                                if address.type == 'invoice':
                                    good_address = address
                                    break
                            if not good_address:
                                for address in reg.partner_invoice_id.address:
                                    if address.type == 'default':
                                        good_address = address
                                        break
                        if good_address:
                            value = u'<p>Sans contre avis de votre part, votre participation sera facturée à : '
                            if good_address.name:
                                if good_address.name[0:2] == '- ' or good_address.name[0:3] == ' - ':
                                    value += ( reg.partner_invoice_id.name + ' ' + good_address.name.lstrip() )
                                else:
                                    value += good_address.name
                            else:
                                value += reg.partner_invoice_id.name
                            value += ', ' + ( good_address.street or '' )
                            if good_address.street2:
                                value += ( u' - ' + good_address.street2 )
                            if good_address.zip_id:
                                value += ( u', ' + good_address.zip_id.name + ' ' + good_address.zip_id.city )
                            elif good_address.zip:
                                value += ( u', ' + good_address.zip + ' ' + good_address.city )
                            if not reg.partner_invoice_id.vat_subjected:
                                value += u', TVA : Non assujetti'
                            else:
                                if reg.partner_invoice_id.vat:
                                    value += ( u', TVA : ' + reg.partner_invoice_id.vat )
                                else:
                                    value += u', TVA : inconnue'
                            # Insertion of a special text for ING but the solution is generic
                            if reg.partner_invoice_id and reg.partner_invoice_id.answers_ids:
                                special_msg = ''
                                parameter_obj = self.pool.get('cci_parameters.cci_value')
                                param_values = parameter_obj.get_value_from_names(cr,uid,['msg_confirm_event'])
                                if param_values and param_values.has_key('msg_confirm_event'):
                                    SPECIAL_QUESTION_ID = param_values['msg_confirm_event']
                                    for answer in reg.partner_invoice_id.answers_ids:
                                        if answer.question_id and answer.question_id.id == SPECIAL_QUESTION_ID:
                                            special_msg = answer.text
                                    if special_msg:
                                        value += ( '<br/><br/>' + special_msg )
                            value += '</p>'
                else:
                    value = ''
                text = text.replace(tag_name,value)
            elif tag_name == '{PERSO nomfact_en}':
                if reg.unit_price > 0.001:
                    value = u'<p>No given invoice address</p>'
                    if reg.partner_invoice_id:
                        # search of the first 'invoice' address, else first 'default' address
                        if reg.partner_invoice_id.address:
                            good_address = False
                            for address in reg.partner_invoice_id.address:
                                if address.type == 'invoice':
                                    good_address = address
                                    break
                            if not good_address:
                                for address in reg.partner_invoice_id.address:
                                    if address.type == 'default':
                                        good_address = address
                                        break
                        if good_address:
                            value = u'<p>Your participation will be invoiced to : '
                            if good_address.name:
                                if good_address.name[0:2] == '- ' or good_address.name[0:3] == ' - ':
                                    value += ( reg.partner_invoice_id.name + ' ' + good_address.name.lstrip() )
                                else:
                                    value += good_address.name
                            else:
                                value += reg.partner_invoice_id.name
                            value += ', ' + ( good_address.street or '' )
                            if good_address.street2:
                                value += ( u' - ' + good_address.street2 )
                            if good_address.zip_id:
                                value += ( u', ' + good_address.zip_id.name + ' ' + good_address.zip_id.city )
                            elif good_address.zip:
                                value += ( u', ' + good_address.zip + ' ' + good_address.city )
                            if not reg.partner_invoice_id.vat_subjected:
                                value += u', VAT : no VAT Customer'
                            else:
                                if reg.partner_invoice_id.vat:
                                    value += ( u', VAT : ' + reg.partner_invoice_id.vat )
                                else:
                                    value += u', VAT : unknown'
                            # Insertion of a special text for ING but the solution is generic
                            if reg.partner_invoice_id and reg.partner_invoice_id.answers_ids:
                                special_msg = ''
                                parameter_obj = self.pool.get('cci_parameters.cci_value')
                                param_values = parameter_obj.get_value_from_names(cr,uid,['msg_confirm_event'])
                                if param_values and param_values.has_key('msg_confirm_event'):
                                    SPECIAL_QUESTION_ID = param_values['msg_confirm_event']
                                    for answer in reg.partner_invoice_id.answers_ids:
                                        if answer.question_id and answer.question_id.id == SPECIAL_QUESTION_ID:
                                            special_msg = answer.text
                                    if special_msg:
                                        value += ( '<br/><br/>' + special_msg )
                            value += '</p>'
                else:
                    value = ''
                text = text.replace(tag_name,value)
            elif tag_name == '{PERSO tu_nomfact}':
                if reg.unit_price > 0.001:
                    value = u'Aucune adresse de facturation définie</p>'
                    if reg.partner_invoice_id:
                        # search of the first 'invoice' address, else first 'default' address
                        if reg.partner_invoice_id.address:
                            good_address = False
                            for address in reg.partner_invoice_id.address:
                                if address.type == 'invoice':
                                    good_address = address
                                    break
                            if not good_address:
                                for address in reg.partner_invoice_id.address:
                                    if address.type == 'default':
                                        good_address = address
                                        break
                        if good_address:
                            value = u'Sans contre avis de ta part, ta participation sera facturée à : '
                            if good_address.name:
                                if good_address.name[0:2] == '- ' or good_address.name[0:3] == ' - ':
                                    value += ( reg.partner_invoice_id.name + ' ' + good_address.name.lstrip() )
                                else:
                                    value += good_address.name
                            else:
                                value += reg.partner_invoice_id.name
                            value += ', ' + ( good_address.street or '' )
                            if good_address.street2:
                                value += ( u' - ' + good_address.street2 )
                            if good_address.zip_id:
                                value += ( u', ' + good_address.zip_id.name + ' ' + good_address.zip_id.city )
                            elif good_address.zip:
                                value += ( u', ' + good_address.zip + ' ' + good_address.city )
                            if not reg.partner_invoice_id.vat_subjected:
                                value += u', TVA : Non assujetti'
                            else:
                                if reg.partner_invoice_id.vat:
                                    value += ( u', TVA : ' + reg.partner_invoice_id.vat )
                                else:
                                    value += u', TVA : inconnue'
                            # Insertion of a special text for ING but the solution is generic
                            if reg.partner_invoice_id and reg.partner_invoice_id.answers_ids:
                                special_msg = ''
                                parameter_obj = self.pool.get('cci_parameters.cci_value')
                                param_values = parameter_obj.get_value_from_names(cr,uid,['msg_confirm_event'])
                                if param_values and param_values.has_key('msg_confirm_event'):
                                    SPECIAL_QUESTION_ID = param_values['msg_confirm_event']
                                    for answer in reg.partner_invoice_id.answers_ids:
                                        if answer.question_id and answer.question_id.id == SPECIAL_QUESTION_ID:
                                            special_msg = answer.text
                                    if special_msg:
                                        value += ( '<br/><br/>' + special_msg )
                            value += '</p>'
                else:
                    value = ''
                text = text.replace(tag_name,value)
            elif tag_name == '{PERSO tu_nomfact_en}':
                if reg.unit_price > 0.001:
                    value = u'No defined invoice address</p>'
                    if reg.partner_invoice_id:
                        # search of the first 'invoice' address, else first 'default' address
                        if reg.partner_invoice_id.address:
                            good_address = False
                            for address in reg.partner_invoice_id.address:
                                if address.type == 'invoice':
                                    good_address = address
                                    break
                            if not good_address:
                                for address in reg.partner_invoice_id.address:
                                    if address.type == 'default':
                                        good_address = address
                                        break
                        if good_address:
                            value = u'Your participation will be invoiced to : '
                            if good_address.name:
                                if good_address.name[0:2] == '- ' or good_address.name[0:3] == ' - ':
                                    value += ( reg.partner_invoice_id.name + ' ' + good_address.name.lstrip() )
                                else:
                                    value += good_address.name
                            else:
                                value += reg.partner_invoice_id.name
                            value += ', ' + ( good_address.street or '' )
                            if good_address.street2:
                                value += ( u' - ' + good_address.street2 )
                            if good_address.zip_id:
                                value += ( u', ' + good_address.zip_id.name + ' ' + good_address.zip_id.city )
                            elif good_address.zip:
                                value += ( u', ' + good_address.zip + ' ' + good_address.city )
                            if not reg.partner_invoice_id.vat_subjected:
                                value += u', VAT: no VAT Customer'
                            else:
                                if reg.partner_invoice_id.vat:
                                    value += ( u', VAT : ' + reg.partner_invoice_id.vat )
                                else:
                                    value += u', VAT : unknown'
                            # Insertion of a special text for ING but the solution is generic
                            if reg.partner_invoice_id and reg.partner_invoice_id.answers_ids:
                                special_msg = ''
                                parameter_obj = self.pool.get('cci_parameters.cci_value')
                                param_values = parameter_obj.get_value_from_names(cr,uid,['msg_confirm_event'])
                                if param_values and param_values.has_key('msg_confirm_event'):
                                    SPECIAL_QUESTION_ID = param_values['msg_confirm_event']
                                    for answer in reg.partner_invoice_id.answers_ids:
                                        if answer.question_id and answer.question_id.id == SPECIAL_QUESTION_ID:
                                            special_msg = answer.text
                                    if special_msg:
                                        value += ( '<br/><br/>' + special_msg )
                            value += '</p>'
                else:
                    value = ''
                text = text.replace(tag_name,value)
            elif tag_name[0:15] == '{PERSO invitpay':
                if len(tag_name) <= 16:
                    if reg.event_id.product_id:
                        event_name = reg.event_id.product_id.name.strip()
                    else:
                        event_name = 'Event CCI'
                else:
                    event_name = tag_name[15:-1].strip()
                if reg.unit_price > 0.001:
                    value = u'<br/>Si ce n\'est pas déjà fait, nous vous invitons à effectuer le paiement TVAC de %s euros sur notre compte BE51 3630 5000 5762, afin de confirmer votre inscription, avec la mention "%s - Nom Prénom".' % ('%.2f' % (reg.unit_price * 1.21),event_name)
                else:
                    value = u''
                text = text.replace(tag_name,value)
            elif tag_name[0:18] == '{PERSO invitpay_en':
                if len(tag_name) <= 19:
                    if reg.event_id.product_id:
                        event_name = reg.event_id.product_id.name.strip()
                    else:
                        event_name = 'Event CCI'
                else:
                    event_name = tag_name[18:-1].strip()
                if reg.unit_price > 0.001:
                    value = u'<br/>If it’s not already done, we invite you to pay %s euros (VAT included) on our account BE51 3630 5000 5762 - BIC BBRUBEBB, in order to confirm your registration with the text "%s – Last_Name First_Name.' % ('%.2f' % (reg.unit_price * 1.21),event_name)
                else:
                    value = u''
                text = text.replace(tag_name,value)
            elif tag_name == '{PERSO salesman_signature_photo}':
                value = ''
                if reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.photo_url:
                    value += '<img src="%s" alt="photo"/><br/>' % reg.partner_id.user_id.photo_url.strip().replace('\n','').replace('\t','')
                if reg.partner_id and reg.partner_id.user_id:
                    value += '%s<br/>' % reg.partner_id.user_id.name.strip().replace('\n','').replace('\t','')
                if reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.title:
                    value += '%s<br/>' % reg.partner_id.user_id.title.strip().replace('\n','').replace('\t','')
                if reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.mobile:
                    value += '%s<br/>' % reg.partner_id.user_id.mobile.strip().replace('\n','').replace('\t','')
                if reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.email:
                    value += '%s<br/>' % reg.partner_id.user_id.email.strip().replace('\n','').replace('\t','')
                value = value[0:-4]
                text = text.replace(tag_name,value)
            elif tag_name == '{PERSO salesman_signature}':
                value = ''
                if reg.partner_id and reg.partner_id.user_id:
                    value += '%s<br/>' % reg.partner_id.user_id.name.strip().replace('\n','').replace('\t','')
                if reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.title:
                    value += '%s<br/>' % reg.partner_id.user_id.title.strip().replace('\n','').replace('\t','')
                if reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.mobile:
                    value += '%s<br/>' % reg.partner_id.user_id.mobile.strip().replace('\n','').replace('\t','')
                if reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.email:
                    value += '%s<br/>' % reg.partner_id.user_id.email.strip().replace('\n','').replace('\t','')
                value = value[0:-4]
                text = text.replace(tag_name,value)
            elif tag_name == '{PERSO salesman_photo}':
                value = ''
                if reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.photo_url:
                    value += '<img src="%s" alt="photo"/>' % reg.partner_id.user_id.photo_url.strip().replace('\n','').replace('\t','')
                text = text.replace(tag_name,value)
            elif tag_name == '{PERSO salesman_pn}':
                value = ''
                if reg.partner_id and reg.partner_id.user_id:
                    value += reg.partner_id.user_id.name.strip().replace('\n','').replace('\t','')
                text = text.replace(tag_name,value)
            elif tag_name == '{PERSO salesman_titre}':
                value = ''
                if reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.title:
                    value += reg.partner_id.user_id.title.strip().replace('\n','').replace('\t','')
                text = text.replace(tag_name,value)
            elif tag_name == '{PERSO salesman_mobile}':
                value = ''
                if reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.mobile:
                    value += '%s<br/>' % reg.partner_id.user_id.mobile.strip().replace('\n','').replace('\t','')
                text = text.replace(tag_name,value)
            elif tag_name == '{PERSO salesman_email}':
                value = ''
                if reg.partner_id and reg.partner_id.user_id and reg.partner_id.user_id.email:
                    value += '%s<br/>' % reg.partner_id.user_id.email.strip().replace('\n','').replace('\t','')
                text = text.replace(tag_name,value)
            else:
                try:
                   text = text.replace(tag_name,str(eval(tag_name[7:-1])).strip())
                except Exception:
                    text = text.replace(tag_name,'??' + tag_name[7:-1] + '??')
        return text
    # this method overwrites the parent method to make it more adapted to CCI events
    # and more personalisable
    def mail_user_confirm(self,cr,uid,ids):
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['BDDeTest'])
        BD_DE_TEST = True
        if param_values.has_key('BDDeTest'):
            if param_values['BDDeTest'] == 0:
                BD_DE_TEST = False
        tags = re.compile('{PERSO .*?}',re.IGNORECASE)
        regs = self.browse(cr,uid,ids)
        for reg in regs:
            # we re-format entirely the message for each registration because they can be of different event => the message change
            msg_mail = self.personalize_text(cr,uid,tags,reg.event_id.mail_confirm,reg)
            src = reg.event_id.reply_to or False
            dest = []
            if reg.email_from:
                dest += [reg.email_from]
                if reg.email_cc:
                    dest += [reg.email_cc]
            if dest and src:
                if reg.event_id.subject_confirm:
                    mail_subject = reg.event_id.subject_confirm.strip()
                else:
                    mail_subject = 'Infos pratiques %s'
                if '%s' not in mail_subject:
                    mail_subject += ' %s'
                mail_subject = mail_subject % ( reg.event_id.name_on_site and reg.event_id.name_on_site or reg.event_id.product_id.name )
                if BD_DE_TEST:
                    print "------------ Msg to send --------------------"
                    print "From : " + src
                    print "To : " + ','.join(dest)
                    print "Subject : " + mail_subject
                    print "Body :\n" + msg_mail
                else:
                    tools.email_send(src, dest,mail_subject, msg_mail,subtype='html')
                self.pool.get('cci_email_sended').create(cr,uid,{'name':u'Inscription et event confirmés',
                                                                 'subject':mail_subject,
                                                                 'body':msg_mail,
                                                                 'ressource':'event.registration:'+str(reg.id)+':',
                                                                 'addr_from':src,
                                                                 'addrs_to':'['+','.join(dest)+']',
                                                                })
            if not src:
                raise osv.except_osv(_('Error!'), _('You must define a reply-to address in order to mail the participant. You can do this in the Mailing tab of your event. Note that this is also the place where you can configure your event to not send emails automaticly while registering'))
        return False

    # this method overwrites the parent method to make it more adapted to CCI events
    # and more personalisable
    def mail_user(self,cr,uid,ids):
        parameter_obj = self.pool.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['BDDeTest'])
        BD_DE_TEST = True
        if param_values.has_key('BDDeTest'):
            if param_values['BDDeTest'] == 0:
                BD_DE_TEST = False
        tags = re.compile('{PERSO .*?}',re.IGNORECASE)
        regs=self.browse(cr,uid,ids)
        for reg in regs:
            msg_mail = ''
            if reg.event_id.state in ['confirm','running']:
                if reg.event_id.mail_auto_confirm:
                    msg_mail = self.personalize_text(cr,uid,tags,reg.event_id.mail_confirm,reg)
            else:
                if reg.event_id.mail_auto_registr:
                    msg_mail = self.personalize_text(cr,uid,tags,reg.event_id.mail_registr,reg)
            flag = ''
            src = reg.event_id.reply_to or False
            dest = []
            if reg.email_from:
                dest += [reg.email_from]
                if reg.email_cc:
                    dest += [reg.email_cc]
            if (reg.event_id.mail_auto_confirm or reg.event_id.mail_auto_registr) and msg_mail:
                if dest and src:
                    if (reg.event_id.state in ['confirm','running']) and reg.event_id.mail_auto_confirm :
                        flag = 't'
                        if reg.event_id.subject_confirm:
                            mail_subject = reg.event_id.subject_confirm.strip()
                        else:
                            mail_subject = 'Infos pratiques %s'
                        if '%s' not in mail_subject:
                            mail_subject += ' %s'
                        mail_subject = mail_subject % ( reg.event_id.name_on_site and reg.event_id.name_on_site or reg.event_id.product_id.name )
                        if BD_DE_TEST:
                            print "------------ Msg to send --------------------"
                            print "From : " + src
                            print "To : " + ','.join(dest)
                            print "Subject : " + mail_subject
                            print "Body :\n" + msg_mail
                        else:
                            tools.email_send(src, dest,mail_subject, msg_mail,subtype='html')
                        self.pool.get('cci_email_sended').create(cr,uid,{'name':u'Confirmation inscription (1)',
                                                                         'subject':mail_subject,
                                                                         'body':msg_mail,
                                                                         'ressource':'event.registration:'+str(reg.id)+':',
                                                                         'addr_from':src,
                                                                         'addrs_to':'['+','.join(dest)+']'
                                                                        })
                    if reg.event_id.state in ['draft', 'fixed', 'open','confirm','running'] and reg.event_id.mail_auto_registr and not flag:
                        if reg.event_id.subject_register:
                            mail_subject = reg.event_id.subject_register.strip()
                        else:
                            mail_subject = 'Confirmation inscription %s'
                        if '%s' not in mail_subject:
                            mail_subject += ' %s'
                        mail_subject = mail_subject %( reg.event_id.name_on_site and reg.event_id.name_on_site or reg.event_id.product_id.name)
                        if BD_DE_TEST:
                            print "------------ Msg to send --------------------"
                            print "From : " + src
                            print "To : " + ','.join(dest)
                            print "Subject : " + mail_subject
                            print "Body :\n" + msg_mail
                        else:
                            tools.email_send(src, dest,mail_subject, msg_mail,subtype='html')
                        self.pool.get('cci_email_sended').create(cr,uid,{'name':u'Confirmation inscription (2)',
                                                                         'subject':mail_subject,
                                                                         'body':msg_mail,
                                                                         'ressource':'event.registration:'+str(reg.id)+':',
                                                                         'addr_from':src,
                                                                         'addrs_to':'['+','.join(dest)+']'
                                                                        })
                if not src:
                    raise osv.except_osv(_('Error!'), _('You must define a reply-to address in order to mail the participant. You can do this in the Mailing tab of your event. Note that this is also the place where you can configure your event to not send emails automaticly while registering'))
        return False
    def get_member_data(self,cr,uid,data_event,partner_invoice_id,contact_id,context):
        if data_event.product_id:
            data = {}
            if contact_id:
                data_contact = self.pool.get('res.partner.contact').browse(cr,uid,contact_id)
            else:
                data_contact = False
            if not partner_invoice_id:
                data['training_authorization']=False
                #if data_contact and data_contact.is_premium:
                #    context['force_member'] = True
                data['unit_price']=self.pool.get('product.product').price_get(cr, uid, [data_event.product_id.id],ptype='member_price',context=context)[data_event.product_id.id]
                if context.has_key('force_member'):
                    context['force_member'] = False
                return data
            data_partner = self.pool.get('res.partner').browse(cr,uid,partner_invoice_id)
            context.update({'partner_id':data_partner and data_partner.id})
            #if data_contact and data_contact.is_premium:
            #    context['force_member'] = True
            data['unit_price']=self.pool.get('product.product').price_get(cr, uid, [data_event.product_id.id],ptype='member_price',context=context)[data_event.product_id.id]
            if context.has_key('force_member'):
                context['force_member'] = False
            return data
        else:
            return {'unit_price' : False,'invoice_label' : False}
    def onchange_event2(self, cr, uid, ids, event_id, partner_id, partner_invoice_id, contact_id,context={}):
        if not event_id:
            return {'value':{'unit_price' : False ,'invoice_label' : False }}
        data_event = self.pool.get('event.event').browse(cr,uid,event_id)
        data = self.get_member_data(cr,uid,data_event,partner_invoice_id or partner_id,contact_id,context)
        if data_event and data_event.product_id:
            data['invoice_label'] = data_event.product_id.name
        else:
            data['invoice_label'] = ""
        return {'value':data}
    def onchange_partner_id2(self, cr, uid, ids, partner_id, event_id, partner_invoice_id, contact_id, email=False):
        data={}
        data['badge_partner'] = data['contact_id'] = data['partner_invoice_id'] = data['email_from'] = data['badge_title'] = data['badge_name'] = False
        if not partner_id:
            return {'value':data}
        #raise an error if the partner cannot participate to event.
        badge_part = False
        warning = False
        if partner_id:
            data_partner = self.pool.get('res.partner').browse(cr,uid,partner_id)
            if data_partner.alert_events:
                warning = {
                    'title': "Warning:",
                    'message': data_partner.alert_explanation or 'Partner is not valid but there is no explanation on partner, only the \'event warning\' selected'
                        }
            if data_partner.badge_partner:
                badge_part = data_partner.badge_partner
        data['partner_invoice_id']=partner_id
        # this calls onchange_partner_invoice_id
        d = self.onchange_partner_invoice_id2(cr, uid, ids, partner_invoice_id, event_id, partner_id, contact_id)
        # this updates the dictionary
        data.update(d['value'])
        addr = self.pool.get('res.partner').address_get(cr, uid, [partner_id])
        if addr:
            if addr.has_key('default'):
                job_ids = self.pool.get('res.partner.job').search(cr, uid, [('address_id','=',addr['default'])])
                if job_ids:
                    data['contact_id'] = self.pool.get('res.partner.job').browse(cr, uid, job_ids[0]).contact_id.id
                    d = self.onchange_contact_id2(cr, uid, ids, data['contact_id'], event_id, partner_id, partner_invoice_id)
                    data.update(d['value'])
        partner_data = self.pool.get('res.partner').browse(cr, uid, partner_id)
        data['badge_partner'] = partner_data.name
        data = {'value':data}
        if badge_part:
            data['value']['badge_partner'] = badge_part
        if warning:
            data['warning'] =  warning
        print data
        return data
    def onchange_partner_invoice_id2(self, cr, uid, ids, partner_invoice_id, event_id, partner_id, contact_id, context={}):
        data={}
        data['training_authorization']=data['unit_price']=False
        if partner_invoice_id:
            data_partner = self.pool.get('res.partner').browse(cr,uid,partner_invoice_id)
            data['training_authorization']=data_partner.training_authorization
        if not event_id:
            return {'value':data}
        data_event =  self.pool.get('event.event').browse(cr,uid,event_id)
        data = self.get_member_data(cr,uid,data_event,partner_invoice_id,contact_id,context)
        return {'value':data}
    def onchange_contact_id2(self, cr, uid, ids, contact_id, event_id, partner_id, partner_invoice_id,context={}):
        warning = False
        data ={}
        data['email_from'] = ''
        if not contact_id:
            data['badge_name'] = ''
            data['badge_title'] = ''
            d = self.onchange_badge_name(cr, uid, ids,data['badge_name'])
            if d:
                data.update(d['value'])
            if event_id:
                data_event =  self.pool.get('event.event').browse(cr,uid,event_id)
                data.update(self.get_member_data(cr,uid,data_event,partner_invoice_id or partner_id,contact_id,context))
        else:
            contact = self.pool.get('res.partner.contact').browse(cr, uid, contact_id)
            data['badge_name'] = contact.badge_name and contact.badge_name or ( contact.name + ' ' + ( contact.first_name or '') ).strip()
            data['badge_title'] = contact.badge_title and contact.badge_title or contact.title
            if partner_id:
                partner_addresses = self.pool.get('res.partner.address').search(cr, uid, [('partner_id','=',partner_id)])
                job_ids = self.pool.get('res.partner.job').search(cr, uid, [('contact_id','=',contact_id),('address_id','in',partner_addresses)])
                if job_ids:
                    data['email_from'] = self.pool.get('res.partner.job').browse(cr, uid, job_ids[0]).email
                    data['badge_title'] = self.pool.get('res.partner.job').browse(cr, uid, job_ids[0]).function_label or ''
            if not data['email_from'] and contact.email:
                data['email_from'] = contact.email
            d = self.onchange_badge_name(cr, uid, ids,data['badge_name'])
            data.update(d['value'])
            if event_id:
                # check if this person is not already registered on this event
                other_ids = self.search(cr,uid,[('contact_id','=',contact_id),('id','not in',ids),('event_id','=',event_id)])
                if other_ids:
                    warning = {
                        'title': "Warning:",
                        'message': u'This person is already registrered on this event. Only a warning...',
                        }
                data_event =  self.pool.get('event.event').browse(cr,uid,event_id)
                data.update(self.get_member_data(cr,uid,data_event,partner_invoice_id or partner_id,contact_id,context))
        if warning:
            return {'warning':warning,'value':data}
        else:
            return {'value':data}
    def create(self, cr, uid, vals, *args, **kwargs):
        if vals['name'] == 'Registration:' or vals['name'] == 'Registration':
            vals['name'] = False # to be sure to have the contact name with 'Registration'
        if vals.has_key('comments') and vals['comments']:
            vals['comments'] = vals['comments'].decode('utf-8') ## to prevent a bug in cci_event module wich we can't modify because it is certified
        return super(event_registration,self).create(cr, uid, vals, *args, **kwargs)
event_registration()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

