# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import datetime
import tools
import pooler
import base64
from pyExcelerator import *
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="from_date" colspan="4"/>
</form>"""

fields = {
    'from_date': {'string': 'From', 'type':'date','required': True},
   }

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="control_analytic_events.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'control_analytic_events.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class control_analytic_events(wizard.interface):
    def _get_defaults(self,cr,uid,data,context):
        data['form']['from_date'] = (datetime.date.today() - datetime.timedelta(3*365/12)).strftime('%Y-%m-%d')
        return data['form']
    def _get_file(self,cr,uid,data,context):
        event_obj = pooler.get_pool(cr.dbname).get('event.event')
        event_ids = event_obj.search(cr,uid,[('date_begin','>=',data['form']['from_date'])])
        if event_ids:
            events = event_obj.browse(cr,uid,event_ids)
            def_analytic_obj = pooler.get_pool(cr.dbname).get('account.analytic.default')
            wb1 = Workbook()
            ws1 = wb1.add_sheet('Events')
            ws1.write(0,0,'event id')
            ws1.write(0,1,'product id')
            ws1.write(0,2,'dist id')
            ws1.write(0,3,_('Event'))
            ws1.write(0,4,_('Date'))
            ws1.write(0,5,_('Product'))
            ws1.write(0,6,_('Distribution'))
            ws1.write(0,7,_('Account'))
            ws1.write(0,8,_('TVA code(s)'))
            ws1.write(0,9,_('Type of Event'))
            ws1.write(0,10,_('Type of Product'))
            line = 1
            for event in events:
                dist_id = 0
                dist_name = u'!!! No Analytic Distribution by Default !!!'
                tva_codes = ''
                if event.product_id:
                    def_ids = def_analytic_obj.search(cr,uid,[('product_id','=',event.product_id.id)])
                    if def_ids:
                        if len(def_ids) == 1:
                            default_analytic = def_analytic_obj.browse(cr,uid,def_ids[0])
                            if default_analytic.analytics_id:
                                dist_id = default_analytic.analytics_id.id
                                dist_name = default_analytic.analytics_id.name
                            else:
                                dist_name = u'!!! Forget to define analytic distribution on default value !!!'
                        else:
                            dist_name = u'!!! Multiple Distributions Defined !!!'
                    if event.product_id.taxes_id:
                        for tax_definition in event.product_id.taxes_id:
                            tva_codes += (', ' + tax_definition.name)
                        tva_codes = tva_codes[2:] # to delete the first comma
                ws1.write(line,0,event.id)
                ws1.write(line,1,event.product_id and event.product_id.id or 0)
                ws1.write(line,2,dist_id)
                ws1.write(line,3,event.name)
                ws1.write(line,4,event.date_begin)
                ws1.write(line,5,event.product_id and event.product_id.name or '')
                ws1.write(line,6,dist_name)
                ws1.write(line,7,(event.product_id and event.product_id.property_account_income) and (event.product_id.property_account_income.code + ' ' + event.product_id.property_account_income.name) or '')
                ws1.write(line,8,tva_codes)
                ws1.write(line,9,event.type and event.type.name or '')
                ws1.write(line,10,(event.product_id and event.product_id.categ_id) and event.product_id.categ_id.name or '')
                line += 1
            wb1.save('control_analytic_events.xls')
            result_file = open('control_analytic_events.xls','rb').read()

            # give the result tos the user
            data['form']['msg']='Save the File with '".xls"' extension.'
            data['form']['control_analytic_events.xls']=base64.encodestring(result_file)
        else:
            darta['form']['msg'] = 'No events from ' + data['form']['from_date']
        return data['form']

    states = {
        'init': {
            'actions': [_get_defaults],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('getfile','Get Excel File')]},
        },
        'getfile': {
            'actions': [_get_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

control_analytic_events('control_analytic_events')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

