# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
#import re
import tools
import pooler
import base64
import dbf

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="choice" colspan="4"/>
    <field name="category_id" colspan="4" width="600"/>
</form>"""

fields = {
    'choice': {'string': 'Selection', 'type':'selection','selection': [('all','Toutes les inscriptions'),('selected','Seulement les actives')],'required': True,'default':'all'},
    'category_id': {'string': 'Activity Sectors Root', 'type':'many2one','relation': 'res.partner.category','required': True},
   }

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="carousel.dbf" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'carousel.dbf':{'string': 'Prepared file',
        'type': 'binary',
        'readonly': True,},
}

class wizard_extract_carousel(wizard.interface):

    def _get_file(self,cr,uid,data,context):

        # we search for the ID of the CCI to correctly identify participers of this special partner
        cci_partner_id = 0
        obj_company = pooler.get_pool(cr.dbname).get('res.company')
        companies = obj_company.search(cr,uid,[('parent_id','=',False)])
        if companies:
            company = obj_company.read(cr,uid,companies[0],['partner_id'])
            cci_partner_id = company['partner_id'][0]

        obj_registration = pooler.get_pool(cr.dbname).get('event.registration')

        # extract all ids of activity sector categories and keep only what is between [] ('[303]') in name
        obj_categ = pooler.get_pool(cr.dbname).get('res.partner.category')
        old_len = 0
        categ_ids = [ data['form']['category_id'] ]
        while len(categ_ids) > old_len:
            new_ids = categ_ids[old_len:] # ids of categories added last time
            old_len = len(categ_ids) # the new frontier ...
            new_categs = obj_categ.read(cr,uid,new_ids,['child_ids'])
            for categ in new_categs:
                if categ['child_ids']:
                    categ_ids.extend(categ['child_ids'])
        categs = obj_categ.read(cr,uid,categ_ids,['name'],{'lang':'fr_FR'})
        dCategs = {}
        for categ in categs:
            formated_name = categ['name']
            posA = formated_name.rfind('[')
            posB = formated_name.rfind(']')
            if posA > 0 and posB > 0 and posA < posB:
                formated_name = formated_name[posA+1:posB]
            dCategs[ categ['id'] ] = formated_name

        # search the registrations linked to the selected events
        if data['form']['choice'] == 'all':
            reg_ids = obj_registration.search(cr,uid,[('event_id','in',data['ids'])])
        else:
            reg_ids = obj_registration.search(cr,uid,[('event_id','in',data['ids']),('state','in',['open','done'])])
        if reg_ids:
            registrations = obj_registration.browse(cr,uid,reg_ids)
        else:
            registrations = []

        table = dbf.Table('carousel.dbf',field_specs='Civilite C(20); TradCiv1 C(25); TradCiv2 C(25); Nom C(25); Titre C(45); Societe C(45); Adresse C(45); Localite C(45); Tel C(30); Fax C(30); EMail C(50); Montant N(15,2); Paiement C(9); Facture C(12); MbrePaye L; MbreClie L; Groupe C(45); Signet C(5); Logo C(250); Photo C(250); RefEntity C(8); RefContact C(8); RefClient C(8); Secteur C(5); Service1 I; Service2 I; Service3 I; CCI L; Present L; Inscrit L; WebURL C(100); ID I', dbf_type='vfp', codepage='cp850' )
        table.open()
        for reg in registrations:
            # construction of the full name
            full_name = reg.contact_id.name or ''
            if reg.contact_id.first_name:
                full_name = full_name + ' ' + reg.contact_id.first_name
            # research of the concerned job and address if this contact has multiple jobs or this partner has multiple address
            current_partner = False
            current_address = False
            current_job = False
            if reg.partner_id:
                current_partner = reg.partner_id
                if len(reg.partner_id.address) == 1:
                    current_address = reg.partner_id.address[0]
                    for job in current_address.job_ids:
                        if job.contact_id.id == reg.contact_id.id:
                            current_job = job
                else:
                    if reg.partner_id.address:
                        # some addresses to search for
                        for addr in reg.partner_id.address:
                            for job in addr.job_ids:
                                if job.contact_id.id == reg.contact_id.id:
                                    current_job = job
            # get the sector of activity
            sector = ''
            for activ in reg.partner_id.category_id:
                if dCategs.has_key( activ.id ):
                    sector = dCategs[ activ.id ]
                    break
            table.append( (reg.contact_id.title or 'Monsieur',
                           '',
                           '',
                           full_name[:25],
                           (current_job and current_job.function_label or '')[:45],
                           (current_partner and current_partner.name or '')[:45],
                           '',
                           '',
                           '',
                           '',
                           '',
                           0.0,
                           '',
                           '',
                           False,
                           False,
                           '',
                           '',
                           '',
                           '',
                           'P' + str( current_partner and current_partner.id or 0 ),
                           'C' + str( reg.contact_id.id ),
                           'P' + str( current_partner and current_partner.id or 0),
                           sector[:5],
                           0,
                           0,
                           0,
                           current_partner.id == cci_partner_id,
                           False,
                           False,
                           '',
                           reg.id
                          ) )
        table.close()
        result_file = open('carousel.dbf','rb').read()

        # give the result tos the user
        data['form']['msg']='Save the File with '".dbf"' extension.'
        data['form']['carousel.dbf']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('getfile','Get DBF File')]},
        },
        'getfile': {
            'actions': [_get_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

wizard_extract_carousel('cci_event_extend.extract_registrations_for_carousel')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

