# -*- coding: utf-8 -*-
##############################################################################
#    
#    Copyright (c) 2009 CCI  ASBL. (<http://www.ccilconnect.be>).
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields, osv
import time
import datetime

class external_prospection_list(osv.osv):
    _name = "external_prospection.list"
    _description = "List of prospects for follow up by external partners"
    _columns = {
        'name': fields.char('Name', required=True, size=64),
        'comments': fields.text('Comments'), #  in minimum the list of criterium for creating this list
        # actually, the refresh of the list after some days is not considered but if necessary,
        # we'll need the way of re-applying the criterium of selection to adapt the list to current data
        'user_ids': fields.many2many('res.users', 'external_list_access','list_id','user_id', 'Users'),
    }
external_prospection_list()

class external_prospection_partner(osv.osv):
    _name = "external_prospection.partner"
    _description = "Prospect for an external prospection"
    _columns = {
        'list_id':fields.many2one('external_prospection.list',"List",required=True),
        'partner_id':fields.many2one('res.partner','Partner',required=True),
        # draft = to be prospected by external partner
        # current = locked by a worker of the external partner for managing working on the same list by several workers simultaneously
        # done = prospection by external partner considered done, positively or not
        # treated = comments converted in data on partner records by internal worker of the CCI
        'state':fields.selection([('draft','Draft'),('current','Current'),('done','Done'),('treated','Internaly managed')],'State'),
        'comments':fields.text('Comments'),
        'date_followup':fields.date('Follow-Up'),
    }
    _defaults = {
        'state': lambda *a: 'draft',
    }
external_prospection_partner()
