# -*- encoding: utf-8 -*-

from osv import fields, osv
import time

class cci_extract_result_line(osv.osv):
    _name = "cci.extract.result.line"
    _description = "cci.extract.result.line"
    _columns = {
        'name'       : fields.char('Name',size=64, required=True),
        'result_id'  : fields.many2one('cci.extract.result','Result', required=True, ondelete='cascade', select=1),
        'extract_id' : fields.related('result_id','extract_id',string='Extract',type='many2one',relation='cci.extract', select=1),
        
        'partner_id' : fields.integer('Partner'),
        'address_id' : fields.integer('Address'), 
        'job_id'     : fields.integer('Job'), 
        'contact_id' : fields.integer('Contact'),
        
        'partner_name' : fields.char('Partner name', size=128, select=1),
        'partner_full_name' : fields.char('Partner full name', size=128),
        'partner_title': fields.char('Partner title', size=32),
        'partner_membership_state': fields.char('Partner membership state',size=32),
        'partner_state_id': fields.integer('Partner state'),
        'partner_vat': fields.char('Partner vat',size=32),
        'partner_user': fields.char('Partner user',size=64),
        'partner_state': fields.char('Partner state',size=50),
        'partner_employee_nbr': fields.integer('Partner state'),
        'partner_category' : fields.char('Partner full name', size=128),
        'partner_website' : fields.char('Partner website', size=64),
        
        'address_name': fields.char('Address name', size=128),
        'address_type': fields.char('Address type',size=16),
        'address_street': fields.char('Address street',size=128),
        'address_street2': fields.char('Address street 2',size=128),
        'address_zip': fields.char('Address zip',size=24),
        'address_city': fields.char('Address city',size=128),
        'address_country': fields.char('Address country',size=64),
        'address_phone': fields.char('Address phone',size=64),
        'address_fax': fields.char('Address fax',size=64),
        'address_email': fields.char('Address email',size=240),
        'partner_type' : fields.char('Address type', size=32),
        
        'job_function_label': fields.char('Job function code',size=128),
        'job_function_code_label': fields.char('Job function code label',size=128),
        'job_phone': fields.char('Job phone',size=64),
        'job_fax': fields.char('Job fax',size=64),
        'job_email': fields.char('Job email',size=240),
        
        'contact_name': fields.char('Contact name',size=30),
        'contact_first_name': fields.char('Contact first name',size=30),
        'contact_title': fields.char('Contact title',size=16),
        'contact_mobile': fields.char('Contact mobile',size=64),
        'contact_email': fields.char('Contact email',size=240),
    }
        
cci_extract_result_line() 
