# -*- encoding: utf-8 -*-

from osv import fields, osv
import time
import string
import cci_extract_bootstrap
import os
import tools

# Fusion avec les autres colonnes
columns = {
    'name'                         : fields.char('Name',size=256, required=True, select=1),
    'description'                  : fields.text('Description'),    
    
    'creation_date'                : fields.date('creation date'),
    
    'code_to_evaluate'             : fields.text('Python code to evaluate (return constraints)'),
    'target_model'                 : fields.selection(
        [   ('partner','Partner'),
            ('address','Address'),
            ('job','Job')], 
        'Target model', 
        required=True, 
        select=1),
    
    'parameter_regex'              : fields.char('Parameter Regex',size=255),
    'parameter_fail_message'       : fields.text('Parameter Fail Message'),
    
    'sequence': fields.integer('Sequence'),
} 
columns = dict(columns.items() + cci_extract_bootstrap.get_fields_required().items())    

class cci_extract_rule_model(osv.osv):
    _name = "cci.extract.rule.model"
    _description = "cci.extract.rule.model"
    _columns = columns
    
    _defaults = {
        'parameter_text_required'  : lambda *a: False,
        'parameter_fail_message'   : lambda *a: "Paramètre invalide",
        'parameter_regex'          : lambda *a: "^Regex$",
        'sequence'                 : lambda *a: 999999,
    }
    
    _order = 'sequence'
    
    def copy(self, cr, uid, source_id, default=None, context=None):
        
        default['rule_ids'] = False
        
        return super(cci_extract_rule_model,self).copy(cr, uid, source_id, default, context)  

    def get_relation_X_answer(self,cr,target,answer_id):

        tables = {
            'partner' : 'res_partner',
            'address' : 'res_partner_address',
            'job'     : 'res_partner_job',
            'contact' : 'res_partner_contact'
        }
        
        rel = target
        if target == "job":
            rel = "jobs"
        if tools.config['debug_mode']:
            pass
            #print tables
            #print target
            #print answer_id
        request = """
            select id 
            from (
                select """+target+""" as id, answer 
                from """+rel+"""_question_rel 
                where answer = """ + str(answer_id) + """ )a 
            natural join (select id from """ + tables[target] +" where active = true)b"
        
        #print request
        cr.execute(request)
                
        ids = []
        for (id) in cr.fetchall():
            ids.append(id)
        
        return ids   

    def get_first_X_ids(self,cr,code):
        
        request = """
            select min(id) as id, address_id
            from (
	            select min(CASE WHEN sequence_partner IS NULL THEN 0 ELSE sequence_partner END) 
	                as sequence_partner, address_id
	            from res_partner_job
	            where function_code_label like '%%%s%%' and active = true
	            group by address_id)a
            natural join (
	            select id, CASE WHEN sequence_partner IS NULL THEN 0 ELSE sequence_partner END, 
	                address_id
	            from res_partner_job
	            where function_code_label like '%%%s%%' and active = true)b
            group by a.address_id;""" % (code or 'G', code or 'G')
        
        #print request
        cr.execute(request)
                
        job_ids     = []
        for (job_id,address_id) in cr.fetchall():
            job_ids.append(job_id)
        
        return job_ids  

    def get_addresses_with_min_count_of_function_code(self, cr, min_count, functions):
        
        address_jobs_dict = {}
        for code in functions:
            request="""
                select address_id, id
                from res_partner_job 
                where function_code_label like '%%%s%%' and active = 't'""" % (code)

            cr.execute(request)

            for (address_id, job_id) in cr.fetchall():
                if not address_jobs_dict.has_key(address_id):
                    address_jobs_dict[address_id] = []
                if not job_id in address_jobs_dict[address_id]:
                    address_jobs_dict[address_id].append(job_id)

        address_ids = []
        for address_id, job_ids in address_jobs_dict.items():
            if len(job_ids) >= min_count:
                address_ids.append(address_id)

        return address_ids 
          
        
cci_extract_rule_model() 

content = ''
f = open(os.path.dirname(os.path.abspath(__file__))+'/view/x_view_extract_rule_model.xml', 'r')
content = f.read()
f.close()

for type_filter in ['integer','text','date','selection','relation']:

    view_content = '<newline/>' 
    for field_name in cci_extract_bootstrap.get_fields_required_names(type_filter):
        view_content = view_content + '<field name="' + field_name + '"/><newline/>'
        
    content = content.replace('<!-- Placeholder : %s -->' % type_filter,view_content)      
    
f = open(os.path.dirname(os.path.abspath(__file__))+'/view/view_extract_rule_model.xml', 'w')
f.write(content)
f.close()
