# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import time
import cci_tools
import cci_extract_bootstrap
import string

def _get_initial_values(self, cr, uid, data, res_get=False):
    
    rule_id = data['id']
    content = cci_tools.read(cr,uid,
        'cci.extract.rule',
        [rule_id],
        ['model_id','extract_id','readonly'])[0]
    #cci_tools.write(cr,uid,'cci.extract.rule',data['ids'],{'extract_id' : content['extract_id'][0]})
    
    return {
        'model_id'           : content['model_id'][0],
        'old_model_id'       : content['model_id'][0],
        'current_state_index': 1,
        'readonly': content['readonly']
    }
    
def _next_state(self, cr, uid, data, context=False):

    model_id = data['form']['model_id']
    fields = cci_extract_bootstrap.get_fields_required_names()
    content = cci_tools.read(cr,uid,'cci.extract.rule.model',[model_id],[])[0]
    
    next_state = 'save'
    current_state_index = data['form']['current_state_index']
    if len(data['form']) == 4:
        current_state_index = 1
    for field in fields:
        value = content[field]
        if value:
            if current_state_index == 1:
                next_state = field[0:len(field)-len("_required")]
                break
            current_state_index = current_state_index - 1;

    return next_state
    
def _next_state_content(self, cr, uid, data, res_get=False):

    model_id = data['form']['model_id']
    old_model_id = data['form']['old_model_id']    
    next_state = _next_state(self,cr,uid,data)
    
    form = {}
    form['current_state_index'] = data['form']['current_state_index'] + 1
    form[next_state] = False
    
    # On conserve l'ancienne valeur
    if model_id == old_model_id and data['form']['current_state_index'] != 0:
        rule_id = data['id']
        form.update(cci_tools.read(cr,uid,'cci.extract.rule',[rule_id],[next_state])[0])
        
    return form
    
def _save(self, cr, uid, data, res_get=False):
    
    rule_id = data['id']
    #extract_id = cci_tools.read(cr,uid,'cci.extract.rule',[rule_id],['extract_id'])[0]['extract_id'][0]
    #print extract_id
    
    model_id = data['form']['model_id']
    fields = cci_extract_bootstrap.get_fields_required_names()      
    content = cci_tools.read(cr,uid,'cci.extract.rule.model',[model_id],fields)[0]
    
    values = {'model_id':model_id}
    for (key,value) in content.items():
        if key != 'id':
            key = key[0:len(key)-len('_required')]
            if value:
                values[key] = data['form'][key]
            else:
                values[key] = False
                            
    cci_tools.write(cr,uid,'cci.extract.rule',data['ids'],values)
    
    return {}

_fields = dict(cci_extract_bootstrap.get_fields_for_wizard().items() + {
    'model_id'    : {
        'string':'Règle',
        'type':'many2one',
        'relation' : 'cci.extract.rule.model',
        'required':True},
    'readonly'    : {
        'string':'readonly',
        'type':'boolean',},}.items())

_form_rule="""<?xml version="1.0"?>
<form title="Modification d'une règle">
    <field name="model_id" colspan="4"/>
</form>
"""
_states = {}
_states['rule'] = {
    'actions' : [_next_state_content],
    'result'  : {
        'type': 'form',
        'arch': _form_rule,
        'fields': _fields,
        'state':[('end','Cancel'),('next_state','Suivant')]}}

_form_general="""<?xml version="1.0"?>
<form title="Modification d'une règle">
    <field name="readonly" colspan="4" invisible="True"/>
    <field name="%s" colspan="4" required="True" attrs="{'readonly':[('readonly','=',True)]}"/>
</form>
"""
_form_answer="""<?xml version="1.0"?>
<form title="Modification d'une règle">
    <field name="readonly" colspan="4" invisible="True"/>
    <field name="%s" colspan="4" invisible="True"/>
    <field name="%s" colspan="4" required="True"  attrs="{'readonly':[('readonly','=',True)]}"
    domain="[('question_id','!=',False),('question_id','=', %s)]"/>
</form>
"""

fields_to_state = cci_extract_bootstrap.get_fields_objects_names()
for field in fields_to_state:
    if 'answer' in field:
        answer_name = string.replace(field,'answer','question')
        _states[field] = {
            'actions' : [_next_state_content],
            'result'  : {
                'type': 'form',
                'arch': _form_answer % (answer_name,field,answer_name),
                'fields': _fields,
                'state':[('end','Cancel'),('next_state','Suivant')]}}   
    else:
        _states[field] = {
            'actions' : [_next_state_content],
            'result'  : {
                'type': 'form',
                'arch': _form_general % field,
                'fields': _fields,
                'state':[('end','Cancel'),('next_state','Suivant')]}}

class cci_traform_wizard_rule(wizard.interface):

    states = dict(_states.items() + {
        'init' : {
            'actions' : [_get_initial_values],
            'result'  : {'type': 'state', 'state': 'next_state'}},
        'next_state' : {
            'actions' : [],
            'result'  : { 'type':'choice', 'next_state':_next_state}},
        'save' : {
            'actions' : [_save],
            'result'  : {'type': 'state', 'state':'end'}},
    }.items())

cci_traform_wizard_rule('cci.extract.wizard.rule')
