# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import time
import cci_tools
import cci_extract_bootstrap
import string

def _get_initial_values(self, cr, uid, data, res_get=False):
    
    rule_id = data['id']
    content = cci_tools.read(cr,uid,'cci.extract.rule',[rule_id],['model_id','readonly'])[0]
    
    return {
        'model_id': content['model_id'][0],
        'readonly': content['readonly']
    }
    
def _save(self, cr, uid, data, res_get=False):
    
    values = {
        'model_id' : data['form']['model_id']
    }     
    cci_tools.write(cr,uid,'cci.extract.rule',data['ids'],values)
    
    return {}

_fields = {
    'model_id' : {
        'string':'Règle',
        'type':'many2one',
        'relation' : 'cci.extract.rule.model',
        'required':True},
    'readonly'    : {
        'string':'readonly',
        'type':'boolean'}
}

_form_model="""<?xml version="1.0"?>
<form title="Modification d'une règle">
    <field name="readonly" colspan="4" invisible="True"/>
    <field name="model_id" colspan="4"  attrs="{'readonly':[('readonly','=',True)]}"/>
</form>
"""

class cci_traform_wizard_rule_model(wizard.interface):

    states = {
        'init' : {
            'actions' : [_get_initial_values],
            'result'  : {
                'type': 'form',
                'arch': _form_model,
                'fields': _fields,
                'state':[('end','Cancel'),('save','Sauvegarder')]}},
        'save' : {
            'actions' : [_save],
            'result'  : {'type': 'state', 'state':'end'}},
    }

cci_traform_wizard_rule_model('cci.extract.wizard.rule.model')
