# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
from osv import fields,osv
import wizard
import pooler
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Change Domiciliation Status">
    <field name="domiciled" colspan="4"/>
    <field name="domiciled_send_date" colspan="4"/>
</form>"""

fields = {
    'domiciled' : {'string':'Domiciled','type':'boolean'},
    'domiciled_send_date': {'string':'Domiciliation Send Date','type':'date'},
   }

class wizard_change_inv_dom(wizard.interface):
    def _get_defaults(self, cr, uid, data, context):
        if len(data['ids']) == 1:
            pool_obj = pooler.get_pool(cr.dbname)
            invoice_obj = pool_obj.get('account.invoice')
            current_inv = invoice_obj.browse(cr,uid,data['ids'][0])
            fields['domiciled']['default'] = current_inv.domiciled
            fields['domiciled_send_date']['default'] = current_inv.domiciled_send_date
        return data['form']

    def _change_all_lines(self, cr, uid, data, context):
        if data['ids']:
            # correct the account_invoice
            dom_value = data['form']['domiciled'] and 'True' or 'False'
            date_value = data['form']['domiciled_send_date']
            if not date_value:
                date_value = 'NULL'
            else:
                date_value = "'" + date_value + "'"
            list_ids = ','.join([str(x) for x in data['ids']])
            #
            correction = "UPDATE account_invoice set domiciled = %s, domiciled_send_date = %s where id in (%s)" % ( dom_value, date_value, list_ids )
            cr.execute( correction )

            # recording of the asked changes in the CCI Logs
            pool_obj = pooler.get_pool(cr.dbname)
            log_obj = pool_obj.get('cci_logs.line')
            log_obj.create(cr,uid,{'name':'Change Domiciliation',
                                   'datetime':datetime.datetime.now(),
                                   'user_id':uid,
                                   'message':"Domiciliation(s) changed to %s and %s for ids [%s]" % ( dom_value, date_value, list_ids ),
                                  })
        return {'type':'state','state':'end'}
    states = {
        'init': {
            'actions': [_get_defaults],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('change','Change')]},
        },
        'change': {
            'actions': [_change_all_lines],
            'result' : {'type':'state', 'state':'end'}
        },
    }
wizard_change_inv_dom("cci_invoice_extend_change_inv_dom")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
