# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
from osv import fields,osv
import wizard
import pooler
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Correct Non Belgian Invoices">
    <field name="confirm" colspan="4"/>
    <label string="This wizard will apply the fiscal position, so : be sure all concerned partners have a fiscal position" colspan="4"/>
</form>"""

fields = {
    'confirm' : {'string':'Confirm','type':'boolean','default':False},
   }

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <field name="msg" colspan="4" nolabel="1" width="600"/>
</form>"""

msg_fields = {
    'msg': {'string':'Corrected invoices', 'type':'text', 'size':'100','readonly':True},
}

class wizard_correct_strangers(wizard.interface):
    def _apply_fiscal_position(self, cr, uid, data, context):
        corrected = 0
        if data['form']['confirm'] and data['ids']:
            # correct the account_invoice
            pool_obj = pooler.get_pool(cr.dbname)
            invoice_obj = pool_obj.get('account.invoice')
            invoices = invoice_obj.browse(cr,uid,data['ids'])
            obj_lines = pool_obj.get('account.invoice.line')
            for inv in invoices:
                if inv.state == 'draft' and inv.partner_id and inv.partner_id.property_account_position:
                    # apply the fiscal position of the partner
                    fpos = inv.partner_id.property_account_position.id and pool_obj.get('account.fiscal.position').browse(cr, uid, inv.partner_id.property_account_position.id) or False
                    for inv_line in inv.invoice_line:
                        value=obj_lines.product_id_change(cr, uid, [], inv_line.product_id.id,uom =False, partner_id=inv.partner_id.id, fposition_id=inv.partner_id.property_account_position.id)
                        obj_lines.write(cr,uid,[inv_line.id],{'invoice_line_tax_id':[(6,0,value['value']['invoice_line_tax_id'])]})
                    invoice_obj.write(cr,uid,[inv.id],{'fiscal_position':inv.partner_id.property_account_position.id})
                    invoice_obj.button_reset_taxes(cr,uid,[inv.id])
                    corrected += 1
        data['form']['msg'] = _('Corrected Invoices : %s') % str(corrected)
        #return {'type':'state','state':'end'}
        return data['form']
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('apply','Apply')]},
        },
        'apply': {
            'actions': [_apply_fiscal_position],
            'result' : {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
wizard_correct_strangers("cci_invoice_extend_correct_strangers")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
