# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
from osv import fields,osv
import wizard
import pooler
from tools.translate import _

class wizard_find_specials(wizard.interface):

    def _find_specials(self, cr, uid, data, context):
        invoice_ids = []
        if data['ids']:
            # find the customers with invoice_special
            pool_obj = pooler.get_pool(cr.dbname)
            invoice_obj = pool_obj.get('account.invoice')
            invoices = invoice_obj.browse(cr,uid,data['ids'])
            for inv in invoices:
                if inv.partner_id and inv.partner_id.invoice_special:
                    invoice_ids.append(inv.id)
        value = {
            'domain': [('id','in',invoice_ids)],
            'name': _('Special Invoices'),
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'account.invoice',
            'context': {},
            'type': 'ir.actions.act_window',
            }
        return value
    states = {
        'init': {
            'actions': [],
            'result': {'type':'action','action':_find_specials,'state':'end'}
        },
    }
wizard_find_specials("cci_invoice_extend_find_specials")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
