# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2008 CCI Connect ASBL. (http://www.cciconnect.be) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
from osv import fields, osv
import datetime

class line(osv.osv):
    _name = 'cci_logs.line'
    _description = "Recordings of changes"
    _columns = {
        'name':fields.char('Source',size=64,required=True),
        'datetime':fields.datetime('Occurs at'),
        'user_id':fields.many2one('res.users','User'),
        'message':fields.text('Message'),
    }
line()

class cron_line(osv.osv):
    _name = 'cci_logs.cron_line'
    _description = "Recordings of cron tasks"
    _columns = {
        'name':fields.char('Source',size=64),
        'start':fields.datetime('Begin at'),
        'stop':fields.datetime('End at'),
        'good':fields.boolean('Good - Correct result'),
        'comments':fields.text('comments'),
    }
    _defaults = {
        'good': lambda *a: False,
    }
    _order = "start desc"

    def _start(self,cr,uid,name):
        obj_source = self.pool.get('cci_logs.cron_line')
        new_id = obj_source.create(cr,uid,{'name':name,'start':datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S'),'comments':''})
        return new_id
    def _addComment(self,cr,uid,obj_id,comment):
        obj = self.pool.get('cci_logs.cron_line').read(cr,uid,[obj_id],['comments'])[0]
        res = self.pool.get('cci_logs.cron_line').write(cr,uid,[obj_id],{'comments':( obj['comments'] or '')+comment})
        return res
    def _stop(self,cr,uid,obj_id,good=True,final_comment=''):
        obj = self.pool.get('cci_logs.cron_line').read(cr,uid,[obj_id],['comments'])[0]
        res = self.pool.get('cci_logs.cron_line').write(cr,uid,[obj_id],{'stop':datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S'),'good':good,'comments':( obj['comments'] or '')+final_comment})
        return res
cron_line()
