# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import pooler
import datetime
import base64
from pyExcelerator import *
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="only_control" colspan="4"/>
</form>"""

fields = {
    'only_control': {'string': 'Only lists to control', 'type':'boolean','default':True},
   }

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="mag_abo_lists_to_control.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'mag_abo_lists_to_control.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

def french_date(date_as_string):
    if len(date_as_string) == 10:
        result = date_as_string[8:10]+'/'+date_as_string[5:7]+'/'+date_as_string[0:4]
    else:
        result = date_as_string
    return result

class extract_subscriptions_to_control(wizard.interface):

    def _extract(self, cr, uid, data, context):
        obj_source = pooler.get_pool(cr.dbname).get('cci_magazine.subscription_source')
        if data['form']['only_control']:
            selection = [('to_control','=',True)]
        else:
            selection = []
        source_ids = obj_source.search(cr,uid,selection)
        if source_ids:
            dTypes = {'postal':u'Postal',
                      'personal':u'Personnel',
                      'prospect':u'Prospection',
                     }
            dMembership = {'free':u'OUI - Membre Gratuit',
                           'paid':u'OUI - Membre Payant',
                           'invoiced':u'OUI - Membre facturé',
                           'none':u'NON - Non Membre',
                           'old':u'NON-  Ancien Membre',
                          }
            sources = obj_source.read(cr,uid,source_ids,['code','name','last_control','manager_id'])
            dSources = {}
            wb1 = Workbook()
            ws1 = wb1.add_sheet(_('Lists of Control'))
            for source in sources:
                dSources[source['code']] = {'name':source['name'],
                                            'last_control': source['last_control'] or _('-Never-'),
                                            'manager': source['manager_id'] and source['manager_id'][1] or _('-Nobody-'),
                                            'count':0,
                                            'sheet':wb1.add_sheet(source['name']),
                                           }
                dSources[source['code']]['sheet'].write(0,0,source['name'])
                dSources[source['code']]['sheet'].write(1,0,'partner_id')
                dSources[source['code']]['sheet'].write(1,1,'address_id')
                dSources[source['code']]['sheet'].write(1,2,'job_id')
                dSources[source['code']]['sheet'].write(1,3,'contact_id')
                dSources[source['code']]['sheet'].write(1,4,'model')
                dSources[source['code']]['sheet'].write(1,5,'type')
                dSources[source['code']]['sheet'].write(1,6,'partner_name')
                dSources[source['code']]['sheet'].write(1,7,'membership_state')
                dSources[source['code']]['sheet'].write(1,8,'street')
                dSources[source['code']]['sheet'].write(1,9,'street2')
                dSources[source['code']]['sheet'].write(1,10,'city')
                dSources[source['code']]['sheet'].write(1,11,'contact_lname')
                dSources[source['code']]['sheet'].write(1,12,'contact_fname')

            # get all addresses concerned
            selection = """SELECT res1.*, partner.id, partner.name, partner.membership_state
                           FROM
                               (SELECT addr.id, addr.partner_id as partner_id, addr.street, addr.street2, zip.name || ' ' || zip.city,  
                                       addr.magazine_subscription, addr.magazine_subscription_source 
                                FROM res_partner_address as addr, res_partner_zip as zip
                                WHERE addr.active AND addr.zip_id = zip.id AND char_length(addr.magazine_subscription_source)>0 and ( addr.magazine_subscription = 'postal' or addr.magazine_subscription = 'personal'
                                      or ( addr.magazine_subscription = 'prospect' and addr.magazine_subscription_source is not null)) ) as res1
                           LEFT OUTER JOIN (SELECT * from res_partner where active ) as partner ON ( res1.partner_id = partner.id )"""
            
            cr.execute( selection )
            addresses = cr.fetchall()
            for addr in addresses:
                # record the data
                if addr[6] in dSources.keys():
                    source = dSources[addr[6]]
                    source['count'] += 1
                    source['sheet'].write(source['count']+1,0,addr[1] or 0)
                    source['sheet'].write(source['count']+1,1,addr[0])
                    source['sheet'].write(source['count']+1,2,0)
                    source['sheet'].write(source['count']+1,3,0)
                    source['sheet'].write(source['count']+1,4,'adresse')
                    source['sheet'].write(source['count']+1,5,addr[5] or '')
                    source['sheet'].write(source['count']+1,6,addr[8] or '')
                    source['sheet'].write(source['count']+1,7,(addr[9] and dMembership.has_key(addr[9])) and dMembership[addr[9]] or '-')
                    source['sheet'].write(source['count']+1,8,addr[2] or '')
                    source['sheet'].write(source['count']+1,9,addr[3] or '')
                    source['sheet'].write(source['count']+1,10,addr[4] or '')
                    source['sheet'].write(source['count']+1,11,'')
                    source['sheet'].write(source['count']+1,12,'')
                    dSources[addr[6]] = source

            # get all jobs concerned
            selection = """SELECT res1.*, partner.id, partner.name, partner.membership_state
                           FROM
                               (SELECT rpjob.id, contact.id, addr.id, addr.partner_id as partner_id, addr.street, addr.street2,
                                       zip.name || ' ' || zip.city, rpjob.magazine_subscription, rpjob.magazine_subscription_source,
                                       contact.name, contact.first_name 
                                FROM res_partner_job as rpjob, res_partner_contact as contact, res_partner_address as addr, res_partner_zip as zip
                                WHERE rpjob.active and rpjob.address_id = addr.id and rpjob.contact_id = contact.id and contact.active AND char_length(rpjob.magazine_subscription_source)>0
                                      and addr.active AND addr.zip_id = zip.id and ( rpjob.magazine_subscription = 'postal' or rpjob.magazine_subscription = 'personal'
                                      or ( rpjob.magazine_subscription = 'prospect' and rpjob.magazine_subscription_source is not null)) ) as res1
                           LEFT OUTER JOIN (SELECT * from res_partner where active ) as partner ON ( res1.partner_id = partner.id )"""
            cr.execute( selection )
            jobs = cr.fetchall()
            for job in jobs:
                # record the data
                if job[8] in dSources.keys():
                    source = dSources[job[8]]
                    source['count'] += 1
                    source['sheet'].write(source['count']+1,0,job[3] or 0)
                    source['sheet'].write(source['count']+1,1,job[2] or 0)
                    source['sheet'].write(source['count']+1,2,job[0])
                    source['sheet'].write(source['count']+1,3,job[1])
                    source['sheet'].write(source['count']+1,4,'job-function')
                    source['sheet'].write(source['count']+1,5,job[7])
                    source['sheet'].write(source['count']+1,6,job[12] or '')
                    source['sheet'].write(source['count']+1,7,(job[13] and dMembership.has_key(job[13])) and dMembership[job[13]] or '')
                    source['sheet'].write(source['count']+1,8,job[4] or '')
                    source['sheet'].write(source['count']+1,9,job[5] or '')
                    source['sheet'].write(source['count']+1,10,job[6] or '')
                    source['sheet'].write(source['count']+1,11,job[9] or '')
                    source['sheet'].write(source['count']+1,12,job[10] or '')
                    dSources[job[8]] = source
            ws1.write(0,0,_('Global Results'))
            ws1.write(1,0,_('Code'))
            ws1.write(1,1,_('Name'))
            ws1.write(1,2,_('Count'))
            ws1.write(1,3,_('Last Control'))
            ws1.write(1,4,_('Manager'))
            line1 = 2
            codes = dSources.keys()
            codes.sort()
            for code in codes:
                source = dSources[code]
                ws1.write(line1,0,code)
                ws1.write(line1,1,source['name'] or '')
                ws1.write(line1,2,source['count'])
                ws1.write(line1,3,french_date(source['last_control']))
                ws1.write(line1,4,source['manager'])
                line1 += 1

            wb1.save('mag_abo_lists_to_control.xls')
            result_file = open('mag_abo_lists_to_control.xls','rb').read()

            # give the result tos the user
            data['form']['msg']='Save the File with '".xls"' extension.'
            data['form']['mag_abo_lists_to_control.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('getfile','Get Excel File')]},
        },
        'getfile': {
            'actions': [_extract],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
extract_subscriptions_to_control("extract_subscriptions_to_control")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

