# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields
import datetime
import wizard
import pooler
from tools.translate import _

msg_form = """<?xml version="1.0"?>
<form string="Inactivation finished">
     <separator string="The test has been done."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
</form>"""

msg_fields = {
    'msg': {'string':'The test has been done', 'type':'text', 'size':'100','readonly':True},
}

class inactivate_old_jobs(wizard.interface):
    def _launch_method(self,cr,uid,data,context):
        obj_job = pooler.get_pool(cr.dbname).get('res.partner.job')
        ids_list = obj_job._inactivate_old(cr,uid,False)
        data['form']['msg']='Inactivated %s jobs with a past "End Job Date".\nList of id : %s' % (str(len(ids_list)),'[' + ','.join([str(x) for x in ids_list]) + ']')
        return data['form']
                
    states = {
        'init' : {
            'actions' : [_launch_method],
            'result' : {'type' : 'form',
                        'arch': msg_form,
                        'fields' : msg_fields,
                        'state' : [('end','Close')],
            },
        },
    }
inactivate_old_jobs("inactivate_old_jobs")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
