# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import pooler
import datetime
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Correct Emails">
    <field name="from" colspan="4" width="600"/>
    <field name="to" colspan="4" width="600"/>
</form>"""

fields = {
    'from':{'string':'Correct', 'type':'char', 'size': 200, 'required': True},
    'to':{'string':'To', 'type':'char', 'size': 200, 'required': True},
}

final_form = """<?xml version="1.0"?>
<form string="Results">
    <field name="final_count"/>
</form>"""

final_fields = {
    'final_count' : {'string':'Corrections Count','type':'integer','readonly':True,'value':-1}
}

class wizard_correct_emails_in_tables(wizard.interface):
 
    def _correct_data(self, cr, uid, data, context):
        from_string = data['form']['from'].decode('utf-8')
        to_string = data['form']['to'].decode('utf-8')
        if data['ids'] and from_string and to_string and from_string != to_string:
            final_count = 0
            obj_usage = pooler.get_pool(cr.dbname).get('mail_usage')
            usages = obj_usage.read(cr,uid,data['ids'],['id','name','source','source_id'])
            parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
            param_values = parameter_obj.get_value_from_names(cr,uid,['MailTables'])
            if param_values.has_key('MailTables'):
                def_tables = param_values['MailTables']
            else:
                def_tables = [('res.partner.address','email')]
            dTableField = {}
            for table in def_tables:
                dTableField[table[0]] = table[1]
            tables = []
            for usage in usages:
                if usage['source'] not in tables:
                    tables.append(usage['source'])
            if tables:
                for table_name in tables:
                    if dTableField.has_key(table_name):
                        field_name = dTableField[table_name]
                        current_obj =  pooler.get_pool(cr.dbname).get(table_name)
                        for usage in usages:
                            if usage['source'] == table_name:
                                old_email = usage['name']
                                new_email = old_email.replace(from_string,to_string)
                                if old_email != new_email:
                                    current_obj.write(cr,uid,[usage['source_id']],{field_name:new_email})
                                    final_count += 1
            data['form']['final_count'] = final_count
        else:
            data['form']['final_count'] = 0
        # give the result to the user
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('correct','Correct','gtk-execute',True)]}
        },
        'correct' : {
            'actions': [_correct_data],
            'result': {'type':'form', 'arch':final_form, 'fields':final_fields, 'state':[('end','Close')]}
        }
    }
wizard_correct_emails_in_tables("cci_mailchimp_correct_emails")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

