# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
# This wizard searchs for emails addresses in a list of given table
import wizard
import time
import datetime
import pooler
import mailchimp
import base64
from pyExcelerator import *

form = """<?xml version="1.0"?>
<form string="Extract RDP Results">
    <field name="from"/>
    <field name="to"/>
</form>"""

fields = {
    'from': {'string': 'From', 'type':'date','help':'Date of the first Revue de Presse','required':True},
    'to': {'string': 'To', 'type':'date','help':'Date of the last Revue de Presse','required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="res_rdp.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'res_rdp.xls':{'string': 'Prepared file',
        'type': 'binary',
        'readonly': True,},
}

def french_date(string):
    return string[8:10]+"/"+string[5:7]+'/'+string[0:4]
    
class wizard_cci_mailchimp_results_rdp(wizard.interface):

    def _extract(self,cr,uid,data,context):
        # Initialisation of result file
        wb1 = Workbook()
        ws1 = wb1.add_sheet(u'Résultats')
        ws1.write(0,0,u'Comptage Revues de Presse')
        ws1.write(1,0,u'De :')
        ws1.write(2,0,u'à :')
        ws1.write(1,1,french_date(data['form']['from']))
        ws1.write(2,1,french_date(data['form']['to']))
        ws1.write(3,0,u'Seules les revue de presse ayant au moins un résultat (tracking activé) sont présentées ici')
        ws1.write(5,0,u'RDP envoyées :')
        ws1.write(9,0,u'Date')
        ws1.write(8,1,u'Total')
        ws1.write(9,1,u'Envois')
        ws1.write(9,2,u'Ouverts')
        ws1.write(9,3,u'Ouv. uniques')
        ws1.write(9,4,u'Clicks')
        ws1.write(9,5,u'Cl. uniques')
        xls_line = 10
        # Possibles revue de presse
        rdps = {}
        rdps[1] = {'name':u'- BW','count':0}
        rdps[2] = {'name':u'- Hainaut','count':0}
        rdps[3] = {'name':u'- Liège Verviers','count':0}
        rdps[4] = {'name':u'- Namur','count':0}
        rdps[5] = {'name':u'- Wapi','count':0}
        rdps[6] = {'name':u'- VL','count':0}
        rdps[7] = {'name':u'- Inconnue','count':0}
        # connections to mailchimp
        # We get the API key
        parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['MailChimpAPIKey'])
        if param_values.has_key('MailChimpAPIKey'):
            mailchimp_server = mailchimp.Mailchimp(param_values['MailChimpAPIKey'],False)
            mailchimp_campaigns = mailchimp.Campaigns(mailchimp_server)
            mailchimp_reports = mailchimp.Reports(mailchimp_server)
            start = 0
            limit = 25
            result = mailchimp_campaigns.list({'status':'sent'},start,limit,'send_time','DESC')
            total = result['total']
            date_from = data['form']['from']
            date_to = data['form']['to']
            final_count = 0
            dates = []
            dResults = {}
            while start <= ((total / limit ) + 1):
                result = mailchimp_campaigns.list({'status':'sent'},start,limit,'send_time','DESC')
                for line in result['data']:
                    if line['emails_sent'] and line['send_time'][0:10] >= date_from and line['send_time'][0:10] <= date_to:
                        rdp_id = False
                        for (key,rdp) in rdps.items():
                            if rdp['name'] in line['title']:
                                rdp_id = key
                                break
                        if not rdp_id:
                            rdp_id = 6
                        rdps[rdp_id]['count'] += 1
                        resu = {'date':line['send_time'][0:10],
                                'rdp_id':rdp_id,
                                'sendings':line['emails_sent'],
                                'opens':line['summary']['opens'],
                                'u_opens':line['summary']['unique_opens'],
                                'clicks':line['summary']['clicks'],
                                'u_clicks':line['summary']['unique_clicks'],}
                        if line['send_time'][0:10] not in dates:
                            dates.append(line['send_time'][0:10])
                        dResults[(line['send_time'][0:10],rdp_id)] = resu
                        final_count += 1
                start += 1
            final_rdps = []
            for (key,rdp) in rdps.items():
                if rdp['count'] > 0:
                    final_rdps.append(key)
            final_rdps.sort()
            index = 1
            for rdp_id in final_rdps:
                ws1.write(8,(index*5)+1,rdps[rdp_id]['name'][2:])
                ws1.write(9,(index*5)+1,u'Envois')
                ws1.write(9,(index*5)+2,u'Ouverts')
                ws1.write(9,(index*5)+3,u'Ouv. uniques')
                ws1.write(9,(index*5)+4,u'Clicks')
                ws1.write(9,(index*5)+5,u'Cl. uniques')
                index += 1
            dates.sort(reverse=True)
            final_results = {}
            full_list = [0,]
            full_list.extend(final_rdps)
            for rdp_id in full_list: ### 0 will serve for totals
                final_results[rdp_id] = {'sendings':0,'opens':0,'u_opens':0,'clicks':0,'u_clicks':0}
            for date in dates:
                ws1.write(xls_line,0,french_date(date))
                index = 1
                total_sendings = 0
                total_opens = 0
                total_u_opens = 0
                total_clicks = 0
                total_u_clicks = 0
                for rdp_id in final_rdps:
                    if dResults.has_key((date,rdp_id)):
                        ws1.write(xls_line,(index*5)+1,dResults[(date,rdp_id)]['sendings'])
                        ws1.write(xls_line,(index*5)+2,dResults[(date,rdp_id)]['opens'])
                        ws1.write(xls_line,(index*5)+3,dResults[(date,rdp_id)]['u_opens'])
                        ws1.write(xls_line,(index*5)+4,dResults[(date,rdp_id)]['clicks'])
                        ws1.write(xls_line,(index*5)+5,dResults[(date,rdp_id)]['u_clicks'])
                        total_sendings += dResults[(date,rdp_id)]['sendings']
                        total_opens += dResults[(date,rdp_id)]['opens']
                        total_u_opens += dResults[(date,rdp_id)]['u_opens']
                        total_clicks += dResults[(date,rdp_id)]['clicks']
                        total_u_clicks += dResults[(date,rdp_id)]['u_clicks']
                        # cumulates for final line
                        for col in [0,rdp_id]:
                            for column_name in ['sendings','opens','u_opens','clicks','u_clicks']:
                                final_results[col][column_name] += dResults[(date,rdp_id)][column_name]
                    else:
                        ws1.write(xls_line,(index*5)+1,0)
                        ws1.write(xls_line,(index*5)+2,0)
                        ws1.write(xls_line,(index*5)+3,0)
                        ws1.write(xls_line,(index*5)+4,0)
                        ws1.write(xls_line,(index*5)+5,0)
                    index += 1
                ws1.write(xls_line,1,total_sendings)
                ws1.write(xls_line,2,total_opens)
                ws1.write(xls_line,3,total_u_opens)
                ws1.write(xls_line,4,total_clicks)
                ws1.write(xls_line,5,total_u_clicks)
                xls_line += 1
            ws1.write(5,1,final_count)
            ws1.write(xls_line,0,u'Totaux')
            index = 0
            for rdp_id in full_list:
                ws1.write(xls_line,(index*5)+1,final_results[rdp_id]['sendings'])
                ws1.write(xls_line,(index*5)+2,final_results[rdp_id]['opens'])
                ws1.write(xls_line,(index*5)+3,final_results[rdp_id]['u_opens'])
                ws1.write(xls_line,(index*5)+4,final_results[rdp_id]['clicks'])
                ws1.write(xls_line,(index*5)+5,final_results[rdp_id]['u_clicks'])
                index += 1
            # save the final result file
            wb1.save('res_rdp.xls')
            result_file = open('res_rdp.xls','rb').read()

            # give the result to the user
            data['form']['msg']=u'Save the File with \'.xls\' extension.'
            data['form']['res_rdp.xls']=base64.encodestring(result_file)
        else:
            data['form']['msg']=u'The parameter MailChimpAPIKey is missing !\nImpossible to extract something.'
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('extract','Extract','gtk-convert',True)]},
        },
        'extract': {
            'actions': [_extract],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

wizard_cci_mailchimp_results_rdp('cci_mailchimp_results_rdp')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

