# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
# This wizard searchs for emails addresses in a list of given table
import wizard
import time
import datetime
import pooler
import mailchimp
import base64

form = """<?xml version="1.0"?>
<form string="Extract RDP Results for a CCI">
    <field name="from"/>
    <field name="to"/>
    <field name="source" colspan="4"/>
    <field name="emails_to" colspan="4"/>
</form>"""

fields = {
    'from': {'string': 'From', 'type':'date','help':'Date of the first Revue de Presse','required':True},
    'to': {'string': 'To', 'type':'date','help':'Date of the last Revue de Presse','required':True},
    'source':{'string': 'For', 'type':'selection','selection':[('ccibw',u'Brabant Wallon'),('ccih',u'Hainaut'),('ccilv',u'Liège Verviers'),('ccinamur','Namur'),('wapi','WAPI'),('vl','Luxembourg belge')],'required':True},
    'emails_to':{'string':u'Send to','type':'char','size':250,'help':'Can be a list of email addresses separated by a comma','required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <field name="msg" colspan="4" nolabel="1"/>
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
}

def french_date(string):
    return string[8:10]+"/"+string[5:7]+'/'+string[0:4]
    
class wizard_cci_mailchimp_results_rdp_unique(wizard.interface):
    def _extract(self,cr,uid,data,context):
        mailchimp_obj = pooler.get_pool(cr.dbname).get('mailchimp_proxy')
        mailchimp_obj._extract_results_rdp_one(cr,uid,data['form']['source'],False,data['form']['from'],data['form']['to'],data['form']['emails_to'])
        data['form']['msg'] = u'Fichier envoyé par email'
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('extract','Extract','gtk-convert',True)]},
        },
        'extract': {
            'actions': [_extract],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
wizard_cci_mailchimp_results_rdp_unique('cci_mailchimp_results_rdp_unique')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

