# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
# This wizard unsubscribe the user from the list and force the deleting of the user to permit the re-subsribe of this user
import wizard
import time
import datetime
import pooler
import mailchimp
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Subscribe Again Unsubscribed usersEmails">
    <field name="confirm" colspan="4" width="600"/>
</form>"""

fields = {
    'confirm':{'string':'Confirmation', 'type':'boolean', 'help':'You must confirm you\'re trying to SPAM this user'},
}

class wizard_cci_mailchimp_resubscribe(wizard.interface):

    def _resubscribe(self,cr,uid,data,context):
        obj_bounce = pooler.get_pool(cr.dbname).get('mail_bounce')
        bounce_email = obj_bounce.read(cr,uid,data['id'],['name'])['name']
        if bounce_email:
            # We get the API key
            parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
            param_values = parameter_obj.get_value_from_names(cr,uid,['MailChimpAPIKey','MailChimpRDPListID'])
            treated = True
            if param_values.has_key('MailChimpAPIKey') and param_values.has_key('MailChimpRDPListID'):
                MailChimpAPIKey = param_values['MailChimpAPIKey']
                mailchimp_list_id = param_values['MailChimpRDPListID']
                mailchimp_server = mailchimp.Mailchimp(MailChimpAPIKey,False)
                mailchimp_lists = mailchimp.Lists(mailchimp_server)
                try:
                    result = mailchimp_lists.unsubscribe(mailchimp_list_id,{'email':bounce_email},True)
                except mailchimp.EmailNotExistsError:
                    treated = True
                except:
                    treated = False
            if treated:
                obj_bounce.write(cr,uid,[data['id'],],{'active':False})
                obj_contact = pooler.get_pool(cr.dbname).get('res.partner.contact')
                contact_ids = obj_contact.search(cr,uid,[('email','=',bounce_email),('rdp_subscribe','=','unsubscribed')])
                if contact_ids:
                    obj_contact.write(cr,uid,contact_ids,{'rdp_subscribe':'default'})
                obj_job = pooler.get_pool(cr.dbname).get('res.partner.job')
                job_ids = obj_job.search(cr,uid,[('email','=',bounce_email)])
                if job_ids:
                    jobs = obj_job.browse(cr,uid,job_ids)
                    for job in jobs:
                        if job.contact_id and job.contact_id.rdp_subscribe == 'unsubscribed':
                            obj_contact.write(cr,uid,job.contact_id.id,{'rdp_subscribe':'default'})
        return True

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('resubscribe','ReSubscribe','gtk-execute',True)]}
        },
        'resubscribe' : {
            'actions': [],
            'result': {'type':'action','action':_resubscribe,'state':'end'}
        }
    }

wizard_cci_mailchimp_resubscribe('cci_mailchimp_resubscribe')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

