# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
# This wizard searchs for emails addresses in a list of given table
import wizard
import time
import datetime
import pooler
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Search Emails">
    <field name="email" colspan="4" width="600"/>
</form>"""

fields = {
    'email': {'string': 'email or part of email address', 'type':'char','size': 200,'help':'You can search on part of emails : like \'@cci.\', for example'},
}

class wizard_search_emails_in_tables(wizard.interface):

    def _search(self,cr,uid,data,context):
        usage_ids = []
        if data['form']['email']:
            parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
            param_values = parameter_obj.get_value_from_names(cr,uid,['MailTables'])
            if param_values.has_key('MailTables'):
                tables = param_values['MailTables']
            else:
                tables = [('res.partner.address','email')]
            obj_usage = pooler.get_pool(cr.dbname).get('mail_usage')
            for (table_name,field_name) in tables:
                current_obj = pooler.get_pool(cr.dbname).get(table_name)
                current_ids = current_obj.search(cr,uid,[(field_name,'ilike',data['form']['email'])])
                if current_ids:
                    current_values = current_obj.read(cr,uid,current_ids,['id',field_name])
                    for current_usage in current_values:
                        new_id = obj_usage.create(cr,uid,{ 'name':current_usage[field_name],
                                                  'source':table_name,
                                                  'source_id':int(current_usage['id']),
                                                })
                        usage_ids.append(int(new_id))
        value = {
            'domain': [('id','in',usage_ids)],
            'name': _('Mail Usage'),
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'mail_usage',
            'context': {},
            'type': 'ir.actions.act_window',
            }
        return value

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('search','Search','gtk-find',True)]},
        },
        'search': {
            'actions': [],
            'result': {'type':'action','action':_search,'state':'end'}
        },
    }

wizard_search_emails_in_tables('cci_mailchimp_search_emails')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

