# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
import pooler
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Unsubscribe Emails">
    <field name="emails" colspan="4" width="600"/>
    <field name="list_name"/>
    <field name="send_warning"/>
</form>"""

fields = {
    'emails': {'string': 'email(s) to unsubscribe', 'type':'text', 'help':'List of emails separated by a <enter>'},
    'list_name': {'string': 'List', 'type':'selection','selection': [('rdp','Revue de Presse'),('agenda','Agenda CCI'),('alterego','Alter Ego')],'required': True,'default':'rdp'},
    'send_warning': {'string': 'Send Warning to Data Sources', 'type':'boolean', 'help':'Send a warning of \'other chambers\' responsibles if corrections in newsletter subscribers'},
}

final_form = """<?xml version="1.0"?>
<form string="Results">
    <field name="final_count"/>
</form>"""

final_fields = {
    'final_count' : {'string':'Unsubscribed Count','type':'integer','readonly':True,'value':-1}
}

class wizard_unsubscribe_emails_in_tables(wizard.interface):

    def _unsubscribe(self,cr,uid,data,context):
        if data['form']['emails'] and data['form']['list_name']:
            list_to_delete = data['form']['emails'].split('\n')
            list_to_delete = [x.strip() for x in list_to_delete if len(x.strip()) > 0]
            obj_mailchimp_proxy = pooler.get_pool(cr.dbname).get('mailchimp_proxy')
            data['form']['final_count'] = obj_mailchimp_proxy.unsubscribe_email(cr,uid,list_to_delete,data['form']['list_name'],data['form']['send_warning'])
        else:
            data['form']['final_count'] = 0
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('unsubscribe','Unsubscribe Them All','gtk-delete',True)]},
        },
        'unsubscribe' : {
            'actions': [_unsubscribe],
            'result': {'type':'form', 'arch':final_form, 'fields':final_fields, 'state':[('end','Close')]}
        },
    }

wizard_unsubscribe_emails_in_tables('cci_mailchimp_unsubscribe_emails')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

