# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import pooler
import tools
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Send Update Page Link">
    <field name="from" colspan="4" width="400"/>
    <field name="email_addr" colspan="4"/>
    <field name="template_id" colspan="4"/>
</form>"""

fields = {
    'from': {'string': 'From', 'type':'char','size':200,'required':True},
    'email_addr': {'string': 'Email Contact', 'type':'char','size':200,'required':True},
    'template_id': {'string': 'Template', 'type':'many2one', 'relation':'cci_email_template','domain':"[]",'required':True},
}

final_form = """<?xml version="1.0"?>
<form string="Results">
    <field name="results" colspan="4" width="600"/>
</form>"""

final_fields = {
    'results' : {'string':'Results','type':'text','readonly':True,'value':''}
}

class add_manual_update(wizard.interface):
    def _set_defaults(self,cr,uid,data,context):
        pool_obj=pooler.get_pool(cr.dbname)
        obj_ir_model = pool_obj.get('ir.model')
        ir_model_ids = obj_ir_model.search(cr,uid,[('model','=','directory.address.proxy')])
        if ir_model_ids:
            fields['template_id']['domain'] = "[('model_id','=',%i)]" % ir_model_ids[0]
            #fields['multiple_addr_template_id']['domain'] = "[('model_id','=',%i)]" % ir_model_ids[0]
            #fields['detail_multiple_addr_template_id']['domain'] = "[('model_id','=',%i)]" % ir_model_ids[0]
        user_obj = pool_obj.get('res.users')
        user = user_obj.browse(cr,uid,[uid,])[0]
        if user.email:
            fields['from']['value'] = user.email.strip()
        return data['form']
    def _send_email(self,cr,uid,data,context):
        if data['id']:
            if len(data['ids']) == 1:
                visual_results = 'Sended'
                # adding the record to manageable records through website
                partner_obj = pooler.get_pool(cr.dbname).get('res.partner')
                addr_proxy_obj = pooler.get_pool(cr.dbname).get('directory.address.proxy')
                added_obj = pooler.get_pool(cr.dbname).get('directory.manual_add')
                partner = partner_obj.browse(cr,uid,data['id'])
                if partner and len(partner.address) > 0:
                    modifiable_proxy_ids = []
                    for addr in partner.address:
                        addr_proxy_obj._synchro_address(cr,uid,addr,partner,modifiable_proxy_ids,[],False,False,False,False,False,False)
                    modifiable_proxy_ids = addr_proxy_obj.search(cr,uid,[('partner_id','=',partner.id)])
                    added_obj.create(cr,uid,{'partner_id':partner.id})
                # get the templates
                template_id = data['form']['template_id']
                parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
                param_values = parameter_obj.get_value_from_names(cr,uid,['MemberMail1AddrID','MemberMailMultiAddrID','MemberMailLinkID','BDDeTest'])
                if param_values.has_key('MemberMail1AddrID') and param_values.has_key('MemberMailMultiAddrID') and param_values.has_key('MemberMailLinkID') and param_values.has_key('BDDeTest'):
                    bddetest = (param_values['BDDeTest'] == 1)
                    template_obj = pooler.get_pool(cr.dbname).get('cci_email_template')
                    template = template_obj.browse(cr,uid,[template_id])[0]
                    add_message_1 = template_obj.browse(cr,uid,[param_values['MemberMail1AddrID']])[0].body
                    add_message_multi = template_obj.browse(cr,uid,[param_values['MemberMailMultiAddrID']])[0].body
                    base_item = template_obj.browse(cr,uid,[param_values['MemberMailLinkID']])[0].body
                    #
                    addrs = addr_proxy_obj.read(cr,uid,modifiable_proxy_ids,['complete_name','link_id'])
                    addrs_list = []
                    for addr in addrs:
                        addrs_list.append(base_item % (addr['complete_name'],
                                                       addr['link_id'],
                                                       addr['link_id']))
                    if addrs_list:
                        if len(addrs_list) > 1:
                            optional_message = add_message_multi.replace('[[sub_datas]]',u'</li><li>'.join(addrs_list))
                        else:
                            optional_message = add_message_1.replace('[[sub_datas]]',addrs_list[0])
                        email_content = template.body.replace('[[data]]',optional_message)
                        # sending the email
                        try:
                            if bddetest:
                                print 'mocked email send'
                                print 'From : \'%s\'' % data['form']['from']
                                print 'To : [\'%s\']' % data['form']['email_addr']
                                print 'Subject : %s' % template.subject
                                print 'Body :\n%s' % email_content
                            else:
                                tools.email_send(data['form']['from'], [data['form']['email_addr'],], template.subject, email_content, subtype='html')
                        except:
                            visual_results = 'Wrong address : %s' % data['form']['email_addr']
                        pooler.get_pool(cr.dbname).get('cci_email_sended').create(cr,uid,{'name':u'Envoi Manuel fiche MAJ partenaire',
                                                                         'subject':template.subject,
                                                                         'body':email_content,
                                                                         'ressource':'res.partner:'+str(partner.id)+':',
                                                                         'addr_from':data['form']['from'],
                                                                         'addrs_to':'[' + data['form']['email_addr'] +',]',
                                                                        })
                    else:
                        visual_results = 'No address to correct !'
            else:
                visual_results = 'You can use this tool only on ONE partner at once !'
        else:
            visual_results = 'You must be on a partner to use this tool !'
        data['form']['results'] = visual_results
        return data['form']

    states = {
        'init': {
            'actions': [_set_defaults],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('send','Send','gtk-execute',True)]},
        },
        'send': {
            'actions': [_send_email],
            'result': {'type':'form', 'arch':final_form, 'fields':final_fields, 'state':[('end','Close')]}
        },
    }

add_manual_update('add_manual_update')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

