# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import pooler
import tools
from pyExcelerator import *
import codecs
import base64
from operator import itemgetter

form = """<?xml version="1.0"?>
<form string="Check Possible Cut Activities on Addresses">
    <field name="warning" colspan="4" width="700" nolabel="1" readonly="1"/>
    <field name="from"/>
    <field name="to"/>
    <field name="max_excel"/>
</form>"""

fields = {
    'warning': {'string': 'Warning', 'type':'text','default':'Cet outil sélectionne les adresses de membres avec une activité faisant entre 245 et 255 caractères, sans point final.\nIl extrait aussi tous les textes dépassant une certaine limite, même si elle ne semble pas tronquée.'},
    'from':{'string':'Longueur - from','type':'integer','required':True},
    'to':{'string':'Longueur - to','type':'integer','required':True},
    'max_excel':{'string':'Max char in Excel','type':'integer','required':True,'default':254},
}

class check_cut_activ_addr(wizard.interface):
    def _extract(self,cr,uid,data,context):
        obj_pooler = pooler.get_pool(cr.dbname)

        # extraction de toutes les adresses nécessaires
        obj_partner = obj_pooler.get('res.partner')
        obj_addr = obj_pooler.get('res.partner.address')
        partner_ids = obj_partner.search(cr,uid,[('membership_state','in',['free','invoiced','paid']),('state_id','=',1),('dir_exclude','=',False)])
        partner2_ids = obj_partner.search(cr,uid,[('dir_presence','=',True),('dir_exclude','=',False)])
        for pid in partner2_ids:
            if pid not in partner_ids:
                partner_ids.append(pid)
        address_ids = obj_addr.search(cr,uid,[('partner_id','in',partner_ids),('dir_exclude','=',False),('notdelivered','=',False),'|',('type','<>','invoice'),('dir_presence','=',True)])
        addresses = obj_addr.browse(cr,uid,address_ids,{'lang':'fr_FR'})
        
        final_ids = []
        for addr in addresses:
            # calculation of some values to extract with conditions
            final_activ = ( addr.activity_description or addr.partner_id.activity_description or '' ).strip(' \n')
            final_activ = final_activ.replace('\n',' ')
            while '  ' in final_activ:
                final_activ = final_activ.replace('  ',' ')
            if final_activ and (final_activ[-1:] not in ['.','!','?'] and len(final_activ) >= data['form']['from'] and len(final_activ) <= data['form']['to']) or len(final_activ) > data['form']['max_excel']:
                partner_id = addr.partner_id.id
                if partner_id not in final_ids:
                    final_ids.append(addr.id)
        value = {
            'domain': [('id', 'in', final_ids)],
            'name': 'Possible Cut Activity Descriptions',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'res.partner.address',
            'context': {},
            'type': 'ir.actions.act_window'
        }
        return value

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('extract','Extract','gtk-find',True)]},
        },
        'extract': {
            'actions': [_extract],
            'result': {'type': 'action','action': _extract,'state': 'end'},
        },
    }

check_cut_activ_addr('check_cut_activ_addr')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

