# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import pooler
import tools
from pyExcelerator import *
import codecs
import base64
from operator import itemgetter

form = """<?xml version="1.0"?>
<form string="Check Empty Addresses">
    <field name="warning" colspan="4" width="700" nolabel="1" readonly="1"/>
    <field name="type" colspan="4"/>
</form>"""

fields = {
    'warning': {'string': 'Warning', 'type':'text','default':'Cet outil sélectionne les membres sans activité définie et/ou sans personnes de contacts reprises dans le répertoire.'},
    'type':{'string':'Selection','type':'selection','selection':[('only_activ','Only empty activity description'),('excluded_contacts','Empty activity description AND contacts but all excluded contacts'),('all','Empty activity description or no contacts or contacts but all excluded')],'default':'excluded_contacts'},
}

class check_empty_addresses(wizard.interface):
    def _extract(self,cr,uid,data,context):
        obj_pooler = pooler.get_pool(cr.dbname)

        # extraction de toutes les adresses nécessaires
        obj_partner = obj_pooler.get('res.partner')
        obj_addr = obj_pooler.get('res.partner.address')
        partner_ids = obj_partner.search(cr,uid,[('membership_state','in',['free','invoiced','paid']),('state_id','=',1),('dir_exclude','=',False)])
        partner2_ids = obj_partner.search(cr,uid,[('dir_presence','=',True),('dir_exclude','=',False)])
        for pid in partner2_ids:
            if pid not in partner_ids:
                partner_ids.append(pid)
        address_ids = obj_addr.search(cr,uid,[('partner_id','in',partner_ids),('dir_exclude','=',False),('notdelivered','=',False)])
        addresses = obj_addr.browse(cr,uid,address_ids,{'lang':'fr_FR'})
        
        final_addr_ids = []
        for addr in addresses:
            to_check = False
            if (not addr.activity_description) and (not addr.partner_id.activity_description):
                to_check = True
            if (not to_check) and (not data['form']['type'] == 'only_activ'):
                if data['form']['type'] == 'all':
                    if not addr.job_ids:
                        to_check = True
                if not to_check:
                    if addr.job_ids:
                        all_excluded = True
                        for job in addr.job_ids:
                            if job.sequence_directory and job.sequence_directory < 99:
                                all_excluded = False
                                break
                        if all_excluded:
                            to_check = True
            if to_check:
                final_addr_ids.append(addr.id)
        value = {
            'domain': [('id', 'in', final_addr_ids)],
            'name': 'Empty Addresses',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'res.partner.address',
            'context': {},
            'type': 'ir.actions.act_window'
        }
        return value

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('extract','Extract','gtk-find',True)]},
        },
        'extract': {
            'actions': [_extract],
            'result': {'type': 'action','action': _extract,'state': 'end'},
        },
    }

check_empty_addresses('check_empty_addresses')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

