# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import pooler
import tools

form = """<?xml version="1.0"?>
<form string="Check Partners with name beginning with some keywords">
    <field name="warning" colspan="4" width="700" nolabel="1" readonly="1"/>
</form>"""

fields = {
    'warning': {'string': 'Warning', 'type':'text','default':'This tool extract the list of partners of at least one address has been validated, and there is some differences between employee global number of the partner record and one of the validated addresses.\nCet outil sort en Excel la liste des partenares dont au moins une adresse a été validée et pour lequel il existe une différence entre le nombre global d\'employés enregistrés sur la fiche du partenaire et les nombres d\'employés locaux enregistrés au niveau des adresses répertoires validées.'},
}

form = """<?xml version="1.0"?>
<form string="Check Names beginning with keywords">
     <field name="names" colspan="4" width="700"/>
     <field name="only_members"/>
</form>"""

fields = {
    'names':{'string': 'Beginnings','type': 'text','required': True,'help':'List of beginnings to check, separated by \',\'.'},
    'only_members':{'string':'Only Members','type':'boolean','default':True},
}
def clean(string):
    return string.strip().replace('\n','').replace('\r','').replace('\t','')

class wizard_check_name_beginning(wizard.interface):
    def _get_defaults(self,cr,uid,data,context):
        obj_pooler = pooler.get_pool(cr.dbname)
        parameter_obj = obj_pooler.get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['PossibleWrongNameBegs'])
        if param_values.has_key('PossibleWrongNameBegs'):
            data['form']['names'] = param_values['PossibleWrongNameBegs']
        else:
            data['form']['names'] = 'ETS,BUREAU,ETUDE'
        return data['form']
        
    def _extract(self,cr,uid,data,context):
        obj_pooler = pooler.get_pool(cr.dbname)
        partner_obj = obj_pooler.get('res.partner')
        
        check_partner_ids = []
        names = data['form']['names'].strip().replace('\n','')
        l_names = names.split(',')
        l_names = [clean(x) for x in l_names if len(clean(x)) > 0]
        if l_names:
            for beg_name in l_names:
                search_criterium = [('name','ilike',beg_name),('state_id','=',1)]
                if data['form']['only_members']:
                    search_criterium.append(('membership_state','in',['free','invoiced','paid']))
                partner_ids = partner_obj.search(cr,uid,search_criterium)
                if partner_ids:
                    partners = partner_obj.read(cr,uid,partner_ids,['name'])
                    for partner in partners:
                        pname = partner['name'].strip()
                        if pname[0:len(beg_name)] == beg_name:
                            check_partner_ids.append(partner['id'])
            parameter_obj = obj_pooler.get('cci_parameters.cci_value')
            parameter_ids = parameter_obj.search(cr,uid,[('name','=','PossibleWrongNameBegs')])
            if parameter_ids:
                parameter_obj.write(cr,uid,parameter_ids[0],{'value':data['form']['names']})
            else:
                parameter_obj.create(cr,uid,{'name':'PossibleWrongNameBegs','type':'char','value':data['form']['names']})
        value = {
            'domain': [('id', 'in', check_partner_ids)],
            'name': 'Partners with name beginning with ...',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'res.partner',
            'context': {},
            'type': 'ir.actions.act_window'
        }
        return value

    states = {
        'init': {
            'actions': [_get_defaults],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('extract','Search','gtk-find',True)]},
        },
        'extract': {
            'actions': [],
            'result': {'type': 'action','action': _extract,'state': 'end',}
        },
    }

wizard_check_name_beginning('wizard_check_name_beginning')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

