# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# 1.1 Doesn't warn if show name = (full_name + legal status) and if sort_name is shorter than full name and begin with the same characters
import wizard
import time
import datetime
import pooler
import tools
from pyExcelerator import *
import codecs
import base64
from tools.translate import _

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File(s) has(have) been created."  colspan="4"/>
     <field name="check_pub_full_page.xls" colspan="4" />
</form>"""

msg_fields = {
    'check_pub_full_page.xls':{'string': 'Excel File','type': 'binary','readonly': True,},
}

class check_pub_full_page(wizard.interface):
    def _extract(self,cr,uid,data,context):
        obj_pooler = pooler.get_pool(cr.dbname)

        # Create empty Excel file
        wb1 = Workbook()
        ws1 = wb1.add_sheet('Detected Possible Errors on Full Page Partners')
        
        # create Excel Headers
        ws1.write(0,0,'partner_id')
        ws1.write(0,1,_('Partner Name'))
        ws1.write(0,2,_('Full Page Status'))
        ws1.write(0,3,_('Count Problems'))
        ws1.write(0,4,_('Not Member'))
        ws1.write(0,5,_('No published address'))
        ws1.write(0,6,_('No published contacts'))
        ws1.write(0,7,_('No activity Description'))
        ws1.write(0,8,_('No activity Sector'))
        line = 1
        
        # extraction de toutes les adresses nécessaires
        fp_obj = obj_pooler.get('directory.fullpage')
        fp_ids = fp_obj.search(cr,uid,[])
        # extraction aussi des pages pleines et/ou des freemium ?
        fps = fp_obj.browse(cr,uid,fp_ids)
        for fp in fps:
            if fp.partner_id:
                # writing line on excel file
                ws1.write(line,0,fp.partner_id.id)
                ws1.write(line,1,fp.partner_id.name)
                ws1.write(line,2,fp.state or '')
                problems = 0
                if fp.partner_id.membership_state not in ['free','invoiced','paid']:
                    problems += 1
                    ws1.write(line,4,_('NO'))
                good_address = False
                contacts = False
                activ_desc = False
                activ_sector = False
                if fp.partner_id.address:
                    for addr in fp.partner_id.address:
                        if (addr.dir_exclude or addr.type == 'invoice') and (not addr.dir_presence):
                            pass
                        else:
                            for job in addr.job_ids:
                                if job.contact_id and job.sequence_directory <= 5:
                                    contacts = True
                            good_address = True
                            if addr.activity_description:
                                activ_desc = True
                            if addr.sector1 or addr.sector2 or addr.sector3:
                                activ_sector = True
                else:
                    good_address = False
                if not good_address:
                    ws1.write(line,5,_('NO'))
                    ws1.write(line,6,'?')
                    problems += 1
                else:
                    if not contacts:
                        ws1.write(line,6,_('NO'))
                        problems += 1
                if not activ_desc:
                    if not fp.partner_id.activity_description:
                        ws1.write(line,7,_('NO'))
                        problems += 1
                if not activ_sector:
                    for category in fp.partner_id.category_id:
                        if category.complete_name and 'Secteur d\'activit' in category.complete_name:
                            activ_sector = True
                if not activ_sector:
                    ws1.write(line,8,_('NO'))
                    problems += 1
                ws1.write(line,3,problems)
                line += 1
        wb1.save('check_pub_full_page.xls')
        result_file = open('check_pub_full_page.xls','rb').read()
        data['form']['check_pub_full_page.xls'] = base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [_extract],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Close')]}
        },
    }
check_pub_full_page('check_pub_full_page')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

