# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# 1.1 Doesn't warn if show name = (full_name + legal status) and if sort_name is shorter than full name and begin with the same characters
import wizard
import time
import datetime
import pooler
import tools
from pyExcelerator import *
import codecs
import base64
from operator import itemgetter

form = """<?xml version="1.0"?>
<form string="Check Show and Sort Name for Directory">
    <field name="warning" colspan="4" width="700" nolabel="1" readonly="1"/>
    <field name="selection"/>
</form>"""

fields = {
    'warning': {'string': 'Warning', 'type':'text','default':'This tool extract the list of partners/addresses with a directory show name or sort name, to validate it year after year.\nCet outil sort en Excel la liste des partenaires avec des adresses ayant un nom imprimé ou alphabétique pour le répertoire.'},
    'selection': {'string': 'Selection', 'type':'selection','selection':[('all','All defined names on members'),('diff','Only significative difference on members')],'default':'all'},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File(s) has(have) been created."  colspan="4"/>
     <field name="check_show_name.xls" colspan="4" />
</form>"""

msg_fields = {
    'check_show_name.xls':{'string': 'Excel File','type': 'binary','readonly': True,},
}

class cci_memberdirectory_check_show_name(wizard.interface):
    def _extract(self,cr,uid,data,context):
        obj_pooler = pooler.get_pool(cr.dbname)

        # Create empty Excel file
        wb1 = Workbook()
        ws1 = wb1.add_sheet('Detected Possible Errors')
        
        # create Excel Headers
        ws1.write(0,0,'partner_id')
        ws1.write(0,1,'address_id')
        ws1.write(0,2,'published')
        ws1.write(0,3,'street')
        ws1.write(0,4,'partner_name')
        ws1.write(0,5,'address_name')
        ws1.write(0,6,'concatened_name')
        ws1.write(0,7,'directory_show_name')
        ws1.write(0,8,'directory_sort_name')
        ws1.write(0,9,'last_validated_final_partner_name')
        ws1.write(0,10,'last_validation_date')
        line = 1
        
        # extraction de toutes les adresses nécessaires
        obj_addr = obj_pooler.get('res.partner.address')
        obj_partner = obj_pooler.get('res.partner')
        obj_dir_address = obj_pooler.get('directory.address.proxy')
        partner_ids = obj_partner.search(cr,uid,[('membership_state','in',['free','invoiced','paid'])])
        # extraction ussi des pages pleines et/ou des freemium ?
        partners = obj_partner.browse(cr,uid,partner_ids)
        for partner in partners:
            to_check = False
            for addr in partner.address:
                if addr.dir_show_name or addr.dir_sort_name:
                    to_check = True
                    break
            if to_check:
                for addr in partner.address:
                    full_name = ''
                    if addr.name:
                        if addr.name.strip()[0:2] == '- ':
                            full_name = partner.name.strip() + ' ' + addr.name.strip()
                        else:
                            full_name = addr.name.strip()
                    else:
                        full_name = partner.name.strip()
                    difference = (data['form']['selection'] == 'all')
                    if not difference and addr.dir_show_name:
                        if (addr.dir_show_name.strip() != full_name):
                            if addr.partner_id.title and (addr.dir_show_name != (full_name + ' ' + addr.partner_id.title.strip().upper())):
                                difference = True
                    if not difference and addr.dir_sort_name:
                        if addr.dir_sort_name.strip() != full_name[0:len(addr.dir_sort_name.strip())]:
                            difference = True
                    if difference:
                        # search for last validated record
                        dir_ids = obj_dir_address.search(cr,uid,[('address_id','=',addr.id),('user_validated','=',True)])
                        if dir_ids:
                            dir_addrs = obj_dir_address.read(cr,uid,dir_ids,['new_complete_name','write_date','create_date'])
                            last_name = dir_addrs[0]['new_complete_name']
                            last_date = dir_addrs[0]['write_date'] or dir_addrs[0]['create_date']
                            if len(dir_addrs) > 1:
                                for dir_addr in dir_addrs[1:]:
                                    if (dir_addrs[0]['write_date'] or dir_addrs[0]['create_date']) > last_date:
                                        last_name = dir_addr['new_complete_name']
                                        last_date = dir_addr['write_date'] or dir_addr['create_date']
                        else:
                            dir_ids = obj_dir_address.search(cr,uid,[('address_id','=',addr.id),('user_validated','=',True),('active','=',False)])
                            if dir_ids:
                                dir_addrs = obj_dir_address.read(cr,uid,dir_ids,['new_complete_name','write_date','create_date'])
                                last_name = dir_addrs[0]['new_complete_name']
                                last_date = dir_addrs[0]['write_date'] or dir_addrs[0]['create_date']
                                if len(dir_addrs) > 1:
                                    for dir_addr in dir_addrs[1:]:
                                        if (dir_addrs[0]['write_date'] or dir_addrs[0]['create_date']) > last_date:
                                            last_name = dir_addr['new_complete_name']
                                            last_date = dir_addr['write_date'] or dir_addr['create_date']
                            else:
                                last_name = ''
                                last_date = ''
                        # writing line on excel file
                        ws1.write(line,0,partner['id'])
                        ws1.write(line,1,addr.id)
                        if partner.membership_state not in ['free','invoiced','paid']:
                            ws1.write(line,2,'no - not a member')
                        elif addr.type == 'invoice':
                            ws1.write(line,2,'no - invoice address')
                        elif addr.dir_exclude:
                            ws1.write(line,2,'no -excluded address')
                        else:
                            ws1.write(line,2,'yes')
                        if addr.zip_id:
                            ws1.write(line,3,(addr.street or '') + ' - ' + addr.zip_id.name + ' ' + addr.zip_id.city)
                        else:
                            ws1.write(line,3,addr.street or '')
                        ws1.write(line,4,partner.name)
                        ws1.write(line,5,addr.name or '')
                        ws1.write(line,6,full_name)
                        ws1.write(line,7,addr.dir_show_name or '')
                        ws1.write(line,8,addr.dir_sort_name or '')
                        ws1.write(line,9,last_name)
                        ws1.write(line,10,last_date)
                        line += 1
        wb1.save('check_show_name.xls')
        result_file = open('check_show_name.xls','rb').read()
        data['form']['check_show_name.xls'] = base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('extract','Extract','gtk-find',True)]},
        },
        'extract': {
            'actions': [_extract],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Close')]}
        },
    }

cci_memberdirectory_check_show_name('cci_memberdirectory_check_show_name')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

