# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# 1.1 Doesn't warn if show name = (full_name + legal status) and if sort_name is shorter than full name and begin with the same characters
import wizard
import time
import datetime
import pooler
import tools
from pyExcelerator import *
import codecs
import base64
from operator import itemgetter
import re
import urllib
import os

form = """<?xml version="1.0"?>
<form string="Check Show and Sort Name for Directory">
    <field name="warning" colspan="4" width="700" nolabel="1" readonly="1"/>
    <field name="selection" colspan="4"/>
    <field name="read" colspan="4"/>
</form>"""

fields = {
    'warning': {'string': 'Warning', 'type':'text','default':'Check all websites.'},
    'selection': {'string': 'Selection', 'type':'selection','selection':[('all','All companies'),('member','Only members')],'default':'all'},
    'read': {'string':'Try read page (solwer)','type':'boolean'},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File(s) has(have) been created."  colspan="4"/>
     <field name="check_websites.xls" colspan="4" />
</form>"""

msg_fields = {
    'check_websites.xls':{'string': 'Excel File','type': 'binary','readonly': True,},
}

class cci_memberdirectory_check_websites(wizard.interface):
    def _extract(self,cr,uid,data,context):
        obj_pooler = pooler.get_pool(cr.dbname)

        # Create empty Excel file
        wb1 = Workbook()
        ws1 = wb1.add_sheet('Detected Possible Errors')
        
        # create Excel Headers
        ws1.write(0,0,'partner_id')
        ws1.write(0,1,'member_state')
        ws1.write(0,2,'partner_name')
        ws1.write(0,3,'web site URL')
        ws1.write(0,4,'error')        
        line = 1
        
        # extraction de toutes les adresses nécessaires
        obj_partner = obj_pooler.get('res.partner')
        if data['form']['selection'] == 'all':
            criteria = [('state_id','=',1)]
        else:
            criteria = [('state_id','=',1),('membership_state','in',['free','invoiced','paid'])]
        criteria.append( ('website','!=',False) )
        partner_ids = obj_partner.search(cr,uid,criteria)
        partners = obj_partner.browse(cr,uid,partner_ids)
        regex = re.compile(
                r'^(?:http|ftp)s?://' # http:// or https://
                r'(?:(?:[A-Z0-9](?:[A-Z0-9-]{0,61}[A-Z0-9])?\.)+(?:[A-Z]{2,6}\.?|[A-Z0-9-]{2,}\.?)|' #domain...
                r'localhost|' #localhost...
                r'\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})' # ...or ip
                r'(?::\d+)?' # optional port
                r'(?:/?|[/?]\S+)$', re.IGNORECASE) ## This regex cames from Django
        for partner in partners:
            if partner.website:
                url = partner.website.strip()
                if '://' not in url:
                    url = 'http://' + url
                error = ''
                if not regex.match(url):
                    error = 'Malformed'
                else:
                    if data['form']['read']:
                        try:
                            code = urllib.urlopen(url).getcode()
                            if str(code) not in ['200','403']:
                                error = str(code)
                            if code == '400':
                                error = code + u'  Mauvais envoide requête'
                            elif code == '404':
                                erreor = code + u' page non trouvée'
                            elif code == '500':
                                erreor = code + u' erreur interne de serveur inexpliquée'
                            elif code == '503':
                                erreor = code + u' serveur actuellement indisponible'
                        except:
                            error = 'URL not existing'
                if error:
                    # writing line on excel file
                    ws1.write(line,0,partner.id)
                    ws1.write(line,1,partner.membership_state)
                    ws1.write(line,2,partner.name)
                    ws1.write(line,3,partner.website.strip())
                    ws1.write(line,4,error)
                    line += 1
        wb1.save('check_websites.xls')
        result_file = open('check_websites.xls','rb').read()
        data['form']['check_websites.xls'] = base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('check','Check','gtk-find',True)]},
        },
        'check': {
            'actions': [_extract],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Close')]}
        },
    }
cci_memberdirectory_check_websites('cci_memberdirectory_check_websites')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

