# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import pooler
import tools
from pyExcelerator import *
import codecs
import base64
from operator import itemgetter

form = """<?xml version="1.0"?>
<form string="Check Show and Sort Name for Directory">
    <field name="warning" colspan="4" width="700" nolabel="1" readonly="1"/>
</form>"""

fields = {
    'warning': {'string': 'Warning', 'type':'text','default':'This tool remove directory show name if this name is the same as the full name; and remove directory sort name is the same as directory show name or full name if not show name.\nCet outil efface les nom imprimés pour le répertoire s\'ils sont identiques au nom complet du partebnaire; et il efface aussi les noms alphabétiques s\'ils sont identiques au nom imprimé.'},
}

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <field name="results" colspan="4" width="700" nolabel="1" readonly="1"/>
</form>"""

msg_fields = {
    'results':{'string': 'Results','type': 'text'},
}

class cci_memberdirectory_clean_show_name(wizard.interface):
    def _clean(self,cr,uid,data,context):
        obj_pooler = pooler.get_pool(cr.dbname)
        obj_addr = obj_pooler.get('res.partner.address')
        obj_partner = obj_pooler.get('res.partner')
        partner_ids = obj_partner.search(cr,uid,[])
        partners = obj_partner.browse(cr,uid,partner_ids)
        dir_show_name_cleaned = 0
        dir_sort_name_cleaned = 0
        dir_show_name_kept = 0
        dir_sort_name_kept = 0
        already_empty_show_name = 0
        already_empty_sort_name = 0
        to_clean_show_ids = []
        to_clean_sort_ids = []
        for partner in partners:
            for addr in partner.address:
                if addr.name:
                    if addr.name.strip()[0:2] == '- ':
                        full_name = partner.name.strip() + ' ' + addr.name.strip()
                    else:
                        full_name = addr.name.strip()
                else:
                    full_name = partner.name.strip()
                if addr.dir_show_name:
                    if addr.dir_show_name.strip() == full_name:
                        dir_show_name_cleaned += 1
                        # write
                        to_clean_show_ids.append(addr.id)
                        final_show_name = ''
                    else:
                        dir_show_name_kept += 1
                        final_show_name = addr.dir_show_name.strip()
                        #print str(addr.id) + ' ' + addr.dir_show_name.strip() + ' <> ' + full_name
                else:
                    already_empty_show_name += 1
                    final_show_name = ''
                if addr.dir_sort_name:
                    if final_show_name:
                        if addr.dir_sort_name.strip() == final_show_name:
                            dir_sort_name_cleaned += 1
                            # write
                            to_clean_sort_ids.append(addr.id)
                        else:
                            dir_sort_name_kept += 1
                            #print str(addr.id) + ' ' + addr.dir_sort_name.strip() + ' <> ' + final_show_name
                    else:
                        if addr.dir_sort_name.strip() == full_name:
                            dir_sort_name_cleaned += 1
                            # write
                            to_clean_sort_ids.append(addr.id)
                        else:
                            dir_sort_name_kept += 1
                else:
                    already_empty_sort_name += 1
        if to_clean_show_ids:
            obj_addr.write(cr,uid,to_clean_show_ids,{'dir_show_name':''})
        if to_clean_sort_ids:
            obj_addr.write(cr,uid,to_clean_sort_ids,{'dir_sort_name':''})
        data['form']['results'] = "Show names :\nCleaned : %i\nKept : %i\nAlready Empty : %i\n\nSort Names :\nCleaned : %i\nKept : %i\nAlready Empty : %i" % (dir_show_name_cleaned,dir_show_name_kept,already_empty_show_name,dir_sort_name_cleaned,dir_sort_name_kept,already_empty_sort_name)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('clean','Clean','gtk-find',True)]},
        },
        'clean': {
            'actions': [_clean],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Close')]}
        },
    }

cci_memberdirectory_clean_show_name('cci_memberdirectory_clean_show_name')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

