# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import pooler
import tools
from tools.translate import _

final_form = """<?xml version="1.0"?>
<form string="Results">
    <field name="results" colspan="4" width="600" nolabel="1"/>
</form>"""

final_fields = {
    'results' : {'string':'Results','type':'text','readonly':True,'value':''}
}

class cci_memberdirectory_count_answers(wizard.interface):
    def _count(self,cr,uid,data,context):
        addr_proxy_obj = pooler.get_pool(cr.dbname).get('directory.address.proxy')
        all_ids = addr_proxy_obj.search(cr,uid,[])
        #answered_ids = addr_proxy_obj.search(cr,uid,[('change_date','<>',False)])
        email_ids = addr_proxy_obj.search(cr,uid,[('sending_address','<>',False)])
        #left_email_ids = addr_proxy_obj.search(cr,uid,[('change_date','=',False),('sending_address','<>',False)])
        already_validated_ids = addr_proxy_obj.search(cr,uid,[('already_validated','=',True)])
        waiting_ids = addr_proxy_obj.search(cr,uid,[('already_validated','=',False),('user_validated','=',True),('internal_validated','=',False)])
        left_email_ids = addr_proxy_obj.search(cr,uid,[('sending_address','<>',False),('already_validated','=',False),('user_validated','=',False)])
        if len(all_ids) > 0:
            pourcents1 = int(((len(already_validated_ids)+len(waiting_ids))*100)/len(email_ids))
        else:
            pourcents1 = 100
        if len(email_ids) > 0:
            pourcents2 = int((len(left_email_ids)*100)/len(email_ids))
        else:
            pourcents2 = 100
        visual_results = "%i adresses à vérifier\n%i avec emails\n\n%i adresses déjà vérifiées par le membre (%i pourcents)\n%i adresses à rappeller par mail (%i pourcents)\n\n%s adresses déjà injectées dans l'ERP" % (len(all_ids),
                                                                                                                                                len(email_ids),
                                                                                                                                                len(already_validated_ids)+len(waiting_ids),
                                                                                                                                                pourcents1,
                                                                                                                                                len(left_email_ids),
                                                                                                                                                pourcents2,
                                                                                                                                                len(already_validated_ids),
                                                                                                                                                )
        data['form']['results'] = visual_results
        return data['form']

    states = {
        'init': {
            'actions': [_count],
            'result': {'type':'form', 'arch':final_form, 'fields':final_fields, 'state':[('end','Close')]}
        },
    }

cci_memberdirectory_count_answers('cci_memberdirectory_count_answers')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

