# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import pooler
import datetime
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="List Members without published addresses">
    <field name="explanation" colspan="4" width="700" height="400" nolabel="1"/>
</form>"""

fields = {
    'explanation': {'string': 'Explanation', 'type':'text','readonly':True,'value':'You\'ll have the list of members without published addresses.\nBecause they don\'t have any addresses, or because all of their addresses are in the following cases :\n\n- excluded\n- no postal delivery\n- type = invoice.'},
}

def _find_members_without_published_address(self, cr, uid, data, context):
    final_ids = []
    obj_partner = pooler.get_pool(cr.dbname).get('res.partner')
    partner_ids = obj_partner.search(cr,uid,[('membership_state','in',['free','invoiced','paid'])])
    if partner_ids:
        partners = obj_partner.browse(cr,uid,partner_ids)
        for partner in partners:
            if not partner.dir_exclude: # the case 'partner.dir_exclude' is managed by another tool
                pub_addr = False
                if partner.address:
                    for addr in partner.address:
                        if addr.dir_presence:
                            pub_addr = True
                            break
                        else:
                            if (not addr.dir_exclude) and (not addr.notdelivered) and (addr.type != 'invoice'):
                                pub_addr = True
                                break
                if not pub_addr:
                    final_ids.append(partner.id)
    value = {
        'domain': [('id', 'in', final_ids)],
        'name': _('Partners without published address'),
        'view_type': 'form',
        'view_mode': 'tree,form',
        'res_model': 'res.partner',
        'context': {},
        'type': 'ir.actions.act_window'
    }
    return value
            

class dir_list_members_wo_pub_addr(wizard.interface):
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('extract','Extract','gtk-find',True)]},
        },
        'extract': {
            'actions': [],
            'result': {'type': 'action','action': _find_members_without_published_address,'state': 'end'},
        },
    }
dir_list_members_wo_pub_addr("dir_list_members_wo_pub_addr")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

