# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import pooler
import tools
from pyExcelerator import *
import codecs
import base64
from operator import itemgetter
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Exclude Invoice Addresses not Forced">
    <field name="warning" colspan="4" width="700" nolabel="1" readonly="1"/>
</form>"""

fields = {
    'warning': {'string': 'Warning', 'type':'text','default':_('This tool disable all invoice addresses not already \'forced\'. Thus, mainly new invoice addresses. The old invoice addresses has already been \'forced\' or let \'excluded\' past year.')},
}

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <field name="results" colspan="4" width="700" nolabel="1" readonly="1"/>
</form>"""

msg_fields = {
    'results':{'string': 'Results','type': 'text'},
}

class exclude_invoice_addresses(wizard.interface):
    def _exclude(self,cr,uid,data,context):
        obj_pooler = pooler.get_pool(cr.dbname)
        obj_addr = obj_pooler.get('res.partner.address')
        addr_ids = obj_addr.search(cr,uid,[('type','=','invoice'),('dir_presence','=',False),('dir_exclude','=',False)])
        count_all = len(addr_ids)
        count_members = 0
        addresses = obj_addr.browse(cr,uid,addr_ids)
        for addr in addresses:
            try:
                # one by one in case of some problems with writing in address => mostly all (if not all) addresses will be corrected
                obj_addr.write(cr,uid,[addr.id,],{'dir_exclude':True})
                print addr.partner_id.membership_state
                if addr.partner_id and addr.partner_id.membership_state in ['free','invoiced','paid']:
                    count_members += 1
            except Exception,e:
                pass
                print 'outside'
        data['form']['results'] = "Exclusion of new addresses of type 'Invoice' :\n\nCorrected addresses : %i\nwith %i concerning members" % (count_all,count_members)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('exclude','Exclude','gtk-find',True)]},
        },
        'exclude': {
            'actions': [_exclude],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Close')]}
        },
    }
exclude_invoice_addresses('exclude_invoice_addresses')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

