# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
#import re
import tools
import pooler
import base64

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="Simple Changes Recorded."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
</form>"""

msg_fields = {
    'msg': {'string':'Details', 'type':'text', 'size':'100','readonly':True},
}

def _correct_escape(string):
    return string.replace("\\" + "'","'")

class wizard_internal_validate(wizard.interface):

    def _try_confirm(self,cr,uid,data,context):
        recorded = 0
        bloqued = 0
        obj_fp = pooler.get_pool(cr.dbname).get('directory.fullpage')
        fp_ids = obj_fp.search(cr,uid,[])
        fps = obj_fp.read(cr,uid,fp_ids,['partner_id'])
        fp_partner_ids = []
        for fp in fps:
            if fp['partner_id'] and fp['partner_id'][0] not in fp_partner_ids:
                fp_partner_ids.append(fp['partner_id'][0])
        obj_proxy = pooler.get_pool(cr.dbname).get('directory.address.proxy')
        proxy_ids = obj_proxy.search(cr,uid,[('user_validated','=',True),('internal_validated','=',False)])
        if proxy_ids:
            proxies = obj_proxy.browse(cr,uid,proxy_ids)
            for proxy in proxies:
                #new_values = self.read(cr, uid, ids, ['user_validated','internal_validated','vat_num','new_vat_num','final_vat_num','complete_name','new_complete_name','final_partner_name','final_address_name','new_zip_code','new_city','final_zip_id','new_desc_activ','final_desc_activ','final_addr_desc_activ','partner_id'], context=context)[0]
                try_to_record = True
                if proxy.new_complete_name and (_correct_escape(proxy.new_complete_name) != proxy.complete_name) and not (proxy.final_partner_name or proxy.final_address_name):
                    try_to_record = False
                if try_to_record and ((proxy.new_zip_code or proxy.new_city) and not proxy.final_zip_id):
                    try_to_record = False
                if try_to_record and proxy.new_desc_activ and not (proxy.final_desc_activ or proxy.final_addr_desc_activ):
                    try_to_record = False
                #if try_to_record and proxy.full_page:
                #    try_to_record = False
                if try_to_record and proxy.partner_id and proxy.partner_id.id:
                    if proxy.partner_id.id in fp_partner_ids:
                        try_to_record = False
                old_vat_num = (proxy.vat_num or '').replace('/','').replace('-','').replace('.','').replace(' ','')
                if proxy.new_vat_num and old_vat_num <> proxy.final_vat_num:
                    # check if not existing new vat num
                    same_vat_ids = pooler.get_pool(cr.dbname).get('res.partner').search(cr,uid,[('vat','=',proxy.final_vat_num)])
                    if same_vat_ids:
                        if len(same_vat_ids) > 1 or proxy.partner_id.id <> same_vat_ids[0]:
                            try_to_record = False
                if try_to_record:
                    proxy.but_confirm_changes(cr,uid,[proxy.id,])
                    recorded += 1
                else:
                    bloqued += 1
        data['form']['msg'] = u'Enregistrés : %i\nEn attente de gestion manuelle : %i' % (recorded,bloqued)
        return data['form']

    states = {
        'init': {
            'actions': [_try_confirm],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

wizard_internal_validate('cci_memberdirectory_internal_validate')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

