# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
#import re
import tools
import pooler
import base64
from pyExcelerator import *

form = """<?xml version="1.0"?>
<form string="Extract Proof of Full Page parutions">
     <field name="warning" colspan="4" nolabel="1" readonly="1" width="600"/>
</form>"""

fields = {
    'warning': {'string':'File created', 'type':'text', 'value':'This tool extract all selected full page orders with the address and contact names for sending the proof of parution in the directory.','readonly':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Proof of Full Page parutions">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="proofs_of_fullpage.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'proofs_of_fullpage.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class proof_of_fullpage(wizard.interface):

    def _get_file(self,cr,uid,data,context):
        obj_fp = pooler.get_pool(cr.dbname).get('directory.fullpage')

        wb1 = Workbook()
        ws1 = wb1.add_sheet('Addresses for FullPage\'s proof of parution')
        ws1.write(0,0,'partner_id')
        ws1.write(0,1,'address_id')
        ws1.write(0,2,'order_contact_id')
        ws1.write(0,3,'sale_order_id')
        ws1.write(0,4,'partner_name')
        ws1.write(0,5,'street')
        ws1.write(0,6,'street2')
        ws1.write(0,7,'zip_code')
        ws1.write(0,8,'zip_name')
        ws1.write(0,9,'country')
        ws1.write(0,10,'contact_full_name')
        ws1.write(0,11,'contact_lastname')
        ws1.write(0,12,'contact_firstname')
        ws1.write(0,13,'contact_courtesy')
        ws1.write(0,14,'order_name')
        ws1.write(0,15,'order_customer_ref')
        line = 1
        fullpages = obj_fp.browse(cr,uid,data['ids'])
        for fp in fullpages:
            # for each full page ordered, we seached first the address linked to to so_contact_id. If not found, 'default' address
            # we keep address only if not 'notdelievered' because the usage of this file is a postal sending
            address = False
            if fp.partner_id and fp.partner_id.address:
                if fp.so_contact_id:
                    for addr in fp.partner_id.address:
                        if not addr.notdelivered:
                            for job in addr.job_ids:
                                if job.contact_id and job.contact_id.id == fp.so_contact_id.id:
                                    address = addr
                                    break
                            if address:
                                break
                if not address:
                    for addr in fp.partner_id.address:
                        if (not addr.notdelivered) and addr.type == 'default':
                            address = addr
                            break
            if address:
                ws1.write(line,0,fp.partner_id.id)
                ws1.write(line,1,address.id)
                ws1.write(line,2,fp.so_contact_id and fp.so_contact_id.id or 0)
                ws1.write(line,3,fp.sale_order_id and fp.sale_order_id.id or 0)
                if address.name:
                    if address.name.strip()[0:2] == '- ':
                        ws1.write(line,4,fp.partner_id.name.strip() + '  ' + address.name.strip())
                    else:
                        ws1.write(line,4,address.name.strip())
                else:
                    ws1.write(line,4,fp.partner_id.name.strip())
                ws1.write(line,5,address.street and address.street.strip() or '')
                ws1.write(line,6,address.street2 and address.street2.strip() or '')
                ws1.write(line,7,address.zip_id and address.zip_id.name or '')
                ws1.write(line,8,address.zip_id and address.zip_id.city or '')
                country = ''
                if address.country_id and address.country_id.id != 20:
                    country = address.country_id.name
                ws1.write(line,9,country)
                if fp.so_contact_id:
                    fullname = fp.so_contact_id.name.strip()
                    if fp.so_contact_id.first_name:
                        fullname = fp.so_contact_id.first_name.strip() + ' ' + fullname
                    if fp.so_contact_id.title:
                        fullname = fp.so_contact_id.title + ' ' + fullname
                    ws1.write(line,10,fullname)
                    ws1.write(line,11,fp.so_contact_id.name.strip())
                    ws1.write(line,12,fp.so_contact_id.first_name or '')
                    ws1.write(line,13,fp.so_contact_id.title or '')
                else:
                    ws1.write(line,10,'')
                    ws1.write(line,11,'')
                    ws1.write(line,12,'')
                    ws1.write(line,13,'')
                ws1.write(line,14,fp.sale_order_id and fp.sale_order_id.name or '')
                ws1.write(line,15,(fp.sale_order_id and fp.sale_order_id.client_order_ref) and fp.sale_order_id.client_order_ref or '')
            line += 1
        wb1.save('proofs_of_fullpage.xls')
        result_file = open('proofs_of_fullpage.xls','rb').read()

        # give the result tos the user
        data['form']['msg']='Save the File with '".xls"' extension.'
        data['form']['proofs_of_fullpage.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('extract','Extract','gtk-find',True)]}
        },
        'extract': {
            'actions': [_get_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

proof_of_fullpage('proof_of_fullpage')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

