# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import pooler
import tools
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Send Emails for Directory's Update">
    <field name="warning" colspan="4" readonly="1" nolabel="1"/>
    <field name="from" colspan="4"/>
    <field name="title" colspan="4"/>
    <field name="type" colspan="4"/>
    <field name="template" colspan="4"/>
    <field name="exclude_readed" colspan="4"/>
    <field name="max" colspan="4"/>
</form>"""
## not more used <field name="year" colspan="4" width="600"/>-->

fields = {
     #'year': {'string': 'Year', 'type':'integer','required':True},
    'warning': {'string':'', 'type':'text','default':'Before sending follow-up mails,\nthink to send initial mails for the new members created since the initial mail !'},
    'from': {'string': 'Email From', 'type':'char','size':200,'required':True},
    'title': {'string': 'Title', 'type':'char','size':200,'required':True},
    'type': {'string': 'Type', 'type':'selection','selection':[('initial','Initial Sending'),('1followup','Current Follow-Up')],'required':True},
    'template': {'string': 'Template', 'type':'selection','selection':[('DirMemberTemplateID','Template envoi initial'),('DirMemberTemplateFollowID','Template niveau de rappel actuel')],'required':True},
    'exclude_readed': {'string':'Exclude not validated', 'type':'boolean', 'help':'Exclude records readed on website but not validated'},
    'max': {'string': 'Max emails', 'type':'integer','required':True,'default':9999},
}

final_form = """<?xml version="1.0"?>
<form string="Results">
    <field name="results" colspan="4" width="600"/>
</form>"""

final_fields = {
    'results' : {'string':'Results','type':'text','readonly':True,'value':''}
}

class cci_memberdirectory_send_email(wizard.interface):
    def _send_emails(self,cr,uid,data,context):
        template_id = data['form']['template']
        parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,[template_id,'DirMemberOptionalID','DirMemberOptionalItemID'])
        if param_values.has_key(template_id) and param_values.has_key('DirMemberOptionalID') and param_values.has_key('DirMemberOptionalItemID'):
            template_obj = pooler.get_pool(cr.dbname).get('cci_email_template')
            template = template_obj.browse(cr,uid,[param_values[template_id]])[0]
            add_message = template_obj.browse(cr,uid,[param_values['DirMemberOptionalID']])[0].body
            base_item = template_obj.browse(cr,uid,[param_values['DirMemberOptionalItemID']])[0].body
            today = datetime.datetime.now().strftime('%Y-%m-%d')
            #
            addr_proxy_obj = pooler.get_pool(cr.dbname).get('directory.address.proxy')
            if data['form']['type'] == 'initial':
                addr_proxy_ids = addr_proxy_obj.search(cr,uid,[('user_validated','=',False),('send_initial_mail','=',False),('sending_address','<>',False),('already_validated','=',False)])
            elif data['form']['type'] == '1followup':
                addr_proxy_ids = addr_proxy_obj.search(cr,uid,[('user_validated','=',False),('send_initial_mail','>','1980-01-01'),('send_initial_mail','<',today),('sending_address','<>',False),('already_validated','=',False)])
                addr_proxies = addr_proxy_obj.read(cr,uid,addr_proxy_ids,[('send_first_followup')])
                addr_proxy_ids = []
                for proxy in addr_proxies:
                    if proxy['send_first_followup']:
                        if proxy['send_first_followup'][0:10] < today:
                            addr_proxy_ids.append(proxy['id'])
                    else:
                        addr_proxy_ids.append(proxy['id'])
            else:
                addr_proxy_ids = addr_proxy_obj.search(cr,uid,[('already_validated','=',False),('sending_address','<>',False)])
            if addr_proxy_ids:
                if data['form']['exclude_readed']:
                    access_obj = pooler.get_pool(cr.dbname).get('directory.address.access')
                    new_ids = []
                    addr_proxies = addr_proxy_obj.read(cr,uid,addr_proxy_ids,['address_id'])
                    for addr_proxy in addr_proxies:
                        access_ids = access_obj.search(cr,uid,[('address_id','=',addr_proxy['address_id'][0])])
                        if not access_ids:
                            new_ids.append(addr_proxy['id'])
                    addr_proxy_ids = list(new_ids)
                if addr_proxy_ids:
                    results = addr_proxy_obj.send_email(cr,uid,addr_proxy_ids[0:data['form']['max']],template.body,add_message,base_item,data['form']['from'],data['form']['title'],data['form']['type'])
                    if results:
                        sended_ids = results[0]
                        sended_emails = results[1]
                        errors = results[2]
                        visual_results = 'Sended emails : %s\nErrors : %s' % (str(len(sended_emails)),str(len(errors)))
                    else:
                        visual_results = 'Internal error.\n\nNo message to send.'
                else:
                    visual_results = 'Internal error.\n\nNo message to send.'
            else:
                visual_results = 'Internal error.\n\nNo message to send.'
        else:
            visual_results = 'You MUST define template "DirMemberTemplate" and "DirMemberTemplateID", and also template "DirMemberTemplateFollow" and "DirMemberTemplateFollowID"'
        data['form']['results'] = visual_results
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('send','Send','gtk-find',True)]},
        },
        'send': {
            'actions': [_send_emails],
            'result': {'type':'form', 'arch':final_form, 'fields':final_fields, 'state':[('end','Close')]}
        },
    }

cci_memberdirectory_send_email('cci_memberdirectory_send_email')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

