# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import pooler
import tools
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Send Emails for Directory's Update">
    <field name="from" colspan="4"/>
    <field name="title" colspan="4"/>
    <field name="type" colspan="4"/>
    <field name="exclude_readed" colspan="4"/>
    <!--<field name="template" colspan="4"/>-->
    <field name="template2" colspan="4"/>
</form>"""
## not more used <field name="year" colspan="4" width="600"/>-->

fields = {
     #'year': {'string': 'Year', 'type':'integer','required':True},
    'from': {'string': 'Email From', 'type':'char','size':200,'required':True},
    'title': {'string': 'Title', 'type':'char','size':200,'required':True},
    'type': {'string': 'Type', 'type':'selection','selection':[('initial','Initial Sending'),('1followup','First Follow-Up'),('nothing','Doesn\'t change anything')],'required':True},
    'exclude_readed': {'string':'Exclude not validated', 'type':'boolean', 'help':'Exclude records readed on website but not validated'},
    #'template': {'string': 'Template', 'type':'selection','selection':[('DirMemberTemplateID','Template envoi initial'),('DirMemberTemplateFollowID','Template niveau de rappel actuel'),('MemberRecordTemplateID','Template pour envoi habituel en cours d\'année')],'required':True},
    'template2': {'string': 'Template', 'type':'many2one','relation':'cci_email_template','domain':"[('model_id','=',0)]",'required':True},
}

final_form = """<?xml version="1.0"?>
<form string="Results">
    <field name="results" colspan="4" width="600"/>
</form>"""

final_fields = {
    'results' : {'string':'Results','type':'text','readonly':True,'value':''}
}

class cci_memberdirectory_send_manual_email(wizard.interface):
    def _get_defaults(self,cr,uid,data,context):
        model_obj = pooler.get_pool(cr.dbname).get('ir.model')
        model_ids = model_obj.search(cr,uid,[('model','=','directory.address.proxy')])
        if model_ids:
            fields['template2']['domain'] = ( "[('model_id','=',%i)]" % model_ids[0] )
        return data['form']
    def _send_emails(self,cr,uid,data,context):
        template_id = data['form']['template2']
        parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['DirMemberOptionalID','DirMemberOptionalItemID'])
        if template_id > 0 and param_values.has_key('DirMemberOptionalID') and param_values.has_key('DirMemberOptionalItemID'):
            template_obj = pooler.get_pool(cr.dbname).get('cci_email_template')
            template = template_obj.browse(cr,uid,template_id)
            add_message = template_obj.browse(cr,uid,[param_values['DirMemberOptionalID']])[0].body
            base_item = template_obj.browse(cr,uid,[param_values['DirMemberOptionalItemID']])[0].body
            #
            addr_proxy_obj = pooler.get_pool(cr.dbname).get('directory.address.proxy')
            addr_proxy_ids = data['ids']
            if data['form']['exclude_readed']:
                access_obj = pooler.get_pool(cr.dbname).get('directory.address.access')
                new_ids = []
                addr_proxies = addr_proxy_obj.read(cr,uid,addr_proxy_ids,['address_id'])
                for addr_proxy in addr_proxies:
                    access_ids = access_obj.search(cr,uid,[('address_id','=',addr_proxy['address_id'][0])])
                    if not access_ids:
                        new_ids.append(addr_proxy['id'])
                addr_proxy_ids = list(new_ids)
            if addr_proxy_ids:
                results = addr_proxy_obj.send_email(cr,uid,addr_proxy_ids,template.body,add_message,base_item,data['form']['from'],data['form']['title'],data['form']['type'])
                if results:
                    sended_ids = results[0]
                    sended_emails = results[1]
                    errors = results[2]
                    visual_results = 'Sended emails : %s\nErrors : %s' % (str(len(sended_emails)),str(len(errors)))
                else:
                    visual_results = 'Internal error.\n\nNo mail to send.'
            else:
                visual_results = 'Internal error.\n\nNo mail to send.'
        else:
            visual_results = 'You MUST use an existing template.'
        data['form']['results'] = visual_results
        return data['form']

    states = {
        'init': {
            'actions': [_get_defaults],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('send','Send','gtk-find',True)]},
        },
        'send': {
            'actions': [_send_emails],
            'result': {'type':'form', 'arch':final_form, 'fields':final_fields, 'state':[('end','Close')]}
        },
    }

cci_memberdirectory_send_manual_email('cci_memberdirectory_send_manual_email')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

