# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import pooler
import datetime

def _show_not_delivered(self, cr, uid, data, context):
    obj_pooler = pooler.get_pool(cr.dbname)
    obj_partner = obj_pooler.get('res.partner')
    obj_addr = obj_pooler.get('res.partner.address')
    partner_ids = obj_partner.search(cr,uid,[('membership_state','in',['free','invoiced','paid']),('state_id','=',1),('dir_exclude','=',False)])
    partner2_ids = obj_partner.search(cr,uid,[('dir_presence','=',True),('dir_exclude','=',False)])
    for pid in partner2_ids:
        if pid not in partner_ids:
            partner_ids.append(pid)
    address_ids = obj_addr.search(cr,uid,[('partner_id','in',partner_ids),('notdelivered','>=','1980-01-01'),'|',('type','<>','invoice'),('dir_presence','=',True)])
    value = {
        'domain': [('id', 'in', address_ids)],
        'name': 'Not-delivered addresses excluded for publication',
        'view_type': 'form',
        'view_mode': 'tree,form',
        'res_model': 'res.partner.address',
        'context': {},
        'type': 'ir.actions.act_window'
    }
    return value

class wizard_show_not_delivered(wizard.interface):
    states = {
        'init': {
            'actions': [],
            'result': {
                'type': 'action',
                'action': _show_not_delivered,
                'state': 'end'
            }
        },
    }
wizard_show_not_delivered("wizard_show_not_delivered")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

