# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import pooler
import datetime

def _show_addr_with_wrong_hyphen(self, cr, uid, data, context):
    obj_pooler = pooler.get_pool(cr.dbname)
    obj_addr = obj_pooler.get('res.partner.address')
    wrong_hyphen_ids = []
    address_ids = obj_addr.search(cr,uid,[('name','ilike','_')])
    addresses = obj_addr.read(cr,uid,address_ids,['name',])
    for addr in addresses:
        if addr['name'].strip()[0] == '_':
            wrong_hyphen_ids.append(addr['id'])
    address_ids = obj_addr.search(cr,uid,[('name','ilike','-')])
    addresses = obj_addr.read(cr,uid,address_ids,['name',])
    for addr in addresses:
        current_name = addr['name'].strip()
        if current_name[0] == '-' and current_name[1] != ' ':
            wrong_hyphen_ids.append(addr['id'])
    value = {
        'domain': [('id', 'in', wrong_hyphen_ids)],
        'name': 'Address with possible wrong Hyphen',
        'view_type': 'form',
        'view_mode': 'tree,form',
        'res_model': 'res.partner.address',
        'context': {},
        'type': 'ir.actions.act_window'
    }
    return value

class wizard_show_addr_with_wrong_hyphen(wizard.interface):
    states = {
        'init': {
            'actions': [],
            'result': {
                'type': 'action',
                'action': _show_addr_with_wrong_hyphen,
                'state': 'end'
            }
        },
    }
wizard_show_addr_with_wrong_hyphen("wizard_show_addr_with_wrong_hyphen")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

