# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import pooler
import datetime
from tools.translate import _

def _correct_escape(string):
    return string.replace("\\" + "'","'")

def _show_all_complex(self, cr, uid, data, context):
    obj_fp = pooler.get_pool(cr.dbname).get('directory.fullpage')
    fp_ids = obj_fp.search(cr,uid,[])
    fps = obj_fp.read(cr,uid,fp_ids,['partner_id'])
    fp_partner_ids = []
    for fp in fps:
        if fp['partner_id'] and fp['partner_id'][0] not in fp_partner_ids:
            fp_partner_ids.append(fp['partner_id'][0])
    obj_addr = pooler.get_pool(cr.dbname).get('directory.address.proxy')
    #obj_complex = pooler.get_pool(cr.dbname).get('directory.complex')
    #complex_ids = obj_complex.search(cr,uid,[])
    #complexs = obj_complex.read(cr,uid,complex_ids,['partner_id'])
    #lComplexs = [x['partner_id'][0] for x in complexs]
    addr_ids = obj_addr.search(cr,uid,[])
    addresses = obj_addr.browse(cr,uid,addr_ids)
    final_ids = []
    for proxy in addresses:
        complex_data = False
        if proxy.new_complete_name and (_correct_escape(proxy.new_complete_name) != proxy.complete_name) and not (proxy.final_partner_name or proxy.final_address_name):
            complex_data = True
        if (not complex_data) and ((proxy.new_zip_code or proxy.new_city) and not proxy.final_zip_id):
            complex_data = True
        if (not complex_data) and proxy.new_desc_activ and not (proxy.final_desc_activ or proxy.final_addr_desc_activ):
            complex_data = True
        if (not complex_data) and proxy.partner_id and proxy.partner_id.id:
            if proxy.partner_id.id in fp_partner_ids:
                complex_data = True
        if complex_data:
            final_ids.append(proxy.id)
    value = {
        'domain': [('id', 'in', final_ids)],
        'name': _('Complex Address Proxy'),
        'view_type': 'form',
        'view_mode': 'tree,form',
        'res_model': 'directory.address.proxy',
        'context': {},
        'type': 'ir.actions.act_window'
    }
    return value

class wizard_show_all_complex(wizard.interface):
    states = {
        'init': {
            'actions': [],
            'result': {
                'type': 'action',
                'action': _show_all_complex,
                'state': 'end'
            }
        },
    }
wizard_show_all_complex("wizard_show_all_complex")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

