# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import pooler
import datetime
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Show all directory's addresses linked to a full page in a certain state">
    <field name="state1" colspan="4" width="700"/>
    <field name="state2" colspan="4" width="700"/>
    <field name="state3" colspan="4" width="700"/>
    <field name="state4" colspan="4" width="700"/>
    <field name="state5" colspan="4" width="700"/>
    <field name="state6" colspan="4" width="700"/>
    <field name="state7" colspan="4" width="700"/>
</form>"""

('draft','Prospect'),('confirm','Full Page confirmed'),('waiting_material','Waiting material'),('gfs_creation','Good for Shooting in creation'),('gfs_sended','Good for Shooting Sended'),('good_gfs','GFS OK'),('finish','GFS OK and verified')

fields = {
    'state1': {'string': 'Prospect', 'type':'boolean',}, # draft
    'state2': {'string': 'Full Page confirmed', 'type':'boolean',}, # confirm
    'state3': {'string': 'Waiting material', 'type':'boolean',}, # waiting_material
    'state4': {'string': 'Good for Shooting in creation', 'type':'boolean',}, # gfs_creation
    'state5': {'string': 'Good for Shooting Sended', 'type':'boolean',}, # gfs_sended
    'state6': {'string': 'GFS OK', 'type':'boolean',}, # good_gfs
    'state7': {'string': 'GFS OK and verified', 'type':'boolean',}, # finish
}

def _show_full_page_states(self, cr, uid, data, context):
    states = []
    state_names = []
    final_ids = []
    if data['form']['state1']:
        states.append('draft')
        state_names.append('Prospect')
    if data['form']['state2']:
        states.append('confirm')
        state_names.append('Full Page confirmed')
    if data['form']['state3']:
        states.append('waiting_material')
        state_names.append('Waiting material')
    if data['form']['state4']:
        states.append('gfs_creation')
        state_names.append('Good for Shooting in creation')
    if data['form']['state5']:
        states.append('gfs_sended')
        state_names.append('Good for Shooting Sended')
    if data['form']['state6']:
        states.append('good_gfs')
        state_names.append('GFS OK')
    if data['form']['state7']:
        states.append('finish')
        state_names.append('GFS OK and verified')
    if states:
        obj_fp = pooler.get_pool(cr.dbname).get('directory.fullpage')
        fullpage_ids = obj_fp.search(cr,uid,[('partner_id','!=',False),('state','in',states)])
        if fullpage_ids:
            fullpages = obj_fp.read(cr,uid,fullpage_ids,['partner_id'])
            partner_ids = []
            for fp in fullpages:
                if fp['partner_id'] and fp['partner_id'][0] not in partner_ids:
                    partner_ids.append(fp['partner_id'][0])
            if partner_ids:
                obj_addr = pooler.get_pool(cr.dbname).get('directory.address.proxy')
                addr_ids = obj_addr.search(cr,uid,[('partner_id','in',partner_ids)])
                if addr_ids:
                    final_ids = list(addr_ids)
    value = {
        'domain': [('id', 'in', final_ids)],
        'name': _('Partners with full page in state(s) [%s]') % ','.join(state_names),
        'view_type': 'form',
        'view_mode': 'tree,form',
        'res_model': 'directory.address.proxy',
        'context': {},
        'type': 'ir.actions.act_window'
    }
    return value
            

class wizard_show_full_page_states(wizard.interface):
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('show','Show','gtk-find',True)]},
        },
        'show': {
            'actions': [],
            'result': {'type': 'action','action': _show_full_page_states,'state': 'end'},
        },
    }
wizard_show_full_page_states("wizard_show_full_page_states")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

