# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import pooler
import tools
import codecs
import base64

form = """<?xml version="1.0"?>
<form string="Try New Email">
    <field name="warning" colspan="4" width="700" nolabel="1" readonly="1"/>
    <field name="only_not_validated"/>
</form>"""

fields = {
    'warning': {'string': 'Warning', 'type':'text','default':'Cet outil change les adresses emails utilisées pour les rappels par une nouvelle adresse. Ne peut être utilisée qu\'une seule fois. Souvent après quelques rappels infructueux.'},
    'only_not_validated':{'string':'Only not validated','type':'boolean','default':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <field name="count_changed" colspan="4" width="600"/>
</form>"""

msg_fields = {
    'count_changed':{'string': 'Changed Emails','type': 'char','size':50,'readonly': True,},
}


class cci_memberdirectory_try_new_email(wizard.interface):
    def _change_email(self,cr,uid,data,context):
        obj_pooler = pooler.get_pool(cr.dbname)

        # extraction de toutes les fiches à essayer de modifier
        obj_dir_address = obj_pooler.get('directory.address.proxy')
        if data['form']['only_not_validated']:
            selected_ids = obj_dir_address.search(cr,uid,[('user_validated','=',False),('already_validated','=',False)])
        else:
            selected_ids = obj_dir_address.search(cr,uid,[])
        if selected_ids:
            addr_proxies = obj_dir_address.browse(cr,uid,selected_ids)
            changed = 0
            for addr_proxy in addr_proxies:
                old_email = addr_proxy.sending_address or ''
                addr = addr_proxy.address_id
                selected_jobs = []
                sending_address = ''
                sending_name = ''
                sending_courtesy = ''
                sending_sequence = 9999
                if addr.job_ids:
                    for job in addr.job_ids:
                        if job.contact_id:
                            new_job = {'sequence':job.sequence_directory or 99,
                                       'last_name':job.contact_id.name,
                                       'first_name':job.contact_id.first_name or '',
                                       'address_proxy_id':addr_proxy.id,
                                       'job_id':job.id,
                                       'contact_id':job.contact_id.id,
                                       'address_id':addr.id,
                                       'email': job.email or job.contact_id.email or '',
                                       'mobile_confidential':'conf' in (job.contact_id.mobile or ''),
                                       'title': job.function_label or '',
                                       'categs': job.function_code_label or '',
                                       'final_courtesy': job.contact_id.title or '',
                                      }
                            selected_jobs.append(new_job)
                if selected_jobs:
                    selected_jobs = sorted(selected_jobs,key= lambda x: x['sequence'])
                found_g = False
                new_sequence = 1
                # before searching for first G, we must exclude the cases where there is a '@' contact on this address or a '!' contact on the partner
                if addr.job_ids:
                    for addr_job in addr.job_ids:
                        if addr_job.function_code_label and ('@' in addr_job.function_code_label) and addr_job.contact_id and (addr_job.email or addr_job.contact_id.email):
                            sending_address = addr_job.email or addr_job.contact_id.email
                            sending_courtesy = addr_job.contact_id.title or ''
                            sending_name = addr_job.contact_id.name
                            found_g = True
                            break
                if (not sending_address) and addr.partner_id and (not found_g):
                    for partner_addr in addr.partner_id.address:
                        if partner_addr.job_ids:
                            for partner_job in partner_addr.job_ids:
                                if partner_job.function_code_label and ('!' in partner_job.function_code_label) and partner_job.contact_id and (partner_job.email or partner_job.contact_id.email):
                                    sending_address = partner_job.email or partner_job.contact_id.email
                                    sending_courtesy = partner_job.contact_id.title or ''
                                    sending_name = partner_job.contact_id.name
                                    found_g = True
                                    break
                        if found_g:
                            break
                if not found_g:
                    for new_job in selected_jobs:
                        if new_job['email'] and new_job['email'] != old_email and (not sending_address or (sending_address and (not found_g) and ('G' in new_job['categs']))):
                            sending_address = new_job['email']
                            sending_courtesy = new_job['final_courtesy']
                            sending_name = new_job['last_name']
                            found_g = ('G' in new_job['categs'])
                    if not sending_address and addr.email and addr.email[0:5] != 'info@':
                        sending_address = addr.email
                        sending_courtesy = 'Cher'
                        sending_name = 'membre'
                # new on 2015-12-11
                # if member with a zip_code or a vat number not belgian, no sending_address, it must be corrected by paper sending
                # because the web form can't manage strangers VAT ou zip codes
                if (addr.partner_id.vat and addr.partner_id.vat[0:2].upper() != 'BE'):
                    sending_address = ''
                    sending_courtesy = ''
                    sending_name = ''
                else:
                    belgian = False
                    if addr.zip_id and addr.zip_id.groups_id:
                        for group in addr.zip_id.groups_id:
                            if group.name == u'Belgique' and len(group.name) == 8:
                                belgian = True
                    if not belgian:
                        sending_address = ''
                        sending_courtesy = ''
                        sending_name = ''
                if sending_address and sending_address != old_email:
                    obj_dir_address.write(cr,uid,[addr_proxy.id,],{'sending_address':sending_address,'sending_name':sending_name,'sending_courtesy':sending_courtesy})
                    changed += 1
            data['form']['count_changed'] = str(changed)+'/'+str(len(selected_ids))
        else:
            data['form']['count_changed'] = 'Nothing to do'
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('change_email','Change email','gtk-find',True)]},
        },
        'change_email': {
            'actions': [_change_email],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Close')]}
        },
    }

cci_memberdirectory_try_new_email('cci_memberdirectory_try_new_email')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

