# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import pooler
import datetime

form = """<?xml version="1.0"?>
<form string="Waiting Approval for Good for Shooting">
    <field name="last_action" colspan="2" width="700"/>
</form>"""

fields = {
    'last_action': {'string': 'Last action date', 'type':'date','required':True},
}

def _select_waiting(self, cr, uid, data, context):
    obj_fp = pooler.get_pool(cr.dbname).get('directory.fullpage')
    fp_ids = obj_fp.search(cr,uid,[('state','=','gfs_sended')])
    if fp_ids:
        fps = obj_fp.browse(cr,uid,fp_ids)
        final_ids = []
        for fp in fps:
            last_action_date = ""
            for hist in fp.history_ids:
                if hist.hour[0:10] > last_action_date:
                    last_action_date = hist.hour[0:10]
            if last_action_date and last_action_date <= data['form']['last_action']:
                final_ids.append(fp.id)
    else:
        final_ids = []
    value = {
        'domain': [('id', 'in', final_ids)],
        'name': 'Waiting Approval Full Pages',
        'view_type': 'form',
        'view_mode': 'tree,form',
        'res_model': 'directory.fullpage',
        'context': {},
        'type': 'ir.actions.act_window'
    }
    return value

class cci_memberdirectory_waiting_approval(wizard.interface):
    def _default(self,cr,uid,data,context):
        data['form']['last_action'] = (datetime.date.today()-datetime.timedelta(5,0,0)).strftime('%Y-%m-%d')
        return data['form']
    states = {
        'init': {
            'actions': [_default],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('show','Show','gtk-find',True)]},
        },
        'show': {
            'actions': [_select_waiting],
            'result': {'type': 'action','action': _select_waiting,'state': 'end'},
        },
    }
cci_memberdirectory_waiting_approval("cci_memberdirectory_waiting_approval")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

