# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
# 2012-01-13 Philmer correct the selected address for the invoice : 'invoice', else 'default' else first one
# 2012-02-07 Philmer select only active addresses with SQL SELECT
# 2018-01-09 Philmer removing line 'invoice form additional sites'
import time
from osv import fields
import wizard
import pooler
from tools.translate import _

def _invoice_membership(self, cr, uid, data, context):
    partner_ids = data['ids']
    product_id = data['form']['product']
    #site_product_id = data['form']['site_product_id']
    pool = pooler.get_pool(cr.dbname)
    cr.execute('''
            SELECT partner_id, id, type
            FROM res_partner_address
            WHERE active = true AND partner_id IN (%s)
            ORDER by partner_id
            ''' % ','.join([str(id) for id in partner_ids])
            )
    fetchal = cr.fetchall()
    if not fetchal and len(partner_ids) <= 1:
        raise wizard.except_wizard(_('Error !'), _('No Address defined for this partner'))
    partner_address_ids = {}
    for x in range(len(fetchal)):
        pid = fetchal[x][0]
        id = fetchal[x][1]
        type = fetchal[x][2]
        if partner_address_ids.has_key(pid):
            if type == 'invoice':
                partner_address_ids[pid] = {'id': id, 'type': type}
            elif type == 'default' and partner_address_ids[pid]['type'] != 'invoice':
                    partner_address_ids[pid] = {'id': id, 'type': type}
        else:
            partner_address_ids[pid] = {'id': id, 'type': type}
    # check if all selected partners have an address, else the invoicing will fail
    partners_wo_address = []
    for pid in partner_ids:
        if not partner_address_ids.has_key(pid):
            partners_wo_address.append(pid)
    invoice_list= []
    if partners_wo_address:
        raise wizard.except_wizard(_('Error !'), _('Some partners have no address (%s) !' % ','.join([str(id) for id in partners_wo_address]) ))
    else:
        invoice_obj = pool.get('account.invoice')
        partner_obj = pool.get('res.partner')
        product_obj = pool.get('product.product')
        invoice_line_obj = pool.get(('account.invoice.line'))
        invoice_tax_obj = pool.get(('account.invoice.tax'))
        product = product_obj.read(cr, uid, product_id, ['uom_id','description','description_sale'])
        #site_product = product_obj.read(cr, uid, site_product_id, ['uom_id','description','description_sale'])
        #desc_site_prod = desc_prod = ''
        if product['description']:
            desc_prod = product['description']
        else:
            desc_prod = product['description_sale'] or ''
        #if site_product['description']:
        #    desc_site_prod = site_product['description']
        #else:
        #    desc_site_prod = site_product['description_sale'] or ''
        for partner_id in partner_ids:
            # check if there is a membership amount on the partner
            # if not, ignore this partner and display a message only if this partner is the only invoiced one
            partner_data = partner_obj.read(cr, uid, partner_id, ['membership_amount','next_membership_bill_forced','property_payment_term']) # ,'site_membership','desc_add_site'
            membership_amount =  partner_data['membership_amount']
            if membership_amount:
                #suppl_sites = partner_data['site_membership'] or 0
                #desc_site = partner_data['desc_add_site'] or ''
                account_id = partner_obj.read(cr, uid, partner_id, ['property_account_receivable'])['property_account_receivable'][0]
                read_fpos = partner_obj.read(cr, uid, partner_id, ['property_account_position'])
                fpos_id = read_fpos['property_account_position'] and read_fpos['property_account_position'][0]
                line_value =  {
                    'product_id' : product_id,
                    }
                quantity = 1
                line_dict = invoice_line_obj.product_id_change(cr, uid, {}, product_id, product['uom_id'][0], quantity, '', 'out_invoice', partner_id, fpos_id, context=context)
                line_value.update(line_dict['value'])
                if line_value['invoice_line_tax_id']:
                    tax_tab = [(6, 0, line_value['invoice_line_tax_id'])]
                    line_value['invoice_line_tax_id'] = tax_tab
                address_id = 0
                if partner_address_ids.has_key(partner_id):
                    address_id = partner_address_ids[partner_id]['id']
                invoice_id = invoice_obj.create(cr, uid, {
                    'name': '',
                    'partner_id' : partner_id,
                    'address_invoice_id': address_id,
                    'account_id': account_id,
                    'payment_term': partner_data['property_payment_term'] and partner_data['property_payment_term'][0] or False,
                    'fiscal_position': fpos_id or False
                    }
                )
                line_value['invoice_id'] = invoice_id
                line_value['price_unit'] = membership_amount
                line_value['note'] = desc_prod
                #membership_amount =  partner_obj.read(cr, uid, partner_id, ['membership_amount'])['membership_amount']
                #if membership_amount:
                #    line_value['price_unit'] = membership_amount
                invoice_line_id = invoice_line_obj.create(cr, uid, line_value, context)
                #if suppl_sites:
                #    site_line_value =  {
                #        'product_id' : site_product_id,
                #        }
                #    site_line_dict = invoice_line_obj.product_id_change(cr, uid, {}, site_product_id, site_product['uom_id'][0], suppl_sites, '', 'out_invoice', partner_id, fpos_id, context=context)
                #    site_line_value.update(site_line_dict['value'])
                #    if site_line_value['invoice_line_tax_id']:
                #        tax_tab = [(6, 0, site_line_value['invoice_line_tax_id'])]
                #        site_line_value['invoice_line_tax_id'] = tax_tab
                #    site_line_value['invoice_id'] = invoice_id
                #    site_line_value['quantity'] = suppl_sites
                #    if '<desc>' in desc_site_prod:
                #        site_line_value['note'] = desc_site_prod.replace('<desc>',desc_site)
                #    else:
                #        site_line_value['note'] = desc_site_prod
                #    site_line_id = invoice_line_obj.create(cr, uid, site_line_value, context)
                #    invoice_obj.write(cr, uid, invoice_id, {'invoice_line':[(6,0,[invoice_line_id,site_line_id])]})
                #else:
                invoice_obj.write(cr, uid, invoice_id, {'invoice_line':[(6,0,[invoice_line_id])]})
                invoice_list.append(invoice_id)
                if line_value['invoice_line_tax_id']:
                    tax_value = invoice_tax_obj.compute(cr, uid, invoice_id).values()
                    for tax in tax_value:
                        invoice_tax_obj.create(cr, uid, tax, context=context)
                if data['form']['remove_forced'] and partner_data['next_membership_bill_forced']:
                    partner_obj.write(cr, uid, [partner_id,],{'next_membership_bill_forced':False})
            else:
                if len(partner_ids) == 1:
                    raise wizard.except_wizard(_('Warning !'), _('No invoice created, because this partner has an empty membership amount !'))
    value = {
            'domain': [
                ('id', 'in', invoice_list),
                ],
            'name': _('Membership invoice'),
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'account.invoice',
            'type': 'ir.actions.act_window',
            'context':{'type':'out_invoice'},
        }
    return value

wizard_arch= """<?xml version="1.0"?>
<form string="Choose invoice details">
    <field name="product" domain="[('membership','=','True')]" context="product='membership_product'" colspan="4" width="800"/>
    <field name="remove_forced" colspan="4"/>
</form>"""
#    <field name="site_product_id" domain="[('membership','=','True')]" context="product='membership_product'" colspan="4"/>

class wizard_extend_invoice_membership(wizard.interface):

    states = {
        'init' : {
            'actions' : [],
            'result' : {
                'type' : 'form',
                'arch' : wizard_arch,
                'fields' : {
                        'product': {
                            'string': 'Membership product',
                            'type': 'many2one',
                            'relation': 'product.product',
                            'required': True
                        },
                        'remove_forced': {'string':'Remove Forced Invoicing','type':'boolean','default':True},
                        #'site_product_id': {
                        #    'string': 'Site product',
                        #    'type': 'many2one',
                        #    'relation': 'product.product',
                        #    'required': True
                        #},
                },
                'state' : [('end', 'Cancel'),('ok', 'Confirm') ]}
        },
        'ok' : {
            'actions' : [],
            'result' : {'type' : 'action',
                        'action': _invoice_membership,
                        'state' : 'end'
            },
        },

    }

wizard_extend_invoice_membership("cci_wizard_extend_invoice_membership")

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
