# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
import tools
import pooler
import base64
from pyExcelerator import *

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="choice" colspan="4"/>
</form>"""

fields = {
    'choice': {'string': 'Selection', 'type':'selection','selection': [('all','Tous les appels préparés'),('selected','Seulement les sélectionnés')],'required': True,'default':'all'},
   }

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="calls.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'calls.xls':{'string': 'Prepared file',
        'type': 'binary',
        'readonly': True,},
}

class extract_calls_in_excel(wizard.interface):
    def _get_file(self,cr,uid,data,context):
        call_obj = pooler.get_pool(cr.dbname).get('cci_membership.membership_call')
        if data['form']['choice'] == 'all':
            call_ids = call_obj.search(cr,uid,[])
        else:
            call_ids = data['ids']
        fields = ['partner_id','address_id','job_id','contact_id','partner_name',
                  'street','street2','zip_code','city','email_addr','phone_addr','fax_addr',
                  'name','first_name','courtesy','title','title_categs','email_contact',
                  'base_amount','count_add_sites','unit_price_site','desc_add_site','wovat_amount','wvat_amount',
                  'char_wovat_amount','char_wvat_amount','salesman','salesman_phone','salesman_fax','salesman_mobile',
                  'salesman_email','salesman_linkedin','salesman_login',
                  'mailing_email','mailing_complete_name','mailing_courtesy','mailing_name','mailing_firstname',
                  'mailing_job_id','mailing_contact_id','mailing_send_date','vcs','vat_num']
        if call_ids:
            calls = call_obj.read(cr,uid,call_ids,fields)
        else:
            calls = []
        # get the data about all contact title
        title_obj = pooler.get_pool(cr.dbname).get('res.partner.title')
        title_ids = title_obj.search(cr,uid,[('domain','=','contact')])
        titles = title_obj.read(cr,uid,title_ids,['id','shortcut','name','other1','other2'])
        dTitles = {}
        for tit in titles:
            dTitles[tit['name']] = tit
        #
        wb1 = Workbook()
        ws1 = wb1.add_sheet('Appels')
        for index in range(0,len(fields)):
            ws1.write(0,index,fields[index])
        index += 1
        ws1.write(0,index,'courtesy1')
        index += 1
        ws1.write(0,index,'courtesy2')
        line = 1
        for call in calls:
            for index in range(0,len(fields)):
                if fields[index] in ['partner_id','address_id','job_id','contact_id','mailing_job_id','mailing_contact_id']:
                    ws1.write(line,index,call[fields[index]] and call[fields[index]][0] or 0)
                else:
                    ws1.write(line,index,call[fields[index]] or '')
            courtesy1 = ''
            courtesy2 = ''
            if call['courtesy'] and dTitles.has_key(call['courtesy']):
                courtesy1 = dTitles[call['courtesy']]['other1'] or ''
                courtesy2 = dTitles[call['courtesy']]['other2'] or ''
            index += 1
            ws1.write(line,index,courtesy1)
            index += 1
            ws1.write(line,index,courtesy2)
            line += 1
        wb1.save('calls.xls')
        result_file = open('calls.xls','rb').read()

        # give the result tos the user
        data['form']['msg']='Save the File with '".xls"' extension.'
        data['form']['calls.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('getfile','Get Excel File')]},
        },
        'getfile': {
            'actions': [_get_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

extract_calls_in_excel('extract_calls_in_excel')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

