# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
from osv import fields
import wizard
import pooler
import base64
from pyExcelerator import *
from tools.translate import _

wizard_arch= """<?xml version="1.0"?>
<form string="Select range">
    <field name="date_from"/>
    <field name="date_to"/>
    <field name="conso"/>
</form>"""

wizard_fields = {
    'date_from': {'string': 'From','type': 'date', 'required':True},
    'date_to': {'string': 'To','type': 'date', 'required':True},
    'conso': {'string': 'With Consumption', 'type':'boolean','default':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="chg_members.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'chg_members.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

def _french_date(english_date):
    return english_date[8:10]+'/'+english_date[5:7]+'/'+english_date[0:4]
def _substract_a_year(date):
    # date = string YYYY-MM-DD
    year = int(date[0:4])
    rest = date[5:]
    if rest == '02-29':
        rest = '02-28'
    return str(year-1)+'-'+rest
def _beginning_of_month(date):
    # date = string YYYY-MM-DD
    return date[0:8]+'01'
    
class extract_chg_members(wizard.interface):
    def _extract_data(self, cr, uid, data, context):
        partner_obj = pooler.get_pool(cr.dbname).get('res.partner')
        #res_new = partner_obj._new_members_between_2_dates(cr,uid,data['form']['date_from'],data['form']['date_to'],'date_from')
        #res_old = partner_obj._lost_members_between_2_dates(cr,uid,data['form']['date_from'],data['form']['date_to'],'date_to')
        (res_news,res_olds) = partner_obj._changed_members_between_2_dates(cr,uid,data['form']['date_from'],data['form']['date_to'],'date_from','date_from')
        consos = []
        if data['form']['conso']:
            conso_shemas = ['FreeEvents','PaidEvents','PaidAE','PaidCNN','PaidTC','PaidMS','PaidPublication','PaidSponsoring','PaidMissions']
            date_conso_to = data['form']['date_to']
            date_conso_from = max('2017-03-29',_substract_a_year(_beginning_of_month(data['form']['date_to'])))
            new_members_conso = partner_obj._new_members_between_2_dates(cr,uid,date_conso_from,date_conso_to,'date_from')	
            new_member_conso_ids = [x['partner_id'] for x in new_members_conso]
            dResCons = partner_obj._extract_consumption(cr,uid,date_conso_from,date_conso_to,conso_shemas,new_member_conso_ids)
            for member in new_members_conso:
                member.update(dResCons[member['partner_id']])
                consos.append(member)
        filename = 'chg_members'+datetime.datetime.now().strftime('%Y%m%d_%H%M%S')+'.xls'
        partner_obj._members_followup_excel_file(cr,
                                                 uid,
                                                 filename,
                                                 data['form']['date_from'],
                                                 data['form']['date_to'],
                                                 datetime.date.today(),
                                                 res_news,
                                                 res_olds,
                                                 consos,
                                                 _french_date(data['form']['date_from']) + ' -> ' + _french_date(data['form']['date_to']) )
        # give the result to the user
        result_file = open(filename,'rb').read()
        data['form']['msg']='Save the File with '".xls"' extension.'
        data['form']['chg_members.xls']=base64.encodestring(result_file)
        return data['form']
    states = {
        'init' : {
            'actions' : [],
            'result' : {'type':'form','arch':wizard_arch,'fields':wizard_fields,'state':[('end', 'Cancel'),('ok', 'Confirm') ]}
        },
        'ok' : {
            'actions' : [_extract_data],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
extract_chg_members("extract_chg_members")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
