# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
import tools
import pooler
import base64
from pyExcelerator import *

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="choice" colspan="4"/>
</form>"""

fields = {
    'choice': {'string': 'Selection', 'type':'selection','selection': [('all','Toutes les fiches préparées'),('selected','Seulement les sélectionnées')],'required': True,'default':'all'},
   }

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="membership_by_year.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'membership_by_year.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class extract_membership_by_year(wizard.interface):
    def _get_file(self,cr,uid,data,context):
        record_obj = pooler.get_pool(cr.dbname).get('cci_membership.membership_by_partner')
        record_ids = data['ids']
        fields = ['partner_id','partner_name','user_id','user_name','year','invoiced','paid','canceled','open']
        records = record_obj.browse(cr,uid,record_ids)
        #
        wb = Workbook()
        ws1 = wb.add_sheet('Membership by Year and Partner')
        for index in range(0,len(fields)):
            ws1.write(0,index,fields[index])
        line = 1
        for record in records:
            ws1.write(line,0,record.partner_id.id)
            ws1.write(line,1,record.partner_id.name)
            ws1.write(line,2,record.user_id and record.user_id.id)
            ws1.write(line,3,record.user_id and record.user_id.name)
            ws1.write(line,4,record.year)
            ws1.write(line,5,record.invoiced)
            ws1.write(line,6,record.paid)
            ws1.write(line,7,record.canceled)
            ws1.write(line,8,record.open)
            line += 1
        wb.save('membership_by_year.xls')
        result_file = open('membership_by_year.xls','rb').read()

        # give the result tos the user
        data['form']['msg']='Save the File with '".xls"' extension.'
        data['form']['membership_by_year.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('getfile','Get Excel File')]},
        },
        'getfile': {
            'actions': [_get_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

extract_membership_by_year('extract_membership_by_year')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

