# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import pooler
import datetime
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Extract Prospects Additional Sites" width="400">
    <label string="Extraction of partners with multiple addresses but no additional sites invoiced with membership."/>
</form>
"""

fields = {
}

class extract_prospect_addsite(wizard.interface):

    def _open_window_selected_partners(self, cr, uid, data, context):
        partner_obj = pooler.get_pool(cr.dbname).get('res.partner')
        member_ids = partner_obj.search(cr,uid,[('state_id','=',1),('site_membership','<',1),('membership_state','in',['free','invoiced','paid'])])
        partners = partner_obj.read(cr,uid,member_ids,['id','address'])
        partner_ids = []
        for partner in partners:
            if partner['address'] and len(partner['address']) > 1:
                partner_ids.append(partner['id'])
        result = {
            'domain': [('id', 'in', partner_ids)],
            'name': _('Prospects Additional Site Membership'),
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'res.partner',
            'context': { },
            'type': 'ir.actions.act_window'
        }
        return result

    states = {
        'init' : {
            'actions' : [],
            'result' : {'type' : 'form' , 'arch' : form,
                    'fields' : fields,
                    'state' : [('end', 'Cancel'), ('go', 'Go')]}
        },
        'go': {
            'actions': [],
            'result': {'type': 'action', 'action':_open_window_selected_partners, 'state':'end'}
        }

    }
extract_prospect_addsite("extract_prospect_addsite")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

