# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import pooler
import datetime
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Extract Partners with lower membership than last invoiced" width="400">
    <field name="only_members"/>
    <newline/>
    <label string="Extraction of used membership amount." colspan="2" width="400"/>
</form>
"""

fields = {
    'only_members':{'string':'Only for current members','type':'boolean','default':True,'help':'If not checked, the list will count ALL active partners ...'},
}

class extract_used_membership_amount(wizard.interface):


    def _open_window_counts(self, cr, uid, data, context):
        # delete all old values
        selection = "DELETE FROM cci_membership_membership_askedused"
        cr.execute( selection )
        selection = '' # unusefull just for the case of
        # count by grouping
        if data['form']['only_members']:
            selection = "SELECT membership_amount, COUNT(id) FROM res_partner WHERE active AND membership_state in ('free','invoiced','paid') AND state_id = 1 GROUP BY membership_amount ORDER BY membership_amount"
            sel_type = 'members'
        else:
            selection = "SELECT membership_amount, COUNT(id) FROM res_partner WHERE active AND state_id = 1 GROUP BY membership_amount ORDER BY membership_amount"
            sel_type = 'all'
        cr.execute( selection )
        counts = cr.fetchall()
        m_used_obj =  pooler.get_pool(cr.dbname).get('cci_membership.membership_askedused')
        if counts:
            for line in counts:
                data = { 'amount': line[0] or 0.0,
                         'count': line[1] or 0,
                         'total_value':(line[0] or 0.0)*(line[1] or 0),
                         'type':sel_type,
                       }
                newcount_id = m_used_obj.create(cr, uid, data, context)
        result = {
            'name': _('Used Membership Amounts'),
            'view_type': 'form',
            'view_mode': 'tree,graph,form',
            'res_model': 'cci_membership.membership_askedused',
            'context': { },
            'type': 'ir.actions.act_window'
        }
        return result

    states = {
        'init' : {
            'actions' : [],
            'result' : {'type' : 'form' , 'arch' : form,
                    'fields' : fields,
                    'state' : [('end', 'Cancel'), ('go', 'Go')]}
        },
        'go': {
            'actions': [],
            'result': {'type': 'action', 'action':_open_window_counts, 'state':'end'}
        }

    }
extract_used_membership_amount("extract_used_membership_amount")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

