# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import pooler
import datetime
import base64
from pyExcelerator import *
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="List Members at a given Date">
    <field name="searched_date" colspan="4"/>
</form>
"""

fields = {
    'searched_date':{'string':'Date','type':'date','required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="list_members_at_date.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'list_members_at_date.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class list_members_at_date(wizard.interface):
    def _create_excel_file(self, cr, uid, data, context):
        # manage parameters
        searched_date = data['form']['searched_date']
        french_date = searched_date[8:10]+'/'+searched_date[5:7]+'/'+searched_date[0:4]
        wb = Workbook()
        ws1 = wb.add_sheet(_('Members'))
        ws1.write(0,0,u'Cette liste donne les membres à la date du \'%s\'.' % (french_date))
        ws1.write(1,0,u'Seuls les membres cotisants, facturés et/ou gratuits figurent dans cette liste.')
        ws1.write(2,0,u'Date de calcul : ' + datetime.date.today().strftime('%d/%m/%Y'))
        if searched_date <= '2017-04-30':
            ws1.write(4,0,_('This tool is only usable on dates after 2017-04-30 before the recording started at this date'))
        else:
            if searched_date >= datetime.date.today().strftime('%Y-%m-%d'):
                ws1.write(4,0,_('This tool can be used to project the membership in the future. However, you can try : www.meteo.be.'))
            else:
                ws1.write(5,0,'partner_id')
                ws1.write(5,1,_('Partner Name'))
                ws1.write(4,2,_('Situation at %s ->') % french_date)
                ws1.write(5,2,_('Membership State'))
                ws1.write(5,3,_('Amount Year %s') % searched_date[0:4])
                ws1.write(5,4,_('Free Status'))
                ws1.write(4,6,_('Situation at %s ->') % datetime.date.today().strftime('%d/%m/%Y'))
                ws1.write(5,6,_('Membership State'))
                ws1.write(5,7,_('Free Status'))
                ws1.write(5,8,_('Refuse Status'))
                ws1.write(5,9,_('Parrain'))
                line = 6
                #
                partner_obj = pooler.get_pool(cr.dbname).get('res.partner')
                change_obj = pooler.get_pool(cr.dbname).get('membership_state_change')
                # We extract all partners from membership_state_change to validate only these and not all the db
                sentence = """SELECT distinct(partner_id) FROM membership_state_change"""
                cr.execute(sentence)
                res = cr.fetchall()
                partner_ids = [x[0] for x in res]
                #
                dPartners = {}
                for partner_id in partner_ids:
                    state_at_date = partner_obj._get_membership_state_at_date(cr,uid,partner_id,searched_date)
                    if state_at_date in ['paid','invoiced','free']:
                        partner = partner_obj.browse(cr,uid,partner_id)
                        change_id = partner_obj._get_membership_state_change_at_date(cr,uid,partner_id,searched_date)
                        amount_year = 0.0
                        if change_id:
                            change = change_obj.browse(cr,uid,change_id)
                            if change.date_from[0:4] == searched_date[0:4]:
                                amount_year = (change.amount_current_year or 0.0)
                            elif (int(change.date_from[0:4])+1) == int(searched_date[0:4]):
                                amount_year = (change.amount_next_year or 0.0)
                            elif (int(change.date_from[0:4])-1) == int(searched_date[0:4]):
                                amount_year = (change.amount_past_year or 0.0)
                        ws1.write(line,0,partner_id)
                        ws1.write(line,1,partner.name)
                        ws1.write(line,2,state_at_date)
                        ws1.write(line,3,change_id and amount_year or 0.0)
                        if change_id:
                            ws1.write(line,4,change.free and 'GRATUIT' or '')
                        else:
                            ws1.write(line,4,'')
                        ws1.write(line,6,partner.membership_state or 'unknown')
                        ws1.write(line,7,partner.free_member and 'GRATUIT' or '')
                        ws1.write(line,8,partner.refuse_membership and 'REFUSE' or '')
                        ws1.write(line,9,partner.associate_member and partner.associate_member.name or '')
                        line += 1
        wb.save('list_members_at_date.xls')
        result_file = open('list_members_at_date.xls','rb').read()

        # give the result tos the user
        data['form']['msg'] = 'Save the File with '".xls"' extension.'
        data['form']['list_members_at_date.xls'] = base64.encodestring(result_file)
        return data['form']

    states = {
        'init' : {
            'actions' : [],
            'result' : {'type' : 'form' , 'arch' : form,
                    'fields' : fields,
                    'state' : [('end', 'Cancel'), ('getfile', 'Get File')]}
        },
        'getfile': {
            'actions': [_create_excel_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },

    }
list_members_at_date("list_members_at_date")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

