# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import pooler
import datetime
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Extract New Members" width="400">
    <field name="since"/>
</form>
"""

fields = {
    'since':{'string':'New Since','type':'date','required':True},
}

class extract_new_members_since(wizard.interface):

    def _open_window_selected_partners(self, cr, uid, data, context):
        selection = "SELECT id FROM res_partner WHERE active AND membership_state in ('free','invoiced','paid') AND cci_date_start_membership >= '%s'" % data['form']['since']
        cr.execute( selection )
        partners = cr.fetchall()
        partner_ids = [x[0] for x in partners]
        result = {
            'domain': [('id', 'in', partner_ids)],
            'name': _("New Members Since '%s'") % data['form']['since'],
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'res.partner',
            'context': { },
            'type': 'ir.actions.act_window'
        }
        return result

    states = {
        'init' : {
            'actions' : [],
            'result' : {'type' : 'form' , 'arch' : form,
                    'fields' : fields,
                    'state' : [('end', 'Cancel'), ('go', 'Go')]}
        },
        'go': {
            'actions': [],
            'result': {'type': 'action', 'action':_open_window_selected_partners, 'state':'end'}
        }

    }
extract_new_members_since("new_members_since")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

