# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import pooler
import datetime
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Search for products used for membership's bills" width="600">
    <field name="from_year"/>
    <field name="to_year"/>
</form>
"""

fields = {
    'from_year':{'string':'From (membership year)','type':'integer','default':int(datetime.datetime.today().strftime('%Y')),'required':True},
    'to_year':{'string':'To (membership year)','type':'integer','default':int(datetime.datetime.today().strftime('%Y')),'required':True},
}

class use_membership_products(wizard.interface):


    def _search_products(self, cr, uid, data, context):
        from_year = min(data['form']['from_year'],data['form']['to_year'])
        to_year = max(data['form']['from_year'],data['form']['to_year'])
        selection = "SELECT id from product_product where membership_year BETWEEN %s AND %s" % (str(from_year),str(to_year))
        cr.execute( selection )
        res = cr.fetchall()
        if len(res) == 0:
            prod_ids = ''
        else:
            prod_ids = ( ','.join([str(x[0]) for x in res]) ) + ','
        result = {
            'name': _("Products used for membership's bills between %s and %s") % (from_year,to_year),
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'product.product',
            'domain':"[('id','in',[%s]),'|',('active','=',True),('active','=',False)]" % prod_ids,
            'type': 'ir.actions.act_window'
        }
        return result

    states = {
        'init' : {
            'actions' : [],
            'result' : {'type' : 'form' , 'arch' : form,
                    'fields' : fields,
                    'state' : [('end', 'Cancel'), ('search', 'Search')]}
        },
        'search': {
            'actions': [],
            'result': {'type': 'action', 'action':_search_products, 'state':'end'}
        }

    }
use_membership_products("use_membership_products")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

