# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
import wizard
import pooler
from tools.translate import _
from pyExcelerator import *
import base64
import csv
import unicodedata

form = """<?xml version="1.0"?>
<form string="Extract Odoo 12">
    <field name="test"/>
    <field name="compta"/>
    <field name="category_id" colspan="4" width="600"/>
</form>"""

fields = {
      'test': {'string':'Test Data','type':'boolean','default':True},
      'compta': {'string':'Compta','type':'boolean','default':False},
      'category_id': {'string': 'Activity Sectors Root', 'type':'many2one','relation': 'res.partner.category','required': True},
}

msg_form = """<?xml version="1.0"?>
<form string="Result">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="res_partner_zip_group_type.csv" colspan="4" />
     <field name="res_partner_zip_group.csv" colspan="4" />
     <field name="res_partner_zip.csv" colspan="4" />
     <field name="res_partner_zip_demo.xml" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'Files created', 'type':'text', 'size':'100','readonly':True},
    'res_partner_zip_group_type.csv':{'string': 'Fichier','type': 'binary','readonly': True,},
    'res_partner_zip_group.csv':{'string': 'Fichier','type': 'binary','readonly': True,},
    'res_partner_zip.csv':{'string': 'Fichier','type': 'binary','readonly': True,},
    'res_partner_zip_demo.xml':{'string': 'Fichier','type': 'binary','readonly': True,},
}

DAJNL = {'VEN':'__export__.account_journal_1_9d9e3fb3',
         'NCV':'__export__.account_journal_1_9d9e3fb3',
         'ACH':'__export__.account_journal_2_0455cf9f',
         'NCA':'__export__.account_journal_2_0455cf9f',
         'JOD':'__export__.account_journal_3_84c150f1',
         'LIS':'__export__.account_journal_3_84c150f1',
         'CBC':'__export__.account_journal_10_aa502634',
         'CBCO':'__export__.account_journal_14_e870daf6',
         'FORT':'__export__.account_journal_11_fa7f249e',
         'ING':'__export__.account_journal_7_3df04b83',
         'CCP':'__export__.account_journal_13_ceea6483',
         'CPS':'__export__.account_journal_6_d87663b1',
         'SOC':'__export__.account_journal_15_b9b1ec31',
         'AWEX':'__export__.account_journal_16_c5d9cf6f',
         'CF':'__export__.account_journal_18_1489e0fa',
         'OUV':'__export__.account_journal_17_b60a8fd1',
         'CARD':'__export__.account_journal_24_4c12c265',
         'LIS':'__export__.account_journal_25_0c19d17d',
    }
dAccountCode2NewID = {"100000":"l10n_be.1_a1000",
"110000":"l10n_be.1_a11",
"130000":"l10n_be.1_a130",
"131000":"__export__.account_account_202_712f73c6",
"131120":"__export__.account_account_203_b1a37b3c",
"132000":"l10n_be.1_a132",
"140000":"l10n_be.1_a140",
"141000":"l10n_be.1_a141",
"150000":"l10n_be.1_a150",
"151000":"l10n_be.1_a151",
"160000":"l10n_be.1_a1600",
"163000":"__export__.account_account_204_c069c933",
"164200":"__export__.account_account_205_1af355da",
"172000":"l10n_be.1_a1720",
"172010":"__export__.account_account_206_97eec4cf",
"172100":"l10n_be.1_a1721",
"172200":"l10n_be.1_a1722",
"172310":"__export__.account_account_207_ee96ad9e",
"172400":"__export__.account_account_208_b95e3f20",
"172500":"__export__.account_account_209_cab6be1e",
"172800":"__export__.account_account_210_0d226edd",
"172900":"__export__.account_account_211_9ebbb8c8",
"172950":"__export__.account_account_212_26b88847",
"172960":"__export__.account_account_213_03905e42",
"173000":"l10n_be.1_a17300",
"174000":"l10n_be.1_a174",
"174400":"__export__.account_account_214_622dcd2a",
"175110":"l10n_be.1_a175110",
"175111":"l10n_be.1_a175111",
"175112":"l10n_be.1_a175112",
"176000":"l10n_be.1_a176",
"200000":"l10n_be.1_a2000",
"200900":"l10n_be.1_a2009",
"204000":"__export__.account_account_215_b69e786e",
"204900":"__export__.account_account_216_92734d30",
"210000":"l10n_be.1_a2100",
"210800":"l10n_be.1_a2108",
"210900":"l10n_be.1_a2109",
"211000":"l10n_be.1_a2110",
"211009":"__export__.account_account_217_3f2b710b",
"211800":"l10n_be.1_a2118",
"211900":"l10n_be.1_a2119",
"213000":"__export__.account_account_218_a8a19686",
"220000":"__export__.account_account_219_0794f08d",
"220200":"__export__.account_account_220_e581a44a",
"220900":"__export__.account_account_221_1ba10856",
"221000":"__export__.account_account_222_5f8fcce7",
"221900":"__export__.account_account_223_1c0a4e1c",
"240000":"l10n_be.1_a24000",
"240009":"__export__.account_account_224_c4260075",
"241000":"l10n_be.1_a24100",
"241009":"__export__.account_account_225_0288316f",
"241050":"l10n_be.1_a24105",
"241900":"l10n_be.1_a24190",
"242000":"__export__.account_account_226_958cbbcc",
"242009":"__export__.account_account_227_ad095bf4",
"243000":"__export__.account_account_228_d5ac3659",
"243009":"__export__.account_account_229_744fc0cb",
"260000":"l10n_be.1_a260",
"260009":"l10n_be.1_a2690",
"269999":"__export__.account_account_230_95c936ad",
"280000":"l10n_be.1_a2800",
"281000":"__export__.account_account_231_4bfc44d7",
"281100":"__export__.account_account_232_a5c3bfc1",
"281110":"__export__.account_account_233_8535f11d",
"281120":"__export__.account_account_234_fe281107",
"281130":"__export__.account_account_235_e3b1df9b",
"281139":"__export__.account_account_236_06e304a7",
"281140":"__export__.account_account_237_c72c1c44",
"282000":"__export__.account_account_238_ec5d8dab",
"284000":"__export__.account_account_239_08dfa752",
"288000":"__export__.account_account_240_6bc057ea",
"290000":"l10n_be.1_a29000",
"290700":"__export__.account_account_241_e32e5aa2",
"300000":"l10n_be.1_a300",
"310000":"l10n_be.1_a3100",
"320000":"l10n_be.1_a3200",
"329000":"l10n_be.1_a329",
"330000":"l10n_be.1_a3300",
"340000":"l10n_be.1_a3400",
"350000":"l10n_be.1_a3500",
"360000":"l10n_be.1_a360",
"370000":"l10n_be.1_a370",
"400000":"l10n_be.1_a4000",
"400050":"__export__.account_account_242_494b6f2f",
"400060":"l10n_be.1_a404",
"400065":"__export__.account_account_243_2191d325",
"400070":"__export__.account_account_244_7a2b9b7e",
"406000":"l10n_be.1_a406",
"406001":"__export__.account_account_245_8c017892",
"407000":"l10n_be.1_a407",
"409000":"__export__.account_account_493_ab37d91d",
"411000":"l10n_be.1_a411059",
"411150":"__export__.account_account_246_98e90e50",
"411200":"l10n_be.1_a4112",
"411800":"l10n_be.1_a4118",
"412000":"l10n_be.1_a4120",
"412500":"l10n_be.1_a4125",
"412800":"l10n_be.1_a4128",
"413000":"__export__.account_account_247_73fb0eef",
"414000":"l10n_be.1_a414",
"414050":"__export__.account_account_199_da5e6153",
"414100":"__export__.account_account_248_decabdaf",
"414200":"__export__.account_account_249_97a5ecc6",
"414210":"__export__.account_account_250_a4f81c75",
"414220":"__export__.account_account_251_dcf1f3e4",
"414230":"__export__.account_account_252_5e20d713",
"414300":"__export__.account_account_253_085935bb",
"414310":"__export__.account_account_254_560dd07a",
"414400":"__export__.account_account_255_c4fd06c3",
"414410":"__export__.account_account_256_7a7c49cf",
"414500":"__export__.account_account_257_748244b4",
"414510":"__export__.account_account_258_ed4155e9",
"414520":"__export__.account_account_259_d61e452b",
"414600":"__export__.account_account_260_7a68cf8c",
"414700":"__export__.account_account_261_552e4bfb",
"414810":"__export__.account_account_262_260345ef",
"414920":"__export__.account_account_263_0c965cfd",
"416000":"l10n_be.1_a4160",
"416001":"__export__.account_account_264_0d0aaabd",
"416002":"__export__.account_account_265_5d7c988b",
"416003":"__export__.account_account_266_684837fd",
"416100":"l10n_be.1_a4161",
"416180":"__export__.account_account_267_212cfcce",
"419000":"l10n_be.1_a419",
"419500":"__export__.account_account_268_8ce3c4c7",
"423000":"l10n_be.1_a4230",
"423001":"__export__.account_account_269_cc980e32",
"423100":"__export__.account_account_270_de7e228f",
"423110":"__export__.account_account_271_dbca577b",
"423200":"__export__.account_account_272_15cf2b87",
"423300":"__export__.account_account_273_a8349a74",
"423400":"__export__.account_account_274_55b534a0",
"423500":"__export__.account_account_275_1df3f327",
"423510":"__export__.account_account_276_a5cd03f1",
"423600":"__export__.account_account_277_935e5245",
"423700":"__export__.account_account_278_7af5fdc7",
"423900":"__export__.account_account_279_6c66e893",
"423950":"__export__.account_account_280_3642d6da",
"423960":"__export__.account_account_281_f61317cc",
"424000":"l10n_be.1_a424",
"430000":"l10n_be.1_a430",
"435000":"__export__.account_account_282_f8a0fb98",
"440000":"l10n_be.1_a440",
"440500":"__export__.account_account_283_b26cf8b5",
"444000":"l10n_be.1_a444",
"444100":"__export__.account_account_284_01559c38",
"446000":"l10n_be.1_a446",
"448000":"l10n_be.1_a448",
"450000":"l10n_be.1_a4500",
"450600":"__export__.account_account_285_aa9a4c01",
"451000":"l10n_be.1_a451054",
"451057":"l10n_be.1_a451057",
"451100":"l10n_be.1_a451055",
"451150":"__export__.account_account_286_02143c8c",
"451200":"l10n_be.1_a4512",
"451300":"l10n_be.1_a451056",
"452800":"__export__.account_account_287_b27469bc",
"453000":"l10n_be.1_a4530",
"453300":"l10n_be.1_a4533",
"453400":"l10n_be.1_a4538",
"454000":"l10n_be.1_a4540",
"455000":"l10n_be.1_a4550",
"456000":"l10n_be.1_a4560",
"459000":"l10n_be.1_a4590",
"459001":"__export__.account_account_288_ca832c58",
"459400":"l10n_be.1_a4594",
"459700":"l10n_be.1_a4597",
"460002":"__export__.account_account_289_08a5027f",
"460004":"__export__.account_account_290_fbdfcffc",
"460005":"__export__.account_account_291_054cf99f",
"463000":"__export__.account_account_292_61eb8dee",
"463001":"__export__.account_account_293_80050093",
"463002":"__export__.account_account_294_ce78f9ac",
"463050":"__export__.account_account_295_00ab4d60",
"463100":"__export__.account_account_296_82d95bb6",
"463101":"__export__.account_account_297_7e2f81e9",
"463102":"__export__.account_account_298_c5d2f9e2",
"463110":"__export__.account_account_299_d3d0b2ad",
"469000":"__export__.account_account_300_78e9d1b4",
"469001":"__export__.account_account_301_a7d07c7b",
"470000":"__export__.account_account_302_b7ea9af1",
"486000":"__export__.account_account_303_2110a549",
"489100":"__export__.account_account_304_e97fcf57",
"489150":"__export__.account_account_305_8454900a",
"489200":"__export__.account_account_306_6ab5c2b9",
"489400":"__export__.account_account_307_e4428163",
"489500":"__export__.account_account_308_9e7f59f6",
"490000":"l10n_be.1_a490",
"490100":"__export__.account_account_309_3c886780",
"491000":"l10n_be.1_a49100",
"491010":"l10n_be.1_a49101",
"491020":"l10n_be.1_a49102",
"492000":"l10n_be.1_a492",
"492001":"__export__.account_account_310_b6450c5d",
"493000":"l10n_be.1_a4930",
"493001":"__export__.account_account_311_ac588082",
"493002":"__export__.account_account_312_adf71ebd",
"493003":"__export__.account_account_313_c36720a4",
"493004":"__export__.account_account_314_9d9b2a41",
"493005":"__export__.account_account_315_ec009f04",
"493006":"__export__.account_account_316_7f66bbb1",
"493010":"__export__.account_account_317_dd876abc",
"493011":"__export__.account_account_318_01eed664",
"493012":"__export__.account_account_319_99c93531",
"493013":"__export__.account_account_320_4d9be35e",
"493014":"__export__.account_account_321_e9e8f363",
"493021":"__export__.account_account_322_49873ef1",
"493022":"__export__.account_account_323_96adc6a9",
"493031":"__export__.account_account_324_f8b5ba8c",
"493032":"__export__.account_account_325_ce98ed29",
"493033":"__export__.account_account_326_507d3433",
"493034":"__export__.account_account_327_d0bb3cfa",
"493035":"__export__.account_account_328_9013d94b",
"493100":"__export__.account_account_329_75f36bcd",
"493101":"__export__.account_account_330_d53708ae",
"493150":"__export__.account_account_331_75770bb6",
"499000":"l10n_be.1_a4990",
"510010":"__export__.account_account_332_13560718",
"510019":"__export__.account_account_333_f12a83b3",
"510020":"__export__.account_account_334_57fd96b0",
"510030":"__export__.account_account_335_257be0b3",
"510040":"__export__.account_account_336_2634b702",
"510049":"__export__.account_account_337_d416c524",
"510050":"__export__.account_account_338_5af39509",
"530000":"__export__.account_account_339_239e0115",
"531000":"__export__.account_account_340_362303e1",
"532000":"__export__.account_account_341_a169bf96",
"540000":"l10n_be.1_a540",
"550000":"__export__.account_account_186_0ef776c0",
"550100":"__export__.account_account_192_9b35c395",
"550110":"__export__.account_account_342_42afcabf",
"550200":"__export__.account_account_190_2bf70914",
"550201":"__export__.account_account_196_12a94c18",
"550202":"__export__.account_account_343_425cf1ba",
"550300":"__export__.account_account_201_7401c271",
"550400":"__export__.account_account_344_5cbbd0a6",
"550500":"__export__.account_account_200_83786cba",
"559000":"__export__.account_account_345_69e32afc",
"560000":"__export__.account_account_194_6718906c",
"570000":"__export__.account_account_188_9d2bf1d3",
"570002":"__export__.account_account_197_62db35e6",
"571000":"__export__.account_account_346_b32343ad",
"572000":"__export__.account_account_347_d9ac6264",
"573000":"__export__.account_account_348_e6c9c67c",
"580000":"l10n_be.1_l10nbe_chart_template_liquidity_transfer",
"600000":"l10n_be.1_a600",
"601000":"l10n_be.1_a601",
"601020":"__export__.account_account_349_e29e4be1",
"601100":"__export__.account_account_350_75ff52c8",
"602000":"l10n_be.1_a602",
"603000":"l10n_be.1_a603",
"603010":"__export__.account_account_351_a07e5b29",
"604000":"l10n_be.1_a604",
"608000":"__export__.account_account_352_fd8ecee5",
"609400":"__export__.account_account_353_9a9b6596",
"610000":"l10n_be.1_a6100",
"610100":"l10n_be.1_a6101",
"611000":"l10n_be.1_a611",
"611010":"__export__.account_account_354_818ee1c9",
"612000":"l10n_be.1_a612",
"612001":"__export__.account_account_355_66e3a30c",
"612002":"__export__.account_account_356_6dc8524e",
"612010":"__export__.account_account_357_e1f7abc0",
"612020":"__export__.account_account_358_991f406c",
"612100":"__export__.account_account_361_83f3e9c6",
"612400":"__export__.account_account_362_12752a29",
"612700":"__export__.account_account_363_35273b8b",
"612900":"__export__.account_account_364_ff468961",
"613000":"l10n_be.1_a613",
"613010":"__export__.account_account_365_e636ebc5",
"613011":"__export__.account_account_366_449622ee",
"613020":"__export__.account_account_367_cb037da0",
"613030":"__export__.account_account_368_6fb39429",
"613040":"__export__.account_account_369_ed53cdde",
"613050":"__export__.account_account_370_4b20e3fa",
"613090":"__export__.account_account_371_206f9e8a",
"613091":"__export__.account_account_372_3f2267e6",
"613200":"__export__.account_account_373_914836ca",
"613300":"__export__.account_account_374_0af3e105",
"613350":"__export__.account_account_375_d3f8cd6a",
"613400":"__export__.account_account_376_5b64c1eb",
"614000":"l10n_be.1_a614",
"614001":"__export__.account_account_377_b4c2ddab",
"615000":"__export__.account_account_378_e678c0cb",
"615001":"__export__.account_account_379_3aa9936d",
"615100":"__export__.account_account_380_5b55c58b",
"616000":"__export__.account_account_381_4ad76ca6",
"616100":"__export__.account_account_382_774dd3a4",
"616110":"__export__.account_account_383_2ed038a2",
"616200":"__export__.account_account_384_32ca9cee",
"617000":"__export__.account_account_385_e866eb7a",
"617100":"__export__.account_account_386_e495bf5e",
"620000":"l10n_be.1_a6200",
"620001":"__export__.account_account_387_bf94c258",
"620002":"__export__.account_account_388_86801a65",
"620003":"__export__.account_account_389_0a56c706",
"620010":"__export__.account_account_390_e5d97146",
"620120":"__export__.account_account_391_7c31f9d0",
"620140":"__export__.account_account_394_5467da60",
"620143":"__export__.account_account_392_d166d109",
"620144":"__export__.account_account_395_1ff65c38",
"620211":"__export__.account_account_396_c90ecaf2",
"620212":"__export__.account_account_397_ee6b29db",
"620213":"__export__.account_account_398_5fb02134",
"620300":"l10n_be.1_a6203",
"620500":"l10n_be.1_a6204",
"621000":"l10n_be.1_a621",
"621110":"__export__.account_account_399_73e227aa",
"623100":"__export__.account_account_401_147930c0",
"623210":"__export__.account_account_402_9e47aa84",
"623220":"__export__.account_account_403_eee6353c",
"623900":"__export__.account_account_404_b71693b2",
"624000":"__export__.account_account_405_1e7b583a",
"624100":"__export__.account_account_406_69e21e3c",
"626000":"__export__.account_account_407_8b0a68e3",
"629100":"__export__.account_account_408_e8e06d81",
"629400":"__export__.account_account_409_edeeee40",
"630200":"l10n_be.1_a6302",
"630201":"__export__.account_account_410_553dc8db",
"630900":"__export__.account_account_411_d8372095",
"634000":"__export__.account_account_412_2a7ceba6",
"634100":"__export__.account_account_413_449f069e",
"637000":"__export__.account_account_414_49708339",
"637100":"__export__.account_account_415_14c7e178",
"640120":"l10n_be.1_a64012",
"640300":"__export__.account_account_416_369d8744",
"640500":"__export__.account_account_417_8452e3c1",
"640600":"__export__.account_account_418_213bf017",
"640700":"__export__.account_account_419_851fbf55",
"642000":"__export__.account_account_420_83ed50f1",
"650000":"__export__.account_account_421_51b35966",
"650001":"__export__.account_account_422_56b4108b",
"650010":"__export__.account_account_423_f5f4cc79",
"650020":"__export__.account_account_424_b05eaa2c",
"650201":"__export__.account_account_425_a3801d3f",
"650202":"__export__.account_account_426_03d3099a",
"650203":"__export__.account_account_427_587179c8",
"650204":"__export__.account_account_428_a2640372",
"650205":"__export__.account_account_429_5dd5d1a7",
"650206":"__export__.account_account_430_e188f837",
"650207":"__export__.account_account_431_27953a5f",
"650208":"__export__.account_account_432_0019682e",
"650210":"__export__.account_account_433_07ecb9a1",
"650211":"__export__.account_account_434_d840a5e2",
"650221":"__export__.account_account_435_a66036f8",
"650300":"__export__.account_account_436_138a8000",
"650700":"__export__.account_account_437_3a0a62ab",
"650950":"__export__.account_account_438_9159d2b7",
"650951":"__export__.account_account_439_5d9dc11d",
"651000":"__export__.account_account_440_70f3612a",
"651100":"__export__.account_account_441_9553aac1",
"652000":"__export__.account_account_442_211672b3",
"653000":"l10n_be.1_a653",
"654000":"l10n_be.1_a654",
"655000":"__export__.account_account_443_ddd42f32",
"657000":"l10n_be.1_a656",
"658000":"__export__.account_account_444_84dc9331",
"659000":"__export__.account_account_445_703b279e",
"660000":"l10n_be.1_a6600",
"660200":"__export__.account_account_446_d21c1fc0",
"663100":"__export__.account_account_447_97ab5e50",
"664100":"__export__.account_account_448_19b54df6",
"664110":"__export__.account_account_449_7a97c8a7",
"664200":"__export__.account_account_450_2471ece8",
"664201":"__export__.account_account_451_0228e5b3",
"665000":"__export__.account_account_452_eeb60675",
"666000":"__export__.account_account_453_c927484c",
"669000":"__export__.account_account_454_4b22eef4",
"670000":"l10n_be.1_a6700",
"670600":"__export__.account_account_455_1e3bf44c",
"671000":"__export__.account_account_456_30f3c57a",
"690000":"l10n_be.1_a690",
"691000":"__export__.account_account_457_96032424",
"692100":"__export__.account_account_458_62204c2b",
"693000":"l10n_be.1_a693",
"696000":"__export__.account_account_459_9235abbb",
"700200":"l10n_be.1_a7002",
"701000":"l10n_be.1_a7010",
"702000":"l10n_be.1_a7000",
"703000":"__export__.account_account_460_1fc78e50",
"704000":"__export__.account_account_461_4f36d019",
#"705000":"__export__.account_account_492_16cbd24a",
"705000":"__export__.account_account_460_1fc78e50",
"706000":"l10n_be.1_a706",
"707000":"__export__.account_account_462_c2f25e98",
"707500":"__export__.account_account_463_47563d71",
"708000":"__export__.account_account_464_ff2ab3e7",
"709000":"__export__.account_account_465_783b1c48",
"709001":"__export__.account_account_466_c73bdce6",
"709994":"l10n_be.1_a7052",
"709995":"l10n_be.1_a7051",
"709996":"l10n_be.1_a7050",
"709997":"l10n_be.1_a7012",
"709998":"l10n_be.1_a7011",
"709999":"l10n_be.1_a7001",
"740000":"l10n_be.1_a740",
"740001":"__export__.account_account_467_14e202fa",
"740400":"__export__.account_account_468_dc222c9b",
"740410":"__export__.account_account_469_a8b3b036",
"740428":"__export__.account_account_470_610a4cd4",
"740430":"__export__.account_account_471_ca439f1e",
"740500":"__export__.account_account_472_08230b7a",
"740600":"__export__.account_account_473_8f1b12fa",
"740700":"__export__.account_account_474_4f6589d6",
"740810":"__export__.account_account_475_c23bf8b3",
"740900":"__export__.account_account_476_b2c4bb79",
"743000":"__export__.account_account_477_e03c3f63",
"743050":"__export__.account_account_478_117845b5",
"743100":"__export__.account_account_479_9d79d29c",
"743200":"__export__.account_account_480_4d4d98fd",
"743300":"__export__.account_account_481_5b6416a4",
"743400":"__export__.account_account_482_1229aa0c",
"743600":"__export__.account_account_483_dae6acb8",
"748000":"__export__.account_account_484_dd2c932b",
"749000":"__export__.account_account_485_2c85d517",
"750000":"l10n_be.1_a7500",
"751000":"l10n_be.1_a751",
"751100":"__export__.account_account_486_9ed81cca",
"753000":"__export__.account_account_487_e5a46371",
"754000":"l10n_be.1_a754",
"755000":"l10n_be.1_a755",
"757000":"l10n_be.1_a757",
"760000":"l10n_be.1_a7600",
"763000":"__export__.account_account_488_a3b01f7e",
"765000":"__export__.account_account_489_1c9b9169",
"765110":"__export__.account_account_490_feaa2478",
"771000":"l10n_be.1_a7710",
"771100":"l10n_be.1_a7711",
"780000":"l10n_be.1_a780",
"789000":"l10n_be.1_a789",
"790000":"l10n_be.1_a790",
"791000":"l10n_be.1_a791",
"792000":"__export__.account_account_491_1a6ead6f",
"793000":"l10n_be.1_a793",
"999999":"__export__.account_account_184_0a75ea2c",
}

dUsersLogin2ID = {
'admin':'__export__.res_users_10_f0a05d23',
'cabay':'__export__.res_users_12_a474257b',
'lecron':'__export__.res_users_27_d8fa6ad5',
'chabottaux':'__export__.res_users_30_01a4c4fc',
'mausen':'__export__.res_users_21_43522545',
'naa':'__export__.res_users_20_e9413956',
'kuetgens':'__export__.res_users_18_846a0adb',
'leonard':'__export__.res_users_7_011f371d',
'rh':'__export__.res_users_14_5c5a9cd2',
'lejeune':'__export__.res_users_25_0f68e110',
'debuisson':'__export__.res_users_23_f4deba1d',
'hurdebise':'__export__.res_users_17_7d04e3f6',
'betsch':'__export__.res_users_19_ed201e6d',
'scius':'__export__.res_users_8_113832db',
'vandieren':'__export__.res_users_31_f1617102',
'renson':'__export__.res_users_9_21d34e26',
'trusgnach':'__export__.res_users_28_b4d6fdc5',
'vandermeer':'__export__.res_users_6_6f4594db',
'renaville':'__export__.res_users_29_4e53bbce',
'nys':'__export__.res_users_13_0862774c',
'henkinet':'__export__.res_users_22_c32c43c0',
'hohlstamm':'__export__.res_users_11_e3acfa8e',
'perron':'__export__.res_users_16_42d9a736',
'schloesser':'__export__.res_users_26_be166d4f',
'bebronne':'__export__.res_users_15_d0878c28',
}

dVATCode2NewID = {
'INV50':'__export__.account_tax_136_dc9b3759',
'NSS 21':'l10n_be.1_attn_VAT-OUT-21-L',
'NSS 12':'l10n_be.1_attn_VAT-OUT-12-L',
'NSS 6':'l10n_be.1_attn_VAT-OUT-06-L',
'NSS 0':'l10n_be.1_attn_VAT-OUT-00-L',
'ISEXP 0':'l10n_be.1_attn_VAT-OUT-00-EU-L',
'NSGSD 21':'l10n_be.1_attn_VAT-IN-V82-21-G',
'NSGSD 12':'l10n_be.1_attn_VAT-IN-V82-12-G',
'NSGSD 6':'l10n_be.1_attn_VAT-IN-V82-06-G',
'NSGSD 0':'l10n_be.1_attn_VAT-IN-V82-00-G',
'INVEST21':'l10n_be.1_attn_VAT-IN-V83-21',
'A-NAT-CO 21':'l10n_be.1_attn_VAT-IN-V81-21-CC',
'V50':'l10n_be.1_attn_VAT-IN-V82-CAR-EXC',
'ESSDD 21':'l10n_be.1_attn_VAT-IN-V81-21-EU',
'ISSDD 21':'l10n_be.1_attn_VAT-IN-V81-21-ROW-CC'}

def get_user_id_from_login(login):
    if dUsersLogin2ID.has_key(login):
        result = dUsersLogin2ID[login]
    else:
        result = ''
    return result
    
def get_full_name_dotation(name):
    if name in [u'Achats',u'Frais Généraux',u'Personnel',u'Financier & Exceptionnel']:
        result = u'[Dépenses] [%s]' % name
    else:
        result = u'[%s]' % name
    return result
    
def get_vatID_from_code(VATCode):
    result = ''
    if VATCode in dVATCode2NewID.keys():
        result = dVATCode2NewID[VATCode]
    else:
        print('CODE TVA inconnu : #'+VATCode+'#')
    return result
    
def get_product_cat(categ_id):
    # -1 = key pour la categ générale 'ALL'
    # -2 = key pour la categ générale 'Ventes'
    # 2 correspond à notre catégorie 'Events'
    if categ_id == -1:
        categ_key = 'product.product_category_all'
    elif categ_id == -2:
        categ_key = 'product.product_category_1'
    elif categ_id == 2:
        categ_key = 'event_sale.product_category_events'
    else:
        categ_key = 'cci_product_category_'+str(categ_id)
    return categ_key
    
def get_account_id_from_code(code):
    if code in dAccountCode2NewID.keys():
        return dAccountCode2NewID[code]
    else:
        print('Account '+code+' unknown')
        return ''

def list_of_ids(ids,prefix):
    if ids:
        list_of_xmlid = []
        for pointer_id in ids:
            list_of_xmlid.append(prefix+str(pointer_id.id))
        list_of_ids = ','.join(list_of_xmlid)
    else:
        list_of_ids = ''
    return list_of_ids
def save_in_demo_xml(file_name,records_list):
    hfOut = open(file_name,'w')
    hfOut.write('<odoo>\n')
    for record in records_list:
        if record['demo_model_name'] and record['demo_id']:
            hfOut.write('\t<record model="%s" id="%s">\n' % (record['demo_model_name'],record['demo_id']))
            for (key,value) in record.items():
                if key not in ['demo_model_name','demo_id']:
                    hfOut.write('\t\t<field name="%s">%s</field>\n' % (key,value))
            hfOut.write('\t<record>\n')
    hfOut.write('</odoo>\n')
    return True
def clean_string(string_to_clean):
    return string_to_clean.strip().replace('\n','')
def clean_website(string_to_clean):
    if string_to_clean:
        result = clean_string(string_to_clean)
        if result and not (result[0:7] == 'http://' or result[0:8] == 'https://'):
            result = 'http://'+result
    else:
        result = ''
    return result
def get_partner_name(partner_name,address_name):
    if address_name:
        if address_name.strip()[0:2] == '- ':
            result = partner_name.strip() + ' ' + address_name.strip()
        else:
            result = address_name.strip()
    else:
        result = partner_name.strip()
    return result
def get_phone_country_prefix(cr,uid):
    result = []
    obj_country = pooler.get_pool(cr.dbname).get('cci.country')
    country_ids = obj_country.search(cr,uid,[('phoneprefix','!=',False),('phoneprefix','!=',0)])
    if country_ids:
        countries = obj_country.read(cr,uid,country_ids,['phoneprefix'])
        result = [str(x['phoneprefix']) for x in countries]
    return result

def get_phone(string,PHONE_COUNTRY_PREFIX):
    def only_digits(string):
        cleaned = ''
        for carac in string:
            if carac in '0123456789':
                cleaned += carac
        return cleaned
    result = ''
    string = only_digits(string)
    if len(string) > 0:
        if len(string) == 9:
            if string[0:2] in ['02','03','04','09']:
                result = string[0:2] + "/" + string[2:5] + "." + string[5:7] + "." + string[7:]
            else:
                result = string[0:3] + "/" + string[3:5] + "." + string[5:7] + "." + string[7:]
        elif len(string) == 10:
            result = string[0:4] + "/" + string[4:6] + "." + string[6:8] + "." + string[8:]
        else:
            # international number
            if string[0:2] == '00':
                # search after a country with this prefix
                prefix = string[2:4]
                if prefix not in PHONE_COUNTRY_PREFIX:
                    prefix = string[2:5]
                    if prefix not in PHONE_COUNTRY_PREFIX:
                        prefix = string[2:6]
                        if prefix not in PHONE_COUNTRY_PREFIX:
                            prefix = ''
                if prefix:
                    result = '+' + string[2:2+len(prefix)] + ' ' + string[2+len(prefix):4+len(prefix)]
                    rest = string[4+len(prefix):]
                    while len(rest) > 3:
                        result += '.' + rest[0:2]
                        rest = rest[2:]
                    result += '.' + rest
                else:
                    result = 'International:'+string
    return result
def get_activsectors(partner,address,dCategID2SectCode,dCodeSect2ID):
    result = []
    forcedAddress = False
    if address and (address.sector1 or address.sector2 or address.sector3):
        forcedAddress = True
        if address.sector1:
            result.append(dCodeSect2ID[address.sector1.code.strip()])
        if address.sector2:
            result.append(dCodeSect2ID[address.sector2.code.strip()])
        if address.sector3:
            result.append(dCodeSect2ID[address.sector3.code.strip()])
    else:
        for category in partner.category_id:
            if category.id in dCategID2SectCode.keys():
                result.append(dCodeSect2ID[dCategID2SectCode[category.id]])
    return (forcedAddress,result)
def unaccent(string_to_unaccent):
    return ''.join(c for c in unicodedata.normalize('NFD', string_to_unaccent) if unicodedata.category(c) != 'Mn')
def valid_lang(code):
    if code:
        result = code
        if result not in ['fr_FR','en_US','nl_NL']:
            result = 'fr_FR' ## TO DO maybe accept nl_NL and de_DE
    else:
        result = 'fr_FR'
    return result
def conv_faillite_type(fail_type):
    result = fail_type.strip().replace(' - ','_')
    result = result.replace('-','_').replace('\'','_').replace(' ','_')
    result = unaccent(result).lower()
    result = result.replace('_r_solution','_resolution').replace('__','_')
    result = result.replace(u'_ministere_public',u'_ministère_public')
    result = result.replace('association_de_fait','')
    return result
def account_journal_key_from_code(journal_code):
    if journal_code in DAJNL.keys():
        key = DAJNL[journal_code]
    else:
        key = ''
    return key
def get_country_key(code,table='cci.country'): # table can be also 'res.country'
    if not code:
        result = ''
    else:
        if code in ['CS','CT','EA','NT','PZ','XO','XX','IC','AN']:
            result = 'cci_country_'+code.lower()
        else:
            result = 'base.'+code.lower()
        if result == 'base.mb':
            result = 'base.im'
        elif result == 'base.zr':
            result = 'base.cg'
        if result == 'base.gb':
            result = 'base.uk'
    return result
def search_zip_id(cr,uid,zip_city):
    result = ''
    zip_code = ''
    isolated_city = ''
    if zip_city:
        pos = zip_city.strip().find(' ')
        if pos:
            zip_code = zip_city[0:pos].strip()
            city_name = zip_city[pos+1:].strip()
            zip_ids = pooler.get_pool(cr.dbname).get('res.partner.zip').search(cr,uid,[('name','=',zip_code),('city','=',city_name)])
            if zip_ids and len(zip_ids) <= 3:
                result = 'res_partner_zip_'+str(zip_ids[0])
                zip_full = pooler.get_pool(cr.dbname).get('res.partner.zip').read(cr,uid,zip_ids[0],['name','city'])
                zip_code = zip_full['name'] or ''
                isolated_city = zip_full['city'] or ''
            else:
                zip_ids = pooler.get_pool(cr.dbname).get('res.partner.zip').search(cr,uid,[('name','=',zip_code),('city','ilike',city_name)])
                if zip_ids and len(zip_ids) <= 3:
                    result = 'res_partner_zip_'+str(zip_ids[0])
                    zip_full = pooler.get_pool(cr.dbname).get('res.partner.zip').read(cr,uid,zip_ids[0],['name','city'])
                    zip_code = zip_full['name'] or ''
                    isolated_city = zip_full['city'] or ''
                else:
                    zip_ids = pooler.get_pool(cr.dbname).get('res.partner.zip').search(cr,uid,[('name','=',zip_code),('old_city','=',city_name)])
                    if zip_ids and len(zip_ids) <= 3:
                        result = 'res_partner_zip_'+str(zip_ids[0])
                        zip_full = pooler.get_pool(cr.dbname).get('res.partner.zip').read(cr,uid,zip_ids[0],['name','city'])
                        zip_code = zip_full['name'] or ''
                        isolated_city = zip_full['city'] or ''
                    else:
                        zip_ids = pooler.get_pool(cr.dbname).get('res.partner.zip').search(cr,uid,[('name','=',zip_code),('other_names','ilike',city_name)])
                        if zip_ids and len(zip_ids) <= 3:
                            result = 'res_partner_zip_'+str(zip_ids[0])
                            zip_full = pooler.get_pool(cr.dbname).get('res.partner.zip').read(cr,uid,zip_ids[0],['name','city'])
                            zip_code = zip_full['name'] or ''
                            isolated_city = zip_full['city'] or ''
    return (result,zip_code,isolated_city)
def get_membership_product_id_from_year(year):
    product_external_ID = ''
    if year == '2008':
        product_external_ID = '__export__.product_product_18_ce4f466f'
    elif year == '2009':
        product_external_ID = '__export__.product_product_17_62e36e5a'
    elif year == '2010':
        product_external_ID = '__export__.product_product_16_56223569'
    elif year == '2011':
        product_external_ID = '__export__.product_product_15_04bc8ac1'
    elif year == '2012':
        product_external_ID = '__export__.product_product_14_f389b7a9'
    elif year == '2013':
        product_external_ID = '__export__.product_product_13_2fae7601'
    elif year == '2014':
        product_external_ID = '__export__.product_product_12_c9a56753'
    elif year == '2015':
        product_external_ID = '__export__.product_product_11_ebe573f2'
    elif year == '2016':
        product_external_ID = '__export__.product_product_10_ac76e78a'
    elif year == '2017':
        product_external_ID = '__export__.product_product_9_d541c77a'
    elif year == '2018':
        product_external_ID = '__export__.product_product_8_ed3d9a8f'
    elif year == '2019':
        product_external_ID = '__export__.product_product_3_8f8838c8'
    elif year == '2020':
        product_external_ID = '__export__.product_product_4_5e0323ef'
    return product_external_ID
def extract_contacts(partner,address,new_sequence,dAddressesID2NewPartnerKey,csvFile,dContactID2JobsID,partnerNewKeys,dCodePosition2ID,PHONE_COUNTRY_PREFIX,dKeptCategs):
    for job in address.job_ids:
        if job.active and job.contact_id and job.contact_id.active:
            record = []
            record.append('res_partner_job_'+str(job.id))
            partnerNewKeys.append('res_partner_job_'+str(job.id))
            record.append(dAddressesID2NewPartnerKey[address.id])
            record.append(False)
            record.append('person')
            record.append('contact')
            # contact name
            record.append(clean_string(job.contact_id.name+' '+(job.contact_id.first_name or '')).encode('utf-8'))
            record.append('')
            record.append('')
            record.append('')
            record.append(True)
            record.append(0)
            if job.contact_id.gender == "man":
                record.append('male')
            elif job.contact_id.gender == "women":
                record.append('female')
            else:
                record.append('unspecified')
            new_sequence += 1
            record.append(new_sequence)
            # postal_code
            record.append('')
            record.append('')
            record.append('')
            record.append('') # country_id
            record.append(False)
            record.append(False)
            record.append(get_phone(job.phone or '',PHONE_COUNTRY_PREFIX).encode('utf-8'))
            record.append(get_phone(job.fax or '',PHONE_COUNTRY_PREFIX).encode('utf-8'))
            record.append(clean_string(job.email or job.contact_id.email or '').encode('utf-8'))
            record.append(clean_website(job.contact_id.website).encode('utf-8'))
            record.append('')
            # is_commissionner
            record.append(False)
            record.append(False)
            # membership
            record.append('')
            record.append('0.0')
            record.append(False)
            record.append(False)
            record.append(False)
            record.append('')
            record.append(False)
            record.append(False)
            record.append('') ## secteurs d'activités
            function_ids = []
            if job.function_code_label:
                for funccode in job.function_code_label.strip().replace(' ',''):
                    if funccode in dCodePosition2ID.keys():
                        function_ids.append(dCodePosition2ID[funccode])
            record.append(','.join(function_ids)) ## code fonctions
            record.append(clean_string(job.function_label or '').encode('utf-8'))
            contact_id = job.contact_id.id
            if dContactID2JobsID.has_key(contact_id):
                list_of_job_ids = dContactID2JobsID[contact_id]
            else:
                list_of_job_ids = []
            list_of_job_ids.append('res_partner_job_'+str(job.id))
            dContactID2JobsID[contact_id] = list_of_job_ids
            record.append((job.contact_id.title or '').encode('utf-8'))
            record.append(job.active and job.contact_id.active)
            record.append('no-message')
            record.append('')
            if job.contact_id and job.contact_id.lang_id:
                record.append(valid_lang(job.contact_id.lang_id.code))
            else:
                record.append('fr_FR')
            record.append('')
            record.append('')
            csvFile.writerow(record)
            # rechercher de answers converties en categorie sur res_partner
            journaliste = False
            if job.answers_ids:
                for answer in job.answers_ids:
                    if answer.id in [112,113]:
                        journaliste = True
            if not journaliste and job.contact_id.answers_ids:
                for answer in job.contact_id.answers_ids:
                    if answer.id in [112,113]:
                        journaliste = True
            if journaliste:
                data_categ = dKeptCategs[-3]
                if data_categ['partner_ids']:
                    data_categ['partner_ids'] += (',res_partner_job_'+str(job.id))
                else:
                    data_categ['partner_ids'] = 'res_partner_job_'+str(job.id)
                dKeptCategs[-3] = data_categ
            # convertion des codes fonctions qui n'en sont pas
            if job.function_code_label and ('!' in job.function_code_label):
                data_categ = dKeptCategs[-4]
                if data_categ['partner_ids']:
                    data_categ['partner_ids'] += (',res_partner_job_'+str(job.id))
                else:
                    data_categ['partner_ids'] = 'res_partner_job_'+str(job.id)
                dKeptCategs[-4] = data_categ
            if job.function_code_label and ('@' in job.function_code_label):
                data_categ = dKeptCategs[-5]
                if data_categ['partner_ids']:
                    data_categ['partner_ids'] += (',res_partner_job_'+str(job.id))
                else:
                    data_categ['partner_ids'] = 'res_partner_job_'+str(job.id)
                dKeptCategs[-5] = data_categ
            if job.function_code_label and ('*' in job.function_code_label):
                data_categ = dKeptCategs[-6]
                if data_categ['partner_ids']:
                    data_categ['partner_ids'] += (',res_partner_job_'+str(job.id))
                else:
                    data_categ['partner_ids'] = 'res_partner_job_'+str(job.id)
                dKeptCategs[-6] = data_categ
            if job.function_code_label and ('>' in job.function_code_label):
                data_categ = dKeptCategs[-7]
                if data_categ['partner_ids']:
                    data_categ['partner_ids'] += (',res_partner_job_'+str(job.id))
                else:
                    data_categ['partner_ids'] = 'res_partner_job_'+str(job.id)
                dKeptCategs[-7] = data_categ
    return True
class wizard_extract_odoo12(wizard.interface):
    def _extract(self, cr, uid, data, context):
        PHONE_COUNTRY_PREFIX = get_phone_country_prefix(cr,uid)
        TEST_DATA = data['form']['test']
        #
        unactive_used_partner_ids = []
        unactive_used_address_ids = []
        unactive_used_job_ids = []
        unactive_used_contact_ids = []
        unactive_used_trustee_ids = []
        unactive_used_commissioner_ids = []
        PARTNER_USED_QUESTION_IDS = []
        ADDRESS_USED_QUESTION_IDS = []
        JOB_USED_QUESTION_IDS = []
        CONTACT_USED_QUESTION_IDS = [16,41,120,108]
        #
        stoday = datetime.date.today().strftime('%Y-%m-%d')
        #

        ## analytic accounts
        hfAADGroups = open('0_oe5_account_analytic_group_data.csv','w')
        csvAADGroups = csv.writer(hfAADGroups,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvAADGroups.writerow(['id','name','description'])
        hfAARGroups = open('0_oe5_account_analytic_group_rel.csv','w')
        csvAARGroups = csv.writer(hfAARGroups,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvAARGroups.writerow(['id','parent_id/id'])
        
        group_lines = []
        group_lines.append(['aaa_header_0',u'Ancienne structure analytique'.encode('utf-8'),'',''])
        hfAAAccounts = open('0_oe5_account_analytic_account.csv','w')
        csvAAAccounts = csv.writer(hfAAAccounts,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvAAAccounts.writerow(['id','active','name','code','group_id/id'])
        aaccount_ids = pooler.get_pool(cr.dbname).get('account.analytic.account').search(cr,uid,['|',('active','=',True),('active','=',False)])
        aaccounts = pooler.get_pool(cr.dbname).get('account.analytic.account').browse(cr,uid,aaccount_ids)
        # determine accounts with childs even inactives
        parent_ids = []
        for aaccount in aaccounts:
            if aaccount.parent_id and aaccount.parent_id.id not in parent_ids:
                parent_ids.append(aaccount.parent_id.id)
        deleted_subventions_aaccount_ids = []
        for aaccount in aaccounts:
            if aaccount.id in parent_ids:
                # has child => is a group
                record = []
                record.append('aaa_header_'+str(aaccount.id))
                record.append((aaccount.name or '').encode('utf-8'))
                record.append((aaccount.description or '').encode('utf-8'))
                if aaccount.parent_id:
                    record.append('aaa_header_'+str(aaccount.parent_id.id))
                else:
                    record.append('aaa_header_0')
                group_lines.append(record)
                #csvAAGroups.writerow(record)
            if aaccount.line_ids or (aaccount.id not in parent_ids):
                # has lines or no child => is an account
                record = []
                record.append('aaccount_'+str(aaccount.id))
                record.append(aaccount.active)
                record.append(aaccount.name.encode('utf-8'))
                record.append(aaccount.code.encode('utf-8'))
                if aaccount.parent_id:
                    record.append('aaa_header_'+str(aaccount.parent_id.id))
                else:
                    record.append('')
                csvAAAccounts.writerow(record)
            # check if it is an account linked to 'Subventions' or 'Provinces' not more used in 2019
            if (aaccount.id == 2) or (aaccount.parent_id and (aaccount.parent_id.id == 2)) or (aaccount.id == 3) or (aaccount.parent_id and (aaccount.parent_id.id == 3)):
                deleted_subventions_aaccount_ids.append(aaccount.id)
        # sort analytic groups by parent_id
        order_is_good = False
        tries = 0
        while not order_is_good:
            tries += 1
            already_parents = []
            new_group_lines = []
            left_lines = []
            found_unknown_parent = False
            for line in group_lines:
                if (not line[3]) or (line[3] in already_parents):
                    already_parents.append(line[0])
                    new_group_lines.append(line)
                else:
                    found_unknown_parent = True
                    left_lines.append(line)
            if found_unknown_parent:
                for line in left_lines:
                    new_group_lines.append(line)
            else:
                order_is_good = True
            group_lines = []
            for line in new_group_lines:
                group_lines.append(line)
        for line in group_lines:
            record_data = [line[0],line[1],line[2]]
            csvAADGroups.writerow(record_data)
            if line[3]:
               record_rel = [line[0],line[3]]
               csvAARGroups.writerow(record_rel)
        hfAADGroups.close()
        hfAARGroups.close()
        #        
        hfADist = open('0_oe5_account_analytic_tag.csv','w')
        csvADist = csv.writer(hfADist,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvADist.writerow(['id','name','active','active_analytic_distribution'])
        hfADistInactive = open('0_oe5_account_analytic_tag_inactive.csv','w')
        csvADistInactive = csv.writer(hfADistInactive,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvADistInactive.writerow(['id','active'])
        hfADistAAccount = open('0_oe5_account_analytic_distribution.csv','w')
        csvADistAAccount = csv.writer(hfADistAAccount,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvADistAAccount.writerow(['id','percentage','account_id/id','tag_id/id'])
        aapinstance_ids = pooler.get_pool(cr.dbname).get('account.analytic.plan.instance').search(cr,uid,['|',('active','=',True),('active','=',False)])
        aapinstances = pooler.get_pool(cr.dbname).get('account.analytic.plan.instance').browse(cr,uid,aapinstance_ids)
        for instance in aapinstances:
            record = []
            record.append('aapinstance_'+str(instance.id))
            record.append(instance.name.encode('utf-8'))
            record.append(True)
            record.append(True)
            csvADist.writerow(record)
            if not instance.active:
                record = []
                record.append('aapinstance_'+str(instance.id))
                record.append(instance.active)
                csvADistInactive.writerow(record)
            sublines_count = 1
            for account_id in instance.account_ids:
                if account_id.analytic_account_id:
                    record_sub = False
                    if instance.active and (account_id.analytic_account_id.id not in deleted_subventions_aaccount_ids):
                        record_sub = True
                    elif not instance.active:
                        record_sub = True
                    if record_sub:
                        record = []
                        record.append('aapinstance_'+str(instance.id)+'_'+str(sublines_count))
                        record.append(account_id.rate or 0.0)
                        record.append('aaccount_'+str(account_id.analytic_account_id.id))
                        record.append('aapinstance_'+str(instance.id))
                        csvADistAAccount.writerow(record)
                        sublines_count += 1

        ### PRODUCT CATEGORIES
        hfPCateg = open('0_oe5_product_category.csv','w')
        csvPCateg = csv.writer(hfPCateg,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvPCateg.writerow(['id','name','property_account_expense_categ_id/id','property_account_income_categ_id/id'])
        #
        hfPCategRel = open('0_oe5_product_category_rel.csv','w')
        csvPCategRel = csv.writer(hfPCategRel,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvPCategRel.writerow(['id','parent_id/id'])
        #
        pcateg_ids = pooler.get_pool(cr.dbname).get('product.category').search(cr,uid,[])
        pcategs = pooler.get_pool(cr.dbname).get('product.category').browse(cr,uid,pcateg_ids)
        for pcateg in pcategs:
            if pcateg.id != 2:
                record = []
                record.append(get_product_cat(pcateg.id))
                record.append(pcateg.name.encode('utf-8'))
                record.append(get_account_id_from_code(pcateg.property_account_expense_categ and pcateg.property_account_expense_categ.code or ''))
                record.append(get_account_id_from_code(pcateg.property_account_income_categ and pcateg.property_account_income_categ.code or ''))
                csvPCateg.writerow(record)
                record = []
                record.append(get_product_cat(pcateg.id))
                record.append(get_product_cat(pcateg.parent_id and pcateg.parent_id.id or -2))
                csvPCategRel.writerow(record)
            
        ### PRODUCTS
        sold_prod_on_dates_ids = []
        dated_soline_ids = pooler.get_pool(cr.dbname).get('sale.order.line').search(cr,uid,[('expected_invoice_date','>=','2018-01-01')])
        if dated_soline_ids:
            dated_solines = pooler.get_pool(cr.dbname).get('sale.order.line').read(cr,uid,dated_soline_ids,['product_id'])
            for soline in dated_solines:
                if soline['product_id'] and soline['product_id'][0] not in sold_prod_on_dates_ids:
                    sold_prod_on_dates_ids.append(soline['product_id'][0])
        print('solines')
        print(len(dated_soline_ids))
        print('prod_ids')
        print(len(sold_prod_on_dates_ids))
        hfProd = open('0_oe5_product_template.csv','w')
        csvProd = csv.writer(hfProd,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvProd.writerow(['id','name','list_price','default_code','type','categ_id/id','property_account_expense_id/id',
                           'property_account_income_id/id','membership_date_from','membership_date_to','description',
                           'description_purchase','description_sale','event_ok','active','company_id/id',
                           'taxes_id/id','supplier_taxes_id/id','invoice_policy'])
        hfAADef = open('0_oe5_account_analytic_default.csv','w')
        csvAADef = csv.writer(hfAADef,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvAADef.writerow(['id','sequence','product_id/id','analytic_tag_ids/id'])
        prod_ids = pooler.get_pool(cr.dbname).get('product.product').search(cr,uid,['|',('active','=',True),('active','=',False)])
        prods = pooler.get_pool(cr.dbname).get('product.product').browse(cr,uid,prod_ids,{'lang':'fr_FR'})
        for prod in prods:
            record = []
            record.append('product_product_'+str(prod.id))
            record.append(prod.name.encode('utf-8'))
            record.append(prod.list_price)
            record.append((prod.code or '').encode('utf-8'))
            record.append('Service')
            record.append(get_product_cat(prod.categ_id.id))
            record.append(prod.product_tmpl_id.property_account_expense and get_account_id_from_code(prod.product_tmpl_id.property_account_expense.code) or '')
            record.append(prod.product_tmpl_id.property_account_income and get_account_id_from_code(prod.product_tmpl_id.property_account_income.code) or '')
            record.append(prod.membership_date_from or '')
            record.append(prod.membership_date_to or '')
            record.append((prod.description or '').encode('utf-8'))
            record.append((prod.description_purchase or '').encode('utf-8'))
            record.append((prod.description_sale or '').encode('utf-8'))
            record.append(prod.categ_id.id == 2)
            record.append(prod.active)
            record.append('base.main_company')
            lTaxes_id = []
            for tax in prod.taxes_id:
                if tax.description:
                    taxID = get_vatID_from_code(tax.description)
                    if taxID:
                        lTaxes_id.append(taxID)
            record.append(','.join(lTaxes_id))
            lTaxes_id = []
            for tax in prod.supplier_taxes_id:
                if tax.description:
                    taxID = get_vatID_from_code(tax.description)
                    if taxID:
                        lTaxes_id.append(taxID)
            record.append(','.join(lTaxes_id))
            invoice_policy = 'order'
            if prod.product_tmpl_id.categ_id and prod.product_tmpl_id.categ_id.id in (5,7):
                if prod.id in sold_prod_on_dates_ids:
                    invoice_policy = 'based_on_date'
            record.append(invoice_policy)
            csvProd.writerow(record)
        aadefault_ids = pooler.get_pool(cr.dbname).get('account.analytic.default').search(cr,uid,[])
        aadefaults = pooler.get_pool(cr.dbname).get('account.analytic.default').browse(cr,uid,aadefault_ids)
        for aadef in aadefaults:
            if aadef.product_id and aadef.analytics_id:
                record = []
                record.append('account_analytic_default_'+str(aadef.id))
                record.append(aadef.sequence or 0)
                record.append('product_product_'+str(aadef.product_id.id))
                record.append('aapinstance_'+str(aadef.analytics_id.id))
                csvAADef.writerow(record)
                
        ### BANKS
        hfRBank = open('0_oe5_res_bank.csv','w')
        csvRBank = csv.writer(hfRBank,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRBank.writerow(['id','bic','name','street','street2','zip','city','country/id','email','phone','active'])
        bank_ids = pooler.get_pool(cr.dbname).get('res.bank').search(cr,uid,['|',('active','=',True),('active','=',False)])
        banks = pooler.get_pool(cr.dbname).get('res.bank').browse(cr,uid,bank_ids)
        for bank in banks:
            old_bic = bank.bic or bank.code or ''
            if not old_bic and bank.name and (len(bank.name.strip()) >= 8) and (len(bank.name.strip()) <= 12):
                old_bic = bank.name.strip()
            if old_bic:
                record = []
                record.append('res_bank_'+str(bank.id))
                record.append(old_bic.encode('utf-8'))
                record.append((bank.name or '').encode('utf-8'))
                record.append((bank.street or '').encode('utf-8'))
                record.append((bank.street2 or '').encode('utf-8'))
                record.append((bank.zip or '').encode('utf-8'))
                record.append((bank.city or '').encode('utf-8'))
                if bank.country:
                    record.append(get_country_key(bank.country.code,'res.country'))
                else:
                    record.append('')
                record.append((bank.email or '').encode('utf-8'))
                record.append((bank.phone or '').encode('utf-8'))
                record.append(bank.active and 'True' or 'False')
                csvRBank.writerow(record)
        hfRPBank = open('0_oe5_res_partner_bank.csv','w')
        csvRPBank = csv.writer(hfRPBank,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPBank.writerow(['id','acc_number','sanitized_acc_number','partner_id/id','bank_id/id','sequence','company_id/id'])
        abank_ids = pooler.get_pool(cr.dbname).get('res.partner.bank').search(cr,uid,[('state','=','iban')])
        abanks = pooler.get_pool(cr.dbname).get('res.partner.bank').browse(cr,uid,abank_ids)
        for abank in abanks:
            if abank.name and abank.partner_id and abank.bank:
                full_acc = abank.name.strip().upper()
                full_acc_number = full_acc[0:4]
                index = 4
                size = 4
                while full_acc[index:index+size]:
                    full_acc_number += (' ' + full_acc[index:index+size])
                    index += size
                record = []
                record.append('res_partner_bank_'+str(abank.id))
                record.append(full_acc_number.encode('utf-8'))
                record.append(full_acc.encode('utf-8'))
                record.append('res_partner_'+str(abank.partner_id.id))
                record.append(abank.bank and ('res_bank_'+str(abank.bank.id)) or '')
                record.append(abank.sequence or 0)
                record.append('base.main_company')
                csvRPBank.writerow(record)
                if abank.partner_id.id not in unactive_used_partner_ids:
                    unactive_used_partner_ids.append(abank.partner_id.id)

        hfSDDM = open('0_oe5_cci_sdd_mandate.csv','w')
        csvSDDM = csv.writer(hfSDDM,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvSDDM.writerow(['id','company_id/id','start_date','end_date','state','name','original_doc','original_doc_filename','partner_bank_id/id','payment_journal_id/id','partner_id/id'])
        journal_key = account_journal_key_from_code('ING')
        mandate_ids = pooler.get_pool(cr.dbname).get('cci.sdd.mandate').search(cr,uid,[])
        mandates = pooler.get_pool(cr.dbname).get('cci.sdd.mandate').browse(cr,uid,mandate_ids)
        for mandate in mandates:
            if mandate.partner_id:
                record = []
                record.append('cci_sdd_mandate_'+str(mandate.id))
                record.append('base.main_company')
                record.append(mandate.signature_date or '')
                if mandate.state == 'expired':
                    record.append(mandate.last_debit_date or mabdate.write_date or stoday)
                else:
                    record.append('')
                record.append('draft')  ### mandate.state == 'valid' and 'active' or 'closed') because no attached document until now
                record.append(mandate.unique_mandate_reference)
                record.append('') # mandate.scan creates errors TODO
                record.append(mandate.unique_mandate_reference+'.pdf')
                record.append('res_partner_bank_'+str(mandate.partner_bank_id.id))
                record.append(journal_key)
                record.append('res_partner_'+str(mandate.partner_id.id))
                csvSDDM.writerow(record)
                if mandate.partner_id.id not in unactive_used_partner_ids:
                    unactive_used_partner_ids.append(mandate.partner_id.id)

        hfRCt = open('0_oe5_res_country.csv','w')
        csvRCt = csv.writer(hfRCt,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRCt.writerow(['id','name','code'])
        country_ids = pooler.get_pool(cr.dbname).get('cci.country').search(cr,uid,[('code','in',['CS','CT','EA','NT','PZ','XO','XX','IC','AN'])])
        if country_ids:
            countries = pooler.get_pool(cr.dbname).get('cci.country').browse(cr,uid,country_ids)
            for country in countries:
                record = []
                record.append('cci_country_'+country.code.strip().lower())
                record.append(country.name.strip().encode('utf-8'))
                record.append(country.code.strip().upper())
                csvRCt.writerow(record)
        dZoneCountries = {}
        country_ids = pooler.get_pool(cr.dbname).get('cci.country').search(cr,uid,[])
        if country_ids:
            countries = pooler.get_pool(cr.dbname).get('cci.country').browse(cr,uid,country_ids)
            for country in countries:
                if len(country.code.strip()) == 2:
                    for linked_country in country.cci_country_ids:
                        if len(linked_country.code.strip()) == 3 and linked_country.code.strip() in dZoneCountries.keys():
                            list_of_countries = dZoneCountries[linked_country.code.strip()]
                        else:
                            list_of_countries = []
                        list_of_countries.append(country.code.strip())
                        dZoneCountries[linked_country.code.strip()] = list_of_countries
        hfRCtG = open('0_oe5_res_country_group.csv','w')
        csvRCtG = csv.writer(hfRCtG,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRCtG.writerow(['id','name','country_ids/id'])
        country_ids = pooler.get_pool(cr.dbname).get('cci.country').search(cr,uid,[])
        if country_ids:
            countries = pooler.get_pool(cr.dbname).get('cci.country').browse(cr,uid,country_ids)
            for country in countries:
                if len(country.code.strip()) == 3:
                    record = []
                    record.append('cci_country_'+country.code.strip().lower())
                    record.append(country.name.strip().encode('utf-8'))
                    if country.code.strip() in dZoneCountries.keys():
                        list_of_countries = dZoneCountries[country.code.strip()]
                        list_of_country_keys = []
                        for linked_country_code in list_of_countries:
                            list_of_country_keys.append(get_country_key(linked_country_code))
                        record.append(','.join(list_of_country_keys))
                    else:
                        record.append('')
                    csvRCtG.writerow(record)
        hfRPZGT = open('0_oe5_cci_zip_type.csv','w')
        csvRPZGT = csv.writer(hfRPZGT,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPZGT.writerow(['id','name'])
        demo_data_zip_group_types = []
        hfRPZG = open('0_oe5_cci_zip_subtype.csv','w')
        csvRPZG = csv.writer(hfRPZG,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPZG.writerow(['id','name','zip_type_id/id'])
        demo_data_zip_groups = []
        hfRPZ = open('0_oe5_cci_zip.csv','w')
        csvRPZ = csv.writer(hfRPZ,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPZ.writerow(['id','postal_code','city','sales_representative_id/id','longitude','latitude','zip_subtype_ids/id','old_name','country_id/id'])
        demo_data_zips = []
        demo_type_ids = [1,7]
        demo_group_ids = []
        type_ids = pooler.get_pool(cr.dbname).get('res.partner.zip.group.type').search(cr,uid,[])
        if type_ids:
            types = pooler.get_pool(cr.dbname).get('res.partner.zip.group.type').browse(cr,uid,type_ids)
            for type_zip in types:
                record = []
                record.append('res_partner_zip_group_type_'+str(type_zip.id))
                record.append(type_zip.name.encode('utf-8'))
                csvRPZGT.writerow(record)
                if type_zip.id in demo_type_ids:
                    demo_data_zip_group_types.append({'demo_model_name':'cci.zip_type',
                                                      'demo_id':'demo_zgt_'+str(type_zip.id),
                                                      'name':clean_string(type_zip.name).encode('utf-8'),
                                                     })
            group_ids = pooler.get_pool(cr.dbname).get('res.partner.zip.group').search(cr,uid,[])
            if group_ids:
                groups = pooler.get_pool(cr.dbname).get('res.partner.zip.group').browse(cr,uid,group_ids)
                for group in groups:
                    if group.type_id:
                        record = []
                        record.append('res_partner_zip_group_'+str(group.id))
                        record.append(group.name.encode('utf-8'))
                        record.append('res_partner_zip_group_type_'+str(group.type_id.id))
                        csvRPZG.writerow(record)
                        if group.type_id.id in demo_type_ids:
                            demo_data_zip_groups.append({'demo_model_name':'cci.zip_subtype',
                                                         'demo_id':'demo_zg_'+str(group.id),
                                                         'name':clean_string(group.name).encode('utf-8'),
                                                         'type_id':'demo_zgt_'+str(group.type_id.id),
                                                        })
                            demo_group_ids.append(group.id)
        zip_ids = pooler.get_pool(cr.dbname).get('res.partner.zip').search(cr,uid,[])
        if zip_ids:
            zip_codes = pooler.get_pool(cr.dbname).get('res.partner.zip').browse(cr,uid,zip_ids,[])
            for zip_code in zip_codes:
                # search for country_id
                country_id = 'base.be'
                for group in zip_code.groups_id:
                    if group.type_id and group.type_id.id == 5:
                        if len(group.name .strip()) == 2:
                            country_id = 'base.' + group.name.strip().lower()
                        elif group.name == 'Belgique':
                            country_id = 'base.be'
                        elif group.name == 'GB ou UK':
                            country_id = 'base.uk'
                #
                record = []
                record.append('res_partner_zip_'+str(zip_code.id))
                record.append(zip_code.name.encode('utf-8'))
                record.append((zip_code.city or '').encode('utf-8'))
                if TEST_DATA:
                    record.append('base.user_admin')
                else:
                    record.append(zip_code.user_id and ('res_users_'+str(zip_code.user_id.id)) or 'base.user_admin')
                record.append(zip_code.longitude and zip_code.longitude or 0.0)
                record.append(zip_code.latitude and zip_code.latitude or 0.0)
                record.append(list_of_ids(zip_code.groups_id,'res_partner_zip_group_'))
                record.append(zip_code.other_names and zip_code.other_names.encode('utf-8') or '')
                record.append(country_id)
                csvRPZ.writerow(record)
                if len(set([x.id for x in zip_code.groups_id]).intersection(set(demo_group_ids))) > 0:
                    zip_group_ids = []
                    for x in zip_code.groups_id:
                        if x.id in demo_group_ids:
                            zip_group_ids.append(x.id)
                    older_names = ''
                    if zip_code.old_city:
                        older_names = zip_code.old_city+'\n'
                    if zip_code.other_names:
                        older_names += zip_code.other_names
                    demo_data_zips.append({'demo_model_name':'cci.zip',
                                           'demo_id':'demo_zip_'+str(zip_code.id),
                                           'postal_code':clean_string(zip_code.name).encode('utf-8'),
                                           'city':clean_string(zip_code.city).encode('utf-8'),
                                           'longitude':'%.2f' % zip_code.longitude or 0.0,
                                           'latitude':'%.2f' % zip_code.latitude or 0.0,
                                           'groups_id':zip_group_ids and ','.join(['demo_zg_%i' % x for x in zip_group_ids] or ''),
                                           'other_name':older_names.encode('utf-8'),
                                          })
        save_in_demo_xml('demo_data_zip_group_types.xml',demo_data_zip_group_types)
        save_in_demo_xml('demo_data_zip_groups.xml',demo_data_zip_groups)
        save_in_demo_xml('demo_data_zips.xml',demo_data_zips)

        hfRPLF = open('0_oe5_cci_legal_form.csv','w')
        csvRPLF = csv.writer(hfRPLF,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPLF.writerow(['id','name'])
        legal_form_ids = pooler.get_pool(cr.dbname).get('res.partner.title').search(cr,uid,[('domain','=','partner')])
        if legal_form_ids:
            legal_forms = pooler.get_pool(cr.dbname).get('res.partner.title').read(cr,uid,legal_form_ids,['shortcut','name'])
            for legal_form in legal_forms:
                record = []
                record.append('res_partner_title_'+str(legal_form['id']))
                record.append(clean_string(legal_form['shortcut'] or '').encode('utf-8'))
                csvRPLF.writerow(record)
                
        hfRPTC = open('0_oe5_res_partner_title.csv','w')
        csvRPTC = csv.writer(hfRPTC,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPTC.writerow(['id','name','shortcut'])
        title_contact_ids = pooler.get_pool(cr.dbname).get('res.partner.title').search(cr,uid,[('domain','=','contact')])
        if title_contact_ids:
            courtesies = pooler.get_pool(cr.dbname).get('res.partner.title').read(cr,uid,title_contact_ids,['shortcut','name'])
            for courtesy in courtesies:
                record = []
                record.append('res_partner_title_'+str(courtesy['id']))
                record.append(clean_string(courtesy['shortcut'] or '').encode('utf-8'))
                csvRPTC.writerow(record)

        hfRPAS = open('0_oe5_cci_activity_state.csv','w')
        csvRPAS = csv.writer(hfRPAS,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPAS.writerow(['id','name','is_in_activity'])
        activstate_ids = pooler.get_pool(cr.dbname).get('res.partner.state').search(cr,uid,[])
        if activstate_ids:
            activstates = pooler.get_pool(cr.dbname).get('res.partner.state').read(cr,uid,activstate_ids,['name'])
            for activstate in activstates:
                record = []
                record.append('res_partner_state_'+str(activstate['id']))
                record.append(clean_string(activstate['name']).encode('utf-8'))
                record.append((activstate['id'] == 1) and 1 or 0)
                csvRPAS.writerow(record)

        hfRPCP = open('0_oe5_cci_position.csv','w')
        csvRPCP = csv.writer(hfRPCP,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPCP.writerow(['id','name','short_name'])
        dCodePosition2ID = {}
        codefunction_ids = pooler.get_pool(cr.dbname).get('res.partner.function').search(cr,uid,[])
        if codefunction_ids:
            codefunctions = pooler.get_pool(cr.dbname).get('res.partner.function').read(cr,uid,codefunction_ids,['name','code'])
            for codefunction in codefunctions:
                if codefunction['code'].strip() not in ['!','@','*','>']:
                    record = []
                    record.append('res_partner_function_'+str(codefunction['id']))
                    record.append(codefunction['name'].strip().encode('utf-8'))
                    record.append(codefunction['code'].strip().encode('utf-8'))
                    csvRPCP.writerow(record)
                    dCodePosition2ID[codefunction['code'].strip()] = 'res_partner_function_'+str(codefunction['id'])
        
        hfRPI = open('0_oe5_res_partner_industry.csv','w')
        csvRPI = csv.writer(hfRPI,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPI.writerow(['id','name','full_name']) ## we must set the code in the displayed field
        dCodeSect2ID = {}
        activsect_ids = pooler.get_pool(cr.dbname).get('res.partner.activsector').search(cr,uid,[])
        if activsect_ids:
            activsects = pooler.get_pool(cr.dbname).get('res.partner.activsector').read(cr,uid,activsect_ids,['name','code'])
            for activsector in activsects:
                record = []
                record.append('res_partner_activsector_'+str(activsector['id']))
                record.append(clean_string(activsector['code'].strip()+' - '+activsector['name']).encode('utf-8'))
                record.append(clean_string(activsector['name']+' ['+activsector['code'].strip()+']').encode('utf-8'))
                csvRPI.writerow(record)
                dCodeSect2ID[activsector['code'].strip()] = 'res_partner_activsector_'+str(activsector['id'])

        hfMembBracket = open('0_oe5_cci_bracket.csv','w')
        csvMembBracket = csv.writer(hfMembBracket,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvMembBracket.writerow(['id','name','year','minimum_employee','maximum_employee','amount'])
        bracket_ids = pooler.get_pool(cr.dbname).get('cci_membership.membership_range').search(cr,uid,[])
        if bracket_ids:
            brackets = pooler.get_pool(cr.dbname).get('cci_membership.membership_range').read(cr,uid,bracket_ids,['date_from','date_to','amount','year'])
            for bracket in brackets:
                record = []
                record.append('membership_range_'+str(bracket['id']))
                record.append((u'De %i à %i' % (bracket['date_from'],bracket['date_to'])).encode('utf-8'))
                record.append(str(bracket['year']).encode('utf-8'))
                record.append(bracket['date_from'])
                record.append(bracket['date_to'])
                record.append('%.2f' % bracket['amount'])
                csvMembBracket.writerow(record)

        final_br_types = []
        hfFailConst = open('0_oe5_cci_publication.csv','w')
        csvFailConst = csv.writer(hfFailConst,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvFailConst.writerow(['id','publication_type','area','name','street','zipcode','city','vat','legal_form','activity_description','partner_id/id','publication_date','event_date',
                               'final_zip_id/id','administrator_title','administrator_first_name','administrator_surname','administrator_position','administrator_code_id/id','nace_code','import_date',
                               'judge_commissioner_id/id','trustee_ids/id','bankruptcy_type'])
        fail_ids = pooler.get_pool(cr.dbname).get('riplay.bankruptcy').search(cr,uid,[])
        if fail_ids:
            fails = pooler.get_pool(cr.dbname).get('riplay.bankruptcy').browse(cr,uid,fail_ids) #,['name','zip_id','type_id','commissioner_id','curator_ids','vat_num','bankruptcy_date',
                                                                                            #  'activ_desc','legal_status','street','output_date','partner_id'])
            for fail in fails:
                record = []
                record.append('riplay_bankruptcy_'+str(fail.id))
                record.append('bankruptcy')
                if fail.zip_id:
                    record.append((fail.zip_id.name[0] == '5') and 'namur' or 'liege')
                else:
                    record.append('liege')
                record.append(clean_string(fail.name or '').encode('utf-8'))
                record.append(clean_string(fail.street or '').encode('utf-8'))
                record.append(fail.zip_id.name.encode('utf-8'))
                record.append(fail.zip_id.city.encode('utf-8'))
                record.append((fail.vat_num or '').encode('utf-8'))
                record.append((fail.legal_status or '').encode('utf-8'))
                record.append((fail.activ_desc or '').encode('utf-8'))
                if fail.partner_id:
                    record.append('res_partner_'+str(fail.partner_id.id))
                else:
                    record.append('')
                record.append(fail.output_date and fail.output_date or '')
                record.append(fail.bankruptcy_date and fail.bankruptcy_date or False)
                record.append(fail.zip_id and ('res_partner_zip_'+str(fail.zip_id.id)) or '')
                record.append('')
                record.append('')
                record.append('')
                record.append('')
                record.append('')
                record.append('')
                record.append('')
                if fail.commissioner_id:
                    record.append('riplay_commissioner_'+str(fail.commissioner_id.id))
                    if not fail.commissioner_id.active and fail.commissioner_id.id not in unactive_used_commissioner_id:
                        unactive_used_commissioner_ids.append(fail.commissioner_id.id)
                else:
                    record.append('')
                libs = []
                for trustee in fail.curator_ids:
                    libs.append('riplay_trustee_'+str(trustee.id))
                    if not trustee.active and trustee.id not in unactive_used_trustee_ids:
                        unactive_used_trustee_ids.append(trustee.id)
                record.append(','.join(libs))
                record.append(conv_faillite_type(fail.type_id.name).encode('utf-8'))
                br_type = conv_faillite_type(fail.type_id.name)
                if br_type not in final_br_types:
                    final_br_types.append(br_type)
                csvFailConst.writerow(record)
        const_ids = pooler.get_pool(cr.dbname).get('riplay.creation').search(cr,uid,[])
        if const_ids:
            consts = pooler.get_pool(cr.dbname).get('riplay.creation').read(cr,uid,const_ids,['name','zip_code','city','final_zip_id','admin_courtesy','admin_first_name','admin_name','vat_num','nace_ids','creation_date',
                                                                                              'activ_desc','import_date','legal_status','street','admin_codes','admin_title','output_date','final_partner_id'])
            for const in consts:
                record = []
                record.append('riplay_creation_'+str(const['id']))
                record.append('constitution')
                record.append((const['zip_code'][0:1] == '5') and 'namur' or 'liege')
                record.append(clean_string(const['name'] or '').encode('utf-8'))
                record.append(clean_string(const['street'] or '').encode('utf-8'))
                record.append((const['zip_code'] or '').encode('utf-8'))
                record.append((const['city'] or '').encode('utf-8'))
                record.append((const['vat_num'] or '').encode('utf-8'))
                record.append((const['legal_status'] or '').encode('utf-8'))
                record.append((const['activ_desc'] or '').encode('utf-8'))
                if const['final_partner_id']:
                    record.append('res_partner_'+str(const['final_partner_id'][0]))
                else:
                    record.append('')
                record.append(const['output_date'] and const['output_date'] or '')
                record.append(const['creation_date'] and const['creation_date'] or '')
                record.append(const['final_zip_id'] and ('res_partner_zip_'+str(const['final_zip_id'][0])) or '')
                record.append((const['admin_courtesy'] or '').encode('utf-8'))
                record.append((const['admin_first_name'] or '').encode('utf-8'))
                record.append((const['admin_name'] or '').encode('utf-8'))
                record.append((const['admin_title'] or '').encode('utf-8'))
                if const['admin_codes']:
                    libs = []
                    for carac in const['admin_codes'].strip():
                        if carac in dCodePosition2ID.keys():
                            libs.append(dCodePosition2ID[carac])
                    if libs:
                        record.append((','.join(libs)).encode('utf-8'))
                    else:
                        record.append('')
                else:
                    record.append('')
                if const['nace_ids']:
                    naces = pooler.get_pool(cr.dbname).get('riplay.prohibited_nace').read(cr,uid,const['nace_ids'],['name','meaning'])
                    libs = []
                    for nace in naces:
                        libs.append(nace['name']+' '+(nace['meaning'] or ''))
                    record.append('\n'.join(libs).encode('utf-8'))
                else:
                    record.append('')
                record.append(const['import_date'] and const['import_date'] or '')
                record.append('')
                record.append('')
                record.append('')
                csvFailConst.writerow(record)
        # trustee and commissioner as res.partners contacts
        hfTC = open('0_oe5_trustee_commissioner.csv','w')
        csvTC = csv.writer(hfTC,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvTC.writerow(['id','parent_id/id','is_company','company_type','type','name','activity_state_id/id','postal_code_id/id','zip','city','country_id/id','street','street2','phone','fax','email',
                        'is_commissioner','is_trustee','customer','supplier','position_ids/id','function','title','active','lang'])
        trustee_ids = pooler.get_pool(cr.dbname).get('riplay.curator').search(cr,uid,[])
        if unactive_used_trustee_ids:
            trustee_ids += unactive_used_trustee_ids
        if trustee_ids:
            trustees = pooler.get_pool(cr.dbname).get('riplay.curator').read(cr,uid,trustee_ids,['name','zip_city','street','office_name','phone','fax','email','active'])
            for trustee in trustees:
                if trustee['name']:
                    record = []
                    record.append('riplay_trustee_'+str(trustee['id']))
                    record.append('')
                    record.append(False)
                    record.append('person')
                    record.append('contact')
                    if trustee['name'][0:3] == 'Me ':
                        courtesy = u'Maître'
                        full_name = trustee['name'][3:].strip()
                    elif trustee['name'][0:3] == 'Mr ':
                        courtesy = 'Monsieur'
                        full_name = trustee['name'][3:].strip()
                    elif trustee['name'][0:4] == 'Mme ':
                        courtesy = 'Madame'
                        full_name = trustee['name'][4:].strip()
                    else:
                        courtesy = False
                        full_name = trustee['name'].strip()
                    record.append(full_name.encode('utf-8'))
                    record.append('res_partner_state_1')
                    street2 = ''
                    (zip_id,zip_code,isolated_city) = search_zip_id(cr,uid,trustee['zip_city'])
                    if not zip_id:
                        street2 = (trustee['zip_city'] or '')
                    record.append(zip_id)
                    record.append(zip_code.encode('utf-8'))
                    record.append(isolated_city.encode('utf-8'))
                    record.append(get_country_key('BE','res.country'))
                    record.append(clean_string(trustee['street'] or '').encode('utf-8'))
                    record.append(street2.encode('utf-8'))
                    record.append(clean_string(trustee['phone'] or '').encode('utf-8'))
                    record.append(clean_string(trustee['fax'] or '').encode('utf-8'))
                    record.append(clean_string(trustee['email'] or '').encode('utf-8'))
                    record.append(False)
                    record.append(True)
                    record.append(False)
                    record.append(False)
                    record.append(dCodePosition2ID['G'])
                    record.append(u'Curateur'.encode('utf-8'))
                    record.append(courtesy.encode('utf-8'))
                    record.append(trustee['active'])
                    record.append('fr_FR')
                    csvTC.writerow(record)
        commissioner_ids = pooler.get_pool(cr.dbname).get('riplay.commissioner').search(cr,uid,[])
        if unactive_used_commissioner_ids:
            commissioner_ids += unactive_used_commissioner_ids
        if commissioner_ids:
            commissioners = pooler.get_pool(cr.dbname).get('riplay.commissioner').read(cr,uid,commissioner_ids,['name','zip_city','street','office_name','phone','fax','email','active'])
            for commissioner in commissioners:
                if commissioner['name']:
                    record = []
                    record.append('riplay_commissioner_'+str(commissioner['id']))
                    record.append('')
                    record.append(False)
                    record.append('person')
                    record.append('contact')
                    if commissioner['name'][0:3] == 'Me ':
                        courtesy = u'Maître'
                        full_name = commissioner['name'][3:].strip()
                    elif commissioner['name'][0:3] == 'Mr ':
                        courtesy = 'Monsieur'
                        full_name = commissioner['name'][3:].strip()
                    elif commissioner['name'][0:4] == 'Mme ':
                        courtesy = 'Madame'
                        full_name = commissioner['name'][4:].strip()
                    else:
                        courtesy = False
                        full_name = commissioner['name'].strip()
                    record.append(full_name.encode('utf-8'))
                    record.append('res_partner_state_1')
                    street2 = ''
                    (zip_id,zip_code,isolated_city) = search_zip_id(cr,uid,commissioner['zip_city'])
                    if not zip_id:
                        street2 = (commissioner['zip_city'] or '')
                    record.append(zip_id)
                    record.append(zip_code.encode('utf-8'))
                    record.append(isolated_city.encode('utf-8'))
                    record.append(get_country_key('BE','res.country'))
                    record.append(clean_string(commissioner['street'] or '').encode('utf-8'))
                    record.append(street2.encode('utf-8'))
                    record.append(clean_string(commissioner['phone'] or '').encode('utf-8'))
                    record.append(clean_string(commissioner['fax'] or '').encode('utf-8'))
                    record.append(clean_string(commissioner['email'] or '').encode('utf-8'))
                    record.append(True)
                    record.append(False)
                    record.append(False)
                    record.append(False)
                    record.append(dCodePosition2ID['G'])
                    record.append(u'Juge-Commissaire'.encode('utf-8'))
                    record.append(courtesy.encode('utf-8'))
                    record.append(commissioner['active'])
                    csvTC.writerow(record)
        hfTC.close()
        
        # extract all activity sector categories
        obj_categ = pooler.get_pool(cr.dbname).get('res.partner.category')
        old_len = 0
        categ_ids = [ data['form']['category_id'] ]
        while len(categ_ids) > old_len:
            new_ids = categ_ids[old_len:] # ids of categories added last time
            old_len = len(categ_ids) # the new frontier ...
            new_categs = obj_categ.read(cr,uid,new_ids,['child_ids'])
            for categ in new_categs:
                if categ['child_ids']:
                    categ_ids.extend(categ['child_ids'])
        categs = obj_categ.read(cr,uid,categ_ids,['name'],{'lang':'fr_FR'})
        dCategID2SectCode = {}
        for categ in categs:
            formated_name = categ['name']
            posA = formated_name.rfind('[')
            posB = formated_name.rfind(']')
            if posA > 0 and posB > 0 and posA < posB:
                sect_code = formated_name[posA+1:posB]
            dCategID2SectCode[ categ['id'] ] = sect_code
        
        # extraction of all res.partner.category kept and exported
        dKeptCategs = {}
        obj_categ = pooler.get_pool(cr.dbname).get('res.partner.category')
        categ_ids = obj_categ.search(cr,uid,[])
        categs = obj_categ.read(cr,uid,categ_ids,['name','parent_id','complete_name'],{'lang':'fr_FR'})
        for categ in categs:
            if categ['complete_name'][0:10] == u'Publicités' or categ['complete_name'][0:12] == u'Institutions':
                data_categ = {'id':'res_partner_category_'+str(categ['id']),
                              'parent_id':categ['parent_id'] and ('res_partner_category_'+str(categ['parent_id'][0])) or '',
                              'name':categ['name'],
                              'partner_ids':''}
                dKeptCategs[categ['id']] = data_categ
            elif u'Fournisseur qualité' in categ['complete_name']:
                data_categ = {'id':'res_partner_category_'+str(categ['id']),
                              'parent_id':categ['parent_id'] and ('res_partner_category_'+str(categ['parent_id'][0])) or '',
                              'name':categ['name'],
                              'partner_ids':''}
                if len(categ['complete_name'].strip()) <= 33:
                    data_categ['parent_id'] = '' # remettre Fournisseur Qualité comme racine
                dKeptCategs[categ['id']] = data_categ
        # create new categories from other informations
        data_categ = {'id':'new_res_partner_category_1',
                      'parent_id':'',
                      'name':u'LISTE ROUGE',
                      'partner_ids':''}
        dKeptCategs[-1] = data_categ
        #
        data_categ = {'id':'new_res_partner_category_2',
                      'parent_id':'',
                      'name':u'Entreprise familiale',
                      'partner_ids':''}
        dKeptCategs[-2] = data_categ
        #
        data_categ = {'id':'new_res_partner_category_3',
                      'parent_id':'',
                      'name':u'Journaliste Conférence de Presse',
                      'partner_ids':''}
        dKeptCategs[-3] = data_categ
        #
        data_categ = {'id':'new_res_partner_category_4',
                      'parent_id':'',
                      'name':u'Contact RdMembres pour cette société',
                      'partner_ids':''}
        dKeptCategs[-4] = data_categ
        #
        data_categ = {'id':'new_res_partner_category_5',
                      'parent_id':'',
                      'name':u'Contact RdMembres pour cette adresse',
                      'partner_ids':''}
        dKeptCategs[-5] = data_categ
        #
        data_categ = {'id':'new_res_partner_category_6',
                      'parent_id':'',
                      'name':u'Contact Membership',
                      'partner_ids':''}
        dKeptCategs[-6] = data_categ
        #
        data_categ = {'id':'new_res_partner_category_7',
                      'parent_id':'',
                      'name':u'Invitation Papier aux Events (pas unique)',
                      'partner_ids':''}
        dKeptCategs[-7] = data_categ
        # membership lines
        # = []
        hfMML = open('0_oe5_membership_membership_line.csv','w')
        csvMML = csv.writer(hfMML,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvMML.writerow(['id','account_invoice_line/id','date','date_cancel','date_from','date_to','member_price','membership_id/id','partner/id','state'])
        member_line_ids = pooler.get_pool(cr.dbname).get('membership.membership_line').search(cr,uid,[])
        member_lines = pooler.get_pool(cr.dbname).get('membership.membership_line').browse(cr,uid,member_line_ids)
        for mline in member_lines:
            if mline.account_invoice_line and mline.account_invoice_line.invoice_id:
                record = []
                record.append('membership_line_'+str(mline.id))
                if data['form']['compta']:
                    record.append('account_invoice_line_'+str(mline.account_invoice_line.id))
                else:
                    record.append('')
                record.append(mline.account_invoice_line.invoice_id.date_invoice or '')
                record.append(mline.date_cancel or '')
                record.append(mline.date_from or '')
                record.append(mline.date_to or '')
                record.append(mline.account_invoice_line.price_subtotal or 0.0)
                record.append(mline.account_invoice_line.product_id and ('product_product_'+str(mline.account_invoice_line.product_id.id)) or '')
                record.append(mline.partner and 'res_partner_'+str(mline.partner.id) or '')
                record.append(mline.state or '')
                csvMML.writerow(record)
                if mline.partner and (mline.partner.id not in unactive_used_partner_ids):
                    unactive_used_partner_ids.append(mline.partner.id)

        ### Clubs : export des participants en attente, et des clubs
        hfCDoWeek = open('0_oe5_ccilvn_day_of_week.csv','w')
        csvCDoWeek = csv.writer(hfCDoWeek,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvCDoWeek.writerow(['id','name','dayofweek'])
        csvCDoWeek.writerow(['day_of_week_1','Lundi',0])
        csvCDoWeek.writerow(['day_of_week_2','Mardi',1])
        csvCDoWeek.writerow(['day_of_week_3','Mercredi',2])
        csvCDoWeek.writerow(['day_of_week_4','Jeudi',3])
        csvCDoWeek.writerow(['day_of_week_5','Vendredi',4])

        hfCSLevel = open('0_oe5_cci_club_level.csv','w')
        csvCSLevel = csv.writer(hfCSLevel,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvCSLevel.writerow(['id','name','level_points'])
        level_ids = pooler.get_pool(cr.dbname).get('cci_club.level').search(cr,uid,[])
        levels = pooler.get_pool(cr.dbname).get('cci_club.level').browse(cr,uid,level_ids)
        for level in levels:
            record = []
            record.append('cci_club_level_'+str(level.id))
            record.append((level.name or '').encode('utf-8'))
            record.append(level.sequence or 99)
            csvCSLevel.writerow(record)

        hfCCTable = open('0_oe5_ccilvn_conversation_table.csv','w')
        csvCCTable = csv.writer(hfCCTable,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvCCTable.writerow(['id','partner_id/id','state','active','subscription_date','start_date','end_date','lang_id/id','level_id/id','availability_ids/id'])
        club_ids = pooler.get_pool(cr.dbname).get('cci_club.club').search(cr,uid,[('type_id','=',17)])
        clubs = pooler.get_pool(cr.dbname).get('cci_club.club').browse(cr,uid,club_ids)
        for club in clubs:
            if club.state == 'draft' and club.code and (club.code.strip()[0:5] == 'TCATT') and (not club.date_begin):
                for part in club.participation_ids:
                    # search for link between partner and contact
                    partner = part.partner_id
                    address = False
                    job = False
                    contact = False
                    if partner.address:
                        for addr in partner.address:
                            for ajob in addr.job_ids:
                                if ajob.contact_id and ajob.contact_id.id == part.contact_id.id:
                                    address = addr
                                    job = ajob
                                    contact = ajob.contact_id
                                    break
                            if job:
                                break
                    if address and job and contact:
                        if part.language_id and part.language_id.code:
                            record = []
                            record.append('cci_club_participation_'+str(part.id))
                            record.append('res_partner_job_'+str(job.id))
                            if part.state_id and part.state_id.id == 1:
                                record.append('waiting')
                                record.append(True)
                            else:
                                record.append('done')
                                record.append(False)
                            record.append(part.date_registration or '')
                            record.append(part.date_in or '')
                            record.append(part.date_out or '')
                            record.append('base.lang_'+part.language_id.code.lower())
                            if part.level_id:
                                record.append('cci_club_level_'+str(part.level_id.id))
                            else:
                                record.append('')
                            days = []
                            if part.monday:
                                days.append('ccilvn_event_sale.mon_day_of_week')
                            if part.tuesday:
                                days.append('ccilvn_event_sale.tue_day_of_week')
                            if part.wednesday:
                                days.append('ccilvn_event_sale.wed_day_of_week')
                            if part.thursday:
                                days.append('ccilvn_event_sale.thu_day_of_week')
                            if part.friday:
                                days.append('ccilvn_event_sale.fri_day_of_week')
                            record.append(','.join(days))
                            csvCCTable.writerow(record)
                            if partner and (partner.id not in unactive_used_partner_ids):
                                unactive_used_partner_ids.append(partner.id)
                            if address and (address.id not in unactive_used_address_ids):
                                unactive_used_address_ids.append(address.id)
                            if job and (job.id not in unactive_used_job_ids):
                                unactive_used_job_ids.append(job.id)
                            if contact and (contact.id not in unactive_used_contact_ids):
                                unactive_used_contact_ids.append(contact.id)
        hfCEvType = open('0_oe5_club_event_type.csv','w')
        csvCEvType = csv.writer(hfCEvType,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvCEvType.writerow(['id','name' ,'active','category','auto_confirm','start_date','end_date','use_mail_schedule','external_name','occurrences',
                            'has_seats_limitation','state','subcategory','accepted_url','declined_url','is_online'])

        hfCCCTAttendee = open('0_oe5_ccilvn_club_table_attendee.csv','w')
        csvCCCTAttendee = csv.writer(hfCCCTAttendee,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvCCCTAttendee.writerow(['id','event_type_id/id' ,'partner_id/id','registration_date','end_date','continuity','notes'])

        hfCTCheck = open('0_oe5_ccilvn_training_check.csv','w')
        csvCTCheck = csv.writer(hfCTCheck,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvCTCheck.writerow(['id','name' ,'check_type','state','club_table_attendee_id/id','active' ,'hours','limit_date','puncture_date','reception_date','step','traform_year','value'])

        hfCEEvent = open('0_oe5_club_event_event.csv','w')
        csvCEEvent = csv.writer(hfCEEvent,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvCEEvent.writerow(['id','name','date_begin','date_end','seats_min','seats_availability','user_id/id','active','description','is_published',
                             'address_id/id','website_track','company_id/id','trainer_id/id','accepted_url','declined_url','is_online','state'])

        hfCEReg = open('0_oe5_club_event_registration.csv','w')
        csvCEReg = csv.writer(hfCEReg,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvCEReg.writerow(['id','name','email','invoice_event','partner_id/id','event_id/id','phone','state'])

        club_ids = pooler.get_pool(cr.dbname).get('cci_club.club').search(cr,uid,[('type_id','in',[16,17,28])])
        clubs = pooler.get_pool(cr.dbname).get('cci_club.club').browse(cr,uid,club_ids)
        for club in clubs:
            record = []
            record.append('cci_club_'+str(club.id))
            record.append((club.name or '').encode('utf-8'))
            record.append(club.active)
            if club.type_id.id in [16,28]:
                record.append('club')
            else:
                record.append('table')
            record.append(False)
            club_date_start = ''
            club_date_end = ''
            if club.date_begin:
                club_date_start = club.date_begin+' 09:00:00'
            if club.date_end:
                club_date_end = club.date_end+' 18:00:00'
            record.append(club_date_start)
            record.append(club_date_end)
            record.append(True)
            record.append((club.external_name or '').encode('utf-8'))
            if club.session_ids:
                record.append(len(club.session_ids))
            else:
                record.append(0)
            record.append(False)
            if club.state == 'draft':
                record.append('waiting')
            elif club.state == 'current':
                record.append('ongoing')
            elif club.state == 'done':
                record.append('done')
            else:
                record.append('none')
            record.append(club.type_id.name.strip().encode('utf-8'))
            record.append('') ## TODO URLS
            record.append('')
            record.append(False)
            csvCEvType.writerow(record)
            # BECAUSE in old club (but inb some recent ones also), a person can participate more than once in a club
            # we need to aggregate participation by (club_id,partner_id) before sending it to odoo 12
            dParticipants = {}
            for part in club.participation_ids:
                # search for link between partner and contact
                partner = part.partner_id
                address = False
                job = False
                contact = False
                if partner.address:
                    for addr in partner.address:
                        for ajob in addr.job_ids:
                            if ajob.contact_id and ajob.contact_id.id == part.contact_id.id:
                                address = addr
                                job = ajob
                                contact = ajob.contact_id
                                break
                        if job:
                            break
                if address and job and contact:
                    if (club.id,job.id) in dParticipants.keys():
                        data_part = dParticipants[(club.id,job.id)]
                        if part.id > data_part['part_id']:
                            data_part['part_id'] = part.id
                        if part.date_registration:
                            if data_part['date_reg'] and part.date_registration < data_part['date_reg']:
                                data_part['date_reg'] = part.date_registration
                        if part.date_out:
                            if data_part['date_out'] and part.date_out > data_part['date_out']:
                                data_part['date_out'] = part.date_out
                        if part.note:
                            if data_part['note']:
                                data_part['note'] += ('\n\nNew Participation : '+str(part.id)+'\n\n' + part.note)
                            else:
                                data_part['note'] = part.note
                        if part.check_ids:
                            if data_part['check_ids']:
                                data_part['check_ids'].extend([x.id for x in part.check_ids])
                            else:
                                data_part['check_ids'] = [x.id for x in part.check_ids]
                    else:
                        data_part = {'club_id':'cci_club_'+str(club.id),
                                     'job_id':'res_partner_job_'+str(job.id),
                                     'part_id':part.id,
                                     'date_reg':part.date_registration or '',
                                     'date_out':part.date_out or '',
                                     'continuation':part.continuation,
                                     'note':part.note or '',
                                     'check_ids':[x.id for x in part.check_ids],
                                    }
                    dParticipants[(club.id,job.id)] = data_part
                    if partner and (partner.id not in unactive_used_partner_ids):
                        unactive_used_partner_ids.append(partner.id)
                    if address and (address.id not in unactive_used_address_ids):
                        unactive_used_address_ids.append(address.id)
                    if job and (job.id not in unactive_used_job_ids):
                        unactive_used_job_ids.append(job.id)
                    if contact and (contact.id not in unactive_used_contact_ids):
                        unactive_used_contact_ids.append(contact.id)
            if dParticipants.values():
                for data_part in dParticipants.values():
                    record = []
                    record.append('cci_club_participation_'+str(data_part['part_id']))
                    record.append(data_part['club_id'])
                    record.append(data_part['job_id'])
                    record.append(data_part['date_reg'])
                    record.append(data_part['date_out'])
                    record.append(data_part['continuation'])
                    record.append(data_part['note'].encode('utf-8'))
                    csvCCCTAttendee.writerow(record)
                    if data_part['check_ids']:
                        checks = pooler.get_pool(cr.dbname).get('cci_club.club_check').browse(cr,uid,data_part['check_ids'])
                        for check in checks:
                            record = []
                            record.append('cci_training_check_'+str(check.id))
                            record.append(check.name.encode('utf-8'))
                            if check.type_id:
                                if check.type_id.id == 2:
                                    record.append('lang')
                                else:
                                    record.append('training')
                            else:
                                record.append('training')
                            if check.state == 'draft':
                                record.append('waiting')
                            elif check.state == 'block':
                                record.append('rejected')
                            elif check.state == 'confirm':
                                record.append('received')
                            elif check.state == 'cancel':
                                record.append('rejected')
                            elif check.state == 'asked':
                                record.append('asked')
                            elif check.state == 'paid':
                                record.append('paid')
                            elif check.state == 'rejected':
                                record.append('rejected')
                            record.append('cci_club_participation_'+str(data_part['part_id']))
                            record.append(check.active)
                            record.append(check.unit_nbr or 1)
                            record.append(check.date_limit or '')
                            record.append(check.date_submission or '')
                            record.append(check.date_reception or '')
                            if check.step_id:
                                record.append(check.step_id.name[-1:])
                            else:
                                record.append('1')
                            if check.traform_year > 0:
                                record.append(str(check.traform_year))
                            else:
                                record.append('')
                            record.append(min(check.unit_value or 0.0,100.0))
                            csvCTCheck.writerow(record)
            for session in club.session_ids:
                if session.group_id:
                    record = []
                    record.append('cci_club_session_'+str(session.id))
                    record.append(('%s %s [%s]' % (session.group_id.name.strip(),session.date,session.number)).encode('utf-8'))
                    record.append(session.date+' 09:00:00')
                    record.append(session.date+' 17:00:00')
                    record.append(0)
                    record.append('unlimited')
                    if session.group_id.responsible_id:
                        record.append(get_user_id_from_login(session.group_id.responsible_id.login))
                    else:
                        record.append('')
                    record.append(True)
                    record.append((session.comments or '').encode('utf-8'))
                    record.append(False)
                    if session.host_address_id:
                        if session.host_address_id.partner_id and session.host_address_id.type == 'default':
                            record.append('res_partner_'+str(session.host_address_id.partner_id.id))
                            if session.host_address_id.partner_id and session.host_address_id.partner_id.id not in unactive_used_partner_ids:
                                unactive_used_partner_ids.append(session.host_address_id.partner_id.id)
                        else:
                            record.append('res_partner_address_'+str(session.host_address_id.id))
                            if session.host_address_id.id not in unactive_used_address_ids:
                                unactive_used_address_ids.append(session.host_address_id.id)
                                if session.host_address_id.partner_id and session.host_address_id.partner_id.id not in unactive_used_partner_ids:
                                    unactive_used_partner_ids.append(session.host_address_id.partner_id.id)
                    elif session.group_id.host_address_id:
                        if session.group_id.host_address_id.partner_id and (session.group_id.host_address_id.type == 'default'):
                            record.append('res_partner_'+str(session.group_id.host_address_id.partner_id.id))
                            if session.group_id.host_address_id.partner_id and session.group_id.host_address_id.partner_id.id not in unactive_used_partner_ids:
                                unactive_used_partner_ids.append(session.host_address_id.partner_id.id)
                        else:
                            record.append('res_partner_address_'+str(session.group_id.host_address_id.id))
                            if session.group_id.host_address_id.id not in unactive_used_address_ids:
                                unactive_used_address_ids.append(session.group_id.host_address_id.id)
                                if session.group_id.host_address_id.partner_id and session.group_id.host_address_id.partner_id.id not in unactive_used_partner_ids:
                                    unactive_used_partner_ids.append(session.group_id.host_address_id.partner_id.id)
                    else:
                        record.append('')
                    record.append(False)
                    record.append('base.main_company')
                    if session.group_id and session.group_id.formative_id:
                        # search for first job of this contact or stand alone contact
                        contact = session.group_id.formative_id
                        job = False
                        address = False
                        partner = False
                        if contact.job_ids:
                            for check_job in contact.job_ids:
                                if check_job.address_id and check_job.address_id.partner_id:
                                    job = check_job
                                    address = check_job.address_id
                                    partner = address.partner_id
                                    record.append('res_partner_job_'+str(check_job.id))
                                    break
                            if not (job and address and partner):
                                record.append('res_partner_contact_'+str(contact.id))
                        else:
                            record.append('res_partner_contact_'+str(contact.id))
                        pooler.get_pool(cr.dbname).get('res.partner.contact').write(cr,uid,[session.group_id.formative_id.id,],{'self_sufficent':True})
                        if partner and (partner.id not in unactive_used_partner_ids):
                            unactive_used_partner_ids.append(partner.id)
                        if address and (address.id not in unactive_used_address_ids):
                            unactive_used_address_ids.append(address.id)
                        if job and (job.id not in unactive_used_job_ids):
                            unactive_used_job_ids.append(job.id)
                        if contact and (contact.id not in unactive_used_contact_ids):
                            unactive_used_contact_ids.append(contact.id)
                    else:
                        record.append('')
                    record.append('')
                    record.append('')
                    record.append(False)
                    if session.state_id and session.state_id.id in [1,2]:
                        record.append('draft')
                    elif session.state_id and session.state_id.id == 3:
                        record.append('confirm')
                    elif session.state_id and session.state_id.id == 4:
                        record.append('cancel')
                    csvCEEvent.writerow(record)
                    for attendance in session.attendance_ids:
                        # search for link between partner and contact on the participation
                        partner = attendance.participation_id.partner_id
                        address = False
                        job = False
                        contact = False
                        if partner.address:
                            for addr in partner.address:
                                for ajob in addr.job_ids:
                                    if ajob.contact_id and ajob.contact_id.id == attendance.participation_id.contact_id.id:
                                        address = addr
                                        job = ajob
                                        contact = ajob.contact_id
                                        break
                                if job:
                                    break
                        if address and job and contact:
                            record = []
                            record.append('cci_club_attendance_'+str(attendance.id))
                            part_name = contact.name
                            if contact.first_name:
                                part_name += (' '+contact.first_name)
                            record.append(part_name.encode('utf-8'))
                            record.append((attendance.participation_id.email or '').encode('utf-8'))
                            record.append(False)
                            record.append('res_partner_job_'+str(job.id))
                            record.append('cci_club_session_'+str(session.id))
                            part_phone = get_phone((attendance.participation_id.phone or '').replace('\n','').replace(' (Job)','').replace(' (Address)','').replace(' (Mobile contact)',''),PHONE_COUNTRY_PREFIX)
                            record.append(part_phone.encode('utf-8'))
                            if attendance.state and attendance.state.id == 5:
                                record.append('draft')
                            elif attendance.state and attendance.state.id in [2,3,4,7]:
                                record.append('cancel')
                            elif attendance.state and attendance.state.id == 6:
                                record.append('open')
                            elif attendance.state and attendance.state.id == 1:
                                record.append('done')
                            else:
                                record.append('draft')
                            csvCEReg.writerow(record)
                            if partner and (partner.id not in unactive_used_partner_ids):
                                unactive_used_partner_ids.append(partner.id)
                            if address and (address.id not in unactive_used_address_ids):
                                unactive_used_address_ids.append(address.id)
                            if job and (job.id not in unactive_used_job_ids):
                                unactive_used_job_ids.append(job.id)
                            if contact and (contact.id not in unactive_used_contact_ids):
                                unactive_used_contact_ids.append(contact.id)

        ### Account
        if data['form']['compta']:
            hfAMove = open('0_oe5_account_move.csv','w')
            csvAMove = csv.writer(hfAMove,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
            csvAMove.writerow(['id','name','ref','partner_id/id','journal_id/id','company_id/id','date','state'])
            hfAMState = open('0_oe5_account_move_state.csv','w')
            csvAMState = csv.writer(hfAMState,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
            csvAMState.writerow(['id','state'])
            hfAMLine = open('0_oe5_account_move_line.csv','w')
            csvAMLine = csv.writer(hfAMLine,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
            csvAMLine.writerow(['id','name','quantity','product_id/id','debit','credit','move_id/id','account_id/id','reconciled','full_reconcile_id/id',
                                    'blocked','date','date_maturity','tax_line_id','invoice_id/id','partner_id/id','tax_exigible',
                                    'internal_note','followup_line_id','followup_date'])
            hfAALine = open('0_oe5_account_analytic_line.csv','w')
            csvAALine = csv.writer(hfAALine,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
            csvAALine.writerow(['id','name','ref','account_id/id','general_account_id/id','partner_id/id','move_id/id','company_id/id','date',
                                    'amount','code','product_id/id','so_line','tag_ids/id','unit_amount','user_id/id'])
            migrated_fiscalyear_ids = [13,15] ##in order of year so the first migrated year is in pos [0]
            period_ids = pooler.get_pool(cr.dbname).get('account.period').search(cr,uid,[('fiscalyear_id','in',migrated_fiscalyear_ids)])
            periods = pooler.get_pool(cr.dbname).get('account.period').browse(cr,uid,period_ids)
            migrated_period_ids = []
            for period in periods:
                if not period.special or (period.special and period.fiscalyear_id.id == migrated_fiscalyear_ids[0]):
                    migrated_period_ids.append(period.id)
            print('len migrated_period_ids')
            print(len(migrated_period_ids))
                
            if data['form']['test']:
                amove_ids = pooler.get_pool(cr.dbname).get('account.move').search(cr,uid,[('date','>=','2019-01-01')])
            else:
                amove_ids = pooler.get_pool(cr.dbname).get('account.move').search(cr,uid,[('period_id','in',migrated_period_ids)])
            index = 0
            size = 100
            while amove_ids[index:index+size]:
                amoves = pooler.get_pool(cr.dbname).get('account.move').browse(cr,uid,amove_ids[index:index+size])
                amline_ids = []
                for amove in amoves:
                    if amove.line_id:
                        header = []
                        header.append('account_move_'+str(amove.id))
                        header.append((amove.name or '').encode('utf-8'))
                        header.append((amove.ref or '').encode('utf-8'))
                        if amove.partner_id:
                            header.append('res_partner_'+str(amove.partner_id.id))
                            if amove.partner_id.id not in unactive_used_partner_ids:
                                unactive_used_partner_ids.append(amove.partner_id.id)
                        else:
                            header.append('')
                        if amove.journal_id:
                            journal_id = account_journal_key_from_code(amove.journal_id.code)
                            if journal_id:
                                header.append(journal_id)
                            else:
                                header.append('')
                        else:
                            header.append('')
                        header.append('base.main_company')
                        header.append(amove.date)
                        header.append('draft')
                        lines = []
                        for amline in amove.line_id:
                            line = []
                            line.append('account_move_line_'+str(amline.id))
                            line.append((amline.name or '').encode('utf-8'))
                            line.append(amline.quantity or 0.0)
                            line.append(amline.product_id and ('product_product_'+str(amline.product_id.id)) or '')
                            if amline.debit:
                                line.append(amline.debit)
                            else:
                                line.append('')
                            if amline.credit:
                                line.append(amline.credit)
                            else:
                                line.append('')
                            #
                            line.append('account_move_'+str(amove.id))
                            line.append(get_account_id_from_code(amline.account_id.code))
                            line.append(False)
                            line.append('')
                            line.append(False)
                            line.append(amline.date or '')
                            line.append(amline.date_maturity or amline.date or '')
                            line.append('') # tax_line
                            line.append('') # invoice_id
                            if amline.partner_id:
                                line.append('res_partner_'+str(amline.partner_id.id))
                                if amline.partner_id.id not in unactive_used_partner_ids:
                                    unactive_used_partner_ids.append(amline.partner_id.id)
                            else:
                                line.append('')
                            line.append(True)
                            line.append('')
                            if amline.followup_line_id:
                                line.append(amline.followup_line_id.id) # followup_line_id
                            else:
                                line.append('')
                            line.append(amline.followup_date or '') # followup_date
                            amline_ids.append(amline.id)
                            lines.append(line)
                    if lines:
                        csvAMove.writerow(header)
                        csvAMState.writerow(['account_move_'+str(amove.id),amove.state])
                        header.append(amove.state)
                        for line in lines:
                            csvAMLine.writerow(line)
                index += size
                aaline_ids = pooler.get_pool(cr.dbname).get('account.analytic.line').search(cr,uid,[('move_id','in',amline_ids)])
                if aaline_ids:
                    aalines = pooler.get_pool(cr.dbname).get('account.analytic.line').browse(cr,uid,aaline_ids)
                    for aaline in aalines:
                        alrecord = []
                        alrecord.append('account_analytic_line_'+str(aaline.id))
                        alrecord.append((aaline.name or '').encode('utf-8'))
                        alrecord.append((aaline.ref or '').encode('utf-8'))
                        alrecord.append('aaccount_'+str(aaline.account_id.id))
                        if aaline.general_account_id:
                            alrecord.append( get_account_id_from_code(aaline.general_account_id.code))
                        else:
                            alrecord.append('')
                        if aaline.partner_id:
                            alrecord.append('res_partner_'+str(aaline.partner_id.id))
                            if aaline.partner_id.id not in unactive_used_partner_ids:
                                unactive_used_partner_ids.append(aaline.partner_id.id)
                        else:
                            alrecord.append('')
                        if aaline.move_id:
                            alrecord.append('account_move_line_'+str(aaline.move_id.id))
                        else:
                            alrecord.append('')
                        alrecord.append('base.main_company')
                        alrecord.append(aaline.date or '')
                        alrecord.append(aaline.amount)
                        alrecord.append((aaline.code or '').encode('utf-8'))
                        alrecord.append('')
                        alrecord.append('')
                        alrecord.append('')
                        alrecord.append(aaline.unit_amount or 0.0)
                        alrecord.append('')
                        csvAALine.writerow(alrecord)
                if index > 2000 and data['form']['test']:
                    break
        
        ### RES.PARTNER AND AFFILIATES RECORDS
        hfCMLogs = open('0_oe5_cci_membership_logs.csv','w')
        csvCMLogs = csv.writer(hfCMLogs,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvCMLogs.writerow(['id','member_id/id','active_state','activity_state','associate_member_id/id','date','free_member','member_refusal','old_state','new_state','occupied_persons','reporting_date'])
        #
        headers = ['id','parent_id/id','is_company','company_type','type','name','activity_state_id/id','legal_form_id/id','vat','is_subject_to_vat','occupied_persons','gender','sequence',
                        'postal_code_id/id','zip','city','country_id/id','street','street2','phone','fax','email','website','snailmail_return_date',
                        'is_commissioner','is_trustee','member_refusal_date','member_fee','read_before_invoicing','membership_notes','free_member','membership_state',
                        'customer','supplier','activity_sector_ids/id','position_ids/id','function','title','active','invoice_warn','invoice_warn_msg','lang','activity_description',
                        'property_account_position_id/id','certificate_prefix']
        hfRPMain = open('0_oe5_res_partner_main.csv','w')
        csvRPMain = csv.writer(hfRPMain,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPMain.writerow(headers)
        #
        hfRP = open('0_oe5_res_partner.csv','w')
        csvRP = csv.writer(hfRP,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRP.writerow(headers)
        if TEST_DATA:
            partner_ids = pooler.get_pool(cr.dbname).get('res.partner').search(cr,uid,['|',('membership_state','in',['free','paid','invoiced']),('employee_nbr_total','>=',200)])
        else:
            partner_ids = pooler.get_pool(cr.dbname).get('res.partner').search(cr,uid,[])
        sentence = """SELECT distinct(partner_id) FROM membership_state_change"""
        cr.execute(sentence)
        res = cr.fetchall()
        for line in res:
            if line[0] not in partner_ids and line[0] not in unactive_used_partner_ids:
                unactive_used_partner_ids.append(line[0])
        if unactive_used_job_ids:
            obj_job = pooler.get_pool(cr.dbname).get('res.partner.job')
            unactive_jobs = obj_job.browse(cr,uid,unactive_used_job_ids)
            for unact_job in unactive_jobs:
                if unact_job.address_id and unact_job.address_id.id not in unactive_used_address_ids:
                    unactive_used_address_ids.append(unact_job.address_id.id)
                if unact_job.contact_id and unact_job.contact_id.id not in unactive_used_contact_ids:
                    unactive_used_contact_ids.append(unact_job.contact_id.id)
        if unactive_used_address_ids:
            obj_addr = pooler.get_pool(cr.dbname).get('res.partner.address')
            unactive_addrs = obj_addr.browse(cr,uid,unactive_used_address_ids)
            for addr in unactive_addrs:
                if addr.id in [18245,21138]:
                    print('lodomez ou damnet')
                if addr.partner_id and addr.partner_id.id not in unactive_used_partner_ids:
                    unactive_used_partner_ids.append(addr.partner_id.id)
        if unactive_used_partner_ids:
            partner_ids += unactive_used_partner_ids
        obj_partner = pooler.get_pool(cr.dbname).get('res.partner')
        obj_partner_title = pooler.get_pool(cr.dbname).get('res.partner.title')
        obj_account_journal = pooler.get_pool(cr.dbname).get('account.journal')
        obj_account_move = pooler.get_pool(cr.dbname).get('account.move')
        #
        purchase_journal_ids = obj_account_journal.search(cr,uid,[('type','=','purchase')])
        beginning_purchases = str(int(datetime.date.today().strftime('%Y'))-3)+'-01-01'
        before_supplier = 0
        after_supplier = 0
        #
        dAddressesID2NewPartnerKey = {}
        dContactID2JobsID = {}
        partnerNewKeys = []
        if partner_ids:
            index = 0
            size= 500
            while partner_ids[index:index+size]:
                partners = obj_partner.browse(cr,uid,partner_ids[index:index+size],{'lang':'fr_FR'})
                for partner in partners:
                    new_sequence = 0
                    record = []
                    partnerNewKeys.append('res_partner_'+str(partner.id))
                    record.append('res_partner_'+str(partner.id))
                    record.append('')
                    record.append(True)
                    record.append('company')
                    record.append('contact')
                    # search for default address
                    default_address = False
                    for address in partner.address:
                        if address.type == 'default':
                            default_address = address
                            break
                    if not default_address and partner.address:
                        default_address = partner.address[0]
                    if default_address:
                        dAddressesID2NewPartnerKey[default_address.id] = 'res_partner_'+str(partner.id)
                    # partner name
                    if default_address:
                        record.append(clean_string(get_partner_name(partner.name,default_address.name)).encode('utf-8'))
                    else:
                        record.append(clean_string(partner.name).encode('utf-8'))
                    record.append(partner.state_id and 'res_partner_state_'+str(partner.state_id.id) or '')
                    title_id = ''
                    if partner.title:
                        title_ids = obj_partner_title.search(cr,uid,[('shortcut','=',partner.title),('domain','=','partner')])
                        if title_ids:
                            title_id = 'res_partner_title_'+str(title_ids[0])
                    record.append(title_id)
                    # REMOVE CCILVN ET ODOO VAT NUMBER for tests
                    if partner.id not in [1,38702]:
                        record.append(partner.vat and clean_string(partner.vat) or '')
                    else:
                        record.append('')
                    record.append(partner.vat_subjected and True or False)
                    record.append((partner.employee_nbr_total and (partner.employee_nbr_total > 0)) and partner.employee_nbr_total or 0)
                    record.append('')
                    record.append(0)
                    # postal_code
                    if default_address:
                        if default_address.zip_id: ### always active in V5 => and default_address.zip_id.active: desactivated
                            record.append('res_partner_zip_'+str(default_address.zip_id.id))
                            record.append((default_address.zip_id.name or '').encode('utf-8'))
                            record.append((default_address.zip_id.city or '').encode('utf-8'))
                        else:
                            record.append('')
                            record.append('')
                            record.append('')
                        record.append(get_country_key(default_address.country_id and default_address.country_id.code or '','res.country'))
                        record.append((default_address.street or '').encode('utf-8'))
                        record.append((default_address.street2 or '').encode('utf-8'))
                        record.append(get_phone(default_address.phone or '',PHONE_COUNTRY_PREFIX).encode('utf-8'))
                        record.append(get_phone(default_address.fax or '',PHONE_COUNTRY_PREFIX).encode('utf-8'))
                        record.append(clean_string(default_address.email or '').encode('utf-8'))
                        record.append(clean_website(partner.website).encode('utf-8'))
                        record.append(default_address.notdelivered or '')
                    else:
                        record.append('')
                        record.append('')
                        record.append('')
                        record.append('')
                        record.append('')
                        record.append('')
                        record.append('')
                        record.append('')
                        record.append('')
                        record.append('')
                        record.append('')
                    # is_commissionner
                    record.append(False) # will be changed later
                    record.append(False) # will be changed later
                    # membership
                    if partner.refuse_membership:
                        record.append(partner.write_date[0:10] or datetime.date.today().strftime('%Y-%m-%d'))
                    else:
                        record.append('')
                    record.append('%.2f' % (partner.membership_amount or 0.0))
                    record.append(partner.read_before_next_membership_bill)
                    record.append((partner.membership_explanation or '').encode('utf-8'))
                    record.append(partner.free_member)
                    if partner.state_id.id != 1 or not partner.active:
                        record.append('none')
                    elif partner.free_member:
                        record.append('free')
                    elif partner.refuse_membership:
                        record.append('canceled')
                    elif partner.associate_member:
                        record.append('asso_'+partner.associate_member.membership_state)
                    else:
                        record.append(partner.membership_state)
                    record.append(partner.customer and partner.active and partner.state_id and partner.state_id.id == 1)
                    new_supplier_value = False
                    if partner.supplier:
                        before_supplier += 1
                        move_ids = obj_account_move.search(cr,uid,[('journal_id','in',purchase_journal_ids),('date','>=',beginning_purchases),('partner_id','=',partner.id)])
                        if move_ids:
                            new_supplier_value = True
                            after_supplier += 1
                    record.append(new_supplier_value)
                    (forcedAddressCodes,activity_sectors) = get_activsectors(partner,default_address,dCategID2SectCode,dCodeSect2ID) # for the main address, doesn't take forcedAddress into account
                    record.append(','.join(activity_sectors[0:3])) ## secteurs d'activités
                    record.append('') ## code fonctions
                    record.append('')
                    record.append('')
                    record.append(partner.active)
                    if partner.alert_explanation:
                        record.append('warning')
                        record.append(partner.alert_explanation.encode('utf-8'))
                    else:
                        record.append('no-message')
                        record.append('')
                    record.append(valid_lang(partner.lang))
                    # record the kept categories attached to this main partner
                    for categ_id in partner.category_id:
                        if categ_id.id in dKeptCategs.keys():
                            data_categ = dKeptCategs[categ_id.id]
                            if data_categ['partner_ids']:
                                data_categ['partner_ids'] += (',res_partner_'+str(partner.id))
                            else:
                                data_categ['partner_ids'] = 'res_partner_'+str(partner.id)
                            dKeptCategs[categ_id.id] = data_categ
                    # record the other informations in categs
                    if partner.alert_explanation and (u'LISTE ROUGE' in partner.alert_explanation):
                        data_categ = dKeptCategs[-1]
                        if data_categ['partner_ids']:
                            data_categ['partner_ids'] += (',res_partner_'+str(partner.id))
                        else:
                            data_categ['partner_ids'] = 'res_partner_'+str(partner.id)
                        dKeptCategs[-1] = data_categ
                    entreprise_familiale = False
                    if partner.answers_ids:
                        for answer in partner.answers_ids:
                            if answer.id == 134:
                                entreprise_familiale = True
                    if entreprise_familiale:
                        data_categ = dKeptCategs[-2]
                        if data_categ['partner_ids']:
                            data_categ['partner_ids'] += (',res_partner_'+str(partner.id))
                        else:
                            data_categ['partner_ids'] = 'res_partner_'+str(partner.id)
                        dKeptCategs[-2] = data_categ
                    record.append((partner.activity_description or '').encode('utf-8'))
                    fiscal_position_key = ''
                    if partner.property_account_position:
                        fiscal_position_key = 'l10n_be.1_fiscal_position_template_'+str(4-partner.property_account_position.id) # id = 1 => 3; id = 2 => 2
                    record.append(fiscal_position_key)
                    record.append((partner.certificate_prefix and partner.certificate_prefix or '').encode('utf-8'))
                    csvRPMain.writerow(record)
                    if default_address:
                        extract_contacts(partner,default_address,new_sequence,dAddressesID2NewPartnerKey,csvRP,dContactID2JobsID,partnerNewKeys,dCodePosition2ID,PHONE_COUNTRY_PREFIX,dKeptCategs)
                    # track_membership_logs of this partner
                    sentence = """SELECT id, active, billed_partner_id, date_from, free, refuse, state FROM membership_state_change WHERE partner_id = %i ORDER BY partner_id, date_from desc""" % partner.id
                    cr.execute(sentence)
                    res = cr.fetchall()
                    if res:
                        old_state = 'none'
                        for line in res:
                            new_state = (line[2] and 'asso_' or '') + line[6]
                            record = []
                            record.append('membership_state_change_'+str(line[0]))
                            record.append('res_partner_' +str(partner.id))
                            record.append(line[1])
                            record.append((partner.state_id and partner.state_id.name or '').encode('utf-8'))
                            record.append(line[2] and 'res_partner_' + str(line[2]) or '')
                            record.append(line[3] or '')
                            record.append(line[4])
                            record.append(line[5])
                            record.append(old_state)
                            record.append(new_state)
                            record.append(partner.employee_nbr_total or 0)
                            record.append(stoday)
                            csvCMLogs.writerow(record)
                            old_state = new_state
                            
                    ########################
                    # treat others addresses
                    ########################
                    for address in partner.address:
                        if not (default_address and address.id == default_address.id):
                            record = []
                            record.append('res_partner_address_'+str(address.id))
                            partnerNewKeys.append('res_partner_address_'+str(address.id))
                            record.append('res_partner_'+str(partner.id))
                            record.append(False)
                            record.append('person')
                            record.append((address.type in ['invoice','other']) and address.type or 'contact')
                            dAddressesID2NewPartnerKey[address.id] = 'res_partner_address_'+str(address.id)
                            # partner name
                            if address.name:
                                record.append(clean_string(get_partner_name(partner.name,address.name)).encode('utf-8'))
                            else:
                                record.append(clean_string(partner.name).encode('utf-8'))
                            record.append('')
                            record.append('')
                            record.append('')
                            record.append(True)
                            record.append(0)
                            record.append('')
                            new_sequence += 1
                            record.append(new_sequence)
                            # postal_code
                            if address.zip_id: ### always active in V5 => and address.zip_id.active: desactivated
                                record.append('res_partner_zip_'+str(address.zip_id.id))
                                record.append((address.zip_id.name or '').encode('utf-8'))
                                record.append((address.zip_id.city or '').encode('utf-8'))
                            else:
                                record.append('')
                                record.append('')
                                record.append('')
                            record.append(get_country_key(address.country_id and address.country_id.code or '','res.country'))
                            record.append((address.street or '').encode('utf-8'))
                            record.append((address.street2 or '').encode('utf-8'))
                            record.append(get_phone(address.phone or '',PHONE_COUNTRY_PREFIX).encode('utf-8'))
                            record.append(get_phone(address.fax or '',PHONE_COUNTRY_PREFIX).encode('utf-8'))
                            record.append(clean_string(address.email or '').encode('utf-8'))
                            record.append('')
                            record.append(address.notdelivered or '')
                            # is_commissionner
                            record.append(False)
                            record.append(False)
                            # membership
                            record.append('')
                            record.append('0.0')
                            record.append(False)
                            record.append(False)
                            record.append(False)
                            record.append('')
                            record.append(partner.customer)
                            record.append(new_supplier_value)
                            (forcedAddressCodes,activity_sectors) = get_activsectors(partner,default_address,dCategID2SectCode,dCodeSect2ID) # for the main address, doesn't take forcedAddress into account
                            if forcedAddressCodes:
                                record.append(','.join(activity_sectors[0:3])) ## secteurs d'activités
                            else:
                                record.append('')
                            record.append('') ## code fonctions
                            record.append('')
                            record.append('')
                            record.append(address.active)
                            record.append('no-message')
                            record.append('')
                            record.append(valid_lang(partner.lang))
                            record.append((address.activity_description or '').encode('utf-8'))
                            record.append('')
                            csvRP.writerow(record)
                            extract_contacts(partner,address,new_sequence,dAddressesID2NewPartnerKey,csvRP,dContactID2JobsID,partnerNewKeys,dCodePosition2ID,PHONE_COUNTRY_PREFIX,dKeptCategs)
                index += size

        # Associated Partners
        if TEST_DATA:
            partner_ids = pooler.get_pool(cr.dbname).get('res.partner').search(cr,uid,[('associate_member','!=',False),'|',('membership_state','in',['free','paid','invoiced']),('employee_nbr_total','>=',200)])
        else:
            partner_ids = pooler.get_pool(cr.dbname).get('res.partner').search(cr,uid,[('associate_member','!=',False),])
        hfRPAP = open('0_oe5_res_partner_associated_members.csv','w')
        csvRPAP = csv.writer(hfRPAP,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPAP.writerow(['id','associate_member/id'])
        if partner_ids:
            partners = obj_partner.browse(cr,uid,partner_ids)
            for partner in partners:
                sponsored_key = 'res_partner_'+str(partner.id)
                sponsor_key = 'res_partner_'+str(partner.associate_member.id)
                if sponsored_key in partnerNewKeys and sponsor_key in partnerNewKeys:
                    record = []
                    record.append(sponsored_key)
                    record.append(sponsor_key)
                    csvRPAP.writerow(record)
        ### Contacts and linked Contacts
        #
        # SELF SUFFICIENT CONTACTS
        #
        obj_contact = pooler.get_pool(cr.dbname).get('res.partner.contact')
        contact_ids = obj_contact.search(cr,uid,[('self_sufficent','=',True)])
        if unactive_used_contact_ids:
            contact_ids.extend(unactive_used_contact_ids)
        contacts = obj_contact.browse(cr,uid,contact_ids)
        for contact in contacts:
            kept_tag_ids = False
            for answer in contact.answers_ids:
                if answer.question_id and answer.question_id.id in CONTACT_USED_QUESTION_IDS:
                    kept_tag_ids = True
            if contact.id not in dContactID2JobsID.keys() and \
               (contact.email or contact.mobile or contact.website or contact.login_name or contact.password or \
               contact.badge_name or contact.badge_title or (contact.rdp_subscribe != 'default') or (contact.rdp_forced_area != 'default')or \
               contact.fse_nationality or contact.fse_studies or contact.fse_work_experience or contact.fse_work_status or \
               contact.fse_zip_id or contact.birthdate or contact.national_number or kept_tag_ids or contact.self_sufficent):
                contact.badge_name or contact.badge_title or (contact.rdp_subscribe != 'default') or (contact.rdp_forced_area != 'default') or \
                contact.fse_nationality or contact.fse_studies or contact.fse_work_experience or contact.fse_work_status or \
                contact.fse_zip_id or contact.birthdate or contact.national_number or kept_tag_ids
                record = []
                record.append('res_partner_contact_'+str(contact.id))
                record.append('')
                record.append(False)
                record.append('person')
                record.append('contact')
                # search for private address with a zip_id, phone and/or email
                private_address = False
                private_job = False
                for job in contact.job_ids:
                    if job.address_id and not job.address_id.partner_id:
                        if job.address_id.zip_id or job.address_id.phone or job.address_id.email:
                            private_address = job.address_id
                            private_job = job
                            break
                if private_address:
                    dAddressesID2NewPartnerKey[private_address.id] = 'res_partner_contact_'+str(contact.id)
                # partner name
                record.append(clean_string(contact.name+' '+(contact.first_name or '')).encode('utf-8'))
                record.append('res_partner_state_1')
                record.append('')
                record.append('')
                record.append(False)
                record.append(0)
                if contact.gender == "man":
                    record.append('male')
                elif contact.gender == "women":
                    record.append('female')
                else:
                    record.append('unspecified')
                record.append(0)
                # postal_code
                if private_address:
                    if private_address.zip_id: ### alwauys active in V5 => and default_address.zip_id.active: desactivated
                        record.append('res_partner_zip_'+str(private_address.zip_id.id))
                        record.append((private_address.zip_id.name or '').encode('utf-8'))
                        record.append((private_address.zip_id.city or '').encode('utf-8'))
                    else:
                        record.append('')
                        record.append('')
                        record.append('')
                    record.append(get_country_key(private_address.country_id and private_address.country_id.code or '','res.country'))
                    record.append((private_address.street or '').encode('utf-8'))
                    record.append((private_address.street2 or '').encode('utf-8'))
                    record.append(get_phone(private_address.phone or '',PHONE_COUNTRY_PREFIX).encode('utf-8'))
                    record.append(get_phone(private_address.fax or '',PHONE_COUNTRY_PREFIX).encode('utf-8'))
                    record.append(clean_string(private_address.email or '').encode('utf-8'))
                    record.append(clean_website(contact.website).encode('utf-8'))
                    record.append(private_address.notdelivered or '')
                else:
                    record.append('')
                    record.append('')
                    record.append('')
                    record.append('')
                    record.append('')
                    record.append('')
                    record.append('')
                    record.append('')
                    record.append(clean_string(contact.email or '').encode('utf-8'))
                    record.append(clean_website(contact.website or '').encode('utf-8'))
                    record.append('')
                # is_commissionner
                record.append(False) # will be changed later
                record.append(False) # will be changed later
                record.append('')
                record.append(0.0)
                record.append(False)
                record.append('')
                record.append(False)
                record.append('none')
                # customer, supplier
                record.append(False)
                record.append(False)
                record.append('')
                record.append('') ## code fonctions
                record.append('')
                record.append((contact.title or '').encode('utf-8'))
                record.append(contact.active)
                record.append('')
                record.append('')
                record.append(valid_lang(contact.lang_id.code))
                record.append('')
                record.append('')
                csvRP.writerow(record)
                if private_address and private_job:
                    if dContactID2JobsID.has_key(contact.id):
                        list_of_job_ids = dContactID2JobsID[contact.id]
                    else:
                        list_of_job_ids = []
                    list_of_job_ids.append('res_partner_contact_'+str(contact.id))
                    dContactID2JobsID[contact.id] = list_of_job_ids

        ### We did this after because we want to put a reference only to contact with multiple jobs saved
        #obj_contact = pooler.get_pool(cr.dbname).get('res.partner.contact')
        hfRPLC = open('0_oe5_res_partner_linked_contacts.csv','w')
        csvRPLC = csv.writer(hfRPLC,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPLC.writerow(['id','reference'])
        for (contact_id,list_of_job_ids) in dContactID2JobsID.items():
            if len(list_of_job_ids) > 1:
                #contact = obj_contact.browse(cr,uid,contact_id)
                for new_key in list_of_job_ids:
                    record = []
                    record.append(new_key)
                    record.append('contact_'+str(contact_id).rjust(6,'0'))
                    csvRPLC.writerow(record)

        ### Record the kept categories with the links to attached partners
        hfRPDCateg = open('0_oe5_res_partner_category_data.csv','w')
        csvRPDCateg = csv.writer(hfRPDCateg,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPDCateg.writerow(['id','name','partner_ids/id'])
        hfRPRCateg = open('0_oe5_res_partner_category_rel.csv','w')
        csvRPRCateg = csv.writer(hfRPRCateg,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
        csvRPRCateg.writerow(['id','parent_id/id'])
        for data_categ in dKeptCategs.values():
            record_data = []
            record_data.append(data_categ['id'])
            record_data.append(data_categ['name'].encode('utf-8'))
            record_data.append(data_categ['partner_ids'])
            csvRPDCateg.writerow(record_data)
            if data_categ['parent_id']:
                record_rel = []
                record_rel.append(data_categ['id'])
                record_rel.append(data_categ['parent_id'])
                csvRPRCateg.writerow(record_rel)

        # budgets 
        if data['form']['compta']:
            print('account.analytic')
            hfABPost = open('0_oe5_account_budget_post.csv','w')
            csvABPost = csv.writer(hfABPost,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
            csvABPost.writerow(['id','name','company_id/id','account_ids/id'])
            hfABPRel = open('0_oe5_account_budget_post_rel.csv','w')
            csvABPRel = csv.writer(hfABPRel,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
            csvABPRel.writerow(['id','parent_id/id'])
            #
            hfCBudget = open('0_oe5_crossovered_budget.csv','w')
            csvCBudget = csv.writer(hfCBudget,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
            csvCBudget.writerow(['id','name','company_id/id','user_id/id','date_from','date_to'])
            #
            hfCBLine = open('0_oe5_crossovered_budget_lines.csv','w')
            csvCBLine = csv.writer(hfCBLine,delimiter=',',quotechar='"',quoting=csv.QUOTE_NONNUMERIC,lineterminator='\n')
            csvCBLine.writerow(['id','name','analytic_account_id/id','date_from','date_to','crossovered_budget_id/id','general_budget_id/id','planned_amount'])
            #
            bacateg_ids = pooler.get_pool(cr.dbname).get('cci_budget.budget_account_category').search(cr,uid,[])
            bacategs = pooler.get_pool(cr.dbname).get('cci_budget.budget_account_category').browse(cr,uid,bacateg_ids)
            for category in bacategs:
                record = []
                record.append('cci_budget_budget_account_category_'+str(category.id))
                record.append(category.name.encode('utf-8'))
                record.append('base.main_company')
                record.append('')
                #csvABPost.writerow(record) # not now because account_ids is mandatory
            bagroup_ids = pooler.get_pool(cr.dbname).get('cci_budget.budget_account_group').search(cr,uid,[])
            bagroups = pooler.get_pool(cr.dbname).get('cci_budget.budget_account_group').browse(cr,uid,bagroup_ids)
            for group in bagroups:
                record = []
                record.append('cci_budget_budget_account_group_'+str(group.id))
                record.append(group.name.encode('utf-8'))
                record.append('base.main_company')
                account_ids = []
                for account in group.account_ids:
                    account_new_id = get_account_id_from_code(account.code)
                    if account_new_id:
                        account_ids.append(account_new_id)
                if account_ids:
                    record.append(','.join(account_ids))
                    csvABPost.writerow(record)
                    if group.category_id:
                        rel_record = []
                        rel_record.append('cci_budget_budget_account_group_'+str(group.id))
                        rel_record.append('cci_budget_budget_account_category_'+str(group.category_id.id))
                        csvABPRel.writerow(rel_record)
            # pour les dotations par période, nous allons globaliser les lignes qui concerne la même période et la même dotation
            # et dans le cas où la dotation est liée à un cci_budget_post lié à plusieurs comptes analytiques, nous allons forcer dans ce code le compte analytique à utiliser
            budget_ids = pooler.get_pool(cr.dbname).get('cci_budget.budget').search(cr,uid,[('state','!=','draft'),('fiscalyear_id.id','>=',13)])
            dbyp_ids = pooler.get_pool(cr.dbname).get('cci_budget.period_dotation').search(cr,uid,[('budget_id','in',budget_ids)])
            dbyps = pooler.get_pool(cr.dbname).get('cci_budget.period_dotation').browse(cr,uid,dbyp_ids)
            dotByPers = {}
            dotations = {}
            for dot_by_per in dbyps:
                key = (dot_by_per.dotation_id,dot_by_per.period_id)
                if key not in dotByPers.keys():
                    dotation_name = '%s %s %s %s' % (get_full_name_dotation(dot_by_per.dotation_id.post_id.department_id.name.strip()),
                                                     get_full_name_dotation(dot_by_per.dotation_id.post_id.name.strip()),
                                                     get_full_name_dotation(dot_by_per.dotation_id.account_id.cci_budget_group_id.category_id.name.strip()),
                                                     get_full_name_dotation(dot_by_per.dotation_id.account_id.cci_budget_group_id.name.strip()))
                    per_data = {'amount':0.0,
                                'date_from':dot_by_per.period_id.date_start,
                                'date_to':dot_by_per.period_id.date_stop,
                                'name':dotation_name + ' ' + dot_by_per.period_id.name,
                                'budget_id':dot_by_per.dotation_id.id,
                                'budget_name':dotation_name,
                                'analytic_account_ids':dot_by_per.dotation_id.post_id.analytic_account_ids or [],
                                'general_budget_id':'cci_budget_budget_account_group_'+str(dot_by_per.dotation_id.account_id.cci_budget_group_id.id),
                                'dotation_id':dot_by_per.dotation_id.id,
                                'id':dot_by_per.id,
                               }
                    if dot_by_per.dotation_id.id not in dotations.keys():
                        dot_data = {'id':dot_by_per.dotation_id.id,
                                    'name':dotation_name,
                                    'date_from':dot_by_per.period_id.date_start,
                                    'date_to':dot_by_per.period_id.date_stop,
                                   }
                    else:
                        dot_data = dotations[dot_by_per.dotation_id.id]
                    if dot_by_per.period_id.date_start <= dot_data['date_from']:
                        dot_data['date_from'] = dot_by_per.period_id.date_start
                    if dot_by_per.period_id.date_stop >= dot_data['date_to']:
                        dot_data['date_to'] = dot_by_per.period_id.date_stop
                    dotations[dot_by_per.dotation_id.id] = dot_data
                else:
                    per_data = dotByPers[key]
                per_data['amount'] += (dot_by_per.amount or 0.0)
                dotByPers[key] = per_data
            for (key,value) in dotations.items():
                record = []
                record.append('cci_budget_dotation_'+str(key))
                record.append(value['name'].encode('utf-8'))
                record.append('base.main_company')
                record.append('')
                record.append(value['date_from'])
                record.append(value['date_to'])
                csvCBudget.writerow(record)
            for (key,value) in dotByPers.items():
                if value['analytic_account_ids']:
                    default_analytic_account_id = value['analytic_account_ids'][0].id
                    if len(value['analytic_account_ids']) > 1:
                        found_pref = False
                        for prefered_def in [407,299,425,298,324,338,172,303]:
                            for aaccount in value['analytic_account_ids']:
                                if prefered_def == aaccount.id:
                                    default_analytic_account_id = prefered_def
                                    found_pref = True
                                    break
                            if found_pref:
                                break
                        if not found_pref:
                            print('not found pref : ' + ','.join(str(x) for x in value['analytic_account_ids']) + ' - dotation id : ' + str(value['dotation_id']) )
                            pass
                    for aaccount in value['analytic_account_ids']:
                        record = []
                        record.append('period_dotation_'+str(value['id']))
                        record.append(value['name'].encode('utf-8'))
                        record.append('aaccount_'+str(aaccount.id))
                        record.append(value['date_from'])
                        record.append(value['date_to'])
                        record.append('cci_budget_dotation_'+str(value['dotation_id']))
                        record.append(value['general_budget_id'])
                        if aaccount.id == default_analytic_account_id:
                            record.append(value['amount'])
                        else:
                            record.append(0.0)
                        csvCBLine.writerow(record)
                else:
                    print('no analytics - dotation id : ' + str(value['dotation_id']) )
                    pass
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','_Cancel'),('extract','Extract')]},
        },
        'extract': {
            'actions': [_extract],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
wizard_extract_odoo12('wizard_extract_odoo12')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
