# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
import pooler
from osv import fields
from osv import osv
from tools.translate import _

def today():
    return time.strftime('%Y-%m-%d')

form = """<?xml version="1.0"?>
<form string="Daily Operations">
    <field name="partner_id" colspan="4"/>
    <field name="day" colspan="4" width="600"/>
</form>"""

fields = {
    'partner_id': {'type':'many2one','relation':'res.partner','string':'Partner','required':True},
    'day': {'type':'date','string':'Day','required':True,'default': today()},
}

#msg_form = """<?xml version="1.0"?>
#<form string="Operations">
#     <field name="line_ids" colspan="4" nolabel="1" width="800" heigth="600"/>
#</form>"""
#
#msg_fields = {
#    'line_ids': {'string':'Operations', 'type':'type':'one2many','relation':'cci_missions.operations'},
#}

class wizard_get_daily_ops(wizard.interface):

    def _get_ops(self,cr,uid,data,context):
        operation_ids = []
        obj_operation = pooler.get_pool(cr.dbname).get('cci_missions.operation')
        # extract certificates for this date and partner
        selection = """SELECT dos.name, dtype.name, cert.total
                        FROM cci_missions_dossier as dos, cci_missions_certificate as cert, cci_missions_dossier_type as dtype
                        WHERE dos.date = '%s' AND order_partner_id = %s AND cert.dossier_id = dos.id AND dos.type_id = dtype.id
                    """ % (data['form']['day'],str(data['form']['partner_id']))
        cr.execute(selection)
        res = cr.fetchall()
        if res:
            for line in res:
                new_record={}
                new_record['type'] = line[1]
                new_record['name'] = line[0]
                new_record['amount'] = line[2]
                operation_ids.append( obj_operation.create(cr,uid,new_record) )
        # extract legalizations for this date and partner
        selection = """SELECT dos.name, dtype.name, leg.total
                        FROM cci_missions_dossier as dos, cci_missions_legalization as leg, cci_missions_dossier_type as dtype
                        WHERE dos.date = '%s' AND order_partner_id = %s AND leg.dossier_id = dos.id AND dos.type_id = dtype.id
                    """ % (data['form']['day'],str(data['form']['partner_id']))
        cr.execute(selection)
        res = cr.fetchall()
        if res:
            for line in res:
                new_record={}
                new_record['type'] = line[1]
                new_record['name'] = line[0]
                new_record['amount'] = line[2]
                operation_ids.append( obj_operation.create(cr,uid,new_record) )
        # extract embassy folder returned this date for the selected partner
        selection = """SELECT crmcase.name, site.name, emb.invoice_total
                        FROM cci_missions_embassy_folder as emb, cci_missions_site as site, crm_case as crmcase
                        WHERE emb.return_date = '%s' AND crmcase.partner_id = %s AND emb.crm_case_id = crmcase.id AND emb.site_id = site.id
                    """ % (data['form']['day'],str(data['form']['partner_id']))
        cr.execute(selection)
        res = cr.fetchall()
        if res:
            for line in res:
                new_record={}
                new_record['type'] = _('Embassy Folder') + ' ' + line[1]
                new_record['name'] = line[0]
                new_record['amount'] = line[2]
                operation_ids.append( obj_operation.create(cr,uid,new_record) )
        # extract ata carnet for this date and partner
        selection = """SELECT ata.name, dtype.name, ata.total
                        FROM cci_missions_ata_carnet as ata, cci_missions_dossier_type as dtype
                        WHERE ata.creation_date = '%s' AND ata.partner_id = %s AND ata.type_id = dtype.id
                    """ % (data['form']['day'],str(data['form']['partner_id']))
        cr.execute(selection)
        res = cr.fetchall()
        if res:
            for line in res:
                new_record={}
                new_record['type'] = line[1]
                new_record['name'] = line[0]
                new_record['amount'] = line[2]
                operation_ids.append( obj_operation.create(cr,uid,new_record) )
        ids_in_str = '[' + ','.join(map(str,operation_ids)) + ']'
        result = {
            'name': _('Daily Ops'),
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'cci_missions.operation',
            'domain': "[('id','in',%s)]" % ids_in_str,
            'type': 'ir.actions.act_window'
        }
        return result
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('search','Search')]},
        },
        'search': {
            'actions': [],
            'result': {'type': 'action', 'action':_get_ops, 'state':'end'}
        },
    }

wizard_get_daily_ops('cci_mission_extend.get_daily_ops')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

