# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
#         1.1 Philmer Adding the new node <Exportal>0|1</Exportal>
import wizard
import time
import datetime
import tools
import pooler
import base64
from osv import fields
from osv import osv
from lxml import objectify        
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="type_id" colspan="4"/>
    <field name="input" colspan="4" width="600"/>
</form>"""

fields = {
    'type_id': {'type':'many2one','relation':'cci_missions.dossier_type','domain':"[('section','=','certificate')]",'string':'Certificate Type','required':True},
    'input': {'type':'binary','string':'Digichambers file','required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="Importation result" colspan="4"/>
     <field name="msg" colspan="4" nolabel="1" width="800" heigth="600"/>
</form>"""

msg_fields = {
    'msg': {'string':'File imported', 'type':'text', 'readonly':True},
}

class wizard_import_digital(wizard.interface):

    new_nums = []
    
    def _import_data(self,cr,uid,data,context):
        inputfile = data['form']['input']
        inputdata = base64.decodestring(inputfile)
        EEC_COUNTRIES = {
             'EUROPEAN UNION(SPAIN)':'ES',
             'EUROPEAN UNION(BELGIUM)':'BE',
             'EUROPEAN UNION(GERMANY)':'DE',
             'EUROPEAN UNION(FRANCE)':'FR',
             'EUROPEAN UNION(PORTUGAL)':'PT',
             'EUROPEAN UNION(GREECE)':'GR',
             'EUROPEAN UNION(POLAND)':'PL',
             'EUROPEAN UNION(ITALY)':'IT',
             'EUROPEAN UNION(CZECH REPUBLIC)':'CZ',
             'EUROPEAN UNION(NETHERLANDS)':'NL',
             'EUROPEAN UNION(FINLAND)':'FI',
             'EUROPEAN UNION(UNITED KINGDOM)':'GB',
             'EUROPEAN UNION(ESTONIA)':'EE',
             'EUROPEAN UNION(HUNGARY)':'HU',
             'EUROPEAN UNION(IRELAND)':'IE',
             'EUROPEAN UNION(LATVIA)':'LV',
             'EUROPEAN UNION(DENMARK)':'DK',
             'EUROPEAN UNION(CYPRUS)':'CY',
             'EUROPEAN UNION(AUSTRIA)':'AT',
             'EUROPEAN UNION(BULGARIA)':'BG',
             'EUROPEAN UNION(CROATIA)':'HR',
             'EUROPEAN UNION(SWEDEN)':'SE',
             'EUROPEAN UNION(SLOVENIA)':'SI',
             'EUROPEAN UNION(SLOVAKIA)':'SK',
             'EUROPEAN UNION(ROMANIA)':'RO',
             'EUROPEAN UNION(LITUANIA)':'LT',
             'EUROPEAN UNION(LUXEMBOURG)':'LU',
             'EUROPEAN UNION(MALTA)':'MT',
        }
        # store the results
        rejected = 0
        imported = 0
        attached_visas = 0
        errors = []
        created_codes = []
        # objects necessary for the import
        parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
        parameter = parameter_obj.get_value_from_names(cr,uid,['DigitalChamberNumber'])
        exportal_product_id = parameter_obj.get_value_from_names(cr,uid,['ExportalProductID'])['ExportalProductID']
        obj_partner = pooler.get_pool(cr.dbname).get('res.partner')
        obj_certificate = pooler.get_pool(cr.dbname).get('cci_missions.certificate')
        obj_leg = pooler.get_pool(cr.dbname).get('cci_missions.legalization')
        obj_country = pooler.get_pool(cr.dbname).get('cci.country')
        obj_custom = pooler.get_pool(cr.dbname).get('cci_missions.custom_code')
        obj_zip = pooler.get_pool(cr.dbname).get('res.partner.zip')
        obj_type = pooler.get_pool(cr.dbname).get('cci_missions.dossier_type')
        obj_product_line = pooler.get_pool(cr.dbname).get('product.lines')
        obj_product = pooler.get_pool(cr.dbname).get('product.product')
        # decoding the xml file
        root = objectify.fromstring(inputdata.replace(' xmlns="http://schemas.fccib.be/doc/CO_10"',''))
        for cert in root.CO:
            internal_id = int(cert.ID)
            #try:
            if True:
                if str(cert.ChamberNumber) == parameter['DigitalChamberNumber']:
                    # searching partner by VAT Number
                    custVAT = str(cert.CompanyVAT).replace(' ','').replace('.','')
                    if (len(custVAT) > 2) and (custVAT[0:2] in ('SE','LU')):
                        pass
                    else:
                        if len(custVAT)==9:
                            custVAT = 'BE0' + custVAT
                        elif len(custVAT)==10:
                            custVAT = 'BE' + custVAT
                    partner_ids = obj_partner.search(cr,uid,[('vat','=',custVAT),('active','=',True)])
                    if len(partner_ids) == 1:
                        partner_id = partner_ids[0]
                        found_partner = obj_partner.read(cr,uid,partner_id,['name','membership_state','certificate_prefix'])
                        # extract others mandatory fields
                        accepteddatetime = str(cert.AcceptedDateTime)
                        cert_date = accepteddatetime[6:10]+'-'+accepteddatetime[3:5]+'-'+accepteddatetime[0:2]
                        #
                        content = cert.XML.CORequest.COForm.COFormContent
                        #
                        destination = str(content.Customs.DestinationCountry)
                        
                        if EEC_COUNTRIES.has_key(destination):
                            country_ids = obj_country.search(cr,uid,[('code','=',EEC_COUNTRIES[destination])])
                        else:
                            destination_code = destination[destination.rfind('(')+1:destination.rfind(')')]
                            country_ids = obj_country.search(cr,uid,[('code','=',destination_code),('valid4certificate','=',True)])
                        if len(country_ids) == 1:
                            destination_id = country_ids[0]
                            #
                            digital_number = str(cert.CONumber).replace(' ','')[1:]
                            cert_ids = obj_certificate.search(cr,uid,[('state','in',('draft','invoiced')),('digital_number','=',digital_number)])
                            if len(cert_ids) > 0:
                                rejected += 1
                                errors.append( 'InternalID : %s - Already used digital number : %s' % (str(internal_id),digital_number) )
                            else:
                                todo_field = ''
                                goods_desc = content.Shipment.ShipmentDescription.pyval
                                goods_value = float(content.Customs.ValueInEuro)
                                if goods_value < 0.001:
                                    goods_value = 0.01
                                    todo_field += 'ValeurBiens:0 -'
                                goods_desc = goods_desc.replace('\n',' - ').replace('\r',' - ')
                                #
                                lRejected = False
                                origins = []
                                for country_element in content.Origins.CountryOfOriginCollection.Country:
                                    country_name = str(country_element)
                                    if country_name == 'EUROPEAN UNION':
                                        country_code = 'EEC'
                                    else:
                                        if EEC_COUNTRIES.has_key(country_name):
                                            country_code = EEC_COUNTRIES[country_name]
                                        else:
                                            country_code = country_name[country_name.rfind('(')+1:country_name.rfind(')')]
                                    country_ids = obj_country.search(cr,uid,[('code','=',country_code),('valid4certificate','=',True)])
                                    if len(country_ids) == 1:
                                        origins.append(country_ids[0])
                                    else:
                                        lRejected = True
                                        rejected += 1
                                        errors.append( 'InternalID : %s - Unknown Origin : %s' % (str(internal_id),country_name) )
                                if len(origins) == 0 and not lRejected:
                                    rejected += 1
                                    errors.append( 'InternalID : %s - No Origin' % (str(internal_id)) )
                                    lRejected = True
                                if not lRejected:
                                    custom_codes = []
                                    for code_element in content.Customs.CustomCodeCollection.CustomCode:
                                        code = str(code_element).rjust(8,'0')
                                        code_ids = obj_custom.search(cr,uid,[('name','=',code)])
                                        if len(code_ids) == 0:
                                            new_id = obj_custom.create(cr,uid,{'name':code,'meaning':'NR','official':False})
                                            created_codes.append( code )
                                            code_ids.append(new_id)
                                        custom_codes.append(code_ids[0])
                                    if len(custom_codes)==0:
                                        rejected += 1
                                        errors.append( 'InternalID : %s - No Custom Codes' % (str(internal_id)) )
                                        lRejected = True
                                    customerRef = ''
                                    if not lRejected:
                                        # others non mandatory fields
                                        copies = int(cert.Duplicates)
                                        customerRef = unicode(cert.CustomerRef)
                                        if customerRef:
                                            while '  ' in customerRef:
                                                customerRef = customerRef.replace('  ',' ')
                                        if hasattr(cert,'Exportal'):
                                            info_exportal = cert.Exportal
                                        else:
                                            info_exportal = 0
                                        if hasattr(content,'Applicant'):
                                            asker_name = content.Applicant.AddressName
                                            asker_street = content.Applicant.AddressStreetAndNumber
                                            zip_code = ''
                                            city_name = ''
                                            if hasattr(content.Applicant,'AddressPostalCode'):
                                                if str(type(content.Applicant.AddressPostalCode)) == "<type 'lxml.objectify.IntElement'>":
                                                    zip_code = str(int(content.Applicant.AddressPostalCode))
                                                else:
                                                    zip_code = str(content.Applicant.AddressPostalCode)
                                            if hasattr(content.Applicant,'AddressCity'):
                                                if str(type(content.Applicant.AddressCity)) == "<type 'lxml.objectify.IntElement'>":
                                                    city_name = str(int(content.Applicant.AddressCity))
                                                else:
                                                    if type(content.Applicant.AddressCity)== "<type 'lxml.objectify.StringElement'>":
                                                        city_name = str(content.Applicant.AddressCity)
                                                    else:
                                                        city_name = unicode(content.Applicant.AddressCity)
                                            asker_city = zip_code + ' ' + city_name
                                            if zip_code[0:3] in ('BE ','BE-'):
                                                zip_code = zip_code[3:]
                                            elif zip_code[0:2] in ('B-','B ','BE'):
                                                zip_code = zip_code[2:]
                                            elif zip_code[0:1] == 'B':
                                                zip_code = zip_code[1:]
                                            zip_id = 0
                                        else:
                                            asker_name = content.Consignor.AddressName
                                            asker_street = content.Consignor.AddressStreetAndNumber
                                            zip_code = ''
                                            city_name = ''
                                            if hasattr(content.Consignor,'AddressPostalCode'):
                                                if str(type(content.Consignor.AddressPostalCode)) == "<type 'lxml.objectify.IntElement'>":
                                                    zip_code = str(int(content.Consignor.AddressPostalCode))
                                                else:
                                                    zip_code = str(content.Consignor.AddressPostalCode)
                                            if hasattr(content.Consignor,'AddressCity'):
                                                if str(type(content.Consignor.AddressCity)) == "<type 'lxml.objectify.IntElement'>":
                                                    city_name = str(int(content.Consignor.AddressCity))
                                                else:
                                                    if type(content.Consignor.AddressCity)== "<type 'lxml.objectify.StringElement'>":
                                                        city_name = str(content.Consignor.AddressCity)
                                                    else:
                                                        city_name = unicode(content.Consignor.AddressCity)
                                            asker_city = zip_code + ' ' + city_name
                                            if zip_code[0:3] in ('BE ','BE-'):
                                                zip_code = zip_code[3:]
                                            elif zip_code[0:2] in ('B-','B ','BE'):
                                                zip_code = zip_code[2:]
                                            elif zip_code[0:1] == 'B':
                                                zip_code = zip_code[1:]
                                            zip_id = 0
                                        # try to find the id of the zip code
                                        # if not found, mark it in 'TO-DO' field
                                        zip_ids = obj_zip.search(cr,uid,[('name','=',zip_code)])
                                        if zip_ids >= 1:
                                            zips = obj_zip.read(cr,uid,zip_ids,['id','name','city','other_names'])
                                            for czip in zips:
                                                if czip['city'].upper() == city_name.upper():
                                                    zip_id = czip['id']
                                                else:
                                                    if czip['other_names'] and ( city_name.upper() in czip['other_names'] ):
                                                        zip_id = czip['id']
                                            if not zip_id:
                                                todo_field += 'CodePostal:'+zip_code+' '+city_name + ' -'
                                        else:
                                            todo_field += 'CodePostal:'+zip_code+' '+city_name + ' -'
                                        # try to add it to the certificates table
                                        certificate_data = {}
                                        certificate_data['type_id'] = data['form']['type_id']
                                        certificate_data['date'] = cert_date
                                        certificate_data['order_partner_id'] = partner_id
                                        certificate_data['asker_name'] = asker_name
                                        certificate_data['asker_address'] = asker_street
                                        if zip_id > 0:
                                            certificate_data['asker_zip_id'] = zip_id
                                        certificate_data['sender_name'] = content.Consignor.AddressName
                                        certificate_data['state'] = 'draft'
                                        certificate_data['goods'] = goods_desc
                                        certificate_data['goods_value'] = goods_value
                                        certificate_data['destination_id'] = destination_id
                                        certificate_data['quantity_copies'] = copies
                                        certificate_data['quantity_original'] = 1
                                        certificate_data['customs_ids'] = [(6,0,custom_codes)]
                                        certificate_data['origin_ids'] = [(6,0,origins)]
                                        certificate_data['digital_number'] = digital_number
                                        certificate_data['customer_ref'] = customerRef
                                        certificate_data['exportal'] = info_exportal
                                        if todo_field:
                                            certificate_data['todo'] = todo_field[0:-2]
                                        # try to find attachments
                                        visas = []
                                        if hasattr(cert.ReviewedAttachments,'Attachment'):
                                            type_code = ''
                                            origs = 0
                                            copies = 0
                                            type_id = False
                                            for attach in cert.ReviewedAttachments.Attachment:
                                                # 2014-08-05 Philmer create associated legalization rather than todo field
                                                # let the todo field in place some days for validation purposes
                                                todo_field += attach.Type + ' (' + str(attach.Number) + ') -'
                                                type_ids = obj_type.search(cr,uid,[('digital_ref','=',attach.Type)])
                                                if type_ids and len(type_ids) == 1:
                                                    type_id = type_ids[0]
                                                    found_type = obj_type.read(cr,uid,type_id,['code'])
                                                    type_code = found_type['code']
                                                    origs = int(attach.Number)
                                                    if origs <= 0:
                                                        origs = 1
                                                    leg_data = {}
                                                    leg_data['type_id'] = type_id
                                                    leg_data['date'] = cert_date
                                                    leg_data['order_partner_id'] = partner_id
                                                    leg_data['asker_name'] = asker_name
                                                    leg_data['sender_name'] = content.Consignor.AddressName
                                                    leg_data['state'] = 'draft'
                                                    leg_data['goods_value'] = goods_value
                                                    leg_data['quantity_copies'] = copies
                                                    leg_data['quantity_original'] = origs
                                                    leg_data['digital_number'] = 'L' + digital_number
                                                    leg_data['customer_ref'] = type_code+'/'+customerRef
                                                    leg_data['goods'] = goods_desc
                                                    leg_data['destination_id'] = destination_id
                                                    leg_data['member_price'] = ( found_partner['membership_state'] in ['free','invoiced','paid'] )
                                                    visas.append(leg_data)
                                        new_id = obj_certificate.create(cr,uid,certificate_data)
                                        # next, no more necessary, because the addition of the prefix occurs in all cases, not only in case of importing
                                        #if new_id and found_partner['certificate_prefix']:
                                        #    cert = obj_certificate.read(cr,uid,new_id,['text_on_invoice'])
                                        #    obj_certificate.write(cr,uid,[new_id,],{'text_on_invoice':found_partner['certificate_prefix'].strip()+' '+(cert['text_on_invoice'] or '')})
                                        for visa in visas:
                                            visa['certificate_id'] = int(new_id)
                                            obj_leg.create(cr,uid,visa)
                                            attached_visas += 1
                                        if info_exportal:
                                            new_certificate = obj_certificate.browse(cr,uid,new_id)
                                            product_line_data = {}
                                            price_unit = uos_id = prod_name = data_partner = False
                                            data_product = obj_product.browse(cr,uid,exportal_product_id)
                                            price = obj_product.price_get(cr,uid,[exportal_product_id])
                                            sale_taxes = []
                                            if data_product.taxes_id:
                                                x = map(lambda x:sale_taxes.append(x.id),data_product.taxes_id)
                                            product_line_data['uos_id'] = data_product.uom_id.id
                                            product_line_data['price_unit'] = price[exportal_product_id]
                                            product_line_data['name'] = data_product.name
                                            product_line_data['taxes_id'] = [(6,0,sale_taxes)]
                                            product_line_data['dossier_product_line_id'] = new_certificate.dossier_id.id
                                            product_line_data['product_id'] = exportal_product_id
                                            new_pl_id = obj_product_line.create(cr,uid,product_line_data)
                                        self.new_nums.append(digital_number)
                                        # after the create, we add the customerref to the text on invoice
                                        if customerRef:
                                            newly_added = obj_certificate.read(cr,uid,[new_id],['id','text_on_invoice'])[0]
                                            obj_certificate.write(cr,uid,[new_id],{'text_on_invoice': customerRef + ' ' + (newly_added['text_on_invoice'] or '')})
                                        # TODO V 7.0 : when create if 'text_on_invoice' not empty, completing with number before already existing text
                                        # so we don't need to work on two steps, in this wizard but also manually
                                        imported += 1
                        else:
                            rejected += 1
                            errors.append( 'InternalID : %s - Unknown Destination : \'%s\'' % (str(internal_id),destination) )
                    else:
                        rejected += 1
                        errors.append( 'InternalID : %s - Unknown VAT Number : \'%s\'' % (str(internal_id),custVAT) )
                else:
                    rejected += 1
                    errors.append( 'InternalID : %s - Wrong ChamberNumber : \'%s\'' % (str(internal_id),str(cert.ChamberNumber)) )
            #except Exception, msg_error:
            #    rejected += 1
            #    print Exception
            #    print msg_error
            #    errors.append( 'InternalID : %s - GENERAL UNDEFINED ERROR IN XML FILE : \'%s\'' % (str(internal_id),str(msg_error)) )
        if len(created_codes)>0:
            errors.append('-')
            errors.append('Created Customs Code(s) : ' + ','.join(created_codes) )
        # give the result to the user
        data['form']['msg']='Number of imported digital certificates : %s\nAttached Visas : %s\nNumber of rejected certificates : %s\nReasons :\n%s' % (str(imported),str(attached_visas),str(rejected),'\n'.join(errors))
        return data['form']
    def _open_window_results(self, cr, uid, data, context):
        result = {
            'name': _('Added Certificates'),
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'cci_missions.certificate',
            'domain': "[('digital_number','in', ['" + "','".join(self.new_nums) + "'])]",
            'context': {},
            'type': 'ir.actions.act_window'
        }
        return result
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('import','Import File')]},
        },
        #'import': {
        #    'actions': [_import_data],
        #    'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        #},
        'import': {
            'actions': [_import_data],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Close'),('show','Show Result')]}
        },
        'show': {
            'actions': [],
            'result': {'type': 'action', 'action':_open_window_results, 'state':'end'}
        },
    }

wizard_import_digital('cci_mission_extend.import_digital')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

