# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
# Created to export also the 250 first caracters of 'comments' fields in Excel format
import wizard
import time
import datetime
#import re
import tools
import pooler
import base64
from pyExcelerator import *
import cci_newsletter
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="source_id" colspan="4" width="600"/>
</form>"""

fields = {
    'source_id': {'string': 'Source', 'type':'many2one','relation': 'cci_newsletter.source','help':'Let this field empty to extract ALL sources'},
   }

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="subscribers.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'subscribers.xls':{'string': 'Prepared file',
        'type': 'binary',
        'readonly': True,},
}

class wizard_extract_subscriber(wizard.interface):

    def _get_file(self,cr,uid,data,context):
        obj_subscriber = pooler.get_pool(cr.dbname).get('cci_newsletter.subscriber')

        # select all subscribers based or not on source
        if data['form']['source_id']:
            sub_ids = obj_subscriber.search(cr,uid,[('source_id','=',data['form']['source_id'][0])])
        else:
            sub_ids = obj_subscriber.search(cr,uid,[])
        if sub_ids:
            subscribers = obj_subscriber.read(cr,uid,sub_ids,['id','internal_id','source_id','name','first_name','forced_area','email','company_name','login_name','password','token','comments','expire'])
        else:
            subscribers = []

        wb1 = Workbook()
        ws1 = wb1.add_sheet('Inscrits')
        ws1.write(0,0,'id')
        ws1.write(0,1,'internal_id')
        ws1.write(0,2,'source')
        ws1.write(0,3,'name')
        ws1.write(0,4,'first_name')
        ws1.write(0,5,'forced_area')
        ws1.write(0,6,'email')
        ws1.write(0,7,'company_name')
        ws1.write(0,8,'login_name')
        ws1.write(0,9,'password')
        ws1.write(0,10,'token')
        ws1.write(0,11,'comments [250 carac]')
        ws1.write(0,12,'expire')
        dAreas = {}
        for area in cci_newsletter.cci_newsletter.AREAS:
            dAreas[area[0]] = area[1]
        line = 1
        for sub in subscribers:
            ws1.write(line,0,sub['id'])
            ws1.write(line,1,sub['internal_id'])
            ws1.write(line,2,sub['source_id'] and sub['source_id'][1] or '' )
            ws1.write(line,3,sub['name'] or '' )
            ws1.write(line,4,sub['first_name'] or '' )
            ws1.write(line,5,sub['forced_area'] and dAreas[sub['forced_area']].decode('utf-8') or '' )
            ws1.write(line,6,sub['email'] or '' )
            ws1.write(line,7,sub['company_name'] or '' )
            ws1.write(line,8,sub['login_name'] or '' )
            ws1.write(line,9,sub['password'] or '' )
            ws1.write(line,10,sub['token'] or '')
            ws1.write(line,11,(sub['comments'] or '')[:250])
            ws1.write(line,12,sub['expire'] and (sub['expire'][8:10]+'/'+sub['expire'][5:7]+'/'+sub['expire'][0:4]) or '')
            line += 1
        wb1.save('subscribers.xls')
        result_file = open('subscribers.xls','rb').read()

        # give the result tos the user
        data['form']['msg']=_('Save the File with '".xls"' extension.')
        data['form']['subscribers.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('getfile','Get Excel File')]},
        },
        'getfile': {
            'actions': [_get_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

wizard_extract_subscriber('cci_newsletter.extract_subscribers')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

