# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import pooler
import datetime
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Update Site Internet">
    <field name="connection_id" colspan="4" width="600"/>
    <field name="connection2_id" colspan="4" width="600"/>
    <field name="ftp_sending" colspan="4"/>
    <field name="login_send" colspan="4"/>
    <field name="create_new_login" colspan="4"/>
    <field name="include_prospects" colspan="4"/>
    <field name="include_all_others" colspan="4"/>
</form>"""

fields = {
    'connection_id':{'string':'Main FTP Connection', 'type':'many2one', 'relation': 'ftp_connection'},
    'connection2_id':{'string':'Alter Ego Connection', 'type':'many2one', 'relation': 'ftp_connection'},
    'ftp_sending':{'string':'Sending via FTP', 'type':'boolean'},
    'login_send':{'string':'Sending waitiong new login', 'type':'boolean'},
    'create_new_login':{'string':'Create New Login', 'type':'boolean'},
    'include_prospects':{'string':'Include Prospects', 'type':'boolean'},
    'include_all_others':{'string':'Include all Others eMails', 'type':'boolean'},
}

final_form = """<?xml version="1.0"?>
<form string="Results">
    <field name="final_text" colspan="4" nolabel="1" width="600"/>
    <field name="final_count"/>
</form>"""

final_fields = {
    'final_text': {'string':'Changes', 'type':'text','readonly':True,'value':'-','size':10000},
    'final_count' : {'string':'Count','type':'integer','readonly':True,'value':-1}
}

class send_site_update(wizard.interface):
 
    def _extract_data(self, cr, uid, data, context):
        # use shared method
        cci_newsletter_subscriber_obj = pooler.get_pool(cr.dbname).get('cci_newsletter.subscriber')
        connection_csv = None
        connection_ae = None
        ftp_connection_obj = pooler.get_pool(cr.dbname).get('ftp_connection')
        if data['form']['connection_id']:
            code_csv = ftp_connection_obj.read(cr,uid,data['form']['connection_id'],['internal_code'])
        if data['form']['connection2_id']:
            code_ae = ftp_connection_obj.read(cr,uid,data['form']['connection2_id'],['internal_code'])
        (result_text,result_count) = cci_newsletter_subscriber_obj.extract_data(cr,uid,code_csv['internal_code'],code_ae['internal_code'],data['form']['ftp_sending'],data['form']['login_send'],data['form']['create_new_login'],data['form']['include_prospects'],data['form']['include_all_others'])
        # give the result to the user
        data['form']['final_text'] = result_text
        data['form']['final_count'] = result_count
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('extract','Extract')]}
        },
        'extract' : {
            'actions': [_extract_data],
            'result': {'type':'form', 'arch':final_form, 'fields':final_fields, 'state':[('end','Close')]}
        }
    }
send_site_update("send_site_update")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

