# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
# Version 5.0.1 : Philmer
from osv import fields, osv

class project_work(osv.osv):
    _inherit = 'project.task.work'
    _columns = {
        'active': fields.boolean('Active'),
    }
    _defaults = {
        'active' : lambda *a : True,
    }
project_work()

class task(osv.osv):
    _inherit = "project.task"
    _columns = {
        'direct_costs':fields.integer('Direct Costs (in Euros)'),
        'added_value_cci':fields.selection([('high','High'),('normal','Normal'),('low','Low'),('none','None')],'Added Value for CCI'),
        'added_value_customer':fields.selection([('high','High'),('normal','Normal'),('low','Low'),('none','None')],'Added Value for Customers'),
        'added_value_explanation':fields.text('Explanation Added Value(s)'),
        'migration_pov':fields.selection([('before','Before!'),('current','During, in free time'),('during','During migration, needed to complete'),('after','After...')],'Migration PoV'), ### migration point of view : in regard of Odoo migration where locating this task
    }
    _defaults = {
        'added_value_cci': lambda *a: 'none',
        'added_value_customer': lambda *a: 'none',
        'migration_pov': lambda *a: 'after',
    }
task()

class project_requirement(osv.osv):
    _name = "project.requirement"
    _description = "Requirement"
    _columns = {
        'name':fields.char('Name',size=100,required=True),
        'description':fields.text('Description',required=True),
        'modules_list':fields.char('Modules',size=250,help=u'Liste des modules implémentant cette fonctionnalité dans V5; séparés par des \',\'.'),
        'domains':fields.char('Domaines',size=250,help=u'Liste des domaines pour lesquels cette fonctionalité est nécessaire'),
        'certified':fields.char('Modules/Fonctionnalités certifiés',size=60,help=u'Oui/Non/Mixte/...autres'),
        'validation_date':fields.date('Validation'),
        'validation_user_id':fields.many2one('res.users','Validated by'),
        'concerned_user_ids':fields.many2many('res.users','requirement_user_rel','requirement_id','user_id','Concerned Users'),
        'tobedone_by': fields.selection([('default',u'A déterminer'),('odoo','Odoo - Certification'),('devodoo','Odoo - To Dev',),('ccilvn','CCILVN'),('base','De Base'),('oca','OCA'),('none','Personne - on laisse tomber'),('later','Later - To do after the migration')],'To be done by'),
        'lines_count':fields.integer('Lines'),
        'cost':fields.float('Coût'),
        'treeorder': fields.char('Ordre/Structure',size=250,help='Sous la forme 001.005.002.015'),
        'active': fields.boolean('Active'),
    }
    _defaults = {
        'active' : lambda *a : True,
        'tobedone_by': lambda *a: 'default',
    }
    #_order = 'treeorder' #### NO; so the default order is by ID and this is usefull to print them by ID; if we want to classify it by treeorder, we have just to click on the column
project_requirement()
