# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from report import report_sxw

class requirement_details(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(requirement_details, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'show_hours': self._show_hours,
            'french_date_only': self._french_date_only,
        })
    def _show_hours(self,floating_value):
        hours,minutes = divmod(floating_value, 1)
        return '%02d:%02d' % (int(hours),int(round(minutes*60,0)))
    def _french_date_only(self,datetime):
        if datetime and len(datetime) > 9:
            return datetime[8:10]+'/'+datetime[5:7]+'/'+datetime[0:4]
        else:
            return False
report_sxw.report_sxw('report.cci_packnet_requirement_details','project.requirement','addons/cci_packnet/report/requirement_details.rml',parser=requirement_details)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
