# -*- encoding: utf-8 -*-
import time
from report import report_sxw

class cci_packnet_requirement_hierarchy(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(cci_packnet_requirement_hierarchy, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'show_hours': self._show_hours,
            'french_date_only': self._french_date_only,
            'structured_hierarchy': self._structured_hierarchy,
        })
    def _show_hours(self,floating_value):
        hours,minutes = divmod(floating_value, 1)
        return '%02d:%02d' % (int(hours),int(round(minutes*60,0)))
    def _french_date_only(self,datetime):
        if datetime and len(datetime) > 9:
            return datetime[8:10]+'/'+datetime[5:7]+'/'+datetime[0:4]
        else:
            return False
    def _structured_hierarchy(self,treeorder):
        cleaned = treeorder.strip()
        while cleaned[-4:] == '.000':
            cleaned = cleaned[:-4]
        points = cleaned.count('.')
        result = ('__' * points) + treeorder.strip()
        return result
report_sxw.report_sxw('report.cci_packnet_requirement_hierarchy','project.requirement','addons/cci_packnet/report/requirement_hierarchy.rml',parser=cci_packnet_requirement_hierarchy)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
