# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import pooler
import time
from report import report_sxw

class cci_packnet_works_landscape(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(cci_packnet_works_landscape, self).__init__(cr, uid, name, context=context)
        self.localcontext.update( {
            'time': time,
            'sum_hours': self._sum_hours,
            'show_hours': self._show_hours,
        })
    def _sum_hours(self,data,objects):
        result = 0.0
        for work in objects:
            result += work.hours
        return self._show_hours(result)
    def _show_hours(self,floating_value):
        hours,minutes = divmod(floating_value, 1)
        return '%02d:%02d' % (int(hours),int(round(minutes*60,0)))
report_sxw.report_sxw('report.cci_packnet_works_landscape',
                      'project.task.work',
                      'addons/cci_packnet/report/works_landscape.rml',
                      parser=cci_packnet_works_landscape,
                      header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

