# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import base64
import time
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Extract works">
    <field name="project_id" colspan="4" width="600"/>
    <field name="user_id" colspan="4"/>
    <field name="from"/>
    <field name="to"/>
</form>"""

fields = {
    'project_id': {'string':'Project', 'type':'many2one', 'relation':'project.project'},
    'user_id': {'string':'User', 'type':'many2one', 'relation':'res.users'},
    'from': {'string':'From', 'type':'date','required':True},
    'to': {'string':'To', 'type':'date','required':True},
}

class extract_works(wizard.interface):
    def _extract_works(self,cr,uid,data,context):
        if data['form']['from'] and data['form']['to']:
            selection = [('date','>=',data['form']['from']),('date','<=',data['form']['to'])]
        else:
            selection = []
        if data['form']['project_id']:
            # extract all ids of project_id and sub-projects
            obj_project = pooler.get_pool(cr.dbname).get('project.project')
            old_len = 0
            project_ids = [ data['form']['project_id'] ]
            while len(project_ids) > old_len:
                new_ids = project_ids[old_len:] # ids of projects added last time
                old_len = len(project_ids) # the new frontier ...
                new_projects = obj_project.read(cr,uid,new_ids,['child_id'])
                for project in new_projects:
                    if project['child_id']:
                        project_ids.extend(project['child_id'])
            if project_ids:
                task_ids = pooler.get_pool(cr.dbname).get('project.task').search(cr,uid,[('project_id','in',project_ids)])
                selection.append( ('task_id','in',task_ids) )
            else:
                selection.append( ('task_id','in',[]) )
        if data['form']['user_id']:
            selection.append( ('user_id','=',data['form']['user_id']) )
        pool_obj = pooler.get_pool(cr.dbname)
        work_ids = pool_obj.get('project.task.work').search(cr,uid,selection)
        values = {
            'domain': [('id', 'in', work_ids)],
            'name': 'Works',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'project.task.work',
            'context': {},
            'type': 'ir.actions.act_window',
        }
        return values

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('extract','Extract')]},
        },
        'extract': {
            'actions': [],
            'result': {'type': 'action','action': _extract_works,'state': 'end'},
        },
    }
extract_works('cci_packnet.extract_works')
