# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2008 CCI Connect ASBL. (http://www.cciconnect.be) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
from osv import fields, osv

class cci_value(osv.osv):
    _name = 'cci_parameters.cci_value'
    #_description = """Parameters for customising the app"""
    _columns = {
        'name':fields.char('Name',size=64,required=True),
        'description':fields.text('Description'),
        'type':fields.selection([('char','Char'),('text','Text or HTML'),('int','Integer'),('float','Float'),('exp','Python Expression')],'Type',required=True),
        'value':fields.text('value'),
    }
    def get_value(self,cr,uid,ids):
        res = False
        if ids:
            obj_value = self.pool.get('cci_parameters.cci_value')
            objs = obj_value.browse(cr,uid,ids)
            res = {}
            for obj in objs:
                if obj.type in ['char','text']:
                    res[obj.id] = obj.value
                elif obj.type in ['int','float','exp']:
                    try:
                        res[obj.id] = eval(obj.value)
                    except Exception, error:
                        res[obj.id] = 'error : ' + str(error)
        return res
    def get_value_from_names(self,cr,uid,names):
        res = False
        if names:
            obj_value = self.pool.get('cci_parameters.cci_value')
            obj_ids = obj_value.search(cr,uid,[('name','in',names)])
            objs = obj_value.browse(cr,uid,obj_ids)
            res = {}
            for obj in objs:
                if obj.type in ['char','text']:
                    res[obj.name] = obj.value or ''
                elif obj.type in ['int','float','exp']:
                    try:
                        res[obj.name] = eval(obj.value)
                    except Exception, error:
                        res[obj.name] = 'error : ' + str(error)
        return res
cci_value()

