# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import pooler

form = '''<?xml version="1.0"?>
<form string="Search for Functions without Codes" >
    <field name="member_select" colspan="4" width="600" />
    <field name="email_select" colspan="4"/>
    <field name="limit"/>
</form>'''

fields = {
    'member_select':{'string':'Membership','type':'selection','selection':[('members','Only Members'),('nonmembers','Non-members'),('all','Members and/or non-members')],'default':'members'},
    'email_select':{'string':'EMail','type':'selection','selection':[('with','Only if email address'),('all','with or without email address')],'default':'with'},
    'limit':{'string':'Maximum','type':'integer','default':500},
}

class search_no_function_codes(wizard.interface):
    def _select_jobs(self, cr, uid, data, context):
        obj_job = pooler.get_pool(cr.dbname).get('res.partner.job')
        selection = """SELECT rpj.id FROM res_partner_job as rpj, res_partner_contact as rpc WHERE rpj.active AND rpc.active AND rpj.contact_id = rpc.id AND (length(rpj.function_label) > 0 AND rpj.function_label IS NOT NULL) AND (length(rpj.function_code_label) = 0 OR rpj.function_code_label IS NULL) %s %s %s"""
        if data['form']['member_select'] == 'members':
            selection1 = """AND rpj.address_id in (SELECT rpa.id FROM res_partner as rp, res_partner_address as rpa WHERE rp.active AND rpa.active AND rpa.partner_id = rp.id AND rp.membership_state in ('free','invoiced','paid'))"""
        elif data['form']['member_select'] == 'nonmembers':
            selection1 = """AND rpj.address_id in (SELECT rpa.id FROM res_partner as rp, res_partner_address as rpa WHERE rp.active AND rpa.active AND rpa.partner_id = rp.id AND rp.membership_state not in ('free','invoiced','paid'))"""
        else:
            selection1 = ''
        if data['form']['email_select'] == 'with':
            selection2 = """AND rpj.id in (SELECT rpj.id FROM res_partner_job as rpj, res_partner_contact as rpc WHERE rpj.active AND rpc.active AND rpj.contact_id = rpc.id AND (rpj.email ilike '%@%' OR rpc.email ilike '%@%'))"""
        else:
            selection2 = ''
        selection3 = 'LIMIT %i' % data['form']['limit']
        sentence = selection % (selection1,selection2,selection3)
        cr.execute(sentence)
        res = cr.fetchall()
        job_ids = [x[0] for x in res]
        values = {
            'domain': [('id', 'in', job_ids)],
            'name': 'Jobs to complete',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'res.partner.job',
            'context': {},
            'type': 'ir.actions.act_window',
        }
        return values

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-cancel'),('search','Search','gtk-find')]}
        },
        'search': {
            'actions': [],
            'result': {'type': 'action','action': _select_jobs,'state': 'end'},
        },
    }
search_no_function_codes("search_no_function_codes")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

