# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
import wizard
import netsvc
import pooler
import pymysql
import base64
from pyExcelerator import *
from osv import fields, osv
import csv

init_form = """<?xml version="1.0"?>
<form string="Export list of stand with special Data" height="400">
    <field name="edition" width="600"/>
    <newline/>
    <field name="only_special"/>
</form>
"""
init_fields = {
    'edition': {'string':u'Edition', 'type':'integer'},
    'only_special': {'string':u'Only Specials', 'type':'boolean','default':False},
}

form = """<?xml version="1.0"?>
<form string="Excel File Created">
    <field name="stands_popup.xls"/>
</form>
"""

fields = {
    'stands_popup.xls':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class export_control(wizard.interface):

    def _export_excel(self, cr, uid, data, context):
        pool_obj = pooler.get_pool(cr.dbname)
        wb1 = Workbook()
        ws1 = wb1.add_sheet('Stands')
        ws1.write(0,0,'Date : ' + datetime.datetime.now().strftime('%d/%m/%Y %H:%M:%S'))
        ws1.write(1,0,'Edition: '+str(data['form']['edition']))
        ws1.write(2,0,'Selection : '+( data['form']['only_special'] and 'only specials' or 'all' ))
        ws1.write(3,0,'Special')
        ws1.write(3,1,'ID')
        ws1.write(3,2,'Stand Type')
        ws1.write(3,3,'Partner ID')
        ws1.write(3,4,'Partner Name')
        ws1.write(3,5,'Stand Name')
        ws1.write(3,6,'Partner_VAT')
        ws1.write(3,7,'Order Name')
        ws1.write(3,8,'Order eMail')
        ws1.write(3,9,'Stand Responsible Name')
        ws1.write(3,10,'Stand Responsible eMail')
        ws1.write(3,11,'Material Name')
        ws1.write(3,12,'Material eMail')
        ws1.write(3,13,'Price')
        ws1.write(3,14,'Count as')
        ws1.write(3,15,'Night Supp')
        ws1.write(3,16,'Night Price')
        ws1.write(3,17,'Exhibitor Supp')
        ws1.write(3,18,'Exhibitor Price')
        ws1.write(3,19,'Guest Supp')
        ws1.write(3,20,'Guest Price')
        ws1.write(3,21,'Confirmation')
        ws1.write(3,22,'Invoice')
        ws1.write(3,23,'Comments')
        ws1.write(3,24,'Stand ID on platform')
        ws1.write(3,25,'Other IDs')
        ws1.write(3,26,'Invoice Status')
        ws1.write(3,27,'Membership state')
        ws1.write(3,28,'Province')
        ws1.write(3,29,'Taille')
        xl_line = 4
        obj_stand = pool_obj.get('cci.popup.stand')
        stand_ids = obj_stand.search(cr,uid,[('edition','=',data['form']['edition'])])
        if stand_ids:
            stands = obj_stand.browse(cr,uid,stand_ids)
            for stand in stands:
                special = False
                if stand.name or stand.comments or stand.other_partner_ids or (stand.count_value != 1):
                    special = True
                if special or (not data['form']['only_special']):
                    province = ''
                    taille = ''
                    if stand.partner_id:
                        for addr in stand.partner_id.address:
                            if addr.type == 'default':
                                if addr.zip_id:
                                    if addr.zip_id.name[0] == '4':
                                        province = 'liege'
                                    elif addr.zip_id.name[0] == '5':
                                        province = 'namur'
                                    else:
                                        province = 'autre'
                        if stand.partner_id.employee_nbr_total and stand.partner_id.employee_nbr_total <= 9:
                            taille = '0-9'
                        elif stand.partner_id.employee_nbr_total and (stand.partner_id.employee_nbr_total >= 10) and (stand.partner_id.employee_nbr_total <= 49):
                            taille = '10-49'
                        elif stand.partner_id.employee_nbr_total and (stand.partner_id.employee_nbr_total >= 50):
                            taille = '50+'
                    ws1.write(xl_line,0,special and 'XXX' or '')
                    ws1.write(xl_line,1,stand.id)
                    ws1.write(xl_line,2,stand.type_id.name)
                    ws1.write(xl_line,3,stand.partner_id and stand.partner_id.id or 0)
                    ws1.write(xl_line,4,stand.partner_id and stand.partner_id.name or '')
                    ws1.write(xl_line,5,stand.name or '')
                    ws1.write(xl_line,6,stand.partner_id and stand.partner_id.vat or '')
                    ws1.write(xl_line,7,stand.order_contact_id and (stand.order_contact_id.name + ' ' + (stand.order_contact_id.first_name or '')).strip() or '')
                    ws1.write(xl_line,8,stand.email_order or '')
                    ws1.write(xl_line,9,stand.stand_contact_id and (stand.stand_contact_id.name + ' ' + (stand.stand_contact_id.first_name or '')).strip() or '')
                    ws1.write(xl_line,10,stand.email_stand or '')
                    ws1.write(xl_line,11,stand.material_contact_id and (stand.material_contact_id.name + ' ' + (stand.material_contact_id.first_name or '')).strip() or '')
                    ws1.write(xl_line,12,stand.email_material or '')
                    ws1.write(xl_line,13,stand.final_stand_price or 0.0)
                    ws1.write(xl_line,14,stand.count_value)
                    ws1.write(xl_line,15,stand.order_night or 0)
                    ws1.write(xl_line,16,stand.price_night or 0.0)
                    ws1.write(xl_line,17,stand.order_add_exhibitor)
                    ws1.write(xl_line,18,stand.price_add_exhibitor)
                    ws1.write(xl_line,19,stand.order_add_guest)
                    ws1.write(xl_line,20,stand.price_add_guest)
                    ws1.write(xl_line,21,stand.confirm_sending and stand.confirm_sending or '')
                    ws1.write(xl_line,22,stand.invoice_id and stand.invoice_id.number or '')
                    if stand.comments and len(stand.comments) > 250:
                        ws1.write(xl_line,23,stand.comments[0:250]+'...')
                    else:
                        ws1.write(xl_line,23,stand.comments or '')
                    ws1.write(xl_line,24,str(stand.web_id) or '')
                    ws1.write(xl_line,25,stand.other_partner_ids or '')
                    ws1.write(xl_line,26,stand.invoice_id and stand.invoice_id.state or '')
                    ws1.write(xl_line,27,stand.partner_id and stand.partner_id.membership_state or '')
                    ws1.write(xl_line,28,province)
                    ws1.write(xl_line,29,taille)
                    xl_line += 1
            wb1.save('stands_popup.xls')
            result_file = open('stands_popup.xls','rb').read()

            # give the result tos the user
            data['form']['stands_popup.xls']=base64.encodestring(result_file)
        return data['form']
        
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':init_form, 'fields':init_fields, 'state':[('end','Cancel'),('getfile','Get Excel File')]},
        },
        'getfile': {
            'actions': [_export_excel],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Close')]}
        },
    }

export_control("export_control")

