# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import datetime
import wizard
import netsvc
import pooler
import base64
from osv import fields, osv
import csv

init_form = """<?xml version="1.0"?>
<form string="Export JSON File for Website" height="400">
    <field name="edition" width="600"/>
    <newline/>
    <field name="source"/>
</form>
"""
init_fields = {
    'edition': {'string':u'Edition', 'type':'integer','required':True},
    'source': {'string':'Source','type':'selection','selection':[('ERP','ERP'),('platform','Plate-Forme Popup')],'required':True},
}

form = """<?xml version="1.0"?>
<form string="JSON File for Popup Website">
    <field name="exposants.json"/>
</form>
"""

fields = {
    'exposants.json':{'string': 'Prepared file','type': 'binary','readonly': True,},
}

class export_stands4site(wizard.interface):
    def _create_json_file(self, cr, uid, data, context):
        pool_obj = pooler.get_pool(cr.dbname)
        stand_obj = pool_obj.get('cci.popup.stand')
        json_string = stand_obj._json_on_site(cr,uid,data['form']['source'],data['form']['edition'])
        if json_string:
            data['form']['exposants.json']=base64.encodestring(json_string)
        return data['form']

    states = {
        'init' : {
               'actions' : [],
               'result': {'type': 'form', 'arch': init_form, 'fields': init_fields, 'state':[('end','Cancel'),('export','Export')]}
            },
        'export' : {
               'actions' : [_create_json_file],
               'result': {'type': 'form', 'arch': form, 'fields': fields, 'state':[('end','Close')]}
            },

    }

export_stands4site("export_stands4site")

