# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import netsvc
import pooler
from tools.translate import _
from osv import fields, osv
import datetime

form = """<?xml version="1.0"?>
<form string="Create invoice(s)">
    <field name="inv_created"/>
    <newline />
    <field name="inv_rejected"/>
    <newline />
    <field name="inv_rej_reason" width="400"/>

</form>
"""

fields = {
        'inv_created': {'string':'Invoice(s) Created', 'type':'char', 'readonly':True},
        'inv_rejected': {'string':'Invoice(s) Rejected', 'type':'char', 'readonly':True},
        'inv_rej_reason': {'string':'Error Messages', 'type':'text', 'readonly':True},
          }

def _create_invoices(self, cr, uid, data, context):
    pool_obj = pooler.get_pool(cr.dbname)
    obj_stand = pool_obj.get('cci.popup.stand')
    data_stand = obj_stand.browse(cr,uid,data['ids'])
    obj_lines=pool_obj.get('account.invoice.line')
    inv_create = 0
    inv_reject = 0
    inv_rej_reason = ""
    list_inv = []

    for stand in data_stand:
        context.update({'pricelist': stand.partner_id.property_product_pricelist.id})
        line_list = []
        value = []
        address_contact = False
        address_invoice = False
        create_ids = []
        if stand.invoice_id:
            inv_reject = inv_reject + 1
            inv_rej_reason += "ID "+str(stand.id)+_(": Already Has an Invoice Linked \n")
            continue

        if stand.final_stand_price >= -0.01 and stand.final_stand_price <= 0.01 and (stand.order_night == 0 or (stand.price_night >= -0.01 and stand.price_night <= 0.01)) and (stand.order_add_exhibitor == 0 or (stand.price_add_exhibitor >= -0.01 and stand.price_add_exhibitor <= 0.01)) and (stand.order_add_guest == 0 or (stand.price_add_guest >= -0.01 and stand.price_add_guest <= 0.01)):
            inv_reject = inv_reject + 1
            inv_rej_reason += "ID "+str(stand.id)+_(": Nothing to Invoice \n")
            continue
        
        context.update({'date':datetime.datetime.now().strftime('%Y-%m-%d')})
        fpos = stand.partner_id.property_account_position and stand.partner_id.property_account_position.id or False

        # there is something to invoice => always add a 'stand' line, event with 0.0 as price
        val = obj_lines.product_id_change(cr, uid, [], stand.type_id.product_id.id,uom =False, partner_id=stand.partner_id.id, fposition_id=fpos)
        tmp = pool_obj.get('account.analytic.default').search(cr, uid, [('product_id','=',stand.type_id.product_id.id)])
        analytic_default_id = tmp and tmp[0] or False
        if analytic_default_id:
            analytics_id = pool_obj.get('account.analytic.default').browse(cr, uid, analytic_default_id).analytics_id.id
            val['value'].update({'analytics_id': analytics_id})
        val['value'].update({'product_id': stand.type_id.product_id.id})
        val['value'].update({'quantity': 1.0})
        val['value'].update({'price_unit':stand.final_stand_price})
        val['value'].update({'sequence': 1})
        sale_taxes = []
        if stand.type_id.product_id.taxes_id:
            map(lambda x:sale_taxes.append(x.id),stand.type_id.product_id.taxes_id)
        val['value'].update({'invoice_line_tax_id': [(6,0,sale_taxes)]})
        note_on_invoice = (val['value']['note'] or '')
        if u'{PERSO order_contact_cpn}' in note_on_invoice:
            if stand.order_contact_id:
                contact_name = (u'La commande a été effectuée par %s %s %s' % (stand.order_contact_id.title or '',stand.order_contact_id.first_name or '',stand.order_contact_id.name)).strip()
            else:
                contact_name  = ''
            val['value'].update({'note':note_on_invoice.replace(u'{PERSO order_contact_cpn}',contact_name)})
        if u'{PERSO order_contact_cnp}' in note_on_invoice:
            if stand.order_contact_id:
                contact_name = (u'La commande a été effectuée par %s %s %s' % (stand.order_contact_id.title or '',stand.order_contact_id.name,stand.order_contact_id.first_name or '')).strip()
            else:
                contact_name  = ''
            val['value'].update({'note':note_on_invoice.replace(u'{PERSO order_contact_cnp}',contact_name)})
        if stand.order_night <= 0:
            val['value'].update({'note':val['value']['note'] + u'\n.\nAttention, vous n\'avez pas encore commandé vos entrées pour la seconde partie de la journée se rapportant à la "Musical Business Party" (facultative).\n.\nCette soirée s\'inscrit dans le prolongement de l\'événement de networking (14H00 à 20H00) et son accès est payant pour tous (exposants et visiteurs) au prix unique de 20 €/pp.'})
        value.append(val)
        if stand.order_night > 0: # and stand.price_night >= 0.01: even if the price is 'free'
            val = obj_lines.product_id_change(cr, uid, [], stand.type_id.night_product_id.id,uom =False, partner_id=stand.partner_id.id, fposition_id=fpos)
            tmp = pool_obj.get('account.analytic.default').search(cr, uid, [('product_id','=',stand.type_id.night_product_id.id)])
            analytic_default_id = tmp and tmp[0] or False
            if analytic_default_id:
                analytics_id = pool_obj.get('account.analytic.default').browse(cr, uid, analytic_default_id).analytics_id.id
                val['value'].update({'analytics_id': analytics_id})
            val['value'].update({'product_id': stand.type_id.night_product_id.id})
            val['value'].update({'quantity': stand.order_night })
            val['value'].update({'price_unit':stand.price_night })
            val['value'].update({'sequence': 2})
            sale_taxes = []
            if stand.type_id.night_product_id.taxes_id:
                map(lambda x:sale_taxes.append(x.id),stand.type_id.night_product_id.taxes_id)
            val['value'].update({'invoice_line_tax_id': [(6,0,sale_taxes)]})
            value.append(val)

        if stand.order_add_exhibitor > 0: # and stand.price_add_exhibitor >= 0.01:
            val = obj_lines.product_id_change(cr, uid, [], stand.type_id.exhibitor_product_id.id,uom =False, partner_id=stand.partner_id.id, fposition_id=fpos)
            tmp = pool_obj.get('account.analytic.default').search(cr, uid, [('product_id','=',stand.type_id.exhibitor_product_id.id)])
            analytic_default_id = tmp and tmp[0] or False
            if analytic_default_id:
                analytics_id = pool_obj.get('account.analytic.default').browse(cr, uid, analytic_default_id).analytics_id.id
                val['value'].update({'analytics_id': analytics_id})
            val['value'].update({'product_id': stand.type_id.exhibitor_product_id.id})
            val['value'].update({'quantity': stand.order_add_exhibitor })
            val['value'].update({'price_unit':stand.price_add_exhibitor })
            val['value'].update({'sequence': 3})
            sale_taxes = []
            if stand.type_id.night_product_id.taxes_id:
                map(lambda x:sale_taxes.append(x.id),stand.type_id.exhibitor_product_id.taxes_id)
            val['value'].update({'invoice_line_tax_id': [(6,0,sale_taxes)]})
            value.append(val)

        if stand.order_add_guest > 0: # and stand.price_add_guest >= 0.01:
            val = obj_lines.product_id_change(cr, uid, [], stand.type_id.guest_product_id.id,uom =False, partner_id=stand.partner_id.id, fposition_id=fpos)
            tmp = pool_obj.get('account.analytic.default').search(cr, uid, [('product_id','=',stand.type_id.guest_product_id.id)])
            analytic_default_id = tmp and tmp[0] or False
            if analytic_default_id:
                analytics_id = pool_obj.get('account.analytic.default').browse(cr, uid, analytic_default_id).analytics_id.id
                val['value'].update({'analytics_id': analytics_id})
            val['value'].update({'product_id': stand.type_id.guest_product_id.id})
            val['value'].update({'quantity': stand.order_add_guest })
            val['value'].update({'price_unit':stand.price_add_guest })
            val['value'].update({'sequence': 4})
            sale_taxes = []
            if stand.type_id.night_product_id.taxes_id:
                map(lambda x:sale_taxes.append(x.id),stand.type_id.guest_product_id.taxes_id)
            val['value'].update({'invoice_line_tax_id': [(6,0,sale_taxes)]})
            value.append(val)

        for add in stand.partner_id.address:
            if add.type == 'contact':
                address_contact = add.id
            if add.type == 'invoice':
                address_invoice = add.id
            if (not address_contact) and (add.type == 'default'):
                address_contact = add.id
            if (not address_invoice) and (add.type == 'default'):
                address_invoice = add.id

        if not address_invoice:
            inv_reject = inv_reject + 1
            inv_rej_reason += "ID "+str(stand.id)+_(": No Partner Address Defined on Partner \n")
            continue
        inv_create = inv_create + 1
        for val in value:
            if val['value']['quantity']>0.00:
                inv_id = pool_obj.get('account.invoice.line').create(cr, uid, val['value'])
                create_ids.append(inv_id)
        inv = {
                'origin': stand.name,
                'type': 'out_invoice',
                'reference': False,
                'account_id': stand.partner_id.property_account_receivable.id,
                'partner_id': stand.partner_id.id,
                'address_invoice_id': address_invoice,
                'address_contact_id': address_contact,
                'invoice_line': [(6,0,create_ids)],
                'currency_id' : stand.partner_id.property_product_pricelist.currency_id.id,
                'comment': '',
                'payment_term': stand.partner_id.property_payment_term.id,
                'fiscal_position': stand.partner_id.property_account_position.id,
                'domiciled': bool(stand.partner_id.domiciliation),
            }

        inv_obj = pool_obj.get('account.invoice')
        inv_id = inv_obj.create(cr, uid, inv)
        inv_obj.button_reset_taxes(cr, uid, [inv_id], context)
        list_inv.append(inv_id)
        obj_stand.write(cr, uid,[stand.id], {'invoice_id' : inv_id})

    return {'inv_created' : str(inv_create),'inv_rejected' : str(inv_reject)  ,'invoice_ids':  list_inv , 'inv_rej_reason': inv_rej_reason }

class invoice_stand(wizard.interface):

    def _open_invoice(self, cr, uid, data, context):
        pool_obj = pooler.get_pool(cr.dbname)
        model_data_ids = pool_obj.get('ir.model.data').search(cr,uid,[('model','=','ir.ui.view'),('name','=','invoice_form')])
        resource_id = pool_obj.get('ir.model.data').read(cr,uid,model_data_ids,fields=['res_id'])[0]['res_id']

        return {
            'domain': "[('id','in', ["+','.join(map(str,data['form']['invoice_ids']))+"])]",
            'name': 'Invoices',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'account.invoice',
            'views': [(False,'tree'),(resource_id,'form')],
            'context': "{'type':'out_invoice'}",
            'type': 'ir.actions.act_window'
        }

    states = {
        'init' : {
            'actions' : [_create_invoices],
            'result' : {'type' : 'form','arch' : form, 'fields' : fields, 'state' : [('end','Ok'),('open','Open Invoice')]}
                  },
        'open': {
            'actions': [],
            'result': {'type':'action', 'action':_open_invoice, 'state':'end'}
                }
             }
invoice_stand("invoice_stand")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

