# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import netsvc
import pooler
from tools.translate import _
from osv import fields, osv
import datetime
import re
import tools

def_form = """<?xml version="1.0"?>
<form string="Send Confirm(s) Options">
    <field name="email_from" colspan="4" width="600"/>
    <field name="template_id" colspan="4"/>
</form>
"""

def_fields = {
    'email_from': {'string':'EMail From','type':'char','size':254,'required':True},
    'template_id': {'string':'Template','type':'many2one','relation':'cci_email_template','required':True,'domain':"[('name','ilike','popup')]"},
}

form = """<?xml version="1.0"?>
<form string="Send Confirm(s)">
    <field name="mail_created"/>
    <newline />
    <field name="mail_rejected"/>
    <newline />
    <field name="mail_rej_reason" width="400"/>
</form>
"""

fields = {
        'mail_created': {'string':'Mails Sended', 'type':'char', 'readonly':True},
        'mail_rejected': {'string':'Mail(s) Rejected', 'type':'char', 'readonly':True},
        'mail_rej_reason': {'string':'Error Messages', 'type':'text', 'readonly':True},
          }
          
def personalize_texts(cr,uid,stand,tags,texts):
    full_texts = []
    partner_obj = pooler.get_pool(cr.dbname).get('res.partner')
    for text in texts:
        for tag in tags.findall(text):
            tag_name = str(tag)
            print tag_name
            if tag_name == '{PERSO stand_type}':
                text = text.replace(tag_name,stand.type_id.name.strip())
            if tag_name == '{PERSO order_contact_cnp}':
                if stand.order_contact_id:
                    text = text.replace(tag_name,( ( stand.order_contact_id.title or '' ) + ' ' + stand.order_contact_id.name + ' ' + ( stand.order_contact_id.first_name or '' ) ).strip())
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            elif tag_name == '{PERSO order_contact_cpn}':
                if stand.order_contact_id:
                    text = text.replace(tag_name,( ( stand.order_contact_id.title or '' ) + ' ' + ( stand.order_contact_id.first_name or '' ) + ' ' + stand.order_contact_id.name ).strip().replace('  ',' '))
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            elif tag_name == '{PERSO order_contact_pn}':
                if stand.order_contact_id:
                    text = text.replace(tag_name,( ( stand.order_contact_id.first_name or '' ) + ' ' + stand.order_contact_id.name ).strip())
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            elif tag_name == '{PERSO order_contact_np}':
                if stand.order_contact_id:
                    text = text.replace(tag_name,( stand.order_contact_id.name + ' ' + ( stand.order_contact_id.first_name or '' ) ).strip())
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            if tag_name == '{PERSO stand_contact_cnp}':
                if stand.stand_contact_id:
                    text = text.replace(tag_name,( ( stand.stand_contact_id.title or '' ) + ' ' + stand.stand_contact_id.name + ' ' + ( stand.stand_contact_id.first_name or '' ) ).strip())
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            elif tag_name == '{PERSO stand_contact_cpn}':
                if stand.stand_contact_id:
                    text = text.replace(tag_name,( ( stand.stand_contact_id.title or '' ) + ' ' + ( stand.stand_contact_id.first_name or '' ) + ' ' + stand.stand_contact_id.name ).strip().replace('  ',' '))
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            elif tag_name == '{PERSO stand_contact_pn}':
                if stand.stand_contact_id:
                    text = text.replace(tag_name,( ( stand.stand_contact_id.first_name or '' ) + ' ' + stand.stand_contact_id.name ).strip())
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            elif tag_name == '{PERSO stand_contact_np}':
                if stand.stand_contact_id:
                    text = text.replace(tag_name,( stand.stand_contact_id.name + ' ' + ( stand.stand_contact_id.first_name or '' ) ).strip())
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            if tag_name == '{PERSO material_contact_cnp}':
                if stand.material_contact_id:
                    text = text.replace(tag_name,( ( stand.material_contact_id.title or '' ) + ' ' + stand.material_contact_id.name + ' ' + ( stand.material_contact_id.first_name or '' ) ).strip())
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            elif tag_name == '{PERSO material_contact_cpn}':
                if stand.material_contact_id:
                    text = text.replace(tag_name,( ( stand.material_contact_id.title or '' ) + ' ' + ( stand.material_contact_id.first_name or '' ) + ' ' + stand.material_contact_id.name ).strip().replace('  ',' '))
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            elif tag_name == '{PERSO material_contact_pn}':
                if stand.material_contact_id:
                    text = text.replace(tag_name,( ( stand.material_contact_id.first_name or '' ) + ' ' + stand.material_contact_id.name ).strip())
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            elif tag_name == '{PERSO material_contact_np}':
                if stand.material_contact_id:
                    text = text.replace(tag_name,( stand.material_contact_id.name + ' ' + ( stand.material_contact_id.first_name or '' ) ).strip())
                else:
                    text = text.replace(tag_name,u'A nous préciser s.v.p.')
            elif tag_name == '{PERSO order_price}':
                price = '%.2f' % stand.final_stand_price
                if price[-3:] == '.00':
                    price = price[0:-3]
                text = text.replace(tag_name,price)
            elif tag_name == '{PERSO order_night}':
                text = text.replace(tag_name,'%i' % stand.order_night)
            elif tag_name == '{PERSO price_night}':
                price = '%.2f' % stand.price_night
                if price[-3:] == '.00':
                    price = price[0:-3]
                text = text.replace(tag_name,price)
            elif tag_name == '{PERSO stand_name}':
                text = text.replace(tag_name,stand.name or stand.partner_id.name or u'Inconnu')
            elif tag_name == '{PERSO order_email}':
                text = text.replace(tag_name,stand.email_order.lower().strip().replace('\n',''))
            elif tag_name == '{PERSO stand_email}':
                text = text.replace(tag_name,stand.email_stand.lower().strip().replace('\n',''))
            elif tag_name == '{PERSO material_email}':
                text = text.replace(tag_name,stand.email_material.lower().strip().replace('\n',''))
            elif tag_name == '{PERSO invoice_data}':
                print 'inside invoice Data'
                value = u'<p>Aucune adresse de facturation définie</p>'
                if stand.partner_id:
                    # search of the first 'invoice' address, else first 'default' address
                    if stand.partner_id.address:
                        good_address = False
                        for address in stand.partner_id.address:
                            if address.type == 'invoice':
                                good_address = address
                                break
                        if not good_address:
                            for address in stand.partner_id.address:
                                if address.type == 'default':
                                    good_address = address
                                    break
                    if good_address:
                        if good_address.name:
                            if good_address.name[0:2] == '- ' or good_address.name[0:3] == ' - ':
                                value = ( stand.partner_id.name + ' ' + good_address.name.lstrip() )
                            else:
                                value = good_address.name
                        else:
                            value = stand.partner_id.name
                        value += '<br/>' + ( good_address.street or '' )
                        if good_address.street2:
                            value += ( u' - ' + good_address.street2 )
                        if good_address.zip_id:
                            value += ( u'<br/>' + good_address.zip_id.name + ' ' + good_address.zip_id.city )
                        elif good_address.zip:
                            value += ( u'<br/>' + good_address.zip + ' ' + good_address.city )
                        if not stand.partner_id.vat_subjected:
                            value += u'<br/>TVA : Non assujetti'
                        else:
                            if stand.partner_id.vat_subjected:
                                if stand.partner_id.vat:
                                    vat_num = stand.partner_id.vat
                                    if vat_num[0:3] == 'BE0' and len(vat_num) == 12:
                                        vat_num = vat_num[0:2]+'-'+vat_num[2:6]+'.'+vat_num[6:9]+'.'+vat_num[9:]
                                    value += ( u'<br/>TVA : ' + vat_num )
                                else:
                                    value += u'<br/>TVA : inconnue (merci de nous la préciser par retour de mail)'
                            else:
                                    value += u'<br/>TVA : Non-assujettie'
                        value += '</p>'
                text = text.replace(tag_name,value)
            else:
                try:
                    text = text.replace(tag_name,str(eval(tag_name[7:-1])).strip())
                except Exception:
                    text = text.replace(tag_name,'??' + tag_name[7:-1] + '??')
        full_texts.append( text )
    return full_texts


def _send_confirmations(self, cr, uid, data, context):
    pool_obj = pooler.get_pool(cr.dbname)
    obj_stand = pool_obj.get('cci.popup.stand')
    data_stand = obj_stand.browse(cr,uid,data['ids'])
    mail_created = 0
    mail_reject = 0
    mail_rej_reason = ""
    list_mail_ids = []

    template_obj = pool_obj.get('cci_email_template')
    mail_sended_obj = parameter_obj = pooler.get_pool(cr.dbname).get('cci_email_sended')
    template = template_obj.browse(cr,uid,data['form']['template_id'])
    tags = re.compile('{PERSO .*?}',re.IGNORECASE)

    parameter_obj = pool_obj.get('cci_parameters.cci_value')
    param_values = parameter_obj.get_value_from_names(cr,uid,['BDDeTest',])
    BD_DE_TEST = True
    if param_values.has_key('BDDeTest'):
        if param_values['BDDeTest'] == 0:
            BD_DE_TEST = False

    for stand in data_stand:
        if not stand.order_contact_id:
            mail_reject = mail_reject + 1
            mail_rej_reason += "ID "+str(stand.id)+_(": No contact for the order\n")
            continue

        if not stand.email_order:
            mail_reject = mail_reject + 1
            mail_rej_reason += "ID "+str(stand.id)+_(": Order contact without email\n")
            continue

        if stand.confirm_sending:
            mail_reject = mail_reject + 1
            mail_rej_reason += "ID "+str(stand.id)+_(": Confirmation already sended\n")
            continue
        
        full_texts = personalize_texts(cr,uid,stand,tags,[template.subject,template.body])
        # sending of the email
        addr_email_from = data['form']['email_from'] #'cm@ccilvn.be'
        if BD_DE_TEST:
            print 'From : ' + addr_email_from
            print 'To : ' + ','.join([stand.email_order,])
            print 'Subject : ' + full_texts[0]
            print 'Message : ' + full_texts[1]
        else:
            tools.email_send(addr_email_from, [stand.email_order,], full_texts[0], full_texts[1], subtype=template.type)
            obj_stand.write(cr,uid,[stand.id,],{'confirm_sending':datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')})
        mail_created += 1
        mail_id = mail_sended_obj.create(cr,uid,{
            'name':'cci_popup.stand_Confirm',
            'subject':full_texts[0],
            'body':full_texts[1],
            'ressource':'cci.popup.stand:'+str(stand.id)+':',
            'addr_from':addr_email_from,
            'addrs_to': '[%s,]' % stand.email_order,
           })
        list_mail_ids.append(mail_id)
                                        
    return {'mail_created' : str(mail_created),'mail_rejected' : str(mail_reject)  ,'mail_ids':  list_mail_ids , 'mail_rej_reason': mail_rej_reason }

class send_confirm_popup(wizard.interface):

    def _show_emails(self, cr, uid, data, context):
        pool_obj = pooler.get_pool(cr.dbname)
        model_data_ids = pool_obj.get('ir.model.data').search(cr,uid,[('model','=','ir.ui.view'),('name','=','invoice_form')])
        resource_id = pool_obj.get('ir.model.data').read(cr,uid,model_data_ids,fields=['res_id'])[0]['res_id']
        return {
            'domain': "[('id','in', ["+','.join(map(str,data['form']['mail_ids']))+"])]",
            'name': 'Sended Mails',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'cci_email_sended',
            'context': {},
            'type': 'ir.actions.act_window'
        }

    states = {
        'init' : {
            'actions' : [],
            'result' : {'type' : 'form','arch' : def_form, 'fields' : def_fields, 'state' : [('end','Cancel'),('send','Send')]}
                 },
        'send':{
            'actions' : [_send_confirmations],
            'result' : {'type' : 'form','arch' : form, 'fields' : fields, 'state' : [('end','Ok'),('open','Open Mails')]},
                  },
        'open': {
            'actions': [],
            'result': {'type':'action', 'action':_show_emails, 'state':'end'}
                }
             }
send_confirm_popup("send_confirm_popup")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

