# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import tools
import pooler
import base64
from pyExcelerator import *

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="template" colspan="4" width="650"/>
    <field name="forced"/>
    <field name="email_from"/>
</form>"""

fields = {
    'template': {'string': 'Template', 'type':'many2one','relation': 'cci_email_template','required': True},
    'forced':{'string':'Même aux login/pw existants ?','type':'boolean'},
    'email_from':{'string':'Email From','type':'char','size':120,'required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <field name="msg" colspan="4" nolabel="1" width="650"/>
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
}

class wizard_send_new_login(wizard.interface):

    def _send_mails(self,cr,uid,data,context):
        obj_contact = pooler.get_pool(cr.dbname).get('res.partner.contact')
        #msg = 'Resultats : ' + ','.join(obj_contact.get_complex_id_from_id(data['ids']))
        (sended,no_email_address,existing) = obj_contact.send_new_login_form(cr,uid,data['ids'],data['form']['template'],data['form']['forced'],data['form']['email_from'])
        # give the result tos the user
        msg = u"""Envois effectués :
                  \nEmails envoyés aux adresses suivantes : %s
                  \n\nPas d'email envoyé aux ID de contact suivants parce que pas d'adresse email : %s
                  \n\nPas d'email envoyés aux ID de contact suivant parce que login/pw existant : %s""" % (sended and ','.join(sended) or u'aucun',
                                                                                                           no_email_address and ','.join([str(x) for x in no_email_address]) or u'aucun',
                                                                                                           existing and ','.join([str(x) for x in existing]) or u'aucun' )
        data['form']['msg'] = msg
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('send_mails','Send Mails')]},
        },
        'send_mails': {
            'actions': [_send_mails],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

wizard_send_new_login('cci_premium_data.send_new_login')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

