# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import pooler
import datetime

form = """<?xml version="1.0"?>
<form string="Inject Company">
    <field name="partner_id" colspan="4"/>
    <field name="address_id" colspan="4"/>
    <field name="address_work_id" colspan="4"/>
    <label string="If you give an partner and an address, the premium data will be injected to theses records." colspan="4"/>
    <label string="If you let the address field empty, we'll create a new address to the given partner." colspan="4"/>
    <label string="The second address field will be used only if the premium user has given an working address." colspan="4"/>
</form>"""

fields = {
    'partner_id': {'type':'many2one','string':'Partner','relation':'res.partner'},
    'address_id': {'type':'many2one','string':'Address','relation':'res.partner.address','domain':"[('partner_id','=',partner_id)]"},
    'address_work_id': {'type':'many2one','string':'Address','relation':'res.partner.address','domain':"[('partner_id','=',partner_id)]"},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="Injection results" colspan="4"/>
     <field name="msg" colspan="4" nolabel="1" width="800" heigth="600"/>
</form>"""

msg_fields = {
    'msg': {'string':'Injection Results', 'type':'text', 'readonly':True},
}

def _inject_company(self, cr, uid, data, context):
    company_obj = pooler.get_pool(cr.dbname).get('premium_company')
    if not data['form']['partner_id'] and data['form']['address_id']:
        error_msg = 'You can\'t give an address and no partner.\n\nAlways select a partner, then an address !'
    else:
        error_msg = company_obj._try_inject_company(cr,uid,data['id'],data['form']['partner_id'],data['form']['address_id'],data['form']['address_work_id'],'wizard')
        if not error_msg or error_msg == 'Partner and Address Injected' or error_msg == 'Partner and Address Injected/Created':
            data['form']['msg'] = 'Company fully injected'
        else:
            data['form']['msg'] = 'Not injected.\n\nReason : %s' % error_msg
    return data['form']

class wizard_inject_premium_company(wizard.interface):
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('inject','Inject')]},
        },
        'inject': {
            'actions': [_inject_company],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
wizard_inject_premium_company("wizard_inject_premium_company")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

