# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import pooler
import datetime

form = """<?xml version="1.0"?>
<form string="Inject Contact">
    <field name="contact_id" colspan="4"/>
    <label string="If you give a contact, the values will be injected in that contact record" colspan="4"/>
    <label string="If you let this field empty, you confirm we MUST create a new contact if we found no correspondance !" colspan="4"/>
</form>"""

fields = {
    'contact_id': {'type':'many2one','string':'Contact','relation':'res.partner.contact'},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="Injection results" colspan="4"/>
     <field name="msg" colspan="4" nolabel="1" width="800" heigth="600"/>
</form>"""

msg_fields = {
    'msg': {'string':'Injection Results', 'type':'text', 'readonly':True},
}

def _inject_contact(self, cr, uid, data, context):
    contact_obj = pooler.get_pool(cr.dbname).get('premium_contact')
    error_msg = contact_obj._try_inject_contact(cr,uid,data['id'],data['form']['contact_id'],'wizard')
    if not error_msg or error_msg == 'Partner and Address Injected' or error_msg == 'Partner and Address Injected/Created':
        data['form']['msg'] = 'Contact fully injected'
    else:
        data['form']['msg'] = 'Not injected.\n\nReason : %s' % error_msg
    return data['form']

class wizard_inject_premium_contact(wizard.interface):
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('inject','Inject')]},
        },
        'inject': {
            'actions': [_inject_contact],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
wizard_inject_premium_contact("wizard_inject_premium_contact")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

