# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
import tools
import pooler
from osv import fields
from osv import osv
from tools.translate import _
from dateutil.relativedelta import relativedelta

form = """<?xml version="1.0"?>
<form string="(Re)Send access to directory">
    <field name="template_id" colspan="4"/>
    <field name="forced_address" colspan="4"/>
</form>"""

fields = {
    'forced_address': {'type':'char','size':250,'string':'Forced EMail Address'},
    'template_id': {'type':'many2one','relation':'cci_email_template','string':'Email Template','domain':"[]",'required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="Sended" colspan="4"/>
     <field name="msg" colspan="4" nolabel="1" width="800" heigth="600"/>
</form>"""

msg_fields = {
    'msg': {'string':'Results', 'type':'text', 'readonly':True},
}

class wizard_send_memberdirectory_access(wizard.interface):

    def _set_defaults(self,cr,uid,data,context):
        pool_obj=pooler.get_pool(cr.dbname)
        obj_ir_model = pool_obj.get('ir.model')
        ir_model_ids = obj_ir_model.search(cr,uid,[('model','=','premium_subscription')])
        if ir_model_ids:
            fields['template_id']['domain'] = "[('model_id','=',%i)]" % ir_model_ids[0]
        if data['ids'] and len(data['ids']) > 1:
            fields['forced_address']['readonly'] = True
        return data['form']
        
    def _send_mails(self,cr,uid,data,context):
        pool_obj=pooler.get_pool(cr.dbname)
        obj_sub = pool_obj.get('premium_subscription')
        subs = obj_sub.browse(cr,uid,data['ids'])
        msg_final = ''
        for subscription in subs:
            # We check if the address(es) are available for management via website
            # and if not, we directly add them before sending mail to user
            obj_user = pool_obj.get('res.users')
            user_website_id = obj_user.search(cr,uid,[('name','=','Noomia')])[0]
            modifiable_proxy_ids = []
            full_page_partner_ids = []
            obj_addr_proxy = pool_obj.get('directory.address.proxy')
            if subscription.contact_id and subscription.contact_id.job_ids:
                for current_job in subscription.contact_id.job_ids:
                    if current_job.address_id:
                        addr_proxy_ids = obj_addr_proxy.search(cr,uid,[('address_id','=',current_job.address_id.id)])
                        if addr_proxy_ids:
                            addr_proxy = obj_addr_proxy.browse(cr,uid,addr_proxy_ids[0])
                            if not addr_proxy.write_uid or (addr_proxy.write_uid and addr_proxy.write_uid.id <> user_website_id and not addr_proxy.user_validated and not addr_proxy.internal_validated):
                                modifiable_proxy_ids.append(addr_proxy.id)
                        if current_job.address_id.partner_id:
                            full_page_partner_ids.append(current_job.address_id.partner_id.id)

            if subscription.contact_id and subscription.contact_id.job_ids:
                for current_job in subscription.contact_id.job_ids:
                    if current_job.address_id:
                        obj_addr_proxy._synchro_address(cr,uid,current_job.address_id,current_job.address_id.partner_id,modifiable_proxy_ids,full_page_partner_ids,False,user_website_id,False,False,False,False)
            # get the email address : forced_address; if not : job email; if not personal email
            if data['form']['forced_address']:
                user_email = data['form']['forced_address']
            else:
                user_email = ''
                if subscription.contact_id:
                    if subscription.contact_id.job_ids and subscription.partner_id:
                        for job in subscription.contact_id.job_ids:
                            if job.address_id and job.address_id.partner_id and job.address_id.partner_id.id == subscription.partner_id.id and job.email:
                                user_email = job.email
                    if not user_email and subscription.contact_id.email:
                        user_email = subscription.contact_id.email
            if data['form']['template_id']:
                print 'user_email'
                print user_email
                used_email = obj_sub._send_url(cr,uid,subscription.id,data['form']['template_id'],user_email)
                if used_email:
                    msg_final += "Send to email '%s'\n" % used_email
                else:
                    msg_final += "Not sended by email because no valid email address was found [%i] \n" % subscription.id
        if msg_final:
            data['form']['msg'] = msg_final
        else:
            data['form']['msg'] = 'Finished'
        return data['form']
    states = {
        'init': {
            'actions': [_set_defaults],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('send','Send')]},
        },
        'send': {
            'actions': [_send_mails],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Close')]}
        },
    }
wizard_send_memberdirectory_access('wizard_send_memberdirectory_access')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

