# -*- encoding: utf-8 -*-
##############################################################################
import datetime
import wizard
import pooler
from tools.translate import _
import base64
from pyExcelerator import *
from pyExcelerator.Worksheet import *
import copy

form = '''<?xml version="1.0"?>
<form string="Parameters">
    <field name="first_year"/>
    <field name="areas_definition_id"/>
</form>'''


fields = {
    'first_year': {'string': 'First Year', 'type': 'integer', 'required': True},
    'areas_definition_id': {'string': 'Type of Zip codes\'Groups', 'type': 'many2one', 'relation': 'res.partner.zip.group.type', 'required': True},
}
msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="areas_follow.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'areas_follow.xls':{'string': 'Prepared file', 'type': 'binary', 'readonly': True,},
}

pyexcel_colours = {
        'aqua'    : 0x0F,
        'cyan'    : 0x0F,
        'black'   : 0x08,
        'blue'    : 0x0C,
        'brown'   : 0x10,
        'magenta' : 0x0E,
        'fuchsia' : 0x0E,
        'gray'    : 0x17,
        'grey'    : 0x17,
        'green'   : 0x11,
        'lime'    : 0x0B,
        'navy'    : 0x12,
        'orange'  : 0x35,
        'pink'    : 0x21,
        'purple'  : 0x14,
        'red'     : 0x0A,
        'silver'  : 0x16,
        'white'   : 0x09,
        'yellow'  : 0x0D,
}

def num_to_letter(line_number_in_pyexcel):
    # this method convert an integer to a line label in Excel
    # first line = 0 (beware on pyExcelerator, first line = 0)
    # 0 => 'A'
    # 26 => 'AA'
    # 27 => 'AB'
    line_number_in_pyexcel += 1
    if line_number_in_pyexcel < 26:
        result = chr(64+line_number_in_pyexcel)
    else:
        first = line_number_in_pyexcel_number_in_pyexcel // 26
        last = number % 26
        result = chr(64+first)+chr(64+last)
    return result
def full_cell(line_number_in_pyexcel,col_number_in_pyexcel,fixed='none'):
    # fixed = none, col, line, both
    result = ''
    if fixed in ('col','both'):
        result += '$'
    result += num_to_letter(col_number_in_pyexcel)
    if fixed in ('line','both'):
        result += '$'
    result += str(line_number_in_pyexcel+1)
    return result
class follow_areas_stats(wizard.interface):
    def _extract_stats(self, cr, uid, data, context):
        string_now = datetime.datetime.now().strftime('%d/%m/%Y - %H:%M:%S')
        current_year = int(datetime.date.today().strftime('%Y'))
        first_year = data['form']['first_year']
        if (first_year < 2000) or (first_year > current_year):
            # give the result tos the user
            data['form']['msg']=_('ERROR : the first year must be greater than 2000 and lesser than the current year.')
        else:
            # selected data
            zip_group_type_obj = pooler.get_pool(cr.dbname).get('res.partner.zip.group.type')
            zip_group_obj = pooler.get_pool(cr.dbname).get('res.partner.zip.group')
            zip_code_obj = pooler.get_pool(cr.dbname).get('res.partner.zip')

            style_pourcent = XFStyle()
            style_pourcent.num_format_str = '0.00%'

            wb1 = Workbook()
            ws1 = wb1.add_sheet(_('Stats by Areas'))
            ws1.write(0,0,_('Detailed Budget '))
            ws1.write(2,0,_('Extract date:'))
            ws1.write(2,1,string_now)
            ws1.write(4,0,_('Product'))
            ws1.write(4,1,_('Area'))
            first_col = 2
            col = first_col + 0
            year = first_year
            while year <= current_year:
                ws1.write(4,col,year)
                year += 1
                col += 2
            line1 = 5
            
            ws2 = wb1.add_sheet(_('Areas Definition'))
            ws2.write(0,0,_('Areas Definition to be sure'))
            ws2.write(1,0,_('Zip'))
            ws2.write(1,1,_('City'))
            ws2.write(1,2,_('Area'))
            line2 = 2
            # extract the areas
            group_type = zip_group_type_obj.browse(cr,uid,data['form']['areas_definition_id'])
            dGroups = {}
            group_ids = zip_group_obj.search(cr,uid,[('type_id','=',group_type.id)])
            groups = zip_group_obj.read(cr,uid,group_ids,['name'])
            for group in groups:
                zip_ids = zip_code_obj.search(cr,uid,[('groups_id','=',group['id'])])
                counts = {}
                year = first_year
                while year <= current_year:
                    counts[year] = 0
                    year += 1
                dGroups[group['id']] = {'name':group['name'],'zip_ids':zip_ids,'counts':counts}
            # alpha order of group ids
            ordered_group_ids = sorted(dGroups.keys())
            counts = {}
            year = first_year
            while year <= current_year:
                counts[year] = 0
                year += 1
            dGroups[-1] = {'name':_('Others'),'zip_ids':[],'counts':counts}
            # ordered list of group ids
            ordered_group_ids.append(-1)
            #
            dZips = {}
            zip_ids = zip_code_obj.search(cr,uid,[])
            zips = zip_code_obj.read(cr,uid,zip_ids,[])
            for zip_code in zips:
                found = -1
                for (group_id,group_data) in dGroups.items():
                    if zip_code['id'] in group_data['zip_ids']:
                        found = group_id
                        break
                dZips[zip_code['id']] = {'name':zip_code['name']+' '+zip_code['city'],'group_id':found}
                ws2.write(line2,0,zip_code['name'])
                ws2.write(line2,1,zip_code['city'])
                ws2.write(line2,2,dGroups[found]['name'])
                line2 += 1

            #######   
            # clubs
            #######
            club_obj = pooler.get_pool(cr.dbname).get('cci_club.club')
            part_obj = pooler.get_pool(cr.dbname).get('cci_club.participation')
            for club_type in [{'name':u'AE','ids':[16,]},{'name':u'CNN','ids':[28,]},{'name':'Tables Conversation','ids':[17,]}]:
                # set counters to 0
                for (key,group_data) in dGroups.items():
                    counts = {}
                    year = first_year
                    while year <= current_year:
                        counts[year] = 0
                        year += 1
                    group_data['counts'] = counts
                    dGroups[key] = group_data
                #
                club_ids = club_obj.search(cr,uid,[('type_id','in',club_type['ids'])])
                if club_ids:
                    # TO DO use only not canceled states
                    part_ids = part_obj.search(cr,uid,[('group_id','in',club_ids),('date_in','>=','%i-01-01' % first_year),('date_in','<=','%i-12-31' % current_year),('state_id.current','=',True)])
                    if part_ids:
                        size = 100
                        offset = 0
                        while part_ids[offset:offset+size]:
                            parts = part_obj.browse(cr,uid,part_ids[offset:offset+size])
                            # search for the couple 'person-company'; if not found, doesn't consider this record
                            for participation in parts:
                                if participation.contact_id and participation.partner_id and participation.contact_id.job_ids:
                                    found_zip_id = False
                                    for job in participation.contact_id.job_ids:
                                        if job.address_id and job.address_id.zip_id and job.address_id.partner_id:
                                            if job.address_id.partner_id.id == participation.partner_id.id:
                                                found_zip_id = job.address_id.zip_id.id
                                                break
                                    if found_zip_id and found_zip_id in dZips.keys():
                                        group_data = dGroups[dZips[found_zip_id]['group_id']]
                                        group_data['counts'][int(participation['date_in'][0:4])] += 1
                                        dGroups[dZips[found_zip_id]['group_id']] = group_data
                            offset += size
                #
                year = first_year
                while year <= current_year:
                    ws1.write(line1,2+((year-first_year)*2),Formula('SUM(%s:%s)' % (full_cell(line1+1,2+((year-first_year)*2)),full_cell(line1+len(dGroups.keys()),2+((year-first_year)*2))) ))
                    year += 1
                ws1.write(line1,0,club_type['name'])
                inner = 1
                for key in ordered_group_ids:
                    group_data = dGroups[key]
                    year = first_year
                    ws1.write(line1+inner,1,group_data['name'])
                    while year <= current_year:
                        ws1.write(line1+inner,2+((year-first_year)*2),group_data['counts'][year])
                        current_cell_name = full_cell(line1+inner,2+((year-first_year)*2))
                        total_cell_name = full_cell(line1,2+((year-first_year)*2))
                        ws1.write(line1+inner,3+((year-first_year)*2),Formula("%s/%s" % (current_cell_name,total_cell_name) ), style_pourcent)
                        year += 1
                    inner += 1
                line1 += (len(dGroups)+2)

            ########
            # events
            ########
            event_obj = pooler.get_pool(cr.dbname).get('event.event')
            reg_obj = pooler.get_pool(cr.dbname).get('event.registration')
            already_selected_event_ids = []
            for event_type in [{'name':u'Event Commerce International','ids':[13,]},{'name':u'Conférences','ids':[41,]},{'name':u'PopUp','ids':[55,]},{'name':u'Events networking','ids':[]}]:
                # set counters to 0
                for (key,group_data) in dGroups.items():
                    counts = {}
                    year = first_year
                    while year <= current_year:
                        counts[year] = 0
                        year += 1
                    group_data['counts'] = counts
                    dGroups[key] = group_data
                #
                if len(event_type['ids']) >= 1:
                    event_ids = event_obj.search(cr,uid,[('date_begin','>=','%i-01-01' % first_year),('date_begin','<=','%i-12-31' % current_year),('type','in',event_type['ids'])])
                    already_selected_event_ids.extend(event_type['ids'])
                else:
                    event_ids = event_obj.search(cr,uid,[('date_begin','>=','%i-01-01' % first_year),('date_begin','<=','%i-12-31' % current_year),('type','not in',already_selected_event_ids),'|',('active','=',True),('active','=',False)])
                if event_ids:
                    # TO DO use only not canceled states
                    reg_ids = reg_obj.search(cr,uid,[('event_id','in',event_ids),])
                    if reg_ids:
                        size = 100
                        offset = 0
                        while reg_ids[offset:offset+size]:
                            regs = reg_obj.browse(cr,uid,reg_ids[offset:offset+size])
                            # search for the couple 'person-company'; if not found, doesn't consider this record
                            for reg in regs:
                                if reg.contact_id and reg.partner_id and reg.contact_id.job_ids:
                                    found_zip_id = False
                                    for job in reg.contact_id.job_ids:
                                        if job.address_id and job.address_id.zip_id and job.address_id.partner_id:
                                            if job.address_id.partner_id.id == reg.partner_id.id:
                                                found_zip_id = job.address_id.zip_id.id
                                                break
                                    if found_zip_id and found_zip_id in dZips.keys():
                                        group_data = dGroups[dZips[found_zip_id]['group_id']]
                                        group_data['counts'][int(reg.event_id.date_begin[0:4])] += 1
                                        dGroups[dZips[found_zip_id]['group_id']] = group_data
                            offset += size
                #
                year = first_year
                while year <= current_year:
                    ws1.write(line1,2+((year-first_year)*2),Formula('SUM(%s:%s)' % (full_cell(line1+1,2+((year-first_year)*2)),full_cell(line1+len(dGroups.keys()),2+((year-first_year)*2))) ))
                    year += 1
                ws1.write(line1,0,event_type['name'])
                inner = 1
                for key in ordered_group_ids:
                    group_data = dGroups[key]
                    year = first_year
                    ws1.write(line1+inner,1,group_data['name'])
                    year = first_year
                    while year <= current_year:
                        ws1.write(line1+inner,2+((year-first_year)*2),group_data['counts'][year])
                        current_cell_name = full_cell(line1+inner,2+((year-first_year)*2))
                        total_cell_name = full_cell(line1,2+((year-first_year)*2))
                        ws1.write(line1+inner,3+((year-first_year)*2),Formula("%s/%s" % (current_cell_name,total_cell_name) ), style_pourcent)
                        year += 1
                    inner += 1
                line1 += (len(dGroups)+2)

            ###############################################
            # invoiced membership (not free not associated)
            ###############################################
            # set counters to 0
            for (key,group_data) in dGroups.items():
                counts = {}
                year = first_year
                while year <= current_year:
                    counts[year] = 0
                    year += 1
                    group_data['counts'] = counts
                dGroups[key] = group_data
            
            product_obj = pooler.get_pool(cr.dbname).get('product.product')
            invoice_line_obj = pooler.get_pool(cr.dbname).get('account.invoice.line')
            prod_ids = product_obj.search(cr,uid,[('membership','=',True),('membership_year','>=',first_year),('membership_year','<=',current_year)])
            if prod_ids:
                iline_ids = invoice_line_obj.search(cr,uid,[('product_id','in',prod_ids),('invoice_id.journal_id.type','=','sale'),('invoice_id.journal_id.refund_journal','=',False)])
                if iline_ids:
                    size = 100
                    offset = 0
                    while iline_ids[offset:offset+size]:
                        ilines = invoice_line_obj.browse(cr,uid,iline_ids[offset:offset+size])
                        for iline in ilines:
                            if iline.invoice_id and iline.invoice_id.partner_id and iline.invoice_id.partner_id.address:
                                found_zip_id = False
                                for address in iline.invoice_id.partner_id.address:
                                    if address.type and address.type == 'default' and address.zip_id:
                                        found_zip_id = address.zip_id.id
                                        break
                                if found_zip_id and found_zip_id in dZips.keys():
                                    group_data = dGroups[dZips[found_zip_id]['group_id']]
                                    group_data['counts'][iline.product_id.membership_year] += 1
                                    dGroups[dZips[found_zip_id]['group_id']] = group_data
                        offset += size
            #
            year = first_year
            while year <= current_year:
                ws1.write(line1,2+((year-first_year)*2),Formula('SUM(%s:%s)' % (full_cell(line1+1,2+((year-first_year)*2)),full_cell(line1+len(dGroups.keys()),2+((year-first_year)*2))) ))
                year += 1
            ws1.write(line1,0,_('Membership invoiced by membership year'))
            inner = 1
            for key in ordered_group_ids:
                group_data = dGroups[key]
                year = first_year
                ws1.write(line1+inner,1,group_data['name'])
                year = first_year
                while year <= current_year:
                    ws1.write(line1+inner,2+((year-first_year)*2),group_data['counts'][year])
                    current_cell_name = full_cell(line1+inner,2+((year-first_year)*2))
                    total_cell_name = full_cell(line1,2+((year-first_year)*2))
                    ws1.write(line1+inner,3+((year-first_year)*2),Formula("%s/%s" % (current_cell_name,total_cell_name) ), style_pourcent)
                    year += 1
                inner += 1
            line1 += (len(dGroups)+2)

            ###############################################
            # Pages pleines Répertoire des Membres
            ###############################################
            # set counters to 0
            for (key,group_data) in dGroups.items():
                counts = {}
                year = first_year
                while year <= current_year:
                    counts[year] = 0
                    year += 1
                    group_data['counts'] = counts
                dGroups[key] = group_data
            
            #product_obj = pooler.get_pool(cr.dbname).get('product.product')
            invoice_line_obj = pooler.get_pool(cr.dbname).get('account.invoice.line')
            prod_ids = [254,744,754]
            if prod_ids:
                iline_ids = invoice_line_obj.search(cr,uid,[('product_id','in',prod_ids),('invoice_id.journal_id.type','=','sale'),('invoice_id.journal_id.refund_journal','=',False)])
                if iline_ids:
                    size = 100
                    offset = 0
                    while iline_ids[offset:offset+size]:
                        ilines = invoice_line_obj.browse(cr,uid,iline_ids[offset:offset+size])
                        for iline in ilines:
                            if iline.invoice_id and iline.invoice_id.date_invoice and int(iline.invoice_id.date_invoice[0:4]) >= first_year and int(iline.invoice_id.date_invoice[0:4]) <= current_year and iline.invoice_id.partner_id and iline.invoice_id.partner_id.address:
                                found_zip_id = False
                                for address in iline.invoice_id.partner_id.address:
                                    if address.type and address.type == 'default' and address.zip_id:
                                        found_zip_id = address.zip_id.id
                                        break
                                if found_zip_id and found_zip_id in dZips.keys():
                                    group_data = dGroups[dZips[found_zip_id]['group_id']]
                                    group_data['counts'][int(iline.invoice_id.date_invoice[0:4])] += 1
                                    dGroups[dZips[found_zip_id]['group_id']] = group_data
                        offset += size
            #
            year = first_year
            while year <= current_year:
                ws1.write(line1,2+((year-first_year)*2),Formula('SUM(%s:%s)' % (full_cell(line1+1,2+((year-first_year)*2)),full_cell(line1+len(dGroups.keys()),2+((year-first_year)*2))) ))
                year += 1
            ws1.write(line1,0,_('Full Pages in Members\'Directory'))
            inner = 1
            for key in ordered_group_ids:
                group_data = dGroups[key]
                year = first_year
                ws1.write(line1+inner,1,group_data['name'])
                year = first_year
                while year <= current_year:
                    ws1.write(line1+inner,2+((year-first_year)*2),group_data['counts'][year])
                    current_cell_name = full_cell(line1+inner,2+((year-first_year)*2))
                    total_cell_name = full_cell(line1,2+((year-first_year)*2))
                    ws1.write(line1+inner,3+((year-first_year)*2),Formula("%s/%s" % (current_cell_name,total_cell_name) ), style_pourcent)
                    year += 1
                inner += 1
            line1 += (len(dGroups)+2)

            ########################
            # Certificates of Origin
            ########################
            dtype_obj = pooler.get_pool(cr.dbname).get('cci_missions.dossier_type')
            certificate_obj = pooler.get_pool(cr.dbname).get('cci_missions.certificate')
            for digital_type in [False,True]:
                # set counters to 0
                for (key,group_data) in dGroups.items():
                    counts = {}
                    year = first_year
                    while year <= current_year:
                        counts[year] = 0
                        year += 1
                        group_data['counts'] = counts
                    dGroups[key] = group_data
                dtype_ids = dtype_obj.search(cr,uid,[('section','=','certificate'),('digital','=',digital_type)])
                if dtype_ids:
                    cert_ids = certificate_obj.search(cr,uid,[('type_id','in',dtype_ids),('date','>=','%i-01-01' % first_year),('date','<=','%i-12-31' % current_year)])
                    if cert_ids:
                        size = 100
                        offset = 0
                        while cert_ids[offset:offset+size]:
                            certs = certificate_obj.browse(cr,uid,cert_ids[offset:offset+size])
                            for cert in certs:
                                if cert.dossier_id and cert.dossier_id.order_partner_id and cert.dossier_id.order_partner_id.address:
                                    found_zip_id = False
                                    for address in cert.dossier_id.order_partner_id.address:
                                        if address.type and address.type == 'default' and address.zip_id:
                                            found_zip_id = address.zip_id.id
                                            break
                                    if found_zip_id and found_zip_id in dZips.keys():
                                        group_data = dGroups[dZips[found_zip_id]['group_id']]
                                        group_data['counts'][int(cert.date[0:4])] += 1
                                        dGroups[dZips[found_zip_id]['group_id']] = group_data
                            offset += size
                #
                year = first_year
                while year <= current_year:
                    ws1.write(line1,2+((year-first_year)*2),Formula('SUM(%s:%s)' % (full_cell(line1+1,2+((year-first_year)*2)),full_cell(line1+len(dGroups.keys()),2+((year-first_year)*2))) ))
                    year += 1
                if digital_type:
                    ws1.write(line1,0,_('Digital certificates'))
                else:
                    ws1.write(line1,0,_('Paper certificates'))
                inner = 1
                for key in ordered_group_ids:
                    group_data = dGroups[key]
                    year = first_year
                    ws1.write(line1+inner,1,group_data['name'])
                    year = first_year
                    while year <= current_year:
                        ws1.write(line1+inner,2+((year-first_year)*2),group_data['counts'][year])
                        current_cell_name = full_cell(line1+inner,2+((year-first_year)*2))
                        total_cell_name = full_cell(line1,2+((year-first_year)*2))
                        ws1.write(line1+inner,3+((year-first_year)*2),Formula("%s/%s" % (current_cell_name,total_cell_name) ), style_pourcent)
                        year += 1
                    inner += 1
                line1 += (len(dGroups)+2)

            ######################
            # Actions commerciales
            ######################
            # set counters to 0
            for (key,group_data) in dGroups.items():
                counts = {}
                year = first_year
                while year <= current_year:
                    counts[year] = 0
                    year += 1
                    group_data['counts'] = counts
                dGroups[key] = group_data
            
            histo_obj = pooler.get_pool(cr.dbname).get('res.partner.history')
            histo_ids = histo_obj.search(cr,uid,[('action','in',['appel_sortant','midi','rdv']),('date','>=','%i-01-01' % first_year),('date','<=','%i-12-31' % current_year)])
            if histo_ids:
                size = 100
                offset = 0
                while histo_ids[offset:offset+size]:
                    histos = histo_obj.browse(cr,uid,histo_ids[offset:offset+size])
                    for histo in histos:
                        if histo.partner and histo.partner.address:
                            found_zip_id = False
                            for address in histo.partner.address:
                                if address.type and address.type == 'default' and address.zip_id:
                                    found_zip_id = address.zip_id.id
                                    break
                            if found_zip_id and found_zip_id in dZips.keys():
                                group_data = dGroups[dZips[found_zip_id]['group_id']]
                                group_data['counts'][int(histo.date[0:4])] += 1
                                dGroups[dZips[found_zip_id]['group_id']] = group_data
                    offset += size
            #
            year = first_year
            while year <= current_year:
                ws1.write(line1,2+((year-first_year)*2),Formula('SUM(%s:%s)' % (full_cell(line1+1,2+((year-first_year)*2)),full_cell(line1+len(dGroups.keys()),2+((year-first_year)*2))) ))
                year += 1
            ws1.write(line1,0,_('Sales\'Actions (visits, emails out, midi CCI)'))
            inner = 1
            for key in ordered_group_ids:
                group_data = dGroups[key]
                year = first_year
                ws1.write(line1+inner,1,group_data['name'])
                year = first_year
                while year <= current_year:
                    ws1.write(line1+inner,2+((year-first_year)*2),group_data['counts'][year])
                    current_cell_name = full_cell(line1+inner,2+((year-first_year)*2))
                    total_cell_name = full_cell(line1,2+((year-first_year)*2))
                    ws1.write(line1+inner,3+((year-first_year)*2),Formula("%s/%s" % (current_cell_name,total_cell_name) ), style_pourcent)
                    year += 1
                inner += 1
            line1 += (len(dGroups)+2)

            #########################
            # Contenu base de données
            #########################
            # set counters to 0
            for (key,group_data) in dGroups.items():
                counts = {}
                year = first_year
                while year <= current_year:
                    counts[year] = 0
                    year += 1
                    group_data['counts'] = counts
                dGroups[key] = group_data
            dEmails = copy.deepcopy(dGroups)
            dMbreAddrs = copy.deepcopy(dGroups)
            dMbreEmails = copy.deepcopy(dGroups)
            
            addr_obj = pooler.get_pool(cr.dbname).get('res.partner.address')
            addr_ids = addr_obj.search(cr,uid,[])
            size = 100
            offset = 0
            while addr_ids[offset:offset+size]:
                addrs = addr_obj.browse(cr,uid,addr_ids[offset:offset+size])
                for addr in addrs:
                    if addr.partner_id and addr.partner_id.state_id and addr.partner_id.state_id.id == 1 and addr.zip_id:
                        found_zip_id = addr.zip_id.id
                        if found_zip_id in dZips.keys():
                            group_id = dZips[found_zip_id]['group_id']
                            group_data = dGroups[group_id]
                            group_data['counts'][current_year] += 1
                            dGroups[group_id] = group_data
                            #
                            email_data = dEmails[group_id]
                            if addr.email:
                                email_data['counts'][current_year] += 1
                            for job in addr.job_ids:
                                if job.contact_id and (job.email or job.contact_id.email):
                                    email_data['counts'][current_year] += 1
                            dEmails[group_id] = email_data
                            #
                            if addr.partner_id.membership_state in ['paid','free','invoiced']:
                                group_data = dMbreAddrs[group_id]
                                group_data['counts'][current_year] += 1
                                dMbreAddrs[group_id] = group_data
                                #
                                email_data = dMbreEmails[group_id]
                                if addr.email:
                                    email_data['counts'][current_year] += 1
                                for job in addr.job_ids:
                                    if job.contact_id and (job.email or job.contact_id.email):
                                        email_data['counts'][current_year] += 1
                                dMbreEmails[group_id] = email_data
                            
                offset += size
            #
            year = first_year
            while year <= current_year:
                ws1.write(line1,2+((year-first_year)*2),Formula('SUM(%s:%s)' % (full_cell(line1+1,2+((year-first_year)*2)),full_cell(line1+len(dGroups.keys()),2+((year-first_year)*2))) ))
                year += 1
            ws1.write(line1,0,_('Addresses in DB'))
            inner = 1
            for key in ordered_group_ids:
                group_data = dGroups[key]
                year = first_year
                ws1.write(line1+inner,1,group_data['name'])
                year = first_year
                while year <= current_year:
                    ws1.write(line1+inner,2+((year-first_year)*2),group_data['counts'][year])
                    current_cell_name = full_cell(line1+inner,2+((year-first_year)*2))
                    total_cell_name = full_cell(line1,2+((year-first_year)*2))
                    ws1.write(line1+inner,3+((year-first_year)*2),Formula("%s/%s" % (current_cell_name,total_cell_name) ), style_pourcent)
                    year += 1
                inner += 1
            line1 += (len(dGroups)+2)
            #
            year = first_year
            while year <= current_year:
                ws1.write(line1,2+((year-first_year)*2),Formula('SUM(%s:%s)' % (full_cell(line1+1,2+((year-first_year)*2)),full_cell(line1+len(dEmails.keys()),2+((year-first_year)*2))) ))
                year += 1
            ws1.write(line1,0,_('eMails in DB'))
            inner = 1
            for key in ordered_group_ids:
                email_data = dEmails[key]
                year = first_year
                ws1.write(line1+inner,1,email_data['name'])
                year = first_year
                while year <= current_year:
                    ws1.write(line1+inner,2+((year-first_year)*2),email_data['counts'][year])
                    current_cell_name = full_cell(line1+inner,2+((year-first_year)*2))
                    total_cell_name = full_cell(line1,2+((year-first_year)*2))
                    ws1.write(line1+inner,3+((year-first_year)*2),Formula("%s/%s" % (current_cell_name,total_cell_name) ), style_pourcent)
                    year += 1
                inner += 1
            line1 += (len(dEmails)+2)
            #
            year = first_year
            while year <= current_year:
                ws1.write(line1,2+((year-first_year)*2),Formula('SUM(%s:%s)' % (full_cell(line1+1,2+((year-first_year)*2)),full_cell(line1+len(dGroups.keys()),2+((year-first_year)*2))) ))
                year += 1
            ws1.write(line1,0,_('Members\'Addresses (CCIMag sending)'))
            inner = 1
            for key in ordered_group_ids:
                group_data = dMbreAddrs[key]
                year = first_year
                ws1.write(line1+inner,1,group_data['name'])
                year = first_year
                while year <= current_year:
                    ws1.write(line1+inner,2+((year-first_year)*2),group_data['counts'][year])
                    current_cell_name = full_cell(line1+inner,2+((year-first_year)*2))
                    total_cell_name = full_cell(line1,2+((year-first_year)*2))
                    ws1.write(line1+inner,3+((year-first_year)*2),Formula("%s/%s" % (current_cell_name,total_cell_name) ), style_pourcent)
                    year += 1
                inner += 1
            line1 += (len(dMbreAddrs)+2)
            #
            year = first_year
            while year <= current_year:
                ws1.write(line1,2+((year-first_year)*2),Formula('SUM(%s:%s)' % (full_cell(line1+1,2+((year-first_year)*2)),full_cell(line1+len(dEmails.keys()),2+((year-first_year)*2))) ))
                year += 1
            ws1.write(line1,0,_('Members\'eMails (PressReview)'))
            inner = 1
            for key in ordered_group_ids:
                email_data = dMbreEmails[key]
                year = first_year
                ws1.write(line1+inner,1,email_data['name'])
                year = first_year
                while year <= current_year:
                    ws1.write(line1+inner,2+((year-first_year)*2),email_data['counts'][year])
                    current_cell_name = full_cell(line1+inner,2+((year-first_year)*2))
                    total_cell_name = full_cell(line1,2+((year-first_year)*2))
                    ws1.write(line1+inner,3+((year-first_year)*2),Formula("%s/%s" % (current_cell_name,total_cell_name) ), style_pourcent)
                    year += 1
                inner += 1
            line1 += (len(dMbreEmails)+2)

            wb1.save('areas_follow.xls')
            result_file = open('areas_follow.xls','rb').read()

            # give the result tos the user
            data['form']['msg']='Save the File with '".xls"' extension.'
            data['form']['areas_follow.xls']=base64.encodestring(result_file)
        return data['form']
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('extract','Extract') ]}
        },
        'extract': {
            'actions': [_extract_stats],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        }
    }
follow_areas_stats('follow_areas_stats')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

