# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
import tools
import pooler
import base64
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="warning" colspan="4" width="600"/>
    <field name="status"/>
</form>"""

fields = {
    'warning': {'type':'text','string':'Warning','value':'This tool export creations and bankruptcies to a HTML file once by week.','readonly':True},
    'status': {'type':'selection', 'selection': [('draft','Draft'),('publish','Published')], 'string':'Status', 'required':True}
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="Result" colspan="4"/>
     <field name="slug" colspan="4"/>
     <field name="msg" colspan="4" nolabel="1" width="800" heigth="600"/>
     <field name="content" colspan="4" nolabel="1"/>
</form>"""

msg_fields = {
    'slug': {'string':'slug','type':'char','size':240},
    'msg': {'string':'File imported', 'type':'text', 'readonly':True},
    'content': {'string':'File exported', 'type':'text', 'readonly':True},
}

class export_week(wizard.interface):
    def _export_data(self,cr,uid,data,context):
        creation_obj = pooler.get_pool(cr.dbname).get('riplay.creation')
        (result,final_slug) = creation_obj.publish_bankr_and_creations(cr,uid,'manual',data['form']['status'])
        data['form']['msg'] = result
        data['form']['slug'] = final_slug
        return data['form']
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('export','Export File')]},
        },
        'export': {
            'actions': [_export_data],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
export_week('export_week')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

