# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler

class order_with_gsc(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(order_with_gsc, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'get_msg_advertising': self._get_msg_advertising,
        })
    def _get_msg_advertising(self,order_id):
        item = pooler.get_pool(self.cr.dbname).get('sale.order').browse(self.cr,self.uid,order_id)
        msg = u''
        for sline in item.order_line:
            if sline.product_id and sline.product_id.categ_id and sline.product_id.categ_id.id in [5,7]:
                msg = u'Aucune annonce publicitaire ne sera intégrée dans nos supports tant que nous ne serons pas en possession d’un bon de commande dûment signé et complété.'
                break
        return msg
report_sxw.report_sxw('report.sale.order.with.gsc','sale.order','addons/cci_sales_extend/report/order_with_gsc.rml',parser=order_with_gsc)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

