# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
import wizard
import time
import datetime
import tools
import pooler
import base64
from pyExcelerator import *

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="order_lines.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'order_lines.xls':{'string': 'Prepared file',
        'type': 'binary',
        'readonly': True,},
}

class wizard_export_order_line(wizard.interface):
    def _get_file(self,cr,uid,data,context):
        obj_line = pooler.get_pool(cr.dbname).get('sale.order.line')
        line_ids = data['ids']
        
        wb = Workbook()
        ws1 = wb.add_sheet(u'Lignes de ventes')
        ws1.write(0,0,u'id')
        ws1.write(0,1,u'Réf BC')
        ws1.write(0,2,u'Etat BC')
        ws1.write(0,3,u'Client')
        ws1.write(0,4,u'Description')
        ws1.write(0,5,u'Produit')
        ws1.write(0,6,u'Sous-Total')
        ws1.write(0,7,u'Date de facturation voulue')
        ws1.write(0,8,u'Etat')
        ws1.write(0,9,u'Début Validité')
        ws1.write(0,10,u'Fin validité')
        ws1.write(0,11,u'Parution Pub')
        ws1.write(0,12,u'Commercial')
        ws1.write(0,13,u'Notes_250')
        ws1.write(0,14,u'MiseEnPage_250')
        ws1.write(0,15,u'Facture(s)')
        line = 1
        if line_ids:
            lines = obj_line.browse(cr,uid,line_ids)
            for oline in lines:
                ws1.write(line,0,oline.id)
                ws1.write(line,1,oline.order_id.name)
                ws1.write(line,2,oline.order_id.state or '')
                ws1.write(line,3,oline.order_partner_id.name)
                ws1.write(line,4,oline.name or '')
                ws1.write(line,5,oline.product_id.name)
                ws1.write(line,6,oline.price_subtotal)
                ws1.write(line,7,oline.expected_invoice_date and oline.expected_invoice_date[0:10] or '' )
                ws1.write(line,8,oline.state or '' )
                ws1.write(line,9,oline.from_date and oline.from_date[0:10] or '' )
                ws1.write(line,10,oline.to_date and oline.to_date[0:10] or '' )
                ws1.write(line,11,oline.adv_issue and oline.adv_issue.name or '')
                ws1.write(line,12,oline.user_id and oline.user_id.name or '')
                ws1.write(line,13,oline.notes and oline.notes[0:250] or '')
                ws1.write(line,14,oline.layout_remark and oline.layout_remark[0:250] or '' )
                invoices = ''
                if oline.invoice_lines:
                    invoice_nums = []
                    for iline in oline.invoice_lines:
                        invoice_nums.append(iline.invoice_id.number or '')
                    invoices = ','.join(invoice_nums)
                ws1.write(line,15,invoices)
                line += 1
        wb.save('order_lines.xls')
        result_file = open('order_lines.xls','rb').read()

        # give the result tos the user
        data['form']['msg']='Save the File with '".xls"' extension.'
        data['form']['order_lines.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [_get_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

wizard_export_order_line('export_order_line_excel')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

