# -*- encoding: utf-8 -*-

from osv import fields, osv
import wizard
import pooler
import os
import datetime
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Extract Sales Lines valid between 2 dates">
    <field name="date_from"/>
    <field name="date_to"/>
</form>"""

fields = {
    'date_from':{'string':'From','type':'date','required':True},
    'date_to':{'string':'To','type':'date','required':True},
}

class extract_sales_validity_2dates(wizard.interface):
    def _init(self,cr,uid,data,context):
        data['form']['date_from'] = datetime.datetime.today().strftime('%Y-%m-%d')
        data['form']['date_to'] = datetime.datetime.today().strftime('%Y-12-31')
        return data['form']
    def _select_lines(self,cr,uid,data,context):
        # create list of concerned periods
        date_from = data['form']['date_from']
        date_to = data['form']['date_to']
        if date_to < date_from:
            (date_from,date_to) = (date_to,date_from)
        obj_line = pooler.get_pool(cr.dbname).get('sale.order.line')
        line_ids = obj_line.search(cr,uid,[('state','<>','cancel'),('from_date','<=',date_to),('to_date','>=',date_from)])
        if line_ids:
            list_of_ids = '[' + ','.join([str(x) for x in line_ids]) + ',]'
        else:
            list_of_ids = '[]'
        # give the result to the user
        result = {
            'name': _('Sales Lines valid between %s and %s') % (date_from,date_to),
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'sale.order.line',
            'domain': "[('id','in',%s)]" % list_of_ids,
            'context': {},
            'type': 'ir.actions.act_window'
        }
        return result

    states = {
        'init': {
            'actions': [_init],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('select','Select')]},
        },
        'select': {
            'actions': [],
            'result': {'type': 'action', 'action':_select_lines, 'state':'end'}
        },
    }
extract_sales_validity_2dates('extract_sales_validity_2dates')
