# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import wizard
import pooler
from tools.translate import _

msg_form = """<?xml version="1.0"?>
<form string="Results">
     <field name="msg" colspan="4" nolabel="1" width="400"/>
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
}

class set_so_as_invoiced(wizard.interface):
    def _set_sale_order_as_invoiced(self,cr,uid,data,context):
        if len(data['ids']) > 1:
            raise wizard.except_wizard(_('Error'), _('You can use this tool on ONE sale order at a time. Nothing has be done.'))
        else:
            obj_so = pooler.get_pool(cr.dbname).get('sale.order')
            obj_sol = pooler.get_pool(cr.dbname).get('sale.order.line')
            saleorder = obj_so.browse(cr,uid,data['ids'])[0]
            if saleorder.state == 'draft':
                raise wizard.except_wizard(_('Error'), _('The Sale Order is still in \'Draft\'. Nothing to do.'))
            else:
                if saleorder.order_line:
                    count_invoiced = 0
                    count_tobeinvoiced = 0
                    oline_ids = []
                    for oline in saleorder.order_line:
                        if oline.invoiced:
                            count_invoiced += 1
                        else:
                            count_tobeinvoiced += 1
                            oline_ids.append(oline.id)
                    if count_invoiced == 0 and count_tobeinvoiced > 0:
                        obj_sol.write(cr,uid,oline_ids,{'invoiced':True})
                        # not to do, just for mention if usefull later
                        #obj_so.write(cr, uid, [saleorder.id], {'state' : 'progress'}, context=context)
                        cronline_id = pooler.get_pool(cr.dbname).get('cci_logs.cron_line')._start(cr,uid,'SetSaleOrderLinesAsInvoiced')
                        current_user = pooler.get_pool(cr.dbname).get('res.users').browse(cr,uid,uid)
                        pooler.get_pool(cr.dbname).get('cci_logs.cron_line')._addComment(cr,uid,cronline_id,'Sale Order %s set as Invoiced by %s : %i lines set invoiced.' % (saleorder.name or 'not ref',current_user.login or str(uid),count_tobeinvoiced) )
                        pooler.get_pool(cr.dbname).get('cci_logs.cron_line')._stop(cr,uid,cronline_id,False,'\n---end---')
                        data['form']['msg']=_('All lines (%i) set to Invoiced.') % count_tobeinvoiced
                    elif count_invoiced > 0 and count_tobeinvoiced > 0:
                        raise wizard.except_wizard(_('Error'), _('Some lines already invoiced and some not invoiced. Can\'t happen. Nothing has been changed.'))
                    else:
                        raise wizard.except_wizard(_('Error'), _('All lines already invoiced. Nothing to do.'))
                else:
                    raise wizard.except_wizard(_('Error'), _('No line to set as invoiced on this sale order. Nothing has be done.'))
        return data['form']
    states = {
        'init': {
            'actions': [_set_sale_order_as_invoiced],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
set_so_as_invoiced("set_so_as_invoiced")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

