# -*- coding: utf-8 -*-

from tools.translate import _
import wizard
import pooler


class create_histo_from_interest(wizard.interface):
    
    def copy_todo_to_histo(self, cr, uid, data, context=None):
        if context is None:
            context = {}
            
        pool = pooler.get_pool(cr.dbname)
        res_id = False
        
        todo_obj = pool.get('crm_cci.todo')
        todo = todo_obj.browse(cr, uid, data['id'])
        if todo.action and todo.action != '/':
            histo_obj = pool.get('res.partner.history')
            contact_cci_id = False
            if todo.cci_contact_follow:
                contact_obj = pool.get('cci.contact')
                contact_ids = contact_obj.search(cr,uid,[('user','=',todo.cci_contact_follow.id)])
                if contact_ids:
                    contact_cci_id = contact_ids[0]
            if not contact_cci_id:
                # No cci_contact_follow on the todo => by default we use the cci_contact
                contact_cci_id = ( todo.cci_contact and todo.cci_contact.id or 0 )
            values  = {'partner': todo.partner and todo.partner.id or 0,
                       #'date': todo.date,  # they prefer 'today'
                       'product': todo.product and todo.product.id or 0,
                       'category': todo.category and todo.category.id or 0,
                       'next_action': False,
                       'cci_contact_follow': False,
                       'description': todo.description,
                       'case_id':0,
                       'cci_contact': contact_cci_id,
                       'contact': todo.contact and todo.contact.id or 0,
                       'action': todo.action,
                       'state': 'closed',
                      }
            res_id = histo_obj.create(cr, uid, values)
        if res_id:
            value = {
                'view_type': 'form',
                'view_mode': 'form,tree',
                'res_model': 'res.partner.history',
                'res_id': [res_id],
                'type': 'ir.actions.act_window',
            }
            return value
        else:
            return {'state':'end'}
    
    states = {
        'init': {
            'actions': [],
            'result': {'type': 'action', 'action': copy_todo_to_histo, 'state': 'end'}
        }
    }
    
create_histo_from_interest('create_histo_from_interest')
