# -*- coding: utf-8 -*-

from tools.translate import _
import wizard
import pooler

form = """<?xml version="1.0"?>
<form string="Create History">
    <field name="action"/>
</form>"""

fields = {
    'action': {'string': 'Action',
               'type':'selection',
               'selection' : [
                 ('appel_sortant','Appel sortant'),
                 ('appel_entrant','Appel entrant'),
                 ('commando','Commando'),
                 ('mail','Mail'),
                 ('site','Site Internet'),
                 ('meeting_cci','Meeting CCI'),
                 ('meeting_externe','Meeting externe'),
                 ('midi','Midi'),
                 ('rdv','RDV')],
               'required': True},
   }

class create_histo_from_mark(wizard.interface):
    
    def copy_mark_to_histo(self, cr, uid, data, context=None):
        if context is None:
            context = {}
            
        pool = pooler.get_pool(cr.dbname)
        res_id = False
        
        mark_obj = pool.get('res.partner.interest')
        mark = mark_obj.browse(cr, uid, data['id'])

        histo_obj = pool.get('res.partner.history')
        values  = {'partner': mark.partner and mark.partner.id or 0,
                   'product': mark.product and mark.product.id or 0,
                   'category': mark.category and mark.category.id or 0,
                   'next_action': False,
                   'cci_contact_follow': False,
                   'description': mark.description,
                   'case_id':0,
                   'cci_contact': mark.cci_contact and mark.cci_contact.id or 0,
                   'contact': mark.contact and mark.contact.id or 0,
                   'action': data['form']['action'],
                   'state': 'closed',
                  }
        res_id = histo_obj.create(cr, uid, values)
        value = {
            'view_type': 'form',
            'view_mode': 'form,tree',
            'res_model': 'res.partner.history',
            'res_id': [],
            'type': 'ir.actions.act_window',
        }
        if res_id:
            value['res_id'] = [res_id]
        return value
    
    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('ok','Create')]},
        },
        'ok': {
            'actions': [],
            'result': {'type': 'action', 'action': copy_mark_to_histo, 'state': 'end'}
        }
    }
    
create_histo_from_mark('create_histo_from_mark')
