# -*- coding: utf-8 -*-
# 2017-11-30 ajout de la possibilité de spécifier le commercial (pour Emeline Lejeune)
from tools.translate import _
import wizard
import pooler
import datetime

PROD_CODES = {
    'AE':1,
    'CCIMAG':14,
    'CNN':13,
    'EMPL':5,
    'EVENT':4,
    'MEMB':8,
    'POP':17,
    'REP':15,
    'SPONS':9,
    'TABLE':2,
    'MENSSANA':21,
    'RDP':20,
}

ACTIONS = [
    ('appel_sortant','Appel sortant'),
    ('appel_entrant','Appel entrant'),
    ('commando','Commando'),
    ('mail','Mail'),
    ('site','Site Internet'),
    ('meeting_cci','Meeting CCI'),
    ('meeting_externe','Meeting externe'),
    ('midi','Midi'),
    ('rdv','RDV'),
]
form = """<?xml version="1.0"?>
<form string="Create Interests">
    <field name="partner_id" colspan="4" width="800"/>
    <field name="user_id" colspan="2"/>
    <newline/>
    <group colspan="4" col="6">
        <label string="Produit" colspan="2"/>
        <label string="Sous-produit" colspan="1"/>
        <label string="Date Suivi" colspan="1"/>
        <label string="Commentaire" colspan="1"/>
        <label string="Contact client" colspan="1"/>
        <newline/>
        <field name="ae"/>
        <field name="ae_subproduct" nolabel="1" attrs="{'readonly':[('ae','=',False)]}"/>
        <field name="ae_date" nolabel="1" attrs="{'readonly':[('ae','=',False)]}"/>
        <field name="ae_comment" nolabel="1" attrs="{'readonly':[('ae','=',False)]}"/>
        <field name="ae_job_id" nolabel="1" attrs="{'readonly':[('ae','=',False)]}"/>
        <field name="ccimag"/>
        <field name="ccimag_subproduct" nolabel="1" attrs="{'readonly':[('ccimag','=',False)]}"/>
        <field name="ccimag_date" nolabel="1" attrs="{'readonly':[('ccimag','=',False)]}"/>
        <field name="ccimag_comment" nolabel="1" attrs="{'readonly':[('ccimag','=',False)]}"/>
        <field name="ccimag_job_id" nolabel="1" attrs="{'readonly':[('ccimag','=',False)]}"/>
        <field name="cnn"/>
        <field name="cnn_subproduct" nolabel="1" attrs="{'readonly':[('cnn','=',False)]}"/>
        <field name="cnn_date" nolabel="1" attrs="{'readonly':[('cnn','=',False)]}"/>
        <field name="cnn_comment" nolabel="1" attrs="{'readonly':[('cnn','=',False)]}"/>
        <field name="cnn_job_id" nolabel="1" attrs="{'readonly':[('cnn','=',False)]}"/>
        <field name="empl"/>
        <field name="empl_subproduct" nolabel="1" attrs="{'readonly':[('empl','=',False)]}"/>
        <field name="empl_date" nolabel="1" attrs="{'readonly':[('empl','=',False)]}"/>
        <field name="empl_comment" nolabel="1" attrs="{'readonly':[('empl','=',False)]}"/>
        <field name="empl_job_id" nolabel="1" attrs="{'readonly':[('empl','=',False)]}"/>
        <field name="event"/>
        <field name="event_subproduct" nolabel="1" attrs="{'readonly':[('event','=',False)]}"/>
        <field name="event_date" nolabel="1" attrs="{'readonly':[('event','=',False)]}"/>
        <field name="event_comment" nolabel="1" attrs="{'readonly':[('event','=',False)]}"/>
        <field name="event_job_id" nolabel="1" attrs="{'readonly':[('event','=',False)]}"/>
        <field name="memb"/>
        <field name="memb_subproduct" nolabel="1" attrs="{'readonly':[('memb','=',False)]}"/>
        <field name="memb_date" nolabel="1" attrs="{'readonly':[('memb','=',False)]}"/>
        <field name="memb_comment" nolabel="1" attrs="{'readonly':[('memb','=',False)]}"/>
        <field name="memb_job_id" nolabel="1" attrs="{'readonly':[('memb','=',False)]}"/>
        <field name="pop"/>
        <field name="pop_subproduct" nolabel="1" attrs="{'readonly':[('pop','=',False)]}"/>
        <field name="pop_date" nolabel="1" attrs="{'readonly':[('pop','=',False)]}"/>
        <field name="pop_comment" nolabel="1" attrs="{'readonly':[('pop','=',False)]}"/>
        <field name="pop_job_id" nolabel="1" attrs="{'readonly':[('pop','=',False)]}"/>
        <field name="rep"/>
        <field name="rep_subproduct" nolabel="1" attrs="{'readonly':[('rep','=',False)]}"/>
        <field name="rep_date" nolabel="1" attrs="{'readonly':[('rep','=',False)]}"/>
        <field name="rep_comment" nolabel="1" attrs="{'readonly':[('rep','=',False)]}"/>
        <field name="rep_job_id" nolabel="1" attrs="{'readonly':[('rep','=',False)]}"/>
        <field name="spons"/>
        <field name="spons_subproduct" nolabel="1" attrs="{'readonly':[('spons','=',False)]}"/>
        <field name="spons_date" nolabel="1" attrs="{'readonly':[('spons','=',False)]}"/>
        <field name="spons_comment" nolabel="1" attrs="{'readonly':[('spons','=',False)]}"/>
        <field name="spons_job_id" nolabel="1" attrs="{'readonly':[('spons','=',False)]}"/>
        <field name="table"/>
        <field name="table_subproduct" nolabel="1" attrs="{'readonly':[('table','=',False)]}"/>
        <field name="table_date" nolabel="1" attrs="{'readonly':[('table','=',False)]}"/>
        <field name="table_comment" nolabel="1" attrs="{'readonly':[('table','=',False)]}"/>
        <field name="table_job_id" nolabel="1" attrs="{'readonly':[('table','=',False)]}"/>
        <field name="menssana"/>
        <field name="menssana_subproduct" nolabel="1" attrs="{'readonly':[('menssana','=',False)]}"/>
        <field name="menssana_date" nolabel="1" attrs="{'readonly':[('menssana','=',False)]}"/>
        <field name="menssana_comment" nolabel="1" attrs="{'readonly':[('menssana','=',False)]}"/>
        <field name="menssana_job_id" nolabel="1" attrs="{'readonly':[('menssana','=',False)]}"/>
        <field name="rdp"/>
        <field name="rdp_subproduct" nolabel="1" attrs="{'readonly':[('rdp','=',False)]}"/>
        <field name="rdp_date" nolabel="1" attrs="{'readonly':[('rdp','=',False)]}"/>
        <field name="rdp_comment" nolabel="1" attrs="{'readonly':[('rdp','=',False)]}"/>
        <field name="rdp_job_id" nolabel="1" attrs="{'readonly':[('rdp','=',False)]}"/>
        <separator string="Historique" colspan="5"/>
    </group>
    <group colspan="4" col="7">
        <field name="histo"/>
        <field name="histo_action" nolabel="1" attrs="{'readonly':[('histo','=',False)]}"/>
        <field name="histo_product" nolabel="1" attrs="{'readonly':[('histo','=',False)]}"/>
        <field name="histo_subproduct" nolabel="1" attrs="{'readonly':[('histo','=',False)]}"/>
        <field name="histo_comment" nolabel="1" attrs="{'readonly':[('histo','=',False)]}"/>
        <field name="histo_job_id" nolabel="1" attrs="{'readonly':[('histo','=',False)]}"/>
    </group>
</form>"""

fields = {
    'partner_id': {'string':'Partner','type':'many2one','relation':'res.partner','required':True},
    'ae': {'string': 'AE', 'type':'boolean'},
    'ae_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['AE']},
    'ae_date': {'string':'Date', 'type':'date'},
    'ae_comment': {'string':'Comment','type':'char','size':250},
    'ae_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'ccimag': {'string': 'CCI Mag', 'type':'boolean'},
    'ccimag_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['CCIMAG']},
    'ccimag_date': {'string':'Date', 'type':'date'},
    'ccimag_comment': {'string':'Comment','type':'char','size':250},
    'ccimag_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'cnn': {'string': 'CNN', 'type':'boolean'},
    'cnn_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['CNN']},
    'cnn_date': {'string':'Date', 'type':'date'},
    'cnn_comment': {'string':'Comment','type':'char','size':250},
    'cnn_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'empl': {'string': 'Employeur', 'type':'boolean'},
    'empl_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['EMPL']},
    'empl_date': {'string':'Date', 'type':'date'},
    'empl_comment': {'string':'Comment','type':'char','size':250},
    'empl_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'event': {'string': 'Event', 'type':'boolean'},
    'event_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['EVENT']},
    'event_date': {'string':'Date', 'type':'date'},
    'event_comment': {'string':'Comment','type':'char','size':250},
    'event_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'memb': {'string': 'MEMB', 'type':'boolean'},
    'memb_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['MEMB']},
    'memb_date': {'string':'Date', 'type':'date'},
    'memb_comment': {'string':'Comment','type':'char','size':250},
    'memb_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'pop': {'string': 'Pop Up', 'type':'boolean'},
    'pop_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['POP']},
    'pop_date': {'string':'Date', 'type':'date'},
    'pop_comment': {'string':'Comment','type':'char','size':250},
    'pop_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'rep': {'string': 'REP', 'type':'boolean'},
    'rep_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['REP']},
    'rep_date': {'string':'Date', 'type':'date'},
    'rep_comment': {'string':'Comment','type':'char','size':250},
    'rep_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'spons': {'string': 'Sponsoring', 'type':'boolean'},
    'spons_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['SPONS']},
    'spons_date': {'string':'Date', 'type':'date'},
    'spons_comment': {'string':'Comment','type':'char','size':250},
    'spons_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'table': {'string': 'Table', 'type':'boolean'},
    'table_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['TABLE']},
    'table_date': {'string':'Date', 'type':'date'},
    'table_comment': {'string':'Comment','type':'char','size':250},
    'table_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'menssana': {'string': 'Mens Sana', 'type':'boolean'},
    'menssana_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['MENSSANA']},
    'menssana_date': {'string':'Date', 'type':'date'},
    'menssana_comment': {'string':'Comment','type':'char','size':250},
    'menssana_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'rdp': {'string': 'RDP', 'type':'boolean'},
    'rdp_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',%s)]" % PROD_CODES['RDP']},
    'rdp_date': {'string':'Date', 'type':'date'},
    'rdp_comment': {'string':'Comment','type':'char','size':250},
    'rdp_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'histo': {'string':'Historique','type':'boolean'},
    'histo_action':{'string':'Action','type':'selection','selection':ACTIONS},
    'histo_product': {'string':'Produit','type':'many2one','relation':'cci.product'},
    'histo_subproduct': {'string':'Sous-produit','type':'many2one','relation':'cci.product.category','domain':"[('cci_product','=',histo_product)]"},
    'histo_comment': {'string':'Comment','type':'char','size':250},
    'histo_job_id': {'string':'Contact Partner','type':'many2one','relation':'res.partner.job','domain':"[('name','=',partner_id)]"},
    'user_id': {'string':'For account of','type':'many2one','relation':'res.users'},
}

class create_interests(wizard.interface):
    
    def _get_defaults(self, cr, uid, data, context=None):
        pool = pooler.get_pool(cr.dbname)
        current_partner_id = False
        if data['model'] == 'res.partner.history':
            hist_obj = pool.get('res.partner.history')
            histo = hist_obj.browse(cr, uid, data['id'])
            if histo.partner:
                current_partner_id = histo.partner.id
        elif data['model'] == 'res.partner.interest':
            int_obj = pool.get('res.partner.interest')
            interest = int_obj.browse(cr, uid, data['id'])
            if interest.partner:
                current_partner_id = interest.partner.id
        elif data['model'] == 'crm_cci.todo':
            todo_obj = pool.get('crm_cci.todo')
            todo = todo_obj.browse(cr, uid, data['id'])
            if todo.partner:
                current_partner_id = todo.partner.id
        elif data['model'] == 'res.partner':
            current_partner_id = data['id']
        if current_partner_id:
            fields['partner_id']['default'] = current_partner_id
        return data['form']

    def create_interestmarks(self, cr, uid, data, context=None):
        # search the cci.contact from defined user_id or uid
        if data['form']['user_id']:
            final_user_id = data['form']['user_id']
        else:
            final_user_id = uid
        print final_user_id
        interest_obj = pooler.get_pool(cr.dbname).get('res.partner.interest')
        cci_contact_obj = pooler.get_pool(cr.dbname).get('cci.contact')
        cci_contacts = cci_contact_obj.search(cr,uid,[('user','=',final_user_id)])
        new_interest_ids = []
        if cci_contacts and data['form']['partner_id']:
            cci_contact = cci_contact_obj.browse(cr,uid,cci_contacts[0])
            new_interest = {
                'cci_contact_follow' : final_user_id,
                'date': datetime.datetime.today().strftime('%Y-%m-%d'),
                'cci_contact' : cci_contact.id,
                'partner' : data['form']['partner_id'],
            }
            if data['form']['ae']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['AE']
                if data['form']['ae_subproduct']:
                    new_subproduct = data['form']['ae_subproduct']
                else:
                    new_subproduct = False
                if data['form']['ae_date']:
                    new_date = data['form']['ae_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['ae_job_id']:
                    new_contact = data['form']['ae_job_id']
                else:
                    new_contact = False
                if data['form']['ae_comment']:
                    new_desc = data['form']['ae_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['ccimag']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['CCIMAG']
                if data['form']['ccimag_subproduct']:
                    new_subproduct = data['form']['ccimag_subproduct']
                else:
                    new_subproduct = False
                if data['form']['ccimag_date']:
                    new_date = data['form']['ccimag_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['ccimag_job_id']:
                    new_contact = data['form']['ccimag_job_id']
                else:
                    new_contact = False
                if data['form']['ccimag_comment']:
                    new_desc = data['form']['ccimag_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['cnn']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['CNN']
                if data['form']['cnn_subproduct']:
                    new_subproduct = data['form']['cnn_subproduct']
                else:
                    new_subproduct = False
                if data['form']['cnn_date']:
                    new_date = data['form']['cnn_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['cnn_job_id']:
                    new_contact = data['form']['cnn_job_id']
                else:
                    new_contact = False
                if data['form']['cnn_comment']:
                    new_desc = data['form']['cnn_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['empl']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['EMPL']
                if data['form']['empl_subproduct']:
                    new_subproduct = data['form']['empl_subproduct']
                else:
                    new_subproduct = False
                if data['form']['empl_date']:
                    new_date = data['form']['empl_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['empl_job_id']:
                    new_contact = data['form']['empl_job_id']
                else:
                    new_contact = False
                if data['form']['empl_comment']:
                    new_desc = data['form']['empl_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['event']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['EVENT']
                if data['form']['event_subproduct']:
                    new_subproduct = data['form']['event_subproduct']
                else:
                    new_subproduct = False
                if data['form']['event_date']:
                    new_date = data['form']['event_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['event_job_id']:
                    new_contact = data['form']['event_job_id']
                else:
                    new_contact = False
                if data['form']['event_comment']:
                    new_desc = data['form']['event_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['memb']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['MEMB']
                if data['form']['memb_subproduct']:
                    new_subproduct = data['form']['memb_subproduct']
                else:
                    new_subproduct = False
                if data['form']['memb_date']:
                    new_date = data['form']['memb_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['memb_job_id']:
                    new_contact = data['form']['memb_job_id']
                else:
                    new_contact = False
                if data['form']['memb_comment']:
                    new_desc = data['form']['memb_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['pop']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['POP']
                if data['form']['pop_subproduct']:
                    new_subproduct = data['form']['pop_subproduct']
                else:
                    new_subproduct = False
                if data['form']['pop_date']:
                    new_date = data['form']['pop_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['pop_job_id']:
                    new_contact = data['form']['pop_job_id']
                else:
                    new_contact = False
                if data['form']['pop_comment']:
                    new_desc = data['form']['pop_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['rep']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['REP']
                if data['form']['rep_subproduct']:
                    new_subproduct = data['form']['rep_subproduct']
                else:
                    new_subproduct = False
                if data['form']['rep_date']:
                    new_date = data['form']['rep_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['rep_job_id']:
                    new_contact = data['form']['rep_job_id']
                else:
                    new_contact = False
                if data['form']['rep_comment']:
                    new_desc = data['form']['rep_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['spons']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['SPONS']
                if data['form']['spons_subproduct']:
                    new_subproduct = data['form']['spons_subproduct']
                else:
                    new_subproduct = False
                if data['form']['spons_date']:
                    new_date = data['form']['spons_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['spons_job_id']:
                    new_contact = data['form']['spons_job_id']
                else:
                    new_contact = False
                if data['form']['spons_comment']:
                    new_desc = data['form']['spons_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['table']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['TABLE']
                if data['form']['table_subproduct']:
                    new_subproduct = data['form']['table_subproduct']
                else:
                    new_subproduct = False
                if data['form']['table_date']:
                    new_date = data['form']['table_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['table_job_id']:
                    new_contact = data['form']['table_job_id']
                else:
                    new_contact = False
                if data['form']['table_comment']:
                    new_desc = data['form']['table_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['menssana']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['MENSSANA']
                if data['form']['menssana_subproduct']:
                    new_subproduct = data['form']['menssana_subproduct']
                else:
                    new_subproduct = False
                if data['form']['menssana_date']:
                    new_date = data['form']['menssana_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['menssana_job_id']:
                    new_contact = data['form']['menssana_job_id']
                else:
                    new_contact = False
                if data['form']['menssana_comment']:
                    new_desc = data['form']['menssana_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['rdp']:
                new_data = new_interest.copy()
                new_product = PROD_CODES['RDP']
                if data['form']['rdp_subproduct']:
                    new_subproduct = data['form']['rdp_subproduct']
                else:
                    new_subproduct = False
                if data['form']['rdp_date']:
                    new_date = data['form']['rdp_date']
                else:
                    new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['rdp_job_id']:
                    new_contact = data['form']['rdp_job_id']
                else:
                    new_contact = False
                if data['form']['rdp_comment']:
                    new_desc = data['form']['rdp_comment']
                else:
                    new_desc = '-'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,'contact':new_contact,'description':new_desc})
                result_id = interest_obj.create(cr,uid,new_data)
                if result_id:
                    new_interest_ids.append(result_id)
            if data['form']['histo'] and data['form']['histo_action']:
                new_data = new_interest.copy()
                new_action = data['form']['histo_action']
                if data['form']['histo_product']:
                    new_product = data['form']['histo_product']
                else:
                    new_product = False
                if data['form']['histo_product'] and data['form']['histo_subproduct']:
                    new_subproduct = data['form']['histo_subproduct']
                else:
                    new_subproduct = False
                new_date = datetime.datetime.today().strftime('%Y-%m-%d')
                if data['form']['histo_job_id']:
                    new_contact = data['form']['histo_job_id']
                else:
                    new_contact = False
                if data['form']['histo_comment']:
                    new_desc = data['form']['histo_comment']
                else:
                    new_desc = '-'
                other_descs = []
                if data['form']['ae_comment']:
                    other_descs.append(data['form']['ae_comment'])
                if data['form']['ccimag_comment']:
                    other_descs.append(data['form']['ccimag_comment'])
                if data['form']['cnn_comment']:
                    other_descs.append(data['form']['cnn_comment'])
                if data['form']['empl_comment']:
                    other_descs.append(data['form']['empl_comment'])
                if data['form']['event_comment']:
                    other_descs.append(data['form']['event_comment'])
                if data['form']['memb_comment']:
                    other_descs.append(data['form']['memb_comment'])
                if data['form']['mi_comment']:
                    other_descs.append(data['form']['mi_comment'])
                if data['form']['rep_comment']:
                    other_descs.append(data['form']['rep_comment'])
                if data['form']['spons_comment']:
                    other_descs.append(data['form']['spons_comment'])
                if data['form']['table_comment']:
                    other_descs.append(data['form']['table_comment'])
                if other_descs:
                    if new_desc != '-':
                        new_desc = new_desc.strip() + ',' + ','.join([x.strip() for x in other_descs])
                    else:
                        new_desc = ','.join([x.strip() for x in other_descs])
                new_state = 'closed'
                new_data.update({'product':new_product,'category':new_subproduct,'next_action':new_date,
                                 'contact':new_contact,'description':new_desc,'action':new_action,'state':new_state})
                result_id = pooler.get_pool(cr.dbname).get('res.partner.history').create(cr,uid,new_data)
        return {'state':'end'}
    
    states = {
        'init': {
            'actions': [_get_defaults],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('create','Create')]},
        },
        'create': {
            'actions': [],
            'result': {'type': 'action', 'action': create_interestmarks, 'state': 'end'}
        }
    }
    
create_interests('create_interests')
