# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
#         1.1 Philmer - added the sum of the sale.order.line programmed until the end of the year or not programmed
import wizard
import time
import datetime
import calendar
import tools
import pooler
import base64
from pyExcelerator import *
from tools.translate import _
from osv import fields, osv

form = """<?xml version="1.0"?>
<form string="Extract Commissions">
    <field name="from"/>
    <field name="to"/>
    <field name="debug"/>
</form>"""

fields = {
    'from': {'string': 'From', 'type':'many2one','relation':'account.period','required': True},
    'to': {'string': 'To', 'type':'many2one','relation':'account.period','required': True},
    'debug': {'string': 'with control info', 'type':'boolean','default':True},
   }
#    'commercial': {'string': 'Salesman', 'type':'many2one', 'relation':'res.users'},

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="commissions_2016.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'commissions_2016.xls':{'string': 'Prepared file',
        'type': 'binary',
        'readonly': True,},
}

def _date_minus_months(start_date,months_to_substract):
    # start date format YYYY-MM-DD, months = positive number of month to substract
    year_older = int(start_date[0:4])
    month_older = int(start_date[5:7])
    day_older = int(start_date[8:10])
    new_day = day_older
    new_year = year_older
    new_month = month_older - months_to_substract
    while new_month <= 0:
        new_year -= 1
        new_month += 12
    new_day = min(new_day,calendar.monthrange(new_year,new_month)[1])
    new_date = '%s-%s-%s' % (str(new_year).rjust(4,'0'),str(new_month).rjust(2,'0'),str(new_day).rjust(2,'0'))
    return new_date
class extract_commissions_2016(wizard.interface):
    commissionned_user_ids = [13,64]
    def _init_fields(self,cr,uid,data,context):
        obj_group = pooler.get_pool(cr.dbname).get('res.groups')
        group_ids = obj_group.search(cr,uid,[('name','=','CCI Salesman Commissions')])
        manager_group = obj_group.browse(cr,uid,group_ids)[0]
        found_manager = False
        for user in manager_group.users:
            if user.id == uid:
                found_manager = True
        if found_manager:
            # manager =< give access to commissions of all salesmen
            obj_contact = pooler.get_pool(cr.dbname).get('cci.contact')
            contact_ids = obj_contact.search(cr,uid,[('commissioned','=',True)])
            contacts = obj_contact.read(cr,uid,contact_ids,['id','user'])
            user_ids = []
            for contact in contacts:
                if contact['user']:
                    user_ids.append(str(contact['user'][0]))
        else:
            # not manager => give no access
            raise osv.except_osv(_('No access'),_('You are not a commission manager or a salesman.\nYou don\'t have access to this tool'))
        #fields['commercial']['domain'] = "[('id','in',[%s])]" % ( ','.join(user_ids) )
        return data['form']
    def _extract_club(self,cr,uid,cci_product_code,period_ids,all_period_ids,journal_list,account_list,dKeptPeriods):
        # For the clubs, we just check the user_id associated with the invoice
        # because the fact that a sale is considered 'new' or not depends on criterai difficult de trace back
        # in the current of our ERP
        # The credit nota's are managed the same way
        cci_prod_ids = pooler.get_pool(cr.dbname).get('cci.product').search(cr,uid,[('code','=',cci_product_code)])
        pprod_ids = pooler.get_pool(cr.dbname).get('product.product').search(cr,uid,[('cci_product_id','in',cci_prod_ids)])
        # selection of all account move line for all users; the selection on users will be made later
        period_list = ','.join(map(str,period_ids))
        pprod_list = ','.join(map(str,pprod_ids))
        selection = """
            SELECT aml.name, aml.id, aml.debit, aml.credit, aml.product_id, cp.id, cp.code, rp.id, rp.name, rp.user_id, ai.user_id, am.name, am.state, aa.code, ap.name, ap.id, aml.product_id, ai.id
                FROM account_move_line as aml
                    LEFT OUTER JOIN res_partner as rp ON ( aml.partner_id = rp.id )
                    LEFT OUTER JOIN account_move as am ON ( aml.move_id = am.id )
                    LEFT OUTER JOIN account_invoice as ai ON ( am.id = ai.move_id )
                    LEFT OUTER JOIN product_product as pp ON ( aml.product_id = pp.id )
                    LEFT OUTER JOIN cci_product as cp ON ( pp.cci_product_id = cp.id )
                    LEFT OUTER JOIN account_account as aa ON ( aml.account_id = aa.id )
                    LEFT OUTER JOIN account_period as ap ON ( aml.period_id = ap.id )
                WHERE aml.period_id in (%s) AND 
                      aml.journal_id in (%s) AND
                      aml.account_id in (%s) AND 
                      aml.product_id in (%s) AND
                      aml.state = 'valid'
                ORDER BY rp.id, cp.code, ap.date_start
        """ % (period_list,journal_list,account_list,pprod_list)
        cr.execute(selection)
        res = cr.fetchall()
        finals = []
        for line in res:
            final = []
            final.append(line[1] or '') # ID move line
            final.append(line[0]) # Name in move line
            final.append(line[3]-line[2]) # amount
            final.append(line[6] or '') # cci product code
            final.append(line[11] or '') # move name
            final.append(line[7] or 0) # partner ID
            final.append(line[8] or '') # partner name
            final.append(line[10] or line[9] or 0) # ID 'salesman'
            final.append(line[13] or '') # account code
            final.append(line[14] or '') # period name
            final.append('Selected')
            if ( line[12] == 'posted' ) and (line[10] or line[9]): # if no salesman ignore the line
                if (line[10] or line[9] or 0) in self.commissionned_user_ids:
                    final.append(1)
                else:
                    final.append(0)
            else:
                final.append(0)
            finals.append(final)
        return finals
    def _extract_membership(self,cr,uid,cci_product_code,period_ids,all_period_ids,journal_list,account_list,dKeptPeriods):
        # this method extract all sales of this kind of products in period_ids then for each line check
        # if there is already an invoice not canceled by credit nota for the same kind of product but for preceding membership year
        # associated products
        # The credit nota's are managed the same way
        obj_pprod = pooler.get_pool(cr.dbname).get('product.product')
        obj_amline = pooler.get_pool(cr.dbname).get('account.move.line')
        cci_prod_ids = pooler.get_pool(cr.dbname).get('cci.product').search(cr,uid,[('code','=',cci_product_code)])
        pprod_ids = obj_pprod.search(cr,uid,[('cci_product_id','in',cci_prod_ids)])
        # selection of all account move line for all users; the selection on users will be made later
        period_list = ','.join(map(str,period_ids))
        pprod_list = ','.join(map(str,pprod_ids))
        selection = """
            SELECT aml.name, aml.id, aml.debit, aml.credit, aml.product_id, cp.id, cp.code, rp.id, rp.name, rp.user_id, ai.user_id, am.name, am.state, aa.code, ap.name, ap.id, aml.product_id, pp.id
                FROM account_move_line as aml
                    LEFT OUTER JOIN res_partner as rp ON ( aml.partner_id = rp.id )
                    LEFT OUTER JOIN account_move as am ON ( aml.move_id = am.id )
                    LEFT OUTER JOIN account_invoice as ai ON ( am.id = ai.move_id )
                    LEFT OUTER JOIN product_product as pp ON ( aml.product_id = pp.id )
                    LEFT OUTER JOIN cci_product as cp ON ( pp.cci_product_id = cp.id )
                    LEFT OUTER JOIN account_account as aa ON ( aml.account_id = aa.id )
                    LEFT OUTER JOIN account_period as ap ON ( aml.period_id = ap.id )
                WHERE aml.period_id in (%s) AND 
                      aml.journal_id in (%s) AND
                      aml.account_id in (%s) AND 
                      aml.product_id in (%s) AND
                      aml.state = 'valid'
                ORDER BY rp.id, cp.code, ap.date_start
        """ % (period_list,journal_list,account_list,pprod_list)
        cr.execute(selection)
        res = cr.fetchall()
        old_partner_id = -1
        old_product_code = '-----'
        old_period_id = -1
        finals = []
        dPrecedingProducts = {}
        # for each product_id found here, we have a lit of product_ids for the preceding membership year
        for line in res:
            final = []
            final.append(line[1] or '') # ID move line
            final.append(line[0]) # Name in move line
            final.append(line[3]-line[2]) # amount
            final.append(line[6] or '') # cci product code
            final.append(line[11] or '') # move name
            final.append(line[7] or 0) # partner ID
            final.append(line[8] or '') # partner name
            final.append(line[10] or line[9] or 0) # ID 'salesman'
            final.append(line[13] or '') # account code
            final.append(line[14] or '') # period name
            final.append('Selected')
            # search if we have an final sum of invoiced amount > 0 for preceding membership year
            if dPrecedingProducts.has_key(line[17]):
                prec_prod_ids = dPrecedingProducts[line[17]]
            else:
                current_product = obj_pprod.read(cr,uid,line[17],['membership_year'])
                if current_product['membership_year']:
                    prec_prod_ids = obj_pprod.search(cr,uid,[('membership_year','=',current_product['membership_year']-1)])
                    dPrecedingProducts[line[17]] = prec_prod_ids
                else:
                    prec_prod_ids = False
            new = 1
            if prec_prod_ids:
                prec_sale_ids = obj_amline.search(cr,uid,[('partner_id','=',line[7]),('product_id','in',prec_prod_ids)])
                if prec_sale_ids:
                    sum_prec = 0.0
                    prec_sales = obj_amline.read(cr,uid,prec_sale_ids,['debit','credit'])
                    for amline in prec_sales:
                        sum_prec += ( (amline['credit'] or 0.0) - (amline['debit'] or 0.0) )
                    if sum_prec > 0.001:
                        new = 0
            if ( line[12] == 'posted' ) and (line[10] or line[9]): # if no salesman ignore the line
                final.append(new)
            else:
                final.append(0)
            finals.append(final)
        return finals
    def _extract_direct(self,cr,uid,cci_product_code,period_ids,all_period_ids,journal_list,account_list,dKeptPeriods):
        # for the credit notas, we must retrieve the linked operation and determine if it is a 'new one'
        cci_prod_ids = pooler.get_pool(cr.dbname).get('cci.product').search(cr,uid,[('code','=',cci_product_code)])
        pprod_ids = pooler.get_pool(cr.dbname).get('product.product').search(cr,uid,[('cci_product_id','in',cci_prod_ids)])
        # selection of all account move line for all users; the selection on users will be made later
        all_period_list = ','.join(map(str,all_period_ids))
        pprod_list = ','.join(map(str,pprod_ids))
        selection = """
            SELECT aml.name, aml.id, aml.debit, aml.credit, aml.product_id, cp.id, cp.code, rp.id, rp.name, rp.user_id, ai.user_id, am.name, am.state, aa.code, ap.name, ap.id, aml.product_id, aj.refund_journal
                FROM account_move_line as aml
                    LEFT OUTER JOIN res_partner as rp ON ( aml.partner_id = rp.id )
                    LEFT OUTER JOIN account_move as am ON ( aml.move_id = am.id )
                    LEFT OUTER JOIN account_invoice as ai ON ( am.id = ai.move_id )
                    LEFT OUTER JOIN product_product as pp ON ( aml.product_id = pp.id )
                    LEFT OUTER JOIN cci_product as cp ON ( pp.cci_product_id = cp.id )
                    LEFT OUTER JOIN account_account as aa ON ( aml.account_id = aa.id )
                    LEFT OUTER JOIN account_period as ap ON ( aml.period_id = ap.id )
                    LEFT OUTER JOIN account_journal as aj ON ( aml.journal_id = aj.id )
                WHERE aml.period_id in (%s) AND 
                      aml.journal_id in (%s) AND
                      aml.account_id in (%s) AND 
                      aml.product_id in (%s) AND
                      aml.state = 'valid'
                ORDER BY rp.id, cp.code, ap.date_start
        """ % (all_period_list,journal_list,account_list,pprod_list)
        cr.execute(selection)
        res = cr.fetchall()
        obj_amline = pooler.get_pool(cr.dbname).get('account.move.line')
        obj_account = pooler.get_pool(cr.dbname).get('account.account')
        obj_period = pooler.get_pool(cr.dbname).get('account.period')
        customer_account_ids = obj_account.search(cr,uid,[('type','=','receivable')])
        old_partner_id = -1
        old_product_code = '-----'
        old_period_id = -1
        finals = []
        for line in res:
            final = []
            final.append(line[1] or '') # ID move line
            final.append(line[0]) # Name in move line
            final.append(line[3]-line[2]) # amount
            final.append(line[6] or '') # cci product code
            final.append(line[11] or '') # move name
            final.append(line[7] or 0) # partner ID
            final.append(line[8] or '') # partner name
            final.append(line[10] or line[9] or 0) # ID 'salesman'
            final.append(line[13] or '') # account code
            final.append(line[14] or '') # period name
            if line[15] not in period_ids:
                #if data['form']['debug']:
                final.append('Out of period') # debug info
                final.append(0)
            else:
                final.append('Selected')
                if ( line[12] == 'posted' ) and (line[10] or line[9]): # if no salesman ignore the line
                    if line[17]:
                        # refund journal
                        amline = obj_amline.browse(cr,uid,line[1])
                        refund_new_op = False
                        if amline.move_id:
                            cn_move = amline.move_id
                            for mline in cn_move.line_id:
                                if mline.account_id and mline.account_id.id in customer_account_ids:
                                    # check if reconciled move
                                    if mline.reconcile_id:
                                        if len(mline.reconcile_id.line_id) == 2:
                                            associated_line = False
                                            for rline in mline.reconcile_id.line_id:
                                                if rline.id <> mline.id:
                                                    if rline.move_id:
                                                        for linked_line in rline.move_id.line_id:
                                                            if linked_line.account_id.id == amline.account_id.id and (linked_line.debit - linked_line.credit) == (amline.credit - amline.debit) and (linked_line.product_id and (linked_line.product_id.id == amline.product_id.id)):
                                                                associated_line = linked_line
                                            if associated_line:
                                                # search if this associated_line is a new one
                                                from_date = _date_minus_months(associated_line.date,18)
                                                to_date = _date_minus_months(associated_line.date,1)
                                                period_to_ids = obj_period.search(cr,uid,[('date_start','<=',to_date),('date_stop','>=',to_date),('special','=',False)])
                                                period_to = obj_period.read(cr,uid,period_to_ids[0],['date_stop'])
                                                period_from_ids = obj_period.search(cr,uid,[('date_start','<=',from_date),('date_stop','>=',from_date),('special','=',False)])
                                                period_from = obj_period.read(cr,uid,period_from_ids[0],['date_start'])
                                                asso_period_ids = obj_period.search(cr,uid,[('date_start','>=',period_from['date_start']),('date_stop','<=',period_to['date_stop']),('special','=',False)])
                                                already_line_ids = obj_amline.search(cr,uid,[('product_id','in',pprod_ids),('partner_id','=',associated_line.partner_id.id),('period_id','in',asso_period_ids)])
                                                if not already_line_ids:
                                                    refund_new_op = True
                                    break
                        final.append(refund_new_op)
                    else:
                        if old_partner_id != line[7] or old_product_code != line[6] or (old_period_id not in dKeptPeriods[line[15]]):
                            final.append(1)
                        else:
                            final.append(0)
                else:
                    final.append(0)
            finals.append(final)
            if not line[17]:
                old_partner_id = line[7]
                old_product_code = line[6]
                old_period_id = line[15]
        return finals
    def _get_file(self,cr,uid,data,context):
        PAST_MONTHS = 18
        # list of concerned users
        obj_contact = pooler.get_pool(cr.dbname).get('cci.contact')
        contact_ids = obj_contact.search(cr,uid,[('commissioned','=',True)])
        contacts = obj_contact.read(cr,uid,contact_ids,['id','user'])
        user_ids = []
        for contact in contacts:
            if contact['user']:
                user_ids.append(contact['user'][0])
        # select of all 'sale' journals
        journal_ids = pooler.get_pool(cr.dbname).get('account.journal').search(cr,uid,[('type','=','sale')])
        journal_list = ','.join(map(str,journal_ids))
        # selection of all commissionable accounts
        account_ids = pooler.get_pool(cr.dbname).get('account.account').search(cr,uid,[('cci_commission','=',True)])
        account_list = ','.join(map(str,account_ids))
        # selection of all concerned periods
        from_period_id = data['form']['from']
        to_period_id = data['form']['to']
        obj_period = pooler.get_pool(cr.dbname).get('account.period')
        period_from = obj_period.read(cr,uid,from_period_id,['id','name','date_start','date_stop'])
        period_to = obj_period.read(cr,uid,to_period_id,['id','name','date_start','date_stop'])
        period_ids = obj_period.search(cr,uid,[('special','=',False),('date_start','>=',min(period_from['date_start'],period_to['date_start'])),('date_stop','<=',max(period_from['date_stop'],period_to['date_stop']))])
        period_list = ','.join(map(str,period_ids))
        from_date = period_from['name']
        to_date = period_to['name']
        current_year = period_from['date_start'][0:4]
        # adding the period 18 months older than start period
        date_start_older = _date_minus_months(min(period_from['date_start'],period_to['date_start']),PAST_MONTHS)
        all_period_ids = obj_period.search(cr,uid,[('special','=',False),('date_start','>=',date_start_older),('date_stop','<=',max(period_from['date_stop'],period_to['date_stop']))])
        all_period_list = ','.join(map(str,all_period_ids))
        # for each kept period, list the 18 periods preceding and same period
        dKeptPeriods = {}
        for period_id in period_ids:
            period = obj_period.read(cr,uid,period_id,['id','date_start','date_stop'])
            older_period_ids = obj_period.search(cr,uid,[('special','=',False),('date_start','>=',_date_minus_months(period['date_start'],PAST_MONTHS)),('date_stop','<=',period['date_stop'])])
            dKeptPeriods[period['id']] = older_period_ids

        usedCCIProducts = [{'code':"AE",'old':0.0,'new':0.10,'extract':'self._extract_club'},
                        {'code':"CNN",'old':0.0,'new':0.10,'extract':'self._extract_club'},
                        {'code':"MEMB",'old':0.01,'new':0.10,'extract':'self._extract_membership'},
                        {'code':"POPUP",'old':0.025,'new':0.04,'extract':'self._extract_direct'},
                        {'code':"REP",'old':0.025,'new':0.04,'extract':'self._extract_direct'},
                       ]

        # creation of dict with users name and detection of users with sliced commissions
        obj_user = pooler.get_pool(cr.dbname).get('res.users')
        #all_user_ids = obj_user.search(cr,uid,['|',('active','=',True),('active','=',False)])
        all_user_ids = obj_user.search(cr,uid,[])
        all_users = obj_user.browse(cr,uid,all_user_ids)
        dUsers = {}
        dUserProd = {}
        ll = []
        for user in all_users:
            dUsers[user['id']] = {'id':user.id,'name':user.name,'salesman':user.salesman,'total_ca_old':0.0,'total_ca_new':0.0,'total_comm_old':0.0,'total_comm_new':0.0}
            for usedProd in usedCCIProducts:
                dUserProd[(user.id,usedProd['code'])] = {'ca_old':0.0,'ca_new':0.0}
            ll.append((user.id,user.login))
        from operator import itemgetter
        ls = sorted(ll, key=itemgetter(1))
        dUsers[0] = {'id':0,'name':'No salesman','salesman':True,'total_ca_old':0.0,'total_ca_new':0.0,'total_comm_old':0.0,'total_comm_new':0.0}
        for usedProd in usedCCIProducts:
            dUserProd[(0,usedProd['code'])] = {'ca_old':0.0,'ca_new':0.0}
        dUsers[-1] = {'id':-1,'name':'Old User','salesman':True,'total_ca_old':0.0,'total_ca_new':0.0,'total_comm_old':0.0,'total_comm_new':0.0}
        for usedProd in usedCCIProducts:
            dUserProd[(-1,usedProd['code'])] = {'ca_old':0.0,'ca_new':0.0}
        ls.append((0,'-no-'))
        ls.append((-1,'-old-'))

        # writing in excel files
        wb = Workbook()
        # writing of details while computing totals
        wsd = wb.add_sheet(_('Details'))
        wsd.write(0,0,_("Line ID" ))
        wsd.write(0,1,_("Description"))
        wsd.write(0,2,_("Amount"))
        wsd.write(0,3,_("CCI Product"))
        wsd.write(0,4,_("Move Name"))
        wsd.write(0,5,_("Partner Name"))
        wsd.write(0,6,_("Partner Location"))
        wsd.write(0,7,_("Salesman"))
        wsd.write(0,8,_("Account"))
        wsd.write(0,9,_("Period"))
        wsd.write(0,10,_("IN Sel Periods"))
        wsd.write(0,11,_("New since"))
        iline = 1

        wsc = wb.add_sheet(_('Commissions'))
        wsc.write(1,0,'Code produit')
        wsc.write(1,1,'%old')
        wsc.write(1,2,'%new')
        salesman_index = 0
        for (user_id,user_name) in ls:
            user_data = dUsers[user_id]
            if user_data['salesman'] and user_data['id'] in self.commissionned_user_ids:
                wsc.write(0,3+(4*salesman_index),user_data['name'])
                wsc.write(1,3+(4*salesman_index),'C.A. Old')
                wsc.write(1,4+(4*salesman_index),'C.A. New')
                wsc.write(1,5+(4*salesman_index),'Comm old')
                wsc.write(1,6+(4*salesman_index),'Comm New')
                salesman_index += 1
        wsc.write(0,3+(4*salesman_index),'Total by product')
        wsc.write(1,3+(4*salesman_index),'C.A. Old')
        wsc.write(1,4+(4*salesman_index),'C.A. New')
        wsc.write(1,5+(4*salesman_index),'Comm old')
        wsc.write(1,6+(4*salesman_index),'Comm New')

        wst = wb.add_sheet(_('Totals'))
        wst.write(1,0,'Code produit')
        user_index = 0
        for (user_id,user_name) in ls:
            user_data = dUsers[user_id]
            wst.write(0,1+(2*user_index),user_data['name'])
            wst.write(1,1+(2*user_index),'C.A. Old')
            wst.write(1,2+(2*user_index),'C.A. New')
            user_index += 1
        wst.write(0,1+(2*user_index),'Total by product')
        wst.write(1,1+(2*user_index),'C.A. Old')
        wst.write(1,2+(2*user_index),'C.A. New')
            
        product_index = 2
        for cci_product_data in usedCCIProducts:
            result = eval(cci_product_data['extract'])(cr,uid,cci_product_data['code'],period_ids,all_period_ids,journal_list,account_list,dKeptPeriods)
            for line in result:
                if (data['form']['debug'] and line[10] == 'Out of period') or line[10] == 'Selected':
                    wsd.write(iline,0,line[0])
                    wsd.write(iline,1,line[1])
                    wsd.write(iline,2,line[2])
                    wsd.write(iline,3,line[3])
                    wsd.write(iline,4,line[4])
                    wsd.write(iline,5,line[5])
                    wsd.write(iline,6,line[6])
                    wsd.write(iline,7,dUsers.has_key(line[7]) and dUsers[line[7]]['name'] or dUsers[-1]['name'])
                    wsd.write(iline,8,line[8])
                    wsd.write(iline,9,line[9])
                    wsd.write(iline,10,line[10])
                    wsd.write(iline,11,line[11])
                    iline += 1
                    if line[10] == 'Selected':
                        salesman_id = line[7]
                        if not dUsers.has_key(salesman_id):
                            salesman_id = -1
                        if line[11] == 1:
                            dUsers[salesman_id]['total_ca_new'] += line[2]
                            dUserProd[(salesman_id,cci_product_data['code'])]['ca_new'] += line[2]
                        else:
                            dUsers[salesman_id]['total_ca_old'] += line[2]
                            dUserProd[(salesman_id,cci_product_data['code'])]['ca_old'] += line[2]
            #endfor line
            # record the total in the two sheets
            c_total_by_product = {'ca_new':0.0,'ca_old':0.0,'comm_new':0.0,'comm_old':0.0}
            t_total_by_product = {'ca_new':0.0,'ca_old':0.0,'comm_new':0.0,'comm_old':0.0}
            #
            wsc.write(product_index,0,cci_product_data['code'])
            wsc.write(product_index,1,cci_product_data['old']*100)
            wsc.write(product_index,2,cci_product_data['new']*100)
            #
            wst.write(product_index,0,cci_product_data['code'])
            salesman_index = 0
            user_index = 0
            for (user_id,user_name) in ls:
                user_data = dUsers[user_id]
                user_prod_data = dUserProd[(user_id,cci_product_data['code'])]
                if user_data['salesman'] and user_data['id'] in self.commissionned_user_ids:
                    wsc.write(product_index,3+(4*salesman_index),user_prod_data['ca_old'])
                    wsc.write(product_index,4+(4*salesman_index),user_prod_data['ca_new'])
                    wsc.write(product_index,5+(4*salesman_index),user_prod_data['ca_old']*cci_product_data['old'])
                    wsc.write(product_index,6+(4*salesman_index),user_prod_data['ca_new']*cci_product_data['new'])
                    c_total_by_product['ca_old'] += user_prod_data['ca_old']
                    c_total_by_product['ca_new'] += user_prod_data['ca_new']
                    c_total_by_product['comm_old'] += user_prod_data['ca_old']*cci_product_data['old']
                    c_total_by_product['comm_new'] += user_prod_data['ca_new']*cci_product_data['new']
                    dUsers[user_id]['total_comm_old'] += user_prod_data['ca_old']*cci_product_data['old']
                    dUsers[user_id]['total_comm_new'] += user_prod_data['ca_new']*cci_product_data['new']
                    salesman_index += 1
                wst.write(product_index,1+(2*user_index),user_prod_data['ca_old'])
                wst.write(product_index,2+(2*user_index),user_prod_data['ca_new'])
                t_total_by_product['ca_old'] += user_prod_data['ca_old']
                t_total_by_product['ca_new'] += user_prod_data['ca_new']
                user_index += 1
            wsc.write(product_index,3+(4*salesman_index),c_total_by_product['ca_old'])
            wsc.write(product_index,4+(4*salesman_index),c_total_by_product['ca_new'])
            wsc.write(product_index,5+(4*salesman_index),c_total_by_product['comm_old'])
            wsc.write(product_index,6+(4*salesman_index),c_total_by_product['comm_new'])
            wst.write(product_index,1+(2*user_index),t_total_by_product['ca_old'])
            wst.write(product_index,2+(2*user_index),t_total_by_product['ca_new'])
            product_index += 1
        # total by user
        salesman_index = 0
        user_index = 0
        for (user_id,user_name) in ls:
            user_data = dUsers[user_id]
            if user_data['salesman'] and user_data['id'] in self.commissionned_user_ids:
                wsc.write(product_index,3+(4*salesman_index),user_data['total_ca_old'])
                wsc.write(product_index,4+(4*salesman_index),user_data['total_ca_new'])
                wsc.write(product_index,5+(4*salesman_index),user_data['total_comm_old'])
                wsc.write(product_index,6+(4*salesman_index),user_data['total_comm_new'])
                salesman_index += 1
            wst.write(product_index,1+(2*user_index),user_data['total_ca_old'])
            wst.write(product_index,2+(2*user_index),user_data['total_ca_new'])
            #t_total_by_product['ca_old'] += user_prod_data['ca_old']
            #t_total_by_product['ca_new'] += user_prod_data['ca_new']
            user_index += 1
        wb.save('commissions_2016.xls')
        result_file = open('commissions_2016.xls','rb').read()
        #endfor product
        
        # give the result to the user
        data['form']['msg']=_('Save the File with '".xls"' extension.')
        data['form']['commissions_2016.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [_init_fields],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('getfile','Get Excel File')]},
        },
        'getfile': {
            'actions': [_get_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }
extract_commissions_2016('extract_commissions_2016')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

