# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
#import re
import tools
import pooler
import base64
from pyExcelerator import *
from tools.translate import _

wizard_arch= """<?xml version="1.0"?>
<form string="Extract Histories regrouped on partner">
    <field name="conso" width="600"/>
</form>"""

wizard_fields = {
    'conso': {'string': 'With Consumption', 'type':'boolean','default':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="compacted_histories.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'compacted_histories.xls':{'string': 'Prepared file',
        'type': 'binary',
        'readonly': True,},
}

class extract_histo_compacted(wizard.interface):
    def _get_file(self,cr,uid,data,context):
        obj_history = pooler.get_pool(cr.dbname).get('res.partner.history')
        histos = obj_history.browse(cr,uid,data['ids'])
        action_types = {'appel_sortant':'Appel sortant',
                        'appel_entrant':'Appel entrant',
                        'commando':'Commando',
                        'mail':'Mail',
                        'site':'Site Internet',
                        'meeting_cci':'Meeting CCI',
                        'meeting_externe':'Meeting externe',
                        'midi':'Midi',
                        'rdv':'RDV',
                        'publication':'Publication'}
        wb1 = Workbook()
        ws1 = wb1.add_sheet('Compacted Histories')
        ws1.write(0,0,_("Compacted Histories"))
        ws1.write(1,0,'partner_id')
        ws1.write(1,1,_('History Count'))
        ws1.write(1,2,_('Contact CCI'))
        ws1.write(1,3,_('Products-Subs'))
        ws1.write(1,4,_('Partner Name'))
        ws1.write(1,5,_('Activ Status'))
        ws1.write(1,6,_('Membership'))
        ws1.write(1,7,_('Partner Salesman'))
        if data['form']['conso']:
            partner_obj = pooler.get_pool(cr.dbname).get('res.partner')
            conso_shemas = ['FreeEvents','PaidEvents','PaidAE','PaidCNN','PaidTC','PaidMS','PaidPublication','PaidSponsoring','PaidMissions']
            col = 8
            for shema in conso_shemas:
                ws1.write(1,col,shema)
                col += 1
        line = 2
        dPartners = {}
        partner_ids = []
        for histo in histos:
            if histo.partner and histo.partner.id:
                if histo.partner.id not in partner_ids:
                    partner_ids.append(histo.partner.id)
                if histo.cci_contact and histo.cci_contact.user:
                    current_user_id = histo.cci_contact.user.id
                    current_salesman = histo.cci_contact.user.name
                else:
                    current_user_id = 0
                    current_salesman = ''
                if dPartners.has_key((histo.partner.id,current_user_id)):
                    partner_data = dPartners[(histo.partner.id,current_user_id)]
                else:
                    partner_data = {'id':histo.partner.id,
                                    'count':0,
                                    'user_id':current_user_id,
                                    'salesman':current_salesman,
                                    'products':'',
                                    'partner_name':histo.partner.name,
                                    'status':histo.partner.state_id and histo.partner.state_id.name or 'unknown',
                                    'membership':histo.partner.membership_state or '',
                                    'partner_salesman':histo.partner.user_id and histo.partner.user_id.name or '',
                                   }
                partner_data['count'] += 1
                new_product = ''
                if histo.product:
                    new_product = histo.product.code or histo.product.name
                    if histo.category:
                        new_product = new_product + '-' + histo.category.name
                    if new_product and new_product not in partner_data['products']:
                        partner_data['products'] += new_product + ', '
                dPartners[(histo.partner.id,current_user_id)] = partner_data
        if data['form']['conso']:
            date_to = datetime.date.today()
            date_from = (date_to + datetime.timedelta(days=-365)).replace(day=1)
            dPartner2Conso = partner_obj._extract_consumption(cr,uid,date_from.strftime('%Y-%m-%d'),date_to.strftime('%Y-%m-%d'),conso_shemas,partner_ids)
        for (key,partner_data) in dPartners.items():
            ws1.write(line,0,partner_data['id'])
            ws1.write(line,1,partner_data['count'])
            ws1.write(line,2,partner_data['salesman'])
            ws1.write(line,3,partner_data['products'])
            ws1.write(line,4,partner_data['partner_name'])
            ws1.write(line,5,partner_data['status'])
            ws1.write(line,6,partner_data['membership'])
            ws1.write(line,7,partner_data['partner_salesman'])
            if data['form']['conso']:
                col = 8
                for shema in conso_shemas:
                    if dPartner2Conso.has_key(key[0]):
                        if dPartner2Conso[key[0]].has_key(shema):
                            ws1.write(line,col,dPartner2Conso[key[0]][shema])
                        else:
                            ws1.write(line,col,0)
                    else:
                        ws1.write(line,col,0)
                    col += 1
            line += 1
        #
        wb1.save('compacted_histories.xls')
        result_file = open('compacted_histories.xls','rb').read()

        # give the result to the user
        data['form']['msg']='Save the File with '".xls"' extension.'
        data['form']['compacted_histories.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init' : {
            'actions' : [],
            'result' : {'type':'form','arch':wizard_arch,'fields':wizard_fields,'state':[('end', 'Cancel'),('ok', 'Confirm') ]}
        },
        'ok' : {
            'actions': [_get_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

extract_histo_compacted('extract_histo_compacted')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

