# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
#import re
import tools
import pooler
import base64
from pyExcelerator import *
from tools.translate import _

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="simple_histories.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'simple_histories.xls':{'string': 'Prepared file',
        'type': 'binary',
        'readonly': True,},
}

class extract_histo_simple(wizard.interface):
    def _get_file(self,cr,uid,data,context):
        obj_history = pooler.get_pool(cr.dbname).get('res.partner.history')
        histos = obj_history.browse(cr,uid,data['ids'])
        action_types = {'appel_sortant':'Appel sortant',
                        'appel_entrant':'Appel entrant',
                        'commando':'Commando',
                        'mail':'Mail',
                        'site':'Site Internet',
                        'meeting_cci':'Meeting CCI',
                        'meeting_externe':'Meeting externe',
                        'midi':'Midi',
                        'rdv':'RDV',
                        'publication':'Publication'}
        wb1 = Workbook()
        ws1 = wb1.add_sheet('Histories')
        ws1.write(0,0,_("Histories"))
        ws1.write(1,0,'histo_id')
        ws1.write(1,1,'partner_id')
        ws1.write(1,2,_('Date'))
        ws1.write(1,3,_('Contact CCI'))
        ws1.write(1,4,_('Customer Contact'))
        ws1.write(1,5,_('Function Codes'))
        ws1.write(1,6,_('Action'))
        ws1.write(1,7,_('Product'))
        ws1.write(1,8,_('Sub-Product'))
        ws1.write(1,9,_('Comments'))
        ws1.write(1,10,_('FollowUp Date'))
        ws1.write(1,11,_('FollowUp User'))
        ws1.write(1,12,_('State'))
        ws1.write(1,13,_('Partner Name'))
        ws1.write(1,14,_('Membership'))
        ws1.write(1,15,_('Salesman'))
        line = 2
        for histo in histos:
            contact_client = ''
            if histo.contact and histo.contact.contact_id:
                contact_client = histo.contact.contact_id.name.strip()
                if histo.contact.contact_id.first_name:
                    contact_client += ' ' + histo.contact.contact_id.first_name.strip()
                if histo.contact.contact_id.title:
                    contact_client += ' (' + histo.contact.contact_id.title.strip() + ')'
                if histo.contact.function_label:
                    contact_client += ', ' + histo.contact.function_label.strip()
            ws1.write(line,0,histo.id)
            ws1.write(line,1,histo.partner and histo.partner.id or 0)
            ws1.write(line,2,histo.date or '')
            ws1.write(line,3,histo.cci_contact and histo.cci_contact.name or '')
            ws1.write(line,4,contact_client)
            ws1.write(line,6,histo.action and action_types[histo.action] or '')
            ws1.write(line,7,histo.product and histo.product.name or '')
            ws1.write(line,8,histo.category and histo.category.name or '')
            ws1.write(line,9,histo.description or '')
            ws1.write(line,10,histo.next_action or '')
            ws1.write(line,11,histo.cci_contact_follow and histo.cci_contact.follow or '')
            ws1.write(line,12,histo.state or '')
            ws1.write(line,13,histo.partner and histo.partner.name or '')
            ws1.write(line,14,histo.partner and histo.partner.membership_state or '')
            ws1.write(line,15,histo.partner and histo.partner.user_id and histo.partner.user_id.name or '')
            line += 1
        #
        wb1.save('simple_histories.xls')
        result_file = open('simple_histories.xls','rb').read()

        # give the result to the user
        data['form']['msg']='Save the File with '".xls"' extension.'
        data['form']['simple_histories.xls']=base64.encodestring(result_file)
        return data['form']

    states = {
        'init': {
            'actions': [_get_file],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

extract_histo_simple('extract_histo_simple')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

