# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
import dateutil
#import re
import tools
import pooler
import base64
from pyExcelerator import *
from pyExcelerator.Worksheet import *
from tools.translate import _
import StringIO

form = """<?xml version="1.0"?>
<form string="Get Back Commissions 2018 Excel File">
    <field name="input" colspan="4" width="600"/>
    <field name="period_id" colspan="4"/>
</form>"""

fields = {
    'input': {'type':'binary','string':'Commissions XLS File','required':True},
    'period_id': {'string':'Period','type':'many2one', 'relation':'account.period','required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <separator string="File has been created."  colspan="4"/>
     <field name="msg" colspan="4" nolabel="1"/>
     <field name="followup_yearly_products.xls" colspan="4" />
</form>"""

msg_fields = {
    'msg': {'string':'File created', 'type':'text', 'size':'100','readonly':True},
    'followup_yearly_products.xls':{'string': 'Prepared file', 'type': 'binary', 'readonly': True,},
}

def transfert_commercial(cr,uid,account_code,dComm2Distri,dAmountBySalesmen,selected_period_id,dpt_distri_code,dpt_name):
    pool = pooler.get_pool(cr.dbname)
    account_obj = pool.get('account.account')
    period_obj = pool.get('account.period')
    amove_obj = pool.get('account.move')
    amline_obj = pool.get('account.move.line')
    journal_obj = pool.get('account.journal')
    distri_obj = pool.get('account.analytic.plan.instance')
    result = True
    account_ids = account_obj.search(cr,uid,[('code','=',account_code)])
    if account_ids:
        account_id = account_ids[0]
        period = period_obj.browse(cr,uid,selected_period_id)
        distri_ids = distri_obj.search(cr,uid, [('code','=',dpt_distri_code)])
        if distri_ids:
            distri_id = distri_ids[0]
            journal_ids = journal_obj.search(cr,uid,[('code','=','JOD')])
            if journal_ids :
                journal_id = journal_ids[0]
                lines_to_add = []
                total_amount = 0.0
                for salesman in ['Simon Micha','Thomas Schloesser']:
                    if salesman in dAmountBySalesmen.keys() and abs(dAmountBySalesmen[salesman]) > 0.001:
                        salesman_distri_code = dComm2Distri[salesman]
                        salesman_distri_ids = distri_obj.search(cr,uid,[('code','=',salesman_distri_code)])
                        if salesman_distri_ids:
                            transfered_amount = dAmountBySalesmen[salesman]
                            lines_to_add.append({'account_id': account_id,
                                                 'analytics_id': salesman_distri_ids[0],
                                                 'journal_id': journal_id,
                                                 'blocked': False,
                                                 'credit': transfered_amount > 0.001 and transfered_amount or 0.0,
                                                 'debit': transfered_amount < -0.001 and abs(transfered_amount) or 0.0,
                                                 'date': period.date_stop,
                                                 'date_created': datetime.date.today().strftime('%Y-%m-%d'),
                                                 'name': u'Transfert Salaire %s sur Département' % (salesman),
                                                 'period_id':period.id,
                                                 'quantity':1,
                                                })
                            total_amount += transfered_amount
                if lines_to_add:
                    lines_to_add.append({'account_id': account_id,
                                         'analytics_id': distri_id,
                                         'journal_id': journal_id,
                                         'blocked':False,
                                         'credit':total_amount < -0.001 and abs(total_amount) or 0.0,
                                         'debit':total_amount > 0.001 and total_amount or 0.0,
                                         'date':period.date_stop,
                                         'date_created':datetime.date.today().strftime('%Y-%m-%d'),
                                         'name':u'Transfert Salaires commerciaux depuis BackOffice',
                                         'period_id':period.id,
                                         'quantity':1,
                                        })
                    vals = {
                        'name': '/',
                        'ref': u'Transferts salaires commerciaux mensuels %s' % dpt_name,
                        'period_id': period.id,
                        'journal_id': journal_id,
                        'date': period.date_stop,
                    }
                    move_id = amove_obj.create(cr, uid, vals)
                    #res_ids.append(move_id)
                    for aline in lines_to_add:
                        aline['move_id'] = move_id
                        amline_obj.create(cr,uid,aline)
                    move = amove_obj.post(cr, uid, [move_id,])
            else:
                result = False
        else:
            result = False
    else:
        result = False
    return result

class getback_yearly_products(wizard.interface):
    def _import_data(self,cr,uid,data,context):
        pool = pooler.get_pool(cr.dbname)
        parameter_obj = pooler.get_pool(cr.dbname).get('cci_parameters.cci_value')
        param_values = parameter_obj.get_value_from_names(cr,uid,['RetroTransfertCommercial'])
        errors = []
        if param_values.has_key('RetroTransfertCommercial'):
            config = param_values['RetroTransfertCommercial']
            account_code = config[0]
            dComm2Distri = config[1]
            dSheet2Pourcent = config[2]
            #
            inputfile = data['form']['input']
            inputdata = base64.decodestring(inputfile)
            # creation of excel file for receiving data during importation
            wb = parse_xls(StringIO.StringIO(inputdata))
            if wb[0][0] == u'CNN30+' and wb[1][0] == u'CNN-30' and wb[2][0] == u'RdM' and wb[3][0] == u'PopUp' and wb[4][0] == u'Facturation de cotisation':
                part_obj = pool.get('cci_club.participation')
                partner_obj = pool.get('res.partner')

                ###################
                # Get back CNN data
                ###################
                sheet = wb[0]
                sheet_content = sheet[1]
                if sheet_content[(5,0)] == u'ailine_id' and sheet_content[(5,1)] == u'partner_id' and sheet_content[(5,2)] == u'participation_id' and sheet_content[(5,9)] == u'Nouveau (18 mois)' and sheet_content[(5,10)] == u'Pas Renouvellement sur fiche participation' and sheet_content[(5,11)] == u'Attribution':
                    line = 6
                    ailine_id = False
                    try:
                        ailine_id = sheet_content[(6,0)]
                    except:
                        errors.append('AE Number 1 is empty')
                    dCommAmounts = {}
                    for salesman in dComm2Distri.keys():
                        dCommAmounts[salesman] = 0.0
                    count_amounts = 0
                    while ailine_id:
                        partner_id = False
                        participation_id = False
                        amount = False
                        new = False
                        not_renew = None
                        assignment = False
                        try:
                            not_renew = sheet_content[(line,10)]
                        except:
                            errors.append('not_renew is empty')
                        if not (not_renew is None) and (not_renew == 0 or not_renew == 1):
                            try:
                                participation_id = sheet_content[(line,2)]
                            except:
                                errors.append('participation_id is empty but there is a not_renew value')
                        try:
                            partner_id = sheet_content[(line,1)]
                        except:
                            errors.append('partner_id is empty')
                        try:
                            amount = sheet_content[(line,8)]
                        except:
                            errors.append('amount is empty')
                        try:
                            new = sheet_content[(line,9)]
                        except:
                            errors.append('field new is empty')
                        try:
                            assignment = sheet_content[(line,11)]
                        except:
                            errors.append('assignment is empty')
                        # if correct not_renew value, try to record it on participation
                        try:
                            if not (not_renew is None) and (not_renew == 0 or not_renew == 1):
                                if participation_id > 0:
                                    # check if participation seems correct
                                    part_ids = part_obj.search(cr,uid,[('id','=',participation_id)])
                                    if part_ids:
                                        part = part_obj.read(cr,uid,part_ids[0:1],['partner_id','continuation'])[0]
                                        if part['partner_id'][0] == partner_id:
                                            if (part['continuation'] and (not_renew == 1)) or ((not_renew == 0) and (not part['continuation'])):
                                                part_obj.write(cr,uid,part_ids[0:1],{'continuation':(not_renew == 0)})
                                        else:
                                            errors.append('Participation id %i has not same partner_id [%i] : %i => no change recorded' % (participation_id,partner_id,part['partner_id'][0]) )
                                    else:
                                        errors.append('participation id %i is not correct' % participation_id)
                                else:
                                    errors.append('participation id %i is not correct' % participation_id)
                            else:
                                errors.append('Not renew is not valid value : ' + str(not_renew) )
                        except:
                            errors.append('not renew or participation_id is wrong type - line %i' %line )
                        if amount and assignment and new and ((not_renew is not None)):
                            if assignment in dCommAmounts.keys() and new == 1 and not_renew == 1:
                                dCommAmounts[assignment] += amount
                                count_amounts += 1
                        line += 1
                        ailine_id = False
                        try:
                            ailine_id = sheet_content[(line,0)]
                        except:
                            errors.append('-')
                    # transfert from back office to dept
                    if 'CNN30+' in dSheet2Pourcent.keys() and count_amounts > 0:
                        dCommTransferts = {}
                        for (key,amount) in dCommAmounts.items():
                            dCommTransferts[key] = amount * dSheet2Pourcent['CNN30+'][1]
                        transfert_commercial(cr,uid,account_code,dComm2Distri,dCommTransferts,data['form']['period_id'],dSheet2Pourcent['CNN30+'][0],'CNN30+')
                    errors.append('--- end of CNN ---')
                else:
                    errors.append('errors in CNN columns')

                ###########################
                # Get back AE Number 1 data
                ###########################
                sheet = wb[1]
                sheet_content = sheet[1]
                errors = []
                if sheet_content[(5,0)] == u'ailine_id' and sheet_content[(5,1)] == u'partner_id' and sheet_content[(5,2)] == u'participation_id' and sheet_content[(5,9)] == u'Nouveau (18 mois)' and sheet_content[(5,10)] == u'Pas Renouvellement sur fiche participation' and sheet_content[(5,11)] == u'Attribution':
                    line = 6
                    ailine_id = False
                    try:
                        ailine_id = sheet_content[(6,0)]
                    except:
                        errors.append('AE Number 1 is empty')
                    dCommAmounts = {}
                    for salesman in dComm2Distri.keys():
                        dCommAmounts[salesman] = 0.0
                    count_amounts = 0
                    while ailine_id:
                        partner_id = False
                        participation_id = False
                        amount = False
                        new = False
                        not_renew = None
                        assignment = False
                        try:
                            not_renew = sheet_content[(line,10)]
                        except:
                            errors.append('not_renew is empty')
                        if not (not_renew is None) and (not_renew == 0 or not_renew == 1):
                            try:
                                participation_id = sheet_content[(line,2)]
                            except:
                                errors.append('participation_id is empty but there is a not_renew value')
                        try:
                            partner_id = sheet_content[(line,1)]
                        except:
                            errors.append('partner_id is empty')
                        try:
                            amount = sheet_content[(line,8)]
                        except:
                            errors.append('amount is empty')
                        try:
                            new = sheet_content[(line,9)]
                        except:
                            errors.append('field new is empty')
                        try:
                            assignment = sheet_content[(line,11)]
                        except:
                            errors.append('assignment is empty')
                        # if correct not_renew value, try to record it on participation
                        try:
                            if not (not_renew is None) and (not_renew == 0 or not_renew == 1):
                                if participation_id > 0:
                                    # check if participation seems correct
                                    part_ids = part_obj.search(cr,uid,[('id','=',participation_id)])
                                    if part_ids:
                                        part = part_obj.read(cr,uid,part_ids[0:1],['partner_id','continuation'])[0]
                                        if part['partner_id'][0] == partner_id:
                                            if (part['continuation'] and (not_renew == 1)) or ((not_renew == 0) and (not part['continuation'])):
                                                part_obj.write(cr,uid,part_ids[0:1],{'continuation':(not_renew == 0)})
                                        else:
                                            errors.append('Participation id %i has not same partner_id [%i] : %i => no change recorded' % (participation_id,partner_id,part['partner_id'][0]) )
                                    else:
                                        errors.append('participation id %i is not correct' % participation_id)
                                else:
                                    errors.append('participation id %i is not correct' % participation_id)
                            else:
                                errors.append('Not renew is not valid value : ' + str(not_renew) )
                        except:
                            errors.append('not renew or participation_id is wrong type - line %i' %line )
                        if amount and assignment and new and ((not_renew is not None)):
                            if assignment in dCommAmounts.keys() and new == 1 and not_renew == 1:
                                dCommAmounts[assignment] += amount
                                count_amounts += 1
                        line += 1
                        ailine_id = False
                        try:
                            ailine_id = sheet_content[(line,0)]
                        except:
                            errors.append('-')
                    # transfert from back office to dept
                    if 'CNN-30' in dSheet2Pourcent.keys() and count_amounts > 0:
                        dCommTransferts = {}
                        for (key,amount) in dCommAmounts.items():
                            dCommTransferts[key] = amount * dSheet2Pourcent['CNN-30'][1]
                        transfert_commercial(cr,uid,account_code,dComm2Distri,dCommTransferts,data['form']['period_id'],dSheet2Pourcent['CNN-30'][0],u'CNN-30')
                    errors.append('--- end of CNN-30 ---')
                else:
                    errors.append('errors in CNN-30 columns')

                ######################################
                # Get back Répertoire des membres data
                ######################################
                sheet = wb[2]
                sheet_content = sheet[1]
                errors = []
                if sheet_content[(5,0)] == u'ailine_id' and sheet_content[(5,1)] == u'partner_id' and sheet_content[(5,7)][0:7] == u'Montant' and sheet_content[(5,8)][0:7] == u'Nouveau' and sheet_content[(5,9)] == u'Attribution':
                    line = 6
                    ailine_id = False
                    try:
                        ailine_id = sheet_content[(6,0)]
                    except:
                        errors.append('Repertoire des Membres is empty')
                    dCommAmounts = {}
                    dCommOldAmounts = {}
                    for salesman in dComm2Distri.keys():
                        dCommAmounts[salesman] = 0.0
                        dCommOldAmounts[salesman] = 0.0
                    count_amounts = 0
                    while ailine_id:
                        amount = False
                        new = False
                        assignment = False
                        try:
                            amount = sheet_content[(line,7)]
                        except:
                            errors.append('amount is empty')
                        try:
                            new = sheet_content[(line,8)]
                        except:
                            errors.append('field new is empty')
                        try:
                            assignment = sheet_content[(line,9)]
                        except:
                            errors.append('assignment is empty')
                        if amount and assignment and new:
                            if assignment in dCommAmounts.keys() and new == 1:
                                dCommAmounts[assignment] += amount
                                count_amounts += 1
                            else:
                                dCommOldAmounts[assignment] += amounts
                                count_amounts += 1
                        line += 1
                        ailine_id = False
                        try:
                            ailine_id = sheet_content[(line,0)]
                        except:
                            errors.append('-')
                    # transfert from back office to dept
                    if 'RdM' in dSheet2Pourcent.keys() and count_amounts > 0:
                        dCommTransferts = {}
                        for (key,amount) in dCommAmounts.items():
                            dCommTransferts[key] = amount * dSheet2Pourcent['RdM'][1]
                        transfert_commercial(cr,uid,account_code,dComm2Distri,dCommTransferts,data['form']['period_id'],dSheet2Pourcent['RdM'][0],u'Répert Membres')
                    errors.append('--- end of Repertoire des membres ---')
                else:
                    errors.append('errors in RdM columns')

                #####################
                # Get back PopUp data
                #####################
                sheet = wb[3]
                sheet_content = sheet[1]
                errors = []
                if sheet_content[(5,0)] == u'ailine_id' and sheet_content[(5,1)] == u'partner_id' and sheet_content[(5,7)][0:7] == u'Montant' and sheet_content[(5,8)][0:7] == u'Nouveau' and sheet_content[(5,9)] == u'Attribution':
                    line = 6
                    ailine_id = False
                    try:
                        ailine_id = sheet_content[(6,0)]
                    except:
                        errors.append('PopUp is empty')
                    dCommAmounts = {}
                    dCommOldAmounts = {}
                    for salesman in dComm2Distri.keys():
                        dCommAmounts[salesman] = 0.0
                        dCommOldAmounts[salesman] = 0.0
                    count_amounts = 0
                    while ailine_id:
                        amount = False
                        new = False
                        assignment = False
                        try:
                            amount = sheet_content[(line,7)]
                        except:
                            errors.append('amount is empty')
                        try:
                            new = sheet_content[(line,8)]
                        except:
                            errors.append('field new is empty')
                        try:
                            assignment = sheet_content[(line,9)]
                        except:
                            errors.append('assignment is empty')
                        if amount and assignment and new:
                            if assignment in dCommAmounts.keys() and new == 1:
                                dCommAmounts[assignment] += amount
                                count_amounts += 1
                        line += 1
                        ailine_id = False
                        try:
                            ailine_id = sheet_content[(line,0)]
                        except:
                            errors.append('-')
                    # transfert from back office to dept
                    if 'PopUp' in dSheet2Pourcent.keys() and count_amounts > 0:
                        dCommTransferts = {}
                        for (key,amount) in dCommAmounts.items():
                            dCommTransferts[key] = amount * dSheet2Pourcent['PopUp'][1]
                        transfert_commercial(cr,uid,account_code,dComm2Distri,dCommTransferts,data['form']['period_id'],dSheet2Pourcent['PopUp'][0],u'Pop-Up')
                    errors.append('--- end of Pop Up ---')
                else:
                    errors.append('errors in PopUp columns')

                ##########################
                # Get back membership data
                ##########################
                sheet = wb[4]
                sheet_content = sheet[1]
                errors = []
                if sheet_content[(5,0)] == u'partner_id' and sheet_content[(5,9)] == u'Zone Membre depuis' and sheet_content[(5,10)] == u'Nouveau membre Comptage' and sheet_content[(5,11)] == u'Attribution':
                    line = 6
                    partner_id = False
                    try:
                        partner_id = sheet_content[(line,0)]
                    except:
                        errors.append('membership is empty')
                    while partner_id:
                        amount = False
                        new = False
                        assignment = False
                        member_since = False
                        try:
                            amount = sheet_content[(line,5)]
                        except:
                            errors.append('amount is empty')
                        try:
                            member_since = sheet_content[(line,9)]
                        except:
                            pass
                        try:
                            new = sheet_content[(line,10)]
                        except:
                            errors.append('field new is empty')
                        try:
                            assignment = sheet_content[(line,11)]
                        except:
                            errors.append('assignment is empty')
                        # if correct member_since value, try to record it on participation
                        try:
                            if not member_since:
                                member_since = -1
                            if str(type(member_since)) in ["<type 'str'>","<type 'unicode'>"]:
                                member_since = int(member_since)
                            if member_since and (member_since == -1 or member_since > 0):
                                if partner_id > 0:
                                    # check if partner seems correct
                                    partner_ids = partner_obj.search(cr,uid,[('id','=',partner_id)])
                                    if partner_ids:
                                        partner = partner_obj.read(cr,uid,partner_ids[0:1],['id','membership_first_year'])[0]
                                        if member_since == -1:
                                            if partner['membership_first_year']:
                                                partner_obj.write(cr,uid,partner_ids[0:1],{'membership_first_year':False})
                                        else:
                                            partner_obj.write(cr,uid,partner_ids[0:1],{'membership_first_year':str(member_since)})
                                    else:
                                        errors.append('partner_id %i is not correct' % participation_id)
                                else:
                                    errors.append('partner id %i is not correct' % participation_id)
                        except:
                            errors.append('membership_since is wrong type - line %i' %line )
                        line += 1
                        partner_id = False
                        try:
                            partner_id = sheet_content[(line,0)]
                        except:
                            errors.append('-')
                    errors.append('--- end of membership ---')
                else:
                    errors.append('errors in membership columns')
            else:
                errors.append('You must have 5 sheets with the original name !')
        else:
            errors.append('No default configuration for transfert. Nothing done.')
        if errors:
            data['form']['msg'] = '\n'.join(errors)
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('import','Import File')]},
        },
        'import': {
            'actions': [_import_data],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

getback_yearly_products('getback_yearly_products')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

