# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
# This wizard searchs for emails addresses in a list of given table
import wizard
import time
import datetime
import pooler
from tools.translate import _
import base64

form = """<?xml version="1.0"?>
<form string="Create Prospection">
    <field name="type" colspan="4" width="600"/>
</form>"""

fields = {
    'type': {'string': 'Type', 'type':'selection','selection':[('full','Full database - through CSV files'),('updates','Only Updates')],'required':True},
}

final_form = """<?xml version="1.0"?>
<form string="Results">
    <field name="results" colspan="4" width="600"/>
    <field name="app_addrs.csv" colspan="4"/>
    <field name="app_conts.csv" colspan="4"/>
    <field name="app_sects.csv" colspan="4"/>
</form>"""

final_fields = {
    'results' : {'string':'Results','type':'text','readonly':True,'value':''},
    'app_addrs.csv':{'string': 'App_addrs.csv','type': 'binary','readonly': True,},
    'app_conts.csv':{'string': 'App_conts.csv','type': 'binary','readonly': True,},
    'app_sects.csv':{'string': 'App_sects.csv','type': 'binary','readonly': True,},
}

final_form2 = """<?xml version="1.0"?>
<form string="Results Incremential Updating">
    <field name="results2" colspan="4" width="600"/>
</form>"""

final_fields2 = {
    'results2' : {'string':'Results','type':'text','readonly':True,'value':''},
}

class cci_sync_mobile_app(wizard.interface):
    def _choose_type(self,cr,uid,data,context):
        return data['form']['type'] == 'full' and 'full_synchro' or 'incremential'
    def _full_synchronise(self,cr,uid,data,context):
        sync_obj = pooler.get_pool(cr.dbname).get('cci_sync_mobile')
        sync_id = sync_obj.create(cr,uid,{'type':'full'})
        sync = sync_obj.browse(cr,uid,[sync_id])[0]
        (file1,file2,file3,partners,addresses,contacts,errors) = sync._export_full_csv()
        results = u'Fichier %s\nFichier %s\nFichier %s\nPartenaires exportés : %s\nAdresses exportées : %s\nContacts exportés : %s\nErreurs : %s\n - %s' \
                        % (file1,file2,file3,str(partners),str(addresses),str(contacts),str(len(errors)),
                           '\n - '.join(['[%s] %s on (%s)' % (str(x['id']),x['type'],str(x['record_id'])) for x in errors]))
        data['form']['results'] = results
        sync_obj.write(cr,uid,[sync_id],{'stats':u'Export en CSV :\nPartenaires : %s\nAdresses : %s\nContacts : %s\nErreurs :\n%s' % (str(partners),
                                                                                    str(addresses),
                                                                                    str(contacts),
                                                                                    '\n - '.join(['[%s] %s sur partenaire (%s)' % (str(x['id']),x['type'],str(x['record_id'])) for x in errors])),
                                     'errors':errors and True or False})
        file1 = open('app_addrs.csv','rb').read()
        data['form']['app_addrs.csv']=base64.encodestring(file1)
        file2 = open('app_conts.csv','rb').read()
        data['form']['app_conts.csv']=base64.encodestring(file2)
        file3 = open('app_sects.csv','rb').read()
        data['form']['app_sects.csv']=base64.encodestring(file3)
        return data['form']
    def _incremential_synchronise(self,cr,uid,data,context):
        sync_obj = pooler.get_pool(cr.dbname).get('cci_sync_mobile')
        sync_id = sync_obj.create(cr,uid,{'type':'incremential'})
        sync = sync_obj.browse(cr,uid,[sync_id])[0]
        (partners,addresses,contacts,errors) = sync._incremential_update()
        results = u'Export en CSV :\nPartenaires : %s\nAdresses : %s\nContacts : %s\nErreurs :\n%s' % (str(partners),
                                                                                    str(addresses),
                                                                                    str(contacts),
                                                                                    '\n - '.join(['[%s] %s sur partenaire (%s)' % (str(x['id']),x['type'],str(x['record_id'])) for x in errors]))
        sync_obj.write(cr,uid,[sync_id],{'stats':results,'errors':errors and True or False})
        data['form']['results2'] = results
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-stop'),('synchro','Sync','gtk-find',True)]},
        },
        'synchro': {
            'actions':[],
            'result':{'type':'choice', 'next_state':_choose_type},
        },
        'full_synchro': {
            'actions': [_full_synchronise],
            'result': {'type':'form', 'arch':final_form, 'fields':final_fields, 'state':[('end','Close')]}
        },
        'incremential': {
            'actions': [_incremential_synchronise],
            'result': {'type':'form', 'arch':final_form2, 'fields':final_fields2, 'state':[('end','Close')]}
        },
    }
cci_sync_mobile_app('cci_sync_mobile_app')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

