# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2008 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import wizard
import netsvc
import pooler
from tools.translate import _
from osv import fields, osv

form = """<?xml version="1.0"?>
<form string="Customer/Supplier Account Status">
    <field name="type" colspan="4" width="650"/>
    <field name="only_open" colspan="2"/>
</form>
"""
fields = {
    'type': {'string':'Type','type':'selection','selection':[('receivable','Customer - Sales'),('payable','Supplier - Purchases')],'required':True,'default':'receivable'},
    'only_open': {'string':'Only Open Lines','type':'boolean'},
}

class cust_status(wizard.interface):
    states = {
        'init' : {
           'actions' : [],
           'result': {'type': 'form', 'arch': form, 'fields': fields, 'state':[('end','Cancel'), ('print','Print')]}
        },
        'print': {
            'actions': [],
            'result': {'type':'print', 'report':'ccih_customer_status_report', 'state':'end'},
        },
    }
cust_status("ccih_customer_status")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
