# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################
# Version 1.0 Philmer
import wizard
import time
import datetime
import tools
import pooler
import base64
import StringIO
from pyExcelerator import *
from tools.translate import _

form = """<?xml version="1.0"?>
<form string="Options">
    <field name="explanation" colspan="4" width="800" nolabel="1" readonly="1"/>
    <field name="publish" colspan="4"/>
</form>"""

fields = {
    'explanation': {'string': 'Source',
                    'type':'text',
                    'value':u'''Cet outil synchronise les membres de l'ERP avec leurs données vers le site web de la CCIH.\n
Vous pouvez lancer cette mise à jour 'pour de vrai' ou en tests, aussi souvent que voulu.
                '''},
    'publish': {'string':'Publish','type':'selection','selection':[('publish','Publication sur le site'),('test','En Test, pour validation')],'default':'test','required':True},
}

msg_form = """<?xml version="1.0"?>
<form string="Notification">
     <field name="msg" colspan="4" nolabel="1" width="800"/>
</form>"""

msg_fields = {
    'msg': {'string':'', 'type':'text','readonly':True},
}

class ccih_wp_member_synchro(wizard.interface):

    def _synchronize(self,cr,uid,data,context):
        obj_partner = pooler.get_pool(cr.dbname).get('res.partner')
        text_result = obj_partner._members_synchro(cr,uid,data['form']['publish'])
        data['form']['msg']= text_result
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('synchro','Synchronize')]},
        },
        'synchro': {
            'actions': [_synchronize],
            'result': {'type':'form', 'arch':msg_form, 'fields':msg_fields, 'state':[('end','Ok')]}
        },
    }

ccih_wp_member_synchro('ccih_wp_member_synchro')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

