# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2008 CCI Connect ASBL. (http://www.cciconnect.be) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
from osv import fields, osv
import ftplib

class ftp_connection(osv.osv):
    _name = 'ftp_connection'
    _description = "Definition of FTP connections"
    _columns = {
        'name':fields.char('Name',size=64,required=True),
        'host':fields.char('Host address',size=64,required=True),
        'user':fields.char('User',size=64,required=True),
        'password':fields.char('Password',size=64,required=True),
        'working_directory':fields.char('Working Directory',size=250,required=True),
        'internal_code':fields.char('Internal ID',size=32),
    }
    def connect(self,cr,uid,id):
        result = None
        data = self.read(cr,uid,[id],['host','user','password','working_directory'])[0]
        if data:
            try:
                result = ftplib.FTP( data['host'], data['user'], data['password'] )
                if result and data['working_directory']:
                    result.cwd( data['working_directory'] )
            except:
                result = None
        return result
    def connect_by_internal_code(self,cr,uid,internal_code):
        ids = self.search(cr,uid,[('internal_code','=',internal_code)])
        if ids and len(ids) == 1:
            result = self.connect(cr,uid,ids[0])
        else:
            result = None
        return result
    def close(self,cr,uid,ftp):
        ftp.quit()
        return True
    def upload(self,cr,uid,ftp,filename,distant_filename=False):
        if not distant_filename:
            distant_filename = filename
        hFile = open(filename,'rb')
        result = ftp.storbinary( 'STOR ' + distant_filename, hFile )
        return result
    def test(self,cr,uid,ftp):
        return ( ftp.getwelcome() + '\n\n' + ftp.pwd() )
ftp_connection()

