# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

{
    'name': 'Reconcile Import',
    'version': '1.0',
    'category': 'Accounting/Import',
    'description': """
        This module imports a file with reconciles to do between account move lines
        This is not only an import of a list of reconciles, but also it use the account.move.line->reconcile method
        to ensure that all treatments are correctly done, as if the reconcile were manually done

        This module works with CSV files of reconciles to do.
        Each line has two data : the name of the reconcile and a list of account.move_line ids separated by '/'
        The file must have an header for these two colums named 'name' and 'ids_list'.
        The field separator is ";" thus the csv file can be encoded manually in Excel, for example

        The main use of this wizard is to finish the import of an external accounting in OpenER
        at the end of a migration process
    """,
    'author': 'CCI Connect - philmer@cciconnect.be',
    'website': 'http://www.cciconnect.be',
    'depends': [ 'account', 
                ],
    'init_xml': [],
    'update_xml': [
                    'reconcile_import_wizard.xml',
                   ],
    'demo_xml': [],
    'installable': True,
}
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
