# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2008 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import wizard
import netsvc
import pooler
import tools
import base64
from tempfile import TemporaryFile
from osv import fields, osv

form = """<?xml version="1.0"?>
<form string="Import a file with Reconciles to Do">
    <image name="gtk-dialog-info" colspan="2"/>
    <field name="file" colspan="4"/>
</form>
"""

fields = {
  'file': {'string':'File', 'type':'binary', 'required':True},
      }

msg_form = """<?xml version="1.0"?>
<form string="Result">
    <field name="message" width="650" height="200"/>
</form>
"""
msg_fields = {
      'message': {'string':'Result', 'type':'text', 'readonly':True}
      }

def _import(self, cr, uid, data, context):

    # we'll use the reconcile method of account.move.line object
    pool = pooler.get_pool(cr.dbname)
    obj_aml = pool.get('account.move.line')

    # temporary file to manage the external file given by the user
    fileobj = TemporaryFile('w+')
    fileobj.write( base64.decodestring(data['form']['file']) )

    fileobj.seek(0)

    # the csv file must have an header line
    first_line = fileobj.readline().strip()
    #(name,ids) = first_line.split(';')
    message = ''
    rec_created = 0
    for line in fileobj:
        if ';' in line:
            (name,str_ids) = line.split(';')
            name = name.replace('"','')
            str_ids = str_ids.replace('"','')
            ids = [int(x) for x in str_ids.split('/')]
            rec_created += 1
            try:
                new_id = obj_aml.reconcile(cr,uid,ids,'auto',context={})
            except Exception, e:
                message += ( name + " : error = " + str(e) + "\n" )
    fileobj.close()
    ##
    message += u"Finished\n"
    message += ( u"%s reconciles created" % str(rec_created) )
    return {'message': message}

class import_reconcile_file(wizard.interface):
    states = {
        'init' : {
           'actions' : [],
           'result': {'type': 'form', 'arch': form, 'fields': fields, 'state':[('end','Cancel'), ('import','Import')]}
        },
        'import': {
            'actions': [_import],
            'result': {'type':'form', 'arch': msg_form, 'fields': msg_fields, 'state':[('end','Ok')]}
        },
    }

import_reconcile_file("wizard_reconcile_import")

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
